/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */

/** OneOf type helpers */
type Without<T, U> = { [P in Exclude<keyof T, keyof U>]?: never };
type XOR<T, U> = T | U extends object
  ? (Without<T, U> & U) | (Without<U, T> & T)
  : T | U;
type OneOf<T extends any[]> = T extends [infer Only]
  ? Only
  : T extends [infer A, infer B, ...infer Rest]
  ? OneOf<[XOR<A, B>, ...Rest]>
  : never;

export interface paths {
  "/": {
    /**
     * GitHub API Root
     * @description Get Hypermedia links to resources accessible in GitHub's REST API
     */
    get: operations["meta/root"];
  };
  "/app": {
    /**
     * Get the authenticated app
     * @description Returns the GitHub App associated with the authentication credentials used. To see how many app installations are associated with this GitHub App, see the `installations_count` in the response. For more details about your app's installations, see the "[List installations for the authenticated app](https://docs.github.com/rest/reference/apps#list-installations-for-the-authenticated-app)" endpoint.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-authenticated"];
  };
  "/app-manifests/{code}/conversions": {
    /**
     * Create a GitHub App from a manifest
     * @description Use this endpoint to complete the handshake necessary when implementing the [GitHub App Manifest flow](https://docs.github.com/apps/building-github-apps/creating-github-apps-from-a-manifest/). When you create a GitHub App with the manifest flow, you receive a temporary `code` used to retrieve the GitHub App's `id`, `pem` (private key), and `webhook_secret`.
     */
    post: operations["apps/create-from-manifest"];
  };
  "/app/hook/config": {
    /**
     * Get a webhook configuration for an app
     * @description Returns the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-webhook-config-for-app"];
    /**
     * Update a webhook configuration for an app
     * @description Updates the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    patch: operations["apps/update-webhook-config-for-app"];
  };
  "/app/hook/deliveries": {
    /**
     * List deliveries for an app webhook
     * @description Returns a list of webhook deliveries for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/list-webhook-deliveries"];
  };
  "/app/hook/deliveries/{delivery_id}": {
    /**
     * Get a delivery for an app webhook
     * @description Returns a delivery for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-webhook-delivery"];
  };
  "/app/hook/deliveries/{delivery_id}/attempts": {
    /**
     * Redeliver a delivery for an app webhook
     * @description Redeliver a delivery for the webhook configured for a GitHub App.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    post: operations["apps/redeliver-webhook-delivery"];
  };
  "/app/installation-requests": {
    /**
     * List installation requests for the authenticated app
     * @description Lists all the pending installation requests for the authenticated GitHub App.
     */
    get: operations["apps/list-installation-requests-for-authenticated-app"];
  };
  "/app/installations": {
    /**
     * List installations for the authenticated app
     * @description You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     *
     * The permissions the installation has are included under the `permissions` key.
     */
    get: operations["apps/list-installations"];
  };
  "/app/installations/{installation_id}": {
    /**
     * Get an installation for the authenticated app
     * @description Enables an authenticated GitHub App to find an installation's information using the installation id.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-installation"];
    /**
     * Delete an installation for the authenticated app
     * @description Uninstalls a GitHub App on a user, organization, or business account. If you prefer to temporarily suspend an app's access to your account's resources, then we recommend the "[Suspend an app installation](https://docs.github.com/rest/reference/apps/#suspend-an-app-installation)" endpoint.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    delete: operations["apps/delete-installation"];
  };
  "/app/installations/{installation_id}/access_tokens": {
    /**
     * Create an installation access token for an app
     * @description Creates an installation access token that enables a GitHub App to make authenticated API requests for the app's installation on an organization or individual account. Installation tokens expire one hour from the time you create them. Using an expired token produces a status code of `401 - Unauthorized`, and requires creating a new installation token. By default the installation token has access to all repositories that the installation can access. To restrict the access to specific repositories, you can provide the `repository_ids` when creating the token. When you omit `repository_ids`, the response does not contain the `repositories` key.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    post: operations["apps/create-installation-access-token"];
  };
  "/app/installations/{installation_id}/suspended": {
    /**
     * Suspend an app installation
     * @description Suspends a GitHub App on a user, organization, or business account, which blocks the app from accessing the account's resources. When a GitHub App is suspended, the app's access to the GitHub API or webhook events is blocked for that account.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    put: operations["apps/suspend-installation"];
    /**
     * Unsuspend an app installation
     * @description Removes a GitHub App installation suspension.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    delete: operations["apps/unsuspend-installation"];
  };
  "/applications/{client_id}/grant": {
    /**
     * Delete an app authorization
     * @description OAuth and GitHub application owners can revoke a grant for their application and a specific user. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password. You must also provide a valid OAuth `access_token` as an input parameter and the grant for the token's owner will be deleted.
     * Deleting an application's grant will also delete all OAuth tokens associated with the application for the user. Once deleted, the application will have no access to the user's account and will no longer be listed on [the application authorizations settings screen within GitHub](https://github.com/settings/applications#authorized).
     */
    delete: operations["apps/delete-authorization"];
  };
  "/applications/{client_id}/token": {
    /**
     * Check a token
     * @description OAuth applications and GitHub applications with OAuth authorizations can use this API method for checking OAuth token validity without exceeding the normal rate limits for failed login attempts. Authentication works differently with this particular endpoint. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) to use this endpoint, where the username is the application `client_id` and the password is its `client_secret`. Invalid tokens will return `404 NOT FOUND`.
     */
    post: operations["apps/check-token"];
    /**
     * Delete an app token
     * @description OAuth  or GitHub application owners can revoke a single token for an OAuth application or a GitHub application with an OAuth authorization. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the application's `client_id` and `client_secret` as the username and password.
     */
    delete: operations["apps/delete-token"];
    /**
     * Reset a token
     * @description OAuth applications and GitHub applications with OAuth authorizations can use this API method to reset a valid OAuth token without end-user involvement. Applications must save the "token" property in the response because changes take effect immediately. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the application's `client_id` and `client_secret` as the username and password. Invalid tokens will return `404 NOT FOUND`.
     */
    patch: operations["apps/reset-token"];
  };
  "/applications/{client_id}/token/scoped": {
    /**
     * Create a scoped access token
     * @description Use a non-scoped user-to-server access token to create a repository scoped and/or permission scoped user-to-server access token. You can specify which repositories the token can access and which permissions are granted to the token. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the `client_id` and `client_secret` of the GitHub App as the username and password. Invalid tokens will return `404 NOT FOUND`.
     */
    post: operations["apps/scope-token"];
  };
  "/apps/{app_slug}": {
    /**
     * Get an app
     * @description **Note**: The `:app_slug` is just the URL-friendly name of your GitHub App. You can find this on the settings page for your GitHub App (e.g., `https://github.com/settings/apps/:app_slug`).
     *
     * If the GitHub App you specify is public, you can access this endpoint without authenticating. If the GitHub App you specify is private, you must authenticate with a [personal access token](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line/) or an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     */
    get: operations["apps/get-by-slug"];
  };
  "/codes_of_conduct": {
    /** Get all codes of conduct */
    get: operations["codes-of-conduct/get-all-codes-of-conduct"];
  };
  "/codes_of_conduct/{key}": {
    /** Get a code of conduct */
    get: operations["codes-of-conduct/get-conduct-code"];
  };
  "/emojis": {
    /**
     * Get emojis
     * @description Lists all the emojis available to use on GitHub.
     */
    get: operations["emojis/get"];
  };
  "/enterprises/{enterprise}/dependabot/alerts": {
    /**
     * List Dependabot alerts for an enterprise
     * @description Lists Dependabot alerts for repositories that are owned by the specified enterprise.
     * To use this endpoint, you must be a member of the enterprise, and you must use an
     * access token with the `repo` scope or `security_events` scope.
     * Alerts are only returned for organizations in the enterprise for which you are an organization owner or a security manager. For more information about security managers, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     */
    get: operations["dependabot/list-alerts-for-enterprise"];
  };
  "/enterprises/{enterprise}/secret-scanning/alerts": {
    /**
     * List secret scanning alerts for an enterprise
     * @description Lists secret scanning alerts for eligible repositories in an enterprise, from newest to oldest.
     * To use this endpoint, you must be a member of the enterprise, and you must use an access token with the `repo` scope or `security_events` scope. Alerts are only returned for organizations in the enterprise for which you are an organization owner or a [security manager](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization).
     */
    get: operations["secret-scanning/list-alerts-for-enterprise"];
  };
  "/events": {
    /**
     * List public events
     * @description We delay the public events feed by five minutes, which means the most recent event returned by the public events API actually occurred at least five minutes ago.
     */
    get: operations["activity/list-public-events"];
  };
  "/feeds": {
    /**
     * Get feeds
     * @description GitHub provides several timeline resources in [Atom](http://en.wikipedia.org/wiki/Atom_(standard)) format. The Feeds API lists all the feeds available to the authenticated user:
     *
     * *   **Timeline**: The GitHub global public timeline
     * *   **User**: The public timeline for any user, using [URI template](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia)
     * *   **Current user public**: The public timeline for the authenticated user
     * *   **Current user**: The private timeline for the authenticated user
     * *   **Current user actor**: The private timeline for activity created by the authenticated user
     * *   **Current user organizations**: The private timeline for the organizations the authenticated user is a member of.
     * *   **Security advisories**: A collection of public announcements that provide information about security-related vulnerabilities in software on GitHub.
     *
     * **Note**: Private feeds are only returned when [authenticating via Basic Auth](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) since current feed URIs use the older, non revocable auth tokens.
     */
    get: operations["activity/get-feeds"];
  };
  "/gists": {
    /**
     * List gists for the authenticated user
     * @description Lists the authenticated user's gists or if called anonymously, this endpoint returns all public gists:
     */
    get: operations["gists/list"];
    /**
     * Create a gist
     * @description Allows you to add a new gist with one or more files.
     *
     * **Note:** Don't name your files "gistfile" with a numerical suffix. This is the format of the automatic naming scheme that Gist uses internally.
     */
    post: operations["gists/create"];
  };
  "/gists/public": {
    /**
     * List public gists
     * @description List public gists sorted by most recently updated to least recently updated.
     *
     * Note: With [pagination](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
     */
    get: operations["gists/list-public"];
  };
  "/gists/starred": {
    /**
     * List starred gists
     * @description List the authenticated user's starred gists:
     */
    get: operations["gists/list-starred"];
  };
  "/gists/{gist_id}": {
    /** Get a gist */
    get: operations["gists/get"];
    /** Delete a gist */
    delete: operations["gists/delete"];
    /**
     * Update a gist
     * @description Allows you to update a gist's description and to update, delete, or rename gist files. Files from the previous version of the gist that aren't explicitly changed during an edit are unchanged.
     */
    patch: operations["gists/update"];
  };
  "/gists/{gist_id}/comments": {
    /** List gist comments */
    get: operations["gists/list-comments"];
    /** Create a gist comment */
    post: operations["gists/create-comment"];
  };
  "/gists/{gist_id}/comments/{comment_id}": {
    /** Get a gist comment */
    get: operations["gists/get-comment"];
    /** Delete a gist comment */
    delete: operations["gists/delete-comment"];
    /** Update a gist comment */
    patch: operations["gists/update-comment"];
  };
  "/gists/{gist_id}/commits": {
    /** List gist commits */
    get: operations["gists/list-commits"];
  };
  "/gists/{gist_id}/forks": {
    /** List gist forks */
    get: operations["gists/list-forks"];
    /** Fork a gist */
    post: operations["gists/fork"];
  };
  "/gists/{gist_id}/star": {
    /** Check if a gist is starred */
    get: operations["gists/check-is-starred"];
    /**
     * Star a gist
     * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["gists/star"];
    /** Unstar a gist */
    delete: operations["gists/unstar"];
  };
  "/gists/{gist_id}/{sha}": {
    /** Get a gist revision */
    get: operations["gists/get-revision"];
  };
  "/gitignore/templates": {
    /**
     * Get all gitignore templates
     * @description List all templates available to pass as an option when [creating a repository](https://docs.github.com/rest/reference/repos#create-a-repository-for-the-authenticated-user).
     */
    get: operations["gitignore/get-all-templates"];
  };
  "/gitignore/templates/{name}": {
    /**
     * Get a gitignore template
     * @description The API also allows fetching the source of a single template.
     * Use the raw [media type](https://docs.github.com/rest/overview/media-types/) to get the raw contents.
     */
    get: operations["gitignore/get-template"];
  };
  "/installation/repositories": {
    /**
     * List repositories accessible to the app installation
     * @description List repositories that an app installation can access.
     *
     * You must use an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     */
    get: operations["apps/list-repos-accessible-to-installation"];
  };
  "/installation/token": {
    /**
     * Revoke an installation access token
     * @description Revokes the installation token you're using to authenticate as an installation and access this endpoint.
     *
     * Once an installation token is revoked, the token is invalidated and cannot be used. Other endpoints that require the revoked installation token must have a new installation token to work. You can create a new token using the "[Create an installation access token for an app](https://docs.github.com/rest/reference/apps#create-an-installation-access-token-for-an-app)" endpoint.
     *
     * You must use an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
     */
    delete: operations["apps/revoke-installation-access-token"];
  };
  "/issues": {
    /**
     * List issues assigned to the authenticated user
     * @description List issues assigned to the authenticated user across all visible repositories including owned repositories, member
     * repositories, and organization repositories. You can use the `filter` query parameter to fetch issues that are not
     * necessarily assigned to you.
     *
     *
     * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
     */
    get: operations["issues/list"];
  };
  "/licenses": {
    /** Get all commonly used licenses */
    get: operations["licenses/get-all-commonly-used"];
  };
  "/licenses/{license}": {
    /** Get a license */
    get: operations["licenses/get"];
  };
  "/markdown": {
    /** Render a Markdown document */
    post: operations["markdown/render"];
  };
  "/markdown/raw": {
    /**
     * Render a Markdown document in raw mode
     * @description You must send Markdown as plain text (using a `Content-Type` header of `text/plain` or `text/x-markdown`) to this endpoint, rather than using JSON format. In raw mode, [GitHub Flavored Markdown](https://github.github.com/gfm/) is not supported and Markdown will be rendered in plain format like a README.md file. Markdown content must be 400 KB or less.
     */
    post: operations["markdown/render-raw"];
  };
  "/marketplace_listing/accounts/{account_id}": {
    /**
     * Get a subscription plan for an account
     * @description Shows whether the user or organization account actively subscribes to a plan listed by the authenticated GitHub App. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/get-subscription-plan-for-account"];
  };
  "/marketplace_listing/plans": {
    /**
     * List plans
     * @description Lists all plans that are part of your GitHub Marketplace listing.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/list-plans"];
  };
  "/marketplace_listing/plans/{plan_id}/accounts": {
    /**
     * List accounts for a plan
     * @description Returns user and organization accounts associated with the specified plan, including free plans. For per-seat pricing, you see the list of accounts that have purchased the plan, including the number of seats purchased. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/list-accounts-for-plan"];
  };
  "/marketplace_listing/stubbed/accounts/{account_id}": {
    /**
     * Get a subscription plan for an account (stubbed)
     * @description Shows whether the user or organization account actively subscribes to a plan listed by the authenticated GitHub App. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/get-subscription-plan-for-account-stubbed"];
  };
  "/marketplace_listing/stubbed/plans": {
    /**
     * List plans (stubbed)
     * @description Lists all plans that are part of your GitHub Marketplace listing.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/list-plans-stubbed"];
  };
  "/marketplace_listing/stubbed/plans/{plan_id}/accounts": {
    /**
     * List accounts for a plan (stubbed)
     * @description Returns repository and organization accounts associated with the specified plan, including free plans. For per-seat pricing, you see the list of accounts that have purchased the plan, including the number of seats purchased. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
     *
     * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
     */
    get: operations["apps/list-accounts-for-plan-stubbed"];
  };
  "/meta": {
    /**
     * Get GitHub meta information
     * @description Returns meta information about GitHub, including a list of GitHub's IP addresses. For more information, see "[About GitHub's IP addresses](https://docs.github.com/articles/about-github-s-ip-addresses/)."
     *
     * The values shown in the documentation's response are example values. You must always query the API directly to get the latest values.
     *
     * **Note:** This endpoint returns both IPv4 and IPv6 addresses. However, not all features support IPv6. You should refer to the specific documentation for each feature to determine if IPv6 is supported.
     */
    get: operations["meta/get"];
  };
  "/networks/{owner}/{repo}/events": {
    /** List public events for a network of repositories */
    get: operations["activity/list-public-events-for-repo-network"];
  };
  "/notifications": {
    /**
     * List notifications for the authenticated user
     * @description List all notifications for the current user, sorted by most recently updated.
     */
    get: operations["activity/list-notifications-for-authenticated-user"];
    /**
     * Mark notifications as read
     * @description Marks all notifications as "read" for the current user. If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List notifications for the authenticated user](https://docs.github.com/rest/reference/activity#list-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
     */
    put: operations["activity/mark-notifications-as-read"];
  };
  "/notifications/threads/{thread_id}": {
    /**
     * Get a thread
     * @description Gets information about a notification thread.
     */
    get: operations["activity/get-thread"];
    /**
     * Mark a thread as read
     * @description Marks a thread as "read." Marking a thread as "read" is equivalent to clicking a notification in your notification inbox on GitHub: https://github.com/notifications.
     */
    patch: operations["activity/mark-thread-as-read"];
  };
  "/notifications/threads/{thread_id}/subscription": {
    /**
     * Get a thread subscription for the authenticated user
     * @description This checks to see if the current user is subscribed to a thread. You can also [get a repository subscription](https://docs.github.com/rest/reference/activity#get-a-repository-subscription).
     *
     * Note that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
     */
    get: operations["activity/get-thread-subscription-for-authenticated-user"];
    /**
     * Set a thread subscription
     * @description If you are watching a repository, you receive notifications for all threads by default. Use this endpoint to ignore future notifications for threads until you comment on the thread or get an **@mention**.
     *
     * You can also use this endpoint to subscribe to threads that you are currently not receiving notifications for or to subscribed to threads that you have previously ignored.
     *
     * Unsubscribing from a conversation in a repository that you are not watching is functionally equivalent to the [Delete a thread subscription](https://docs.github.com/rest/reference/activity#delete-a-thread-subscription) endpoint.
     */
    put: operations["activity/set-thread-subscription"];
    /**
     * Delete a thread subscription
     * @description Mutes all future notifications for a conversation until you comment on the thread or get an **@mention**. If you are watching the repository of the thread, you will still receive notifications. To ignore future notifications for a repository you are watching, use the [Set a thread subscription](https://docs.github.com/rest/reference/activity#set-a-thread-subscription) endpoint and set `ignore` to `true`.
     */
    delete: operations["activity/delete-thread-subscription"];
  };
  "/octocat": {
    /**
     * Get Octocat
     * @description Get the octocat as ASCII art
     */
    get: operations["meta/get-octocat"];
  };
  "/organizations": {
    /**
     * List organizations
     * @description Lists all organizations, in the order that they were created on GitHub.
     *
     * **Note:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of organizations.
     */
    get: operations["orgs/list"];
  };
  "/organizations/{org}/personal-access-token-requests": {
    /**
     * List requests to access organization resources with fine-grained personal access tokens
     * @description Lists requests from organization members to access organization resources with a fine-grained personal access token. Only GitHub Apps can call this API,
     * using the `organization_personal_access_token_requests: read` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    get: operations["orgs/list-pat-grant-requests"];
    /**
     * Review requests to access organization resources with fine-grained personal access tokens
     * @description Approves or denies multiple pending requests to access organization resources via a fine-grained personal access token. Only GitHub Apps can call this API,
     * using the `organization_personal_access_token_requests: write` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    post: operations["orgs/review-pat-grant-requests-in-bulk"];
  };
  "/organizations/{org}/personal-access-token-requests/{pat_request_id}": {
    /**
     * Review a request to access organization resources with a fine-grained personal access token
     * @description Approves or denies a pending request to access organization resources via a fine-grained personal access token. Only GitHub Apps can call this API,
     * using the `organization_personal_access_token_requests: write` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    post: operations["orgs/review-pat-grant-request"];
  };
  "/organizations/{org}/personal-access-token-requests/{pat_request_id}/repositories": {
    /**
     * List repositories requested to be accessed by a fine-grained personal access token
     * @description Lists the repositories a fine-grained personal access token request is requesting access to. Only GitHub Apps can call this API,
     * using the `organization_personal_access_token_requests: read` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    get: operations["orgs/list-pat-grant-request-repositories"];
  };
  "/organizations/{org}/personal-access-tokens": {
    /**
     * List fine-grained personal access tokens with access to organization resources
     * @description Lists approved fine-grained personal access tokens owned by organization members that can access organization resources. Only GitHub Apps can call this API,
     * using the `organization_personal_access_tokens: read` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    get: operations["orgs/list-pat-grants"];
    /**
     * Update the access to organization resources via fine-grained personal access tokens
     * @description Updates the access organization members have to organization resources via fine-grained personal access tokens. Limited to revoking a token's existing access. Only GitHub Apps can call this API,
     * using the `organization_personal_access_tokens: write` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    post: operations["orgs/update-pat-accesses"];
  };
  "/organizations/{org}/personal-access-tokens/{pat_id}": {
    /**
     * Update the access a fine-grained personal access token has to organization resources
     * @description Updates the access an organization member has to organization resources via a fine-grained personal access token. Limited to revoking the token's existing access. Limited to revoking a token's existing access. Only GitHub Apps can call this API,
     * using the `organization_personal_access_tokens: write` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    post: operations["orgs/update-pat-access"];
  };
  "/organizations/{org}/personal-access-tokens/{pat_id}/repositories": {
    /**
     * List repositories a fine-grained personal access token has access to
     * @description Lists the repositories a fine-grained personal access token has access to. Only GitHub Apps can call this API,
     * using the `organization_personal_access_tokens: read` permission.
     *
     * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
     */
    get: operations["orgs/list-pat-grant-repositories"];
  };
  "/orgs/{org}": {
    /**
     * Get an organization
     * @description To see many of the organization response values, you need to be an authenticated organization owner with the `admin:org` scope. When the value of `two_factor_requirement_enabled` is `true`, the organization requires all members, billing managers, and outside collaborators to enable [two-factor authentication](https://docs.github.com/articles/securing-your-account-with-two-factor-authentication-2fa/).
     *
     * GitHub Apps with the `Organization plan` permission can use this endpoint to retrieve information about an organization's GitHub plan. See "[Authenticating with GitHub Apps](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/)" for details. For an example response, see 'Response with GitHub plan information' below."
     */
    get: operations["orgs/get"];
    /**
     * Delete an organization
     * @description Deletes an organization and all its repositories.
     *
     * The organization login will be unavailable for 90 days after deletion.
     *
     * Please review the Terms of Service regarding account deletion before using this endpoint:
     *
     * https://docs.github.com/site-policy/github-terms/github-terms-of-service
     */
    delete: operations["orgs/delete"];
    /**
     * Update an organization
     * @description **Parameter Deprecation Notice:** GitHub will replace and discontinue `members_allowed_repository_creation_type` in favor of more granular permissions. The new input parameters are `members_can_create_public_repositories`, `members_can_create_private_repositories` for all organizations and `members_can_create_internal_repositories` for organizations associated with an enterprise account using GitHub Enterprise Cloud or GitHub Enterprise Server 2.20+. For more information, see the [blog post](https://developer.github.com/changes/2019-12-03-internal-visibility-changes).
     *
     * Enables an authenticated organization owner with the `admin:org` scope to update the organization's profile and member privileges.
     */
    patch: operations["orgs/update"];
  };
  "/orgs/{org}/actions/cache/usage": {
    /**
     * Get GitHub Actions cache usage for an organization
     * @description Gets the total GitHub Actions cache usage for an organization.
     * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
     * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `organization_admistration:read` permission to use this endpoint.
     */
    get: operations["actions/get-actions-cache-usage-for-org"];
  };
  "/orgs/{org}/actions/cache/usage-by-repository": {
    /**
     * List repositories with GitHub Actions cache usage for an organization
     * @description Lists repositories and their GitHub Actions cache usage for an organization.
     * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
     * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `organization_admistration:read` permission to use this endpoint.
     */
    get: operations["actions/get-actions-cache-usage-by-repo-for-org"];
  };
  "/orgs/{org}/actions/oidc/customization/sub": {
    /**
     * Get the customization template for an OIDC subject claim for an organization
     * @description Gets the customization template for an OpenID Connect (OIDC) subject claim.
     * You must authenticate using an access token with the `read:org` scope to use this endpoint.
     * GitHub Apps must have the `organization_administration:write` permission to use this endpoint.
     */
    get: operations["oidc/get-oidc-custom-sub-template-for-org"];
    /**
     * Set the customization template for an OIDC subject claim for an organization
     * @description Creates or updates the customization template for an OpenID Connect (OIDC) subject claim.
     * You must authenticate using an access token with the `write:org` scope to use this endpoint.
     * GitHub Apps must have the `admin:org` permission to use this endpoint.
     */
    put: operations["oidc/update-oidc-custom-sub-template-for-org"];
  };
  "/orgs/{org}/actions/permissions": {
    /**
     * Get GitHub Actions permissions for an organization
     * @description Gets the GitHub Actions permissions policy for repositories and allowed actions and reusable workflows in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    get: operations["actions/get-github-actions-permissions-organization"];
    /**
     * Set GitHub Actions permissions for an organization
     * @description Sets the GitHub Actions permissions policy for repositories and allowed actions and reusable workflows in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    put: operations["actions/set-github-actions-permissions-organization"];
  };
  "/orgs/{org}/actions/permissions/repositories": {
    /**
     * List selected repositories enabled for GitHub Actions in an organization
     * @description Lists the selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    get: operations["actions/list-selected-repositories-enabled-github-actions-organization"];
    /**
     * Set selected repositories enabled for GitHub Actions in an organization
     * @description Replaces the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    put: operations["actions/set-selected-repositories-enabled-github-actions-organization"];
  };
  "/orgs/{org}/actions/permissions/repositories/{repository_id}": {
    /**
     * Enable a selected repository for GitHub Actions in an organization
     * @description Adds a repository to the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    put: operations["actions/enable-selected-repository-github-actions-organization"];
    /**
     * Disable a selected repository for GitHub Actions in an organization
     * @description Removes a repository from the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    delete: operations["actions/disable-selected-repository-github-actions-organization"];
  };
  "/orgs/{org}/actions/permissions/selected-actions": {
    /**
     * Get allowed actions and reusable workflows for an organization
     * @description Gets the selected actions and reusable workflows that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization).""
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    get: operations["actions/get-allowed-actions-organization"];
    /**
     * Set allowed actions and reusable workflows for an organization
     * @description Sets the actions and reusable workflows that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    put: operations["actions/set-allowed-actions-organization"];
  };
  "/orgs/{org}/actions/permissions/workflow": {
    /**
     * Get default workflow permissions for an organization
     * @description Gets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in an organization,
     * as well as whether GitHub Actions can submit approving pull request reviews. For more information, see
     * "[Setting the permissions of the GITHUB_TOKEN for your organization](https://docs.github.com/organizations/managing-organization-settings/disabling-or-limiting-github-actions-for-your-organization#setting-the-permissions-of-the-github_token-for-your-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    get: operations["actions/get-github-actions-default-workflow-permissions-organization"];
    /**
     * Set default workflow permissions for an organization
     * @description Sets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in an organization, and sets if GitHub Actions
     * can submit approving pull request reviews. For more information, see
     * "[Setting the permissions of the GITHUB_TOKEN for your organization](https://docs.github.com/organizations/managing-organization-settings/disabling-or-limiting-github-actions-for-your-organization#setting-the-permissions-of-the-github_token-for-your-organization)."
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
     */
    put: operations["actions/set-github-actions-default-workflow-permissions-organization"];
  };
  "/orgs/{org}/actions/required_workflows": {
    /**
     * List required workflows
     * @description List all required workflows in an organization.
     *
     * You must authenticate using an access token with the `read:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/list-required-workflows"];
    /**
     * Create a required workflow
     * @description Create a required workflow in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    post: operations["actions/create-required-workflow"];
  };
  "/orgs/{org}/actions/required_workflows/{required_workflow_id}": {
    /**
     * Get a required workflow
     * @description Get a required workflow configured in an organization.
     *
     * You must authenticate using an access token with the `read:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/get-required-workflow"];
    /**
     * Delete a required workflow
     * @description Deletes a required workflow configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    delete: operations["actions/delete-required-workflow"];
    /**
     * Update a required workflow
     * @description Update a required workflow in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    patch: operations["actions/update-required-workflow"];
  };
  "/orgs/{org}/actions/required_workflows/{required_workflow_id}/repositories": {
    /**
     * List selected repositories for a required workflow
     * @description Lists the selected repositories that are configured for a required workflow in an organization. To use this endpoint, the required workflow must be configured to run on selected repositories.
     *
     * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/list-selected-repositories-required-workflow"];
    /**
     * Sets repositories for a required workflow
     * @description Sets the repositories for a required workflow that is required for selected repositories.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    put: operations["actions/set-selected-repos-to-required-workflow"];
  };
  "/orgs/{org}/actions/required_workflows/{required_workflow_id}/repositories/{repository_id}": {
    /**
     * Add a repository to a required workflow
     * @description Adds a repository to a required workflow. To use this endpoint, the required workflow must be configured to run on selected repositories.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    put: operations["actions/add-selected-repo-to-required-workflow"];
    /**
     * Remove a selected repository from required workflow
     * @description Removes a repository from a required workflow. To use this endpoint, the required workflow must be configured to run on selected repositories.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    delete: operations["actions/remove-selected-repo-from-required-workflow"];
  };
  "/orgs/{org}/actions/runners": {
    /**
     * List self-hosted runners for an organization
     * @description Lists all self-hosted runners configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["actions/list-self-hosted-runners-for-org"];
  };
  "/orgs/{org}/actions/runners/downloads": {
    /**
     * List runner applications for an organization
     * @description Lists binaries for the runner application that you can download and run.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["actions/list-runner-applications-for-org"];
  };
  "/orgs/{org}/actions/runners/registration-token": {
    /**
     * Create a registration token for an organization
     * @description Returns a token that you can pass to the `config` script. The token expires after one hour.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * #### Example using registration token
     *
     * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
     *
     * ```
     * ./config.sh --url https://github.com/octo-org --token TOKEN
     * ```
     */
    post: operations["actions/create-registration-token-for-org"];
  };
  "/orgs/{org}/actions/runners/remove-token": {
    /**
     * Create a remove token for an organization
     * @description Returns a token that you can pass to the `config` script to remove a self-hosted runner from an organization. The token expires after one hour.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     *
     * #### Example using remove token
     *
     * To remove your self-hosted runner from an organization, replace `TOKEN` with the remove token provided by this
     * endpoint.
     *
     * ```
     * ./config.sh remove --token TOKEN
     * ```
     */
    post: operations["actions/create-remove-token-for-org"];
  };
  "/orgs/{org}/actions/runners/{runner_id}": {
    /**
     * Get a self-hosted runner for an organization
     * @description Gets a specific self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["actions/get-self-hosted-runner-for-org"];
    /**
     * Delete a self-hosted runner from an organization
     * @description Forces the removal of a self-hosted runner from an organization. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["actions/delete-self-hosted-runner-from-org"];
  };
  "/orgs/{org}/actions/runners/{runner_id}/labels": {
    /**
     * List labels for a self-hosted runner for an organization
     * @description Lists all labels for a self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["actions/list-labels-for-self-hosted-runner-for-org"];
    /**
     * Set custom labels for a self-hosted runner for an organization
     * @description Remove all previous custom labels and set the new custom labels for a specific
     * self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    put: operations["actions/set-custom-labels-for-self-hosted-runner-for-org"];
    /**
     * Add custom labels to a self-hosted runner for an organization
     * @description Add custom labels to a self-hosted runner configured in an organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    post: operations["actions/add-custom-labels-to-self-hosted-runner-for-org"];
    /**
     * Remove all custom labels from a self-hosted runner for an organization
     * @description Remove all custom labels from a self-hosted runner configured in an
     * organization. Returns the remaining read-only labels from the runner.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["actions/remove-all-custom-labels-from-self-hosted-runner-for-org"];
  };
  "/orgs/{org}/actions/runners/{runner_id}/labels/{name}": {
    /**
     * Remove a custom label from a self-hosted runner for an organization
     * @description Remove a custom label from a self-hosted runner configured
     * in an organization. Returns the remaining labels from the runner.
     *
     * This endpoint returns a `404 Not Found` status if the custom label is not
     * present on the runner.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["actions/remove-custom-label-from-self-hosted-runner-for-org"];
  };
  "/orgs/{org}/actions/secrets": {
    /**
     * List organization secrets
     * @description Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    get: operations["actions/list-org-secrets"];
  };
  "/orgs/{org}/actions/secrets/public-key": {
    /**
     * Get an organization public key
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    get: operations["actions/get-org-public-key"];
  };
  "/orgs/{org}/actions/secrets/{secret_name}": {
    /**
     * Get an organization secret
     * @description Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    get: operations["actions/get-org-secret"];
    /**
     * Create or update an organization secret
     * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to
     * use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["actions/create-or-update-org-secret"];
    /**
     * Delete an organization secret
     * @description Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    delete: operations["actions/delete-org-secret"];
  };
  "/orgs/{org}/actions/secrets/{secret_name}/repositories": {
    /**
     * List selected repositories for an organization secret
     * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    get: operations["actions/list-selected-repos-for-org-secret"];
    /**
     * Set selected repositories for an organization secret
     * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    put: operations["actions/set-selected-repos-for-org-secret"];
  };
  "/orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}": {
    /**
     * Add selected repository to an organization secret
     * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    put: operations["actions/add-selected-repo-to-org-secret"];
    /**
     * Remove selected repository from an organization secret
     * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
     */
    delete: operations["actions/remove-selected-repo-from-org-secret"];
  };
  "/orgs/{org}/actions/variables": {
    /**
     * List organization variables
     * @description Lists all organization variables. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
     */
    get: operations["actions/list-org-variables"];
    /**
     * Create an organization variable
     * @description Creates an organization variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    post: operations["actions/create-org-variable"];
  };
  "/orgs/{org}/actions/variables/{name}": {
    /**
     * Get an organization variable
     * @description Gets a specific variable in an organization. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
     */
    get: operations["actions/get-org-variable"];
    /**
     * Delete an organization variable
     * @description Deletes an organization variable using the variable name.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    delete: operations["actions/delete-org-variable"];
    /**
     * Update an organization variable
     * @description Updates an organization variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    patch: operations["actions/update-org-variable"];
  };
  "/orgs/{org}/actions/variables/{name}/repositories": {
    /**
     * List selected repositories for an organization variable
     * @description Lists all repositories that can access an organization variable that is available to selected repositories. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
     */
    get: operations["actions/list-selected-repos-for-org-variable"];
    /**
     * Set selected repositories for an organization variable
     * @description Replaces all repositories for an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    put: operations["actions/set-selected-repos-for-org-variable"];
  };
  "/orgs/{org}/actions/variables/{name}/repositories/{repository_id}": {
    /**
     * Add selected repository to an organization variable
     * @description Adds a repository to an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    put: operations["actions/add-selected-repo-to-org-variable"];
    /**
     * Remove selected repository from an organization variable
     * @description Removes a repository from an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
     */
    delete: operations["actions/remove-selected-repo-from-org-variable"];
  };
  "/orgs/{org}/blocks": {
    /**
     * List users blocked by an organization
     * @description List the users blocked by an organization.
     */
    get: operations["orgs/list-blocked-users"];
  };
  "/orgs/{org}/blocks/{username}": {
    /** Check if a user is blocked by an organization */
    get: operations["orgs/check-blocked-user"];
    /** Block a user from an organization */
    put: operations["orgs/block-user"];
    /** Unblock a user from an organization */
    delete: operations["orgs/unblock-user"];
  };
  "/orgs/{org}/code-scanning/alerts": {
    /**
     * List code scanning alerts for an organization
     * @description Lists code scanning alerts for the default branch for all eligible repositories in an organization. Eligible repositories are repositories that are owned by organizations that you own or for which you are a security manager. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     *
     * To use this endpoint, you must be an owner or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     */
    get: operations["code-scanning/list-alerts-for-org"];
  };
  "/orgs/{org}/codespaces": {
    /**
     * List codespaces for the organization
     * @description Lists the codespaces associated to a specified organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/list-in-organization"];
  };
  "/orgs/{org}/codespaces/billing": {
    /**
     * Manage access control for organization codespaces
     * @description Sets which users can access codespaces in an organization. This is synonymous with granting or revoking codespaces billing permissions for users according to the visibility.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    put: operations["codespaces/set-codespaces-billing"];
  };
  "/orgs/{org}/codespaces/billing/selected_users": {
    /**
     * Add users to Codespaces billing for an organization
     * @description Codespaces for the specified users will be billed to the organization.
     * To use this endpoint, the billing settings for the organization must be set to `selected_members`. For information on how to change this setting please see [these docs].(https://docs.github.com/rest/codespaces/organizations#manage-access-control-for-organization-codespaces) You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    post: operations["codespaces/set-codespaces-billing-users"];
    /**
     * Removes users from Codespaces billing for an organization
     * @description Codespaces for the specified users will no longer be billed to the organization.
     * To use this endpoint, the billing settings for the organization must be set to `selected_members`. For information on how to change this setting please see [these docs].(https://docs.github.com/rest/codespaces/organizations#manage-access-control-for-organization-codespaces) You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["codespaces/delete-codespaces-billing-users"];
  };
  "/orgs/{org}/codespaces/secrets": {
    /**
     * List organization secrets
     * @description Lists all Codespaces secrets available at the organization-level without revealing their encrypted values.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/list-org-secrets"];
  };
  "/orgs/{org}/codespaces/secrets/public-key": {
    /**
     * Get an organization public key
     * @description Gets a public key for an organization, which is required in order to encrypt secrets. You need to encrypt the value of a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/get-org-public-key"];
  };
  "/orgs/{org}/codespaces/secrets/{secret_name}": {
    /**
     * Get an organization secret
     * @description Gets an organization secret without revealing its encrypted value.
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/get-org-secret"];
    /**
     * Create or update an organization secret
     * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `admin:org` scope to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["codespaces/create-or-update-org-secret"];
    /**
     * Delete an organization secret
     * @description Deletes an organization secret using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["codespaces/delete-org-secret"];
  };
  "/orgs/{org}/codespaces/secrets/{secret_name}/repositories": {
    /**
     * List selected repositories for an organization secret
     * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/list-selected-repos-for-org-secret"];
    /**
     * Set selected repositories for an organization secret
     * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    put: operations["codespaces/set-selected-repos-for-org-secret"];
  };
  "/orgs/{org}/codespaces/secrets/{secret_name}/repositories/{repository_id}": {
    /**
     * Add selected repository to an organization secret
     * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    put: operations["codespaces/add-selected-repo-to-org-secret"];
    /**
     * Remove selected repository from an organization secret
     * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["codespaces/remove-selected-repo-from-org-secret"];
  };
  "/orgs/{org}/dependabot/alerts": {
    /**
     * List Dependabot alerts for an organization
     * @description Lists Dependabot alerts for an organization.
     *
     * To use this endpoint, you must be an owner or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
     *
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
     */
    get: operations["dependabot/list-alerts-for-org"];
  };
  "/orgs/{org}/dependabot/secrets": {
    /**
     * List organization secrets
     * @description Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    get: operations["dependabot/list-org-secrets"];
  };
  "/orgs/{org}/dependabot/secrets/public-key": {
    /**
     * Get an organization public key
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    get: operations["dependabot/get-org-public-key"];
  };
  "/orgs/{org}/dependabot/secrets/{secret_name}": {
    /**
     * Get an organization secret
     * @description Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    get: operations["dependabot/get-org-secret"];
    /**
     * Create or update an organization secret
     * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization
     * permission to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
     *
     * ```
     * const sodium = require('tweetsodium');
     *
     * const key = "base64-encoded-public-key";
     * const value = "plain-text-secret";
     *
     * // Convert the message and key to Uint8Array's (Buffer implements that interface)
     * const messageBytes = Buffer.from(value);
     * const keyBytes = Buffer.from(key, 'base64');
     *
     * // Encrypt using LibSodium.
     * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
     *
     * // Base64 the encrypted secret
     * const encrypted = Buffer.from(encryptedBytes).toString('base64');
     *
     * console.log(encrypted);
     * ```
     *
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["dependabot/create-or-update-org-secret"];
    /**
     * Delete an organization secret
     * @description Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    delete: operations["dependabot/delete-org-secret"];
  };
  "/orgs/{org}/dependabot/secrets/{secret_name}/repositories": {
    /**
     * List selected repositories for an organization secret
     * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    get: operations["dependabot/list-selected-repos-for-org-secret"];
    /**
     * Set selected repositories for an organization secret
     * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    put: operations["dependabot/set-selected-repos-for-org-secret"];
  };
  "/orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}": {
    /**
     * Add selected repository to an organization secret
     * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    put: operations["dependabot/add-selected-repo-to-org-secret"];
    /**
     * Remove selected repository from an organization secret
     * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
     */
    delete: operations["dependabot/remove-selected-repo-from-org-secret"];
  };
  "/orgs/{org}/docker/conflicts": {
    /**
     * Get list of conflicting packages during Docker migration for organization
     * @description Lists all packages that are in a specific organization, are readable by the requesting user, and that encountered a conflict during a Docker migration.
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
     */
    get: operations["packages/list-docker-migration-conflicting-packages-for-organization"];
  };
  "/orgs/{org}/events": {
    /** List public organization events */
    get: operations["activity/list-public-org-events"];
  };
  "/orgs/{org}/failed_invitations": {
    /**
     * List failed organization invitations
     * @description The return hash contains `failed_at` and `failed_reason` fields which represent the time at which the invitation failed and the reason for the failure.
     */
    get: operations["orgs/list-failed-invitations"];
  };
  "/orgs/{org}/hooks": {
    /** List organization webhooks */
    get: operations["orgs/list-webhooks"];
    /**
     * Create an organization webhook
     * @description Here's how you can create a hook that posts payloads in JSON format:
     */
    post: operations["orgs/create-webhook"];
  };
  "/orgs/{org}/hooks/{hook_id}": {
    /**
     * Get an organization webhook
     * @description Returns a webhook configured in an organization. To get only the webhook `config` properties, see "[Get a webhook configuration for an organization](/rest/reference/orgs#get-a-webhook-configuration-for-an-organization)."
     */
    get: operations["orgs/get-webhook"];
    /** Delete an organization webhook */
    delete: operations["orgs/delete-webhook"];
    /**
     * Update an organization webhook
     * @description Updates a webhook configured in an organization. When you update a webhook, the `secret` will be overwritten. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for an organization](/rest/reference/orgs#update-a-webhook-configuration-for-an-organization)."
     */
    patch: operations["orgs/update-webhook"];
  };
  "/orgs/{org}/hooks/{hook_id}/config": {
    /**
     * Get a webhook configuration for an organization
     * @description Returns the webhook configuration for an organization. To get more information about the webhook, including the `active` state and `events`, use "[Get an organization webhook ](/rest/reference/orgs#get-an-organization-webhook)."
     *
     * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:read` permission.
     */
    get: operations["orgs/get-webhook-config-for-org"];
    /**
     * Update a webhook configuration for an organization
     * @description Updates the webhook configuration for an organization. To update more information about the webhook, including the `active` state and `events`, use "[Update an organization webhook ](/rest/reference/orgs#update-an-organization-webhook)."
     *
     * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:write` permission.
     */
    patch: operations["orgs/update-webhook-config-for-org"];
  };
  "/orgs/{org}/hooks/{hook_id}/deliveries": {
    /**
     * List deliveries for an organization webhook
     * @description Returns a list of webhook deliveries for a webhook configured in an organization.
     */
    get: operations["orgs/list-webhook-deliveries"];
  };
  "/orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}": {
    /**
     * Get a webhook delivery for an organization webhook
     * @description Returns a delivery for a webhook configured in an organization.
     */
    get: operations["orgs/get-webhook-delivery"];
  };
  "/orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}/attempts": {
    /**
     * Redeliver a delivery for an organization webhook
     * @description Redeliver a delivery for a webhook configured in an organization.
     */
    post: operations["orgs/redeliver-webhook-delivery"];
  };
  "/orgs/{org}/hooks/{hook_id}/pings": {
    /**
     * Ping an organization webhook
     * @description This will trigger a [ping event](https://docs.github.com/webhooks/#ping-event) to be sent to the hook.
     */
    post: operations["orgs/ping-webhook"];
  };
  "/orgs/{org}/installation": {
    /**
     * Get an organization installation for the authenticated app
     * @description Enables an authenticated GitHub App to find the organization's installation information.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-org-installation"];
  };
  "/orgs/{org}/installations": {
    /**
     * List app installations for an organization
     * @description Lists all GitHub Apps in an organization. The installation count includes all GitHub Apps installed on repositories in the organization. You must be an organization owner with `admin:read` scope to use this endpoint.
     */
    get: operations["orgs/list-app-installations"];
  };
  "/orgs/{org}/interaction-limits": {
    /**
     * Get interaction restrictions for an organization
     * @description Shows which type of GitHub user can interact with this organization and when the restriction expires. If there is no restrictions, you will see an empty response.
     */
    get: operations["interactions/get-restrictions-for-org"];
    /**
     * Set interaction restrictions for an organization
     * @description Temporarily restricts interactions to a certain type of GitHub user in any public repository in the given organization. You must be an organization owner to set these restrictions. Setting the interaction limit at the organization level will overwrite any interaction limits that are set for individual repositories owned by the organization.
     */
    put: operations["interactions/set-restrictions-for-org"];
    /**
     * Remove interaction restrictions for an organization
     * @description Removes all interaction restrictions from public repositories in the given organization. You must be an organization owner to remove restrictions.
     */
    delete: operations["interactions/remove-restrictions-for-org"];
  };
  "/orgs/{org}/invitations": {
    /**
     * List pending organization invitations
     * @description The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, or `hiring_manager`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
     */
    get: operations["orgs/list-pending-invitations"];
    /**
     * Create an organization invitation
     * @description Invite people to an organization by using their GitHub user ID or their email address. In order to create invitations in an organization, the authenticated user must be an organization owner.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["orgs/create-invitation"];
  };
  "/orgs/{org}/invitations/{invitation_id}": {
    /**
     * Cancel an organization invitation
     * @description Cancel an organization invitation. In order to cancel an organization invitation, the authenticated user must be an organization owner.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications).
     */
    delete: operations["orgs/cancel-invitation"];
  };
  "/orgs/{org}/invitations/{invitation_id}/teams": {
    /**
     * List organization invitation teams
     * @description List all teams associated with an invitation. In order to see invitations in an organization, the authenticated user must be an organization owner.
     */
    get: operations["orgs/list-invitation-teams"];
  };
  "/orgs/{org}/issues": {
    /**
     * List organization issues assigned to the authenticated user
     * @description List issues in an organization assigned to the authenticated user.
     *
     * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
     */
    get: operations["issues/list-for-org"];
  };
  "/orgs/{org}/members": {
    /**
     * List organization members
     * @description List all users who are members of an organization. If the authenticated user is also a member of this organization then both concealed and public members will be returned.
     */
    get: operations["orgs/list-members"];
  };
  "/orgs/{org}/members/{username}": {
    /**
     * Check organization membership for a user
     * @description Check if a user is, publicly or privately, a member of the organization.
     */
    get: operations["orgs/check-membership-for-user"];
    /**
     * Remove an organization member
     * @description Removing a user from this list will remove them from all teams and they will no longer have any access to the organization's repositories.
     */
    delete: operations["orgs/remove-member"];
  };
  "/orgs/{org}/members/{username}/codespaces": {
    /**
     * List codespaces for a user in organization
     * @description Lists the codespaces that a member of an organization has for repositories in that organization.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    get: operations["codespaces/get-codespaces-for-user-in-org"];
  };
  "/orgs/{org}/members/{username}/codespaces/{codespace_name}": {
    /**
     * Delete a codespace from the organization
     * @description Deletes a user's codespace.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    delete: operations["codespaces/delete-from-organization"];
  };
  "/orgs/{org}/members/{username}/codespaces/{codespace_name}/stop": {
    /**
     * Stop a codespace for an organization user
     * @description Stops a user's codespace.
     *
     * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
     */
    post: operations["codespaces/stop-in-organization"];
  };
  "/orgs/{org}/memberships/{username}": {
    /**
     * Get organization membership for a user
     * @description In order to get a user's membership with an organization, the authenticated user must be an organization member. The `state` parameter in the response can be used to identify the user's membership status.
     */
    get: operations["orgs/get-membership-for-user"];
    /**
     * Set organization membership for a user
     * @description Only authenticated organization owners can add a member to the organization or update the member's role.
     *
     * *   If the authenticated user is _adding_ a member to the organization, the invited user will receive an email inviting them to the organization. The user's [membership status](https://docs.github.com/rest/reference/orgs#get-organization-membership-for-a-user) will be `pending` until they accept the invitation.
     *
     * *   Authenticated users can _update_ a user's membership by passing the `role` parameter. If the authenticated user changes a member's role to `admin`, the affected user will receive an email notifying them that they've been made an organization owner. If the authenticated user changes an owner's role to `member`, no email will be sent.
     *
     * **Rate limits**
     *
     * To prevent abuse, the authenticated user is limited to 50 organization invitations per 24 hour period. If the organization is more than one month old or on a paid plan, the limit is 500 invitations per 24 hour period.
     */
    put: operations["orgs/set-membership-for-user"];
    /**
     * Remove organization membership for a user
     * @description In order to remove a user's membership with an organization, the authenticated user must be an organization owner.
     *
     * If the specified user is an active member of the organization, this will remove them from the organization. If the specified user has been invited to the organization, this will cancel their invitation. The specified user will receive an email notification in both cases.
     */
    delete: operations["orgs/remove-membership-for-user"];
  };
  "/orgs/{org}/migrations": {
    /**
     * List organization migrations
     * @description Lists the most recent migrations, including both exports (which can be started through the REST API) and imports (which cannot be started using the REST API).
     *
     * A list of `repositories` is only returned for export migrations.
     */
    get: operations["migrations/list-for-org"];
    /**
     * Start an organization migration
     * @description Initiates the generation of a migration archive.
     */
    post: operations["migrations/start-for-org"];
  };
  "/orgs/{org}/migrations/{migration_id}": {
    /**
     * Get an organization migration status
     * @description Fetches the status of a migration.
     *
     * The `state` of a migration can be one of the following values:
     *
     * *   `pending`, which means the migration hasn't started yet.
     * *   `exporting`, which means the migration is in progress.
     * *   `exported`, which means the migration finished successfully.
     * *   `failed`, which means the migration failed.
     */
    get: operations["migrations/get-status-for-org"];
  };
  "/orgs/{org}/migrations/{migration_id}/archive": {
    /**
     * Download an organization migration archive
     * @description Fetches the URL to a migration archive.
     */
    get: operations["migrations/download-archive-for-org"];
    /**
     * Delete an organization migration archive
     * @description Deletes a previous migration archive. Migration archives are automatically deleted after seven days.
     */
    delete: operations["migrations/delete-archive-for-org"];
  };
  "/orgs/{org}/migrations/{migration_id}/repos/{repo_name}/lock": {
    /**
     * Unlock an organization repository
     * @description Unlocks a repository that was locked for migration. You should unlock each migrated repository and [delete them](https://docs.github.com/rest/repos/repos#delete-a-repository) when the migration is complete and you no longer need the source data.
     */
    delete: operations["migrations/unlock-repo-for-org"];
  };
  "/orgs/{org}/migrations/{migration_id}/repositories": {
    /**
     * List repositories in an organization migration
     * @description List all the repositories for this organization migration.
     */
    get: operations["migrations/list-repos-for-org"];
  };
  "/orgs/{org}/outside_collaborators": {
    /**
     * List outside collaborators for an organization
     * @description List all users who are outside collaborators of an organization.
     */
    get: operations["orgs/list-outside-collaborators"];
  };
  "/orgs/{org}/outside_collaborators/{username}": {
    /**
     * Convert an organization member to outside collaborator
     * @description When an organization member is converted to an outside collaborator, they'll only have access to the repositories that their current team membership allows. The user will no longer be a member of the organization. For more information, see "[Converting an organization member to an outside collaborator](https://docs.github.com/articles/converting-an-organization-member-to-an-outside-collaborator/)". Converting an organization member to an outside collaborator may be restricted by enterprise administrators. For more information, see "[Enforcing repository management policies in your enterprise](https://docs.github.com/admin/policies/enforcing-policies-for-your-enterprise/enforcing-repository-management-policies-in-your-enterprise#enforcing-a-policy-for-inviting-outside-collaborators-to-repositories)."
     */
    put: operations["orgs/convert-member-to-outside-collaborator"];
    /**
     * Remove outside collaborator from an organization
     * @description Removing a user from this list will remove them from all the organization's repositories.
     */
    delete: operations["orgs/remove-outside-collaborator"];
  };
  "/orgs/{org}/packages": {
    /**
     * List packages for an organization
     * @description Lists packages in an organization readable by the user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/list-packages-for-organization"];
  };
  "/orgs/{org}/packages/{package_type}/{package_name}": {
    /**
     * Get a package for an organization
     * @description Gets a specific package in an organization.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-for-organization"];
    /**
     * Delete a package for an organization
     * @description Deletes an entire package in an organization. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    delete: operations["packages/delete-package-for-org"];
  };
  "/orgs/{org}/packages/{package_type}/{package_name}/restore": {
    /**
     * Restore a package for an organization
     * @description Restores an entire package in an organization.
     *
     * You can restore a deleted package under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    post: operations["packages/restore-package-for-org"];
  };
  "/orgs/{org}/packages/{package_type}/{package_name}/versions": {
    /**
     * List package versions for a package owned by an organization
     * @description Lists package versions for a package owned by an organization.
     *
     * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-all-package-versions-for-package-owned-by-org"];
  };
  "/orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}": {
    /**
     * Get a package version for an organization
     * @description Gets a specific package version in an organization.
     *
     * You must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-version-for-organization"];
    /**
     * Delete package version for an organization
     * @description Deletes a specific package version in an organization. If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    delete: operations["packages/delete-package-version-for-org"];
  };
  "/orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore": {
    /**
     * Restore package version for an organization
     * @description Restores a specific package version in an organization.
     *
     * You can restore a deleted package under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    post: operations["packages/restore-package-version-for-org"];
  };
  "/orgs/{org}/projects": {
    /**
     * List organization projects
     * @description Lists the projects in an organization. Returns a `404 Not Found` status if projects are disabled in the organization. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    get: operations["projects/list-for-org"];
    /**
     * Create an organization project
     * @description Creates an organization project board. Returns a `410 Gone` status if projects are disabled in the organization or if the organization does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    post: operations["projects/create-for-org"];
  };
  "/orgs/{org}/public_members": {
    /**
     * List public organization members
     * @description Members of an organization can choose to have their membership publicized or not.
     */
    get: operations["orgs/list-public-members"];
  };
  "/orgs/{org}/public_members/{username}": {
    /** Check public organization membership for a user */
    get: operations["orgs/check-public-membership-for-user"];
    /**
     * Set public organization membership for the authenticated user
     * @description The user can publicize their own membership. (A user cannot publicize the membership for another user.)
     *
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["orgs/set-public-membership-for-authenticated-user"];
    /** Remove public organization membership for the authenticated user */
    delete: operations["orgs/remove-public-membership-for-authenticated-user"];
  };
  "/orgs/{org}/repos": {
    /**
     * List organization repositories
     * @description Lists repositories for the specified organization.
     *
     * **Note:** In order to see the `security_and_analysis` block for a repository you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     */
    get: operations["repos/list-for-org"];
    /**
     * Create an organization repository
     * @description Creates a new repository in the specified organization. The authenticated user must be a member of the organization.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository
     */
    post: operations["repos/create-in-org"];
  };
  "/orgs/{org}/rulesets": {
    /**
     * Get all organization repository rulesets
     * @description Get all the repository rulesets for an organization.
     */
    get: operations["repos/get-org-rulesets"];
    /**
     * Create an organization repository ruleset
     * @description Create a repository ruleset for an organization.
     */
    post: operations["repos/create-org-ruleset"];
  };
  "/orgs/{org}/rulesets/{ruleset_id}": {
    /**
     * Get an organization repository ruleset
     * @description Get a repository ruleset for an organization.
     */
    get: operations["repos/get-org-ruleset"];
    /**
     * Update an organization repository ruleset
     * @description Update a ruleset for an organization.
     */
    put: operations["repos/update-org-ruleset"];
    /**
     * Delete an organization repository ruleset
     * @description Delete a ruleset for an organization.
     */
    delete: operations["repos/delete-org-ruleset"];
  };
  "/orgs/{org}/secret-scanning/alerts": {
    /**
     * List secret scanning alerts for an organization
     * @description Lists secret scanning alerts for eligible repositories in an organization, from newest to oldest.
     * To use this endpoint, you must be an administrator or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     */
    get: operations["secret-scanning/list-alerts-for-org"];
  };
  "/orgs/{org}/security-managers": {
    /**
     * List security manager teams
     * @description Lists teams that are security managers for an organization. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     *
     * To use this endpoint, you must be an administrator or security manager for the organization, and you must use an access token with the `read:org` scope.
     *
     * GitHub Apps must have the `administration` organization read permission to use this endpoint.
     */
    get: operations["orgs/list-security-manager-teams"];
  };
  "/orgs/{org}/security-managers/teams/{team_slug}": {
    /**
     * Add a security manager team
     * @description Adds a team as a security manager for an organization. For more information, see "[Managing security for an organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization) for an organization."
     *
     * To use this endpoint, you must be an administrator for the organization, and you must use an access token with the `write:org` scope.
     *
     * GitHub Apps must have the `administration` organization read-write permission to use this endpoint.
     */
    put: operations["orgs/add-security-manager-team"];
    /**
     * Remove a security manager team
     * @description Removes the security manager role from a team for an organization. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization) team from an organization."
     *
     * To use this endpoint, you must be an administrator for the organization, and you must use an access token with the `admin:org` scope.
     *
     * GitHub Apps must have the `administration` organization read-write permission to use this endpoint.
     */
    delete: operations["orgs/remove-security-manager-team"];
  };
  "/orgs/{org}/settings/billing/actions": {
    /**
     * Get GitHub Actions billing for an organization
     * @description Gets the summary of the free and paid GitHub Actions minutes used.
     *
     * Paid minutes only apply to workflows in private repositories that use GitHub-hosted runners. Minutes used is listed for each GitHub-hosted runner operating system. Any job re-runs are also included in the usage. The usage returned includes any minute multipliers for macOS and Windows runners, and is rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
     *
     * Access tokens must have the `repo` or `admin:org` scope.
     */
    get: operations["billing/get-github-actions-billing-org"];
  };
  "/orgs/{org}/settings/billing/packages": {
    /**
     * Get GitHub Packages billing for an organization
     * @description Gets the free and paid storage used for GitHub Packages in gigabytes.
     *
     * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
     *
     * Access tokens must have the `repo` or `admin:org` scope.
     */
    get: operations["billing/get-github-packages-billing-org"];
  };
  "/orgs/{org}/settings/billing/shared-storage": {
    /**
     * Get shared storage billing for an organization
     * @description Gets the estimated paid and estimated total storage used for GitHub Actions and GitHub Packages.
     *
     * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
     *
     * Access tokens must have the `repo` or `admin:org` scope.
     */
    get: operations["billing/get-shared-storage-billing-org"];
  };
  "/orgs/{org}/teams": {
    /**
     * List teams
     * @description Lists all teams in an organization that are visible to the authenticated user.
     */
    get: operations["teams/list"];
    /**
     * Create a team
     * @description To create a team, the authenticated user must be a member or owner of `{org}`. By default, organization members can create teams. Organization owners can limit team creation to organization owners. For more information, see "[Setting team creation permissions](https://docs.github.com/articles/setting-team-creation-permissions-in-your-organization)."
     *
     * When you create a new team, you automatically become a team maintainer without explicitly adding yourself to the optional array of `maintainers`. For more information, see "[About teams](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/about-teams)".
     */
    post: operations["teams/create"];
  };
  "/orgs/{org}/teams/{team_slug}": {
    /**
     * Get a team by name
     * @description Gets a team using the team's `slug`. To create the `slug`, GitHub replaces special characters in the `name` string, changes all words to lowercase, and replaces spaces with a `-` separator. For example, `"My TEam Näme"` would become `my-team-name`.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}`.
     */
    get: operations["teams/get-by-name"];
    /**
     * Delete a team
     * @description To delete a team, the authenticated user must be an organization owner or team maintainer.
     *
     * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}`.
     */
    delete: operations["teams/delete-in-org"];
    /**
     * Update a team
     * @description To edit a team, the authenticated user must either be an organization owner or a team maintainer.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}`.
     */
    patch: operations["teams/update-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions": {
    /**
     * List discussions
     * @description List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions`.
     */
    get: operations["teams/list-discussions-in-org"];
    /**
     * Create a discussion
     * @description Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions`.
     */
    post: operations["teams/create-discussion-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}": {
    /**
     * Get a discussion
     * @description Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     */
    get: operations["teams/get-discussion-in-org"];
    /**
     * Delete a discussion
     * @description Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     */
    delete: operations["teams/delete-discussion-in-org"];
    /**
     * Update a discussion
     * @description Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
     */
    patch: operations["teams/update-discussion-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments": {
    /**
     * List discussion comments
     * @description List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
     */
    get: operations["teams/list-discussion-comments-in-org"];
    /**
     * Create a discussion comment
     * @description Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
     */
    post: operations["teams/create-discussion-comment-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}": {
    /**
     * Get a discussion comment
     * @description Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     */
    get: operations["teams/get-discussion-comment-in-org"];
    /**
     * Delete a discussion comment
     * @description Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     */
    delete: operations["teams/delete-discussion-comment-in-org"];
    /**
     * Update a discussion comment
     * @description Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
     */
    patch: operations["teams/update-discussion-comment-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions": {
    /**
     * List reactions for a team discussion comment
     * @description List the reactions to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments/). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
     */
    get: operations["reactions/list-for-team-discussion-comment-in-org"];
    /**
     * Create reaction for a team discussion comment
     * @description Create a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
     */
    post: operations["reactions/create-for-team-discussion-comment-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions/{reaction_id}": {
    /**
     * Delete team discussion comment reaction
     * @description **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions/:reaction_id`.
     *
     * Delete a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["reactions/delete-for-team-discussion-comment"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions": {
    /**
     * List reactions for a team discussion
     * @description List the reactions to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
     */
    get: operations["reactions/list-for-team-discussion-in-org"];
    /**
     * Create reaction for a team discussion
     * @description Create a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
     */
    post: operations["reactions/create-for-team-discussion-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions/{reaction_id}": {
    /**
     * Delete team discussion reaction
     * @description **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions/:reaction_id`.
     *
     * Delete a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["reactions/delete-for-team-discussion"];
  };
  "/orgs/{org}/teams/{team_slug}/invitations": {
    /**
     * List pending team invitations
     * @description The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, `hiring_manager`, or `reinstate`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/invitations`.
     */
    get: operations["teams/list-pending-invitations-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/members": {
    /**
     * List team members
     * @description Team members will include the members of child teams.
     *
     * To list members in a team, the team must be visible to the authenticated user.
     */
    get: operations["teams/list-members-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/memberships/{username}": {
    /**
     * Get team membership for a user
     * @description Team members will include the members of child teams.
     *
     * To get a user's membership with a team, the team must be visible to the authenticated user.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     *
     * **Note:**
     * The response contains the `state` of the membership and the member's `role`.
     *
     * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see see [Create a team](https://docs.github.com/rest/reference/teams#create-a-team).
     */
    get: operations["teams/get-membership-for-user-in-org"];
    /**
     * Add or update team membership for a user
     * @description Adds an organization member to a team. An authenticated organization owner or team maintainer can add organization members to a team.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * An organization owner can add someone who is not part of the team's organization to a team. When an organization owner adds someone to a team who is not an organization member, this endpoint will send an invitation to the person via email. This newly-created membership will be in the "pending" state until the person accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team.
     *
     * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     */
    put: operations["teams/add-or-update-membership-for-user-in-org"];
    /**
     * Remove team membership for a user
     * @description To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/memberships/{username}`.
     */
    delete: operations["teams/remove-membership-for-user-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/projects": {
    /**
     * List team projects
     * @description Lists the organization projects for a team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects`.
     */
    get: operations["teams/list-projects-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/projects/{project_id}": {
    /**
     * Check team permissions for a project
     * @description Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     */
    get: operations["teams/check-permissions-for-project-in-org"];
    /**
     * Add or update team project permissions
     * @description Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     */
    put: operations["teams/add-or-update-project-permissions-in-org"];
    /**
     * Remove a project from a team
     * @description Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. This endpoint removes the project from the team, but does not delete the project.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
     */
    delete: operations["teams/remove-project-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/repos": {
    /**
     * List team repositories
     * @description Lists a team's repositories visible to the authenticated user.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos`.
     */
    get: operations["teams/list-repos-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}": {
    /**
     * Check team permissions for a repository
     * @description Checks whether a team has `admin`, `push`, `maintain`, `triage`, or `pull` permission for a repository. Repositories inherited through a parent team will also be checked.
     *
     * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `application/vnd.github.v3.repository+json` accept header.
     *
     * If a team doesn't have permission for the repository, you will receive a `404 Not Found` response status.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     */
    get: operations["teams/check-permissions-for-repo-in-org"];
    /**
     * Add or update team repository permissions
     * @description To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization. Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     *
     * For more information about the permission levels, see "[Repository permission levels for an organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)".
     */
    put: operations["teams/add-or-update-repo-permissions-in-org"];
    /**
     * Remove a repository from a team
     * @description If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. This does not delete the repository, it just removes it from the team.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
     */
    delete: operations["teams/remove-repo-in-org"];
  };
  "/orgs/{org}/teams/{team_slug}/teams": {
    /**
     * List child teams
     * @description Lists the child teams of the team specified by `{team_slug}`.
     *
     * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/teams`.
     */
    get: operations["teams/list-child-in-org"];
  };
  "/orgs/{org}/{security_product}/{enablement}": {
    /**
     * Enable or disable a security feature for an organization
     * @description Enables or disables the specified security feature for all eligible repositories in an organization.
     *
     * To use this endpoint, you must be an organization owner or be member of a team with the security manager role.
     * A token with the 'write:org' scope is also required.
     *
     * GitHub Apps must have the `organization_administration:write` permission to use this endpoint.
     *
     * For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     */
    post: operations["orgs/enable-or-disable-security-product-on-all-org-repos"];
  };
  "/projects/columns/cards/{card_id}": {
    /** Get a project card */
    get: operations["projects/get-card"];
    /** Delete a project card */
    delete: operations["projects/delete-card"];
    /** Update an existing project card */
    patch: operations["projects/update-card"];
  };
  "/projects/columns/cards/{card_id}/moves": {
    /** Move a project card */
    post: operations["projects/move-card"];
  };
  "/projects/columns/{column_id}": {
    /** Get a project column */
    get: operations["projects/get-column"];
    /** Delete a project column */
    delete: operations["projects/delete-column"];
    /** Update an existing project column */
    patch: operations["projects/update-column"];
  };
  "/projects/columns/{column_id}/cards": {
    /** List project cards */
    get: operations["projects/list-cards"];
    /** Create a project card */
    post: operations["projects/create-card"];
  };
  "/projects/columns/{column_id}/moves": {
    /** Move a project column */
    post: operations["projects/move-column"];
  };
  "/projects/{project_id}": {
    /**
     * Get a project
     * @description Gets a project by its `id`. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    get: operations["projects/get"];
    /**
     * Delete a project
     * @description Deletes a project board. Returns a `404 Not Found` status if projects are disabled.
     */
    delete: operations["projects/delete"];
    /**
     * Update a project
     * @description Updates a project board's information. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    patch: operations["projects/update"];
  };
  "/projects/{project_id}/collaborators": {
    /**
     * List project collaborators
     * @description Lists the collaborators for an organization project. For a project, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners. You must be an organization owner or a project `admin` to list collaborators.
     */
    get: operations["projects/list-collaborators"];
  };
  "/projects/{project_id}/collaborators/{username}": {
    /**
     * Add project collaborator
     * @description Adds a collaborator to an organization project and sets their permission level. You must be an organization owner or a project `admin` to add a collaborator.
     */
    put: operations["projects/add-collaborator"];
    /**
     * Remove user as a collaborator
     * @description Removes a collaborator from an organization project. You must be an organization owner or a project `admin` to remove a collaborator.
     */
    delete: operations["projects/remove-collaborator"];
  };
  "/projects/{project_id}/collaborators/{username}/permission": {
    /**
     * Get project permission for a user
     * @description Returns the collaborator's permission level for an organization project. Possible values for the `permission` key: `admin`, `write`, `read`, `none`. You must be an organization owner or a project `admin` to review a user's permission level.
     */
    get: operations["projects/get-permission-for-user"];
  };
  "/projects/{project_id}/columns": {
    /** List project columns */
    get: operations["projects/list-columns"];
    /** Create a project column */
    post: operations["projects/create-column"];
  };
  "/rate_limit": {
    /**
     * Get rate limit status for the authenticated user
     * @description **Note:** Accessing this endpoint does not count against your REST API rate limit.
     *
     * **Note:** The `rate` object is deprecated. If you're writing new API client code or updating existing code, you should use the `core` object instead of the `rate` object. The `core` object contains the same information that is present in the `rate` object.
     */
    get: operations["rate-limit/get"];
  };
  "/repos/{org}/{repo}/actions/required_workflows": {
    /**
     * List repository required workflows
     * @description Lists the required workflows in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/list-repo-required-workflows"];
  };
  "/repos/{org}/{repo}/actions/required_workflows/{required_workflow_id_for_repo}": {
    /**
     * Get a required workflow entity for a repository
     * @description Gets a specific required workflow present in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/get-repo-required-workflow"];
  };
  "/repos/{org}/{repo}/actions/required_workflows/{required_workflow_id_for_repo}/timing": {
    /**
     * Get required workflow usage
     * @description Gets the number of billable minutes used by a specific required workflow during the current billing cycle.
     *
     * Billable minutes only apply to required workflows running in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)."
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-repo-required-workflow-usage"];
  };
  "/repos/{owner}/{repo}": {
    /**
     * Get a repository
     * @description The `parent` and `source` objects are present when the repository is a fork. `parent` is the repository this repository was forked from, `source` is the ultimate source for the network.
     *
     * **Note:** In order to see the `security_and_analysis` block for a repository you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
     */
    get: operations["repos/get"];
    /**
     * Delete a repository
     * @description Deleting a repository requires admin access. If OAuth is used, the `delete_repo` scope is required.
     *
     * If an organization owner has configured the organization to prevent members from deleting organization-owned
     * repositories, you will get a `403 Forbidden` response.
     */
    delete: operations["repos/delete"];
    /**
     * Update a repository
     * @description **Note**: To edit a repository's topics, use the [Replace all repository topics](https://docs.github.com/rest/reference/repos#replace-all-repository-topics) endpoint.
     */
    patch: operations["repos/update"];
  };
  "/repos/{owner}/{repo}/actions/artifacts": {
    /**
     * List artifacts for a repository
     * @description Lists all artifacts for a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/list-artifacts-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/artifacts/{artifact_id}": {
    /**
     * Get an artifact
     * @description Gets a specific artifact for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-artifact"];
    /**
     * Delete an artifact
     * @description Deletes an artifact for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    delete: operations["actions/delete-artifact"];
  };
  "/repos/{owner}/{repo}/actions/artifacts/{artifact_id}/{archive_format}": {
    /**
     * Download an artifact
     * @description Gets a redirect URL to download an archive for a repository. This URL expires after 1 minute. Look for `Location:` in
     * the response header to find the URL for the download. The `:archive_format` must be `zip`. Anyone with read access to
     * the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
     * GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/download-artifact"];
  };
  "/repos/{owner}/{repo}/actions/cache/usage": {
    /**
     * Get GitHub Actions cache usage for a repository
     * @description Gets GitHub Actions cache usage for a repository.
     * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-actions-cache-usage"];
  };
  "/repos/{owner}/{repo}/actions/caches": {
    /**
     * List GitHub Actions caches for a repository
     * @description Lists the GitHub Actions caches for a repository.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-actions-cache-list"];
    /**
     * Delete GitHub Actions caches for a repository (using a cache key)
     * @description Deletes one or more GitHub Actions caches for a repository, using a complete cache key. By default, all caches that match the provided key are deleted, but you can optionally provide a Git ref to restrict deletions to caches that match both the provided key and the Git ref.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     *
     * GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    delete: operations["actions/delete-actions-cache-by-key"];
  };
  "/repos/{owner}/{repo}/actions/caches/{cache_id}": {
    /**
     * Delete a GitHub Actions cache for a repository (using a cache ID)
     * @description Deletes a GitHub Actions cache for a repository, using a cache ID.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     *
     * GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    delete: operations["actions/delete-actions-cache-by-id"];
  };
  "/repos/{owner}/{repo}/actions/jobs/{job_id}": {
    /**
     * Get a job for a workflow run
     * @description Gets a specific job in a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-job-for-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/jobs/{job_id}/logs": {
    /**
     * Download job logs for a workflow run
     * @description Gets a redirect URL to download a plain text file of logs for a workflow job. This link expires after 1 minute. Look
     * for `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can
     * use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must
     * have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/download-job-logs-for-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/jobs/{job_id}/rerun": {
    /**
     * Re-run a job from a workflow run
     * @description Re-run a job and its dependent jobs in a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    post: operations["actions/re-run-job-for-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/oidc/customization/sub": {
    /**
     * Get the customization template for an OIDC subject claim for a repository
     * @description Gets the customization template for an OpenID Connect (OIDC) subject claim.
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint. GitHub Apps must have the `organization_administration:read` permission to use this endpoint.
     */
    get: operations["actions/get-custom-oidc-sub-claim-for-repo"];
    /**
     * Set the customization template for an OIDC subject claim for a repository
     * @description Sets the customization template and `opt-in` or `opt-out` flag for an OpenID Connect (OIDC) subject claim for a repository.
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    put: operations["actions/set-custom-oidc-sub-claim-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/organization-secrets": {
    /**
     * List repository organization secrets
     * @description Lists all organization secrets shared with a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/list-repo-organization-secrets"];
  };
  "/repos/{owner}/{repo}/actions/organization-variables": {
    /**
     * List repository organization variables
     * @description Lists all organiation variables shared with a repository. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
     */
    get: operations["actions/list-repo-organization-variables"];
  };
  "/repos/{owner}/{repo}/actions/permissions": {
    /**
     * Get GitHub Actions permissions for a repository
     * @description Gets the GitHub Actions permissions policy for a repository, including whether GitHub Actions is enabled and the actions and reusable workflows allowed to run in the repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     */
    get: operations["actions/get-github-actions-permissions-repository"];
    /**
     * Set GitHub Actions permissions for a repository
     * @description Sets the GitHub Actions permissions policy for enabling GitHub Actions and allowed actions and reusable workflows in the repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     */
    put: operations["actions/set-github-actions-permissions-repository"];
  };
  "/repos/{owner}/{repo}/actions/permissions/access": {
    /**
     * Get the level of access for workflows outside of the repository
     * @description Gets the level of access that workflows outside of the repository have to actions and reusable workflows in the repository.
     * This endpoint only applies to private repositories.
     * For more information, see "[Allowing access to components in a private repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#allowing-access-to-components-in-a-private-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the
     * repository `administration` permission to use this endpoint.
     */
    get: operations["actions/get-workflow-access-to-repository"];
    /**
     * Set the level of access for workflows outside of the repository
     * @description Sets the level of access that workflows outside of the repository have to actions and reusable workflows in the repository.
     * This endpoint only applies to private repositories.
     * For more information, see "[Allowing access to components in a private repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#allowing-access-to-components-in-a-private-repository)".
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the
     * repository `administration` permission to use this endpoint.
     */
    put: operations["actions/set-workflow-access-to-repository"];
  };
  "/repos/{owner}/{repo}/actions/permissions/selected-actions": {
    /**
     * Get allowed actions and reusable workflows for a repository
     * @description Gets the settings for selected actions and reusable workflows that are allowed in a repository. To use this endpoint, the repository policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     */
    get: operations["actions/get-allowed-actions-repository"];
    /**
     * Set allowed actions and reusable workflows for a repository
     * @description Sets the actions and reusable workflows that are allowed in a repository. To use this endpoint, the repository permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
     */
    put: operations["actions/set-allowed-actions-repository"];
  };
  "/repos/{owner}/{repo}/actions/permissions/workflow": {
    /**
     * Get default workflow permissions for a repository
     * @description Gets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in a repository,
     * as well as if GitHub Actions can submit approving pull request reviews.
     * For more information, see "[Setting the permissions of the GITHUB_TOKEN for your repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#setting-the-permissions-of-the-github_token-for-your-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the repository `administration` permission to use this API.
     */
    get: operations["actions/get-github-actions-default-workflow-permissions-repository"];
    /**
     * Set default workflow permissions for a repository
     * @description Sets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in a repository, and sets if GitHub Actions
     * can submit approving pull request reviews.
     * For more information, see "[Setting the permissions of the GITHUB_TOKEN for your repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#setting-the-permissions-of-the-github_token-for-your-repository)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the repository `administration` permission to use this API.
     */
    put: operations["actions/set-github-actions-default-workflow-permissions-repository"];
  };
  "/repos/{owner}/{repo}/actions/required_workflows/{required_workflow_id_for_repo}/runs": {
    /**
     * List workflow runs for a required workflow
     * @description List all workflow runs for a required workflow. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
     */
    get: operations["actions/list-required-workflow-runs"];
  };
  "/repos/{owner}/{repo}/actions/runners": {
    /**
     * List self-hosted runners for a repository
     * @description Lists all self-hosted runners configured in a repository. You must authenticate using an access token with the `repo` scope to use this endpoint.
     */
    get: operations["actions/list-self-hosted-runners-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/downloads": {
    /**
     * List runner applications for a repository
     * @description Lists binaries for the runner application that you can download and run.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     */
    get: operations["actions/list-runner-applications-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/registration-token": {
    /**
     * Create a registration token for a repository
     * @description Returns a token that you can pass to the `config` script. The token expires after one hour. You must authenticate
     * using an access token with the `repo` scope to use this endpoint.
     *
     * #### Example using registration token
     *
     * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
     *
     * ```
     * ./config.sh --url https://github.com/octo-org/octo-repo-artifacts --token TOKEN
     * ```
     */
    post: operations["actions/create-registration-token-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/remove-token": {
    /**
     * Create a remove token for a repository
     * @description Returns a token that you can pass to remove a self-hosted runner from a repository. The token expires after one hour.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     *
     * #### Example using remove token
     *
     * To remove your self-hosted runner from a repository, replace TOKEN with the remove token provided by this endpoint.
     *
     * ```
     * ./config.sh remove --token TOKEN
     * ```
     */
    post: operations["actions/create-remove-token-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/{runner_id}": {
    /**
     * Get a self-hosted runner for a repository
     * @description Gets a specific self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    get: operations["actions/get-self-hosted-runner-for-repo"];
    /**
     * Delete a self-hosted runner from a repository
     * @description Forces the removal of a self-hosted runner from a repository. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
     *
     * You must authenticate using an access token with the `repo`
     * scope to use this endpoint.
     */
    delete: operations["actions/delete-self-hosted-runner-from-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/{runner_id}/labels": {
    /**
     * List labels for a self-hosted runner for a repository
     * @description Lists all labels for a self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    get: operations["actions/list-labels-for-self-hosted-runner-for-repo"];
    /**
     * Set custom labels for a self-hosted runner for a repository
     * @description Remove all previous custom labels and set the new custom labels for a specific
     * self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    put: operations["actions/set-custom-labels-for-self-hosted-runner-for-repo"];
    /**
     * Add custom labels to a self-hosted runner for a repository
     * @description Add custom labels to a self-hosted runner configured in a repository.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    post: operations["actions/add-custom-labels-to-self-hosted-runner-for-repo"];
    /**
     * Remove all custom labels from a self-hosted runner for a repository
     * @description Remove all custom labels from a self-hosted runner configured in a
     * repository. Returns the remaining read-only labels from the runner.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    delete: operations["actions/remove-all-custom-labels-from-self-hosted-runner-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runners/{runner_id}/labels/{name}": {
    /**
     * Remove a custom label from a self-hosted runner for a repository
     * @description Remove a custom label from a self-hosted runner configured
     * in a repository. Returns the remaining labels from the runner.
     *
     * This endpoint returns a `404 Not Found` status if the custom label is not
     * present on the runner.
     *
     * You must authenticate using an access token with the `repo` scope to use this
     * endpoint.
     */
    delete: operations["actions/remove-custom-label-from-self-hosted-runner-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runs": {
    /**
     * List workflow runs for a repository
     * @description Lists all workflow runs for a repository. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/list-workflow-runs-for-repo"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}": {
    /**
     * Get a workflow run
     * @description Gets a specific workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-workflow-run"];
    /**
     * Delete a workflow run
     * @description Delete a specific workflow run. Anyone with write access to the repository can use this endpoint. If the repository is
     * private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:write` permission to use
     * this endpoint.
     */
    delete: operations["actions/delete-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/approvals": {
    /**
     * Get the review history for a workflow run
     * @description Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-reviews-for-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/approve": {
    /**
     * Approve a workflow run for a fork pull request
     * @description Approves a workflow run for a pull request from a public fork of a first time contributor. For more information, see ["Approving workflow runs from public forks](https://docs.github.com/actions/managing-workflow-runs/approving-workflow-runs-from-public-forks)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    post: operations["actions/approve-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/artifacts": {
    /**
     * List workflow run artifacts
     * @description Lists artifacts for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/list-workflow-run-artifacts"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}": {
    /**
     * Get a workflow run attempt
     * @description Gets a specific workflow run attempt. Anyone with read access to the repository
     * can use this endpoint. If the repository is private you must use an access token
     * with the `repo` scope. GitHub Apps must have the `actions:read` permission to
     * use this endpoint.
     */
    get: operations["actions/get-workflow-run-attempt"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/jobs": {
    /**
     * List jobs for a workflow run attempt
     * @description Lists jobs for a specific workflow run attempt. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
     */
    get: operations["actions/list-jobs-for-workflow-run-attempt"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/logs": {
    /**
     * Download workflow run attempt logs
     * @description Gets a redirect URL to download an archive of log files for a specific workflow run attempt. This link expires after
     * 1 minute. Look for `Location:` in the response header to find the URL for the download. Anyone with read access to
     * the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
     * GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/download-workflow-run-attempt-logs"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/cancel": {
    /**
     * Cancel a workflow run
     * @description Cancels a workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    post: operations["actions/cancel-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/deployment_protection_rule": {
    /**
     * Review custom deployment protection rules for a workflow run
     * @description Approve or reject custom deployment protection rules provided by a GitHub App for a workflow run. For more information, see "[Using environments for deployment](https://docs.github.com/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
     *
     * **Note:** GitHub Apps can only review their own custom deployment protection rules.
     * To approve or reject pending deployments that are waiting for review from a specific person or team, see [`POST /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments`](/rest/actions/workflow-runs#review-pending-deployments-for-a-workflow-run).
     *
     * GitHub Apps must have read and write permission for **Deployments** to use this endpoint.
     */
    post: operations["actions/review-custom-gates-for-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/jobs": {
    /**
     * List jobs for a workflow run
     * @description Lists jobs for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
     */
    get: operations["actions/list-jobs-for-workflow-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/logs": {
    /**
     * Download workflow run logs
     * @description Gets a redirect URL to download an archive of log files for a workflow run. This link expires after 1 minute. Look for
     * `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can use
     * this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have
     * the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/download-workflow-run-logs"];
    /**
     * Delete workflow run logs
     * @description Deletes all logs for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    delete: operations["actions/delete-workflow-run-logs"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments": {
    /**
     * Get pending deployments for a workflow run
     * @description Get all deployment environments for a workflow run that are waiting for protection rules to pass.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-pending-deployments-for-run"];
    /**
     * Review pending deployments for a workflow run
     * @description Approve or reject pending deployments that are waiting on approval by a required reviewer.
     *
     * Required reviewers with read access to the repository contents and deployments can use this endpoint. Required reviewers must authenticate using an access token with the `repo` scope to use this endpoint.
     */
    post: operations["actions/review-pending-deployments-for-run"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/rerun": {
    /**
     * Re-run a workflow
     * @description Re-runs your workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    post: operations["actions/re-run-workflow"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/rerun-failed-jobs": {
    /**
     * Re-run failed jobs from a workflow run
     * @description Re-run all of the failed jobs and their dependent jobs in a workflow run using the `id` of the workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint.
     */
    post: operations["actions/re-run-workflow-failed-jobs"];
  };
  "/repos/{owner}/{repo}/actions/runs/{run_id}/timing": {
    /**
     * Get workflow run usage
     * @description Gets the number of billable minutes and total run time for a specific workflow run. Billable minutes only apply to workflows in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-workflow-run-usage"];
  };
  "/repos/{owner}/{repo}/actions/secrets": {
    /**
     * List repository secrets
     * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/list-repo-secrets"];
  };
  "/repos/{owner}/{repo}/actions/secrets/public-key": {
    /**
     * Get a repository public key
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/get-repo-public-key"];
  };
  "/repos/{owner}/{repo}/actions/secrets/{secret_name}": {
    /**
     * Get a repository secret
     * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/get-repo-secret"];
    /**
     * Create or update a repository secret
     * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
     * this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["actions/create-or-update-repo-secret"];
    /**
     * Delete a repository secret
     * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    delete: operations["actions/delete-repo-secret"];
  };
  "/repos/{owner}/{repo}/actions/variables": {
    /**
     * List repository variables
     * @description Lists all repository variables. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
     */
    get: operations["actions/list-repo-variables"];
    /**
     * Create a repository variable
     * @description Creates a repository variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
     */
    post: operations["actions/create-repo-variable"];
  };
  "/repos/{owner}/{repo}/actions/variables/{name}": {
    /**
     * Get a repository variable
     * @description Gets a specific variable in a repository. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
     */
    get: operations["actions/get-repo-variable"];
    /**
     * Delete a repository variable
     * @description Deletes a repository variable using the variable name.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
     */
    delete: operations["actions/delete-repo-variable"];
    /**
     * Update a repository variable
     * @description Updates a repository variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
     */
    patch: operations["actions/update-repo-variable"];
  };
  "/repos/{owner}/{repo}/actions/workflows": {
    /**
     * List repository workflows
     * @description Lists the workflows in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/list-repo-workflows"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}": {
    /**
     * Get a workflow
     * @description Gets a specific workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-workflow"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}/disable": {
    /**
     * Disable a workflow
     * @description Disables a workflow and sets the `state` of the workflow to `disabled_manually`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    put: operations["actions/disable-workflow"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}/dispatches": {
    /**
     * Create a workflow dispatch event
     * @description You can use this endpoint to manually trigger a GitHub Actions workflow run. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must configure your GitHub Actions workflow to run when the [`workflow_dispatch` webhook](/developers/webhooks-and-events/webhook-events-and-payloads#workflow_dispatch) event occurs. The `inputs` are configured in the workflow file. For more information about how to configure the `workflow_dispatch` event in the workflow file, see "[Events that trigger workflows](/actions/reference/events-that-trigger-workflows#workflow_dispatch)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)."
     */
    post: operations["actions/create-workflow-dispatch"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}/enable": {
    /**
     * Enable a workflow
     * @description Enables a workflow and sets the `state` of the workflow to `active`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
     */
    put: operations["actions/enable-workflow"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}/runs": {
    /**
     * List workflow runs for a workflow
     * @description List all workflow runs for a workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
     */
    get: operations["actions/list-workflow-runs"];
  };
  "/repos/{owner}/{repo}/actions/workflows/{workflow_id}/timing": {
    /**
     * Get workflow usage
     * @description Gets the number of billable minutes used by a specific workflow during the current billing cycle. Billable minutes only apply to workflows in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
     *
     * You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["actions/get-workflow-usage"];
  };
  "/repos/{owner}/{repo}/assignees": {
    /**
     * List assignees
     * @description Lists the [available assignees](https://docs.github.com/articles/assigning-issues-and-pull-requests-to-other-github-users/) for issues in a repository.
     */
    get: operations["issues/list-assignees"];
  };
  "/repos/{owner}/{repo}/assignees/{assignee}": {
    /**
     * Check if a user can be assigned
     * @description Checks if a user has permission to be assigned to an issue in this repository.
     *
     * If the `assignee` can be assigned to issues in the repository, a `204` header with no content is returned.
     *
     * Otherwise a `404` status code is returned.
     */
    get: operations["issues/check-user-can-be-assigned"];
  };
  "/repos/{owner}/{repo}/autolinks": {
    /**
     * List all autolinks of a repository
     * @description This returns a list of autolinks configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     */
    get: operations["repos/list-autolinks"];
    /**
     * Create an autolink reference for a repository
     * @description Users with admin access to the repository can create an autolink.
     */
    post: operations["repos/create-autolink"];
  };
  "/repos/{owner}/{repo}/autolinks/{autolink_id}": {
    /**
     * Get an autolink reference of a repository
     * @description This returns a single autolink reference by ID that was configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     */
    get: operations["repos/get-autolink"];
    /**
     * Delete an autolink reference from a repository
     * @description This deletes a single autolink reference by ID that was configured for the given repository.
     *
     * Information about autolinks are only available to repository administrators.
     */
    delete: operations["repos/delete-autolink"];
  };
  "/repos/{owner}/{repo}/automated-security-fixes": {
    /**
     * Enable automated security fixes
     * @description Enables automated security fixes for a repository. The authenticated user must have admin access to the repository. For more information, see "[Configuring automated security fixes](https://docs.github.com/articles/configuring-automated-security-fixes)".
     */
    put: operations["repos/enable-automated-security-fixes"];
    /**
     * Disable automated security fixes
     * @description Disables automated security fixes for a repository. The authenticated user must have admin access to the repository. For more information, see "[Configuring automated security fixes](https://docs.github.com/articles/configuring-automated-security-fixes)".
     */
    delete: operations["repos/disable-automated-security-fixes"];
  };
  "/repos/{owner}/{repo}/branches": {
    /** List branches */
    get: operations["repos/list-branches"];
  };
  "/repos/{owner}/{repo}/branches/{branch}": {
    /** Get a branch */
    get: operations["repos/get-branch"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection": {
    /**
     * Get branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["repos/get-branch-protection"];
    /**
     * Update branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Protecting a branch requires admin or owner permissions to the repository.
     *
     * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
     *
     * **Note**: The list of users, apps, and teams in total is limited to 100 items.
     */
    put: operations["repos/update-branch-protection"];
    /**
     * Delete branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    delete: operations["repos/delete-branch-protection"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins": {
    /**
     * Get admin branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["repos/get-admin-branch-protection"];
    /**
     * Set admin branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Adding admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     */
    post: operations["repos/set-admin-branch-protection"];
    /**
     * Delete admin branch protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removing admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     */
    delete: operations["repos/delete-admin-branch-protection"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews": {
    /**
     * Get pull request review protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["repos/get-pull-request-review-protection"];
    /**
     * Delete pull request review protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    delete: operations["repos/delete-pull-request-review-protection"];
    /**
     * Update pull request review protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Updating pull request review enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
     *
     * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
     */
    patch: operations["repos/update-pull-request-review-protection"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/required_signatures": {
    /**
     * Get commit signature protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to check whether a branch requires signed commits. An enabled status of `true` indicates you must sign commits on this branch. For more information, see [Signing commits with GPG](https://docs.github.com/articles/signing-commits-with-gpg) in GitHub Help.
     *
     * **Note**: You must enable branch protection to require signed commits.
     */
    get: operations["repos/get-commit-signature-protection"];
    /**
     * Create commit signature protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to require signed commits on a branch. You must enable branch protection to require signed commits.
     */
    post: operations["repos/create-commit-signature-protection"];
    /**
     * Delete commit signature protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * When authenticated with admin or owner permissions to the repository, you can use this endpoint to disable required signed commits on a branch. You must enable branch protection to require signed commits.
     */
    delete: operations["repos/delete-commit-signature-protection"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks": {
    /**
     * Get status checks protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["repos/get-status-checks-protection"];
    /**
     * Remove status check protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    delete: operations["repos/remove-status-check-protection"];
    /**
     * Update status check protection
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Updating required status checks requires admin or owner permissions to the repository and branch protection to be enabled.
     */
    patch: operations["repos/update-status-check-protection"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts": {
    /**
     * Get all status check contexts
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["repos/get-all-status-check-contexts"];
    /**
     * Set status check contexts
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    put: operations["repos/set-status-check-contexts"];
    /**
     * Add status check contexts
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    post: operations["repos/add-status-check-contexts"];
    /**
     * Remove status check contexts
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    delete: operations["repos/remove-status-check-contexts"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/restrictions": {
    /**
     * Get access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists who has access to this protected branch.
     *
     * **Note**: Users, apps, and teams `restrictions` are only available for organization-owned repositories.
     */
    get: operations["repos/get-access-restrictions"];
    /**
     * Delete access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Disables the ability to restrict who can push to this branch.
     */
    delete: operations["repos/delete-access-restrictions"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps": {
    /**
     * Get apps with access to the protected branch
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the GitHub Apps that have push access to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     */
    get: operations["repos/get-apps-with-access-to-protected-branch"];
    /**
     * Set app access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of apps that have push access to this branch. This removes all apps that previously had push access and grants push access to the new list of apps. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     */
    put: operations["repos/set-app-access-restrictions"];
    /**
     * Add app access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified apps push access for this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     */
    post: operations["repos/add-app-access-restrictions"];
    /**
     * Remove app access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of an app to push to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
     */
    delete: operations["repos/remove-app-access-restrictions"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams": {
    /**
     * Get teams with access to the protected branch
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the teams who have push access to this branch. The list includes child teams.
     */
    get: operations["repos/get-teams-with-access-to-protected-branch"];
    /**
     * Set team access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of teams that have push access to this branch. This removes all teams that previously had push access and grants push access to the new list of teams. Team restrictions include child teams.
     */
    put: operations["repos/set-team-access-restrictions"];
    /**
     * Add team access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified teams push access for this branch. You can also give push access to child teams.
     */
    post: operations["repos/add-team-access-restrictions"];
    /**
     * Remove team access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of a team to push to this branch. You can also remove push access for child teams.
     */
    delete: operations["repos/remove-team-access-restrictions"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users": {
    /**
     * Get users with access to the protected branch
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists the people who have push access to this branch.
     */
    get: operations["repos/get-users-with-access-to-protected-branch"];
    /**
     * Set user access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Replaces the list of people that have push access to this branch. This removes all people that previously had push access and grants push access to the new list of people.
     *
     * | Type    | Description                                                                                                                   |
     * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     */
    put: operations["repos/set-user-access-restrictions"];
    /**
     * Add user access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Grants the specified people push access for this branch.
     *
     * | Type    | Description                                                                                                                   |
     * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     */
    post: operations["repos/add-user-access-restrictions"];
    /**
     * Remove user access restrictions
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Removes the ability of a user to push to this branch.
     *
     * | Type    | Description                                                                                                                                   |
     * | ------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
     * | `array` | Usernames of the people who should no longer have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
     */
    delete: operations["repos/remove-user-access-restrictions"];
  };
  "/repos/{owner}/{repo}/branches/{branch}/rename": {
    /**
     * Rename a branch
     * @description Renames a branch in a repository.
     *
     * **Note:** Although the API responds immediately, the branch rename process might take some extra time to complete in the background. You won't be able to push to the old branch name while the rename process is in progress. For more information, see "[Renaming a branch](https://docs.github.com/github/administering-a-repository/renaming-a-branch)".
     *
     * The permissions required to use this endpoint depends on whether you are renaming the default branch.
     *
     * To rename a non-default branch:
     *
     * * Users must have push access.
     * * GitHub Apps must have the `contents:write` repository permission.
     *
     * To rename the default branch:
     *
     * * Users must have admin or owner permissions.
     * * GitHub Apps must have the `administration:write` repository permission.
     */
    post: operations["repos/rename-branch"];
  };
  "/repos/{owner}/{repo}/check-runs": {
    /**
     * Create a check run
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Creates a new check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to create check runs.
     *
     * In a check suite, GitHub limits the number of check runs with the same name to 1000. Once these check runs exceed 1000, GitHub will start to automatically delete older check runs.
     */
    post: operations["checks/create"];
  };
  "/repos/{owner}/{repo}/check-runs/{check_run_id}": {
    /**
     * Get a check run
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Gets a single check run using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     */
    get: operations["checks/get"];
    /**
     * Update a check run
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Updates a check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to edit check runs.
     */
    patch: operations["checks/update"];
  };
  "/repos/{owner}/{repo}/check-runs/{check_run_id}/annotations": {
    /**
     * List check run annotations
     * @description Lists annotations for a check run using the annotation `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get annotations for a check run. OAuth Apps and authenticated users must have the `repo` scope to get annotations for a check run in a private repository.
     */
    get: operations["checks/list-annotations"];
  };
  "/repos/{owner}/{repo}/check-runs/{check_run_id}/rerequest": {
    /**
     * Rerequest a check run
     * @description Triggers GitHub to rerequest an existing check run, without pushing new code to a repository. This endpoint will trigger the [`check_run` webhook](https://docs.github.com/webhooks/event-payloads/#check_run) event with the action `rerequested`. When a check run is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
     *
     * To rerequest a check run, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
     */
    post: operations["checks/rerequest-run"];
  };
  "/repos/{owner}/{repo}/check-suites": {
    /**
     * Create a check suite
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * By default, check suites are automatically created when you create a [check run](https://docs.github.com/rest/reference/checks#check-runs). You only need to use this endpoint for manually creating check suites when you've disabled automatic creation using "[Update repository preferences for check suites](https://docs.github.com/rest/reference/checks#update-repository-preferences-for-check-suites)". Your GitHub App must have the `checks:write` permission to create check suites.
     */
    post: operations["checks/create-suite"];
  };
  "/repos/{owner}/{repo}/check-suites/preferences": {
    /**
     * Update repository preferences for check suites
     * @description Changes the default automatic flow when creating check suites. By default, a check suite is automatically created each time code is pushed to a repository. When you disable the automatic creation of check suites, you can manually [Create a check suite](https://docs.github.com/rest/reference/checks#create-a-check-suite). You must have admin permissions in the repository to set preferences for check suites.
     */
    patch: operations["checks/set-suites-preferences"];
  };
  "/repos/{owner}/{repo}/check-suites/{check_suite_id}": {
    /**
     * Get a check suite
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * Gets a single check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
     */
    get: operations["checks/get-suite"];
  };
  "/repos/{owner}/{repo}/check-suites/{check_suite_id}/check-runs": {
    /**
     * List check runs in a check suite
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Lists check runs for a check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     */
    get: operations["checks/list-for-suite"];
  };
  "/repos/{owner}/{repo}/check-suites/{check_suite_id}/rerequest": {
    /**
     * Rerequest a check suite
     * @description Triggers GitHub to rerequest an existing check suite, without pushing new code to a repository. This endpoint will trigger the [`check_suite` webhook](https://docs.github.com/webhooks/event-payloads/#check_suite) event with the action `rerequested`. When a check suite is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
     *
     * To rerequest a check suite, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
     */
    post: operations["checks/rerequest-suite"];
  };
  "/repos/{owner}/{repo}/code-scanning/alerts": {
    /**
     * List code scanning alerts for a repository
     * @description Lists all open code scanning alerts for the default branch (usually `main`
     * or `master`). You must use an access token with the `security_events` scope to use
     * this endpoint with private repos, the `public_repo` scope also grants permission to read
     * security events on public repos only. GitHub Apps must have the `security_events` read
     * permission to use this endpoint.
     *
     * The response includes a `most_recent_instance` object.
     * This provides details of the most recent instance of this alert
     * for the default branch or for the specified Git reference
     * (if you used `ref` in the request).
     */
    get: operations["code-scanning/list-alerts-for-repo"];
  };
  "/repos/{owner}/{repo}/code-scanning/alerts/{alert_number}": {
    /**
     * Get a code scanning alert
     * @description Gets a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
     */
    get: operations["code-scanning/get-alert"];
    /**
     * Update a code scanning alert
     * @description Updates the status of a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
     */
    patch: operations["code-scanning/update-alert"];
  };
  "/repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances": {
    /**
     * List instances of a code scanning alert
     * @description Lists all instances of the specified code scanning alert.
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     */
    get: operations["code-scanning/list-alert-instances"];
  };
  "/repos/{owner}/{repo}/code-scanning/analyses": {
    /**
     * List code scanning analyses for a repository
     * @description Lists the details of all code scanning analyses for a repository,
     * starting with the most recent.
     * The response is paginated and you can use the `page` and `per_page` parameters
     * to list the analyses you're interested in.
     * By default 30 analyses are listed per page.
     *
     * The `rules_count` field in the response give the number of rules
     * that were run in the analysis.
     * For very old analyses this data is not available,
     * and `0` is returned in this field.
     *
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     *
     * **Deprecation notice**:
     * The `tool_name` field is deprecated and will, in future, not be included in the response for this endpoint. The example response reflects this change. The tool name can now be found inside the `tool` field.
     */
    get: operations["code-scanning/list-recent-analyses"];
  };
  "/repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}": {
    /**
     * Get a code scanning analysis for a repository
     * @description Gets a specified code scanning analysis for a repository.
     * You must use an access token with the `security_events` scope to use this endpoint with private repos,
     * the `public_repo` scope also grants permission to read security events on public repos only.
     * GitHub Apps must have the `security_events` read permission to use this endpoint.
     *
     * The default JSON response contains fields that describe the analysis.
     * This includes the Git reference and commit SHA to which the analysis relates,
     * the datetime of the analysis, the name of the code scanning tool,
     * and the number of alerts.
     *
     * The `rules_count` field in the default response give the number of rules
     * that were run in the analysis.
     * For very old analyses this data is not available,
     * and `0` is returned in this field.
     *
     * If you use the Accept header `application/sarif+json`,
     * the response contains the analysis data that was uploaded.
     * This is formatted as
     * [SARIF version 2.1.0](https://docs.oasis-open.org/sarif/sarif/v2.1.0/cs01/sarif-v2.1.0-cs01.html).
     */
    get: operations["code-scanning/get-analysis"];
    /**
     * Delete a code scanning analysis from a repository
     * @description Deletes a specified code scanning analysis from a repository. For
     * private repositories, you must use an access token with the `repo` scope. For public repositories,
     * you must use an access token with `public_repo` scope.
     * GitHub Apps must have the `security_events` write permission to use this endpoint.
     *
     * You can delete one analysis at a time.
     * To delete a series of analyses, start with the most recent analysis and work backwards.
     * Conceptually, the process is similar to the undo function in a text editor.
     *
     * When you list the analyses for a repository,
     * one or more will be identified as deletable in the response:
     *
     * ```
     * "deletable": true
     * ```
     *
     * An analysis is deletable when it's the most recent in a set of analyses.
     * Typically, a repository will have multiple sets of analyses
     * for each enabled code scanning tool,
     * where a set is determined by a unique combination of analysis values:
     *
     * * `ref`
     * * `tool`
     * * `category`
     *
     * If you attempt to delete an analysis that is not the most recent in a set,
     * you'll get a 400 response with the message:
     *
     * ```
     * Analysis specified is not deletable.
     * ```
     *
     * The response from a successful `DELETE` operation provides you with
     * two alternative URLs for deleting the next analysis in the set:
     * `next_analysis_url` and `confirm_delete_url`.
     * Use the `next_analysis_url` URL if you want to avoid accidentally deleting the final analysis
     * in a set. This is a useful option if you want to preserve at least one analysis
     * for the specified tool in your repository.
     * Use the `confirm_delete_url` URL if you are content to remove all analyses for a tool.
     * When you delete the last analysis in a set, the value of `next_analysis_url` and `confirm_delete_url`
     * in the 200 response is `null`.
     *
     * As an example of the deletion process,
     * let's imagine that you added a workflow that configured a particular code scanning tool
     * to analyze the code in a repository. This tool has added 15 analyses:
     * 10 on the default branch, and another 5 on a topic branch.
     * You therefore have two separate sets of analyses for this tool.
     * You've now decided that you want to remove all of the analyses for the tool.
     * To do this you must make 15 separate deletion requests.
     * To start, you must find an analysis that's identified as deletable.
     * Each set of analyses always has one that's identified as deletable.
     * Having found the deletable analysis for one of the two sets,
     * delete this analysis and then continue deleting the next analysis in the set until they're all deleted.
     * Then repeat the process for the second set.
     * The procedure therefore consists of a nested loop:
     *
     * **Outer loop**:
     * * List the analyses for the repository, filtered by tool.
     * * Parse this list to find a deletable analysis. If found:
     *
     *   **Inner loop**:
     *   * Delete the identified analysis.
     *   * Parse the response for the value of `confirm_delete_url` and, if found, use this in the next iteration.
     *
     * The above process assumes that you want to remove all trace of the tool's analyses from the GitHub user interface, for the specified repository, and it therefore uses the `confirm_delete_url` value. Alternatively, you could use the `next_analysis_url` value, which would leave the last analysis in each set undeleted to avoid removing a tool's analysis entirely.
     */
    delete: operations["code-scanning/delete-analysis"];
  };
  "/repos/{owner}/{repo}/code-scanning/codeql/databases": {
    /**
     * List CodeQL databases for a repository
     * @description Lists the CodeQL databases that are available in a repository.
     *
     * For private repositories, you must use an access token with the `security_events` scope.
     * For public repositories, you can use tokens with the `security_events` or `public_repo` scope.
     * GitHub Apps must have the `contents` read permission to use this endpoint.
     */
    get: operations["code-scanning/list-codeql-databases"];
  };
  "/repos/{owner}/{repo}/code-scanning/codeql/databases/{language}": {
    /**
     * Get a CodeQL database for a repository
     * @description Gets a CodeQL database for a language in a repository.
     *
     * By default this endpoint returns JSON metadata about the CodeQL database. To
     * download the CodeQL database binary content, set the `Accept` header of the request
     * to [`application/zip`](https://docs.github.com/rest/overview/media-types), and make sure
     * your HTTP client is configured to follow redirects or use the `Location` header
     * to make a second request to get the redirect URL.
     *
     * For private repositories, you must use an access token with the `security_events` scope.
     * For public repositories, you can use tokens with the `security_events` or `public_repo` scope.
     * GitHub Apps must have the `contents` read permission to use this endpoint.
     */
    get: operations["code-scanning/get-codeql-database"];
  };
  "/repos/{owner}/{repo}/code-scanning/default-setup": {
    /**
     * Get a code scanning default setup configuration
     * @description Gets a code scanning default setup configuration.
     * You must use an access token with the `repo` scope to use this endpoint with private repos or the `public_repo`
     * scope for public repos. GitHub Apps must have the `repo` write permission to use this endpoint.
     */
    get: operations["code-scanning/get-default-setup"];
    /**
     * Update a code scanning default setup configuration
     * @description Updates a code scanning default setup configuration.
     * You must use an access token with the `repo` scope to use this endpoint with private repos or the `public_repo`
     * scope for public repos. GitHub Apps must have the `repo` write permission to use this endpoint.
     */
    patch: operations["code-scanning/update-default-setup"];
  };
  "/repos/{owner}/{repo}/code-scanning/sarifs": {
    /**
     * Upload an analysis as SARIF data
     * @description Uploads SARIF data containing the results of a code scanning analysis to make the results available in a repository. You must use an access token with the `security_events` scope to use this endpoint for private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
     *
     * There are two places where you can upload code scanning results.
     *  - If you upload to a pull request, for example `--ref refs/pull/42/merge` or `--ref refs/pull/42/head`, then the results appear as alerts in a pull request check. For more information, see "[Triaging code scanning alerts in pull requests](/code-security/secure-coding/triaging-code-scanning-alerts-in-pull-requests)."
     *  - If you upload to a branch, for example `--ref refs/heads/my-branch`, then the results appear in the **Security** tab for your repository. For more information, see "[Managing code scanning alerts for your repository](/code-security/secure-coding/managing-code-scanning-alerts-for-your-repository#viewing-the-alerts-for-a-repository)."
     *
     * You must compress the SARIF-formatted analysis data that you want to upload, using `gzip`, and then encode it as a Base64 format string. For example:
     *
     * ```
     * gzip -c analysis-data.sarif | base64 -w0
     * ```
     * <br>
     * SARIF upload supports a maximum number of entries per the following data objects, and an analysis will be rejected if any of these objects is above its maximum value. For some objects, there are additional values over which the entries will be ignored while keeping the most important entries whenever applicable.
     * To get the most out of your analysis when it includes data above the supported limits, try to optimize the analysis configuration. For example, for the CodeQL tool, identify and remove the most noisy queries.
     *
     *
     * | **SARIF data**                   | **Maximum values** | **Additional limits**                                                            |
     * |----------------------------------|:------------------:|----------------------------------------------------------------------------------|
     * | Runs per file                    |         20         |                                                                                  |
     * | Results per run                  |       25,000       | Only the top 5,000 results will be included, prioritized by severity.            |
     * | Rules per run                    |       25,000       |                                                                                  |
     * | Tool extensions per run          |        100         |                                                                                  |
     * | Thread Flow Locations per result |       10,000       | Only the top 1,000 Thread Flow Locations will be included, using prioritization. |
     * | Location per result	             |       1,000        | Only 100 locations will be included.                                             |
     * | Tags per rule	                   |         20         | Only 10 tags will be included.                                                   |
     *
     *
     * The `202 Accepted` response includes an `id` value.
     * You can use this ID to check the status of the upload by using it in the `/sarifs/{sarif_id}` endpoint.
     * For more information, see "[Get information about a SARIF upload](/rest/reference/code-scanning#get-information-about-a-sarif-upload)."
     */
    post: operations["code-scanning/upload-sarif"];
  };
  "/repos/{owner}/{repo}/code-scanning/sarifs/{sarif_id}": {
    /**
     * Get information about a SARIF upload
     * @description Gets information about a SARIF upload, including the status and the URL of the analysis that was uploaded so that you can retrieve details of the analysis. For more information, see "[Get a code scanning analysis for a repository](/rest/reference/code-scanning#get-a-code-scanning-analysis-for-a-repository)." You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
     */
    get: operations["code-scanning/get-sarif"];
  };
  "/repos/{owner}/{repo}/codeowners/errors": {
    /**
     * List CODEOWNERS errors
     * @description List any syntax errors that are detected in the CODEOWNERS
     * file.
     *
     * For more information about the correct CODEOWNERS syntax,
     * see "[About code owners](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/customizing-your-repository/about-code-owners)."
     */
    get: operations["repos/codeowners-errors"];
  };
  "/repos/{owner}/{repo}/codespaces": {
    /**
     * List codespaces in a repository for the authenticated user
     * @description Lists the codespaces associated to a specified repository and the authenticated user.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
     */
    get: operations["codespaces/list-in-repository-for-authenticated-user"];
    /**
     * Create a codespace in a repository
     * @description Creates a codespace owned by the authenticated user in the specified repository.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    post: operations["codespaces/create-with-repo-for-authenticated-user"];
  };
  "/repos/{owner}/{repo}/codespaces/devcontainers": {
    /**
     * List devcontainer configurations in a repository for the authenticated user
     * @description Lists the devcontainer.json files associated with a specified repository and the authenticated user. These files
     * specify launchpoint configurations for codespaces created within the repository.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_metadata` repository permission to use this endpoint.
     */
    get: operations["codespaces/list-devcontainers-in-repository-for-authenticated-user"];
  };
  "/repos/{owner}/{repo}/codespaces/machines": {
    /**
     * List available machine types for a repository
     * @description List the machine types available for a given repository based on its configuration.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_metadata` repository permission to use this endpoint.
     */
    get: operations["codespaces/repo-machines-for-authenticated-user"];
  };
  "/repos/{owner}/{repo}/codespaces/new": {
    /**
     * Get default attributes for a codespace
     * @description Gets the default attributes for codespaces created by the user with the repository.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    get: operations["codespaces/pre-flight-with-repo-for-authenticated-user"];
  };
  "/repos/{owner}/{repo}/codespaces/secrets": {
    /**
     * List repository secrets
     * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
     */
    get: operations["codespaces/list-repo-secrets"];
  };
  "/repos/{owner}/{repo}/codespaces/secrets/public-key": {
    /**
     * Get a repository public key
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
     */
    get: operations["codespaces/get-repo-public-key"];
  };
  "/repos/{owner}/{repo}/codespaces/secrets/{secret_name}": {
    /**
     * Get a repository secret
     * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
     */
    get: operations["codespaces/get-repo-secret"];
    /**
     * Create or update a repository secret
     * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets`
     * repository permission to use this endpoint.
     *
     * #### Example of encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example of encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example of encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example of encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["codespaces/create-or-update-repo-secret"];
    /**
     * Delete a repository secret
     * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
     */
    delete: operations["codespaces/delete-repo-secret"];
  };
  "/repos/{owner}/{repo}/collaborators": {
    /**
     * List repository collaborators
     * @description For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
     * Organization members with write, maintain, or admin privileges on the organization-owned repository can use this endpoint.
     *
     * Team members will include the members of child teams.
     *
     * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
     * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
     * endpoint.
     */
    get: operations["repos/list-collaborators"];
  };
  "/repos/{owner}/{repo}/collaborators/{username}": {
    /**
     * Check if a user is a repository collaborator
     * @description For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
     *
     * Team members will include the members of child teams.
     *
     * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
     * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
     * endpoint.
     */
    get: operations["repos/check-collaborator"];
    /**
     * Add a repository collaborator
     * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * Adding an outside collaborator may be restricted by enterprise administrators. For more information, see "[Enforcing repository management policies in your enterprise](https://docs.github.com/admin/policies/enforcing-policies-for-your-enterprise/enforcing-repository-management-policies-in-your-enterprise#enforcing-a-policy-for-inviting-outside-collaborators-to-repositories)."
     *
     * For more information on permission levels, see "[Repository permission levels for an organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)". There are restrictions on which permissions can be granted to organization members when an organization base role is in place. In this case, the permission being given must be equal to or higher than the org base permission. Otherwise, the request will fail with:
     *
     * ```
     * Cannot assign {member} permission of {role name}
     * ```
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * The invitee will receive a notification that they have been invited to the repository, which they must accept or decline. They may do this via the notifications page, the email they receive, or by using the [repository invitations API endpoints](https://docs.github.com/rest/reference/repos#invitations).
     *
     * **Updating an existing collaborator's permission level**
     *
     * The endpoint can also be used to change the permissions of an existing collaborator without first removing and re-adding the collaborator. To change the permissions, use the same endpoint and pass a different `permission` parameter. The response will be a `204`, with no other indication that the permission level changed.
     *
     * **Rate limits**
     *
     * You are limited to sending 50 invitations to a repository per 24 hour period. Note there is no limit if you are inviting organization members to an organization repository.
     */
    put: operations["repos/add-collaborator"];
    /** Remove a repository collaborator */
    delete: operations["repos/remove-collaborator"];
  };
  "/repos/{owner}/{repo}/collaborators/{username}/permission": {
    /**
     * Get repository permissions for a user
     * @description Checks the repository permission of a collaborator. The possible repository permissions are `admin`, `write`, `read`, and `none`.
     */
    get: operations["repos/get-collaborator-permission-level"];
  };
  "/repos/{owner}/{repo}/comments": {
    /**
     * List commit comments for a repository
     * @description Commit Comments use [these custom media types](https://docs.github.com/rest/reference/repos#custom-media-types). You can read more about the use of media types in the API [here](https://docs.github.com/rest/overview/media-types/).
     *
     * Comments are ordered by ascending ID.
     */
    get: operations["repos/list-commit-comments-for-repo"];
  };
  "/repos/{owner}/{repo}/comments/{comment_id}": {
    /** Get a commit comment */
    get: operations["repos/get-commit-comment"];
    /** Delete a commit comment */
    delete: operations["repos/delete-commit-comment"];
    /** Update a commit comment */
    patch: operations["repos/update-commit-comment"];
  };
  "/repos/{owner}/{repo}/comments/{comment_id}/reactions": {
    /**
     * List reactions for a commit comment
     * @description List the reactions to a [commit comment](https://docs.github.com/rest/reference/repos#comments).
     */
    get: operations["reactions/list-for-commit-comment"];
    /**
     * Create reaction for a commit comment
     * @description Create a reaction to a [commit comment](https://docs.github.com/rest/reference/repos#comments). A response with an HTTP `200` status means that you already added the reaction type to this commit comment.
     */
    post: operations["reactions/create-for-commit-comment"];
  };
  "/repos/{owner}/{repo}/comments/{comment_id}/reactions/{reaction_id}": {
    /**
     * Delete a commit comment reaction
     * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/comments/:comment_id/reactions/:reaction_id`.
     *
     * Delete a reaction to a [commit comment](https://docs.github.com/rest/reference/repos#comments).
     */
    delete: operations["reactions/delete-for-commit-comment"];
  };
  "/repos/{owner}/{repo}/commits": {
    /**
     * List commits
     * @description **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["repos/list-commits"];
  };
  "/repos/{owner}/{repo}/commits/{commit_sha}/branches-where-head": {
    /**
     * List branches for HEAD commit
     * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Returns all branches where the given commit SHA is the HEAD, or latest commit for the branch.
     */
    get: operations["repos/list-branches-for-head-commit"];
  };
  "/repos/{owner}/{repo}/commits/{commit_sha}/comments": {
    /**
     * List commit comments
     * @description Use the `:commit_sha` to specify the commit that will have its comments listed.
     */
    get: operations["repos/list-comments-for-commit"];
    /**
     * Create a commit comment
     * @description Create a comment for a commit using its `:commit_sha`.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["repos/create-commit-comment"];
  };
  "/repos/{owner}/{repo}/commits/{commit_sha}/pulls": {
    /**
     * List pull requests associated with a commit
     * @description Lists the merged pull request that introduced the commit to the repository. If the commit is not present in the default branch, will only return open pull requests associated with the commit.
     */
    get: operations["repos/list-pull-requests-associated-with-commit"];
  };
  "/repos/{owner}/{repo}/commits/{ref}": {
    /**
     * Get a commit
     * @description Returns the contents of a single commit reference. You must have `read` access for the repository to use this endpoint.
     *
     * **Note:** If there are more than 300 files in the commit diff, the response will include pagination link headers for the remaining files, up to a limit of 3000 files. Each page contains the static commit information, and the only changes are to the file listing.
     *
     * You can pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to  fetch `diff` and `patch` formats. Diffs with binary data will have no `patch` property.
     *
     * To return only the SHA-1 hash of the commit reference, you can provide the `sha` custom [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) in the `Accept` header. You can use this endpoint to check if a remote reference's SHA-1 hash is the same as your local reference's SHA-1 hash by providing the local SHA-1 reference as the ETag.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["repos/get-commit"];
  };
  "/repos/{owner}/{repo}/commits/{ref}/check-runs": {
    /**
     * List check runs for a Git reference
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
     *
     * Lists check runs for a commit ref. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
     */
    get: operations["checks/list-for-ref"];
  };
  "/repos/{owner}/{repo}/commits/{ref}/check-suites": {
    /**
     * List check suites for a Git reference
     * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
     *
     * Lists check suites for a commit `ref`. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to list check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
     */
    get: operations["checks/list-suites-for-ref"];
  };
  "/repos/{owner}/{repo}/commits/{ref}/status": {
    /**
     * Get the combined status for a specific reference
     * @description Users with pull access in a repository can access a combined view of commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name.
     *
     *
     * Additionally, a combined `state` is returned. The `state` is one of:
     *
     * *   **failure** if any of the contexts report as `error` or `failure`
     * *   **pending** if there are no statuses or a context is `pending`
     * *   **success** if the latest status for all contexts is `success`
     */
    get: operations["repos/get-combined-status-for-ref"];
  };
  "/repos/{owner}/{repo}/commits/{ref}/statuses": {
    /**
     * List commit statuses for a reference
     * @description Users with pull access in a repository can view commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name. Statuses are returned in reverse chronological order. The first status in the list will be the latest one.
     *
     * This resource is also available via a legacy route: `GET /repos/:owner/:repo/statuses/:ref`.
     */
    get: operations["repos/list-commit-statuses-for-ref"];
  };
  "/repos/{owner}/{repo}/community/profile": {
    /**
     * Get community profile metrics
     * @description Returns all community profile metrics for a repository. The repository cannot be a fork.
     *
     * The returned metrics include an overall health score, the repository description, the presence of documentation, the
     * detected code of conduct, the detected license, and the presence of ISSUE\_TEMPLATE, PULL\_REQUEST\_TEMPLATE,
     * README, and CONTRIBUTING files.
     *
     * The `health_percentage` score is defined as a percentage of how many of
     * these four documents are present: README, CONTRIBUTING, LICENSE, and
     * CODE_OF_CONDUCT. For example, if all four documents are present, then
     * the `health_percentage` is `100`. If only one is present, then the
     * `health_percentage` is `25`.
     *
     * `content_reports_enabled` is only returned for organization-owned repositories.
     */
    get: operations["repos/get-community-profile-metrics"];
  };
  "/repos/{owner}/{repo}/compare/{basehead}": {
    /**
     * Compare two commits
     * @description Compares two commits against one another. You can compare branches in the same repository, or you can compare branches that exist in different repositories within the same repository network, including fork branches. For more information about how to view a repository's network, see "[Understanding connections between repositories](https://docs.github.com/repositories/viewing-activity-and-data-for-your-repository/understanding-connections-between-repositories)."
     *
     * This endpoint is equivalent to running the `git log BASE..HEAD` command, but it returns commits in a different order. The `git log BASE..HEAD` command returns commits in reverse chronological order, whereas the API returns commits in chronological order. You can pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
     *
     * The API response includes details about the files that were changed between the two commits. This includes the status of the change (if a file was added, removed, modified, or renamed), and details of the change itself. For example, files with a `renamed` status have a `previous_filename` field showing the previous filename of the file, and files with a `modified` status have a `patch` field showing the changes made to the file.
     *
     * When calling this endpoint without any paging parameter (`per_page` or `page`), the returned list is limited to 250 commits, and the last commit in the list is the most recent of the entire comparison.
     *
     * **Working with large comparisons**
     *
     * To process a response with a large number of commits, use a query parameter (`per_page` or `page`) to paginate the results. When using pagination:
     *
     * - The list of changed files is only shown on the first page of results, but it includes all changed files for the entire comparison.
     * - The results are returned in chronological order, but the last commit in the returned list may not be the most recent one in the entire set if there are more pages of results.
     *
     * For more information on working with pagination, see "[Using pagination in the REST API](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api)."
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The `verification` object includes the following fields:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["repos/compare-commits-with-basehead"];
  };
  "/repos/{owner}/{repo}/contents/{path}": {
    /**
     * Get repository content
     * @description Gets the contents of a file or directory in a repository. Specify the file path or directory in `:path`. If you omit
     * `:path`, you will receive the contents of the repository's root directory. See the description below regarding what the API response includes for directories.
     *
     * Files and symlinks support [a custom media type](https://docs.github.com/rest/reference/repos#custom-media-types) for
     * retrieving the raw content or rendered HTML (when supported). All content types support [a custom media
     * type](https://docs.github.com/rest/reference/repos#custom-media-types) to ensure the content is returned in a consistent
     * object format.
     *
     * **Notes**:
     * *   To get a repository's contents recursively, you can [recursively get the tree](https://docs.github.com/rest/reference/git#trees).
     * *   This API has an upper limit of 1,000 files for a directory. If you need to retrieve more files, use the [Git Trees
     * API](https://docs.github.com/rest/reference/git#get-a-tree).
     *  *  Download URLs expire and are meant to be used just once. To ensure the download URL does not expire, please use the contents API to obtain a fresh download URL for each download.
     * #### Size limits
     * If the requested file's size is:
     * * 1 MB or smaller: All features of this endpoint are supported.
     * * Between 1-100 MB: Only the `raw` or `object` [custom media types](https://docs.github.com/rest/repos/contents#custom-media-types-for-repository-contents) are supported. Both will work as normal, except that when using the `object` media type, the `content` field will be an empty string and the `encoding` field will be `"none"`. To get the contents of these larger files, use the `raw` media type.
     *  * Greater than 100 MB: This endpoint is not supported.
     *
     * #### If the content is a directory
     * The response will be an array of objects, one object for each item in the directory.
     * When listing the contents of a directory, submodules have their "type" specified as "file". Logically, the value
     * _should_ be "submodule". This behavior exists in API v3 [for backwards compatibility purposes](https://git.io/v1YCW).
     * In the next major version of the API, the type will be returned as "submodule".
     *
     * #### If the content is a symlink
     * If the requested `:path` points to a symlink, and the symlink's target is a normal file in the repository, then the
     * API responds with the content of the file (in the format shown in the example. Otherwise, the API responds with an object
     * describing the symlink itself.
     *
     * #### If the content is a submodule
     * The `submodule_git_url` identifies the location of the submodule repository, and the `sha` identifies a specific
     * commit within the submodule repository. Git uses the given URL when cloning the submodule repository, and checks out
     * the submodule at that specific commit.
     *
     * If the submodule repository is not hosted on github.com, the Git URLs (`git_url` and `_links["git"]`) and the
     * github.com URLs (`html_url` and `_links["html"]`) will have null values.
     */
    get: operations["repos/get-content"];
    /**
     * Create or update file contents
     * @description Creates a new file or replaces an existing file in a repository. You must authenticate using an access token with the `workflow` scope to use this endpoint.
     *
     * **Note:** If you use this endpoint and the "[Delete a file](https://docs.github.com/rest/reference/repos/#delete-file)" endpoint in parallel, the concurrent requests will conflict and you will receive errors. You must use these endpoints serially instead.
     */
    put: operations["repos/create-or-update-file-contents"];
    /**
     * Delete a file
     * @description Deletes a file in a repository.
     *
     * You can provide an additional `committer` parameter, which is an object containing information about the committer. Or, you can provide an `author` parameter, which is an object containing information about the author.
     *
     * The `author` section is optional and is filled in with the `committer` information if omitted. If the `committer` information is omitted, the authenticated user's information is used.
     *
     * You must provide values for both `name` and `email`, whether you choose to use `author` or `committer`. Otherwise, you'll receive a `422` status code.
     *
     * **Note:** If you use this endpoint and the "[Create or update file contents](https://docs.github.com/rest/reference/repos/#create-or-update-file-contents)" endpoint in parallel, the concurrent requests will conflict and you will receive errors. You must use these endpoints serially instead.
     */
    delete: operations["repos/delete-file"];
  };
  "/repos/{owner}/{repo}/contributors": {
    /**
     * List repository contributors
     * @description Lists contributors to the specified repository and sorts them by the number of commits per contributor in descending order. This endpoint may return information that is a few hours old because the GitHub REST API caches contributor data to improve performance.
     *
     * GitHub identifies contributors by author email address. This endpoint groups contribution counts by GitHub user, which includes all associated email addresses. To improve performance, only the first 500 author email addresses in the repository link to GitHub users. The rest will appear as anonymous contributors without associated GitHub user information.
     */
    get: operations["repos/list-contributors"];
  };
  "/repos/{owner}/{repo}/dependabot/alerts": {
    /**
     * List Dependabot alerts for a repository
     * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
     * You can also use tokens with the `public_repo` scope for public repositories only.
     * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
     */
    get: operations["dependabot/list-alerts-for-repo"];
  };
  "/repos/{owner}/{repo}/dependabot/alerts/{alert_number}": {
    /**
     * Get a Dependabot alert
     * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
     * You can also use tokens with the `public_repo` scope for public repositories only.
     * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
     */
    get: operations["dependabot/get-alert"];
    /**
     * Update a Dependabot alert
     * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
     * You can also use tokens with the `public_repo` scope for public repositories only.
     * GitHub Apps must have **Dependabot alerts** write permission to use this endpoint.
     */
    patch: operations["dependabot/update-alert"];
  };
  "/repos/{owner}/{repo}/dependabot/secrets": {
    /**
     * List repository secrets
     * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     */
    get: operations["dependabot/list-repo-secrets"];
  };
  "/repos/{owner}/{repo}/dependabot/secrets/public-key": {
    /**
     * Get a repository public key
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     */
    get: operations["dependabot/get-repo-public-key"];
  };
  "/repos/{owner}/{repo}/dependabot/secrets/{secret_name}": {
    /**
     * Get a repository secret
     * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     */
    get: operations["dependabot/get-repo-secret"];
    /**
     * Create or update a repository secret
     * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository
     * permission to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["dependabot/create-or-update-repo-secret"];
    /**
     * Delete a repository secret
     * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
     */
    delete: operations["dependabot/delete-repo-secret"];
  };
  "/repos/{owner}/{repo}/dependency-graph/compare/{basehead}": {
    /**
     * Get a diff of the dependencies between commits
     * @description Gets the diff of the dependency changes between two commits of a repository, based on the changes to the dependency manifests made in those commits.
     */
    get: operations["dependency-graph/diff-range"];
  };
  "/repos/{owner}/{repo}/dependency-graph/sbom": {
    /**
     * Export a software bill of materials (SBOM) for a repository.
     * @description Exports the software bill of materials (SBOM) for a repository in SPDX JSON format.
     */
    get: operations["dependency-graph/export-sbom"];
  };
  "/repos/{owner}/{repo}/dependency-graph/snapshots": {
    /**
     * Create a snapshot of dependencies for a repository
     * @description Create a new snapshot of a repository's dependencies. You must authenticate using an access token with the `repo` scope to use this endpoint for a repository that the requesting user has access to.
     */
    post: operations["dependency-graph/create-repository-snapshot"];
  };
  "/repos/{owner}/{repo}/deployments": {
    /**
     * List deployments
     * @description Simple filtering of deployments is available via query parameters:
     */
    get: operations["repos/list-deployments"];
    /**
     * Create a deployment
     * @description Deployments offer a few configurable parameters with certain defaults.
     *
     * The `ref` parameter can be any named branch, tag, or SHA. At GitHub we often deploy branches and verify them
     * before we merge a pull request.
     *
     * The `environment` parameter allows deployments to be issued to different runtime environments. Teams often have
     * multiple environments for verifying their applications, such as `production`, `staging`, and `qa`. This parameter
     * makes it easier to track which environments have requested deployments. The default environment is `production`.
     *
     * The `auto_merge` parameter is used to ensure that the requested ref is not behind the repository's default branch. If
     * the ref _is_ behind the default branch for the repository, we will attempt to merge it for you. If the merge succeeds,
     * the API will return a successful merge commit. If merge conflicts prevent the merge from succeeding, the API will
     * return a failure response.
     *
     * By default, [commit statuses](https://docs.github.com/rest/commits/statuses) for every submitted context must be in a `success`
     * state. The `required_contexts` parameter allows you to specify a subset of contexts that must be `success`, or to
     * specify contexts that have not yet been submitted. You are not required to use commit statuses to deploy. If you do
     * not require any contexts or create any commit statuses, the deployment will always succeed.
     *
     * The `payload` parameter is available for any extra information that a deployment system might need. It is a JSON text
     * field that will be passed on when a deployment event is dispatched.
     *
     * The `task` parameter is used by the deployment system to allow different execution paths. In the web world this might
     * be `deploy:migrations` to run schema changes on the system. In the compiled world this could be a flag to compile an
     * application with debugging enabled.
     *
     * Users with `repo` or `repo_deployment` scopes can create a deployment for a given ref.
     *
     * #### Merged branch response
     * You will see this response when GitHub automatically merges the base branch into the topic branch instead of creating
     * a deployment. This auto-merge happens when:
     * *   Auto-merge option is enabled in the repository
     * *   Topic branch does not include the latest changes on the base branch, which is `master` in the response example
     * *   There are no merge conflicts
     *
     * If there are no new commits in the base branch, a new request to create a deployment should give a successful
     * response.
     *
     * #### Merge conflict response
     * This error happens when the `auto_merge` option is enabled and when the default branch (in this case `master`), can't
     * be merged into the branch that's being deployed (in this case `topic-branch`), due to merge conflicts.
     *
     * #### Failed commit status checks
     * This error happens when the `required_contexts` parameter indicates that one or more contexts need to have a `success`
     * status for the commit to be deployed, but one or more of the required contexts do not have a state of `success`.
     */
    post: operations["repos/create-deployment"];
  };
  "/repos/{owner}/{repo}/deployments/{deployment_id}": {
    /** Get a deployment */
    get: operations["repos/get-deployment"];
    /**
     * Delete a deployment
     * @description If the repository only has one deployment, you can delete the deployment regardless of its status. If the repository has more than one deployment, you can only delete inactive deployments. This ensures that repositories with multiple deployments will always have an active deployment. Anyone with `repo` or `repo_deployment` scopes can delete a deployment.
     *
     * To set a deployment as inactive, you must:
     *
     * *   Create a new deployment that is active so that the system has a record of the current state, then delete the previously active deployment.
     * *   Mark the active deployment as inactive by adding any non-successful deployment status.
     *
     * For more information, see "[Create a deployment](https://docs.github.com/rest/deployments/deployments/#create-a-deployment)" and "[Create a deployment status](https://docs.github.com/rest/deployments/deployment-statuses#create-a-deployment-status)."
     */
    delete: operations["repos/delete-deployment"];
  };
  "/repos/{owner}/{repo}/deployments/{deployment_id}/statuses": {
    /**
     * List deployment statuses
     * @description Users with pull access can view deployment statuses for a deployment:
     */
    get: operations["repos/list-deployment-statuses"];
    /**
     * Create a deployment status
     * @description Users with `push` access can create deployment statuses for a given deployment.
     *
     * GitHub Apps require `read & write` access to "Deployments" and `read-only` access to "Repo contents" (for private repos). OAuth Apps require the `repo_deployment` scope.
     */
    post: operations["repos/create-deployment-status"];
  };
  "/repos/{owner}/{repo}/deployments/{deployment_id}/statuses/{status_id}": {
    /**
     * Get a deployment status
     * @description Users with pull access can view a deployment status for a deployment:
     */
    get: operations["repos/get-deployment-status"];
  };
  "/repos/{owner}/{repo}/dispatches": {
    /**
     * Create a repository dispatch event
     * @description You can use this endpoint to trigger a webhook event called `repository_dispatch` when you want activity that happens outside of GitHub to trigger a GitHub Actions workflow or GitHub App webhook. You must configure your GitHub Actions workflow or GitHub App to run when the `repository_dispatch` event occurs. For an example `repository_dispatch` webhook payload, see "[RepositoryDispatchEvent](https://docs.github.com/webhooks/event-payloads/#repository_dispatch)."
     *
     * The `client_payload` parameter is available for any extra information that your workflow might need. This parameter is a JSON payload that will be passed on when the webhook event is dispatched. For example, the `client_payload` can include a message that a user would like to send using a GitHub Actions workflow. Or the `client_payload` can be used as a test to debug your workflow.
     *
     * This endpoint requires write access to the repository by providing either:
     *
     *   - Personal access tokens with `repo` scope. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)" in the GitHub Help documentation.
     *   - GitHub Apps with both `metadata:read` and `contents:read&write` permissions.
     *
     * This input example shows how you can use the `client_payload` as a test to debug your workflow.
     */
    post: operations["repos/create-dispatch-event"];
  };
  "/repos/{owner}/{repo}/environments": {
    /**
     * List environments
     * @description Lists the environments for a repository.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["repos/get-all-environments"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}": {
    /**
     * Get an environment
     * @description **Note:** To get information about name patterns that branches must match in order to deploy to this environment, see "[Get a deployment branch policy](/rest/deployments/branch-policies#get-a-deployment-branch-policy)."
     *
     * Anyone with read access to the repository can use this endpoint. If the
     * repository is private, you must use an access token with the `repo` scope. GitHub
     * Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["repos/get-environment"];
    /**
     * Create or update an environment
     * @description Create or update an environment with protection rules, such as required reviewers. For more information about environment protection rules, see "[Environments](/actions/reference/environments#environment-protection-rules)."
     *
     * **Note:** To create or update name patterns that branches must match in order to deploy to this environment, see "[Deployment branch policies](/rest/deployments/branch-policies)."
     *
     * **Note:** To create or update secrets for an environment, see "[Secrets](/rest/reference/actions#secrets)."
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
     */
    put: operations["repos/create-or-update-environment"];
    /**
     * Delete an environment
     * @description You must authenticate using an access token with the repo scope to use this endpoint.
     */
    delete: operations["repos/delete-an-environment"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies": {
    /**
     * List deployment branch policies
     * @description Lists the deployment branch policies for an environment.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["repos/list-deployment-branch-policies"];
    /**
     * Create a deployment branch policy
     * @description Creates a deployment branch policy for an environment.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
     */
    post: operations["repos/create-deployment-branch-policy"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}/deployment-branch-policies/{branch_policy_id}": {
    /**
     * Get a deployment branch policy
     * @description Gets a deployment branch policy for an environment.
     *
     * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
     */
    get: operations["repos/get-deployment-branch-policy"];
    /**
     * Update a deployment branch policy
     * @description Updates a deployment branch policy for an environment.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
     */
    put: operations["repos/update-deployment-branch-policy"];
    /**
     * Delete a deployment branch policy
     * @description Deletes a deployment branch policy for an environment.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
     */
    delete: operations["repos/delete-deployment-branch-policy"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules": {
    /**
     * Get all deployment protection rules for an environment
     * @description Gets all custom deployment protection rules that are enabled for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint. For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
     *
     * For more information about the app that is providing this custom deployment rule, see the [documentation for the `GET /apps/{app_slug}` endpoint](https://docs.github.com/rest/apps/apps#get-an-app).
     */
    get: operations["repos/get-all-deployment-protection-rules"];
    /**
     * Create a custom deployment protection rule on an environment
     * @description Enable a custom deployment protection rule for an environment.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. Enabling a custom protection rule requires admin or owner permissions to the repository. GitHub Apps must have the `actions:write` permission to use this endpoint.
     *
     * For more information about the app that is providing this custom deployment rule, see the [documentation for the `GET /apps/{app_slug}` endpoint](https://docs.github.com/rest/apps/apps#get-an-app).
     */
    post: operations["repos/create-deployment-protection-rule"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules/apps": {
    /**
     * List custom deployment rule integrations available for an environment
     * @description Gets all custom deployment protection rule integrations that are available for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint.
     *
     * For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
     *
     * For more information about the app that is providing this custom deployment rule, see "[GET an app](https://docs.github.com/rest/apps/apps#get-an-app)".
     */
    get: operations["repos/list-custom-deployment-rule-integrations"];
  };
  "/repos/{owner}/{repo}/environments/{environment_name}/deployment_protection_rules/{protection_rule_id}": {
    /**
     * Get a custom deployment protection rule
     * @description Gets an enabled custom deployment protection rule for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint. For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
     *
     * For more information about the app that is providing this custom deployment rule, see [`GET /apps/{app_slug}`](https://docs.github.com/rest/apps/apps#get-an-app).
     */
    get: operations["repos/get-custom-deployment-protection-rule"];
    /**
     * Disable a custom protection rule for an environment
     * @description Disables a custom deployment protection rule for an environment.
     *
     * You must authenticate using an access token with the `repo` scope to use this endpoint. Removing a custom protection rule requires admin or owner permissions to the repository. GitHub Apps must have the `actions:write` permission to use this endpoint. For more information, see "[Get an app](https://docs.github.com/rest/apps/apps#get-an-app)".
     */
    delete: operations["repos/disable-deployment-protection-rule"];
  };
  "/repos/{owner}/{repo}/events": {
    /**
     * List repository events
     * @description **Note**: This API is not built to serve real-time use cases. Depending on the time of day, event latency can be anywhere from 30s to 6h.
     */
    get: operations["activity/list-repo-events"];
  };
  "/repos/{owner}/{repo}/forks": {
    /** List forks */
    get: operations["repos/list-forks"];
    /**
     * Create a fork
     * @description Create a fork for the authenticated user.
     *
     * **Note**: Forking a Repository happens asynchronously. You may have to wait a short period of time before you can access the git objects. If this takes longer than 5 minutes, be sure to contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api).
     *
     * **Note**: Although this endpoint works with GitHub Apps, the GitHub App must be installed on the destination account with access to all repositories and on the source account with access to the source repository.
     */
    post: operations["repos/create-fork"];
  };
  "/repos/{owner}/{repo}/git/blobs": {
    /** Create a blob */
    post: operations["git/create-blob"];
  };
  "/repos/{owner}/{repo}/git/blobs/{file_sha}": {
    /**
     * Get a blob
     * @description The `content` in the response will always be Base64 encoded.
     *
     * _Note_: This API supports blobs up to 100 megabytes in size.
     */
    get: operations["git/get-blob"];
  };
  "/repos/{owner}/{repo}/git/commits": {
    /**
     * Create a commit
     * @description Creates a new Git [commit object](https://git-scm.com/slider/en/v1/Git-Internals-Git-Objects#Commit-Objects).
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in the table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    post: operations["git/create-commit"];
  };
  "/repos/{owner}/{repo}/git/commits/{commit_sha}": {
    /**
     * Get a commit
     * @description Gets a Git [commit object](https://git-scm.com/slider/en/v1/Git-Internals-Git-Objects#Commit-Objects).
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in the table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["git/get-commit"];
  };
  "/repos/{owner}/{repo}/git/matching-refs/{ref}": {
    /**
     * List matching references
     * @description Returns an array of references from your Git database that match the supplied name. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't exist in the repository, but existing refs start with `:ref`, they will be returned as an array.
     *
     * When you use this endpoint without providing a `:ref`, it will return an array of all the references from your Git database, including notes and stashes if they exist on the server. Anything in the namespace is returned, not just `heads` and `tags`.
     *
     * **Note:** You need to explicitly [request a pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     *
     * If you request matching references for a branch named `feature` but the branch `feature` doesn't exist, the response can still include other matching head refs that start with the word `feature`, such as `featureA` and `featureB`.
     */
    get: operations["git/list-matching-refs"];
  };
  "/repos/{owner}/{repo}/git/ref/{ref}": {
    /**
     * Get a reference
     * @description Returns a single reference from your Git database. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't match an existing ref, a `404` is returned.
     *
     * **Note:** You need to explicitly [request a pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     */
    get: operations["git/get-ref"];
  };
  "/repos/{owner}/{repo}/git/refs": {
    /**
     * Create a reference
     * @description Creates a reference for your repository. You are unable to create new references for empty repositories, even if the commit SHA-1 hash used exists. Empty repositories are repositories without branches.
     */
    post: operations["git/create-ref"];
  };
  "/repos/{owner}/{repo}/git/refs/{ref}": {
    /** Delete a reference */
    delete: operations["git/delete-ref"];
    /** Update a reference */
    patch: operations["git/update-ref"];
  };
  "/repos/{owner}/{repo}/git/tags": {
    /**
     * Create a tag object
     * @description Note that creating a tag object does not create the reference that makes a tag in Git. If you want to create an annotated tag in Git, you have to do this call to create the tag object, and then [create](https://docs.github.com/rest/reference/git#create-a-reference) the `refs/tags/[tag]` reference. If you want to create a lightweight tag, you only have to [create](https://docs.github.com/rest/reference/git#create-a-reference) the tag reference - this call would be unnecessary.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    post: operations["git/create-tag"];
  };
  "/repos/{owner}/{repo}/git/tags/{tag_sha}": {
    /**
     * Get a tag
     * @description **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["git/get-tag"];
  };
  "/repos/{owner}/{repo}/git/trees": {
    /**
     * Create a tree
     * @description The tree creation API accepts nested entries. If you specify both a tree and a nested path modifying that tree, this endpoint will overwrite the contents of the tree with the new path contents, and create a new tree structure.
     *
     * If you use this endpoint to add, delete, or modify the file contents in a tree, you will need to commit the tree and then update a branch to point to the commit. For more information see "[Create a commit](https://docs.github.com/rest/reference/git#create-a-commit)" and "[Update a reference](https://docs.github.com/rest/reference/git#update-a-reference)."
     *
     * Returns an error if you try to delete a file that does not exist.
     */
    post: operations["git/create-tree"];
  };
  "/repos/{owner}/{repo}/git/trees/{tree_sha}": {
    /**
     * Get a tree
     * @description Returns a single tree using the SHA1 value for that tree.
     *
     * If `truncated` is `true` in the response then the number of items in the `tree` array exceeded our maximum limit. If you need to fetch more items, use the non-recursive method of fetching trees, and fetch one sub-tree at a time.
     *
     *
     * **Note**: The limit for the `tree` array is 100,000 entries with a maximum size of 7 MB when using the `recursive` parameter.
     */
    get: operations["git/get-tree"];
  };
  "/repos/{owner}/{repo}/hooks": {
    /**
     * List repository webhooks
     * @description Lists webhooks for a repository. `last response` may return null if there have not been any deliveries within 30 days.
     */
    get: operations["repos/list-webhooks"];
    /**
     * Create a repository webhook
     * @description Repositories can have multiple webhooks installed. Each webhook should have a unique `config`. Multiple webhooks can
     * share the same `config` as long as those webhooks do not have any `events` that overlap.
     */
    post: operations["repos/create-webhook"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}": {
    /**
     * Get a repository webhook
     * @description Returns a webhook configured in a repository. To get only the webhook `config` properties, see "[Get a webhook configuration for a repository](/rest/reference/repos#get-a-webhook-configuration-for-a-repository)."
     */
    get: operations["repos/get-webhook"];
    /** Delete a repository webhook */
    delete: operations["repos/delete-webhook"];
    /**
     * Update a repository webhook
     * @description Updates a webhook configured in a repository. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for a repository](/rest/reference/repos#update-a-webhook-configuration-for-a-repository)."
     */
    patch: operations["repos/update-webhook"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/config": {
    /**
     * Get a webhook configuration for a repository
     * @description Returns the webhook configuration for a repository. To get more information about the webhook, including the `active` state and `events`, use "[Get a repository webhook](/rest/reference/orgs#get-a-repository-webhook)."
     *
     * Access tokens must have the `read:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:read` permission.
     */
    get: operations["repos/get-webhook-config-for-repo"];
    /**
     * Update a webhook configuration for a repository
     * @description Updates the webhook configuration for a repository. To update more information about the webhook, including the `active` state and `events`, use "[Update a repository webhook](/rest/reference/orgs#update-a-repository-webhook)."
     *
     * Access tokens must have the `write:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:write` permission.
     */
    patch: operations["repos/update-webhook-config-for-repo"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/deliveries": {
    /**
     * List deliveries for a repository webhook
     * @description Returns a list of webhook deliveries for a webhook configured in a repository.
     */
    get: operations["repos/list-webhook-deliveries"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}": {
    /**
     * Get a delivery for a repository webhook
     * @description Returns a delivery for a webhook configured in a repository.
     */
    get: operations["repos/get-webhook-delivery"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}/attempts": {
    /**
     * Redeliver a delivery for a repository webhook
     * @description Redeliver a webhook delivery for a webhook configured in a repository.
     */
    post: operations["repos/redeliver-webhook-delivery"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/pings": {
    /**
     * Ping a repository webhook
     * @description This will trigger a [ping event](https://docs.github.com/webhooks/#ping-event) to be sent to the hook.
     */
    post: operations["repos/ping-webhook"];
  };
  "/repos/{owner}/{repo}/hooks/{hook_id}/tests": {
    /**
     * Test the push repository webhook
     * @description This will trigger the hook with the latest push to the current repository if the hook is subscribed to `push` events. If the hook is not subscribed to `push` events, the server will respond with 204 but no test POST will be generated.
     *
     * **Note**: Previously `/repos/:owner/:repo/hooks/:hook_id/test`
     */
    post: operations["repos/test-push-webhook"];
  };
  "/repos/{owner}/{repo}/import": {
    /**
     * Get an import status
     * @description View the progress of an import.
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     *
     * **Import status**
     *
     * This section includes details about the possible values of the `status` field of the Import Progress response.
     *
     * An import that does not have errors will progress through these steps:
     *
     * *   `detecting` - the "detection" step of the import is in progress because the request did not include a `vcs` parameter. The import is identifying the type of source control present at the URL.
     * *   `importing` - the "raw" step of the import is in progress. This is where commit data is fetched from the original repository. The import progress response will include `commit_count` (the total number of raw commits that will be imported) and `percent` (0 - 100, the current progress through the import).
     * *   `mapping` - the "rewrite" step of the import is in progress. This is where SVN branches are converted to Git branches, and where author updates are applied. The import progress response does not include progress information.
     * *   `pushing` - the "push" step of the import is in progress. This is where the importer updates the repository on GitHub. The import progress response will include `push_percent`, which is the percent value reported by `git push` when it is "Writing objects".
     * *   `complete` - the import is complete, and the repository is ready on GitHub.
     *
     * If there are problems, you will see one of these in the `status` field:
     *
     * *   `auth_failed` - the import requires authentication in order to connect to the original repository. To update authentication for the import, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
     * *   `error` - the import encountered an error. The import progress response will include the `failed_step` and an error message. Contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api) for more information.
     * *   `detection_needs_auth` - the importer requires authentication for the originating repository to continue detection. To update authentication for the import, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
     * *   `detection_found_nothing` - the importer didn't recognize any source control at the URL. To resolve, [Cancel the import](https://docs.github.com/rest/migrations/source-imports#cancel-an-import) and [retry](https://docs.github.com/rest/migrations/source-imports#start-an-import) with the correct URL.
     * *   `detection_found_multiple` - the importer found several projects or repositories at the provided URL. When this is the case, the Import Progress response will also include a `project_choices` field with the possible project choices as values. To update project choice, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
     *
     * **The project_choices field**
     *
     * When multiple projects are found at the provided URL, the response hash will include a `project_choices` field, the value of which is an array of hashes each representing a project choice. The exact key/value pairs of the project hashes will differ depending on the version control type.
     *
     * **Git LFS related fields**
     *
     * This section includes details about Git LFS related fields that may be present in the Import Progress response.
     *
     * *   `use_lfs` - describes whether the import has been opted in or out of using Git LFS. The value can be `opt_in`, `opt_out`, or `undecided` if no action has been taken.
     * *   `has_large_files` - the boolean value describing whether files larger than 100MB were found during the `importing` step.
     * *   `large_files_size` - the total size in gigabytes of files larger than 100MB found in the originating repository.
     * *   `large_files_count` - the total number of files larger than 100MB found in the originating repository. To see a list of these files, make a "Get Large Files" request.
     */
    get: operations["migrations/get-import-status"];
    /**
     * Start an import
     * @description Start a source import to a GitHub repository using GitHub Importer. Importing into a GitHub repository with GitHub Actions enabled is not supported and will return a status `422 Unprocessable Entity` response.
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    put: operations["migrations/start-import"];
    /**
     * Cancel an import
     * @description Stop an import for a repository.
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    delete: operations["migrations/cancel-import"];
    /**
     * Update an import
     * @description An import can be updated with credentials or a project choice by passing in the appropriate parameters in this API
     * request. If no parameters are provided, the import will be restarted.
     *
     * Some servers (e.g. TFS servers) can have several projects at a single URL. In those cases the import progress will
     * have the status `detection_found_multiple` and the Import Progress response will include a `project_choices` array.
     * You can select the project to import by providing one of the objects in the `project_choices` array in the update request.
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    patch: operations["migrations/update-import"];
  };
  "/repos/{owner}/{repo}/import/authors": {
    /**
     * Get commit authors
     * @description Each type of source control system represents authors in a different way. For example, a Git commit author has a display name and an email address, but a Subversion commit author just has a username. The GitHub Importer will make the author information valid, but the author might not be correct. For example, it will change the bare Subversion username `hubot` into something like `hubot <hubot@12341234-abab-fefe-8787-fedcba987654>`.
     *
     * This endpoint and the [Map a commit author](https://docs.github.com/rest/migrations/source-imports#map-a-commit-author) endpoint allow you to provide correct Git author information.
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    get: operations["migrations/get-commit-authors"];
  };
  "/repos/{owner}/{repo}/import/authors/{author_id}": {
    /**
     * Map a commit author
     * @description Update an author's identity for the import. Your application can continue updating authors any time before you push
     * new commits to the repository.
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    patch: operations["migrations/map-commit-author"];
  };
  "/repos/{owner}/{repo}/import/large_files": {
    /**
     * Get large files
     * @description List files larger than 100MB found during the import
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    get: operations["migrations/get-large-files"];
  };
  "/repos/{owner}/{repo}/import/lfs": {
    /**
     * Update Git LFS preference
     * @description You can import repositories from Subversion, Mercurial, and TFS that include files larger than 100MB. This ability
     * is powered by [Git LFS](https://git-lfs.com).
     *
     * You can learn more about our LFS feature and working with large files [on our help
     * site](https://docs.github.com/repositories/working-with-files/managing-large-files).
     *
     * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
     * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
     * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
     */
    patch: operations["migrations/set-lfs-preference"];
  };
  "/repos/{owner}/{repo}/installation": {
    /**
     * Get a repository installation for the authenticated app
     * @description Enables an authenticated GitHub App to find the repository's installation information. The installation's account type will be either an organization or a user account, depending which account the repository belongs to.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-repo-installation"];
  };
  "/repos/{owner}/{repo}/interaction-limits": {
    /**
     * Get interaction restrictions for a repository
     * @description Shows which type of GitHub user can interact with this repository and when the restriction expires. If there are no restrictions, you will see an empty response.
     */
    get: operations["interactions/get-restrictions-for-repo"];
    /**
     * Set interaction restrictions for a repository
     * @description Temporarily restricts interactions to a certain type of GitHub user within the given repository. You must have owner or admin access to set these restrictions. If an interaction limit is set for the user or organization that owns this repository, you will receive a `409 Conflict` response and will not be able to use this endpoint to change the interaction limit for a single repository.
     */
    put: operations["interactions/set-restrictions-for-repo"];
    /**
     * Remove interaction restrictions for a repository
     * @description Removes all interaction restrictions from the given repository. You must have owner or admin access to remove restrictions. If the interaction limit is set for the user or organization that owns this repository, you will receive a `409 Conflict` response and will not be able to use this endpoint to change the interaction limit for a single repository.
     */
    delete: operations["interactions/remove-restrictions-for-repo"];
  };
  "/repos/{owner}/{repo}/invitations": {
    /**
     * List repository invitations
     * @description When authenticating as a user with admin rights to a repository, this endpoint will list all currently open repository invitations.
     */
    get: operations["repos/list-invitations"];
  };
  "/repos/{owner}/{repo}/invitations/{invitation_id}": {
    /** Delete a repository invitation */
    delete: operations["repos/delete-invitation"];
    /** Update a repository invitation */
    patch: operations["repos/update-invitation"];
  };
  "/repos/{owner}/{repo}/issues": {
    /**
     * List repository issues
     * @description List issues in a repository. Only open issues will be listed.
     *
     * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
     */
    get: operations["issues/list-for-repo"];
    /**
     * Create an issue
     * @description Any user with pull access to a repository can create an issue. If [issues are disabled in the repository](https://docs.github.com/articles/disabling-issues/), the API returns a `410 Gone` status.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["issues/create"];
  };
  "/repos/{owner}/{repo}/issues/comments": {
    /**
     * List issue comments for a repository
     * @description You can use the REST API to list comments on issues and pull requests for a repository. Every pull request is an issue, but not every issue is a pull request.
     *
     * By default, issue comments are ordered by ascending ID.
     */
    get: operations["issues/list-comments-for-repo"];
  };
  "/repos/{owner}/{repo}/issues/comments/{comment_id}": {
    /**
     * Get an issue comment
     * @description You can use the REST API to get comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
     */
    get: operations["issues/get-comment"];
    /**
     * Delete an issue comment
     * @description You can use the REST API to delete comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
     */
    delete: operations["issues/delete-comment"];
    /**
     * Update an issue comment
     * @description You can use the REST API to update comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
     */
    patch: operations["issues/update-comment"];
  };
  "/repos/{owner}/{repo}/issues/comments/{comment_id}/reactions": {
    /**
     * List reactions for an issue comment
     * @description List the reactions to an [issue comment](https://docs.github.com/rest/reference/issues#comments).
     */
    get: operations["reactions/list-for-issue-comment"];
    /**
     * Create reaction for an issue comment
     * @description Create a reaction to an [issue comment](https://docs.github.com/rest/reference/issues#comments). A response with an HTTP `200` status means that you already added the reaction type to this issue comment.
     */
    post: operations["reactions/create-for-issue-comment"];
  };
  "/repos/{owner}/{repo}/issues/comments/{comment_id}/reactions/{reaction_id}": {
    /**
     * Delete an issue comment reaction
     * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE delete /repositories/:repository_id/issues/comments/:comment_id/reactions/:reaction_id`.
     *
     * Delete a reaction to an [issue comment](https://docs.github.com/rest/reference/issues#comments).
     */
    delete: operations["reactions/delete-for-issue-comment"];
  };
  "/repos/{owner}/{repo}/issues/events": {
    /** List issue events for a repository */
    get: operations["issues/list-events-for-repo"];
  };
  "/repos/{owner}/{repo}/issues/events/{event_id}": {
    /** Get an issue event */
    get: operations["issues/get-event"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}": {
    /**
     * Get an issue
     * @description The API returns a [`301 Moved Permanently` status](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-redirects-redirects) if the issue was
     * [transferred](https://docs.github.com/articles/transferring-an-issue-to-another-repository/) to another repository. If
     * the issue was transferred to or deleted from a repository where the authenticated user lacks read access, the API
     * returns a `404 Not Found` status. If the issue was deleted from a repository where the authenticated user has read
     * access, the API returns a `410 Gone` status. To receive webhook events for transferred and deleted issues, subscribe
     * to the [`issues`](https://docs.github.com/webhooks/event-payloads/#issues) webhook.
     *
     * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
     */
    get: operations["issues/get"];
    /**
     * Update an issue
     * @description Issue owners and users with push access can edit an issue.
     */
    patch: operations["issues/update"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/assignees": {
    /**
     * Add assignees to an issue
     * @description Adds up to 10 assignees to an issue. Users already assigned to an issue are not replaced.
     */
    post: operations["issues/add-assignees"];
    /**
     * Remove assignees from an issue
     * @description Removes one or more assignees from an issue.
     */
    delete: operations["issues/remove-assignees"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/assignees/{assignee}": {
    /**
     * Check if a user can be assigned to a issue
     * @description Checks if a user has permission to be assigned to a specific issue.
     *
     * If the `assignee` can be assigned to this issue, a `204` status code with no content is returned.
     *
     * Otherwise a `404` status code is returned.
     */
    get: operations["issues/check-user-can-be-assigned-to-issue"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/comments": {
    /**
     * List issue comments
     * @description You can use the REST API to list comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
     *
     * Issue comments are ordered by ascending ID.
     */
    get: operations["issues/list-comments"];
    /**
     * Create an issue comment
     * @description
     * You can use the REST API to create comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications).
     * Creating content too quickly using this endpoint may result in secondary rate limiting.
     * See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)"
     * and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)"
     * for details.
     */
    post: operations["issues/create-comment"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/events": {
    /** List issue events */
    get: operations["issues/list-events"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/labels": {
    /** List labels for an issue */
    get: operations["issues/list-labels-on-issue"];
    /**
     * Set labels for an issue
     * @description Removes any previous labels and sets the new labels for an issue.
     */
    put: operations["issues/set-labels"];
    /** Add labels to an issue */
    post: operations["issues/add-labels"];
    /** Remove all labels from an issue */
    delete: operations["issues/remove-all-labels"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/labels/{name}": {
    /**
     * Remove a label from an issue
     * @description Removes the specified label from the issue, and returns the remaining labels on the issue. This endpoint returns a `404 Not Found` status if the label does not exist.
     */
    delete: operations["issues/remove-label"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/lock": {
    /**
     * Lock an issue
     * @description Users with push access can lock an issue or pull request's conversation.
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["issues/lock"];
    /**
     * Unlock an issue
     * @description Users with push access can unlock an issue's conversation.
     */
    delete: operations["issues/unlock"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/reactions": {
    /**
     * List reactions for an issue
     * @description List the reactions to an [issue](https://docs.github.com/rest/reference/issues).
     */
    get: operations["reactions/list-for-issue"];
    /**
     * Create reaction for an issue
     * @description Create a reaction to an [issue](https://docs.github.com/rest/reference/issues/). A response with an HTTP `200` status means that you already added the reaction type to this issue.
     */
    post: operations["reactions/create-for-issue"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/reactions/{reaction_id}": {
    /**
     * Delete an issue reaction
     * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/issues/:issue_number/reactions/:reaction_id`.
     *
     * Delete a reaction to an [issue](https://docs.github.com/rest/reference/issues/).
     */
    delete: operations["reactions/delete-for-issue"];
  };
  "/repos/{owner}/{repo}/issues/{issue_number}/timeline": {
    /** List timeline events for an issue */
    get: operations["issues/list-events-for-timeline"];
  };
  "/repos/{owner}/{repo}/keys": {
    /** List deploy keys */
    get: operations["repos/list-deploy-keys"];
    /**
     * Create a deploy key
     * @description You can create a read-only deploy key.
     */
    post: operations["repos/create-deploy-key"];
  };
  "/repos/{owner}/{repo}/keys/{key_id}": {
    /** Get a deploy key */
    get: operations["repos/get-deploy-key"];
    /**
     * Delete a deploy key
     * @description Deploy keys are immutable. If you need to update a key, remove the key and create a new one instead.
     */
    delete: operations["repos/delete-deploy-key"];
  };
  "/repos/{owner}/{repo}/labels": {
    /** List labels for a repository */
    get: operations["issues/list-labels-for-repo"];
    /** Create a label */
    post: operations["issues/create-label"];
  };
  "/repos/{owner}/{repo}/labels/{name}": {
    /** Get a label */
    get: operations["issues/get-label"];
    /** Delete a label */
    delete: operations["issues/delete-label"];
    /** Update a label */
    patch: operations["issues/update-label"];
  };
  "/repos/{owner}/{repo}/languages": {
    /**
     * List repository languages
     * @description Lists languages for the specified repository. The value shown for each language is the number of bytes of code written in that language.
     */
    get: operations["repos/list-languages"];
  };
  "/repos/{owner}/{repo}/lfs": {
    /**
     * Enable Git LFS for a repository
     * @description Enables Git LFS for a repository. Access tokens must have the `admin:enterprise` scope.
     */
    put: operations["repos/enable-lfs-for-repo"];
    /**
     * Disable Git LFS for a repository
     * @description Disables Git LFS for a repository. Access tokens must have the `admin:enterprise` scope.
     */
    delete: operations["repos/disable-lfs-for-repo"];
  };
  "/repos/{owner}/{repo}/license": {
    /**
     * Get the license for a repository
     * @description This method returns the contents of the repository's license file, if one is detected.
     *
     * Similar to [Get repository content](https://docs.github.com/rest/reference/repos#get-repository-content), this method also supports [custom media types](https://docs.github.com/rest/overview/media-types) for retrieving the raw license content or rendered license HTML.
     */
    get: operations["licenses/get-for-repo"];
  };
  "/repos/{owner}/{repo}/merge-upstream": {
    /**
     * Sync a fork branch with the upstream repository
     * @description Sync a branch of a forked repository to keep it up-to-date with the upstream repository.
     */
    post: operations["repos/merge-upstream"];
  };
  "/repos/{owner}/{repo}/merges": {
    /** Merge a branch */
    post: operations["repos/merge"];
  };
  "/repos/{owner}/{repo}/milestones": {
    /** List milestones */
    get: operations["issues/list-milestones"];
    /** Create a milestone */
    post: operations["issues/create-milestone"];
  };
  "/repos/{owner}/{repo}/milestones/{milestone_number}": {
    /** Get a milestone */
    get: operations["issues/get-milestone"];
    /** Delete a milestone */
    delete: operations["issues/delete-milestone"];
    /** Update a milestone */
    patch: operations["issues/update-milestone"];
  };
  "/repos/{owner}/{repo}/milestones/{milestone_number}/labels": {
    /** List labels for issues in a milestone */
    get: operations["issues/list-labels-for-milestone"];
  };
  "/repos/{owner}/{repo}/notifications": {
    /**
     * List repository notifications for the authenticated user
     * @description Lists all notifications for the current user in the specified repository.
     */
    get: operations["activity/list-repo-notifications-for-authenticated-user"];
    /**
     * Mark repository notifications as read
     * @description Marks all notifications in a repository as "read" for the current user. If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List repository notifications for the authenticated user](https://docs.github.com/rest/reference/activity#list-repository-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
     */
    put: operations["activity/mark-repo-notifications-as-read"];
  };
  "/repos/{owner}/{repo}/pages": {
    /** Get a GitHub Pages site */
    get: operations["repos/get-pages"];
    /**
     * Update information about a GitHub Pages site
     * @description Updates information for a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages).
     *
     * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
     */
    put: operations["repos/update-information-about-pages-site"];
    /**
     * Create a GitHub Pages site
     * @description Configures a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages)."
     *
     * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
     */
    post: operations["repos/create-pages-site"];
    /**
     * Delete a GitHub Pages site
     * @description Deletes a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages).
     *
     * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
     */
    delete: operations["repos/delete-pages-site"];
  };
  "/repos/{owner}/{repo}/pages/builds": {
    /** List GitHub Pages builds */
    get: operations["repos/list-pages-builds"];
    /**
     * Request a GitHub Pages build
     * @description You can request that your site be built from the latest revision on the default branch. This has the same effect as pushing a commit to your default branch, but does not require an additional commit. Manually triggering page builds can be helpful when diagnosing build warnings and failures.
     *
     * Build requests are limited to one concurrent build per repository and one concurrent build per requester. If you request a build while another is still in progress, the second request will be queued until the first completes.
     */
    post: operations["repos/request-pages-build"];
  };
  "/repos/{owner}/{repo}/pages/builds/latest": {
    /** Get latest Pages build */
    get: operations["repos/get-latest-pages-build"];
  };
  "/repos/{owner}/{repo}/pages/builds/{build_id}": {
    /** Get GitHub Pages build */
    get: operations["repos/get-pages-build"];
  };
  "/repos/{owner}/{repo}/pages/deployment": {
    /**
     * Create a GitHub Pages deployment
     * @description Create a GitHub Pages deployment for a repository.
     *
     * Users must have write permissions. GitHub Apps must have the `pages:write` permission to use this endpoint.
     */
    post: operations["repos/create-pages-deployment"];
  };
  "/repos/{owner}/{repo}/pages/health": {
    /**
     * Get a DNS health check for GitHub Pages
     * @description Gets a health check of the DNS settings for the `CNAME` record configured for a repository's GitHub Pages.
     *
     * The first request to this endpoint returns a `202 Accepted` status and starts an asynchronous background task to get the results for the domain. After the background task completes, subsequent requests to this endpoint return a `200 OK` status with the health check results in the response.
     *
     * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administrative:write` and `pages:write` permissions.
     */
    get: operations["repos/get-pages-health-check"];
  };
  "/repos/{owner}/{repo}/projects": {
    /**
     * List repository projects
     * @description Lists the projects in a repository. Returns a `404 Not Found` status if projects are disabled in the repository. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    get: operations["projects/list-for-repo"];
    /**
     * Create a repository project
     * @description Creates a repository project board. Returns a `410 Gone` status if projects are disabled in the repository or if the repository does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    post: operations["projects/create-for-repo"];
  };
  "/repos/{owner}/{repo}/pulls": {
    /**
     * List pull requests
     * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     */
    get: operations["pulls/list"];
    /**
     * Create a pull request
     * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-rate-limits)" for details.
     */
    post: operations["pulls/create"];
  };
  "/repos/{owner}/{repo}/pulls/comments": {
    /**
     * List review comments in a repository
     * @description Lists review comments for all pull requests in a repository. By default, review comments are in ascending order by ID.
     */
    get: operations["pulls/list-review-comments-for-repo"];
  };
  "/repos/{owner}/{repo}/pulls/comments/{comment_id}": {
    /**
     * Get a review comment for a pull request
     * @description Provides details for a review comment.
     */
    get: operations["pulls/get-review-comment"];
    /**
     * Delete a review comment for a pull request
     * @description Deletes a review comment.
     */
    delete: operations["pulls/delete-review-comment"];
    /**
     * Update a review comment for a pull request
     * @description Enables you to edit a review comment.
     */
    patch: operations["pulls/update-review-comment"];
  };
  "/repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions": {
    /**
     * List reactions for a pull request review comment
     * @description List the reactions to a [pull request review comment](https://docs.github.com/rest/reference/pulls#review-comments).
     */
    get: operations["reactions/list-for-pull-request-review-comment"];
    /**
     * Create reaction for a pull request review comment
     * @description Create a reaction to a [pull request review comment](https://docs.github.com/rest/reference/pulls#comments). A response with an HTTP `200` status means that you already added the reaction type to this pull request review comment.
     */
    post: operations["reactions/create-for-pull-request-review-comment"];
  };
  "/repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions/{reaction_id}": {
    /**
     * Delete a pull request comment reaction
     * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/pulls/comments/:comment_id/reactions/:reaction_id.`
     *
     * Delete a reaction to a [pull request review comment](https://docs.github.com/rest/reference/pulls#review-comments).
     */
    delete: operations["reactions/delete-for-pull-request-comment"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}": {
    /**
     * Get a pull request
     * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * Lists details of a pull request by providing its number.
     *
     * When you get, [create](https://docs.github.com/rest/reference/pulls/#create-a-pull-request), or [edit](https://docs.github.com/rest/reference/pulls#update-a-pull-request) a pull request, GitHub creates a merge commit to test whether the pull request can be automatically merged into the base branch. This test commit is not added to the base branch or the head branch. You can review the status of the test commit using the `mergeable` key. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
     *
     * The value of the `mergeable` attribute can be `true`, `false`, or `null`. If the value is `null`, then GitHub has started a background job to compute the mergeability. After giving the job time to complete, resubmit the request. When the job finishes, you will see a non-`null` value for the `mergeable` attribute in the response. If `mergeable` is `true`, then `merge_commit_sha` will be the SHA of the _test_ merge commit.
     *
     * The value of the `merge_commit_sha` attribute changes depending on the state of the pull request. Before merging a pull request, the `merge_commit_sha` attribute holds the SHA of the _test_ merge commit. After merging a pull request, the `merge_commit_sha` attribute changes depending on how you merged the pull request:
     *
     * *   If merged as a [merge commit](https://docs.github.com/articles/about-merge-methods-on-github/), `merge_commit_sha` represents the SHA of the merge commit.
     * *   If merged via a [squash](https://docs.github.com/articles/about-merge-methods-on-github/#squashing-your-merge-commits), `merge_commit_sha` represents the SHA of the squashed commit on the base branch.
     * *   If [rebased](https://docs.github.com/articles/about-merge-methods-on-github/#rebasing-and-merging-your-commits), `merge_commit_sha` represents the commit that the base branch was updated to.
     *
     * Pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
     */
    get: operations["pulls/get"];
    /**
     * Update a pull request
     * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
     */
    patch: operations["pulls/update"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/codespaces": {
    /**
     * Create a codespace from a pull request
     * @description Creates a codespace owned by the authenticated user for the specified pull request.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    post: operations["codespaces/create-with-pr-for-authenticated-user"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/comments": {
    /**
     * List review comments on a pull request
     * @description Lists all review comments for a pull request. By default, review comments are in ascending order by ID.
     */
    get: operations["pulls/list-review-comments"];
    /**
     * Create a review comment for a pull request
     * @description
     * Creates a review comment in the pull request diff. To add a regular comment to a pull request timeline, see "[Create an issue comment](https://docs.github.com/rest/reference/issues#create-an-issue-comment)." We recommend creating a review comment using `line`, `side`, and optionally `start_line` and `start_side` if your comment applies to more than one line in the pull request diff.
     *
     * The `position` parameter is deprecated. If you use `position`, the `line`, `side`, `start_line`, and `start_side` parameters are not required.
     *
     * **Note:** The position value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["pulls/create-review-comment"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/comments/{comment_id}/replies": {
    /**
     * Create a reply for a review comment
     * @description Creates a reply to a review comment for a pull request. For the `comment_id`, provide the ID of the review comment you are replying to. This must be the ID of a _top-level review comment_, not a reply to that comment. Replies to replies are not supported.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["pulls/create-reply-for-review-comment"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/commits": {
    /**
     * List commits on a pull request
     * @description Lists a maximum of 250 commits for a pull request. To receive a complete commit list for pull requests with more than 250 commits, use the [List commits](https://docs.github.com/rest/reference/repos#list-commits) endpoint.
     */
    get: operations["pulls/list-commits"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/files": {
    /**
     * List pull requests files
     * @description **Note:** Responses include a maximum of 3000 files. The paginated response returns 30 files per page by default.
     */
    get: operations["pulls/list-files"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/merge": {
    /** Check if a pull request has been merged */
    get: operations["pulls/check-if-merged"];
    /**
     * Merge a pull request
     * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    put: operations["pulls/merge"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers": {
    /**
     * Get all requested reviewers for a pull request
     * @description Gets the users or teams whose review is requested for a pull request. Once a requested reviewer submits a review, they are no longer considered a requested reviewer. Their review will instead be returned by the [List reviews for a pull request](https://docs.github.com/rest/pulls/reviews#list-reviews-for-a-pull-request) operation.
     */
    get: operations["pulls/list-requested-reviewers"];
    /**
     * Request reviewers for a pull request
     * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["pulls/request-reviewers"];
    /** Remove requested reviewers from a pull request */
    delete: operations["pulls/remove-requested-reviewers"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/reviews": {
    /**
     * List reviews for a pull request
     * @description The list of reviews returns in chronological order.
     */
    get: operations["pulls/list-reviews"];
    /**
     * Create a review for a pull request
     * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     *
     * Pull request reviews created in the `PENDING` state are not submitted and therefore do not include the `submitted_at` property in the response. To create a pending review for a pull request, leave the `event` parameter blank. For more information about submitting a `PENDING` review, see "[Submit a review for a pull request](https://docs.github.com/rest/pulls#submit-a-review-for-a-pull-request)."
     *
     * **Note:** To comment on a specific line in a file, you need to first determine the _position_ of that line in the diff. The GitHub REST API offers the `application/vnd.github.v3.diff` [media type](https://docs.github.com/rest/overview/media-types#commits-commit-comparison-and-pull-requests). To see a pull request diff, add this media type to the `Accept` header of a call to the [single pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) endpoint.
     *
     * The `position` value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
     */
    post: operations["pulls/create-review"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}": {
    /** Get a review for a pull request */
    get: operations["pulls/get-review"];
    /**
     * Update a review for a pull request
     * @description Update the review summary comment with new text.
     */
    put: operations["pulls/update-review"];
    /** Delete a pending review for a pull request */
    delete: operations["pulls/delete-pending-review"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/comments": {
    /**
     * List comments for a pull request review
     * @description List comments for a specific pull request review.
     */
    get: operations["pulls/list-comments-for-review"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/dismissals": {
    /**
     * Dismiss a review for a pull request
     * @description **Note:** To dismiss a pull request review on a [protected branch](https://docs.github.com/rest/reference/repos#branches), you must be a repository administrator or be included in the list of people or teams who can dismiss pull request reviews.
     */
    put: operations["pulls/dismiss-review"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/events": {
    /**
     * Submit a review for a pull request
     * @description Submits a pending review for a pull request. For more information about creating a pending review for a pull request, see "[Create a review for a pull request](https://docs.github.com/rest/pulls#create-a-review-for-a-pull-request)."
     */
    post: operations["pulls/submit-review"];
  };
  "/repos/{owner}/{repo}/pulls/{pull_number}/update-branch": {
    /**
     * Update a pull request branch
     * @description Updates the pull request branch with the latest upstream changes by merging HEAD from the base branch into the pull request branch.
     */
    put: operations["pulls/update-branch"];
  };
  "/repos/{owner}/{repo}/readme": {
    /**
     * Get a repository README
     * @description Gets the preferred README for a repository.
     *
     * READMEs support [custom media types](https://docs.github.com/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
     */
    get: operations["repos/get-readme"];
  };
  "/repos/{owner}/{repo}/readme/{dir}": {
    /**
     * Get a repository README for a directory
     * @description Gets the README from a repository directory.
     *
     * READMEs support [custom media types](https://docs.github.com/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
     */
    get: operations["repos/get-readme-in-directory"];
  };
  "/repos/{owner}/{repo}/releases": {
    /**
     * List releases
     * @description This returns a list of releases, which does not include regular Git tags that have not been associated with a release. To get a list of Git tags, use the [Repository Tags API](https://docs.github.com/rest/reference/repos#list-repository-tags).
     *
     * Information about published releases are available to everyone. Only users with push access will receive listings for draft releases.
     */
    get: operations["repos/list-releases"];
    /**
     * Create a release
     * @description Users with push access to the repository can create a release.
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["repos/create-release"];
  };
  "/repos/{owner}/{repo}/releases/assets/{asset_id}": {
    /**
     * Get a release asset
     * @description To download the asset's binary content, set the `Accept` header of the request to [`application/octet-stream`](https://docs.github.com/rest/overview/media-types). The API will either redirect the client to the location, or stream it directly if possible. API clients should handle both a `200` or `302` response.
     */
    get: operations["repos/get-release-asset"];
    /** Delete a release asset */
    delete: operations["repos/delete-release-asset"];
    /**
     * Update a release asset
     * @description Users with push access to the repository can edit a release asset.
     */
    patch: operations["repos/update-release-asset"];
  };
  "/repos/{owner}/{repo}/releases/generate-notes": {
    /**
     * Generate release notes content for a release
     * @description Generate a name and body describing a [release](https://docs.github.com/rest/reference/repos#releases). The body content will be markdown formatted and contain information like the changes since last release and users who contributed. The generated release notes are not saved anywhere. They are intended to be generated and used when creating a new release.
     */
    post: operations["repos/generate-release-notes"];
  };
  "/repos/{owner}/{repo}/releases/latest": {
    /**
     * Get the latest release
     * @description View the latest published full release for the repository.
     *
     * The latest release is the most recent non-prerelease, non-draft release, sorted by the `created_at` attribute. The `created_at` attribute is the date of the commit used for the release, and not the date when the release was drafted or published.
     */
    get: operations["repos/get-latest-release"];
  };
  "/repos/{owner}/{repo}/releases/tags/{tag}": {
    /**
     * Get a release by tag name
     * @description Get a published release with the specified tag.
     */
    get: operations["repos/get-release-by-tag"];
  };
  "/repos/{owner}/{repo}/releases/{release_id}": {
    /**
     * Get a release
     * @description **Note:** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a [hypermedia resource](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia).
     */
    get: operations["repos/get-release"];
    /**
     * Delete a release
     * @description Users with push access to the repository can delete a release.
     */
    delete: operations["repos/delete-release"];
    /**
     * Update a release
     * @description Users with push access to the repository can edit a release.
     */
    patch: operations["repos/update-release"];
  };
  "/repos/{owner}/{repo}/releases/{release_id}/assets": {
    /** List release assets */
    get: operations["repos/list-release-assets"];
    /**
     * Upload a release asset
     * @description This endpoint makes use of [a Hypermedia relation](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia) to determine which URL to access. The endpoint you call to upload release assets is specific to your release. Use the `upload_url` returned in
     * the response of the [Create a release endpoint](https://docs.github.com/rest/releases/releases#create-a-release) to upload a release asset.
     *
     * You need to use an HTTP client which supports [SNI](http://en.wikipedia.org/wiki/Server_Name_Indication) to make calls to this endpoint.
     *
     * Most libraries will set the required `Content-Length` header automatically. Use the required `Content-Type` header to provide the media type of the asset. For a list of media types, see [Media Types](https://www.iana.org/assignments/media-types/media-types.xhtml). For example:
     *
     * `application/zip`
     *
     * GitHub expects the asset data in its raw binary form, rather than JSON. You will send the raw binary content of the asset as the request body. Everything else about the endpoint is the same as the rest of the API. For example,
     * you'll still need to pass your authentication to be able to upload an asset.
     *
     * When an upstream failure occurs, you will receive a `502 Bad Gateway` status. This may leave an empty asset with a state of `starter`. It can be safely deleted.
     *
     * **Notes:**
     * *   GitHub renames asset filenames that have special characters, non-alphanumeric characters, and leading or trailing periods. The "[List assets for a release](https://docs.github.com/rest/reference/repos#list-assets-for-a-release)"
     * endpoint lists the renamed filenames. For more information and help, contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api).
     * *   To find the `release_id` query the [`GET /repos/{owner}/{repo}/releases/latest` endpoint](https://docs.github.com/rest/releases/releases#get-the-latest-release).
     * *   If you upload an asset with the same filename as another uploaded asset, you'll receive an error and must delete the old file before you can re-upload the new asset.
     */
    post: operations["repos/upload-release-asset"];
  };
  "/repos/{owner}/{repo}/releases/{release_id}/reactions": {
    /**
     * List reactions for a release
     * @description List the reactions to a [release](https://docs.github.com/rest/reference/repos#releases).
     */
    get: operations["reactions/list-for-release"];
    /**
     * Create reaction for a release
     * @description Create a reaction to a [release](https://docs.github.com/rest/reference/repos#releases). A response with a `Status: 200 OK` means that you already added the reaction type to this release.
     */
    post: operations["reactions/create-for-release"];
  };
  "/repos/{owner}/{repo}/releases/{release_id}/reactions/{reaction_id}": {
    /**
     * Delete a release reaction
     * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE delete /repositories/:repository_id/releases/:release_id/reactions/:reaction_id`.
     *
     * Delete a reaction to a [release](https://docs.github.com/rest/reference/repos#releases).
     */
    delete: operations["reactions/delete-for-release"];
  };
  "/repos/{owner}/{repo}/rules/branches/{branch}": {
    /**
     * Get rules for a branch
     * @description Returns all rules that apply to the specified branch.
     */
    get: operations["repos/get-branch-rules"];
  };
  "/repos/{owner}/{repo}/rulesets": {
    /**
     * Get all repository rulesets
     * @description Get all the rulesets for a repository.
     */
    get: operations["repos/get-repo-rulesets"];
    /**
     * Create a repository ruleset
     * @description Create a ruleset for a repository.
     */
    post: operations["repos/create-repo-ruleset"];
  };
  "/repos/{owner}/{repo}/rulesets/{ruleset_id}": {
    /**
     * Get a repository ruleset
     * @description Get a ruleset for a repository.
     */
    get: operations["repos/get-repo-ruleset"];
    /**
     * Update a repository ruleset
     * @description Update a ruleset for a repository.
     */
    put: operations["repos/update-repo-ruleset"];
    /**
     * Delete a repository ruleset
     * @description Delete a ruleset for a repository.
     */
    delete: operations["repos/delete-repo-ruleset"];
  };
  "/repos/{owner}/{repo}/secret-scanning/alerts": {
    /**
     * List secret scanning alerts for a repository
     * @description Lists secret scanning alerts for an eligible repository, from newest to oldest.
     * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     */
    get: operations["secret-scanning/list-alerts-for-repo"];
  };
  "/repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}": {
    /**
     * Get a secret scanning alert
     * @description Gets a single secret scanning alert detected in an eligible repository.
     * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     */
    get: operations["secret-scanning/get-alert"];
    /**
     * Update a secret scanning alert
     * @description Updates the status of a secret scanning alert in an eligible repository.
     * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` write permission to use this endpoint.
     */
    patch: operations["secret-scanning/update-alert"];
  };
  "/repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}/locations": {
    /**
     * List locations for a secret scanning alert
     * @description Lists all locations for a given secret scanning alert for an eligible repository.
     * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
     * For public repositories, you may instead use the `public_repo` scope.
     *
     * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
     */
    get: operations["secret-scanning/list-locations-for-alert"];
  };
  "/repos/{owner}/{repo}/security-advisories": {
    /**
     * List repository security advisories
     * @description Lists security advisories in a repository.
     * You must authenticate using an access token with the `repo` scope or `repository_advisories:read` permission
     * in order to get published security advisories in a private repository, or any unpublished security advisories that you have access to.
     *
     * You can access unpublished security advisories from a repository if you are a security manager or administrator of that repository, or if you are a collaborator on any security advisory.
     */
    get: operations["security-advisories/list-repository-advisories"];
    /**
     * Create a repository security advisory
     * @description Creates a new repository security advisory.
     * You must authenticate using an access token with the `repo` scope or `repository_advisories:write` permission to use this endpoint.
     *
     * In order to create a draft repository security advisory, you must be a security manager or administrator of that repository.
     */
    post: operations["security-advisories/create-repository-advisory"];
  };
  "/repos/{owner}/{repo}/security-advisories/reports": {
    /**
     * Privately report a security vulnerability
     * @description Report a security vulnerability to the maintainers of the repository.
     * See "[Privately reporting a security vulnerability](https://docs.github.com/code-security/security-advisories/guidance-on-reporting-and-writing/privately-reporting-a-security-vulnerability)" for more information about private vulnerability reporting.
     */
    post: operations["security-advisories/create-private-vulnerability-report"];
  };
  "/repos/{owner}/{repo}/security-advisories/{ghsa_id}": {
    /**
     * Get a repository security advisory
     * @description Get a repository security advisory using its GitHub Security Advisory (GHSA) identifier.
     * You can access any published security advisory on a public repository.
     * You must authenticate using an access token with the `repo` scope or `repository_advisories:read` permission
     * in order to get a published security advisory in a private repository, or any unpublished security advisory that you have access to.
     *
     * You can access an unpublished security advisory from a repository if you are a security manager or administrator of that repository, or if you are a
     * collaborator on the security advisory.
     */
    get: operations["security-advisories/get-repository-advisory"];
    /**
     * Update a repository security advisory
     * @description Update a repository security advisory using its GitHub Security Advisory (GHSA) identifier.
     * You must authenticate using an access token with the `repo` scope or `repository_advisories:write` permission to use this endpoint.
     *
     * In order to update any security advisory, you must be a security manager or administrator of that repository,
     * or a collaborator on the repository security advisory.
     */
    patch: operations["security-advisories/update-repository-advisory"];
  };
  "/repos/{owner}/{repo}/stargazers": {
    /**
     * List stargazers
     * @description Lists the people that have starred the repository.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
     */
    get: operations["activity/list-stargazers-for-repo"];
  };
  "/repos/{owner}/{repo}/stats/code_frequency": {
    /**
     * Get the weekly commit activity
     * @description Returns a weekly aggregate of the number of additions and deletions pushed to a repository.
     */
    get: operations["repos/get-code-frequency-stats"];
  };
  "/repos/{owner}/{repo}/stats/commit_activity": {
    /**
     * Get the last year of commit activity
     * @description Returns the last year of commit activity grouped by week. The `days` array is a group of commits per day, starting on `Sunday`.
     */
    get: operations["repos/get-commit-activity-stats"];
  };
  "/repos/{owner}/{repo}/stats/contributors": {
    /**
     * Get all contributor commit activity
     * @description
     * Returns the `total` number of commits authored by the contributor. In addition, the response includes a Weekly Hash (`weeks` array) with the following information:
     *
     * *   `w` - Start of the week, given as a [Unix timestamp](http://en.wikipedia.org/wiki/Unix_time).
     * *   `a` - Number of additions
     * *   `d` - Number of deletions
     * *   `c` - Number of commits
     */
    get: operations["repos/get-contributors-stats"];
  };
  "/repos/{owner}/{repo}/stats/participation": {
    /**
     * Get the weekly commit count
     * @description Returns the total commit counts for the `owner` and total commit counts in `all`. `all` is everyone combined, including the `owner` in the last 52 weeks. If you'd like to get the commit counts for non-owners, you can subtract `owner` from `all`.
     *
     * The array order is oldest week (index 0) to most recent week.
     */
    get: operations["repos/get-participation-stats"];
  };
  "/repos/{owner}/{repo}/stats/punch_card": {
    /**
     * Get the hourly commit count for each day
     * @description Each array contains the day number, hour number, and number of commits:
     *
     * *   `0-6`: Sunday - Saturday
     * *   `0-23`: Hour of day
     * *   Number of commits
     *
     * For example, `[2, 14, 25]` indicates that there were 25 total commits, during the 2:00pm hour on Tuesdays. All times are based on the time zone of individual commits.
     */
    get: operations["repos/get-punch-card-stats"];
  };
  "/repos/{owner}/{repo}/statuses/{sha}": {
    /**
     * Create a commit status
     * @description Users with push access in a repository can create commit statuses for a given SHA.
     *
     * Note: there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
     */
    post: operations["repos/create-commit-status"];
  };
  "/repos/{owner}/{repo}/subscribers": {
    /**
     * List watchers
     * @description Lists the people watching the specified repository.
     */
    get: operations["activity/list-watchers-for-repo"];
  };
  "/repos/{owner}/{repo}/subscription": {
    /** Get a repository subscription */
    get: operations["activity/get-repo-subscription"];
    /**
     * Set a repository subscription
     * @description If you would like to watch a repository, set `subscribed` to `true`. If you would like to ignore notifications made within a repository, set `ignored` to `true`. If you would like to stop watching a repository, [delete the repository's subscription](https://docs.github.com/rest/reference/activity#delete-a-repository-subscription) completely.
     */
    put: operations["activity/set-repo-subscription"];
    /**
     * Delete a repository subscription
     * @description This endpoint should only be used to stop watching a repository. To control whether or not you wish to receive notifications from a repository, [set the repository's subscription manually](https://docs.github.com/rest/reference/activity#set-a-repository-subscription).
     */
    delete: operations["activity/delete-repo-subscription"];
  };
  "/repos/{owner}/{repo}/tags": {
    /** List repository tags */
    get: operations["repos/list-tags"];
  };
  "/repos/{owner}/{repo}/tags/protection": {
    /**
     * List tag protection states for a repository
     * @description This returns the tag protection states of a repository.
     *
     * This information is only available to repository administrators.
     */
    get: operations["repos/list-tag-protection"];
    /**
     * Create a tag protection state for a repository
     * @description This creates a tag protection state for a repository.
     * This endpoint is only available to repository administrators.
     */
    post: operations["repos/create-tag-protection"];
  };
  "/repos/{owner}/{repo}/tags/protection/{tag_protection_id}": {
    /**
     * Delete a tag protection state for a repository
     * @description This deletes a tag protection state for a repository.
     * This endpoint is only available to repository administrators.
     */
    delete: operations["repos/delete-tag-protection"];
  };
  "/repos/{owner}/{repo}/tarball/{ref}": {
    /**
     * Download a repository archive (tar)
     * @description Gets a redirect URL to download a tar archive for a repository. If you omit `:ref`, the repository’s default branch (usually
     * `main`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
     * the `Location` header to make a second `GET` request.
     * **Note**: For private repositories, these links are temporary and expire after five minutes.
     */
    get: operations["repos/download-tarball-archive"];
  };
  "/repos/{owner}/{repo}/teams": {
    /** List repository teams */
    get: operations["repos/list-teams"];
  };
  "/repos/{owner}/{repo}/topics": {
    /** Get all repository topics */
    get: operations["repos/get-all-topics"];
    /** Replace all repository topics */
    put: operations["repos/replace-all-topics"];
  };
  "/repos/{owner}/{repo}/traffic/clones": {
    /**
     * Get repository clones
     * @description Get the total number of clones and breakdown per day or week for the last 14 days. Timestamps are aligned to UTC midnight of the beginning of the day or week. Week begins on Monday.
     */
    get: operations["repos/get-clones"];
  };
  "/repos/{owner}/{repo}/traffic/popular/paths": {
    /**
     * Get top referral paths
     * @description Get the top 10 popular contents over the last 14 days.
     */
    get: operations["repos/get-top-paths"];
  };
  "/repos/{owner}/{repo}/traffic/popular/referrers": {
    /**
     * Get top referral sources
     * @description Get the top 10 referrers over the last 14 days.
     */
    get: operations["repos/get-top-referrers"];
  };
  "/repos/{owner}/{repo}/traffic/views": {
    /**
     * Get page views
     * @description Get the total number of views and breakdown per day or week for the last 14 days. Timestamps are aligned to UTC midnight of the beginning of the day or week. Week begins on Monday.
     */
    get: operations["repos/get-views"];
  };
  "/repos/{owner}/{repo}/transfer": {
    /**
     * Transfer a repository
     * @description A transfer request will need to be accepted by the new owner when transferring a personal repository to another user. The response will contain the original `owner`, and the transfer will continue asynchronously. For more details on the requirements to transfer personal and organization-owned repositories, see [about repository transfers](https://docs.github.com/articles/about-repository-transfers/).
     */
    post: operations["repos/transfer"];
  };
  "/repos/{owner}/{repo}/vulnerability-alerts": {
    /**
     * Check if vulnerability alerts are enabled for a repository
     * @description Shows whether dependency alerts are enabled or disabled for a repository. The authenticated user must have admin read access to the repository. For more information, see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
     */
    get: operations["repos/check-vulnerability-alerts"];
    /**
     * Enable vulnerability alerts
     * @description Enables dependency alerts and the dependency graph for a repository. The authenticated user must have admin access to the repository. For more information, see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
     */
    put: operations["repos/enable-vulnerability-alerts"];
    /**
     * Disable vulnerability alerts
     * @description Disables dependency alerts and the dependency graph for a repository.
     * The authenticated user must have admin access to the repository. For more information,
     * see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
     */
    delete: operations["repos/disable-vulnerability-alerts"];
  };
  "/repos/{owner}/{repo}/zipball/{ref}": {
    /**
     * Download a repository archive (zip)
     * @description Gets a redirect URL to download a zip archive for a repository. If you omit `:ref`, the repository’s default branch (usually
     * `main`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
     * the `Location` header to make a second `GET` request.
     *
     * **Note**: For private repositories, these links are temporary and expire after five minutes. If the repository is empty, you will receive a 404 when you follow the redirect.
     */
    get: operations["repos/download-zipball-archive"];
  };
  "/repos/{template_owner}/{template_repo}/generate": {
    /**
     * Create a repository using a template
     * @description Creates a new repository using a repository template. Use the `template_owner` and `template_repo` route parameters to specify the repository to use as the template. If the repository is not public, the authenticated user must own or be a member of an organization that owns the repository. To check if a repository is available to use as a template, get the repository's information using the [Get a repository](https://docs.github.com/rest/reference/repos#get-a-repository) endpoint and check that the `is_template` key is `true`.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository
     */
    post: operations["repos/create-using-template"];
  };
  "/repositories": {
    /**
     * List public repositories
     * @description Lists all public repositories in the order that they were created.
     *
     * Note:
     * - For GitHub Enterprise Server, this endpoint will only list repositories available to all users on the enterprise.
     * - Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of repositories.
     */
    get: operations["repos/list-public"];
  };
  "/repositories/{repository_id}/environments/{environment_name}/secrets": {
    /**
     * List environment secrets
     * @description Lists all secrets available in an environment without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/list-environment-secrets"];
  };
  "/repositories/{repository_id}/environments/{environment_name}/secrets/public-key": {
    /**
     * Get an environment public key
     * @description Get the public key for an environment, which you need to encrypt environment secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/get-environment-public-key"];
  };
  "/repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}": {
    /**
     * Get an environment secret
     * @description Gets a single environment secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    get: operations["actions/get-environment-secret"];
    /**
     * Create or update an environment secret
     * @description Creates or updates an environment secret with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
     * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
     * this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["actions/create-or-update-environment-secret"];
    /**
     * Delete an environment secret
     * @description Deletes a secret in an environment using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
     */
    delete: operations["actions/delete-environment-secret"];
  };
  "/repositories/{repository_id}/environments/{environment_name}/variables": {
    /**
     * List environment variables
     * @description Lists all environment variables. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `environments:read` repository permission to use this endpoint.
     */
    get: operations["actions/list-environment-variables"];
    /**
     * Create an environment variable
     * @description Create an environment variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
     */
    post: operations["actions/create-environment-variable"];
  };
  "/repositories/{repository_id}/environments/{environment_name}/variables/{name}": {
    /**
     * Get an environment variable
     * @description Gets a specific variable in an environment. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `environments:read` repository permission to use this endpoint.
     */
    get: operations["actions/get-environment-variable"];
    /**
     * Delete an environment variable
     * @description Deletes an environment variable using the variable name.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
     */
    delete: operations["actions/delete-environment-variable"];
    /**
     * Update an environment variable
     * @description Updates an environment variable that you can reference in a GitHub Actions workflow.
     * You must authenticate using an access token with the `repo` scope to use this endpoint.
     * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
     */
    patch: operations["actions/update-environment-variable"];
  };
  "/search/code": {
    /**
     * Search code
     * @description Searches for query terms inside of a file. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for code, you can get text match metadata for the file **content** and file **path** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find the definition of the `addClass` function inside [jQuery](https://github.com/jquery/jquery) repository, your query would look something like this:
     *
     * `q=addClass+in:file+language:js+repo:jquery/jquery`
     *
     * This query searches for the keyword `addClass` within a file's contents. The query limits the search to files where the language is JavaScript in the `jquery/jquery` repository.
     *
     * #### Considerations for code search
     *
     * Due to the complexity of searching code, there are a few restrictions on how searches are performed:
     *
     * *   Only the _default branch_ is considered. In most cases, this will be the `master` branch.
     * *   Only files smaller than 384 KB are searchable.
     * *   You must always include at least one search term when searching source code. For example, searching for [`language:go`](https://github.com/search?utf8=%E2%9C%93&q=language%3Ago&type=Code) is not valid, while [`amazing
     * language:go`](https://github.com/search?utf8=%E2%9C%93&q=amazing+language%3Ago&type=Code) is.
     *
     * This endpoint requires you to authenticate and limits you to 10 requests per minute.
     */
    get: operations["search/code"];
  };
  "/search/commits": {
    /**
     * Search commits
     * @description Find commits via various criteria on the default branch (usually `main`). This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for commits, you can get text match metadata for the **message** field when you provide the `text-match` media type. For more details about how to receive highlighted search results, see [Text match
     * metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find commits related to CSS in the [octocat/Spoon-Knife](https://github.com/octocat/Spoon-Knife) repository. Your query would look something like this:
     *
     * `q=repo:octocat/Spoon-Knife+css`
     */
    get: operations["search/commits"];
  };
  "/search/issues": {
    /**
     * Search issues and pull requests
     * @description Find issues by state and keyword. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for issues, you can get text match metadata for the issue **title**, issue **body**, and issue **comment body** fields when you pass the `text-match` media type. For more details about how to receive highlighted
     * search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find the oldest unresolved Python bugs on Windows. Your query might look something like this.
     *
     * `q=windows+label:bug+language:python+state:open&sort=created&order=asc`
     *
     * This query searches for the keyword `windows`, within any open issue that is labeled as `bug`. The search runs across repositories whose primary language is Python. The results are sorted by creation date in ascending order, which means the oldest issues appear first in the search results.
     *
     * **Note:** For [user-to-server](https://docs.github.com/developers/apps/identifying-and-authorizing-users-for-github-apps#user-to-server-requests) GitHub App requests, you can't retrieve a combination of issues and pull requests in a single query. Requests that don't include the `is:issue` or `is:pull-request` qualifier will receive an HTTP `422 Unprocessable Entity` response. To get results for both issues and pull requests, you must send separate queries for issues and pull requests. For more information about the `is` qualifier, see "[Searching only issues or pull requests](https://docs.github.com/github/searching-for-information-on-github/searching-issues-and-pull-requests#search-only-issues-or-pull-requests)."
     */
    get: operations["search/issues-and-pull-requests"];
  };
  "/search/labels": {
    /**
     * Search labels
     * @description Find labels in a repository with names or descriptions that match search keywords. Returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for labels, you can get text match metadata for the label **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to find labels in the `linguist` repository that match `bug`, `defect`, or `enhancement`. Your query might look like this:
     *
     * `q=bug+defect+enhancement&repository_id=64778136`
     *
     * The labels that best match the query appear first in the search results.
     */
    get: operations["search/labels"];
  };
  "/search/repositories": {
    /**
     * Search repositories
     * @description Find repositories via various criteria. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for repositories, you can get text match metadata for the **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to search for popular Tetris repositories written in assembly code, your query might look like this:
     *
     * `q=tetris+language:assembly&sort=stars&order=desc`
     *
     * This query searches for repositories with the word `tetris` in the name, the description, or the README. The results are limited to repositories where the primary language is assembly. The results are sorted by stars in descending order, so that the most popular repositories appear first in the search results.
     */
    get: operations["search/repos"];
  };
  "/search/topics": {
    /**
     * Search topics
     * @description Find topics via various criteria. Results are sorted by best match. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination). See "[Searching topics](https://docs.github.com/articles/searching-topics/)" for a detailed list of qualifiers.
     *
     * When searching for topics, you can get text match metadata for the topic's **short\_description**, **description**, **name**, or **display\_name** field when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you want to search for topics related to Ruby that are featured on https://github.com/topics. Your query might look like this:
     *
     * `q=ruby+is:featured`
     *
     * This query searches for topics with the keyword `ruby` and limits the results to find only topics that are featured. The topics that are the best match for the query appear first in the search results.
     */
    get: operations["search/topics"];
  };
  "/search/users": {
    /**
     * Search users
     * @description Find users via various criteria. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
     *
     * When searching for users, you can get text match metadata for the issue **login**, public **email**, and **name** fields when you pass the `text-match` media type. For more details about highlighting search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata). For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
     *
     * For example, if you're looking for a list of popular users, you might try this query:
     *
     * `q=tom+repos:%3E42+followers:%3E1000`
     *
     * This query searches for users with the name `tom`. The results are restricted to users with more than 42 repositories and over 1,000 followers.
     */
    get: operations["search/users"];
  };
  "/teams/{team_id}": {
    /**
     * Get a team (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the [Get a team by name](https://docs.github.com/rest/reference/teams#get-a-team-by-name) endpoint.
     */
    get: operations["teams/get-legacy"];
    /**
     * Delete a team (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a team](https://docs.github.com/rest/reference/teams#delete-a-team) endpoint.
     *
     * To delete a team, the authenticated user must be an organization owner or team maintainer.
     *
     * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
     */
    delete: operations["teams/delete-legacy"];
    /**
     * Update a team (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a team](https://docs.github.com/rest/reference/teams#update-a-team) endpoint.
     *
     * To edit a team, the authenticated user must either be an organization owner or a team maintainer.
     *
     * **Note:** With nested teams, the `privacy` for parent teams cannot be `secret`.
     */
    patch: operations["teams/update-legacy"];
  };
  "/teams/{team_id}/discussions": {
    /**
     * List discussions (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List discussions`](https://docs.github.com/rest/reference/teams#list-discussions) endpoint.
     *
     * List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["teams/list-discussions-legacy"];
    /**
     * Create a discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create a discussion`](https://docs.github.com/rest/reference/teams#create-a-discussion) endpoint.
     *
     * Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["teams/create-discussion-legacy"];
  };
  "/teams/{team_id}/discussions/{discussion_number}": {
    /**
     * Get a discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion](https://docs.github.com/rest/reference/teams#get-a-discussion) endpoint.
     *
     * Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["teams/get-discussion-legacy"];
    /**
     * Delete a discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Delete a discussion`](https://docs.github.com/rest/reference/teams#delete-a-discussion) endpoint.
     *
     * Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["teams/delete-discussion-legacy"];
    /**
     * Update a discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion](https://docs.github.com/rest/reference/teams#update-a-discussion) endpoint.
     *
     * Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    patch: operations["teams/update-discussion-legacy"];
  };
  "/teams/{team_id}/discussions/{discussion_number}/comments": {
    /**
     * List discussion comments (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List discussion comments](https://docs.github.com/rest/reference/teams#list-discussion-comments) endpoint.
     *
     * List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["teams/list-discussion-comments-legacy"];
    /**
     * Create a discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Create a discussion comment](https://docs.github.com/rest/reference/teams#create-a-discussion-comment) endpoint.
     *
     * Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     *
     * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
     */
    post: operations["teams/create-discussion-comment-legacy"];
  };
  "/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}": {
    /**
     * Get a discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion comment](https://docs.github.com/rest/reference/teams#get-a-discussion-comment) endpoint.
     *
     * Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["teams/get-discussion-comment-legacy"];
    /**
     * Delete a discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a discussion comment](https://docs.github.com/rest/reference/teams#delete-a-discussion-comment) endpoint.
     *
     * Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["teams/delete-discussion-comment-legacy"];
    /**
     * Update a discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion comment](https://docs.github.com/rest/reference/teams#update-a-discussion-comment) endpoint.
     *
     * Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    patch: operations["teams/update-discussion-comment-legacy"];
  };
  "/teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions": {
    /**
     * List reactions for a team discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion comment`](https://docs.github.com/rest/reference/reactions#list-reactions-for-a-team-discussion-comment) endpoint.
     *
     * List the reactions to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["reactions/list-for-team-discussion-comment-legacy"];
    /**
     * Create reaction for a team discussion comment (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Create reaction for a team discussion comment](https://docs.github.com/rest/reference/reactions#create-reaction-for-a-team-discussion-comment)" endpoint.
     *
     * Create a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
     */
    post: operations["reactions/create-for-team-discussion-comment-legacy"];
  };
  "/teams/{team_id}/discussions/{discussion_number}/reactions": {
    /**
     * List reactions for a team discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion`](https://docs.github.com/rest/reference/reactions#list-reactions-for-a-team-discussion) endpoint.
     *
     * List the reactions to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["reactions/list-for-team-discussion-legacy"];
    /**
     * Create reaction for a team discussion (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create reaction for a team discussion`](https://docs.github.com/rest/reference/reactions#create-reaction-for-a-team-discussion) endpoint.
     *
     * Create a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
     */
    post: operations["reactions/create-for-team-discussion-legacy"];
  };
  "/teams/{team_id}/invitations": {
    /**
     * List pending team invitations (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List pending team invitations`](https://docs.github.com/rest/reference/teams#list-pending-team-invitations) endpoint.
     *
     * The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, `hiring_manager`, or `reinstate`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
     */
    get: operations["teams/list-pending-invitations-legacy"];
  };
  "/teams/{team_id}/members": {
    /**
     * List team members (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team members`](https://docs.github.com/rest/reference/teams#list-team-members) endpoint.
     *
     * Team members will include the members of child teams.
     */
    get: operations["teams/list-members-legacy"];
  };
  "/teams/{team_id}/members/{username}": {
    /**
     * Get team member (Legacy)
     * @deprecated
     * @description The "Get team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Get team membership for a user](https://docs.github.com/rest/reference/teams#get-team-membership-for-a-user) endpoint instead. It allows you to get both active and pending memberships.
     *
     * To list members in a team, the team must be visible to the authenticated user.
     */
    get: operations["teams/get-member-legacy"];
    /**
     * Add team member (Legacy)
     * @deprecated
     * @description The "Add team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Add or update team membership for a user](https://docs.github.com/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint instead. It allows you to invite new organization members to your teams.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To add someone to a team, the authenticated user must be an organization owner or a team maintainer in the team they're changing. The person being added to the team must be a member of the team's organization.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["teams/add-member-legacy"];
    /**
     * Remove team member (Legacy)
     * @deprecated
     * @description The "Remove team member" endpoint (described below) is deprecated.
     *
     * We recommend using the [Remove team membership for a user](https://docs.github.com/rest/reference/teams#remove-team-membership-for-a-user) endpoint instead. It allows you to remove both active and pending memberships.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To remove a team member, the authenticated user must have 'admin' permissions to the team or be an owner of the org that the team is associated with. Removing a team member does not delete the user, it just removes them from the team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     */
    delete: operations["teams/remove-member-legacy"];
  };
  "/teams/{team_id}/memberships/{username}": {
    /**
     * Get team membership for a user (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get team membership for a user](https://docs.github.com/rest/reference/teams#get-team-membership-for-a-user) endpoint.
     *
     * Team members will include the members of child teams.
     *
     * To get a user's membership with a team, the team must be visible to the authenticated user.
     *
     * **Note:**
     * The response contains the `state` of the membership and the member's `role`.
     *
     * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see [Create a team](https://docs.github.com/rest/reference/teams#create-a-team).
     */
    get: operations["teams/get-membership-for-user-legacy"];
    /**
     * Add or update team membership for a user (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team membership for a user](https://docs.github.com/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * If the user is already a member of the team's organization, this endpoint will add the user to the team. To add a membership between an organization member and a team, the authenticated user must be an organization owner or a team maintainer.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     *
     * If the user is unaffiliated with the team's organization, this endpoint will send an invitation to the user via email. This newly-created membership will be in the "pending" state until the user accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team. To add a membership between an unaffiliated user and a team, the authenticated user must be an organization owner.
     *
     * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
     */
    put: operations["teams/add-or-update-membership-for-user-legacy"];
    /**
     * Remove team membership for a user (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove team membership for a user](https://docs.github.com/rest/reference/teams#remove-team-membership-for-a-user) endpoint.
     *
     * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
     *
     * To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
     *
     * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
     */
    delete: operations["teams/remove-membership-for-user-legacy"];
  };
  "/teams/{team_id}/projects": {
    /**
     * List team projects (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team projects`](https://docs.github.com/rest/reference/teams#list-team-projects) endpoint.
     *
     * Lists the organization projects for a team.
     */
    get: operations["teams/list-projects-legacy"];
  };
  "/teams/{team_id}/projects/{project_id}": {
    /**
     * Check team permissions for a project (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a project](https://docs.github.com/rest/reference/teams#check-team-permissions-for-a-project) endpoint.
     *
     * Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
     */
    get: operations["teams/check-permissions-for-project-legacy"];
    /**
     * Add or update team project permissions (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team project permissions](https://docs.github.com/rest/reference/teams#add-or-update-team-project-permissions) endpoint.
     *
     * Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
     */
    put: operations["teams/add-or-update-project-permissions-legacy"];
    /**
     * Remove a project from a team (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a project from a team](https://docs.github.com/rest/reference/teams#remove-a-project-from-a-team) endpoint.
     *
     * Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. **Note:** This endpoint removes the project from the team, but does not delete it.
     */
    delete: operations["teams/remove-project-legacy"];
  };
  "/teams/{team_id}/repos": {
    /**
     * List team repositories (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List team repositories](https://docs.github.com/rest/reference/teams#list-team-repositories) endpoint.
     */
    get: operations["teams/list-repos-legacy"];
  };
  "/teams/{team_id}/repos/{owner}/{repo}": {
    /**
     * Check team permissions for a repository (Legacy)
     * @deprecated
     * @description **Note**: Repositories inherited through a parent team will also be checked.
     *
     * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a repository](https://docs.github.com/rest/reference/teams#check-team-permissions-for-a-repository) endpoint.
     *
     * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header:
     */
    get: operations["teams/check-permissions-for-repo-legacy"];
    /**
     * Add or update team repository permissions (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Add or update team repository permissions](https://docs.github.com/rest/reference/teams#add-or-update-team-repository-permissions)" endpoint.
     *
     * To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization.
     *
     * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["teams/add-or-update-repo-permissions-legacy"];
    /**
     * Remove a repository from a team (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a repository from a team](https://docs.github.com/rest/reference/teams#remove-a-repository-from-a-team) endpoint.
     *
     * If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. NOTE: This does not delete the repository, it just removes it from the team.
     */
    delete: operations["teams/remove-repo-legacy"];
  };
  "/teams/{team_id}/teams": {
    /**
     * List child teams (Legacy)
     * @deprecated
     * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List child teams`](https://docs.github.com/rest/reference/teams#list-child-teams) endpoint.
     */
    get: operations["teams/list-child-legacy"];
  };
  "/user": {
    /**
     * Get the authenticated user
     * @description If the authenticated user is authenticated through basic authentication or OAuth with the `user` scope, then the response lists public and private profile information.
     *
     * If the authenticated user is authenticated through OAuth without the `user` scope, then the response lists only public profile information.
     */
    get: operations["users/get-authenticated"];
    /**
     * Update the authenticated user
     * @description **Note:** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
     */
    patch: operations["users/update-authenticated"];
  };
  "/user/blocks": {
    /**
     * List users blocked by the authenticated user
     * @description List the users you've blocked on your personal account.
     */
    get: operations["users/list-blocked-by-authenticated-user"];
  };
  "/user/blocks/{username}": {
    /** Check if a user is blocked by the authenticated user */
    get: operations["users/check-blocked"];
    /** Block a user */
    put: operations["users/block"];
    /** Unblock a user */
    delete: operations["users/unblock"];
  };
  "/user/codespaces": {
    /**
     * List codespaces for the authenticated user
     * @description Lists the authenticated user's codespaces.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
     */
    get: operations["codespaces/list-for-authenticated-user"];
    /**
     * Create a codespace for the authenticated user
     * @description Creates a new codespace, owned by the authenticated user.
     *
     * This endpoint requires either a `repository_id` OR a `pull_request` but not both.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    post: operations["codespaces/create-for-authenticated-user"];
  };
  "/user/codespaces/secrets": {
    /**
     * List secrets for the authenticated user
     * @description Lists all secrets available for a user's Codespaces without revealing their
     * encrypted values.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
     */
    get: operations["codespaces/list-secrets-for-authenticated-user"];
  };
  "/user/codespaces/secrets/public-key": {
    /**
     * Get public key for the authenticated user
     * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
     */
    get: operations["codespaces/get-public-key-for-authenticated-user"];
  };
  "/user/codespaces/secrets/{secret_name}": {
    /**
     * Get a secret for the authenticated user
     * @description Gets a secret available to a user's codespaces without revealing its encrypted value.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
     */
    get: operations["codespaces/get-secret-for-authenticated-user"];
    /**
     * Create or update a secret for the authenticated user
     * @description Creates or updates a secret for a user's codespace with an encrypted value. Encrypt your secret using
     * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages).
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must also have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
     *
     * #### Example encrypting a secret using Node.js
     *
     * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
     *
     * ```
     * const sodium = require('libsodium-wrappers')
     * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
     * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
     *
     * //Check if libsodium is ready and then proceed.
     * sodium.ready.then(() => {
     *   // Convert Secret & Base64 key to Uint8Array.
     *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
     *   let binsec = sodium.from_string(secret)
     *
     *   //Encrypt the secret using LibSodium
     *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
     *
     *   // Convert encrypted Uint8Array to Base64
     *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
     *
     *   console.log(output)
     * });
     * ```
     *
     * #### Example encrypting a secret using Python
     *
     * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
     *
     * ```
     * from base64 import b64encode
     * from nacl import encoding, public
     *
     * def encrypt(public_key: str, secret_value: str) -> str:
     *   """Encrypt a Unicode string using the public key."""
     *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
     *   sealed_box = public.SealedBox(public_key)
     *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
     *   return b64encode(encrypted).decode("utf-8")
     * ```
     *
     * #### Example encrypting a secret using C#
     *
     * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
     *
     * ```
     * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
     * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
     *
     * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
     *
     * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
     * ```
     *
     * #### Example encrypting a secret using Ruby
     *
     * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
     *
     * ```ruby
     * require "rbnacl"
     * require "base64"
     *
     * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
     * public_key = RbNaCl::PublicKey.new(key)
     *
     * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
     * encrypted_secret = box.encrypt("my_secret")
     *
     * # Print the base64 encoded secret
     * puts Base64.strict_encode64(encrypted_secret)
     * ```
     */
    put: operations["codespaces/create-or-update-secret-for-authenticated-user"];
    /**
     * Delete a secret for the authenticated user
     * @description Deletes a secret from a user's codespaces using the secret name. Deleting the secret will remove access from all codespaces that were allowed to access the secret.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_user_secrets` user permission to use this endpoint.
     */
    delete: operations["codespaces/delete-secret-for-authenticated-user"];
  };
  "/user/codespaces/secrets/{secret_name}/repositories": {
    /**
     * List selected repositories for a user secret
     * @description List the repositories that have been granted the ability to use a user's codespace secret.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
     */
    get: operations["codespaces/list-repositories-for-secret-for-authenticated-user"];
    /**
     * Set selected repositories for a user secret
     * @description Select the repositories that will use a user's codespace secret.
     *
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
     */
    put: operations["codespaces/set-repositories-for-secret-for-authenticated-user"];
  };
  "/user/codespaces/secrets/{secret_name}/repositories/{repository_id}": {
    /**
     * Add a selected repository to a user secret
     * @description Adds a repository to the selected repositories for a user's codespace secret.
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on the referenced repository to use this endpoint.
     */
    put: operations["codespaces/add-repository-for-secret-for-authenticated-user"];
    /**
     * Remove a selected repository from a user secret
     * @description Removes a repository from the selected repositories for a user's codespace secret.
     * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
     * GitHub Apps must have write access to the `codespaces_user_secrets` user permission to use this endpoint.
     */
    delete: operations["codespaces/remove-repository-for-secret-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}": {
    /**
     * Get a codespace for the authenticated user
     * @description Gets information about a user's codespace.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
     */
    get: operations["codespaces/get-for-authenticated-user"];
    /**
     * Delete a codespace for the authenticated user
     * @description Deletes a user's codespace.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    delete: operations["codespaces/delete-for-authenticated-user"];
    /**
     * Update a codespace for the authenticated user
     * @description Updates a codespace owned by the authenticated user. Currently only the codespace's machine type and recent folders can be modified using this endpoint.
     *
     * If you specify a new machine type it will be applied the next time your codespace is started.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    patch: operations["codespaces/update-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/exports": {
    /**
     * Export a codespace for the authenticated user
     * @description Triggers an export of the specified codespace and returns a URL and ID where the status of the export can be monitored.
     *
     * If changes cannot be pushed to the codespace's repository, they will be pushed to a new or previously-existing fork instead.
     *
     * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
     */
    post: operations["codespaces/export-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/exports/{export_id}": {
    /**
     * Get details about a codespace export
     * @description Gets information about an export of a codespace.
     *
     * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
     */
    get: operations["codespaces/get-export-details-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/machines": {
    /**
     * List machine types for a codespace
     * @description List the machine types a codespace can transition to use.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have read access to the `codespaces_metadata` repository permission to use this endpoint.
     */
    get: operations["codespaces/codespace-machines-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/publish": {
    /**
     * Create a repository from an unpublished codespace
     * @description Publishes an unpublished codespace, creating a new repository and assigning it to the codespace.
     *
     * The codespace's token is granted write permissions to the repository, allowing the user to push their changes.
     *
     * This will fail for a codespace that is already published, meaning it has an associated repository.
     *
     * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
     */
    post: operations["codespaces/publish-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/start": {
    /**
     * Start a codespace for the authenticated user
     * @description Starts a user's codespace.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
     */
    post: operations["codespaces/start-for-authenticated-user"];
  };
  "/user/codespaces/{codespace_name}/stop": {
    /**
     * Stop a codespace for the authenticated user
     * @description Stops a user's codespace.
     *
     * You must authenticate using an access token with the `codespace` scope to use this endpoint.
     *
     * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
     */
    post: operations["codespaces/stop-for-authenticated-user"];
  };
  "/user/docker/conflicts": {
    /**
     * Get list of conflicting packages during Docker migration for authenticated-user
     * @description Lists all packages that are owned by the authenticated user within the user's namespace, and that encountered a conflict during a Docker migration.
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
     */
    get: operations["packages/list-docker-migration-conflicting-packages-for-authenticated-user"];
  };
  "/user/email/visibility": {
    /**
     * Set primary email visibility for the authenticated user
     * @description Sets the visibility for your primary email addresses.
     */
    patch: operations["users/set-primary-email-visibility-for-authenticated-user"];
  };
  "/user/emails": {
    /**
     * List email addresses for the authenticated user
     * @description Lists all of your email addresses, and specifies which one is visible to the public. This endpoint is accessible with the `user:email` scope.
     */
    get: operations["users/list-emails-for-authenticated-user"];
    /**
     * Add an email address for the authenticated user
     * @description This endpoint is accessible with the `user` scope.
     */
    post: operations["users/add-email-for-authenticated-user"];
    /**
     * Delete an email address for the authenticated user
     * @description This endpoint is accessible with the `user` scope.
     */
    delete: operations["users/delete-email-for-authenticated-user"];
  };
  "/user/followers": {
    /**
     * List followers of the authenticated user
     * @description Lists the people following the authenticated user.
     */
    get: operations["users/list-followers-for-authenticated-user"];
  };
  "/user/following": {
    /**
     * List the people the authenticated user follows
     * @description Lists the people who the authenticated user follows.
     */
    get: operations["users/list-followed-by-authenticated-user"];
  };
  "/user/following/{username}": {
    /** Check if a person is followed by the authenticated user */
    get: operations["users/check-person-is-followed-by-authenticated"];
    /**
     * Follow a user
     * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     *
     * Following a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
     */
    put: operations["users/follow"];
    /**
     * Unfollow a user
     * @description Unfollowing a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
     */
    delete: operations["users/unfollow"];
  };
  "/user/gpg_keys": {
    /**
     * List GPG keys for the authenticated user
     * @description Lists the current user's GPG keys. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["users/list-gpg-keys-for-authenticated-user"];
    /**
     * Create a GPG key for the authenticated user
     * @description Adds a GPG key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    post: operations["users/create-gpg-key-for-authenticated-user"];
  };
  "/user/gpg_keys/{gpg_key_id}": {
    /**
     * Get a GPG key for the authenticated user
     * @description View extended details for a single GPG key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["users/get-gpg-key-for-authenticated-user"];
    /**
     * Delete a GPG key for the authenticated user
     * @description Removes a GPG key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["users/delete-gpg-key-for-authenticated-user"];
  };
  "/user/installations": {
    /**
     * List app installations accessible to the user access token
     * @description Lists installations of your GitHub App that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
     *
     * You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     *
     * You can find the permissions for the installation under the `permissions` key.
     */
    get: operations["apps/list-installations-for-authenticated-user"];
  };
  "/user/installations/{installation_id}/repositories": {
    /**
     * List repositories accessible to the user access token
     * @description List repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access for an installation.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     *
     * You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
     *
     * The access the user has to each repository is included in the hash under the `permissions` key.
     */
    get: operations["apps/list-installation-repos-for-authenticated-user"];
  };
  "/user/installations/{installation_id}/repositories/{repository_id}": {
    /**
     * Add a repository to an app installation
     * @description Add a single repository to an installation. The authenticated user must have admin access to the repository.
     *
     * You must use a personal access token (which you can create via the [command line](https://docs.github.com/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
     */
    put: operations["apps/add-repo-to-installation-for-authenticated-user"];
    /**
     * Remove a repository from an app installation
     * @description Remove a single repository from an installation. The authenticated user must have admin access to the repository.
     *
     * You must use a personal access token (which you can create via the [command line](https://docs.github.com/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
     */
    delete: operations["apps/remove-repo-from-installation-for-authenticated-user"];
  };
  "/user/interaction-limits": {
    /**
     * Get interaction restrictions for your public repositories
     * @description Shows which type of GitHub user can interact with your public repositories and when the restriction expires.
     */
    get: operations["interactions/get-restrictions-for-authenticated-user"];
    /**
     * Set interaction restrictions for your public repositories
     * @description Temporarily restricts which type of GitHub user can interact with your public repositories. Setting the interaction limit at the user level will overwrite any interaction limits that are set for individual repositories owned by the user.
     */
    put: operations["interactions/set-restrictions-for-authenticated-user"];
    /**
     * Remove interaction restrictions from your public repositories
     * @description Removes any interaction restrictions from your public repositories.
     */
    delete: operations["interactions/remove-restrictions-for-authenticated-user"];
  };
  "/user/issues": {
    /**
     * List user account issues assigned to the authenticated user
     * @description List issues across owned and member repositories assigned to the authenticated user.
     *
     * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
     * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
     * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
     * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
     */
    get: operations["issues/list-for-authenticated-user"];
  };
  "/user/keys": {
    /**
     * List public SSH keys for the authenticated user
     * @description Lists the public SSH keys for the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["users/list-public-ssh-keys-for-authenticated-user"];
    /**
     * Create a public SSH key for the authenticated user
     * @description Adds a public SSH key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    post: operations["users/create-public-ssh-key-for-authenticated-user"];
  };
  "/user/keys/{key_id}": {
    /**
     * Get a public SSH key for the authenticated user
     * @description View extended details for a single public SSH key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    get: operations["users/get-public-ssh-key-for-authenticated-user"];
    /**
     * Delete a public SSH key for the authenticated user
     * @description Removes a public SSH key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
     */
    delete: operations["users/delete-public-ssh-key-for-authenticated-user"];
  };
  "/user/marketplace_purchases": {
    /**
     * List subscriptions for the authenticated user
     * @description Lists the active subscriptions for the authenticated user. You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint. . OAuth Apps must authenticate using an [OAuth token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/).
     */
    get: operations["apps/list-subscriptions-for-authenticated-user"];
  };
  "/user/marketplace_purchases/stubbed": {
    /**
     * List subscriptions for the authenticated user (stubbed)
     * @description Lists the active subscriptions for the authenticated user. You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint. . OAuth Apps must authenticate using an [OAuth token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/).
     */
    get: operations["apps/list-subscriptions-for-authenticated-user-stubbed"];
  };
  "/user/memberships/orgs": {
    /** List organization memberships for the authenticated user */
    get: operations["orgs/list-memberships-for-authenticated-user"];
  };
  "/user/memberships/orgs/{org}": {
    /** Get an organization membership for the authenticated user */
    get: operations["orgs/get-membership-for-authenticated-user"];
    /** Update an organization membership for the authenticated user */
    patch: operations["orgs/update-membership-for-authenticated-user"];
  };
  "/user/migrations": {
    /**
     * List user migrations
     * @description Lists all migrations a user has started.
     */
    get: operations["migrations/list-for-authenticated-user"];
    /**
     * Start a user migration
     * @description Initiates the generation of a user migration archive.
     */
    post: operations["migrations/start-for-authenticated-user"];
  };
  "/user/migrations/{migration_id}": {
    /**
     * Get a user migration status
     * @description Fetches a single user migration. The response includes the `state` of the migration, which can be one of the following values:
     *
     * *   `pending` - the migration hasn't started yet.
     * *   `exporting` - the migration is in progress.
     * *   `exported` - the migration finished successfully.
     * *   `failed` - the migration failed.
     *
     * Once the migration has been `exported` you can [download the migration archive](https://docs.github.com/rest/migrations/users#download-a-user-migration-archive).
     */
    get: operations["migrations/get-status-for-authenticated-user"];
  };
  "/user/migrations/{migration_id}/archive": {
    /**
     * Download a user migration archive
     * @description Fetches the URL to download the migration archive as a `tar.gz` file. Depending on the resources your repository uses, the migration archive can contain JSON files with data for these objects:
     *
     * *   attachments
     * *   bases
     * *   commit\_comments
     * *   issue\_comments
     * *   issue\_events
     * *   issues
     * *   milestones
     * *   organizations
     * *   projects
     * *   protected\_branches
     * *   pull\_request\_reviews
     * *   pull\_requests
     * *   releases
     * *   repositories
     * *   review\_comments
     * *   schema
     * *   users
     *
     * The archive will also contain an `attachments` directory that includes all attachment files uploaded to GitHub.com and a `repositories` directory that contains the repository's Git data.
     */
    get: operations["migrations/get-archive-for-authenticated-user"];
    /**
     * Delete a user migration archive
     * @description Deletes a previous migration archive. Downloadable migration archives are automatically deleted after seven days. Migration metadata, which is returned in the [List user migrations](https://docs.github.com/rest/migrations/users#list-user-migrations) and [Get a user migration status](https://docs.github.com/rest/migrations/users#get-a-user-migration-status) endpoints, will continue to be available even after an archive is deleted.
     */
    delete: operations["migrations/delete-archive-for-authenticated-user"];
  };
  "/user/migrations/{migration_id}/repos/{repo_name}/lock": {
    /**
     * Unlock a user repository
     * @description Unlocks a repository. You can lock repositories when you [start a user migration](https://docs.github.com/rest/migrations/users#start-a-user-migration). Once the migration is complete you can unlock each repository to begin using it again or [delete the repository](https://docs.github.com/rest/repos/repos#delete-a-repository) if you no longer need the source data. Returns a status of `404 Not Found` if the repository is not locked.
     */
    delete: operations["migrations/unlock-repo-for-authenticated-user"];
  };
  "/user/migrations/{migration_id}/repositories": {
    /**
     * List repositories for a user migration
     * @description Lists all the repositories for this user migration.
     */
    get: operations["migrations/list-repos-for-authenticated-user"];
  };
  "/user/orgs": {
    /**
     * List organizations for the authenticated user
     * @description List organizations for the authenticated user.
     *
     * **OAuth scope requirements**
     *
     * This only lists organizations that your authorization allows you to operate on in some way (e.g., you can list teams with `read:org` scope, you can publicize your organization membership with `user` scope, etc.). Therefore, this API requires at least `user` or `read:org` scope. OAuth requests with insufficient scope receive a `403 Forbidden` response.
     */
    get: operations["orgs/list-for-authenticated-user"];
  };
  "/user/packages": {
    /**
     * List packages for the authenticated user's namespace
     * @description Lists packages owned by the authenticated user within the user's namespace.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/list-packages-for-authenticated-user"];
  };
  "/user/packages/{package_type}/{package_name}": {
    /**
     * Get a package for the authenticated user
     * @description Gets a specific package for a package owned by the authenticated user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-for-authenticated-user"];
    /**
     * Delete a package for the authenticated user
     * @description Deletes a package owned by the authenticated user. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes.
     * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    delete: operations["packages/delete-package-for-authenticated-user"];
  };
  "/user/packages/{package_type}/{package_name}/restore": {
    /**
     * Restore a package for the authenticated user
     * @description Restores a package owned by the authenticated user.
     *
     * You can restore a deleted package under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    post: operations["packages/restore-package-for-authenticated-user"];
  };
  "/user/packages/{package_type}/{package_name}/versions": {
    /**
     * List package versions for a package owned by the authenticated user
     * @description Lists package versions for a package owned by the authenticated user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-all-package-versions-for-package-owned-by-authenticated-user"];
  };
  "/user/packages/{package_type}/{package_name}/versions/{package_version_id}": {
    /**
     * Get a package version for the authenticated user
     * @description Gets a specific package version for a package owned by the authenticated user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-version-for-authenticated-user"];
    /**
     * Delete a package version for the authenticated user
     * @description Deletes a specific package version for a package owned by the authenticated user.  If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes.
     * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    delete: operations["packages/delete-package-version-for-authenticated-user"];
  };
  "/user/packages/{package_type}/{package_name}/versions/{package_version_id}/restore": {
    /**
     * Restore a package version for the authenticated user
     * @description Restores a package version owned by the authenticated user.
     *
     * You can restore a deleted package version under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    post: operations["packages/restore-package-version-for-authenticated-user"];
  };
  "/user/projects": {
    /**
     * Create a user project
     * @description Creates a user project board. Returns a `410 Gone` status if the user does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
     */
    post: operations["projects/create-for-authenticated-user"];
  };
  "/user/public_emails": {
    /**
     * List public email addresses for the authenticated user
     * @description Lists your publicly visible email address, which you can set with the [Set primary email visibility for the authenticated user](https://docs.github.com/rest/reference/users#set-primary-email-visibility-for-the-authenticated-user) endpoint. This endpoint is accessible with the `user:email` scope.
     */
    get: operations["users/list-public-emails-for-authenticated-user"];
  };
  "/user/repos": {
    /**
     * List repositories for the authenticated user
     * @description Lists repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
     *
     * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
     */
    get: operations["repos/list-for-authenticated-user"];
    /**
     * Create a repository for the authenticated user
     * @description Creates a new repository for the authenticated user.
     *
     * **OAuth scope requirements**
     *
     * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
     *
     * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
     * *   `repo` scope to create a private repository.
     */
    post: operations["repos/create-for-authenticated-user"];
  };
  "/user/repository_invitations": {
    /**
     * List repository invitations for the authenticated user
     * @description When authenticating as a user, this endpoint will list all currently open repository invitations for that user.
     */
    get: operations["repos/list-invitations-for-authenticated-user"];
  };
  "/user/repository_invitations/{invitation_id}": {
    /** Decline a repository invitation */
    delete: operations["repos/decline-invitation-for-authenticated-user"];
    /** Accept a repository invitation */
    patch: operations["repos/accept-invitation-for-authenticated-user"];
  };
  "/user/social_accounts": {
    /**
     * List social accounts for the authenticated user
     * @description Lists all of your social accounts.
     */
    get: operations["users/list-social-accounts-for-authenticated-user"];
    /**
     * Add social accounts for the authenticated user
     * @description Add one or more social accounts to the authenticated user's profile. This endpoint is accessible with the `user` scope.
     */
    post: operations["users/add-social-account-for-authenticated-user"];
    /**
     * Delete social accounts for the authenticated user
     * @description Deletes one or more social accounts from the authenticated user's profile. This endpoint is accessible with the `user` scope.
     */
    delete: operations["users/delete-social-account-for-authenticated-user"];
  };
  "/user/ssh_signing_keys": {
    /**
     * List SSH signing keys for the authenticated user
     * @description Lists the SSH signing keys for the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `read:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
     */
    get: operations["users/list-ssh-signing-keys-for-authenticated-user"];
    /**
     * Create a SSH signing key for the authenticated user
     * @description Creates an SSH signing key for the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `write:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
     */
    post: operations["users/create-ssh-signing-key-for-authenticated-user"];
  };
  "/user/ssh_signing_keys/{ssh_signing_key_id}": {
    /**
     * Get an SSH signing key for the authenticated user
     * @description Gets extended details for an SSH signing key. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `read:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
     */
    get: operations["users/get-ssh-signing-key-for-authenticated-user"];
    /**
     * Delete an SSH signing key for the authenticated user
     * @description Deletes an SSH signing key from the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `admin:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
     */
    delete: operations["users/delete-ssh-signing-key-for-authenticated-user"];
  };
  "/user/starred": {
    /**
     * List repositories starred by the authenticated user
     * @description Lists repositories the authenticated user has starred.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
     */
    get: operations["activity/list-repos-starred-by-authenticated-user"];
  };
  "/user/starred/{owner}/{repo}": {
    /** Check if a repository is starred by the authenticated user */
    get: operations["activity/check-repo-is-starred-by-authenticated-user"];
    /**
     * Star a repository for the authenticated user
     * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
     */
    put: operations["activity/star-repo-for-authenticated-user"];
    /** Unstar a repository for the authenticated user */
    delete: operations["activity/unstar-repo-for-authenticated-user"];
  };
  "/user/subscriptions": {
    /**
     * List repositories watched by the authenticated user
     * @description Lists repositories the authenticated user is watching.
     */
    get: operations["activity/list-watched-repos-for-authenticated-user"];
  };
  "/user/teams": {
    /**
     * List teams for the authenticated user
     * @description List all of the teams across all of the organizations to which the authenticated user belongs. This method requires `user`, `repo`, or `read:org` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/) when authenticating via [OAuth](https://docs.github.com/apps/building-oauth-apps/). When using a fine-grained personal access token, the resource owner of the token [must be a single organization](https://docs.github.com/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token#fine-grained-personal-access-tokens), and have at least read-only member organization permissions. The response payload only contains the teams from a single organization when using a fine-grained personal access token.
     */
    get: operations["teams/list-for-authenticated-user"];
  };
  "/users": {
    /**
     * List users
     * @description Lists all users, in the order that they signed up on GitHub. This list includes personal user accounts and organization accounts.
     *
     * Note: Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
     */
    get: operations["users/list"];
  };
  "/users/{username}": {
    /**
     * Get a user
     * @description Provides publicly available information about someone with a GitHub account.
     *
     * GitHub Apps with the `Plan` user permission can use this endpoint to retrieve information about a user's GitHub plan. The GitHub App must be authenticated as a user. See "[Identifying and authorizing users for GitHub Apps](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/)" for details about authentication. For an example response, see 'Response with GitHub plan information' below"
     *
     * The `email` key in the following response is the publicly visible email address from your GitHub [profile page](https://github.com/settings/profile). When setting up your profile, you can select a primary email address to be “public” which provides an email entry for this endpoint. If you do not set a public email address for `email`, then it will have a value of `null`. You only see publicly visible email addresses when authenticated with GitHub. For more information, see [Authentication](https://docs.github.com/rest/overview/resources-in-the-rest-api#authentication).
     *
     * The Emails API enables you to list all of your email addresses, and toggle a primary email to be visible publicly. For more information, see "[Emails API](https://docs.github.com/rest/reference/users#emails)".
     */
    get: operations["users/get-by-username"];
  };
  "/users/{username}/docker/conflicts": {
    /**
     * Get list of conflicting packages during Docker migration for user
     * @description Lists all packages that are in a specific user's namespace, that the requesting user has access to, and that encountered a conflict during Docker migration.
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
     */
    get: operations["packages/list-docker-migration-conflicting-packages-for-user"];
  };
  "/users/{username}/events": {
    /**
     * List events for the authenticated user
     * @description If you are authenticated as the given user, you will see your private events. Otherwise, you'll only see public events.
     */
    get: operations["activity/list-events-for-authenticated-user"];
  };
  "/users/{username}/events/orgs/{org}": {
    /**
     * List organization events for the authenticated user
     * @description This is the user's organization dashboard. You must be authenticated as the user to view this.
     */
    get: operations["activity/list-org-events-for-authenticated-user"];
  };
  "/users/{username}/events/public": {
    /** List public events for a user */
    get: operations["activity/list-public-events-for-user"];
  };
  "/users/{username}/followers": {
    /**
     * List followers of a user
     * @description Lists the people following the specified user.
     */
    get: operations["users/list-followers-for-user"];
  };
  "/users/{username}/following": {
    /**
     * List the people a user follows
     * @description Lists the people who the specified user follows.
     */
    get: operations["users/list-following-for-user"];
  };
  "/users/{username}/following/{target_user}": {
    /** Check if a user follows another user */
    get: operations["users/check-following-for-user"];
  };
  "/users/{username}/gists": {
    /**
     * List gists for a user
     * @description Lists public gists for the specified user:
     */
    get: operations["gists/list-for-user"];
  };
  "/users/{username}/gpg_keys": {
    /**
     * List GPG keys for a user
     * @description Lists the GPG keys for a user. This information is accessible by anyone.
     */
    get: operations["users/list-gpg-keys-for-user"];
  };
  "/users/{username}/hovercard": {
    /**
     * Get contextual information for a user
     * @description Provides hovercard information when authenticated through basic auth or OAuth with the `repo` scope. You can find out more about someone in relation to their pull requests, issues, repositories, and organizations.
     *
     * The `subject_type` and `subject_id` parameters provide context for the person's hovercard, which returns more information than without the parameters. For example, if you wanted to find out more about `octocat` who owns the `Spoon-Knife` repository via cURL, it would look like this:
     *
     * ```shell
     *  curl -u username:token
     *   https://api.github.com/users/octocat/hovercard?subject_type=repository&subject_id=1300192
     * ```
     */
    get: operations["users/get-context-for-user"];
  };
  "/users/{username}/installation": {
    /**
     * Get a user installation for the authenticated app
     * @description Enables an authenticated GitHub App to find the user’s installation information.
     *
     * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
     */
    get: operations["apps/get-user-installation"];
  };
  "/users/{username}/keys": {
    /**
     * List public keys for a user
     * @description Lists the _verified_ public SSH keys for a user. This is accessible by anyone.
     */
    get: operations["users/list-public-keys-for-user"];
  };
  "/users/{username}/orgs": {
    /**
     * List organizations for a user
     * @description List [public organization memberships](https://docs.github.com/articles/publicizing-or-concealing-organization-membership) for the specified user.
     *
     * This method only lists _public_ memberships, regardless of authentication. If you need to fetch all of the organization memberships (public and private) for the authenticated user, use the [List organizations for the authenticated user](https://docs.github.com/rest/reference/orgs#list-organizations-for-the-authenticated-user) API instead.
     */
    get: operations["orgs/list-for-user"];
  };
  "/users/{username}/packages": {
    /**
     * List packages for a user
     * @description Lists all packages in a user's namespace for which the requesting user has access.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/list-packages-for-user"];
  };
  "/users/{username}/packages/{package_type}/{package_name}": {
    /**
     * Get a package for a user
     * @description Gets a specific package metadata for a public package owned by a user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-for-user"];
    /**
     * Delete a package for a user
     * @description Deletes an entire package for a user. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    delete: operations["packages/delete-package-for-user"];
  };
  "/users/{username}/packages/{package_type}/{package_name}/restore": {
    /**
     * Restore a package for a user
     * @description Restores an entire package for a user.
     *
     * You can restore a deleted package under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    post: operations["packages/restore-package-for-user"];
  };
  "/users/{username}/packages/{package_type}/{package_name}/versions": {
    /**
     * List package versions for a package owned by a user
     * @description Lists package versions for a public package owned by a specified user.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-all-package-versions-for-package-owned-by-user"];
  };
  "/users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}": {
    /**
     * Get a package version for a user
     * @description Gets a specific package version for a public package owned by a specified user.
     *
     * At this time, to use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     */
    get: operations["packages/get-package-version-for-user"];
    /**
     * Delete package version for a user
     * @description Deletes a specific package version for a user. If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    delete: operations["packages/delete-package-version-for-user"];
  };
  "/users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore": {
    /**
     * Restore package version for a user
     * @description Restores a specific package version for a user.
     *
     * You can restore a deleted package under the following conditions:
     *   - The package was deleted within the last 30 days.
     *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
     *
     * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
     * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
     * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    post: operations["packages/restore-package-version-for-user"];
  };
  "/users/{username}/projects": {
    /** List user projects */
    get: operations["projects/list-for-user"];
  };
  "/users/{username}/received_events": {
    /**
     * List events received by the authenticated user
     * @description These are events that you've received by watching repos and following users. If you are authenticated as the given user, you will see private events. Otherwise, you'll only see public events.
     */
    get: operations["activity/list-received-events-for-user"];
  };
  "/users/{username}/received_events/public": {
    /** List public events received by a user */
    get: operations["activity/list-received-public-events-for-user"];
  };
  "/users/{username}/repos": {
    /**
     * List repositories for a user
     * @description Lists public repositories for the specified user. Note: For GitHub AE, this endpoint will list internal repositories for the specified user.
     */
    get: operations["repos/list-for-user"];
  };
  "/users/{username}/settings/billing/actions": {
    /**
     * Get GitHub Actions billing for a user
     * @description Gets the summary of the free and paid GitHub Actions minutes used.
     *
     * Paid minutes only apply to workflows in private repositories that use GitHub-hosted runners. Minutes used is listed for each GitHub-hosted runner operating system. Any job re-runs are also included in the usage. The usage returned includes any minute multipliers for macOS and Windows runners, and is rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
     *
     * Access tokens must have the `user` scope.
     */
    get: operations["billing/get-github-actions-billing-user"];
  };
  "/users/{username}/settings/billing/packages": {
    /**
     * Get GitHub Packages billing for a user
     * @description Gets the free and paid storage used for GitHub Packages in gigabytes.
     *
     * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
     *
     * Access tokens must have the `user` scope.
     */
    get: operations["billing/get-github-packages-billing-user"];
  };
  "/users/{username}/settings/billing/shared-storage": {
    /**
     * Get shared storage billing for a user
     * @description Gets the estimated paid and estimated total storage used for GitHub Actions and GitHub Packages.
     *
     * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
     *
     * Access tokens must have the `user` scope.
     */
    get: operations["billing/get-shared-storage-billing-user"];
  };
  "/users/{username}/social_accounts": {
    /**
     * List social accounts for a user
     * @description Lists social media accounts for a user. This endpoint is accessible by anyone.
     */
    get: operations["users/list-social-accounts-for-user"];
  };
  "/users/{username}/ssh_signing_keys": {
    /**
     * List SSH signing keys for a user
     * @description Lists the SSH signing keys for a user. This operation is accessible by anyone.
     */
    get: operations["users/list-ssh-signing-keys-for-user"];
  };
  "/users/{username}/starred": {
    /**
     * List repositories starred by a user
     * @description Lists repositories a user has starred.
     *
     * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
     */
    get: operations["activity/list-repos-starred-by-user"];
  };
  "/users/{username}/subscriptions": {
    /**
     * List repositories watched by a user
     * @description Lists repositories a user is watching.
     */
    get: operations["activity/list-repos-watched-by-user"];
  };
  "/versions": {
    /**
     * Get all API versions
     * @description Get all supported GitHub API versions.
     */
    get: operations["meta/get-all-versions"];
  };
  "/zen": {
    /**
     * Get the Zen of GitHub
     * @description Get a random sentence from the Zen of GitHub
     */
    get: operations["meta/get-zen"];
  };
  "/repos/{owner}/{repo}/compare/{base}...{head}": {
    /**
     * Compare two commits
     * @description **Deprecated**: Use `repos.compareCommitsWithBasehead()` (`GET /repos/{owner}/{repo}/compare/{basehead}`) instead. Both `:base` and `:head` must be branch names in `:repo`. To compare branches across other repositories in the same network as `:repo`, use the format `<USERNAME>:branch`.
     *
     * The response from the API is equivalent to running the `git log base..head` command; however, commits are returned in chronological order. Pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
     *
     * The response also includes details on the files that were changed between the two commits. This includes the status of the change (for example, if a file was added, removed, modified, or renamed), and details of the change itself. For example, files with a `renamed` status have a `previous_filename` field showing the previous filename of the file, and files with a `modified` status have a `patch` field showing the changes made to the file.
     *
     * **Working with large comparisons**
     *
     * To process a response with a large number of commits, you can use (`per_page` or `page`) to paginate the results. When using paging, the list of changed files is only returned with page 1, but includes all changed files for the entire comparison. For more information on working with pagination, see "[Traversing with pagination](/rest/guides/traversing-with-pagination)."
     *
     * When calling this API without any paging parameters (`per_page` or `page`), the returned list is limited to 250 commits and the last commit in the list is the most recent of the entire comparison. When a paging parameter is specified, the first commit in the returned list of each page is the earliest.
     *
     * **Signature verification object**
     *
     * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
     *
     * | Name | Type | Description |
     * | ---- | ---- | ----------- |
     * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
     * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
     * | `signature` | `string` | The signature that was extracted from the commit. |
     * | `payload` | `string` | The value that was signed. |
     *
     * These are the possible values for `reason` in the `verification` object:
     *
     * | Value | Description |
     * | ----- | ----------- |
     * | `expired_key` | The key that made the signature is expired. |
     * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
     * | `gpgverify_error` | There was an error communicating with the signature verification service. |
     * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
     * | `unsigned` | The object does not include a signature. |
     * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
     * | `no_user` | No user was associated with the `committer` email address in the commit. |
     * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
     * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
     * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
     * | `malformed_signature` | There was an error parsing the signature. |
     * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
     * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
     */
    get: operations["repos/compare-commits"];
  };
}

export type webhooks = Record<string, never>;

export interface components {
  schemas: {
    root: {
      /** Format: uri-template */
      current_user_url: string;
      /** Format: uri-template */
      current_user_authorizations_html_url: string;
      /** Format: uri-template */
      authorizations_url: string;
      /** Format: uri-template */
      code_search_url: string;
      /** Format: uri-template */
      commit_search_url: string;
      /** Format: uri-template */
      emails_url: string;
      /** Format: uri-template */
      emojis_url: string;
      /** Format: uri-template */
      events_url: string;
      /** Format: uri-template */
      feeds_url: string;
      /** Format: uri-template */
      followers_url: string;
      /** Format: uri-template */
      following_url: string;
      /** Format: uri-template */
      gists_url: string;
      /** Format: uri-template */
      hub_url: string;
      /** Format: uri-template */
      issue_search_url: string;
      /** Format: uri-template */
      issues_url: string;
      /** Format: uri-template */
      keys_url: string;
      /** Format: uri-template */
      label_search_url: string;
      /** Format: uri-template */
      notifications_url: string;
      /** Format: uri-template */
      organization_url: string;
      /** Format: uri-template */
      organization_repositories_url: string;
      /** Format: uri-template */
      organization_teams_url: string;
      /** Format: uri-template */
      public_gists_url: string;
      /** Format: uri-template */
      rate_limit_url: string;
      /** Format: uri-template */
      repository_url: string;
      /** Format: uri-template */
      repository_search_url: string;
      /** Format: uri-template */
      current_user_repositories_url: string;
      /** Format: uri-template */
      starred_url: string;
      /** Format: uri-template */
      starred_gists_url: string;
      /** Format: uri-template */
      topic_search_url?: string;
      /** Format: uri-template */
      user_url: string;
      /** Format: uri-template */
      user_organizations_url: string;
      /** Format: uri-template */
      user_repositories_url: string;
      /** Format: uri-template */
      user_search_url: string;
    };
    /**
     * Simple User
     * @description A GitHub user.
     */
    "nullable-simple-user": {
      name?: string | null;
      email?: string | null;
      /** @example octocat */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDQ6VXNlcjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/images/error/octocat_happy.gif
       */
      avatar_url: string;
      /** @example 41d064eb2195891e12d0413f63227ea7 */
      gravatar_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/followers
       */
      followers_url: string;
      /** @example https://api.github.com/users/octocat/following{/other_user} */
      following_url: string;
      /** @example https://api.github.com/users/octocat/gists{/gist_id} */
      gists_url: string;
      /** @example https://api.github.com/users/octocat/starred{/owner}{/repo} */
      starred_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/subscriptions
       */
      subscriptions_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/orgs
       */
      organizations_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repos_url: string;
      /** @example https://api.github.com/users/octocat/events{/privacy} */
      events_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/received_events
       */
      received_events_url: string;
      /** @example User */
      type: string;
      site_admin: boolean;
      /** @example "2020-07-09T00:17:55Z" */
      starred_at?: string;
    } | null;
    /**
     * GitHub app
     * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
     */
    integration: {
      /**
       * @description Unique identifier of the GitHub app
       * @example 37
       */
      id: number;
      /**
       * @description The slug name of the GitHub app
       * @example probot-owners
       */
      slug?: string;
      /** @example MDExOkludGVncmF0aW9uMQ== */
      node_id: string;
      owner: components["schemas"]["nullable-simple-user"];
      /**
       * @description The name of the GitHub app
       * @example Probot Owners
       */
      name: string;
      /** @example The description of the app. */
      description: string | null;
      /**
       * Format: uri
       * @example https://example.com
       */
      external_url: string;
      /**
       * Format: uri
       * @example https://github.com/apps/super-ci
       */
      html_url: string;
      /**
       * Format: date-time
       * @example 2017-07-08T16:18:44-04:00
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2017-07-08T16:18:44-04:00
       */
      updated_at: string;
      /**
       * @description The set of permissions for the GitHub app
       * @example {
       *   "issues": "read",
       *   "deployments": "write"
       * }
       */
      permissions: {
        issues?: string;
        checks?: string;
        metadata?: string;
        contents?: string;
        deployments?: string;
        [key: string]: string | undefined;
      };
      /**
       * @description The list of events for the GitHub app
       * @example [
       *   "label",
       *   "deployment"
       * ]
       */
      events: string[];
      /**
       * @description The number of installations associated with the GitHub app
       * @example 5
       */
      installations_count?: number;
      /** @example "Iv1.25b5d1e65ffc4022" */
      client_id?: string;
      /** @example "1d4b2097ac622ba702d19de498f005747a8b21d3" */
      client_secret?: string;
      /** @example "6fba8f2fc8a7e8f2cca5577eddd82ca7586b3b6b" */
      webhook_secret?: string | null;
      /** @example "-----BEGIN RSA PRIVATE KEY-----\nMIIEogIBAAKCAQEArYxrNYD/iT5CZVpRJu4rBKmmze3PVmT/gCo2ATUvDvZTPTey\nxcGJ3vvrJXazKk06pN05TN29o98jrYz4cengG3YGsXPNEpKsIrEl8NhbnxapEnM9\nJCMRe0P5JcPsfZlX6hmiT7136GRWiGOUba2X9+HKh8QJVLG5rM007TBER9/z9mWm\nrJuNh+m5l320oBQY/Qq3A7wzdEfZw8qm/mIN0FCeoXH1L6B8xXWaAYBwhTEh6SSn\nZHlO1Xu1JWDmAvBCi0RO5aRSKM8q9QEkvvHP4yweAtK3N8+aAbZ7ovaDhyGz8r6r\nzhU1b8Uo0Z2ysf503WqzQgIajr7Fry7/kUwpgQIDAQABAoIBADwJp80Ko1xHPZDy\nfcCKBDfIuPvkmSW6KumbsLMaQv1aGdHDwwTGv3t0ixSay8CGlxMRtRDyZPib6SvQ\n6OH/lpfpbMdW2ErkksgtoIKBVrDilfrcAvrNZu7NxRNbhCSvN8q0s4ICecjbbVQh\nnueSdlA6vGXbW58BHMq68uRbHkP+k+mM9U0mDJ1HMch67wlg5GbayVRt63H7R2+r\nVxcna7B80J/lCEjIYZznawgiTvp3MSanTglqAYi+m1EcSsP14bJIB9vgaxS79kTu\noiSo93leJbBvuGo8QEiUqTwMw4tDksmkLsoqNKQ1q9P7LZ9DGcujtPy4EZsamSJT\ny8OJt0ECgYEA2lxOxJsQk2kI325JgKFjo92mQeUObIvPfSNWUIZQDTjniOI6Gv63\nGLWVFrZcvQBWjMEQraJA9xjPbblV8PtfO87MiJGLWCHFxmPz2dzoedN+2Coxom8m\nV95CLz8QUShuao6u/RYcvUaZEoYs5bHcTmy5sBK80JyEmafJPtCQVxMCgYEAy3ar\nZr3yv4xRPEPMat4rseswmuMooSaK3SKub19WFI5IAtB/e7qR1Rj9JhOGcZz+OQrl\nT78O2OFYlgOIkJPvRMrPpK5V9lslc7tz1FSh3BZMRGq5jSyD7ETSOQ0c8T2O/s7v\nbeEPbVbDe4mwvM24XByH0GnWveVxaDl51ABD65sCgYB3ZAspUkOA5egVCh8kNpnd\nSd6SnuQBE3ySRlT2WEnCwP9Ph6oPgn+oAfiPX4xbRqkL8q/k0BdHQ4h+zNwhk7+h\nWtPYRAP1Xxnc/F+jGjb+DVaIaKGU18MWPg7f+FI6nampl3Q0KvfxwX0GdNhtio8T\nTj1E+SnFwh56SRQuxSh2gwKBgHKjlIO5NtNSflsUYFM+hyQiPiqnHzddfhSG+/3o\nm5nNaSmczJesUYreH5San7/YEy2UxAugvP7aSY2MxB+iGsiJ9WD2kZzTUlDZJ7RV\nUzWsoqBR+eZfVJ2FUWWvy8TpSG6trh4dFxImNtKejCR1TREpSiTV3Zb1dmahK9GV\nrK9NAoGAbBxRLoC01xfxCTgt5BDiBcFVh4fp5yYKwavJPLzHSpuDOrrI9jDn1oKN\nonq5sDU1i391zfQvdrbX4Ova48BN+B7p63FocP/MK5tyyBoT8zQEk2+vWDOw7H/Z\nu5dTCPxTIsoIwUw1I+7yIxqJzLPFgR2gVBwY1ra/8iAqCj+zeBw=\n-----END RSA PRIVATE KEY-----\n" */
      pem?: string;
    };
    /**
     * Basic Error
     * @description Basic Error
     */
    "basic-error": {
      message?: string;
      documentation_url?: string;
      url?: string;
      status?: string;
    };
    /**
     * Validation Error Simple
     * @description Validation Error Simple
     */
    "validation-error-simple": {
      message: string;
      documentation_url: string;
      errors?: string[];
    };
    /**
     * Format: uri
     * @description The URL to which the payloads will be delivered.
     * @example https://example.com/webhook
     */
    "webhook-config-url": string;
    /**
     * @description The media type used to serialize the payloads. Supported values include `json` and `form`. The default is `form`.
     * @example "json"
     */
    "webhook-config-content-type": string;
    /**
     * @description If provided, the `secret` will be used as the `key` to generate the HMAC hex digest value for [delivery signature headers](https://docs.github.com/webhooks/event-payloads/#delivery-headers).
     * @example "********"
     */
    "webhook-config-secret": string;
    "webhook-config-insecure-ssl": string | number;
    /**
     * Webhook Configuration
     * @description Configuration object of the webhook
     */
    "webhook-config": {
      url?: components["schemas"]["webhook-config-url"];
      content_type?: components["schemas"]["webhook-config-content-type"];
      secret?: components["schemas"]["webhook-config-secret"];
      insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
    };
    /**
     * Simple webhook delivery
     * @description Delivery made by a webhook, without request and response information.
     */
    "hook-delivery-item": {
      /**
       * @description Unique identifier of the webhook delivery.
       * @example 42
       */
      id: number;
      /**
       * @description Unique identifier for the event (shared with all deliveries for all webhooks that subscribe to this event).
       * @example 58474f00-b361-11eb-836d-0e4f3503ccbe
       */
      guid: string;
      /**
       * Format: date-time
       * @description Time when the webhook delivery occurred.
       * @example 2021-05-12T20:33:44Z
       */
      delivered_at: string;
      /**
       * @description Whether the webhook delivery is a redelivery.
       * @example false
       */
      redelivery: boolean;
      /**
       * @description Time spent delivering.
       * @example 0.03
       */
      duration: number;
      /**
       * @description Describes the response returned after attempting the delivery.
       * @example failed to connect
       */
      status: string;
      /**
       * @description Status code received when delivery was made.
       * @example 502
       */
      status_code: number;
      /**
       * @description The event that triggered the delivery.
       * @example issues
       */
      event: string;
      /**
       * @description The type of activity for the event that triggered the delivery.
       * @example opened
       */
      action: string | null;
      /**
       * @description The id of the GitHub App installation associated with this event.
       * @example 123
       */
      installation_id: number | null;
      /**
       * @description The id of the repository associated with this event.
       * @example 123
       */
      repository_id: number | null;
    };
    /**
     * Scim Error
     * @description Scim Error
     */
    "scim-error": {
      message?: string | null;
      documentation_url?: string | null;
      detail?: string | null;
      status?: number;
      scimType?: string | null;
      schemas?: string[];
    };
    /**
     * Validation Error
     * @description Validation Error
     */
    "validation-error": {
      message: string;
      documentation_url: string;
      errors?: {
        resource?: string;
        field?: string;
        message?: string;
        code: string;
        index?: number;
        value?: (string | null) | (number | null) | (string[] | null);
      }[];
    };
    /**
     * Webhook delivery
     * @description Delivery made by a webhook.
     */
    "hook-delivery": {
      /**
       * @description Unique identifier of the delivery.
       * @example 42
       */
      id: number;
      /**
       * @description Unique identifier for the event (shared with all deliveries for all webhooks that subscribe to this event).
       * @example 58474f00-b361-11eb-836d-0e4f3503ccbe
       */
      guid: string;
      /**
       * Format: date-time
       * @description Time when the delivery was delivered.
       * @example 2021-05-12T20:33:44Z
       */
      delivered_at: string;
      /**
       * @description Whether the delivery is a redelivery.
       * @example false
       */
      redelivery: boolean;
      /**
       * @description Time spent delivering.
       * @example 0.03
       */
      duration: number;
      /**
       * @description Description of the status of the attempted delivery
       * @example failed to connect
       */
      status: string;
      /**
       * @description Status code received when delivery was made.
       * @example 502
       */
      status_code: number;
      /**
       * @description The event that triggered the delivery.
       * @example issues
       */
      event: string;
      /**
       * @description The type of activity for the event that triggered the delivery.
       * @example opened
       */
      action: string | null;
      /**
       * @description The id of the GitHub App installation associated with this event.
       * @example 123
       */
      installation_id: number | null;
      /**
       * @description The id of the repository associated with this event.
       * @example 123
       */
      repository_id: number | null;
      /**
       * @description The URL target of the delivery.
       * @example https://www.example.com
       */
      url?: string;
      request: {
        /** @description The request headers sent with the webhook delivery. */
        headers: {
          [key: string]: unknown;
        } | null;
        /** @description The webhook payload. */
        payload: {
          [key: string]: unknown;
        } | null;
      };
      response: {
        /** @description The response headers received when the delivery was made. */
        headers: {
          [key: string]: unknown;
        } | null;
        /** @description The response payload received. */
        payload: string | null;
      };
    };
    /**
     * Simple User
     * @description A GitHub user.
     */
    "simple-user": {
      name?: string | null;
      email?: string | null;
      /** @example octocat */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDQ6VXNlcjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/images/error/octocat_happy.gif
       */
      avatar_url: string;
      /** @example 41d064eb2195891e12d0413f63227ea7 */
      gravatar_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/followers
       */
      followers_url: string;
      /** @example https://api.github.com/users/octocat/following{/other_user} */
      following_url: string;
      /** @example https://api.github.com/users/octocat/gists{/gist_id} */
      gists_url: string;
      /** @example https://api.github.com/users/octocat/starred{/owner}{/repo} */
      starred_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/subscriptions
       */
      subscriptions_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/orgs
       */
      organizations_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repos_url: string;
      /** @example https://api.github.com/users/octocat/events{/privacy} */
      events_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/received_events
       */
      received_events_url: string;
      /** @example User */
      type: string;
      site_admin: boolean;
      /** @example "2020-07-09T00:17:55Z" */
      starred_at?: string;
    };
    /**
     * Enterprise
     * @description An enterprise on GitHub.
     */
    enterprise: {
      /** @description A short description of the enterprise. */
      description?: string | null;
      /**
       * Format: uri
       * @example https://github.com/enterprises/octo-business
       */
      html_url: string;
      /**
       * Format: uri
       * @description The enterprise's website URL.
       */
      website_url?: string | null;
      /**
       * @description Unique identifier of the enterprise
       * @example 42
       */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /**
       * @description The name of the enterprise.
       * @example Octo Business
       */
      name: string;
      /**
       * @description The slug url identifier for the enterprise.
       * @example octo-business
       */
      slug: string;
      /**
       * Format: date-time
       * @example 2019-01-26T19:01:12Z
       */
      created_at: string | null;
      /**
       * Format: date-time
       * @example 2019-01-26T19:14:43Z
       */
      updated_at: string | null;
      /** Format: uri */
      avatar_url: string;
    };
    /**
     * Integration Installation Request
     * @description Request to install an integration on a target
     */
    "integration-installation-request": {
      /**
       * @description Unique identifier of the request installation.
       * @example 42
       */
      id: number;
      /** @example MDExOkludGVncmF0aW9uMQ== */
      node_id?: string;
      account:
        | components["schemas"]["simple-user"]
        | components["schemas"]["enterprise"];
      requester: components["schemas"]["simple-user"];
      /**
       * Format: date-time
       * @example 2022-07-08T16:18:44-04:00
       */
      created_at: string;
    };
    /**
     * App Permissions
     * @description The permissions granted to the user-to-server access token.
     * @example {
     *   "contents": "read",
     *   "issues": "read",
     *   "deployments": "write",
     *   "single_file": "read"
     * }
     */
    "app-permissions": {
      /**
       * @description The level of permission to grant the access token for GitHub Actions workflows, workflow runs, and artifacts.
       * @enum {string}
       */
      actions?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for repository creation, deletion, settings, teams, and collaborators creation.
       * @enum {string}
       */
      administration?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for checks on code.
       * @enum {string}
       */
      checks?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for repository contents, commits, branches, downloads, releases, and merges.
       * @enum {string}
       */
      contents?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for deployments and deployment statuses.
       * @enum {string}
       */
      deployments?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for managing repository environments.
       * @enum {string}
       */
      environments?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for issues and related comments, assignees, labels, and milestones.
       * @enum {string}
       */
      issues?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to search repositories, list collaborators, and access repository metadata.
       * @enum {string}
       */
      metadata?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for packages published to GitHub Packages.
       * @enum {string}
       */
      packages?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to retrieve Pages statuses, configuration, and builds, as well as create new builds.
       * @enum {string}
       */
      pages?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for pull requests and related comments, assignees, labels, milestones, and merges.
       * @enum {string}
       */
      pull_requests?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage the post-receive hooks for a repository.
       * @enum {string}
       */
      repository_hooks?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage repository projects, columns, and cards.
       * @enum {string}
       */
      repository_projects?: "read" | "write" | "admin";
      /**
       * @description The level of permission to grant the access token to view and manage secret scanning alerts.
       * @enum {string}
       */
      secret_scanning_alerts?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage repository secrets.
       * @enum {string}
       */
      secrets?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to view and manage security events like code scanning alerts.
       * @enum {string}
       */
      security_events?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage just a single file.
       * @enum {string}
       */
      single_file?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for commit statuses.
       * @enum {string}
       */
      statuses?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage Dependabot alerts.
       * @enum {string}
       */
      vulnerability_alerts?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to update GitHub Actions workflow files.
       * @enum {string}
       */
      workflows?: "write";
      /**
       * @description The level of permission to grant the access token for organization teams and members.
       * @enum {string}
       */
      members?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage access to an organization.
       * @enum {string}
       */
      organization_administration?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for custom repository roles management. This property is in beta and is subject to change.
       * @enum {string}
       */
      organization_custom_roles?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to view and manage announcement banners for an organization.
       * @enum {string}
       */
      organization_announcement_banners?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage the post-receive hooks for an organization.
       * @enum {string}
       */
      organization_hooks?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for viewing and managing fine-grained personal access token requests to an organization.
       * @enum {string}
       */
      organization_personal_access_tokens?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for viewing and managing fine-grained personal access tokens that have been approved by an organization.
       * @enum {string}
       */
      organization_personal_access_token_requests?: "read" | "write";
      /**
       * @description The level of permission to grant the access token for viewing an organization's plan.
       * @enum {string}
       */
      organization_plan?: "read";
      /**
       * @description The level of permission to grant the access token to manage organization projects and projects beta (where available).
       * @enum {string}
       */
      organization_projects?: "read" | "write" | "admin";
      /**
       * @description The level of permission to grant the access token for organization packages published to GitHub Packages.
       * @enum {string}
       */
      organization_packages?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage organization secrets.
       * @enum {string}
       */
      organization_secrets?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to view and manage GitHub Actions self-hosted runners available to an organization.
       * @enum {string}
       */
      organization_self_hosted_runners?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to view and manage users blocked by the organization.
       * @enum {string}
       */
      organization_user_blocking?: "read" | "write";
      /**
       * @description The level of permission to grant the access token to manage team discussions and related comments.
       * @enum {string}
       */
      team_discussions?: "read" | "write";
    };
    /**
     * Installation
     * @description Installation
     */
    installation: {
      /**
       * @description The ID of the installation.
       * @example 1
       */
      id: number;
      account:
        | (
            | components["schemas"]["simple-user"]
            | components["schemas"]["enterprise"]
          )
        | null;
      /**
       * @description Describe whether all repositories have been selected or there's a selection involved
       * @enum {string}
       */
      repository_selection: "all" | "selected";
      /**
       * Format: uri
       * @example https://api.github.com/installations/1/access_tokens
       */
      access_tokens_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/installation/repositories
       */
      repositories_url: string;
      /**
       * Format: uri
       * @example https://github.com/organizations/github/settings/installations/1
       */
      html_url: string;
      /** @example 1 */
      app_id: number;
      /** @description The ID of the user or organization this token is being scoped to. */
      target_id: number;
      /** @example Organization */
      target_type: string;
      permissions: components["schemas"]["app-permissions"];
      events: string[];
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      /** @example config.yaml */
      single_file_name: string | null;
      /** @example true */
      has_multiple_single_files?: boolean;
      /**
       * @example [
       *   "config.yml",
       *   ".github/issue_TEMPLATE.md"
       * ]
       */
      single_file_paths?: string[];
      /** @example github-actions */
      app_slug: string;
      suspended_by: components["schemas"]["nullable-simple-user"];
      /** Format: date-time */
      suspended_at: string | null;
      /** @example "test_13f1e99741e3e004@d7e1eb0bc0a1ba12.com" */
      contact_email?: string | null;
    };
    /**
     * License Simple
     * @description License Simple
     */
    "nullable-license-simple": {
      /** @example mit */
      key: string;
      /** @example MIT License */
      name: string;
      /**
       * Format: uri
       * @example https://api.github.com/licenses/mit
       */
      url: string | null;
      /** @example MIT */
      spdx_id: string | null;
      /** @example MDc6TGljZW5zZW1pdA== */
      node_id: string;
      /** Format: uri */
      html_url?: string;
    } | null;
    /**
     * Repository
     * @description A repository on GitHub.
     */
    repository: {
      /**
       * @description Unique identifier of the repository
       * @example 42
       */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /**
       * @description The name of the repository.
       * @example Team Environment
       */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      license: components["schemas"]["nullable-license-simple"];
      organization?: components["schemas"]["nullable-simple-user"];
      forks: number;
      permissions?: {
        admin: boolean;
        pull: boolean;
        triage?: boolean;
        push: boolean;
        maintain?: boolean;
      };
      owner: components["schemas"]["simple-user"];
      /**
       * @description Whether the repository is private or public.
       * @default false
       */
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      /** @example git:github.com/octocat/Hello-World.git */
      git_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      /** @example git@github.com:octocat/Hello-World.git */
      ssh_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      /** @example https://github.com/octocat/Hello-World.git */
      clone_url: string;
      /**
       * Format: uri
       * @example git:git.example.com/octocat/Hello-World
       */
      mirror_url: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      /**
       * Format: uri
       * @example https://svn.github.com/octocat/Hello-World
       */
      svn_url: string;
      /**
       * Format: uri
       * @example https://github.com
       */
      homepage: string | null;
      language: string | null;
      /** @example 9 */
      forks_count: number;
      /** @example 80 */
      stargazers_count: number;
      /** @example 80 */
      watchers_count: number;
      /**
       * @description The size of the repository. Size is calculated hourly. When a repository is initially created, the size is 0.
       * @example 108
       */
      size: number;
      /**
       * @description The default branch of the repository.
       * @example master
       */
      default_branch: string;
      /** @example 0 */
      open_issues_count: number;
      /**
       * @description Whether this repository acts as a template that can be used to generate new repositories.
       * @default false
       * @example true
       */
      is_template?: boolean;
      topics?: string[];
      /**
       * @description Whether issues are enabled.
       * @default true
       * @example true
       */
      has_issues: boolean;
      /**
       * @description Whether projects are enabled.
       * @default true
       * @example true
       */
      has_projects: boolean;
      /**
       * @description Whether the wiki is enabled.
       * @default true
       * @example true
       */
      has_wiki: boolean;
      has_pages: boolean;
      /**
       * @description Whether downloads are enabled.
       * @default true
       * @example true
       */
      has_downloads: boolean;
      /**
       * @description Whether discussions are enabled.
       * @default false
       * @example true
       */
      has_discussions?: boolean;
      /**
       * @description Whether the repository is archived.
       * @default false
       */
      archived: boolean;
      /** @description Returns whether or not this repository disabled. */
      disabled: boolean;
      /**
       * @description The repository visibility: public, private, or internal.
       * @default public
       */
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at: string | null;
      /**
       * @description Whether to allow rebase merges for pull requests.
       * @default true
       * @example true
       */
      allow_rebase_merge?: boolean;
      template_repository?: {
        id?: number;
        node_id?: string;
        name?: string;
        full_name?: string;
        owner?: {
          login?: string;
          id?: number;
          node_id?: string;
          avatar_url?: string;
          gravatar_id?: string;
          url?: string;
          html_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          starred_url?: string;
          subscriptions_url?: string;
          organizations_url?: string;
          repos_url?: string;
          events_url?: string;
          received_events_url?: string;
          type?: string;
          site_admin?: boolean;
        };
        private?: boolean;
        html_url?: string;
        description?: string;
        fork?: boolean;
        url?: string;
        archive_url?: string;
        assignees_url?: string;
        blobs_url?: string;
        branches_url?: string;
        collaborators_url?: string;
        comments_url?: string;
        commits_url?: string;
        compare_url?: string;
        contents_url?: string;
        contributors_url?: string;
        deployments_url?: string;
        downloads_url?: string;
        events_url?: string;
        forks_url?: string;
        git_commits_url?: string;
        git_refs_url?: string;
        git_tags_url?: string;
        git_url?: string;
        issue_comment_url?: string;
        issue_events_url?: string;
        issues_url?: string;
        keys_url?: string;
        labels_url?: string;
        languages_url?: string;
        merges_url?: string;
        milestones_url?: string;
        notifications_url?: string;
        pulls_url?: string;
        releases_url?: string;
        ssh_url?: string;
        stargazers_url?: string;
        statuses_url?: string;
        subscribers_url?: string;
        subscription_url?: string;
        tags_url?: string;
        teams_url?: string;
        trees_url?: string;
        clone_url?: string;
        mirror_url?: string;
        hooks_url?: string;
        svn_url?: string;
        homepage?: string;
        language?: string;
        forks_count?: number;
        stargazers_count?: number;
        watchers_count?: number;
        size?: number;
        default_branch?: string;
        open_issues_count?: number;
        is_template?: boolean;
        topics?: string[];
        has_issues?: boolean;
        has_projects?: boolean;
        has_wiki?: boolean;
        has_pages?: boolean;
        has_downloads?: boolean;
        archived?: boolean;
        disabled?: boolean;
        visibility?: string;
        pushed_at?: string;
        created_at?: string;
        updated_at?: string;
        permissions?: {
          admin?: boolean;
          maintain?: boolean;
          push?: boolean;
          triage?: boolean;
          pull?: boolean;
        };
        allow_rebase_merge?: boolean;
        temp_clone_token?: string;
        allow_squash_merge?: boolean;
        allow_auto_merge?: boolean;
        delete_branch_on_merge?: boolean;
        allow_update_branch?: boolean;
        use_squash_pr_title_as_default?: boolean;
        /**
         * @description The default value for a squash merge commit title:
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description The default value for a squash merge commit message:
         *
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a merge commit message.
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        allow_merge_commit?: boolean;
        subscribers_count?: number;
        network_count?: number;
      } | null;
      temp_clone_token?: string;
      /**
       * @description Whether to allow squash merges for pull requests.
       * @default true
       * @example true
       */
      allow_squash_merge?: boolean;
      /**
       * @description Whether to allow Auto-merge to be used on pull requests.
       * @default false
       * @example false
       */
      allow_auto_merge?: boolean;
      /**
       * @description Whether to delete head branches when pull requests are merged
       * @default false
       * @example false
       */
      delete_branch_on_merge?: boolean;
      /**
       * @description Whether or not a pull request head branch that is behind its base branch can always be updated even if it is not required to be up to date before merging.
       * @default false
       * @example false
       */
      allow_update_branch?: boolean;
      /**
       * @deprecated
       * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
       * @default false
       */
      use_squash_pr_title_as_default?: boolean;
      /**
       * @description The default value for a squash merge commit title:
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
       * @enum {string}
       */
      squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
      /**
       * @description The default value for a squash merge commit message:
       *
       * - `PR_BODY` - default to the pull request's body.
       * - `COMMIT_MESSAGES` - default to the branch's commit messages.
       * - `BLANK` - default to a blank commit message.
       * @enum {string}
       */
      squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
      /**
       * @description The default value for a merge commit title.
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
       * @enum {string}
       */
      merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
      /**
       * @description The default value for a merge commit message.
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `PR_BODY` - default to the pull request's body.
       * - `BLANK` - default to a blank commit message.
       * @enum {string}
       */
      merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
      /**
       * @description Whether to allow merge commits for pull requests.
       * @default true
       * @example true
       */
      allow_merge_commit?: boolean;
      /** @description Whether to allow forking this repo */
      allow_forking?: boolean;
      /**
       * @description Whether to require contributors to sign off on web-based commits
       * @default false
       */
      web_commit_signoff_required?: boolean;
      subscribers_count?: number;
      network_count?: number;
      open_issues: number;
      watchers: number;
      master_branch?: string;
      /** @example "2020-07-09T00:17:42Z" */
      starred_at?: string;
      /** @description Whether anonymous git access is enabled for this repository */
      anonymous_access_enabled?: boolean;
    };
    /**
     * Installation Token
     * @description Authentication token for a GitHub App installed on a user or org.
     */
    "installation-token": {
      token: string;
      expires_at: string;
      permissions?: components["schemas"]["app-permissions"];
      /** @enum {string} */
      repository_selection?: "all" | "selected";
      repositories?: components["schemas"]["repository"][];
      /** @example README.md */
      single_file?: string;
      /** @example true */
      has_multiple_single_files?: boolean;
      /**
       * @example [
       *   "config.yml",
       *   ".github/issue_TEMPLATE.md"
       * ]
       */
      single_file_paths?: string[];
    };
    /** Scoped Installation */
    "nullable-scoped-installation": {
      permissions: components["schemas"]["app-permissions"];
      /**
       * @description Describe whether all repositories have been selected or there's a selection involved
       * @enum {string}
       */
      repository_selection: "all" | "selected";
      /** @example config.yaml */
      single_file_name: string | null;
      /** @example true */
      has_multiple_single_files?: boolean;
      /**
       * @example [
       *   "config.yml",
       *   ".github/issue_TEMPLATE.md"
       * ]
       */
      single_file_paths?: string[];
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repositories_url: string;
      account: components["schemas"]["simple-user"];
    } | null;
    /**
     * Authorization
     * @description The authorization for an OAuth app, GitHub App, or a Personal Access Token.
     */
    authorization: {
      id: number;
      /** Format: uri */
      url: string;
      /** @description A list of scopes that this authorization is in. */
      scopes: string[] | null;
      token: string;
      token_last_eight: string | null;
      hashed_token: string | null;
      app: {
        client_id: string;
        name: string;
        /** Format: uri */
        url: string;
      };
      note: string | null;
      /** Format: uri */
      note_url: string | null;
      /** Format: date-time */
      updated_at: string;
      /** Format: date-time */
      created_at: string;
      fingerprint: string | null;
      user?: components["schemas"]["nullable-simple-user"];
      installation?: components["schemas"]["nullable-scoped-installation"];
      /** Format: date-time */
      expires_at: string | null;
    };
    /**
     * Code Of Conduct
     * @description Code Of Conduct
     */
    "code-of-conduct": {
      /** @example contributor_covenant */
      key: string;
      /** @example Contributor Covenant */
      name: string;
      /**
       * Format: uri
       * @example https://api.github.com/codes_of_conduct/contributor_covenant
       */
      url: string;
      /**
       * @example # Contributor Covenant Code of Conduct
       *
       * ## Our Pledge
       *
       * In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation.
       *
       * ## Our Standards
       *
       * Examples of behavior that contributes to creating a positive environment include:
       *
       * * Using welcoming and inclusive language
       * * Being respectful of differing viewpoints and experiences
       * * Gracefully accepting constructive criticism
       * * Focusing on what is best for the community
       * * Showing empathy towards other community members
       *
       * Examples of unacceptable behavior by participants include:
       *
       * * The use of sexualized language or imagery and unwelcome sexual attention or advances
       * * Trolling, insulting/derogatory comments, and personal or political attacks
       * * Public or private harassment
       * * Publishing others' private information, such as a physical or electronic address, without explicit permission
       * * Other conduct which could reasonably be considered inappropriate in a professional setting
       *
       * ## Our Responsibilities
       *
       * Project maintainers are responsible for clarifying the standards of acceptable behavior and are expected to take appropriate and fair corrective action in response
       *                   to any instances of unacceptable behavior.
       *
       * Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, or to ban temporarily or permanently any contributor for other behaviors that they deem inappropriate, threatening, offensive, or harmful.
       *
       * ## Scope
       *
       * This Code of Conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Examples of representing a project or community include using an official project e-mail address,
       *                   posting via an official social media account, or acting as an appointed representative at an online or offline event. Representation of a project may be further defined and clarified by project maintainers.
       *
       * ## Enforcement
       *
       * Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by contacting the project team at [EMAIL]. The project team will review and investigate all complaints, and will respond in a way that it deems appropriate to the circumstances. The project team is obligated to maintain confidentiality with regard to the reporter of an incident. Further details of specific enforcement policies may be posted separately.
       *
       * Project maintainers who do not follow or enforce the Code of Conduct in good faith may face temporary or permanent repercussions as determined by other members of the project's leadership.
       *
       * ## Attribution
       *
       * This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4, available at [http://contributor-covenant.org/version/1/4][version]
       *
       * [homepage]: http://contributor-covenant.org
       * [version]: http://contributor-covenant.org/version/1/4/
       */
      body?: string;
      /** Format: uri */
      html_url: string | null;
    };
    /** @description The security alert number. */
    readonly "alert-number": number;
    /** @description Details for the vulnerable package. */
    readonly "dependabot-alert-package": {
      /** @description The package's language or package management ecosystem. */
      readonly ecosystem: string;
      /** @description The unique package name within its ecosystem. */
      readonly name: string;
    };
    /** @description Details pertaining to one vulnerable version range for the advisory. */
    readonly "dependabot-alert-security-vulnerability": {
      readonly package: components["schemas"]["dependabot-alert-package"];
      /**
       * @description The severity of the vulnerability.
       * @enum {string}
       */
      readonly severity: "low" | "medium" | "high" | "critical";
      /** @description Conditions that identify vulnerable versions of this vulnerability's package. */
      readonly vulnerable_version_range: string;
      /** @description Details pertaining to the package version that patches this vulnerability. */
      readonly first_patched_version: {
        /** @description The package version that patches this vulnerability. */
        readonly identifier: string;
      } | null;
    };
    /** @description Details for the GitHub Security Advisory. */
    readonly "dependabot-alert-security-advisory": {
      /** @description The unique GitHub Security Advisory ID assigned to the advisory. */
      readonly ghsa_id: string;
      /** @description The unique CVE ID assigned to the advisory. */
      readonly cve_id: string | null;
      /** @description A short, plain text summary of the advisory. */
      readonly summary: string;
      /** @description A long-form Markdown-supported description of the advisory. */
      readonly description: string;
      /** @description Vulnerable version range information for the advisory. */
      readonly vulnerabilities: readonly components["schemas"]["dependabot-alert-security-vulnerability"][];
      /**
       * @description The severity of the advisory.
       * @enum {string}
       */
      readonly severity: "low" | "medium" | "high" | "critical";
      /** @description Details for the advisory pertaining to the Common Vulnerability Scoring System. */
      readonly cvss: {
        /** @description The overall CVSS score of the advisory. */
        readonly score: number;
        /** @description The full CVSS vector string for the advisory. */
        readonly vector_string: string | null;
      };
      /** @description Details for the advisory pertaining to Common Weakness Enumeration. */
      readonly cwes: readonly {
        /** @description The unique CWE ID. */
        readonly cwe_id: string;
        /** @description The short, plain text name of the CWE. */
        readonly name: string;
      }[];
      /** @description Values that identify this advisory among security information sources. */
      readonly identifiers: readonly {
        /**
         * @description The type of advisory identifier.
         * @enum {string}
         */
        readonly type: "CVE" | "GHSA";
        /** @description The value of the advisory identifer. */
        readonly value: string;
      }[];
      /** @description Links to additional advisory information. */
      readonly references: readonly {
        /**
         * Format: uri
         * @description The URL of the reference.
         */
        readonly url: string;
      }[];
      /**
       * Format: date-time
       * @description The time that the advisory was published in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      readonly published_at: string;
      /**
       * Format: date-time
       * @description The time that the advisory was last modified in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      readonly updated_at: string;
      /**
       * Format: date-time
       * @description The time that the advisory was withdrawn in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      readonly withdrawn_at: string | null;
    };
    /**
     * Format: uri
     * @description The REST API URL of the alert resource.
     */
    readonly "alert-url": string;
    /**
     * Format: uri
     * @description The GitHub URL of the alert resource.
     */
    readonly "alert-html-url": string;
    /**
     * Format: date-time
     * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "alert-created-at": string;
    /**
     * Format: date-time
     * @description The time that the alert was last updated in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "alert-updated-at": string;
    /**
     * Format: date-time
     * @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "alert-dismissed-at": string | null;
    /**
     * Format: date-time
     * @description The time that the alert was no longer detected and was considered fixed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "alert-fixed-at": string | null;
    /**
     * Format: date-time
     * @description The time that the alert was auto-dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "alert-auto-dismissed-at": string | null;
    /**
     * Simple Repository
     * @description A GitHub repository.
     */
    "simple-repository": {
      /**
       * @description A unique identifier of the repository.
       * @example 1296269
       */
      id: number;
      /**
       * @description The GraphQL identifier of the repository.
       * @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5
       */
      node_id: string;
      /**
       * @description The name of the repository.
       * @example Hello-World
       */
      name: string;
      /**
       * @description The full, globally unique, name of the repository.
       * @example octocat/Hello-World
       */
      full_name: string;
      owner: components["schemas"]["simple-user"];
      /** @description Whether the repository is private. */
      private: boolean;
      /**
       * Format: uri
       * @description The URL to view the repository on GitHub.com.
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /**
       * @description The repository description.
       * @example This your first repo!
       */
      description: string | null;
      /** @description Whether the repository is a fork. */
      fork: boolean;
      /**
       * Format: uri
       * @description The URL to get more information about the repository from the GitHub API.
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /**
       * @description A template for the API URL to download the repository as an archive.
       * @example https://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref}
       */
      archive_url: string;
      /**
       * @description A template for the API URL to list the available assignees for issues in the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/assignees{/user}
       */
      assignees_url: string;
      /**
       * @description A template for the API URL to create or retrieve a raw Git blob in the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/git/blobs{/sha}
       */
      blobs_url: string;
      /**
       * @description A template for the API URL to get information about branches in the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/branches{/branch}
       */
      branches_url: string;
      /**
       * @description A template for the API URL to get information about collaborators of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator}
       */
      collaborators_url: string;
      /**
       * @description A template for the API URL to get information about comments on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/comments{/number}
       */
      comments_url: string;
      /**
       * @description A template for the API URL to get information about commits on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/commits{/sha}
       */
      commits_url: string;
      /**
       * @description A template for the API URL to compare two commits or refs.
       * @example https://api.github.com/repos/octocat/Hello-World/compare/{base}...{head}
       */
      compare_url: string;
      /**
       * @description A template for the API URL to get the contents of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/contents/{+path}
       */
      contents_url: string;
      /**
       * Format: uri
       * @description A template for the API URL to list the contributors to the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @description The API URL to list the deployments of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @description The API URL to list the downloads on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @description The API URL to list the events of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @description The API URL to list the forks of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /**
       * @description A template for the API URL to get information about Git commits of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/git/commits{/sha}
       */
      git_commits_url: string;
      /**
       * @description A template for the API URL to get information about Git refs of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/git/refs{/sha}
       */
      git_refs_url: string;
      /**
       * @description A template for the API URL to get information about Git tags of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/git/tags{/sha}
       */
      git_tags_url: string;
      /**
       * @description A template for the API URL to get information about issue comments on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/issues/comments{/number}
       */
      issue_comment_url: string;
      /**
       * @description A template for the API URL to get information about issue events on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/issues/events{/number}
       */
      issue_events_url: string;
      /**
       * @description A template for the API URL to get information about issues on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/issues{/number}
       */
      issues_url: string;
      /**
       * @description A template for the API URL to get information about deploy keys on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/keys{/key_id}
       */
      keys_url: string;
      /**
       * @description A template for the API URL to get information about labels of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/labels{/name}
       */
      labels_url: string;
      /**
       * Format: uri
       * @description The API URL to get information about the languages of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @description The API URL to merge branches in the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /**
       * @description A template for the API URL to get information about milestones of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/milestones{/number}
       */
      milestones_url: string;
      /**
       * @description A template for the API URL to get information about notifications on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating}
       */
      notifications_url: string;
      /**
       * @description A template for the API URL to get information about pull requests on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/pulls{/number}
       */
      pulls_url: string;
      /**
       * @description A template for the API URL to get information about releases on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/releases{/id}
       */
      releases_url: string;
      /**
       * Format: uri
       * @description The API URL to list the stargazers on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /**
       * @description A template for the API URL to get information about statuses of a commit.
       * @example https://api.github.com/repos/octocat/Hello-World/statuses/{sha}
       */
      statuses_url: string;
      /**
       * Format: uri
       * @description The API URL to list the subscribers on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @description The API URL to subscribe to notifications for this repository.
       * @example https://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @description The API URL to get information about tags on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @description The API URL to list the teams on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /**
       * @description A template for the API URL to create or retrieve a raw Git tree of the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/git/trees{/sha}
       */
      trees_url: string;
      /**
       * Format: uri
       * @description The API URL to list the hooks on the repository.
       * @example https://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
    };
    /** @description A Dependabot alert. */
    "dependabot-alert-with-repository": {
      number: components["schemas"]["alert-number"];
      /**
       * @description The state of the Dependabot alert.
       * @enum {string}
       */
      state: "auto_dismissed" | "dismissed" | "fixed" | "open";
      /** @description Details for the vulnerable dependency. */
      dependency: {
        readonly package?: components["schemas"]["dependabot-alert-package"];
        /** @description The full path to the dependency manifest file, relative to the root of the repository. */
        readonly manifest_path?: string;
        /**
         * @description The execution scope of the vulnerable dependency.
         * @enum {string|null}
         */
        readonly scope?: "development" | "runtime" | null;
      };
      security_advisory: components["schemas"]["dependabot-alert-security-advisory"];
      security_vulnerability: components["schemas"]["dependabot-alert-security-vulnerability"];
      url: components["schemas"]["alert-url"];
      html_url: components["schemas"]["alert-html-url"];
      created_at: components["schemas"]["alert-created-at"];
      updated_at: components["schemas"]["alert-updated-at"];
      dismissed_at: components["schemas"]["alert-dismissed-at"];
      dismissed_by: components["schemas"]["nullable-simple-user"];
      /**
       * @description The reason that the alert was dismissed.
       * @enum {string|null}
       */
      dismissed_reason:
        | "fix_started"
        | "inaccurate"
        | "no_bandwidth"
        | "not_used"
        | "tolerable_risk"
        | null;
      /** @description An optional comment associated with the alert's dismissal. */
      dismissed_comment: string | null;
      fixed_at: components["schemas"]["alert-fixed-at"];
      auto_dismissed_at?: components["schemas"]["alert-auto-dismissed-at"];
      repository: components["schemas"]["simple-repository"];
    };
    /**
     * Format: date-time
     * @description The time that the alert was last updated in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "nullable-alert-updated-at": string | null;
    /**
     * @description Sets the state of the secret scanning alert. You must provide `resolution` when you set the state to `resolved`.
     * @enum {string}
     */
    "secret-scanning-alert-state": "open" | "resolved";
    /**
     * @description **Required when the `state` is `resolved`.** The reason for resolving the alert.
     * @enum {string|null}
     */
    "secret-scanning-alert-resolution":
      | "false_positive"
      | "wont_fix"
      | "revoked"
      | "used_in_tests"
      | null;
    "organization-secret-scanning-alert": {
      number?: components["schemas"]["alert-number"];
      created_at?: components["schemas"]["alert-created-at"];
      updated_at?: components["schemas"]["nullable-alert-updated-at"];
      url?: components["schemas"]["alert-url"];
      html_url?: components["schemas"]["alert-html-url"];
      /**
       * Format: uri
       * @description The REST API URL of the code locations for this alert.
       */
      locations_url?: string;
      state?: components["schemas"]["secret-scanning-alert-state"];
      resolution?: components["schemas"]["secret-scanning-alert-resolution"];
      /**
       * Format: date-time
       * @description The time that the alert was resolved in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      resolved_at?: string | null;
      resolved_by?: components["schemas"]["nullable-simple-user"];
      /** @description The type of secret that secret scanning detected. */
      secret_type?: string;
      /**
       * @description User-friendly name for the detected secret, matching the `secret_type`.
       * For a list of built-in patterns, see "[Secret scanning patterns](https://docs.github.com/code-security/secret-scanning/secret-scanning-patterns#supported-secrets-for-advanced-security)."
       */
      secret_type_display_name?: string;
      /** @description The secret that was detected. */
      secret?: string;
      repository?: components["schemas"]["simple-repository"];
      /** @description Whether push protection was bypassed for the detected secret. */
      push_protection_bypassed?: boolean | null;
      push_protection_bypassed_by?: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @description The time that push protection was bypassed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      push_protection_bypassed_at?: string | null;
      /** @description The comment that was optionally added when this alert was closed */
      resolution_comment?: string | null;
    };
    /**
     * Actor
     * @description Actor
     */
    actor: {
      id: number;
      login: string;
      display_login?: string;
      gravatar_id: string | null;
      /** Format: uri */
      url: string;
      /** Format: uri */
      avatar_url: string;
    };
    /**
     * Milestone
     * @description A collection of related issues and pull requests.
     */
    "nullable-milestone": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/milestones/1
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/milestones/v1.0
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/milestones/1/labels
       */
      labels_url: string;
      /** @example 1002604 */
      id: number;
      /** @example MDk6TWlsZXN0b25lMTAwMjYwNA== */
      node_id: string;
      /**
       * @description The number of the milestone.
       * @example 42
       */
      number: number;
      /**
       * @description The state of the milestone.
       * @default open
       * @example open
       * @enum {string}
       */
      state: "open" | "closed";
      /**
       * @description The title of the milestone.
       * @example v1.0
       */
      title: string;
      /** @example Tracking milestone for version 1.0 */
      description: string | null;
      creator: components["schemas"]["nullable-simple-user"];
      /** @example 4 */
      open_issues: number;
      /** @example 8 */
      closed_issues: number;
      /**
       * Format: date-time
       * @example 2011-04-10T20:09:31Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2014-03-03T18:58:10Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2013-02-12T13:22:01Z
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @example 2012-10-09T23:39:01Z
       */
      due_on: string | null;
    } | null;
    /**
     * GitHub app
     * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
     */
    "nullable-integration": {
      /**
       * @description Unique identifier of the GitHub app
       * @example 37
       */
      id: number;
      /**
       * @description The slug name of the GitHub app
       * @example probot-owners
       */
      slug?: string;
      /** @example MDExOkludGVncmF0aW9uMQ== */
      node_id: string;
      owner: components["schemas"]["nullable-simple-user"];
      /**
       * @description The name of the GitHub app
       * @example Probot Owners
       */
      name: string;
      /** @example The description of the app. */
      description: string | null;
      /**
       * Format: uri
       * @example https://example.com
       */
      external_url: string;
      /**
       * Format: uri
       * @example https://github.com/apps/super-ci
       */
      html_url: string;
      /**
       * Format: date-time
       * @example 2017-07-08T16:18:44-04:00
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2017-07-08T16:18:44-04:00
       */
      updated_at: string;
      /**
       * @description The set of permissions for the GitHub app
       * @example {
       *   "issues": "read",
       *   "deployments": "write"
       * }
       */
      permissions: {
        issues?: string;
        checks?: string;
        metadata?: string;
        contents?: string;
        deployments?: string;
        [key: string]: string | undefined;
      };
      /**
       * @description The list of events for the GitHub app
       * @example [
       *   "label",
       *   "deployment"
       * ]
       */
      events: string[];
      /**
       * @description The number of installations associated with the GitHub app
       * @example 5
       */
      installations_count?: number;
      /** @example "Iv1.25b5d1e65ffc4022" */
      client_id?: string;
      /** @example "1d4b2097ac622ba702d19de498f005747a8b21d3" */
      client_secret?: string;
      /** @example "6fba8f2fc8a7e8f2cca5577eddd82ca7586b3b6b" */
      webhook_secret?: string | null;
      /** @example "-----BEGIN RSA PRIVATE KEY-----\nMIIEogIBAAKCAQEArYxrNYD/iT5CZVpRJu4rBKmmze3PVmT/gCo2ATUvDvZTPTey\nxcGJ3vvrJXazKk06pN05TN29o98jrYz4cengG3YGsXPNEpKsIrEl8NhbnxapEnM9\nJCMRe0P5JcPsfZlX6hmiT7136GRWiGOUba2X9+HKh8QJVLG5rM007TBER9/z9mWm\nrJuNh+m5l320oBQY/Qq3A7wzdEfZw8qm/mIN0FCeoXH1L6B8xXWaAYBwhTEh6SSn\nZHlO1Xu1JWDmAvBCi0RO5aRSKM8q9QEkvvHP4yweAtK3N8+aAbZ7ovaDhyGz8r6r\nzhU1b8Uo0Z2ysf503WqzQgIajr7Fry7/kUwpgQIDAQABAoIBADwJp80Ko1xHPZDy\nfcCKBDfIuPvkmSW6KumbsLMaQv1aGdHDwwTGv3t0ixSay8CGlxMRtRDyZPib6SvQ\n6OH/lpfpbMdW2ErkksgtoIKBVrDilfrcAvrNZu7NxRNbhCSvN8q0s4ICecjbbVQh\nnueSdlA6vGXbW58BHMq68uRbHkP+k+mM9U0mDJ1HMch67wlg5GbayVRt63H7R2+r\nVxcna7B80J/lCEjIYZznawgiTvp3MSanTglqAYi+m1EcSsP14bJIB9vgaxS79kTu\noiSo93leJbBvuGo8QEiUqTwMw4tDksmkLsoqNKQ1q9P7LZ9DGcujtPy4EZsamSJT\ny8OJt0ECgYEA2lxOxJsQk2kI325JgKFjo92mQeUObIvPfSNWUIZQDTjniOI6Gv63\nGLWVFrZcvQBWjMEQraJA9xjPbblV8PtfO87MiJGLWCHFxmPz2dzoedN+2Coxom8m\nV95CLz8QUShuao6u/RYcvUaZEoYs5bHcTmy5sBK80JyEmafJPtCQVxMCgYEAy3ar\nZr3yv4xRPEPMat4rseswmuMooSaK3SKub19WFI5IAtB/e7qR1Rj9JhOGcZz+OQrl\nT78O2OFYlgOIkJPvRMrPpK5V9lslc7tz1FSh3BZMRGq5jSyD7ETSOQ0c8T2O/s7v\nbeEPbVbDe4mwvM24XByH0GnWveVxaDl51ABD65sCgYB3ZAspUkOA5egVCh8kNpnd\nSd6SnuQBE3ySRlT2WEnCwP9Ph6oPgn+oAfiPX4xbRqkL8q/k0BdHQ4h+zNwhk7+h\nWtPYRAP1Xxnc/F+jGjb+DVaIaKGU18MWPg7f+FI6nampl3Q0KvfxwX0GdNhtio8T\nTj1E+SnFwh56SRQuxSh2gwKBgHKjlIO5NtNSflsUYFM+hyQiPiqnHzddfhSG+/3o\nm5nNaSmczJesUYreH5San7/YEy2UxAugvP7aSY2MxB+iGsiJ9WD2kZzTUlDZJ7RV\nUzWsoqBR+eZfVJ2FUWWvy8TpSG6trh4dFxImNtKejCR1TREpSiTV3Zb1dmahK9GV\nrK9NAoGAbBxRLoC01xfxCTgt5BDiBcFVh4fp5yYKwavJPLzHSpuDOrrI9jDn1oKN\nonq5sDU1i391zfQvdrbX4Ova48BN+B7p63FocP/MK5tyyBoT8zQEk2+vWDOw7H/Z\nu5dTCPxTIsoIwUw1I+7yIxqJzLPFgR2gVBwY1ra/8iAqCj+zeBw=\n-----END RSA PRIVATE KEY-----\n" */
      pem?: string;
    } | null;
    /**
     * author_association
     * @description How the author is associated with the repository.
     * @example OWNER
     * @enum {string}
     */
    "author-association":
      | "COLLABORATOR"
      | "CONTRIBUTOR"
      | "FIRST_TIMER"
      | "FIRST_TIME_CONTRIBUTOR"
      | "MANNEQUIN"
      | "MEMBER"
      | "NONE"
      | "OWNER";
    /** Reaction Rollup */
    "reaction-rollup": {
      /** Format: uri */
      url: string;
      total_count: number;
      "+1": number;
      "-1": number;
      laugh: number;
      confused: number;
      heart: number;
      hooray: number;
      eyes: number;
      rocket: number;
    };
    /**
     * Issue
     * @description Issues are a great way to keep track of tasks, enhancements, and bugs for your projects.
     */
    issue: {
      /** Format: int64 */
      id: number;
      node_id: string;
      /**
       * Format: uri
       * @description URL for the issue
       * @example https://api.github.com/repositories/42/issues/1
       */
      url: string;
      /** Format: uri */
      repository_url: string;
      labels_url: string;
      /** Format: uri */
      comments_url: string;
      /** Format: uri */
      events_url: string;
      /** Format: uri */
      html_url: string;
      /**
       * @description Number uniquely identifying the issue within its repository
       * @example 42
       */
      number: number;
      /**
       * @description State of the issue; either 'open' or 'closed'
       * @example open
       */
      state: string;
      /**
       * @description The reason for the current state
       * @example not_planned
       * @enum {string|null}
       */
      state_reason?: "completed" | "reopened" | "not_planned" | null;
      /**
       * @description Title of the issue
       * @example Widget creation fails in Safari on OS X 10.8
       */
      title: string;
      /**
       * @description Contents of the issue
       * @example It looks like the new widget form is broken on Safari. When I try and create the widget, Safari crashes. This is reproducible on 10.8, but not 10.9. Maybe a browser bug?
       */
      body?: string | null;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * @description Labels to associate with this issue; pass one or more label names to replace the set of labels on this issue; send an empty array to clear all labels from the issue; note that the labels are silently dropped for users without push access to the repository
       * @example [
       *   "bug",
       *   "registration"
       * ]
       */
      labels: OneOf<
        [
          string,
          {
            /** Format: int64 */
            id?: number;
            node_id?: string;
            /** Format: uri */
            url?: string;
            name?: string;
            description?: string | null;
            color?: string | null;
            default?: boolean;
          }
        ]
      >[];
      assignee: components["schemas"]["nullable-simple-user"];
      assignees?: components["schemas"]["simple-user"][] | null;
      milestone: components["schemas"]["nullable-milestone"];
      locked: boolean;
      active_lock_reason?: string | null;
      comments: number;
      pull_request?: {
        /** Format: date-time */
        merged_at?: string | null;
        /** Format: uri */
        diff_url: string | null;
        /** Format: uri */
        html_url: string | null;
        /** Format: uri */
        patch_url: string | null;
        /** Format: uri */
        url: string | null;
      };
      /** Format: date-time */
      closed_at: string | null;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      draft?: boolean;
      closed_by?: components["schemas"]["nullable-simple-user"];
      body_html?: string;
      body_text?: string;
      /** Format: uri */
      timeline_url?: string;
      repository?: components["schemas"]["repository"];
      performed_via_github_app?: components["schemas"]["nullable-integration"];
      author_association: components["schemas"]["author-association"];
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Issue Comment
     * @description Comments provide a way for people to collaborate on an issue.
     */
    "issue-comment": {
      /**
       * Format: int64
       * @description Unique identifier of the issue comment
       * @example 42
       */
      id: number;
      node_id: string;
      /**
       * Format: uri
       * @description URL for the issue comment
       * @example https://api.github.com/repositories/42/issues/comments/1
       */
      url: string;
      /**
       * @description Contents of the issue comment
       * @example What version of Safari were you using when you observed this bug?
       */
      body?: string;
      body_text?: string;
      body_html?: string;
      /** Format: uri */
      html_url: string;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      updated_at: string;
      /** Format: uri */
      issue_url: string;
      author_association: components["schemas"]["author-association"];
      performed_via_github_app?: components["schemas"]["nullable-integration"];
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Event
     * @description Event
     */
    event: {
      id: string;
      type: string | null;
      actor: components["schemas"]["actor"];
      repo: {
        id: number;
        name: string;
        /** Format: uri */
        url: string;
      };
      org?: components["schemas"]["actor"];
      payload: {
        action?: string;
        issue?: components["schemas"]["issue"];
        comment?: components["schemas"]["issue-comment"];
        pages?: {
          page_name?: string;
          title?: string;
          summary?: string | null;
          action?: string;
          sha?: string;
          html_url?: string;
        }[];
      };
      public: boolean;
      /** Format: date-time */
      created_at: string | null;
    };
    /**
     * Link With Type
     * @description Hypermedia Link with Type
     */
    "link-with-type": {
      href: string;
      type: string;
    };
    /**
     * Feed
     * @description Feed
     */
    feed: {
      /** @example https://github.com/timeline */
      timeline_url: string;
      /** @example https://github.com/{user} */
      user_url: string;
      /** @example https://github.com/octocat */
      current_user_public_url?: string;
      /** @example https://github.com/octocat.private?token=abc123 */
      current_user_url?: string;
      /** @example https://github.com/octocat.private.actor?token=abc123 */
      current_user_actor_url?: string;
      /** @example https://github.com/octocat-org */
      current_user_organization_url?: string;
      /**
       * @example [
       *   "https://github.com/organizations/github/octocat.private.atom?token=abc123"
       * ]
       */
      current_user_organization_urls?: string[];
      /** @example https://github.com/security-advisories */
      security_advisories_url?: string;
      /**
       * @description A feed of discussions for a given repository.
       * @example https://github.com/{user}/{repo}/discussions
       */
      repository_discussions_url?: string;
      /**
       * @description A feed of discussions for a given repository and category.
       * @example https://github.com/{user}/{repo}/discussions/categories/{category}
       */
      repository_discussions_category_url?: string;
      _links: {
        timeline: components["schemas"]["link-with-type"];
        user: components["schemas"]["link-with-type"];
        security_advisories?: components["schemas"]["link-with-type"];
        current_user?: components["schemas"]["link-with-type"];
        current_user_public?: components["schemas"]["link-with-type"];
        current_user_actor?: components["schemas"]["link-with-type"];
        current_user_organization?: components["schemas"]["link-with-type"];
        current_user_organizations?: components["schemas"]["link-with-type"][];
        repository_discussions?: components["schemas"]["link-with-type"];
        repository_discussions_category?: components["schemas"]["link-with-type"];
      };
    };
    /**
     * Base Gist
     * @description Base Gist
     */
    "base-gist": {
      /** Format: uri */
      url: string;
      /** Format: uri */
      forks_url: string;
      /** Format: uri */
      commits_url: string;
      id: string;
      node_id: string;
      /** Format: uri */
      git_pull_url: string;
      /** Format: uri */
      git_push_url: string;
      /** Format: uri */
      html_url: string;
      files: {
        [key: string]:
          | {
              filename?: string;
              type?: string;
              language?: string;
              raw_url?: string;
              size?: number;
            }
          | undefined;
      };
      public: boolean;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      description: string | null;
      comments: number;
      user: components["schemas"]["nullable-simple-user"];
      /** Format: uri */
      comments_url: string;
      owner?: components["schemas"]["simple-user"];
      truncated?: boolean;
      forks?: unknown[];
      history?: unknown[];
    };
    /**
     * Public User
     * @description Public User
     */
    "public-user": {
      login: string;
      id: number;
      node_id: string;
      /** Format: uri */
      avatar_url: string;
      gravatar_id: string | null;
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      followers_url: string;
      following_url: string;
      gists_url: string;
      starred_url: string;
      /** Format: uri */
      subscriptions_url: string;
      /** Format: uri */
      organizations_url: string;
      /** Format: uri */
      repos_url: string;
      events_url: string;
      /** Format: uri */
      received_events_url: string;
      type: string;
      site_admin: boolean;
      name: string | null;
      company: string | null;
      blog: string | null;
      location: string | null;
      /** Format: email */
      email: string | null;
      hireable: boolean | null;
      bio: string | null;
      twitter_username?: string | null;
      public_repos: number;
      public_gists: number;
      followers: number;
      following: number;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      plan?: {
        collaborators: number;
        name: string;
        space: number;
        private_repos: number;
      };
      /** Format: date-time */
      suspended_at?: string | null;
      /** @example 1 */
      private_gists?: number;
      /** @example 2 */
      total_private_repos?: number;
      /** @example 2 */
      owned_private_repos?: number;
      /** @example 1 */
      disk_usage?: number;
      /** @example 3 */
      collaborators?: number;
    };
    /**
     * Gist History
     * @description Gist History
     */
    "gist-history": {
      user?: components["schemas"]["nullable-simple-user"];
      version?: string;
      /** Format: date-time */
      committed_at?: string;
      change_status?: {
        total?: number;
        additions?: number;
        deletions?: number;
      };
      /** Format: uri */
      url?: string;
    };
    /**
     * Gist Simple
     * @description Gist Simple
     */
    "gist-simple": {
      /** @deprecated */
      forks?:
        | {
            id?: string;
            /** Format: uri */
            url?: string;
            user?: components["schemas"]["public-user"];
            /** Format: date-time */
            created_at?: string;
            /** Format: date-time */
            updated_at?: string;
          }[]
        | null;
      /** @deprecated */
      history?: components["schemas"]["gist-history"][] | null;
      /**
       * Gist
       * @description Gist
       */
      fork_of?: {
        /** Format: uri */
        url: string;
        /** Format: uri */
        forks_url: string;
        /** Format: uri */
        commits_url: string;
        id: string;
        node_id: string;
        /** Format: uri */
        git_pull_url: string;
        /** Format: uri */
        git_push_url: string;
        /** Format: uri */
        html_url: string;
        files: {
          [key: string]:
            | {
                filename?: string;
                type?: string;
                language?: string;
                raw_url?: string;
                size?: number;
              }
            | undefined;
        };
        public: boolean;
        /** Format: date-time */
        created_at: string;
        /** Format: date-time */
        updated_at: string;
        description: string | null;
        comments: number;
        user: components["schemas"]["nullable-simple-user"];
        /** Format: uri */
        comments_url: string;
        owner?: components["schemas"]["nullable-simple-user"];
        truncated?: boolean;
        forks?: unknown[];
        history?: unknown[];
      } | null;
      url?: string;
      forks_url?: string;
      commits_url?: string;
      id?: string;
      node_id?: string;
      git_pull_url?: string;
      git_push_url?: string;
      html_url?: string;
      files?: {
        [key: string]:
          | ({
              filename?: string;
              type?: string;
              language?: string;
              raw_url?: string;
              size?: number;
              truncated?: boolean;
              content?: string;
            } | null)
          | undefined;
      };
      public?: boolean;
      created_at?: string;
      updated_at?: string;
      description?: string | null;
      comments?: number;
      user?: string | null;
      comments_url?: string;
      owner?: components["schemas"]["simple-user"];
      truncated?: boolean;
    };
    /**
     * Gist Comment
     * @description A comment made to a gist.
     */
    "gist-comment": {
      /** @example 1 */
      id: number;
      /** @example MDExOkdpc3RDb21tZW50MQ== */
      node_id: string;
      /**
       * Format: uri
       * @example https://api.github.com/gists/a6db0bec360bb87e9418/comments/1
       */
      url: string;
      /**
       * @description The comment text.
       * @example Body of the attachment
       */
      body: string;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @example 2011-04-18T23:23:56Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-04-18T23:23:56Z
       */
      updated_at: string;
      author_association: components["schemas"]["author-association"];
    };
    /**
     * Gist Commit
     * @description Gist Commit
     */
    "gist-commit": {
      /**
       * Format: uri
       * @example https://api.github.com/gists/aa5a315d61ae9438b18d/57a7f021a713b1c5a6a199b54cc514735d2d462f
       */
      url: string;
      /** @example 57a7f021a713b1c5a6a199b54cc514735d2d462f */
      version: string;
      user: components["schemas"]["nullable-simple-user"];
      change_status: {
        total?: number;
        additions?: number;
        deletions?: number;
      };
      /**
       * Format: date-time
       * @example 2010-04-14T02:15:15Z
       */
      committed_at: string;
    };
    /**
     * Gitignore Template
     * @description Gitignore Template
     */
    "gitignore-template": {
      /** @example C */
      name: string;
      /**
       * @example # Object files
       * *.o
       *
       * # Libraries
       * *.lib
       * *.a
       *
       * # Shared objects (inc. Windows DLLs)
       * *.dll
       * *.so
       * *.so.*
       * *.dylib
       *
       * # Executables
       * *.exe
       * *.out
       * *.app
       */
      source: string;
    };
    /**
     * License Simple
     * @description License Simple
     */
    "license-simple": {
      /** @example mit */
      key: string;
      /** @example MIT License */
      name: string;
      /**
       * Format: uri
       * @example https://api.github.com/licenses/mit
       */
      url: string | null;
      /** @example MIT */
      spdx_id: string | null;
      /** @example MDc6TGljZW5zZW1pdA== */
      node_id: string;
      /** Format: uri */
      html_url?: string;
    };
    /**
     * License
     * @description License
     */
    license: {
      /** @example mit */
      key: string;
      /** @example MIT License */
      name: string;
      /** @example MIT */
      spdx_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/licenses/mit
       */
      url: string | null;
      /** @example MDc6TGljZW5zZW1pdA== */
      node_id: string;
      /**
       * Format: uri
       * @example http://choosealicense.com/licenses/mit/
       */
      html_url: string;
      /** @example A permissive license that is short and to the point. It lets people do anything with your code with proper attribution and without warranty. */
      description: string;
      /** @example Create a text file (typically named LICENSE or LICENSE.txt) in the root of your source code and copy the text of the license into the file. Replace [year] with the current year and [fullname] with the name (or names) of the copyright holders. */
      implementation: string;
      /**
       * @example [
       *   "commercial-use",
       *   "modifications",
       *   "distribution",
       *   "sublicense",
       *   "private-use"
       * ]
       */
      permissions: string[];
      /**
       * @example [
       *   "include-copyright"
       * ]
       */
      conditions: string[];
      /**
       * @example [
       *   "no-liability"
       * ]
       */
      limitations: string[];
      /**
       * @example
       *
       * The MIT License (MIT)
       *
       * Copyright (c) [year] [fullname]
       *
       * Permission is hereby granted, free of charge, to any person obtaining a copy
       * of this software and associated documentation files (the "Software"), to deal
       * in the Software without restriction, including without limitation the rights
       * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
       * copies of the Software, and to permit persons to whom the Software is
       * furnished to do so, subject to the following conditions:
       *
       * The above copyright notice and this permission notice shall be included in all
       * copies or substantial portions of the Software.
       *
       * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
       * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
       * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
       * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
       * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
       * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
       * SOFTWARE.
       */
      body: string;
      /** @example true */
      featured: boolean;
    };
    /**
     * Marketplace Listing Plan
     * @description Marketplace Listing Plan
     */
    "marketplace-listing-plan": {
      /**
       * Format: uri
       * @example https://api.github.com/marketplace_listing/plans/1313
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/marketplace_listing/plans/1313/accounts
       */
      accounts_url: string;
      /** @example 1313 */
      id: number;
      /** @example 3 */
      number: number;
      /** @example Pro */
      name: string;
      /** @example A professional-grade CI solution */
      description: string;
      /** @example 1099 */
      monthly_price_in_cents: number;
      /** @example 11870 */
      yearly_price_in_cents: number;
      /**
       * @example FLAT_RATE
       * @enum {string}
       */
      price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
      /** @example true */
      has_free_trial: boolean;
      unit_name: string | null;
      /** @example published */
      state: string;
      /**
       * @example [
       *   "Up to 25 private repositories",
       *   "11 concurrent builds"
       * ]
       */
      bullets: string[];
    };
    /**
     * Marketplace Purchase
     * @description Marketplace Purchase
     */
    "marketplace-purchase": {
      url: string;
      type: string;
      id: number;
      login: string;
      organization_billing_email?: string;
      email?: string | null;
      marketplace_pending_change?: {
        is_installed?: boolean;
        effective_date?: string;
        unit_count?: number | null;
        id?: number;
        plan?: components["schemas"]["marketplace-listing-plan"];
      } | null;
      marketplace_purchase: {
        billing_cycle?: string;
        next_billing_date?: string | null;
        is_installed?: boolean;
        unit_count?: number | null;
        on_free_trial?: boolean;
        free_trial_ends_on?: string | null;
        updated_at?: string;
        plan?: components["schemas"]["marketplace-listing-plan"];
      };
    };
    /**
     * Api Overview
     * @description Api Overview
     */
    "api-overview": {
      /** @example true */
      verifiable_password_authentication: boolean;
      ssh_key_fingerprints?: {
        SHA256_RSA?: string;
        SHA256_DSA?: string;
        SHA256_ECDSA?: string;
        SHA256_ED25519?: string;
      };
      /**
       * @example [
       *   "ssh-ed25519 ABCDEFGHIJKLMNOPQRSTUVWXYZ"
       * ]
       */
      ssh_keys?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      hooks?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      web?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      api?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      git?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      packages?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      pages?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      importer?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      actions?: string[];
      /**
       * @example [
       *   "192.0.2.1"
       * ]
       */
      dependabot?: string[];
    };
    "security-and-analysis": {
      advanced_security?: {
        /** @enum {string} */
        status?: "enabled" | "disabled";
      };
      secret_scanning?: {
        /** @enum {string} */
        status?: "enabled" | "disabled";
      };
      secret_scanning_push_protection?: {
        /** @enum {string} */
        status?: "enabled" | "disabled";
      };
    } | null;
    /**
     * Minimal Repository
     * @description Minimal Repository
     */
    "minimal-repository": {
      /** @example 1296269 */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /** @example Hello-World */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      owner: components["schemas"]["simple-user"];
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      git_url?: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      ssh_url?: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      clone_url?: string;
      mirror_url?: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      svn_url?: string;
      homepage?: string | null;
      language?: string | null;
      forks_count?: number;
      stargazers_count?: number;
      watchers_count?: number;
      /** @description The size of the repository. Size is calculated hourly. When a repository is initially created, the size is 0. */
      size?: number;
      default_branch?: string;
      open_issues_count?: number;
      is_template?: boolean;
      topics?: string[];
      has_issues?: boolean;
      has_projects?: boolean;
      has_wiki?: boolean;
      has_pages?: boolean;
      has_downloads?: boolean;
      has_discussions?: boolean;
      archived?: boolean;
      disabled?: boolean;
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at?: string | null;
      permissions?: {
        admin?: boolean;
        maintain?: boolean;
        push?: boolean;
        triage?: boolean;
        pull?: boolean;
      };
      /** @example admin */
      role_name?: string;
      temp_clone_token?: string;
      delete_branch_on_merge?: boolean;
      subscribers_count?: number;
      network_count?: number;
      code_of_conduct?: components["schemas"]["code-of-conduct"];
      license?: {
        key?: string;
        name?: string;
        spdx_id?: string;
        url?: string;
        node_id?: string;
      } | null;
      /** @example 0 */
      forks?: number;
      /** @example 0 */
      open_issues?: number;
      /** @example 0 */
      watchers?: number;
      allow_forking?: boolean;
      /** @example false */
      web_commit_signoff_required?: boolean;
      security_and_analysis?: components["schemas"]["security-and-analysis"];
    };
    /**
     * Thread
     * @description Thread
     */
    thread: {
      id: string;
      repository: components["schemas"]["minimal-repository"];
      subject: {
        title: string;
        url: string;
        latest_comment_url: string;
        type: string;
      };
      reason: string;
      unread: boolean;
      updated_at: string;
      last_read_at: string | null;
      url: string;
      /** @example https://api.github.com/notifications/threads/2/subscription */
      subscription_url: string;
    };
    /**
     * Thread Subscription
     * @description Thread Subscription
     */
    "thread-subscription": {
      /** @example true */
      subscribed: boolean;
      ignored: boolean;
      reason: string | null;
      /**
       * Format: date-time
       * @example 2012-10-06T21:34:12Z
       */
      created_at: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/notifications/threads/1/subscription
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/notifications/threads/1
       */
      thread_url?: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/1
       */
      repository_url?: string;
    };
    /**
     * Organization Simple
     * @description A GitHub organization.
     */
    "organization-simple": {
      /** @example github */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDEyOk9yZ2FuaXphdGlvbjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/repos
       */
      repos_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/events
       */
      events_url: string;
      /** @example https://api.github.com/orgs/github/hooks */
      hooks_url: string;
      /** @example https://api.github.com/orgs/github/issues */
      issues_url: string;
      /** @example https://api.github.com/orgs/github/members{/member} */
      members_url: string;
      /** @example https://api.github.com/orgs/github/public_members{/member} */
      public_members_url: string;
      /** @example https://github.com/images/error/octocat_happy.gif */
      avatar_url: string;
      /** @example A great organization */
      description: string | null;
    };
    /**
     * Simple Organization Programmatic Access Grant Request
     * @description Minimal representation of an organization programmatic access grant request for enumerations
     */
    "organization-programmatic-access-grant-request": {
      /** @description Unique identifier of the request for access via fine-grained personal access token. The `pat_request_id` used to review PAT requests. */
      id: number;
      /** @description Reason for requesting access. */
      reason: string | null;
      owner: components["schemas"]["simple-user"];
      /**
       * @description Type of repository selection requested.
       * @enum {string}
       */
      repository_selection: "none" | "all" | "subset";
      /** @description URL to the list of repositories requested to be accessed via fine-grained personal access token. Should only be followed when `repository_selection` is `subset`. */
      repositories_url: string;
      /** @description Permissions requested, categorized by type of permission. */
      permissions: {
        organization?: {
          [key: string]: string | undefined;
        };
        repository?: {
          [key: string]: string | undefined;
        };
        other?: {
          [key: string]: string | undefined;
        };
      };
      /** @description Date and time when the request for access was created. */
      created_at: string;
      /** @description Whether the associated fine-grained personal access token has expired. */
      token_expired: boolean;
      /** @description Date and time when the associated fine-grained personal access token expires. */
      token_expires_at: string | null;
      /** @description Date and time when the associated fine-grained personal access token was last used for authentication. */
      token_last_used_at: string | null;
    };
    /**
     * Organization Programmatic Access Grant
     * @description Minimal representation of an organization programmatic access grant for enumerations
     */
    "organization-programmatic-access-grant": {
      /** @description Unique identifier of the fine-grained personal access token. The `pat_id` used to get details about an approved fine-grained personal access token. */
      id: number;
      owner: components["schemas"]["simple-user"];
      /**
       * @description Type of repository selection requested.
       * @enum {string}
       */
      repository_selection: "none" | "all" | "subset";
      /** @description URL to the list of repositories the fine-grained personal access token can access. Only follow when `repository_selection` is `subset`. */
      repositories_url: string;
      /** @description Permissions requested, categorized by type of permission. */
      permissions: {
        organization?: {
          [key: string]: string | undefined;
        };
        repository?: {
          [key: string]: string | undefined;
        };
        other?: {
          [key: string]: string | undefined;
        };
      };
      /** @description Date and time when the fine-grained personal access token was approved to access the organization. */
      access_granted_at: string;
      /** @description Whether the associated fine-grained personal access token has expired. */
      token_expired: boolean;
      /** @description Date and time when the associated fine-grained personal access token expires. */
      token_expires_at: string | null;
      /** @description Date and time when the associated fine-grained personal access token was last used for authentication. */
      token_last_used_at: string | null;
    };
    /**
     * Organization Full
     * @description Organization Full
     */
    "organization-full": {
      /** @example github */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDEyOk9yZ2FuaXphdGlvbjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/repos
       */
      repos_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/events
       */
      events_url: string;
      /** @example https://api.github.com/orgs/github/hooks */
      hooks_url: string;
      /** @example https://api.github.com/orgs/github/issues */
      issues_url: string;
      /** @example https://api.github.com/orgs/github/members{/member} */
      members_url: string;
      /** @example https://api.github.com/orgs/github/public_members{/member} */
      public_members_url: string;
      /** @example https://github.com/images/error/octocat_happy.gif */
      avatar_url: string;
      /** @example A great organization */
      description: string | null;
      /** @example github */
      name?: string;
      /** @example GitHub */
      company?: string;
      /**
       * Format: uri
       * @example https://github.com/blog
       */
      blog?: string;
      /** @example San Francisco */
      location?: string;
      /**
       * Format: email
       * @example octocat@github.com
       */
      email?: string;
      /** @example github */
      twitter_username?: string | null;
      /** @example true */
      is_verified?: boolean;
      /** @example true */
      has_organization_projects: boolean;
      /** @example true */
      has_repository_projects: boolean;
      /** @example 2 */
      public_repos: number;
      /** @example 1 */
      public_gists: number;
      /** @example 20 */
      followers: number;
      /** @example 0 */
      following: number;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: date-time
       * @example 2008-01-14T04:33:35Z
       */
      created_at: string;
      /** @example Organization */
      type: string;
      /** @example 100 */
      total_private_repos?: number;
      /** @example 100 */
      owned_private_repos?: number;
      /** @example 81 */
      private_gists?: number | null;
      /** @example 10000 */
      disk_usage?: number | null;
      /** @example 8 */
      collaborators?: number | null;
      /**
       * Format: email
       * @example org@example.com
       */
      billing_email?: string | null;
      plan?: {
        name: string;
        space: number;
        private_repos: number;
        filled_seats?: number;
        seats?: number;
      };
      default_repository_permission?: string | null;
      /** @example true */
      members_can_create_repositories?: boolean | null;
      /** @example true */
      two_factor_requirement_enabled?: boolean | null;
      /** @example all */
      members_allowed_repository_creation_type?: string;
      /** @example true */
      members_can_create_public_repositories?: boolean;
      /** @example true */
      members_can_create_private_repositories?: boolean;
      /** @example true */
      members_can_create_internal_repositories?: boolean;
      /** @example true */
      members_can_create_pages?: boolean;
      /** @example true */
      members_can_create_public_pages?: boolean;
      /** @example true */
      members_can_create_private_pages?: boolean;
      /** @example false */
      members_can_fork_private_repositories?: boolean | null;
      /** @example false */
      web_commit_signoff_required?: boolean;
      /** Format: date-time */
      updated_at: string;
      /**
       * @description Whether GitHub Advanced Security is enabled for new repositories and repositories transferred to this organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      advanced_security_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether GitHub Advanced Security is automatically enabled for new repositories and repositories transferred to
       * this organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      dependabot_alerts_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether dependabot security updates are automatically enabled for new repositories and repositories transferred
       * to this organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      dependabot_security_updates_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether dependency graph is automatically enabled for new repositories and repositories transferred to this
       * organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      dependency_graph_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether secret scanning is automatically enabled for new repositories and repositories transferred to this
       * organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      secret_scanning_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether secret scanning push protection is automatically enabled for new repositories and repositories
       * transferred to this organization.
       *
       * This field is only visible to organization owners or members of a team with the security manager role.
       * @example false
       */
      secret_scanning_push_protection_enabled_for_new_repositories?: boolean;
      /**
       * @description Whether a custom link is shown to contributors who are blocked from pushing a secret by push protection.
       * @example false
       */
      secret_scanning_push_protection_custom_link_enabled?: boolean;
      /**
       * @description An optional URL string to display to contributors who are blocked from pushing a secret.
       * @example https://github.com/test-org/test-repo/blob/main/README.md
       */
      secret_scanning_push_protection_custom_link?: string | null;
    };
    "actions-cache-usage-org-enterprise": {
      /** @description The count of active caches across all repositories of an enterprise or an organization. */
      total_active_caches_count: number;
      /** @description The total size in bytes of all active cache items across all repositories of an enterprise or an organization. */
      total_active_caches_size_in_bytes: number;
    };
    /**
     * Actions Cache Usage by repository
     * @description GitHub Actions Cache Usage by repository.
     */
    "actions-cache-usage-by-repository": {
      /**
       * @description The repository owner and name for the cache usage being shown.
       * @example octo-org/Hello-World
       */
      full_name: string;
      /**
       * @description The sum of the size in bytes of all the active cache items in the repository.
       * @example 2322142
       */
      active_caches_size_in_bytes: number;
      /**
       * @description The number of active caches in the repository.
       * @example 3
       */
      active_caches_count: number;
    };
    /**
     * Actions OIDC Subject customization
     * @description Actions OIDC Subject customization
     */
    "oidc-custom-sub": {
      /** @description Array of unique strings. Each claim key can only contain alphanumeric characters and underscores. */
      include_claim_keys: string[];
    };
    /**
     * Empty Object
     * @description An object without any properties.
     */
    "empty-object": Record<string, never>;
    /**
     * @description The policy that controls the repositories in the organization that are allowed to run GitHub Actions.
     * @enum {string}
     */
    "enabled-repositories": "all" | "none" | "selected";
    /**
     * @description The permissions policy that controls the actions and reusable workflows that are allowed to run.
     * @enum {string}
     */
    "allowed-actions": "all" | "local_only" | "selected";
    /** @description The API URL to use to get or set the actions and reusable workflows that are allowed to run, when `allowed_actions` is set to `selected`. */
    "selected-actions-url": string;
    "actions-organization-permissions": {
      enabled_repositories: components["schemas"]["enabled-repositories"];
      /** @description The API URL to use to get or set the selected repositories that are allowed to run GitHub Actions, when `enabled_repositories` is set to `selected`. */
      selected_repositories_url?: string;
      allowed_actions?: components["schemas"]["allowed-actions"];
      selected_actions_url?: components["schemas"]["selected-actions-url"];
    };
    "selected-actions": {
      /** @description Whether GitHub-owned actions are allowed. For example, this includes the actions in the `actions` organization. */
      github_owned_allowed?: boolean;
      /** @description Whether actions from GitHub Marketplace verified creators are allowed. Set to `true` to allow all actions by GitHub Marketplace verified creators. */
      verified_allowed?: boolean;
      /**
       * @description Specifies a list of string-matching patterns to allow specific action(s) and reusable workflow(s). Wildcards, tags, and SHAs are allowed. For example, `monalisa/octocat@*`, `monalisa/octocat@v2`, `monalisa/*`.
       *
       * **Note**: The `patterns_allowed` setting only applies to public repositories.
       */
      patterns_allowed?: string[];
    };
    /**
     * @description The default workflow permissions granted to the GITHUB_TOKEN when running workflows.
     * @enum {string}
     */
    "actions-default-workflow-permissions": "read" | "write";
    /** @description Whether GitHub Actions can approve pull requests. Enabling this can be a security risk. */
    "actions-can-approve-pull-request-reviews": boolean;
    "actions-get-default-workflow-permissions": {
      default_workflow_permissions: components["schemas"]["actions-default-workflow-permissions"];
      can_approve_pull_request_reviews: components["schemas"]["actions-can-approve-pull-request-reviews"];
    };
    "actions-set-default-workflow-permissions": {
      default_workflow_permissions?: components["schemas"]["actions-default-workflow-permissions"];
      can_approve_pull_request_reviews?: components["schemas"]["actions-can-approve-pull-request-reviews"];
    };
    "required-workflow": {
      /** @description Unique identifier for a required workflow */
      id: number;
      /** @description Name present in the workflow file */
      name: string;
      /** @description Path of the workflow file */
      path: string;
      /**
       * @description Scope of the required workflow
       * @enum {string}
       */
      scope: "all" | "selected";
      /** @description Ref at which the workflow file will be selected */
      ref: string;
      /**
       * @description State of the required workflow
       * @enum {string}
       */
      state: "active" | "deleted";
      /**
       * Format: uri
       * @example https://api.github.com/organizations/org/actions/required_workflows/1/repositories
       */
      selected_repositories_url?: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      repository: components["schemas"]["minimal-repository"];
    };
    /**
     * Self hosted runner label
     * @description A label for a self hosted runner
     */
    "runner-label": {
      /** @description Unique identifier of the label. */
      id?: number;
      /** @description Name of the label. */
      name: string;
      /**
       * @description The type of label. Read-only labels are applied automatically when the runner is configured.
       * @enum {string}
       */
      type?: "read-only" | "custom";
    };
    /**
     * Self hosted runners
     * @description A self hosted runner
     */
    runner: {
      /**
       * @description The id of the runner.
       * @example 5
       */
      id: number;
      /**
       * @description The id of the runner group.
       * @example 1
       */
      runner_group_id?: number;
      /**
       * @description The name of the runner.
       * @example iMac
       */
      name: string;
      /**
       * @description The Operating System of the runner.
       * @example macos
       */
      os: string;
      /**
       * @description The status of the runner.
       * @example online
       */
      status: string;
      busy: boolean;
      labels: components["schemas"]["runner-label"][];
    };
    /**
     * Runner Application
     * @description Runner Application
     */
    "runner-application": {
      os: string;
      architecture: string;
      download_url: string;
      filename: string;
      /** @description A short lived bearer token used to download the runner, if needed. */
      temp_download_token?: string;
      sha256_checksum?: string;
    };
    /**
     * Authentication Token
     * @description Authentication Token
     */
    "authentication-token": {
      /**
       * @description The token used for authentication
       * @example v1.1f699f1069f60xxx
       */
      token: string;
      /**
       * Format: date-time
       * @description The time this token expires
       * @example 2016-07-11T22:14:10Z
       */
      expires_at: string;
      /**
       * @example {
       *   "issues": "read",
       *   "deployments": "write"
       * }
       */
      permissions?: Record<string, never>;
      /** @description The repositories this token has access to */
      repositories?: components["schemas"]["repository"][];
      /** @example config.yaml */
      single_file?: string | null;
      /**
       * @description Describe whether all repositories have been selected or there's a selection involved
       * @enum {string}
       */
      repository_selection?: "all" | "selected";
    };
    /**
     * Actions Secret for an Organization
     * @description Secrets for GitHub Actions for an organization.
     */
    "organization-actions-secret": {
      /**
       * @description The name of the secret.
       * @example SECRET_TOKEN
       */
      name: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      /**
       * @description Visibility of a secret
       * @enum {string}
       */
      visibility: "all" | "private" | "selected";
      /**
       * Format: uri
       * @example https://api.github.com/organizations/org/secrets/my_secret/repositories
       */
      selected_repositories_url?: string;
    };
    /**
     * ActionsPublicKey
     * @description The public key used for setting Actions Secrets.
     */
    "actions-public-key": {
      /**
       * @description The identifier for the key.
       * @example 1234567
       */
      key_id: string;
      /**
       * @description The Base64 encoded public key.
       * @example hBT5WZEj8ZoOv6TYJsfWq7MxTEQopZO5/IT3ZCVQPzs=
       */
      key: string;
      /** @example 2 */
      id?: number;
      /** @example https://api.github.com/user/keys/2 */
      url?: string;
      /** @example ssh-rsa AAAAB3NzaC1yc2EAAA */
      title?: string;
      /** @example 2011-01-26T19:01:12Z */
      created_at?: string;
    };
    /**
     * Actions Variable for an Organization
     * @description Organization variable for GitHub Actions.
     */
    "organization-actions-variable": {
      /**
       * @description The name of the variable.
       * @example USERNAME
       */
      name: string;
      /**
       * @description The value of the variable.
       * @example octocat
       */
      value: string;
      /**
       * Format: date-time
       * @description The date and time at which the variable was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       * @example 2019-01-24T22:45:36.000Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The date and time at which the variable was last updated, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       * @example 2019-01-24T22:45:36.000Z
       */
      updated_at: string;
      /**
       * @description Visibility of a variable
       * @enum {string}
       */
      visibility: "all" | "private" | "selected";
      /**
       * Format: uri
       * @example https://api.github.com/organizations/org/variables/USERNAME/repositories
       */
      selected_repositories_url?: string;
    };
    /** @description The name of the tool used to generate the code scanning analysis. */
    "code-scanning-analysis-tool-name": string;
    /** @description The GUID of the tool used to generate the code scanning analysis, if provided in the uploaded SARIF data. */
    "code-scanning-analysis-tool-guid": string | null;
    /**
     * @description State of a code scanning alert.
     * @enum {string}
     */
    "code-scanning-alert-state": "open" | "closed" | "dismissed" | "fixed";
    /**
     * @description Severity of a code scanning alert.
     * @enum {string}
     */
    "code-scanning-alert-severity":
      | "critical"
      | "high"
      | "medium"
      | "low"
      | "warning"
      | "note"
      | "error";
    /**
     * Format: uri
     * @description The REST API URL for fetching the list of instances for an alert.
     */
    readonly "alert-instances-url": string;
    /**
     * @description **Required when the state is dismissed.** The reason for dismissing or closing the alert.
     * @enum {string|null}
     */
    "code-scanning-alert-dismissed-reason":
      | ""
      | "false positive"
      | "won't fix"
      | "used in tests"
      | null;
    /** @description The dismissal comment associated with the dismissal of the alert. */
    "code-scanning-alert-dismissed-comment": string | null;
    "code-scanning-alert-rule": {
      /** @description A unique identifier for the rule used to detect the alert. */
      id?: string | null;
      /** @description The name of the rule used to detect the alert. */
      name?: string;
      /**
       * @description The severity of the alert.
       * @enum {string|null}
       */
      severity?: "none" | "note" | "warning" | "error" | null;
      /**
       * @description The security severity of the alert.
       * @enum {string|null}
       */
      security_severity_level?: "low" | "medium" | "high" | "critical" | null;
      /** @description A short description of the rule used to detect the alert. */
      description?: string;
      /** @description description of the rule used to detect the alert. */
      full_description?: string;
      /** @description A set of tags applicable for the rule. */
      tags?: string[] | null;
      /** @description Detailed documentation for the rule as GitHub Flavored Markdown. */
      help?: string | null;
      /** @description A link to the documentation for the rule used to detect the alert. */
      help_uri?: string | null;
    };
    /** @description The version of the tool used to generate the code scanning analysis. */
    "code-scanning-analysis-tool-version": string | null;
    "code-scanning-analysis-tool": {
      name?: components["schemas"]["code-scanning-analysis-tool-name"];
      version?: components["schemas"]["code-scanning-analysis-tool-version"];
      guid?: components["schemas"]["code-scanning-analysis-tool-guid"];
    };
    /**
     * @description The full Git reference, formatted as `refs/heads/<branch name>`,
     * `refs/pull/<number>/merge`, or `refs/pull/<number>/head`.
     */
    "code-scanning-ref": string;
    /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
    "code-scanning-analysis-analysis-key": string;
    /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
    "code-scanning-alert-environment": string;
    /** @description Identifies the configuration under which the analysis was executed. Used to distinguish between multiple analyses for the same tool and commit, but performed on different languages or different parts of the code. */
    "code-scanning-analysis-category": string;
    /** @description Describe a region within a file for the alert. */
    "code-scanning-alert-location": {
      path?: string;
      start_line?: number;
      end_line?: number;
      start_column?: number;
      end_column?: number;
    };
    /**
     * @description A classification of the file. For example to identify it as generated.
     * @enum {string|null}
     */
    "code-scanning-alert-classification":
      | "source"
      | "generated"
      | "test"
      | "library"
      | null;
    "code-scanning-alert-instance": {
      ref?: components["schemas"]["code-scanning-ref"];
      analysis_key?: components["schemas"]["code-scanning-analysis-analysis-key"];
      environment?: components["schemas"]["code-scanning-alert-environment"];
      category?: components["schemas"]["code-scanning-analysis-category"];
      state?: components["schemas"]["code-scanning-alert-state"];
      commit_sha?: string;
      message?: {
        text?: string;
      };
      location?: components["schemas"]["code-scanning-alert-location"];
      html_url?: string;
      /**
       * @description Classifications that have been applied to the file that triggered the alert.
       * For example identifying it as documentation, or a generated file.
       */
      classifications?: components["schemas"]["code-scanning-alert-classification"][];
    };
    "code-scanning-organization-alert-items": {
      number: components["schemas"]["alert-number"];
      created_at: components["schemas"]["alert-created-at"];
      updated_at?: components["schemas"]["alert-updated-at"];
      url: components["schemas"]["alert-url"];
      html_url: components["schemas"]["alert-html-url"];
      instances_url: components["schemas"]["alert-instances-url"];
      state: components["schemas"]["code-scanning-alert-state"];
      fixed_at?: components["schemas"]["alert-fixed-at"];
      dismissed_by: components["schemas"]["nullable-simple-user"];
      dismissed_at: components["schemas"]["alert-dismissed-at"];
      dismissed_reason: components["schemas"]["code-scanning-alert-dismissed-reason"];
      dismissed_comment?: components["schemas"]["code-scanning-alert-dismissed-comment"];
      rule: components["schemas"]["code-scanning-alert-rule"];
      tool: components["schemas"]["code-scanning-analysis-tool"];
      most_recent_instance: components["schemas"]["code-scanning-alert-instance"];
      repository: components["schemas"]["simple-repository"];
    };
    /**
     * Codespace machine
     * @description A description of the machine powering a codespace.
     */
    "nullable-codespace-machine": {
      /**
       * @description The name of the machine.
       * @example standardLinux
       */
      name: string;
      /**
       * @description The display name of the machine includes cores, memory, and storage.
       * @example 4 cores, 8 GB RAM, 64 GB storage
       */
      display_name: string;
      /**
       * @description The operating system of the machine.
       * @example linux
       */
      operating_system: string;
      /**
       * @description How much storage is available to the codespace.
       * @example 68719476736
       */
      storage_in_bytes: number;
      /**
       * @description How much memory is available to the codespace.
       * @example 8589934592
       */
      memory_in_bytes: number;
      /**
       * @description How many cores are available to the codespace.
       * @example 4
       */
      cpus: number;
      /**
       * @description Whether a prebuild is currently available when creating a codespace for this machine and repository. If a branch was not specified as a ref, the default branch will be assumed. Value will be "null" if prebuilds are not supported or prebuild availability could not be determined. Value will be "none" if no prebuild is available. Latest values "ready" and "in_progress" indicate the prebuild availability status.
       * @example ready
       * @enum {string|null}
       */
      prebuild_availability: "none" | "ready" | "in_progress" | null;
    } | null;
    /**
     * Codespace
     * @description A codespace.
     */
    codespace: {
      /** @example 1 */
      id: number;
      /**
       * @description Automatically generated name of this codespace.
       * @example monalisa-octocat-hello-world-g4wpq6h95q
       */
      name: string;
      /**
       * @description Display name for this codespace.
       * @example sliderish space pancake
       */
      display_name?: string | null;
      /**
       * @description UUID identifying this codespace's environment.
       * @example 26a7c758-7299-4a73-b978-5a92a7ae98a0
       */
      environment_id: string | null;
      owner: components["schemas"]["simple-user"];
      billable_owner: components["schemas"]["simple-user"];
      repository: components["schemas"]["minimal-repository"];
      machine: components["schemas"]["nullable-codespace-machine"];
      /**
       * @description Path to devcontainer.json from repo root used to create Codespace.
       * @example .devcontainer/example/devcontainer.json
       */
      devcontainer_path?: string | null;
      /**
       * @description Whether the codespace was created from a prebuild.
       * @example false
       */
      prebuild: boolean | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @description Last known time this codespace was started.
       * @example 2011-01-26T19:01:12Z
       */
      last_used_at: string;
      /**
       * @description State of this codespace.
       * @example Available
       * @enum {string}
       */
      state:
        | "Unknown"
        | "Created"
        | "Queued"
        | "Provisioning"
        | "Available"
        | "Awaiting"
        | "Unavailable"
        | "Deleted"
        | "Moved"
        | "Shutdown"
        | "Archived"
        | "Starting"
        | "ShuttingDown"
        | "Failed"
        | "Exporting"
        | "Updating"
        | "Rebuilding";
      /**
       * Format: uri
       * @description API URL for this codespace.
       */
      url: string;
      /** @description Details about the codespace's git repository. */
      git_status: {
        /**
         * @description The number of commits the local repository is ahead of the remote.
         * @example 0
         */
        ahead?: number;
        /**
         * @description The number of commits the local repository is behind the remote.
         * @example 0
         */
        behind?: number;
        /** @description Whether the local repository has unpushed changes. */
        has_unpushed_changes?: boolean;
        /** @description Whether the local repository has uncommitted changes. */
        has_uncommitted_changes?: boolean;
        /**
         * @description The current branch (or SHA if in detached HEAD state) of the local repository.
         * @example main
         */
        ref?: string;
      };
      /**
       * @description The initally assigned location of a new codespace.
       * @example WestUs2
       * @enum {string}
       */
      location: "EastUs" | "SouthEastAsia" | "WestEurope" | "WestUs2";
      /**
       * @description The number of minutes of inactivity after which this codespace will be automatically stopped.
       * @example 60
       */
      idle_timeout_minutes: number | null;
      /**
       * Format: uri
       * @description URL to access this codespace on the web.
       */
      web_url: string;
      /**
       * Format: uri
       * @description API URL to access available alternate machine types for this codespace.
       */
      machines_url: string;
      /**
       * Format: uri
       * @description API URL to start this codespace.
       */
      start_url: string;
      /**
       * Format: uri
       * @description API URL to stop this codespace.
       */
      stop_url: string;
      /**
       * Format: uri
       * @description API URL to publish this codespace to a new repository.
       */
      publish_url?: string | null;
      /**
       * Format: uri
       * @description API URL for the Pull Request associated with this codespace, if any.
       */
      pulls_url: string | null;
      recent_folders: string[];
      runtime_constraints?: {
        /** @description The privacy settings a user can select from when forwarding a port. */
        allowed_port_privacy_settings?: string[] | null;
      };
      /** @description Whether or not a codespace has a pending async operation. This would mean that the codespace is temporarily unavailable. The only thing that you can do with a codespace in this state is delete it. */
      pending_operation?: boolean | null;
      /** @description Text to show user when codespace is disabled by a pending operation */
      pending_operation_disabled_reason?: string | null;
      /** @description Text to show user when codespace idle timeout minutes has been overriden by an organization policy */
      idle_timeout_notice?: string | null;
      /**
       * @description Duration in minutes after codespace has gone idle in which it will be deleted. Must be integer minutes between 0 and 43200 (30 days).
       * @example 60
       */
      retention_period_minutes?: number | null;
      /**
       * Format: date-time
       * @description When a codespace will be auto-deleted based on the "retention_period_minutes" and "last_used_at"
       * @example 2011-01-26T20:01:12Z
       */
      retention_expires_at?: string | null;
      /**
       * @description The text to display to a user when a codespace has been stopped for a potentially actionable reason.
       * @example you've used 100% of your spending limit for Codespaces
       */
      last_known_stop_notice?: string | null;
    };
    /**
     * Codespaces Secret
     * @description Secrets for a GitHub Codespace.
     */
    "codespaces-org-secret": {
      /**
       * @description The name of the secret
       * @example SECRET_NAME
       */
      name: string;
      /**
       * Format: date-time
       * @description The date and time at which the secret was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The date and time at which the secret was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      updated_at: string;
      /**
       * @description The type of repositories in the organization that the secret is visible to
       * @enum {string}
       */
      visibility: "all" | "private" | "selected";
      /**
       * Format: uri
       * @description The API URL at which the list of repositories this secret is visible to can be retrieved
       * @example https://api.github.com/orgs/ORGANIZATION/codespaces/secrets/SECRET_NAME/repositories
       */
      selected_repositories_url?: string;
    };
    /**
     * CodespacesPublicKey
     * @description The public key used for setting Codespaces secrets.
     */
    "codespaces-public-key": {
      /**
       * @description The identifier for the key.
       * @example 1234567
       */
      key_id: string;
      /**
       * @description The Base64 encoded public key.
       * @example hBT5WZEj8ZoOv6TYJsfWq7MxTEQopZO5/IT3ZCVQPzs=
       */
      key: string;
      /** @example 2 */
      id?: number;
      /** @example https://api.github.com/user/keys/2 */
      url?: string;
      /** @example ssh-rsa AAAAB3NzaC1yc2EAAA */
      title?: string;
      /** @example 2011-01-26T19:01:12Z */
      created_at?: string;
    };
    /**
     * Dependabot Secret for an Organization
     * @description Secrets for GitHub Dependabot for an organization.
     */
    "organization-dependabot-secret": {
      /**
       * @description The name of the secret.
       * @example SECRET_TOKEN
       */
      name: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      /**
       * @description Visibility of a secret
       * @enum {string}
       */
      visibility: "all" | "private" | "selected";
      /**
       * Format: uri
       * @example https://api.github.com/organizations/org/dependabot/secrets/my_secret/repositories
       */
      selected_repositories_url?: string;
    };
    /**
     * DependabotPublicKey
     * @description The public key used for setting Dependabot Secrets.
     */
    "dependabot-public-key": {
      /**
       * @description The identifier for the key.
       * @example 1234567
       */
      key_id: string;
      /**
       * @description The Base64 encoded public key.
       * @example hBT5WZEj8ZoOv6TYJsfWq7MxTEQopZO5/IT3ZCVQPzs=
       */
      key: string;
    };
    /**
     * Minimal Repository
     * @description Minimal Repository
     */
    "nullable-minimal-repository": {
      /** @example 1296269 */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /** @example Hello-World */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      owner: components["schemas"]["simple-user"];
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      git_url?: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      ssh_url?: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      clone_url?: string;
      mirror_url?: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      svn_url?: string;
      homepage?: string | null;
      language?: string | null;
      forks_count?: number;
      stargazers_count?: number;
      watchers_count?: number;
      /** @description The size of the repository. Size is calculated hourly. When a repository is initially created, the size is 0. */
      size?: number;
      default_branch?: string;
      open_issues_count?: number;
      is_template?: boolean;
      topics?: string[];
      has_issues?: boolean;
      has_projects?: boolean;
      has_wiki?: boolean;
      has_pages?: boolean;
      has_downloads?: boolean;
      has_discussions?: boolean;
      archived?: boolean;
      disabled?: boolean;
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at?: string | null;
      permissions?: {
        admin?: boolean;
        maintain?: boolean;
        push?: boolean;
        triage?: boolean;
        pull?: boolean;
      };
      /** @example admin */
      role_name?: string;
      temp_clone_token?: string;
      delete_branch_on_merge?: boolean;
      subscribers_count?: number;
      network_count?: number;
      code_of_conduct?: components["schemas"]["code-of-conduct"];
      license?: {
        key?: string;
        name?: string;
        spdx_id?: string;
        url?: string;
        node_id?: string;
      } | null;
      /** @example 0 */
      forks?: number;
      /** @example 0 */
      open_issues?: number;
      /** @example 0 */
      watchers?: number;
      allow_forking?: boolean;
      /** @example false */
      web_commit_signoff_required?: boolean;
      security_and_analysis?: components["schemas"]["security-and-analysis"];
    } | null;
    /**
     * Package
     * @description A software package
     */
    package: {
      /**
       * @description Unique identifier of the package.
       * @example 1
       */
      id: number;
      /**
       * @description The name of the package.
       * @example super-linter
       */
      name: string;
      /**
       * @example docker
       * @enum {string}
       */
      package_type:
        | "npm"
        | "maven"
        | "rubygems"
        | "docker"
        | "nuget"
        | "container";
      /** @example https://api.github.com/orgs/github/packages/container/super-linter */
      url: string;
      /** @example https://github.com/orgs/github/packages/container/package/super-linter */
      html_url: string;
      /**
       * @description The number of versions of the package.
       * @example 1
       */
      version_count: number;
      /**
       * @example private
       * @enum {string}
       */
      visibility: "private" | "public";
      owner?: components["schemas"]["nullable-simple-user"];
      repository?: components["schemas"]["nullable-minimal-repository"];
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Organization Invitation
     * @description Organization Invitation
     */
    "organization-invitation": {
      id: number;
      login: string | null;
      email: string | null;
      role: string;
      created_at: string;
      failed_at?: string | null;
      failed_reason?: string | null;
      inviter: components["schemas"]["simple-user"];
      team_count: number;
      /** @example "MDIyOk9yZ2FuaXphdGlvbkludml0YXRpb24x" */
      node_id: string;
      /** @example "https://api.github.com/organizations/16/invitations/1/teams" */
      invitation_teams_url: string;
      /** @example "member" */
      invitation_source?: string;
    };
    /**
     * Org Hook
     * @description Org Hook
     */
    "org-hook": {
      /** @example 1 */
      id: number;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octocat/hooks/1
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octocat/hooks/1/pings
       */
      ping_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octocat/hooks/1/deliveries
       */
      deliveries_url?: string;
      /** @example web */
      name: string;
      /**
       * @example [
       *   "push",
       *   "pull_request"
       * ]
       */
      events: string[];
      /** @example true */
      active: boolean;
      config: {
        /** @example "http://example.com/2" */
        url?: string;
        /** @example "0" */
        insecure_ssl?: string;
        /** @example "form" */
        content_type?: string;
        /** @example "********" */
        secret?: string;
      };
      /**
       * Format: date-time
       * @example 2011-09-06T20:39:23Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2011-09-06T17:26:27Z
       */
      created_at: string;
      type: string;
    };
    /**
     * @description The type of GitHub user that can comment, open issues, or create pull requests while the interaction limit is in effect.
     * @example collaborators_only
     * @enum {string}
     */
    "interaction-group":
      | "existing_users"
      | "contributors_only"
      | "collaborators_only";
    /**
     * Interaction Limits
     * @description Interaction limit settings.
     */
    "interaction-limit-response": {
      limit: components["schemas"]["interaction-group"];
      /** @example repository */
      origin: string;
      /**
       * Format: date-time
       * @example 2018-08-17T04:18:39Z
       */
      expires_at: string;
    };
    /**
     * @description The duration of the interaction restriction. Default: `one_day`.
     * @example one_month
     * @enum {string}
     */
    "interaction-expiry":
      | "one_day"
      | "three_days"
      | "one_week"
      | "one_month"
      | "six_months";
    /**
     * Interaction Restrictions
     * @description Limit interactions to a specific type of user for a specified duration
     */
    "interaction-limit": {
      limit: components["schemas"]["interaction-group"];
      expiry?: components["schemas"]["interaction-expiry"];
    };
    /**
     * Team Simple
     * @description Groups of organization members that gives permissions on specified repositories.
     */
    "nullable-team-simple": {
      /**
       * @description Unique identifier of the team
       * @example 1
       */
      id: number;
      /** @example MDQ6VGVhbTE= */
      node_id: string;
      /**
       * Format: uri
       * @description URL for the team
       * @example https://api.github.com/organizations/1/team/1
       */
      url: string;
      /** @example https://api.github.com/organizations/1/team/1/members{/member} */
      members_url: string;
      /**
       * @description Name of the team
       * @example Justice League
       */
      name: string;
      /**
       * @description Description of the team
       * @example A great team.
       */
      description: string | null;
      /**
       * @description Permission that the team will have for its repositories
       * @example admin
       */
      permission: string;
      /**
       * @description The level of privacy this team should have
       * @example closed
       */
      privacy?: string;
      /**
       * @description The notification setting the team has set
       * @example notifications_enabled
       */
      notification_setting?: string;
      /**
       * Format: uri
       * @example https://github.com/orgs/rails/teams/core
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/1/repos
       */
      repositories_url: string;
      /** @example justice-league */
      slug: string;
      /**
       * @description Distinguished Name (DN) that team maps to within LDAP environment
       * @example uid=example,ou=users,dc=github,dc=com
       */
      ldap_dn?: string;
    } | null;
    /**
     * Team
     * @description Groups of organization members that gives permissions on specified repositories.
     */
    team: {
      id: number;
      node_id: string;
      name: string;
      slug: string;
      description: string | null;
      privacy?: string;
      notification_setting?: string;
      permission: string;
      permissions?: {
        pull: boolean;
        triage: boolean;
        push: boolean;
        maintain: boolean;
        admin: boolean;
      };
      /** Format: uri */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/orgs/rails/teams/core
       */
      html_url: string;
      members_url: string;
      /** Format: uri */
      repositories_url: string;
      parent: components["schemas"]["nullable-team-simple"];
    };
    /**
     * Org Membership
     * @description Org Membership
     */
    "org-membership": {
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octocat/memberships/defunkt
       */
      url: string;
      /**
       * @description The state of the member in the organization. The `pending` state indicates the user has not yet accepted an invitation.
       * @example active
       * @enum {string}
       */
      state: "active" | "pending";
      /**
       * @description The user's membership type in the organization.
       * @example admin
       * @enum {string}
       */
      role: "admin" | "member" | "billing_manager";
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octocat
       */
      organization_url: string;
      organization: components["schemas"]["organization-simple"];
      user: components["schemas"]["nullable-simple-user"];
      permissions?: {
        can_create_repository: boolean;
      };
    };
    /**
     * Migration
     * @description A migration.
     */
    migration: {
      /** @example 79 */
      id: number;
      owner: components["schemas"]["nullable-simple-user"];
      /** @example 0b989ba4-242f-11e5-81e1-c7b6966d2516 */
      guid: string;
      /** @example pending */
      state: string;
      /** @example true */
      lock_repositories: boolean;
      exclude_metadata: boolean;
      exclude_git_data: boolean;
      exclude_attachments: boolean;
      exclude_releases: boolean;
      exclude_owner_projects: boolean;
      org_metadata_only: boolean;
      /** @description The repositories included in the migration. Only returned for export migrations. */
      repositories: components["schemas"]["repository"][];
      /**
       * Format: uri
       * @example https://api.github.com/orgs/octo-org/migrations/79
       */
      url: string;
      /**
       * Format: date-time
       * @example 2015-07-06T15:33:38-07:00
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2015-07-06T15:33:38-07:00
       */
      updated_at: string;
      node_id: string;
      /** Format: uri */
      archive_url?: string;
      /** @description Exclude related items from being returned in the response in order to improve performance of the request. The array can include any of: `"repositories"`. */
      exclude?: string[];
    };
    /**
     * Package Version
     * @description A version of a software package
     */
    "package-version": {
      /**
       * @description Unique identifier of the package version.
       * @example 1
       */
      id: number;
      /**
       * @description The name of the package version.
       * @example latest
       */
      name: string;
      /** @example https://api.github.com/orgs/github/packages/container/super-linter/versions/786068 */
      url: string;
      /** @example https://github.com/orgs/github/packages/container/package/super-linter */
      package_html_url: string;
      /** @example https://github.com/orgs/github/packages/container/super-linter/786068 */
      html_url?: string;
      /** @example MIT */
      license?: string;
      description?: string;
      /**
       * Format: date-time
       * @example 2011-04-10T20:09:31Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2014-03-03T18:58:10Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2014-03-03T18:58:10Z
       */
      deleted_at?: string;
      /** Package Version Metadata */
      metadata?: {
        /**
         * @example docker
         * @enum {string}
         */
        package_type:
          | "npm"
          | "maven"
          | "rubygems"
          | "docker"
          | "nuget"
          | "container";
        /** Container Metadata */
        container?: {
          tags: string[];
        };
        /** Docker Metadata */
        docker?: {
          tag?: string[];
        };
      };
    };
    /**
     * Project
     * @description Projects are a way to organize columns and cards of work.
     */
    project: {
      /**
       * Format: uri
       * @example https://api.github.com/repos/api-playground/projects-test
       */
      owner_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/1002604
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/api-playground/projects-test/projects/12
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/1002604/columns
       */
      columns_url: string;
      /** @example 1002604 */
      id: number;
      /** @example MDc6UHJvamVjdDEwMDI2MDQ= */
      node_id: string;
      /**
       * @description Name of the project
       * @example Week One Sprint
       */
      name: string;
      /**
       * @description Body of the project
       * @example This project represents the sprint of the first week in January
       */
      body: string | null;
      /** @example 1 */
      number: number;
      /**
       * @description State of the project; either 'open' or 'closed'
       * @example open
       */
      state: string;
      creator: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @example 2011-04-10T20:09:31Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2014-03-03T18:58:10Z
       */
      updated_at: string;
      /**
       * @description The baseline permission that all organization members have on this project. Only present if owner is an organization.
       * @enum {string}
       */
      organization_permission?: "read" | "write" | "admin" | "none";
      /** @description Whether or not this project can be seen by everyone. Only present if owner is an organization. */
      private?: boolean;
    };
    /**
     * @description The enforcement level of the ruleset. `evaluate` allows admins to test rules before enforcing them. Admins can view insights on the Rule Insights page (`evaluate` is only available with GitHub Enterprise).
     * @enum {string}
     */
    "repository-rule-enforcement": "disabled" | "active" | "evaluate";
    /**
     * Repository Ruleset Bypass Actor
     * @description An actor that can bypass rules in a ruleset
     */
    "repository-ruleset-bypass-actor": {
      /** @description The ID of the actor that can bypass a ruleset */
      actor_id?: number;
      /**
       * @description The type of actor that can bypass a ruleset
       * @enum {string}
       */
      actor_type?: "Team" | "Integration";
    };
    /**
     * Repository ruleset conditions for ref names
     * @description Parameters for a repository ruleset ref name condition
     */
    "repository-ruleset-conditions": {
      ref_name?: {
        /** @description Array of ref names or patterns to include. One of these patterns must match for the condition to pass. Also accepts `~DEFAULT_BRANCH` to include the default branch or `~ALL` to include all branches. */
        include?: string[];
        /** @description Array of ref names or patterns to exclude. The condition will not pass if any of these patterns match. */
        exclude?: string[];
      };
    };
    /**
     * Repository ruleset conditions for repository names
     * @description Parameters for a repository name condition
     */
    "repository-ruleset-conditions-repository-name-target": {
      repository_name?: {
        /** @description Array of repository names or patterns to include. One of these patterns must match for the condition to pass. Also accepts `~ALL` to include all repositories. */
        include?: string[];
        /** @description Array of repository names or patterns to exclude. The condition will not pass if any of these patterns match. */
        exclude?: string[];
        /** @description Whether renaming of target repositories is prevented. */
        protected?: boolean;
      };
    };
    /**
     * Organization ruleset conditions
     * @description Conditions for a organization ruleset
     */
    "org-ruleset-conditions": components["schemas"]["repository-ruleset-conditions"] &
      components["schemas"]["repository-ruleset-conditions-repository-name-target"];
    /**
     * creation
     * @description Parameters to be used for the creation rule
     */
    "repository-rule-creation": {
      /** @enum {string} */
      type: "creation";
    };
    /**
     * update
     * @description Parameters to be used for the update rule
     */
    "repository-rule-update": {
      /** @enum {string} */
      type: "update";
      parameters?: {
        /** @description Branch can pull changes from its upstream repository */
        update_allows_fetch_and_merge: boolean;
      };
    };
    /**
     * deletion
     * @description Parameters to be used for the deletion rule
     */
    "repository-rule-deletion": {
      /** @enum {string} */
      type: "deletion";
    };
    /**
     * required_linear_history
     * @description Parameters to be used for the required_linear_history rule
     */
    "repository-rule-required-linear-history": {
      /** @enum {string} */
      type: "required_linear_history";
    };
    /**
     * required_deployments
     * @description Parameters to be used for the required_deployments rule
     */
    "repository-rule-required-deployments": {
      /** @enum {string} */
      type: "required_deployments";
      parameters?: {
        /** @description The environments that must be successfully deployed to before branches can be merged. */
        required_deployment_environments: string[];
      };
    };
    /**
     * required_signatures
     * @description Parameters to be used for the required_signatures rule
     */
    "repository-rule-required-signatures": {
      /** @enum {string} */
      type: "required_signatures";
    };
    /**
     * pull_request
     * @description Parameters to be used for the pull_request rule
     */
    "repository-rule-pull-request": {
      /** @enum {string} */
      type: "pull_request";
      parameters?: {
        /** @description New, reviewable commits pushed will dismiss previous pull request review approvals. */
        dismiss_stale_reviews_on_push: boolean;
        /** @description Require an approving review in pull requests that modify files that have a designated code owner. */
        require_code_owner_review: boolean;
        /** @description Whether the most recent reviewable push must be approved by someone other than the person who pushed it. */
        require_last_push_approval: boolean;
        /** @description The number of approving reviews that are required before a pull request can be merged. */
        required_approving_review_count: number;
        /** @description All conversations on code must be resolved before a pull request can be merged. */
        required_review_thread_resolution: boolean;
      };
    };
    /**
     * StatusCheckConfiguration
     * @description Required status check
     */
    "repository-rule-params-status-check-configuration": {
      /** @description The status check context name that must be present on the commit. */
      context: string;
      /** @description The optional integration ID that this status check must originate from. */
      integration_id?: number;
    };
    /**
     * required_status_checks
     * @description Parameters to be used for the required_status_checks rule
     */
    "repository-rule-required-status-checks": {
      /** @enum {string} */
      type: "required_status_checks";
      parameters?: {
        /** @description Status checks that are required. */
        required_status_checks: components["schemas"]["repository-rule-params-status-check-configuration"][];
        /** @description Whether pull requests targeting a matching branch must be tested with the latest code. This setting will not take effect unless at least one status check is enabled. */
        strict_required_status_checks_policy: boolean;
      };
    };
    /**
     * non_fast_forward
     * @description Parameters to be used for the non_fast_forward rule
     */
    "repository-rule-non-fast-forward": {
      /** @enum {string} */
      type: "non_fast_forward";
    };
    /**
     * commit_message_pattern
     * @description Parameters to be used for the commit_message_pattern rule
     */
    "repository-rule-commit-message-pattern": {
      /** @enum {string} */
      type: "commit_message_pattern";
      parameters?: {
        /** @description How this rule will appear to users. */
        name?: string;
        /** @description If true, the rule will fail if the pattern matches. */
        negate?: boolean;
        /**
         * @description The operator to use for matching.
         * @enum {string}
         */
        operator: "starts_with" | "ends_with" | "contains" | "regex";
        /** @description The pattern to match with. */
        pattern: string;
      };
    };
    /**
     * commit_author_email_pattern
     * @description Parameters to be used for the commit_author_email_pattern rule
     */
    "repository-rule-commit-author-email-pattern": {
      /** @enum {string} */
      type: "commit_author_email_pattern";
      parameters?: {
        /** @description How this rule will appear to users. */
        name?: string;
        /** @description If true, the rule will fail if the pattern matches. */
        negate?: boolean;
        /**
         * @description The operator to use for matching.
         * @enum {string}
         */
        operator: "starts_with" | "ends_with" | "contains" | "regex";
        /** @description The pattern to match with. */
        pattern: string;
      };
    };
    /**
     * committer_email_pattern
     * @description Parameters to be used for the committer_email_pattern rule
     */
    "repository-rule-committer-email-pattern": {
      /** @enum {string} */
      type: "committer_email_pattern";
      parameters?: {
        /** @description How this rule will appear to users. */
        name?: string;
        /** @description If true, the rule will fail if the pattern matches. */
        negate?: boolean;
        /**
         * @description The operator to use for matching.
         * @enum {string}
         */
        operator: "starts_with" | "ends_with" | "contains" | "regex";
        /** @description The pattern to match with. */
        pattern: string;
      };
    };
    /**
     * branch_name_pattern
     * @description Parameters to be used for the branch_name_pattern rule
     */
    "repository-rule-branch-name-pattern": {
      /** @enum {string} */
      type: "branch_name_pattern";
      parameters?: {
        /** @description How this rule will appear to users. */
        name?: string;
        /** @description If true, the rule will fail if the pattern matches. */
        negate?: boolean;
        /**
         * @description The operator to use for matching.
         * @enum {string}
         */
        operator: "starts_with" | "ends_with" | "contains" | "regex";
        /** @description The pattern to match with. */
        pattern: string;
      };
    };
    /**
     * tag_name_pattern
     * @description Parameters to be used for the tag_name_pattern rule
     */
    "repository-rule-tag-name-pattern": {
      /** @enum {string} */
      type: "tag_name_pattern";
      parameters?: {
        /** @description How this rule will appear to users. */
        name?: string;
        /** @description If true, the rule will fail if the pattern matches. */
        negate?: boolean;
        /**
         * @description The operator to use for matching.
         * @enum {string}
         */
        operator: "starts_with" | "ends_with" | "contains" | "regex";
        /** @description The pattern to match with. */
        pattern: string;
      };
    };
    /**
     * Repository Rule
     * @description A repository rule.
     */
    "repository-rule":
      | components["schemas"]["repository-rule-creation"]
      | components["schemas"]["repository-rule-update"]
      | components["schemas"]["repository-rule-deletion"]
      | components["schemas"]["repository-rule-required-linear-history"]
      | components["schemas"]["repository-rule-required-deployments"]
      | components["schemas"]["repository-rule-required-signatures"]
      | components["schemas"]["repository-rule-pull-request"]
      | components["schemas"]["repository-rule-required-status-checks"]
      | components["schemas"]["repository-rule-non-fast-forward"]
      | components["schemas"]["repository-rule-commit-message-pattern"]
      | components["schemas"]["repository-rule-commit-author-email-pattern"]
      | components["schemas"]["repository-rule-committer-email-pattern"]
      | components["schemas"]["repository-rule-branch-name-pattern"]
      | components["schemas"]["repository-rule-tag-name-pattern"];
    /**
     * Repository ruleset
     * @description A set of rules to apply when specified conditions are met.
     */
    "repository-ruleset": {
      /** @description The ID of the ruleset */
      id: number;
      /** @description The name of the ruleset */
      name: string;
      /**
       * @description The target of the ruleset
       * @enum {string}
       */
      target?: "branch" | "tag";
      /**
       * @description The type of the source of the ruleset
       * @enum {string}
       */
      source_type?: "Repository" | "Organization";
      /** @description The name of the source */
      source: string;
      enforcement: components["schemas"]["repository-rule-enforcement"];
      /**
       * @description The permission level required to bypass this ruleset. "repository" allows those with bypass permission at the repository level to bypass. "organization" allows those with bypass permission at the organization level to bypass. "none" prevents anyone from bypassing.
       * @enum {string}
       */
      bypass_mode?: "none" | "repository" | "organization";
      /** @description The actors that can bypass the rules in this ruleset */
      bypass_actors?: components["schemas"]["repository-ruleset-bypass-actor"][];
      node_id?: string;
      _links?: {
        self?: {
          /** @description The URL of the ruleset */
          href?: string;
        };
      };
      conditions?:
        | components["schemas"]["repository-ruleset-conditions"]
        | components["schemas"]["org-ruleset-conditions"];
      rules?: components["schemas"]["repository-rule"][];
    };
    /**
     * Team Simple
     * @description Groups of organization members that gives permissions on specified repositories.
     */
    "team-simple": {
      /**
       * @description Unique identifier of the team
       * @example 1
       */
      id: number;
      /** @example MDQ6VGVhbTE= */
      node_id: string;
      /**
       * Format: uri
       * @description URL for the team
       * @example https://api.github.com/organizations/1/team/1
       */
      url: string;
      /** @example https://api.github.com/organizations/1/team/1/members{/member} */
      members_url: string;
      /**
       * @description Name of the team
       * @example Justice League
       */
      name: string;
      /**
       * @description Description of the team
       * @example A great team.
       */
      description: string | null;
      /**
       * @description Permission that the team will have for its repositories
       * @example admin
       */
      permission: string;
      /**
       * @description The level of privacy this team should have
       * @example closed
       */
      privacy?: string;
      /**
       * @description The notification setting the team has set
       * @example notifications_enabled
       */
      notification_setting?: string;
      /**
       * Format: uri
       * @example https://github.com/orgs/rails/teams/core
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/1/repos
       */
      repositories_url: string;
      /** @example justice-league */
      slug: string;
      /**
       * @description Distinguished Name (DN) that team maps to within LDAP environment
       * @example uid=example,ou=users,dc=github,dc=com
       */
      ldap_dn?: string;
    };
    "actions-billing-usage": {
      /** @description The sum of the free and paid GitHub Actions minutes used. */
      total_minutes_used: number;
      /** @description The total paid GitHub Actions minutes used. */
      total_paid_minutes_used: number;
      /** @description The amount of free GitHub Actions minutes available. */
      included_minutes: number;
      minutes_used_breakdown: {
        /** @description Total minutes used on Ubuntu runner machines. */
        UBUNTU?: number;
        /** @description Total minutes used on macOS runner machines. */
        MACOS?: number;
        /** @description Total minutes used on Windows runner machines. */
        WINDOWS?: number;
        /** @description Total minutes used on Ubuntu 4 core runner machines. */
        ubuntu_4_core?: number;
        /** @description Total minutes used on Ubuntu 8 core runner machines. */
        ubuntu_8_core?: number;
        /** @description Total minutes used on Ubuntu 16 core runner machines. */
        ubuntu_16_core?: number;
        /** @description Total minutes used on Ubuntu 32 core runner machines. */
        ubuntu_32_core?: number;
        /** @description Total minutes used on Ubuntu 64 core runner machines. */
        ubuntu_64_core?: number;
        /** @description Total minutes used on Windows 4 core runner machines. */
        windows_4_core?: number;
        /** @description Total minutes used on Windows 8 core runner machines. */
        windows_8_core?: number;
        /** @description Total minutes used on Windows 16 core runner machines. */
        windows_16_core?: number;
        /** @description Total minutes used on Windows 32 core runner machines. */
        windows_32_core?: number;
        /** @description Total minutes used on Windows 64 core runner machines. */
        windows_64_core?: number;
        /** @description Total minutes used on macOS 12 core runner machines. */
        macos_12_core?: number;
        /** @description Total minutes used on all runner machines. */
        total?: number;
      };
    };
    "packages-billing-usage": {
      /** @description Sum of the free and paid storage space (GB) for GitHuub Packages. */
      total_gigabytes_bandwidth_used: number;
      /** @description Total paid storage space (GB) for GitHuub Packages. */
      total_paid_gigabytes_bandwidth_used: number;
      /** @description Free storage space (GB) for GitHub Packages. */
      included_gigabytes_bandwidth: number;
    };
    "combined-billing-usage": {
      /** @description Numbers of days left in billing cycle. */
      days_left_in_billing_cycle: number;
      /** @description Estimated storage space (GB) used in billing cycle. */
      estimated_paid_storage_for_month: number;
      /** @description Estimated sum of free and paid storage space (GB) used in billing cycle. */
      estimated_storage_for_month: number;
    };
    /**
     * Team Organization
     * @description Team Organization
     */
    "team-organization": {
      /** @example github */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDEyOk9yZ2FuaXphdGlvbjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/repos
       */
      repos_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/orgs/github/events
       */
      events_url: string;
      /** @example https://api.github.com/orgs/github/hooks */
      hooks_url: string;
      /** @example https://api.github.com/orgs/github/issues */
      issues_url: string;
      /** @example https://api.github.com/orgs/github/members{/member} */
      members_url: string;
      /** @example https://api.github.com/orgs/github/public_members{/member} */
      public_members_url: string;
      /** @example https://github.com/images/error/octocat_happy.gif */
      avatar_url: string;
      /** @example A great organization */
      description: string | null;
      /** @example github */
      name?: string;
      /** @example GitHub */
      company?: string;
      /**
       * Format: uri
       * @example https://github.com/blog
       */
      blog?: string;
      /** @example San Francisco */
      location?: string;
      /**
       * Format: email
       * @example octocat@github.com
       */
      email?: string;
      /** @example github */
      twitter_username?: string | null;
      /** @example true */
      is_verified?: boolean;
      /** @example true */
      has_organization_projects: boolean;
      /** @example true */
      has_repository_projects: boolean;
      /** @example 2 */
      public_repos: number;
      /** @example 1 */
      public_gists: number;
      /** @example 20 */
      followers: number;
      /** @example 0 */
      following: number;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: date-time
       * @example 2008-01-14T04:33:35Z
       */
      created_at: string;
      /** @example Organization */
      type: string;
      /** @example 100 */
      total_private_repos?: number;
      /** @example 100 */
      owned_private_repos?: number;
      /** @example 81 */
      private_gists?: number | null;
      /** @example 10000 */
      disk_usage?: number | null;
      /** @example 8 */
      collaborators?: number | null;
      /**
       * Format: email
       * @example org@example.com
       */
      billing_email?: string | null;
      plan?: {
        name: string;
        space: number;
        private_repos: number;
        filled_seats?: number;
        seats?: number;
      };
      default_repository_permission?: string | null;
      /** @example true */
      members_can_create_repositories?: boolean | null;
      /** @example true */
      two_factor_requirement_enabled?: boolean | null;
      /** @example all */
      members_allowed_repository_creation_type?: string;
      /** @example true */
      members_can_create_public_repositories?: boolean;
      /** @example true */
      members_can_create_private_repositories?: boolean;
      /** @example true */
      members_can_create_internal_repositories?: boolean;
      /** @example true */
      members_can_create_pages?: boolean;
      /** @example true */
      members_can_create_public_pages?: boolean;
      /** @example true */
      members_can_create_private_pages?: boolean;
      /** @example false */
      members_can_fork_private_repositories?: boolean | null;
      /** @example false */
      web_commit_signoff_required?: boolean;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Full Team
     * @description Groups of organization members that gives permissions on specified repositories.
     */
    "team-full": {
      /**
       * @description Unique identifier of the team
       * @example 42
       */
      id: number;
      /** @example MDQ6VGVhbTE= */
      node_id: string;
      /**
       * Format: uri
       * @description URL for the team
       * @example https://api.github.com/organizations/1/team/1
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/orgs/rails/teams/core
       */
      html_url: string;
      /**
       * @description Name of the team
       * @example Developers
       */
      name: string;
      /** @example justice-league */
      slug: string;
      /** @example A great team. */
      description: string | null;
      /**
       * @description The level of privacy this team should have
       * @example closed
       * @enum {string}
       */
      privacy?: "closed" | "secret";
      /**
       * @description The notification setting the team has set
       * @example notifications_enabled
       * @enum {string}
       */
      notification_setting?: "notifications_enabled" | "notifications_disabled";
      /**
       * @description Permission that the team will have for its repositories
       * @example push
       */
      permission: string;
      /** @example https://api.github.com/organizations/1/team/1/members{/member} */
      members_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/1/repos
       */
      repositories_url: string;
      parent?: components["schemas"]["nullable-team-simple"];
      /** @example 3 */
      members_count: number;
      /** @example 10 */
      repos_count: number;
      /**
       * Format: date-time
       * @example 2017-07-14T16:53:42Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2017-08-17T12:37:15Z
       */
      updated_at: string;
      organization: components["schemas"]["team-organization"];
      /**
       * @description Distinguished Name (DN) that team maps to within LDAP environment
       * @example uid=example,ou=users,dc=github,dc=com
       */
      ldap_dn?: string;
    };
    /**
     * Team Discussion
     * @description A team discussion is a persistent record of a free-form conversation within a team.
     */
    "team-discussion": {
      author: components["schemas"]["nullable-simple-user"];
      /**
       * @description The main text of the discussion.
       * @example Please suggest improvements to our workflow in comments.
       */
      body: string;
      /** @example <p>Hi! This is an area for us to collaborate as a team</p> */
      body_html: string;
      /**
       * @description The current version of the body content. If provided, this update operation will be rejected if the given version does not match the latest version on the server.
       * @example 0307116bbf7ced493b8d8a346c650b71
       */
      body_version: string;
      /** @example 0 */
      comments_count: number;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/2343027/discussions/1/comments
       */
      comments_url: string;
      /**
       * Format: date-time
       * @example 2018-01-25T18:56:31Z
       */
      created_at: string;
      /** Format: date-time */
      last_edited_at: string | null;
      /**
       * Format: uri
       * @example https://github.com/orgs/github/teams/justice-league/discussions/1
       */
      html_url: string;
      /** @example MDE0OlRlYW1EaXNjdXNzaW9uMQ== */
      node_id: string;
      /**
       * @description The unique sequence number of a team discussion.
       * @example 42
       */
      number: number;
      /**
       * @description Whether or not this discussion should be pinned for easy retrieval.
       * @example true
       */
      pinned: boolean;
      /**
       * @description Whether or not this discussion should be restricted to team members and organization administrators.
       * @example true
       */
      private: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/2343027
       */
      team_url: string;
      /**
       * @description The title of the discussion.
       * @example How can we improve our workflow?
       */
      title: string;
      /**
       * Format: date-time
       * @example 2018-01-25T18:56:31Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/2343027/discussions/1
       */
      url: string;
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Team Discussion Comment
     * @description A reply to a discussion within a team.
     */
    "team-discussion-comment": {
      author: components["schemas"]["nullable-simple-user"];
      /**
       * @description The main text of the comment.
       * @example I agree with this suggestion.
       */
      body: string;
      /** @example <p>Do you like apples?</p> */
      body_html: string;
      /**
       * @description The current version of the body content. If provided, this update operation will be rejected if the given version does not match the latest version on the server.
       * @example 0307116bbf7ced493b8d8a346c650b71
       */
      body_version: string;
      /**
       * Format: date-time
       * @example 2018-01-15T23:53:58Z
       */
      created_at: string;
      /** Format: date-time */
      last_edited_at: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/2403582/discussions/1
       */
      discussion_url: string;
      /**
       * Format: uri
       * @example https://github.com/orgs/github/teams/justice-league/discussions/1/comments/1
       */
      html_url: string;
      /** @example MDIxOlRlYW1EaXNjdXNzaW9uQ29tbWVudDE= */
      node_id: string;
      /**
       * @description The unique sequence number of a team discussion comment.
       * @example 42
       */
      number: number;
      /**
       * Format: date-time
       * @example 2018-01-15T23:53:58Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/organizations/1/team/2403582/discussions/1/comments/1
       */
      url: string;
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Reaction
     * @description Reactions to conversations provide a way to help people express their feelings more simply and effectively.
     */
    reaction: {
      /** @example 1 */
      id: number;
      /** @example MDg6UmVhY3Rpb24x */
      node_id: string;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * @description The reaction to use
       * @example heart
       * @enum {string}
       */
      content:
        | "+1"
        | "-1"
        | "laugh"
        | "confused"
        | "heart"
        | "hooray"
        | "rocket"
        | "eyes";
      /**
       * Format: date-time
       * @example 2016-05-20T20:09:31Z
       */
      created_at: string;
    };
    /**
     * Team Membership
     * @description Team Membership
     */
    "team-membership": {
      /** Format: uri */
      url: string;
      /**
       * @description The role of the user in the team.
       * @default member
       * @example member
       * @enum {string}
       */
      role: "member" | "maintainer";
      /**
       * @description The state of the user's membership in the team.
       * @enum {string}
       */
      state: "active" | "pending";
    };
    /**
     * Team Project
     * @description A team's access to a project.
     */
    "team-project": {
      owner_url: string;
      url: string;
      html_url: string;
      columns_url: string;
      id: number;
      node_id: string;
      name: string;
      body: string | null;
      number: number;
      state: string;
      creator: components["schemas"]["simple-user"];
      created_at: string;
      updated_at: string;
      /** @description The organization permission for this project. Only present when owner is an organization. */
      organization_permission?: string;
      /** @description Whether the project is private or not. Only present when owner is an organization. */
      private?: boolean;
      permissions: {
        read: boolean;
        write: boolean;
        admin: boolean;
      };
    };
    /**
     * Repository
     * @description A repository on GitHub.
     */
    "nullable-repository": {
      /**
       * @description Unique identifier of the repository
       * @example 42
       */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /**
       * @description The name of the repository.
       * @example Team Environment
       */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      license: components["schemas"]["nullable-license-simple"];
      organization?: components["schemas"]["nullable-simple-user"];
      forks: number;
      permissions?: {
        admin: boolean;
        pull: boolean;
        triage?: boolean;
        push: boolean;
        maintain?: boolean;
      };
      owner: components["schemas"]["simple-user"];
      /**
       * @description Whether the repository is private or public.
       * @default false
       */
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      /** @example git:github.com/octocat/Hello-World.git */
      git_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      /** @example git@github.com:octocat/Hello-World.git */
      ssh_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      /** @example https://github.com/octocat/Hello-World.git */
      clone_url: string;
      /**
       * Format: uri
       * @example git:git.example.com/octocat/Hello-World
       */
      mirror_url: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      /**
       * Format: uri
       * @example https://svn.github.com/octocat/Hello-World
       */
      svn_url: string;
      /**
       * Format: uri
       * @example https://github.com
       */
      homepage: string | null;
      language: string | null;
      /** @example 9 */
      forks_count: number;
      /** @example 80 */
      stargazers_count: number;
      /** @example 80 */
      watchers_count: number;
      /**
       * @description The size of the repository. Size is calculated hourly. When a repository is initially created, the size is 0.
       * @example 108
       */
      size: number;
      /**
       * @description The default branch of the repository.
       * @example master
       */
      default_branch: string;
      /** @example 0 */
      open_issues_count: number;
      /**
       * @description Whether this repository acts as a template that can be used to generate new repositories.
       * @default false
       * @example true
       */
      is_template?: boolean;
      topics?: string[];
      /**
       * @description Whether issues are enabled.
       * @default true
       * @example true
       */
      has_issues: boolean;
      /**
       * @description Whether projects are enabled.
       * @default true
       * @example true
       */
      has_projects: boolean;
      /**
       * @description Whether the wiki is enabled.
       * @default true
       * @example true
       */
      has_wiki: boolean;
      has_pages: boolean;
      /**
       * @description Whether downloads are enabled.
       * @default true
       * @example true
       */
      has_downloads: boolean;
      /**
       * @description Whether discussions are enabled.
       * @default false
       * @example true
       */
      has_discussions?: boolean;
      /**
       * @description Whether the repository is archived.
       * @default false
       */
      archived: boolean;
      /** @description Returns whether or not this repository disabled. */
      disabled: boolean;
      /**
       * @description The repository visibility: public, private, or internal.
       * @default public
       */
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at: string | null;
      /**
       * @description Whether to allow rebase merges for pull requests.
       * @default true
       * @example true
       */
      allow_rebase_merge?: boolean;
      template_repository?: {
        id?: number;
        node_id?: string;
        name?: string;
        full_name?: string;
        owner?: {
          login?: string;
          id?: number;
          node_id?: string;
          avatar_url?: string;
          gravatar_id?: string;
          url?: string;
          html_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          starred_url?: string;
          subscriptions_url?: string;
          organizations_url?: string;
          repos_url?: string;
          events_url?: string;
          received_events_url?: string;
          type?: string;
          site_admin?: boolean;
        };
        private?: boolean;
        html_url?: string;
        description?: string;
        fork?: boolean;
        url?: string;
        archive_url?: string;
        assignees_url?: string;
        blobs_url?: string;
        branches_url?: string;
        collaborators_url?: string;
        comments_url?: string;
        commits_url?: string;
        compare_url?: string;
        contents_url?: string;
        contributors_url?: string;
        deployments_url?: string;
        downloads_url?: string;
        events_url?: string;
        forks_url?: string;
        git_commits_url?: string;
        git_refs_url?: string;
        git_tags_url?: string;
        git_url?: string;
        issue_comment_url?: string;
        issue_events_url?: string;
        issues_url?: string;
        keys_url?: string;
        labels_url?: string;
        languages_url?: string;
        merges_url?: string;
        milestones_url?: string;
        notifications_url?: string;
        pulls_url?: string;
        releases_url?: string;
        ssh_url?: string;
        stargazers_url?: string;
        statuses_url?: string;
        subscribers_url?: string;
        subscription_url?: string;
        tags_url?: string;
        teams_url?: string;
        trees_url?: string;
        clone_url?: string;
        mirror_url?: string;
        hooks_url?: string;
        svn_url?: string;
        homepage?: string;
        language?: string;
        forks_count?: number;
        stargazers_count?: number;
        watchers_count?: number;
        size?: number;
        default_branch?: string;
        open_issues_count?: number;
        is_template?: boolean;
        topics?: string[];
        has_issues?: boolean;
        has_projects?: boolean;
        has_wiki?: boolean;
        has_pages?: boolean;
        has_downloads?: boolean;
        archived?: boolean;
        disabled?: boolean;
        visibility?: string;
        pushed_at?: string;
        created_at?: string;
        updated_at?: string;
        permissions?: {
          admin?: boolean;
          maintain?: boolean;
          push?: boolean;
          triage?: boolean;
          pull?: boolean;
        };
        allow_rebase_merge?: boolean;
        temp_clone_token?: string;
        allow_squash_merge?: boolean;
        allow_auto_merge?: boolean;
        delete_branch_on_merge?: boolean;
        allow_update_branch?: boolean;
        use_squash_pr_title_as_default?: boolean;
        /**
         * @description The default value for a squash merge commit title:
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description The default value for a squash merge commit message:
         *
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a merge commit message.
         *
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        allow_merge_commit?: boolean;
        subscribers_count?: number;
        network_count?: number;
      } | null;
      temp_clone_token?: string;
      /**
       * @description Whether to allow squash merges for pull requests.
       * @default true
       * @example true
       */
      allow_squash_merge?: boolean;
      /**
       * @description Whether to allow Auto-merge to be used on pull requests.
       * @default false
       * @example false
       */
      allow_auto_merge?: boolean;
      /**
       * @description Whether to delete head branches when pull requests are merged
       * @default false
       * @example false
       */
      delete_branch_on_merge?: boolean;
      /**
       * @description Whether or not a pull request head branch that is behind its base branch can always be updated even if it is not required to be up to date before merging.
       * @default false
       * @example false
       */
      allow_update_branch?: boolean;
      /**
       * @deprecated
       * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
       * @default false
       */
      use_squash_pr_title_as_default?: boolean;
      /**
       * @description The default value for a squash merge commit title:
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
       * @enum {string}
       */
      squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
      /**
       * @description The default value for a squash merge commit message:
       *
       * - `PR_BODY` - default to the pull request's body.
       * - `COMMIT_MESSAGES` - default to the branch's commit messages.
       * - `BLANK` - default to a blank commit message.
       * @enum {string}
       */
      squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
      /**
       * @description The default value for a merge commit title.
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
       * @enum {string}
       */
      merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
      /**
       * @description The default value for a merge commit message.
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `PR_BODY` - default to the pull request's body.
       * - `BLANK` - default to a blank commit message.
       * @enum {string}
       */
      merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
      /**
       * @description Whether to allow merge commits for pull requests.
       * @default true
       * @example true
       */
      allow_merge_commit?: boolean;
      /** @description Whether to allow forking this repo */
      allow_forking?: boolean;
      /**
       * @description Whether to require contributors to sign off on web-based commits
       * @default false
       */
      web_commit_signoff_required?: boolean;
      subscribers_count?: number;
      network_count?: number;
      open_issues: number;
      watchers: number;
      master_branch?: string;
      /** @example "2020-07-09T00:17:42Z" */
      starred_at?: string;
      /** @description Whether anonymous git access is enabled for this repository */
      anonymous_access_enabled?: boolean;
    } | null;
    /**
     * Team Repository
     * @description A team's access to a repository.
     */
    "team-repository": {
      /**
       * @description Unique identifier of the repository
       * @example 42
       */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /**
       * @description The name of the repository.
       * @example Team Environment
       */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      license: components["schemas"]["nullable-license-simple"];
      forks: number;
      permissions?: {
        admin: boolean;
        pull: boolean;
        triage?: boolean;
        push: boolean;
        maintain?: boolean;
      };
      /** @example admin */
      role_name?: string;
      owner: components["schemas"]["nullable-simple-user"];
      /**
       * @description Whether the repository is private or public.
       * @default false
       */
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      /** @example git:github.com/octocat/Hello-World.git */
      git_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      /** @example git@github.com:octocat/Hello-World.git */
      ssh_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      /** @example https://github.com/octocat/Hello-World.git */
      clone_url: string;
      /**
       * Format: uri
       * @example git:git.example.com/octocat/Hello-World
       */
      mirror_url: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      /**
       * Format: uri
       * @example https://svn.github.com/octocat/Hello-World
       */
      svn_url: string;
      /**
       * Format: uri
       * @example https://github.com
       */
      homepage: string | null;
      language: string | null;
      /** @example 9 */
      forks_count: number;
      /** @example 80 */
      stargazers_count: number;
      /** @example 80 */
      watchers_count: number;
      /** @example 108 */
      size: number;
      /**
       * @description The default branch of the repository.
       * @example master
       */
      default_branch: string;
      /** @example 0 */
      open_issues_count: number;
      /**
       * @description Whether this repository acts as a template that can be used to generate new repositories.
       * @default false
       * @example true
       */
      is_template?: boolean;
      topics?: string[];
      /**
       * @description Whether issues are enabled.
       * @default true
       * @example true
       */
      has_issues: boolean;
      /**
       * @description Whether projects are enabled.
       * @default true
       * @example true
       */
      has_projects: boolean;
      /**
       * @description Whether the wiki is enabled.
       * @default true
       * @example true
       */
      has_wiki: boolean;
      has_pages: boolean;
      /**
       * @description Whether downloads are enabled.
       * @default true
       * @example true
       */
      has_downloads: boolean;
      /**
       * @description Whether the repository is archived.
       * @default false
       */
      archived: boolean;
      /** @description Returns whether or not this repository disabled. */
      disabled: boolean;
      /**
       * @description The repository visibility: public, private, or internal.
       * @default public
       */
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at: string | null;
      /**
       * @description Whether to allow rebase merges for pull requests.
       * @default true
       * @example true
       */
      allow_rebase_merge?: boolean;
      template_repository?: components["schemas"]["nullable-repository"];
      temp_clone_token?: string;
      /**
       * @description Whether to allow squash merges for pull requests.
       * @default true
       * @example true
       */
      allow_squash_merge?: boolean;
      /**
       * @description Whether to allow Auto-merge to be used on pull requests.
       * @default false
       * @example false
       */
      allow_auto_merge?: boolean;
      /**
       * @description Whether to delete head branches when pull requests are merged
       * @default false
       * @example false
       */
      delete_branch_on_merge?: boolean;
      /**
       * @description Whether to allow merge commits for pull requests.
       * @default true
       * @example true
       */
      allow_merge_commit?: boolean;
      /**
       * @description Whether to allow forking this repo
       * @default false
       * @example false
       */
      allow_forking?: boolean;
      /**
       * @description Whether to require contributors to sign off on web-based commits
       * @default false
       * @example false
       */
      web_commit_signoff_required?: boolean;
      subscribers_count?: number;
      network_count?: number;
      open_issues: number;
      watchers: number;
      master_branch?: string;
    };
    /**
     * Project Card
     * @description Project cards represent a scope of work.
     */
    "project-card": {
      /**
       * Format: uri
       * @example https://api.github.com/projects/columns/cards/1478
       */
      url: string;
      /**
       * @description The project card's ID
       * @example 42
       */
      id: number;
      /** @example MDExOlByb2plY3RDYXJkMTQ3OA== */
      node_id: string;
      /** @example Add payload for delete Project column */
      note: string | null;
      creator: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @example 2016-09-05T14:21:06Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2016-09-05T14:20:22Z
       */
      updated_at: string;
      /**
       * @description Whether or not the card is archived
       * @example false
       */
      archived?: boolean;
      column_name?: string;
      project_id?: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/columns/367
       */
      column_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/api-playground/projects-test/issues/3
       */
      content_url?: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/120
       */
      project_url: string;
    };
    /**
     * Project Column
     * @description Project columns contain cards of work.
     */
    "project-column": {
      /**
       * Format: uri
       * @example https://api.github.com/projects/columns/367
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/120
       */
      project_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/projects/columns/367/cards
       */
      cards_url: string;
      /**
       * @description The unique identifier of the project column
       * @example 42
       */
      id: number;
      /** @example MDEzOlByb2plY3RDb2x1bW4zNjc= */
      node_id: string;
      /**
       * @description Name of the project column
       * @example Remaining tasks
       */
      name: string;
      /**
       * Format: date-time
       * @example 2016-09-05T14:18:44Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2016-09-05T14:22:28Z
       */
      updated_at: string;
    };
    /**
     * Project Collaborator Permission
     * @description Project Collaborator Permission
     */
    "project-collaborator-permission": {
      permission: string;
      user: components["schemas"]["nullable-simple-user"];
    };
    /** Rate Limit */
    "rate-limit": {
      limit: number;
      remaining: number;
      reset: number;
      used: number;
    };
    /**
     * Rate Limit Overview
     * @description Rate Limit Overview
     */
    "rate-limit-overview": {
      resources: {
        core: components["schemas"]["rate-limit"];
        graphql?: components["schemas"]["rate-limit"];
        search: components["schemas"]["rate-limit"];
        source_import?: components["schemas"]["rate-limit"];
        integration_manifest?: components["schemas"]["rate-limit"];
        code_scanning_upload?: components["schemas"]["rate-limit"];
        actions_runner_registration?: components["schemas"]["rate-limit"];
        scim?: components["schemas"]["rate-limit"];
        dependency_snapshots?: components["schemas"]["rate-limit"];
      };
      rate: components["schemas"]["rate-limit"];
    };
    /**
     * Required workflow
     * @description A GitHub Actions required workflow
     */
    "repo-required-workflow": {
      /** @example 5 */
      id: number;
      /** @example MDg6V29ya2Zsb3cxMg== */
      node_id: string;
      /** @example Required CI */
      name: string;
      /** @example .github/workflows/required_ci.yaml */
      path: string;
      /**
       * @example active
       * @enum {string}
       */
      state: "active" | "deleted";
      source_repository: components["schemas"]["minimal-repository"];
      /**
       * Format: date-time
       * @example 2019-12-06T14:20:20.000Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2019-12-06T14:20:20.000Z
       */
      updated_at: string;
      /** @example https://api.github.com/repos/sample-org/sample-repo/actions/required_workflows/5 */
      url: string;
      /** @example https://github.com/sample-org/source-repo/blob/main/.github/workflows/required_ci.yaml */
      html_url: string;
      /** @example https://github.com/sample-org/sample-repo/workflows/required/sample-org/source-repo/.github/workflows/required_ci.yaml/badge.svg */
      badge_url: string;
    };
    /**
     * Workflow Usage
     * @description Workflow Usage
     */
    "workflow-usage": {
      billable: {
        UBUNTU?: {
          total_ms?: number;
        };
        MACOS?: {
          total_ms?: number;
        };
        WINDOWS?: {
          total_ms?: number;
        };
      };
    };
    /**
     * Code Of Conduct Simple
     * @description Code of Conduct Simple
     */
    "code-of-conduct-simple": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/github/docs/community/code_of_conduct
       */
      url: string;
      /** @example citizen_code_of_conduct */
      key: string;
      /** @example Citizen Code of Conduct */
      name: string;
      /**
       * Format: uri
       * @example https://github.com/github/docs/blob/main/CODE_OF_CONDUCT.md
       */
      html_url: string | null;
    };
    /**
     * Full Repository
     * @description Full Repository
     */
    "full-repository": {
      /** @example 1296269 */
      id: number;
      /** @example MDEwOlJlcG9zaXRvcnkxMjk2MjY5 */
      node_id: string;
      /** @example Hello-World */
      name: string;
      /** @example octocat/Hello-World */
      full_name: string;
      owner: components["schemas"]["simple-user"];
      private: boolean;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World
       */
      html_url: string;
      /** @example This your first repo! */
      description: string | null;
      fork: boolean;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World
       */
      url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/{archive_format}{/ref} */
      archive_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/assignees{/user} */
      assignees_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/blobs{/sha} */
      blobs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/branches{/branch} */
      branches_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/collaborators{/collaborator} */
      collaborators_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/comments{/number} */
      comments_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/commits{/sha} */
      commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/compare/{base}...{head} */
      compare_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/contents/{+path} */
      contents_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/contributors
       */
      contributors_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/deployments
       */
      deployments_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/downloads
       */
      downloads_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/events
       */
      events_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/forks
       */
      forks_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/commits{/sha} */
      git_commits_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/refs{/sha} */
      git_refs_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/tags{/sha} */
      git_tags_url: string;
      /** @example git:github.com/octocat/Hello-World.git */
      git_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/comments{/number} */
      issue_comment_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues/events{/number} */
      issue_events_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/issues{/number} */
      issues_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/keys{/key_id} */
      keys_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/labels{/name} */
      labels_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/languages
       */
      languages_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/merges
       */
      merges_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/milestones{/number} */
      milestones_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/notifications{?since,all,participating} */
      notifications_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/pulls{/number} */
      pulls_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/releases{/id} */
      releases_url: string;
      /** @example git@github.com:octocat/Hello-World.git */
      ssh_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/stargazers
       */
      stargazers_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/statuses/{sha} */
      statuses_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscribers
       */
      subscribers_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/subscription
       */
      subscription_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/tags
       */
      tags_url: string;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/teams
       */
      teams_url: string;
      /** @example http://api.github.com/repos/octocat/Hello-World/git/trees{/sha} */
      trees_url: string;
      /** @example https://github.com/octocat/Hello-World.git */
      clone_url: string;
      /**
       * Format: uri
       * @example git:git.example.com/octocat/Hello-World
       */
      mirror_url: string | null;
      /**
       * Format: uri
       * @example http://api.github.com/repos/octocat/Hello-World/hooks
       */
      hooks_url: string;
      /**
       * Format: uri
       * @example https://svn.github.com/octocat/Hello-World
       */
      svn_url: string;
      /**
       * Format: uri
       * @example https://github.com
       */
      homepage: string | null;
      language: string | null;
      /** @example 9 */
      forks_count: number;
      /** @example 80 */
      stargazers_count: number;
      /** @example 80 */
      watchers_count: number;
      /**
       * @description The size of the repository. Size is calculated hourly. When a repository is initially created, the size is 0.
       * @example 108
       */
      size: number;
      /** @example master */
      default_branch: string;
      /** @example 0 */
      open_issues_count: number;
      /** @example true */
      is_template?: boolean;
      /**
       * @example [
       *   "octocat",
       *   "atom",
       *   "electron",
       *   "API"
       * ]
       */
      topics?: string[];
      /** @example true */
      has_issues: boolean;
      /** @example true */
      has_projects: boolean;
      /** @example true */
      has_wiki: boolean;
      has_pages: boolean;
      /** @example true */
      has_downloads: boolean;
      /** @example true */
      has_discussions: boolean;
      archived: boolean;
      /** @description Returns whether or not this repository disabled. */
      disabled: boolean;
      /**
       * @description The repository visibility: public, private, or internal.
       * @example public
       */
      visibility?: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:06:43Z
       */
      pushed_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:14:43Z
       */
      updated_at: string;
      permissions?: {
        admin: boolean;
        maintain?: boolean;
        push: boolean;
        triage?: boolean;
        pull: boolean;
      };
      /** @example true */
      allow_rebase_merge?: boolean;
      template_repository?: components["schemas"]["nullable-repository"];
      temp_clone_token?: string | null;
      /** @example true */
      allow_squash_merge?: boolean;
      /** @example false */
      allow_auto_merge?: boolean;
      /** @example false */
      delete_branch_on_merge?: boolean;
      /** @example true */
      allow_merge_commit?: boolean;
      /** @example true */
      allow_update_branch?: boolean;
      /** @example false */
      use_squash_pr_title_as_default?: boolean;
      /**
       * @description The default value for a squash merge commit title:
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
       * @example PR_TITLE
       * @enum {string}
       */
      squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
      /**
       * @description The default value for a squash merge commit message:
       *
       * - `PR_BODY` - default to the pull request's body.
       * - `COMMIT_MESSAGES` - default to the branch's commit messages.
       * - `BLANK` - default to a blank commit message.
       * @example PR_BODY
       * @enum {string}
       */
      squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
      /**
       * @description The default value for a merge commit title.
       *
       *   - `PR_TITLE` - default to the pull request's title.
       *   - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
       * @example PR_TITLE
       * @enum {string}
       */
      merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
      /**
       * @description The default value for a merge commit message.
       *
       * - `PR_TITLE` - default to the pull request's title.
       * - `PR_BODY` - default to the pull request's body.
       * - `BLANK` - default to a blank commit message.
       * @example PR_BODY
       * @enum {string}
       */
      merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
      /** @example true */
      allow_forking?: boolean;
      /** @example false */
      web_commit_signoff_required?: boolean;
      /** @example 42 */
      subscribers_count: number;
      /** @example 0 */
      network_count: number;
      license: components["schemas"]["nullable-license-simple"];
      organization?: components["schemas"]["nullable-simple-user"];
      parent?: components["schemas"]["repository"];
      source?: components["schemas"]["repository"];
      forks: number;
      master_branch?: string;
      open_issues: number;
      watchers: number;
      /**
       * @description Whether anonymous git access is allowed.
       * @default true
       */
      anonymous_access_enabled?: boolean;
      code_of_conduct?: components["schemas"]["code-of-conduct-simple"];
      security_and_analysis?: components["schemas"]["security-and-analysis"];
    };
    /**
     * Artifact
     * @description An artifact
     */
    artifact: {
      /** @example 5 */
      id: number;
      /** @example MDEwOkNoZWNrU3VpdGU1 */
      node_id: string;
      /**
       * @description The name of the artifact.
       * @example AdventureWorks.Framework
       */
      name: string;
      /**
       * @description The size in bytes of the artifact.
       * @example 12345
       */
      size_in_bytes: number;
      /** @example https://api.github.com/repos/github/hello-world/actions/artifacts/5 */
      url: string;
      /** @example https://api.github.com/repos/github/hello-world/actions/artifacts/5/zip */
      archive_download_url: string;
      /** @description Whether or not the artifact has expired. */
      expired: boolean;
      /** Format: date-time */
      created_at: string | null;
      /** Format: date-time */
      expires_at: string | null;
      /** Format: date-time */
      updated_at: string | null;
      workflow_run?: {
        /** @example 10 */
        id?: number;
        /** @example 42 */
        repository_id?: number;
        /** @example 42 */
        head_repository_id?: number;
        /** @example main */
        head_branch?: string;
        /** @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d */
        head_sha?: string;
      } | null;
    };
    /**
     * Repository actions caches
     * @description Repository actions caches
     */
    "actions-cache-list": {
      /**
       * @description Total number of caches
       * @example 2
       */
      total_count: number;
      /** @description Array of caches */
      actions_caches: {
        /** @example 2 */
        id?: number;
        /** @example refs/heads/main */
        ref?: string;
        /** @example Linux-node-958aff96db2d75d67787d1e634ae70b659de937b */
        key?: string;
        /** @example 73885106f58cc52a7df9ec4d4a5622a5614813162cb516c759a30af6bf56e6f0 */
        version?: string;
        /**
         * Format: date-time
         * @example 2019-01-24T22:45:36.000Z
         */
        last_accessed_at?: string;
        /**
         * Format: date-time
         * @example 2019-01-24T22:45:36.000Z
         */
        created_at?: string;
        /** @example 1024 */
        size_in_bytes?: number;
      }[];
    };
    /**
     * Job
     * @description Information of a job execution in a workflow run
     */
    job: {
      /**
       * @description The id of the job.
       * @example 21
       */
      id: number;
      /**
       * @description The id of the associated workflow run.
       * @example 5
       */
      run_id: number;
      /** @example https://api.github.com/repos/github/hello-world/actions/runs/5 */
      run_url: string;
      /**
       * @description Attempt number of the associated workflow run, 1 for first attempt and higher if the workflow was re-run.
       * @example 1
       */
      run_attempt?: number;
      /** @example MDg6Q2hlY2tSdW40 */
      node_id: string;
      /**
       * @description The SHA of the commit that is being run.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha: string;
      /** @example https://api.github.com/repos/github/hello-world/actions/jobs/21 */
      url: string;
      /** @example https://github.com/github/hello-world/runs/4 */
      html_url: string | null;
      /**
       * @description The phase of the lifecycle that the job is currently in.
       * @example queued
       * @enum {string}
       */
      status: "queued" | "in_progress" | "completed";
      /**
       * @description The outcome of the job.
       * @example success
       * @enum {string|null}
       */
      conclusion:
        | "success"
        | "failure"
        | "neutral"
        | "cancelled"
        | "skipped"
        | "timed_out"
        | "action_required"
        | null;
      /**
       * Format: date-time
       * @description The time that the job created, in ISO 8601 format.
       * @example 2019-08-08T08:00:00-07:00
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The time that the job started, in ISO 8601 format.
       * @example 2019-08-08T08:00:00-07:00
       */
      started_at: string;
      /**
       * Format: date-time
       * @description The time that the job finished, in ISO 8601 format.
       * @example 2019-08-08T08:00:00-07:00
       */
      completed_at: string | null;
      /**
       * @description The name of the job.
       * @example test-coverage
       */
      name: string;
      /** @description Steps in this job. */
      steps?: {
        /**
         * @description The phase of the lifecycle that the job is currently in.
         * @example queued
         * @enum {string}
         */
        status: "queued" | "in_progress" | "completed";
        /**
         * @description The outcome of the job.
         * @example success
         */
        conclusion: string | null;
        /**
         * @description The name of the job.
         * @example test-coverage
         */
        name: string;
        /** @example 1 */
        number: number;
        /**
         * Format: date-time
         * @description The time that the step started, in ISO 8601 format.
         * @example 2019-08-08T08:00:00-07:00
         */
        started_at?: string | null;
        /**
         * Format: date-time
         * @description The time that the job finished, in ISO 8601 format.
         * @example 2019-08-08T08:00:00-07:00
         */
        completed_at?: string | null;
      }[];
      /** @example https://api.github.com/repos/github/hello-world/check-runs/4 */
      check_run_url: string;
      /**
       * @description Labels for the workflow job. Specified by the "runs_on" attribute in the action's workflow file.
       * @example [
       *   "self-hosted",
       *   "foo",
       *   "bar"
       * ]
       */
      labels: string[];
      /**
       * @description The ID of the runner to which this job has been assigned. (If a runner hasn't yet been assigned, this will be null.)
       * @example 1
       */
      runner_id: number | null;
      /**
       * @description The name of the runner to which this job has been assigned. (If a runner hasn't yet been assigned, this will be null.)
       * @example my runner
       */
      runner_name: string | null;
      /**
       * @description The ID of the runner group to which this job has been assigned. (If a runner hasn't yet been assigned, this will be null.)
       * @example 2
       */
      runner_group_id: number | null;
      /**
       * @description The name of the runner group to which this job has been assigned. (If a runner hasn't yet been assigned, this will be null.)
       * @example my runner group
       */
      runner_group_name: string | null;
      /**
       * @description The name of the workflow.
       * @example Build
       */
      workflow_name: string | null;
      /**
       * @description The name of the current branch.
       * @example main
       */
      head_branch: string | null;
    };
    /**
     * Actions OIDC subject customization for a repository
     * @description Actions OIDC subject customization for a repository
     */
    "oidc-custom-sub-repo": {
      /** @description Whether to use the default template or not. If `true`, the `include_claim_keys` field is ignored. */
      use_default: boolean;
      /** @description Array of unique strings. Each claim key can only contain alphanumeric characters and underscores. */
      include_claim_keys?: string[];
    };
    /**
     * Actions Secret
     * @description Set secrets for GitHub Actions.
     */
    "actions-secret": {
      /**
       * @description The name of the secret.
       * @example SECRET_TOKEN
       */
      name: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /** Actions Variable */
    "actions-variable": {
      /**
       * @description The name of the variable.
       * @example USERNAME
       */
      name: string;
      /**
       * @description The value of the variable.
       * @example octocat
       */
      value: string;
      /**
       * Format: date-time
       * @description The date and time at which the variable was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       * @example 2019-01-24T22:45:36.000Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The date and time at which the variable was last updated, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       * @example 2019-01-24T22:45:36.000Z
       */
      updated_at: string;
    };
    /** @description Whether GitHub Actions is enabled on the repository. */
    "actions-enabled": boolean;
    "actions-repository-permissions": {
      enabled: components["schemas"]["actions-enabled"];
      allowed_actions?: components["schemas"]["allowed-actions"];
      selected_actions_url?: components["schemas"]["selected-actions-url"];
    };
    "actions-workflow-access-to-repository": {
      /**
       * @description Defines the level of access that workflows outside of the repository have to actions and reusable workflows within the
       * repository.
       *
       * `none` means the access is only possible from workflows in this repository. `user` level access allows sharing across user owned private repos only. `organization` level access allows sharing across the organization.
       * @enum {string}
       */
      access_level: "none" | "user" | "organization";
    };
    /**
     * Referenced workflow
     * @description A workflow referenced/reused by the initial caller workflow
     */
    "referenced-workflow": {
      path: string;
      sha: string;
      ref?: string;
    };
    /** Pull Request Minimal */
    "pull-request-minimal": {
      id: number;
      number: number;
      url: string;
      head: {
        ref: string;
        sha: string;
        repo: {
          id: number;
          url: string;
          name: string;
        };
      };
      base: {
        ref: string;
        sha: string;
        repo: {
          id: number;
          url: string;
          name: string;
        };
      };
    };
    /**
     * Simple Commit
     * @description A commit.
     */
    "nullable-simple-commit": {
      id: string;
      tree_id: string;
      message: string;
      /** Format: date-time */
      timestamp: string;
      author: {
        name: string;
        email: string;
      } | null;
      committer: {
        name: string;
        email: string;
      } | null;
    } | null;
    /**
     * Workflow Run
     * @description An invocation of a workflow
     */
    "workflow-run": {
      /**
       * @description The ID of the workflow run.
       * @example 5
       */
      id: number;
      /**
       * @description The name of the workflow run.
       * @example Build
       */
      name?: string | null;
      /** @example MDEwOkNoZWNrU3VpdGU1 */
      node_id: string;
      /**
       * @description The ID of the associated check suite.
       * @example 42
       */
      check_suite_id?: number;
      /**
       * @description The node ID of the associated check suite.
       * @example MDEwOkNoZWNrU3VpdGU0Mg==
       */
      check_suite_node_id?: string;
      /** @example master */
      head_branch: string | null;
      /**
       * @description The SHA of the head commit that points to the version of the workflow being run.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha: string;
      /**
       * @description The full path of the workflow
       * @example octocat/octo-repo/.github/workflows/ci.yml@main
       */
      path: string;
      /**
       * @description The auto incrementing run number for the workflow run.
       * @example 106
       */
      run_number: number;
      /**
       * @description Attempt number of the run, 1 for first attempt and higher if the workflow was re-run.
       * @example 1
       */
      run_attempt?: number;
      referenced_workflows?:
        | components["schemas"]["referenced-workflow"][]
        | null;
      /** @example push */
      event: string;
      /** @example completed */
      status: string | null;
      /** @example neutral */
      conclusion: string | null;
      /**
       * @description The ID of the parent workflow.
       * @example 5
       */
      workflow_id: number;
      /**
       * @description The URL to the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5
       */
      url: string;
      /** @example https://github.com/github/hello-world/suites/4 */
      html_url: string;
      pull_requests: components["schemas"]["pull-request-minimal"][] | null;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      actor?: components["schemas"]["simple-user"];
      triggering_actor?: components["schemas"]["simple-user"];
      /**
       * Format: date-time
       * @description The start time of the latest run. Resets on re-run.
       */
      run_started_at?: string;
      /**
       * @description The URL to the jobs for the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/jobs
       */
      jobs_url: string;
      /**
       * @description The URL to download the logs for the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/logs
       */
      logs_url: string;
      /**
       * @description The URL to the associated check suite.
       * @example https://api.github.com/repos/github/hello-world/check-suites/12
       */
      check_suite_url: string;
      /**
       * @description The URL to the artifacts for the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/rerun/artifacts
       */
      artifacts_url: string;
      /**
       * @description The URL to cancel the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/cancel
       */
      cancel_url: string;
      /**
       * @description The URL to rerun the workflow run.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/rerun
       */
      rerun_url: string;
      /**
       * @description The URL to the previous attempted run of this workflow, if one exists.
       * @example https://api.github.com/repos/github/hello-world/actions/runs/5/attempts/3
       */
      previous_attempt_url?: string | null;
      /**
       * @description The URL to the workflow.
       * @example https://api.github.com/repos/github/hello-world/actions/workflows/main.yaml
       */
      workflow_url: string;
      head_commit: components["schemas"]["nullable-simple-commit"];
      repository: components["schemas"]["minimal-repository"];
      head_repository: components["schemas"]["minimal-repository"];
      /** @example 5 */
      head_repository_id?: number;
      /**
       * @description The event-specific title associated with the run or the run-name if set, or the value of `run-name` if it is set in the workflow.
       * @example Simple Workflow
       */
      display_title: string;
    };
    /**
     * Environment Approval
     * @description An entry in the reviews log for environment deployments
     */
    "environment-approvals": {
      /** @description The list of environments that were approved or rejected */
      environments: {
        /**
         * @description The id of the environment.
         * @example 56780428
         */
        id?: number;
        /** @example MDExOkVudmlyb25tZW50NTY3ODA0Mjg= */
        node_id?: string;
        /**
         * @description The name of the environment.
         * @example staging
         */
        name?: string;
        /** @example https://api.github.com/repos/github/hello-world/environments/staging */
        url?: string;
        /** @example https://github.com/github/hello-world/deployments/activity_log?environments_filter=staging */
        html_url?: string;
        /**
         * Format: date-time
         * @description The time that the environment was created, in ISO 8601 format.
         * @example 2020-11-23T22:00:40Z
         */
        created_at?: string;
        /**
         * Format: date-time
         * @description The time that the environment was last updated, in ISO 8601 format.
         * @example 2020-11-23T22:00:40Z
         */
        updated_at?: string;
      }[];
      /**
       * @description Whether deployment to the environment(s) was approved or rejected or pending (with comments)
       * @example approved
       * @enum {string}
       */
      state: "approved" | "rejected" | "pending";
      user: components["schemas"]["simple-user"];
      /**
       * @description The comment submitted with the deployment review
       * @example Ship it!
       */
      comment: string;
    };
    "review-custom-gates-comment-required": {
      /** @description The name of the environment to approve or reject. */
      environment_name: string;
      /** @description Comment associated with the pending deployment protection rule. **Required when state is not provided.** */
      comment: string;
    };
    "review-custom-gates-state-required": {
      /** @description The name of the environment to approve or reject. */
      environment_name: string;
      /**
       * @description Whether to approve or reject deployment to the specified environments.
       * @enum {string}
       */
      state: "approved" | "rejected";
      /** @description Optional comment to include with the review. */
      comment?: string;
    };
    /**
     * @description The type of reviewer.
     * @example User
     * @enum {string}
     */
    "deployment-reviewer-type": "User" | "Team";
    /**
     * Pending Deployment
     * @description Details of a deployment that is waiting for protection rules to pass
     */
    "pending-deployment": {
      environment: {
        /**
         * @description The id of the environment.
         * @example 56780428
         */
        id?: number;
        /** @example MDExOkVudmlyb25tZW50NTY3ODA0Mjg= */
        node_id?: string;
        /**
         * @description The name of the environment.
         * @example staging
         */
        name?: string;
        /** @example https://api.github.com/repos/github/hello-world/environments/staging */
        url?: string;
        /** @example https://github.com/github/hello-world/deployments/activity_log?environments_filter=staging */
        html_url?: string;
      };
      /**
       * @description The set duration of the wait timer
       * @example 30
       */
      wait_timer: number;
      /**
       * Format: date-time
       * @description The time that the wait timer began.
       * @example 2020-11-23T22:00:40Z
       */
      wait_timer_started_at: string | null;
      /**
       * @description Whether the currently authenticated user can approve the deployment
       * @example true
       */
      current_user_can_approve: boolean;
      /** @description The people or teams that may approve jobs that reference the environment. You can list up to six users or teams as reviewers. The reviewers must have at least read access to the repository. Only one of the required reviewers needs to approve the job for it to proceed. */
      reviewers: {
        type?: components["schemas"]["deployment-reviewer-type"];
        reviewer?:
          | components["schemas"]["simple-user"]
          | components["schemas"]["team"];
      }[];
    };
    /**
     * Deployment
     * @description A request for a specific ref(branch,sha,tag) to be deployed
     */
    deployment: {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/1
       */
      url: string;
      /**
       * @description Unique identifier of the deployment
       * @example 42
       */
      id: number;
      /** @example MDEwOkRlcGxveW1lbnQx */
      node_id: string;
      /** @example a84d88e7554fc1fa21bcbc4efae3c782a70d2b9d */
      sha: string;
      /**
       * @description The ref to deploy. This can be a branch, tag, or sha.
       * @example topic-branch
       */
      ref: string;
      /**
       * @description Parameter to specify a task to execute
       * @example deploy
       */
      task: string;
      payload: OneOf<
        [
          {
            [key: string]: unknown;
          },
          string
        ]
      >;
      /** @example staging */
      original_environment?: string;
      /**
       * @description Name for the target deployment environment.
       * @example production
       */
      environment: string;
      /** @example Deploy request from hubot */
      description: string | null;
      creator: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/1/statuses
       */
      statuses_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example
       */
      repository_url: string;
      /**
       * @description Specifies if the given environment is will no longer exist at some point in the future. Default: false.
       * @example true
       */
      transient_environment?: boolean;
      /**
       * @description Specifies if the given environment is one that end-users directly interact with. Default: false.
       * @example true
       */
      production_environment?: boolean;
      performed_via_github_app?: components["schemas"]["nullable-integration"];
    };
    /**
     * Workflow Run Usage
     * @description Workflow Run Usage
     */
    "workflow-run-usage": {
      billable: {
        UBUNTU?: {
          total_ms: number;
          jobs: number;
          job_runs?: {
            job_id: number;
            duration_ms: number;
          }[];
        };
        MACOS?: {
          total_ms: number;
          jobs: number;
          job_runs?: {
            job_id: number;
            duration_ms: number;
          }[];
        };
        WINDOWS?: {
          total_ms: number;
          jobs: number;
          job_runs?: {
            job_id: number;
            duration_ms: number;
          }[];
        };
      };
      run_duration_ms?: number;
    };
    /**
     * Workflow
     * @description A GitHub Actions workflow
     */
    workflow: {
      /** @example 5 */
      id: number;
      /** @example MDg6V29ya2Zsb3cxMg== */
      node_id: string;
      /** @example CI */
      name: string;
      /** @example ruby.yaml */
      path: string;
      /**
       * @example active
       * @enum {string}
       */
      state:
        | "active"
        | "deleted"
        | "disabled_fork"
        | "disabled_inactivity"
        | "disabled_manually";
      /**
       * Format: date-time
       * @example 2019-12-06T14:20:20.000Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2019-12-06T14:20:20.000Z
       */
      updated_at: string;
      /** @example https://api.github.com/repos/actions/setup-ruby/workflows/5 */
      url: string;
      /** @example https://github.com/actions/setup-ruby/blob/master/.github/workflows/ruby.yaml */
      html_url: string;
      /** @example https://github.com/actions/setup-ruby/workflows/CI/badge.svg */
      badge_url: string;
      /**
       * Format: date-time
       * @example 2019-12-06T14:20:20.000Z
       */
      deleted_at?: string;
    };
    /**
     * Autolink reference
     * @description An autolink reference.
     */
    autolink: {
      /** @example 3 */
      id: number;
      /**
       * @description The prefix of a key that is linkified.
       * @example TICKET-
       */
      key_prefix: string;
      /**
       * @description A template for the target URL that is generated if a key was found.
       * @example https://example.com/TICKET?query=<num>
       */
      url_template: string;
      /**
       * @description Whether this autolink reference matches alphanumeric characters. If false, this autolink reference only matches numeric characters.
       * @example true
       */
      is_alphanumeric: boolean;
    };
    /**
     * Protected Branch Required Status Check
     * @description Protected Branch Required Status Check
     */
    "protected-branch-required-status-check": {
      url?: string;
      enforcement_level?: string;
      contexts: string[];
      checks: {
        context: string;
        app_id: number | null;
      }[];
      contexts_url?: string;
      strict?: boolean;
    };
    /**
     * Protected Branch Admin Enforced
     * @description Protected Branch Admin Enforced
     */
    "protected-branch-admin-enforced": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/enforce_admins
       */
      url: string;
      /** @example true */
      enabled: boolean;
    };
    /**
     * Protected Branch Pull Request Review
     * @description Protected Branch Pull Request Review
     */
    "protected-branch-pull-request-review": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/dismissal_restrictions
       */
      url?: string;
      dismissal_restrictions?: {
        /** @description The list of users with review dismissal access. */
        users?: components["schemas"]["simple-user"][];
        /** @description The list of teams with review dismissal access. */
        teams?: components["schemas"]["team"][];
        /** @description The list of apps with review dismissal access. */
        apps?: components["schemas"]["integration"][];
        /** @example "https://api.github.com/repos/the-org/an-org-repo/branches/master/protection/dismissal_restrictions" */
        url?: string;
        /** @example "https://api.github.com/repos/the-org/an-org-repo/branches/master/protection/dismissal_restrictions/users" */
        users_url?: string;
        /** @example "https://api.github.com/repos/the-org/an-org-repo/branches/master/protection/dismissal_restrictions/teams" */
        teams_url?: string;
      };
      /** @description Allow specific users, teams, or apps to bypass pull request requirements. */
      bypass_pull_request_allowances?: {
        /** @description The list of users allowed to bypass pull request requirements. */
        users?: components["schemas"]["simple-user"][];
        /** @description The list of teams allowed to bypass pull request requirements. */
        teams?: components["schemas"]["team"][];
        /** @description The list of apps allowed to bypass pull request requirements. */
        apps?: components["schemas"]["integration"][];
      };
      /** @example true */
      dismiss_stale_reviews: boolean;
      /** @example true */
      require_code_owner_reviews: boolean;
      /** @example 2 */
      required_approving_review_count?: number;
      /**
       * @description Whether the most recent push must be approved by someone other than the person who pushed it.
       * @default false
       * @example true
       */
      require_last_push_approval?: boolean;
    };
    /**
     * Branch Restriction Policy
     * @description Branch Restriction Policy
     */
    "branch-restriction-policy": {
      /** Format: uri */
      url: string;
      /** Format: uri */
      users_url: string;
      /** Format: uri */
      teams_url: string;
      /** Format: uri */
      apps_url: string;
      users: {
        login?: string;
        id?: number;
        node_id?: string;
        avatar_url?: string;
        gravatar_id?: string;
        url?: string;
        html_url?: string;
        followers_url?: string;
        following_url?: string;
        gists_url?: string;
        starred_url?: string;
        subscriptions_url?: string;
        organizations_url?: string;
        repos_url?: string;
        events_url?: string;
        received_events_url?: string;
        type?: string;
        site_admin?: boolean;
      }[];
      teams: {
        id?: number;
        node_id?: string;
        url?: string;
        html_url?: string;
        name?: string;
        slug?: string;
        description?: string | null;
        privacy?: string;
        notification_setting?: string;
        permission?: string;
        members_url?: string;
        repositories_url?: string;
        parent?: string | null;
      }[];
      apps: {
        id?: number;
        slug?: string;
        node_id?: string;
        owner?: {
          login?: string;
          id?: number;
          node_id?: string;
          url?: string;
          repos_url?: string;
          events_url?: string;
          hooks_url?: string;
          issues_url?: string;
          members_url?: string;
          public_members_url?: string;
          avatar_url?: string;
          description?: string;
          /** @example "" */
          gravatar_id?: string;
          /** @example "https://github.com/testorg-ea8ec76d71c3af4b" */
          html_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/followers" */
          followers_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/following{/other_user}" */
          following_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/gists{/gist_id}" */
          gists_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/starred{/owner}{/repo}" */
          starred_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/subscriptions" */
          subscriptions_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/orgs" */
          organizations_url?: string;
          /** @example "https://api.github.com/users/testorg-ea8ec76d71c3af4b/received_events" */
          received_events_url?: string;
          /** @example "Organization" */
          type?: string;
          /** @example false */
          site_admin?: boolean;
        };
        name?: string;
        description?: string;
        external_url?: string;
        html_url?: string;
        created_at?: string;
        updated_at?: string;
        permissions?: {
          metadata?: string;
          contents?: string;
          issues?: string;
          single_file?: string;
        };
        events?: string[];
      }[];
    };
    /**
     * Branch Protection
     * @description Branch Protection
     */
    "branch-protection": {
      url?: string;
      enabled?: boolean;
      required_status_checks?: components["schemas"]["protected-branch-required-status-check"];
      enforce_admins?: components["schemas"]["protected-branch-admin-enforced"];
      required_pull_request_reviews?: components["schemas"]["protected-branch-pull-request-review"];
      restrictions?: components["schemas"]["branch-restriction-policy"];
      required_linear_history?: {
        enabled?: boolean;
      };
      allow_force_pushes?: {
        enabled?: boolean;
      };
      allow_deletions?: {
        enabled?: boolean;
      };
      block_creations?: {
        enabled?: boolean;
      };
      required_conversation_resolution?: {
        enabled?: boolean;
      };
      /** @example "branch/with/protection" */
      name?: string;
      /** @example "https://api.github.com/repos/owner-79e94e2d36b3fd06a32bb213/AAA_Public_Repo/branches/branch/with/protection/protection" */
      protection_url?: string;
      required_signatures?: {
        /**
         * Format: uri
         * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/required_signatures
         */
        url: string;
        /** @example true */
        enabled: boolean;
      };
      /** @description Whether to set the branch as read-only. If this is true, users will not be able to push to the branch. */
      lock_branch?: {
        /** @default false */
        enabled?: boolean;
      };
      /** @description Whether users can pull changes from upstream when the branch is locked. Set to `true` to allow fork syncing. Set to `false` to prevent fork syncing. */
      allow_fork_syncing?: {
        /** @default false */
        enabled?: boolean;
      };
    };
    /**
     * Short Branch
     * @description Short Branch
     */
    "short-branch": {
      name: string;
      commit: {
        sha: string;
        /** Format: uri */
        url: string;
      };
      protected: boolean;
      protection?: components["schemas"]["branch-protection"];
      /** Format: uri */
      protection_url?: string;
    };
    /**
     * Git User
     * @description Metaproperties for Git author/committer information.
     */
    "nullable-git-user": {
      /** @example "Chris Wanstrath" */
      name?: string;
      /** @example "chris@ozmm.org" */
      email?: string;
      /** @example "2007-10-29T02:42:39.000-07:00" */
      date?: string;
    } | null;
    /** Verification */
    verification: {
      verified: boolean;
      reason: string;
      payload: string | null;
      signature: string | null;
    };
    /**
     * Diff Entry
     * @description Diff Entry
     */
    "diff-entry": {
      /** @example bbcd538c8e72b8c175046e27cc8f907076331401 */
      sha: string;
      /** @example file1.txt */
      filename: string;
      /**
       * @example added
       * @enum {string}
       */
      status:
        | "added"
        | "removed"
        | "modified"
        | "renamed"
        | "copied"
        | "changed"
        | "unchanged";
      /** @example 103 */
      additions: number;
      /** @example 21 */
      deletions: number;
      /** @example 124 */
      changes: number;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/blob/6dcb09b5b57875f334f61aebed695e2e4193db5e/file1.txt
       */
      blob_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/raw/6dcb09b5b57875f334f61aebed695e2e4193db5e/file1.txt
       */
      raw_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/contents/file1.txt?ref=6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      contents_url: string;
      /** @example @@ -132,7 +132,7 @@ module Test @@ -1000,7 +1000,7 @@ module Test */
      patch?: string;
      /** @example file.txt */
      previous_filename?: string;
    };
    /**
     * Commit
     * @description Commit
     */
    commit: {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/commits/6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      url: string;
      /** @example 6dcb09b5b57875f334f61aebed695e2e4193db5e */
      sha: string;
      /** @example MDY6Q29tbWl0NmRjYjA5YjViNTc4NzVmMzM0ZjYxYWViZWQ2OTVlMmU0MTkzZGI1ZQ== */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/commit/6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/commits/6dcb09b5b57875f334f61aebed695e2e4193db5e/comments
       */
      comments_url: string;
      commit: {
        /**
         * Format: uri
         * @example https://api.github.com/repos/octocat/Hello-World/commits/6dcb09b5b57875f334f61aebed695e2e4193db5e
         */
        url: string;
        author: components["schemas"]["nullable-git-user"];
        committer: components["schemas"]["nullable-git-user"];
        /** @example Fix all the bugs */
        message: string;
        /** @example 0 */
        comment_count: number;
        tree: {
          /** @example 827efc6d56897b048c772eb4087f854f46256132 */
          sha: string;
          /**
           * Format: uri
           * @example https://api.github.com/repos/octocat/Hello-World/tree/827efc6d56897b048c772eb4087f854f46256132
           */
          url: string;
        };
        verification?: components["schemas"]["verification"];
      };
      author: components["schemas"]["nullable-simple-user"];
      committer: components["schemas"]["nullable-simple-user"];
      parents: {
        /** @example 7638417db6d59f3c431d3e1f261cc637155684cd */
        sha: string;
        /**
         * Format: uri
         * @example https://api.github.com/repos/octocat/Hello-World/commits/7638417db6d59f3c431d3e1f261cc637155684cd
         */
        url: string;
        /**
         * Format: uri
         * @example https://github.com/octocat/Hello-World/commit/7638417db6d59f3c431d3e1f261cc637155684cd
         */
        html_url?: string;
      }[];
      stats?: {
        additions?: number;
        deletions?: number;
        total?: number;
      };
      files?: components["schemas"]["diff-entry"][];
    };
    /**
     * Branch With Protection
     * @description Branch With Protection
     */
    "branch-with-protection": {
      name: string;
      commit: components["schemas"]["commit"];
      _links: {
        html: string;
        /** Format: uri */
        self: string;
      };
      protected: boolean;
      protection: components["schemas"]["branch-protection"];
      /** Format: uri */
      protection_url: string;
      /** @example "mas*" */
      pattern?: string;
      /** @example 1 */
      required_approving_review_count?: number;
    };
    /**
     * Status Check Policy
     * @description Status Check Policy
     */
    "status-check-policy": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/required_status_checks
       */
      url: string;
      /** @example true */
      strict: boolean;
      /**
       * @example [
       *   "continuous-integration/travis-ci"
       * ]
       */
      contexts: string[];
      checks: {
        /** @example continuous-integration/travis-ci */
        context: string;
        app_id: number | null;
      }[];
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/required_status_checks/contexts
       */
      contexts_url: string;
    };
    /**
     * Protected Branch
     * @description Branch protections protect branches
     */
    "protected-branch": {
      /** Format: uri */
      url: string;
      required_status_checks?: components["schemas"]["status-check-policy"];
      required_pull_request_reviews?: {
        /** Format: uri */
        url: string;
        dismiss_stale_reviews?: boolean;
        require_code_owner_reviews?: boolean;
        required_approving_review_count?: number;
        /**
         * @description Whether the most recent push must be approved by someone other than the person who pushed it.
         * @default false
         */
        require_last_push_approval?: boolean;
        dismissal_restrictions?: {
          /** Format: uri */
          url: string;
          /** Format: uri */
          users_url: string;
          /** Format: uri */
          teams_url: string;
          users: components["schemas"]["simple-user"][];
          teams: components["schemas"]["team"][];
          apps?: components["schemas"]["integration"][];
        };
        bypass_pull_request_allowances?: {
          users: components["schemas"]["simple-user"][];
          teams: components["schemas"]["team"][];
          apps?: components["schemas"]["integration"][];
        };
      };
      required_signatures?: {
        /**
         * Format: uri
         * @example https://api.github.com/repos/octocat/Hello-World/branches/master/protection/required_signatures
         */
        url: string;
        /** @example true */
        enabled: boolean;
      };
      enforce_admins?: {
        /** Format: uri */
        url: string;
        enabled: boolean;
      };
      required_linear_history?: {
        enabled: boolean;
      };
      allow_force_pushes?: {
        enabled: boolean;
      };
      allow_deletions?: {
        enabled: boolean;
      };
      restrictions?: components["schemas"]["branch-restriction-policy"];
      required_conversation_resolution?: {
        enabled?: boolean;
      };
      block_creations?: {
        enabled: boolean;
      };
      /** @description Whether to set the branch as read-only. If this is true, users will not be able to push to the branch. */
      lock_branch?: {
        /** @default false */
        enabled?: boolean;
      };
      /** @description Whether users can pull changes from upstream when the branch is locked. Set to `true` to allow fork syncing. Set to `false` to prevent fork syncing. */
      allow_fork_syncing?: {
        /** @default false */
        enabled?: boolean;
      };
    };
    /**
     * Deployment
     * @description A deployment created as the result of an Actions check run from a workflow that references an environment
     */
    "deployment-simple": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/1
       */
      url: string;
      /**
       * @description Unique identifier of the deployment
       * @example 42
       */
      id: number;
      /** @example MDEwOkRlcGxveW1lbnQx */
      node_id: string;
      /**
       * @description Parameter to specify a task to execute
       * @example deploy
       */
      task: string;
      /** @example staging */
      original_environment?: string;
      /**
       * @description Name for the target deployment environment.
       * @example production
       */
      environment: string;
      /** @example Deploy request from hubot */
      description: string | null;
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/1/statuses
       */
      statuses_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example
       */
      repository_url: string;
      /**
       * @description Specifies if the given environment is will no longer exist at some point in the future. Default: false.
       * @example true
       */
      transient_environment?: boolean;
      /**
       * @description Specifies if the given environment is one that end-users directly interact with. Default: false.
       * @example true
       */
      production_environment?: boolean;
      performed_via_github_app?: components["schemas"]["nullable-integration"];
    };
    /**
     * CheckRun
     * @description A check performed on the code of a given code change
     */
    "check-run": {
      /**
       * @description The id of the check.
       * @example 21
       */
      id: number;
      /**
       * @description The SHA of the commit that is being checked.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha: string;
      /** @example MDg6Q2hlY2tSdW40 */
      node_id: string;
      /** @example 42 */
      external_id: string | null;
      /** @example https://api.github.com/repos/github/hello-world/check-runs/4 */
      url: string;
      /** @example https://github.com/github/hello-world/runs/4 */
      html_url: string | null;
      /** @example https://example.com */
      details_url: string | null;
      /**
       * @description The phase of the lifecycle that the check is currently in.
       * @example queued
       * @enum {string}
       */
      status: "queued" | "in_progress" | "completed";
      /**
       * @example neutral
       * @enum {string|null}
       */
      conclusion:
        | "success"
        | "failure"
        | "neutral"
        | "cancelled"
        | "skipped"
        | "timed_out"
        | "action_required"
        | null;
      /**
       * Format: date-time
       * @example 2018-05-04T01:14:52Z
       */
      started_at: string | null;
      /**
       * Format: date-time
       * @example 2018-05-04T01:14:52Z
       */
      completed_at: string | null;
      output: {
        title: string | null;
        summary: string | null;
        text: string | null;
        annotations_count: number;
        /** Format: uri */
        annotations_url: string;
      };
      /**
       * @description The name of the check.
       * @example test-coverage
       */
      name: string;
      check_suite: {
        id: number;
      } | null;
      app: components["schemas"]["nullable-integration"];
      pull_requests: components["schemas"]["pull-request-minimal"][];
      deployment?: components["schemas"]["deployment-simple"];
    };
    /**
     * Check Annotation
     * @description Check Annotation
     */
    "check-annotation": {
      /** @example README.md */
      path: string;
      /** @example 2 */
      start_line: number;
      /** @example 2 */
      end_line: number;
      /** @example 5 */
      start_column: number | null;
      /** @example 10 */
      end_column: number | null;
      /** @example warning */
      annotation_level: string | null;
      /** @example Spell Checker */
      title: string | null;
      /** @example Check your spelling for 'banaas'. */
      message: string | null;
      /** @example Do you mean 'bananas' or 'banana'? */
      raw_details: string | null;
      blob_href: string;
    };
    /**
     * Simple Commit
     * @description A commit.
     */
    "simple-commit": {
      id: string;
      tree_id: string;
      message: string;
      /** Format: date-time */
      timestamp: string;
      author: {
        name: string;
        email: string;
      } | null;
      committer: {
        name: string;
        email: string;
      } | null;
    };
    /**
     * CheckSuite
     * @description A suite of checks performed on the code of a given code change
     */
    "check-suite": {
      /** @example 5 */
      id: number;
      /** @example MDEwOkNoZWNrU3VpdGU1 */
      node_id: string;
      /** @example master */
      head_branch: string | null;
      /**
       * @description The SHA of the head commit that is being checked.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha: string;
      /**
       * @example completed
       * @enum {string|null}
       */
      status: "queued" | "in_progress" | "completed" | null;
      /**
       * @example neutral
       * @enum {string|null}
       */
      conclusion:
        | "success"
        | "failure"
        | "neutral"
        | "cancelled"
        | "skipped"
        | "timed_out"
        | "action_required"
        | "startup_failure"
        | "stale"
        | ""
        | null;
      /** @example https://api.github.com/repos/github/hello-world/check-suites/5 */
      url: string | null;
      /** @example 146e867f55c26428e5f9fade55a9bbf5e95a7912 */
      before: string | null;
      /** @example d6fde92930d4715a2b49857d24b940956b26d2d3 */
      after: string | null;
      pull_requests: components["schemas"]["pull-request-minimal"][] | null;
      app: components["schemas"]["nullable-integration"];
      repository: components["schemas"]["minimal-repository"];
      /** Format: date-time */
      created_at: string | null;
      /** Format: date-time */
      updated_at: string | null;
      head_commit: components["schemas"]["simple-commit"];
      latest_check_runs_count: number;
      check_runs_url: string;
      rerequestable?: boolean;
      runs_rerequestable?: boolean;
    };
    /**
     * Check Suite Preference
     * @description Check suite configuration preferences for a repository.
     */
    "check-suite-preference": {
      preferences: {
        auto_trigger_checks?: {
          app_id: number;
          setting: boolean;
        }[];
      };
      repository: components["schemas"]["minimal-repository"];
    };
    "code-scanning-alert-rule-summary": {
      /** @description A unique identifier for the rule used to detect the alert. */
      id?: string | null;
      /** @description The name of the rule used to detect the alert. */
      name?: string;
      /** @description A set of tags applicable for the rule. */
      tags?: string[] | null;
      /**
       * @description The severity of the alert.
       * @enum {string|null}
       */
      severity?: "none" | "note" | "warning" | "error" | null;
      /** @description A short description of the rule used to detect the alert. */
      description?: string;
    };
    "code-scanning-alert-items": {
      number: components["schemas"]["alert-number"];
      created_at: components["schemas"]["alert-created-at"];
      updated_at?: components["schemas"]["alert-updated-at"];
      url: components["schemas"]["alert-url"];
      html_url: components["schemas"]["alert-html-url"];
      instances_url: components["schemas"]["alert-instances-url"];
      state: components["schemas"]["code-scanning-alert-state"];
      fixed_at?: components["schemas"]["alert-fixed-at"];
      dismissed_by: components["schemas"]["nullable-simple-user"];
      dismissed_at: components["schemas"]["alert-dismissed-at"];
      dismissed_reason: components["schemas"]["code-scanning-alert-dismissed-reason"];
      dismissed_comment?: components["schemas"]["code-scanning-alert-dismissed-comment"];
      rule: components["schemas"]["code-scanning-alert-rule-summary"];
      tool: components["schemas"]["code-scanning-analysis-tool"];
      most_recent_instance: components["schemas"]["code-scanning-alert-instance"];
    };
    "code-scanning-alert": {
      number: components["schemas"]["alert-number"];
      created_at: components["schemas"]["alert-created-at"];
      updated_at?: components["schemas"]["alert-updated-at"];
      url: components["schemas"]["alert-url"];
      html_url: components["schemas"]["alert-html-url"];
      instances_url: components["schemas"]["alert-instances-url"];
      state: components["schemas"]["code-scanning-alert-state"];
      fixed_at?: components["schemas"]["alert-fixed-at"];
      dismissed_by: components["schemas"]["nullable-simple-user"];
      dismissed_at: components["schemas"]["alert-dismissed-at"];
      dismissed_reason: components["schemas"]["code-scanning-alert-dismissed-reason"];
      dismissed_comment?: components["schemas"]["code-scanning-alert-dismissed-comment"];
      rule: components["schemas"]["code-scanning-alert-rule"];
      tool: components["schemas"]["code-scanning-analysis-tool"];
      most_recent_instance: components["schemas"]["code-scanning-alert-instance"];
    };
    /**
     * @description Sets the state of the code scanning alert. You must provide `dismissed_reason` when you set the state to `dismissed`.
     * @enum {string}
     */
    "code-scanning-alert-set-state": "open" | "dismissed";
    /**
     * @description An identifier for the upload.
     * @example 6c81cd8e-b078-4ac3-a3be-1dad7dbd0b53
     */
    "code-scanning-analysis-sarif-id": string;
    /** @description The SHA of the commit to which the analysis you are uploading relates. */
    "code-scanning-analysis-commit-sha": string;
    /** @description Identifies the variable values associated with the environment in which this analysis was performed. */
    "code-scanning-analysis-environment": string;
    /**
     * Format: date-time
     * @description The time that the analysis was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
     */
    readonly "code-scanning-analysis-created-at": string;
    /**
     * Format: uri
     * @description The REST API URL of the analysis resource.
     */
    readonly "code-scanning-analysis-url": string;
    "code-scanning-analysis": {
      ref: components["schemas"]["code-scanning-ref"];
      commit_sha: components["schemas"]["code-scanning-analysis-commit-sha"];
      analysis_key: components["schemas"]["code-scanning-analysis-analysis-key"];
      environment: components["schemas"]["code-scanning-analysis-environment"];
      category?: components["schemas"]["code-scanning-analysis-category"];
      /** @example error reading field xyz */
      error: string;
      created_at: components["schemas"]["code-scanning-analysis-created-at"];
      /** @description The total number of results in the analysis. */
      results_count: number;
      /** @description The total number of rules used in the analysis. */
      rules_count: number;
      /** @description Unique identifier for this analysis. */
      id: number;
      url: components["schemas"]["code-scanning-analysis-url"];
      sarif_id: components["schemas"]["code-scanning-analysis-sarif-id"];
      tool: components["schemas"]["code-scanning-analysis-tool"];
      deletable: boolean;
      /**
       * @description Warning generated when processing the analysis
       * @example 123 results were ignored
       */
      warning: string;
    };
    /**
     * Analysis deletion
     * @description Successful deletion of a code scanning analysis
     */
    "code-scanning-analysis-deletion": {
      /**
       * Format: uri
       * @description Next deletable analysis in chain, without last analysis deletion confirmation
       */
      next_analysis_url: string | null;
      /**
       * Format: uri
       * @description Next deletable analysis in chain, with last analysis deletion confirmation
       */
      confirm_delete_url: string | null;
    };
    /**
     * CodeQL Database
     * @description A CodeQL database.
     */
    "code-scanning-codeql-database": {
      /** @description The ID of the CodeQL database. */
      id: number;
      /** @description The name of the CodeQL database. */
      name: string;
      /** @description The language of the CodeQL database. */
      language: string;
      uploader: components["schemas"]["simple-user"];
      /** @description The MIME type of the CodeQL database file. */
      content_type: string;
      /** @description The size of the CodeQL database file in bytes. */
      size: number;
      /**
       * Format: date-time
       * @description The date and time at which the CodeQL database was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The date and time at which the CodeQL database was last updated, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      updated_at: string;
      /**
       * Format: uri
       * @description The URL at which to download the CodeQL database. The `Accept` header must be set to the value of the `content_type` property.
       */
      url: string;
    };
    /** @description Configuration for code scanning default setup. */
    "code-scanning-default-setup": {
      /**
       * @description Code scanning default setup has been configured or not.
       * @enum {string}
       */
      state?: "configured" | "not-configured";
      /** @description Languages to be analysed. */
      languages?: (
        | "c"
        | "cpp"
        | "csharp"
        | "go"
        | "java"
        | "javascript"
        | "kotlin"
        | "python"
        | "ruby"
        | "typescript"
      )[];
      /**
       * @description CodeQL query suite to be used.
       * @enum {string}
       */
      query_suite?: "default" | "extended";
      /**
       * Format: date-time
       * @description Timestamp of latest configuration update.
       * @example 2023-12-06T14:20:20.000Z
       */
      updated_at?: string | null;
    };
    /** @description Configuration for code scanning default setup. */
    "code-scanning-default-setup-update": {
      /**
       * @description Whether code scanning default setup has been configured or not.
       * @enum {string}
       */
      state: "configured" | "not-configured";
      /**
       * @description CodeQL query suite to be used.
       * @enum {string}
       */
      query_suite?: "default" | "extended";
    };
    /**
     * @description You can use `run_url` to track the status of the run. This includes a property status and conclusion.
     * You should not rely on this always being an actions workflow run object.
     */
    "code-scanning-default-setup-update-response": {
      /** @description ID of the corresponding run. */
      run_id?: number;
      /** @description URL of the corresponding run. */
      run_url?: string;
    };
    /** @description A Base64 string representing the SARIF file to upload. You must first compress your SARIF file using [`gzip`](http://www.gnu.org/software/gzip/manual/gzip.html) and then translate the contents of the file into a Base64 encoding string. For more information, see "[SARIF support for code scanning](https://docs.github.com/code-security/secure-coding/sarif-support-for-code-scanning)." */
    "code-scanning-analysis-sarif-file": string;
    "code-scanning-sarifs-receipt": {
      id?: components["schemas"]["code-scanning-analysis-sarif-id"];
      /**
       * Format: uri
       * @description The REST API URL for checking the status of the upload.
       */
      url?: string;
    };
    "code-scanning-sarifs-status": {
      /**
       * @description `pending` files have not yet been processed, while `complete` means results from the SARIF have been stored. `failed` files have either not been processed at all, or could only be partially processed.
       * @enum {string}
       */
      processing_status?: "pending" | "complete" | "failed";
      /**
       * Format: uri
       * @description The REST API URL for getting the analyses associated with the upload.
       */
      analyses_url?: string | null;
      /** @description Any errors that ocurred during processing of the delivery. */
      errors?: readonly string[] | null;
    };
    /**
     * CODEOWNERS errors
     * @description A list of errors found in a repo's CODEOWNERS file
     */
    "codeowners-errors": {
      errors: {
        /**
         * @description The line number where this errors occurs.
         * @example 7
         */
        line: number;
        /**
         * @description The column number where this errors occurs.
         * @example 3
         */
        column: number;
        /**
         * @description The contents of the line where the error occurs.
         * @example * user
         */
        source?: string;
        /**
         * @description The type of error.
         * @example Invalid owner
         */
        kind: string;
        /**
         * @description Suggested action to fix the error. This will usually be `null`, but is provided for some common errors.
         * @example The pattern `/` will never match anything, did you mean `*` instead?
         */
        suggestion?: string | null;
        /**
         * @description A human-readable description of the error, combining information from multiple fields, laid out for display in a monospaced typeface (for example, a command-line setting).
         * @example Invalid owner on line 7:
         *
         *   * user
         *     ^
         */
        message: string;
        /**
         * @description The path of the file where the error occured.
         * @example .github/CODEOWNERS
         */
        path: string;
      }[];
    };
    /**
     * Codespace machine
     * @description A description of the machine powering a codespace.
     */
    "codespace-machine": {
      /**
       * @description The name of the machine.
       * @example standardLinux
       */
      name: string;
      /**
       * @description The display name of the machine includes cores, memory, and storage.
       * @example 4 cores, 8 GB RAM, 64 GB storage
       */
      display_name: string;
      /**
       * @description The operating system of the machine.
       * @example linux
       */
      operating_system: string;
      /**
       * @description How much storage is available to the codespace.
       * @example 68719476736
       */
      storage_in_bytes: number;
      /**
       * @description How much memory is available to the codespace.
       * @example 8589934592
       */
      memory_in_bytes: number;
      /**
       * @description How many cores are available to the codespace.
       * @example 4
       */
      cpus: number;
      /**
       * @description Whether a prebuild is currently available when creating a codespace for this machine and repository. If a branch was not specified as a ref, the default branch will be assumed. Value will be "null" if prebuilds are not supported or prebuild availability could not be determined. Value will be "none" if no prebuild is available. Latest values "ready" and "in_progress" indicate the prebuild availability status.
       * @example ready
       * @enum {string|null}
       */
      prebuild_availability: "none" | "ready" | "in_progress" | null;
    };
    /**
     * Codespaces Secret
     * @description Set repository secrets for GitHub Codespaces.
     */
    "repo-codespaces-secret": {
      /**
       * @description The name of the secret.
       * @example SECRET_TOKEN
       */
      name: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Collaborator
     * @description Collaborator
     */
    collaborator: {
      /** @example octocat */
      login: string;
      /** @example 1 */
      id: number;
      email?: string | null;
      name?: string | null;
      /** @example MDQ6VXNlcjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/images/error/octocat_happy.gif
       */
      avatar_url: string;
      /** @example 41d064eb2195891e12d0413f63227ea7 */
      gravatar_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/followers
       */
      followers_url: string;
      /** @example https://api.github.com/users/octocat/following{/other_user} */
      following_url: string;
      /** @example https://api.github.com/users/octocat/gists{/gist_id} */
      gists_url: string;
      /** @example https://api.github.com/users/octocat/starred{/owner}{/repo} */
      starred_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/subscriptions
       */
      subscriptions_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/orgs
       */
      organizations_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repos_url: string;
      /** @example https://api.github.com/users/octocat/events{/privacy} */
      events_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/received_events
       */
      received_events_url: string;
      /** @example User */
      type: string;
      site_admin: boolean;
      permissions?: {
        pull: boolean;
        triage?: boolean;
        push: boolean;
        maintain?: boolean;
        admin: boolean;
      };
      /** @example admin */
      role_name: string;
    };
    /**
     * Repository Invitation
     * @description Repository invitations let you manage who you collaborate with.
     */
    "repository-invitation": {
      /**
       * @description Unique identifier of the repository invitation.
       * @example 42
       */
      id: number;
      repository: components["schemas"]["minimal-repository"];
      invitee: components["schemas"]["nullable-simple-user"];
      inviter: components["schemas"]["nullable-simple-user"];
      /**
       * @description The permission associated with the invitation.
       * @example read
       * @enum {string}
       */
      permissions: "read" | "write" | "admin" | "triage" | "maintain";
      /**
       * Format: date-time
       * @example 2016-06-13T14:52:50-05:00
       */
      created_at: string;
      /** @description Whether or not the invitation has expired */
      expired?: boolean;
      /**
       * @description URL for the repository invitation
       * @example https://api.github.com/user/repository-invitations/1
       */
      url: string;
      /** @example https://github.com/octocat/Hello-World/invitations */
      html_url: string;
      node_id: string;
    };
    /**
     * Collaborator
     * @description Collaborator
     */
    "nullable-collaborator": {
      /** @example octocat */
      login: string;
      /** @example 1 */
      id: number;
      email?: string | null;
      name?: string | null;
      /** @example MDQ6VXNlcjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/images/error/octocat_happy.gif
       */
      avatar_url: string;
      /** @example 41d064eb2195891e12d0413f63227ea7 */
      gravatar_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/followers
       */
      followers_url: string;
      /** @example https://api.github.com/users/octocat/following{/other_user} */
      following_url: string;
      /** @example https://api.github.com/users/octocat/gists{/gist_id} */
      gists_url: string;
      /** @example https://api.github.com/users/octocat/starred{/owner}{/repo} */
      starred_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/subscriptions
       */
      subscriptions_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/orgs
       */
      organizations_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repos_url: string;
      /** @example https://api.github.com/users/octocat/events{/privacy} */
      events_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/received_events
       */
      received_events_url: string;
      /** @example User */
      type: string;
      site_admin: boolean;
      permissions?: {
        pull: boolean;
        triage?: boolean;
        push: boolean;
        maintain?: boolean;
        admin: boolean;
      };
      /** @example admin */
      role_name: string;
    } | null;
    /**
     * Repository Collaborator Permission
     * @description Repository Collaborator Permission
     */
    "repository-collaborator-permission": {
      permission: string;
      /** @example admin */
      role_name: string;
      user: components["schemas"]["nullable-collaborator"];
    };
    /**
     * Commit Comment
     * @description Commit Comment
     */
    "commit-comment": {
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      url: string;
      id: number;
      node_id: string;
      body: string;
      path: string | null;
      position: number | null;
      line: number | null;
      commit_id: string;
      user: components["schemas"]["nullable-simple-user"];
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      author_association: components["schemas"]["author-association"];
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Branch Short
     * @description Branch Short
     */
    "branch-short": {
      name: string;
      commit: {
        sha: string;
        url: string;
      };
      protected: boolean;
    };
    /**
     * Link
     * @description Hypermedia Link
     */
    link: {
      href: string;
    };
    /**
     * Auto merge
     * @description The status of auto merging a pull request.
     */
    "auto-merge": {
      enabled_by: components["schemas"]["simple-user"];
      /**
       * @description The merge method to use.
       * @enum {string}
       */
      merge_method: "merge" | "squash" | "rebase";
      /** @description Title for the merge commit message. */
      commit_title: string;
      /** @description Commit message for the merge commit. */
      commit_message: string;
    } | null;
    /**
     * Pull Request Simple
     * @description Pull Request Simple
     */
    "pull-request-simple": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347
       */
      url: string;
      /** @example 1 */
      id: number;
      /** @example MDExOlB1bGxSZXF1ZXN0MQ== */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347.diff
       */
      diff_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347.patch
       */
      patch_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347
       */
      issue_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347/commits
       */
      commits_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347/comments
       */
      review_comments_url: string;
      /** @example https://api.github.com/repos/octocat/Hello-World/pulls/comments{/number} */
      review_comment_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347/comments
       */
      comments_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/statuses/6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      statuses_url: string;
      /** @example 1347 */
      number: number;
      /** @example open */
      state: string;
      /** @example true */
      locked: boolean;
      /** @example new-feature */
      title: string;
      user: components["schemas"]["nullable-simple-user"];
      /** @example Please pull these awesome changes */
      body: string | null;
      labels: {
        /** Format: int64 */
        id: number;
        node_id: string;
        url: string;
        name: string;
        description: string;
        color: string;
        default: boolean;
      }[];
      milestone: components["schemas"]["nullable-milestone"];
      /** @example too heated */
      active_lock_reason?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      merged_at: string | null;
      /** @example e5bd3914e2e596debea16f433f57875b5b90bcd6 */
      merge_commit_sha: string | null;
      assignee: components["schemas"]["nullable-simple-user"];
      assignees?: components["schemas"]["simple-user"][] | null;
      requested_reviewers?: components["schemas"]["simple-user"][] | null;
      requested_teams?: components["schemas"]["team"][] | null;
      head: {
        label: string;
        ref: string;
        repo: components["schemas"]["repository"];
        sha: string;
        user: components["schemas"]["nullable-simple-user"];
      };
      base: {
        label: string;
        ref: string;
        repo: components["schemas"]["repository"];
        sha: string;
        user: components["schemas"]["nullable-simple-user"];
      };
      _links: {
        comments: components["schemas"]["link"];
        commits: components["schemas"]["link"];
        statuses: components["schemas"]["link"];
        html: components["schemas"]["link"];
        issue: components["schemas"]["link"];
        review_comments: components["schemas"]["link"];
        review_comment: components["schemas"]["link"];
        self: components["schemas"]["link"];
      };
      author_association: components["schemas"]["author-association"];
      auto_merge: components["schemas"]["auto-merge"];
      /**
       * @description Indicates whether or not the pull request is a draft.
       * @example false
       */
      draft?: boolean;
    };
    /** Simple Commit Status */
    "simple-commit-status": {
      description: string | null;
      id: number;
      node_id: string;
      state: string;
      context: string;
      /** Format: uri */
      target_url: string | null;
      required?: boolean | null;
      /** Format: uri */
      avatar_url: string | null;
      /** Format: uri */
      url: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Combined Commit Status
     * @description Combined Commit Status
     */
    "combined-commit-status": {
      state: string;
      statuses: components["schemas"]["simple-commit-status"][];
      sha: string;
      total_count: number;
      repository: components["schemas"]["minimal-repository"];
      /** Format: uri */
      commit_url: string;
      /** Format: uri */
      url: string;
    };
    /**
     * Status
     * @description The status of a commit.
     */
    status: {
      url: string;
      avatar_url: string | null;
      id: number;
      node_id: string;
      state: string;
      description: string | null;
      target_url: string | null;
      context: string;
      created_at: string;
      updated_at: string;
      creator: components["schemas"]["nullable-simple-user"];
    };
    /**
     * Code Of Conduct Simple
     * @description Code of Conduct Simple
     */
    "nullable-code-of-conduct-simple": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/github/docs/community/code_of_conduct
       */
      url: string;
      /** @example citizen_code_of_conduct */
      key: string;
      /** @example Citizen Code of Conduct */
      name: string;
      /**
       * Format: uri
       * @example https://github.com/github/docs/blob/main/CODE_OF_CONDUCT.md
       */
      html_url: string | null;
    } | null;
    /** Community Health File */
    "nullable-community-health-file": {
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string;
    } | null;
    /**
     * Community Profile
     * @description Community Profile
     */
    "community-profile": {
      /** @example 100 */
      health_percentage: number;
      /** @example My first repository on GitHub! */
      description: string | null;
      /** @example example.com */
      documentation: string | null;
      files: {
        code_of_conduct: components["schemas"]["nullable-code-of-conduct-simple"];
        code_of_conduct_file: components["schemas"]["nullable-community-health-file"];
        license: components["schemas"]["nullable-license-simple"];
        contributing: components["schemas"]["nullable-community-health-file"];
        readme: components["schemas"]["nullable-community-health-file"];
        issue_template: components["schemas"]["nullable-community-health-file"];
        pull_request_template: components["schemas"]["nullable-community-health-file"];
      };
      /**
       * Format: date-time
       * @example 2017-02-28T19:09:29Z
       */
      updated_at: string | null;
      /** @example true */
      content_reports_enabled?: boolean;
    };
    /**
     * Commit Comparison
     * @description Commit Comparison
     */
    "commit-comparison": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/compare/master...topic
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/compare/master...topic
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/compare/octocat:bbcd538c8e72b8c175046e27cc8f907076331401...octocat:0328041d1152db8ae77652d1618a02e57f745f17
       */
      permalink_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/compare/master...topic.diff
       */
      diff_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/compare/master...topic.patch
       */
      patch_url: string;
      base_commit: components["schemas"]["commit"];
      merge_base_commit: components["schemas"]["commit"];
      /**
       * @example ahead
       * @enum {string}
       */
      status: "diverged" | "ahead" | "behind" | "identical";
      /** @example 4 */
      ahead_by: number;
      /** @example 5 */
      behind_by: number;
      /** @example 6 */
      total_commits: number;
      commits: components["schemas"]["commit"][];
      files?: components["schemas"]["diff-entry"][];
    };
    /**
     * Content Tree
     * @description Content Tree
     */
    "content-tree": {
      type: string;
      size: number;
      name: string;
      path: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      download_url: string | null;
      entries?: {
        type: string;
        size: number;
        name: string;
        path: string;
        content?: string;
        sha: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        git_url: string | null;
        /** Format: uri */
        html_url: string | null;
        /** Format: uri */
        download_url: string | null;
        _links: {
          /** Format: uri */
          git: string | null;
          /** Format: uri */
          html: string | null;
          /** Format: uri */
          self: string;
        };
      }[];
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
    };
    /**
     * Content Directory
     * @description A list of directory items
     */
    "content-directory": {
      /** @enum {string} */
      type: "dir" | "file" | "submodule" | "symlink";
      size: number;
      name: string;
      path: string;
      content?: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      download_url: string | null;
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
    }[];
    /**
     * Content File
     * @description Content File
     */
    "content-file": {
      /** @enum {string} */
      type: "file";
      encoding: string;
      size: number;
      name: string;
      path: string;
      content: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      download_url: string | null;
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
      /** @example "actual/actual.md" */
      target?: string;
      /** @example "git://example.com/defunkt/dotjs.git" */
      submodule_git_url?: string;
    };
    /**
     * Symlink Content
     * @description An object describing a symlink
     */
    "content-symlink": {
      /** @enum {string} */
      type: "symlink";
      target: string;
      size: number;
      name: string;
      path: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      download_url: string | null;
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
    };
    /**
     * Submodule Content
     * @description An object describing a submodule
     */
    "content-submodule": {
      /** @enum {string} */
      type: "submodule";
      /** Format: uri */
      submodule_git_url: string;
      size: number;
      name: string;
      path: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      download_url: string | null;
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
    };
    /**
     * File Commit
     * @description File Commit
     */
    "file-commit": {
      content: {
        name?: string;
        path?: string;
        sha?: string;
        size?: number;
        url?: string;
        html_url?: string;
        git_url?: string;
        download_url?: string;
        type?: string;
        _links?: {
          self?: string;
          git?: string;
          html?: string;
        };
      } | null;
      commit: {
        sha?: string;
        node_id?: string;
        url?: string;
        html_url?: string;
        author?: {
          date?: string;
          name?: string;
          email?: string;
        };
        committer?: {
          date?: string;
          name?: string;
          email?: string;
        };
        message?: string;
        tree?: {
          url?: string;
          sha?: string;
        };
        parents?: {
          url?: string;
          html_url?: string;
          sha?: string;
        }[];
        verification?: {
          verified?: boolean;
          reason?: string;
          signature?: string | null;
          payload?: string | null;
        };
      };
    };
    /**
     * Contributor
     * @description Contributor
     */
    contributor: {
      login?: string;
      id?: number;
      node_id?: string;
      /** Format: uri */
      avatar_url?: string;
      gravatar_id?: string | null;
      /** Format: uri */
      url?: string;
      /** Format: uri */
      html_url?: string;
      /** Format: uri */
      followers_url?: string;
      following_url?: string;
      gists_url?: string;
      starred_url?: string;
      /** Format: uri */
      subscriptions_url?: string;
      /** Format: uri */
      organizations_url?: string;
      /** Format: uri */
      repos_url?: string;
      events_url?: string;
      /** Format: uri */
      received_events_url?: string;
      type: string;
      site_admin?: boolean;
      contributions: number;
      email?: string;
      name?: string;
    };
    /** @description A Dependabot alert. */
    "dependabot-alert": {
      number: components["schemas"]["alert-number"];
      /**
       * @description The state of the Dependabot alert.
       * @enum {string}
       */
      state: "auto_dismissed" | "dismissed" | "fixed" | "open";
      /** @description Details for the vulnerable dependency. */
      dependency: {
        readonly package?: components["schemas"]["dependabot-alert-package"];
        /** @description The full path to the dependency manifest file, relative to the root of the repository. */
        readonly manifest_path?: string;
        /**
         * @description The execution scope of the vulnerable dependency.
         * @enum {string|null}
         */
        readonly scope?: "development" | "runtime" | null;
      };
      security_advisory: components["schemas"]["dependabot-alert-security-advisory"];
      security_vulnerability: components["schemas"]["dependabot-alert-security-vulnerability"];
      url: components["schemas"]["alert-url"];
      html_url: components["schemas"]["alert-html-url"];
      created_at: components["schemas"]["alert-created-at"];
      updated_at: components["schemas"]["alert-updated-at"];
      dismissed_at: components["schemas"]["alert-dismissed-at"];
      dismissed_by: components["schemas"]["nullable-simple-user"];
      /**
       * @description The reason that the alert was dismissed.
       * @enum {string|null}
       */
      dismissed_reason:
        | "fix_started"
        | "inaccurate"
        | "no_bandwidth"
        | "not_used"
        | "tolerable_risk"
        | null;
      /** @description An optional comment associated with the alert's dismissal. */
      dismissed_comment: string | null;
      fixed_at: components["schemas"]["alert-fixed-at"];
      auto_dismissed_at?: components["schemas"]["alert-auto-dismissed-at"];
    };
    /**
     * Dependabot Secret
     * @description Set secrets for Dependabot.
     */
    "dependabot-secret": {
      /**
       * @description The name of the secret.
       * @example MY_ARTIFACTORY_PASSWORD
       */
      name: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Dependency Graph Diff
     * @description A diff of the dependencies between two commits.
     */
    "dependency-graph-diff": {
      /** @enum {string} */
      change_type: "added" | "removed";
      /** @example path/to/package-lock.json */
      manifest: string;
      /** @example npm */
      ecosystem: string;
      /** @example @actions/core */
      name: string;
      /** @example 1.0.0 */
      version: string;
      /** @example pkg:/npm/%40actions/core@1.1.0 */
      package_url: string | null;
      /** @example MIT */
      license: string | null;
      /** @example https://github.com/github/actions */
      source_repository_url: string | null;
      vulnerabilities: {
        /** @example critical */
        severity: string;
        /** @example GHSA-rf4j-j272-fj86 */
        advisory_ghsa_id: string;
        /** @example A summary of the advisory. */
        advisory_summary: string;
        /** @example https://github.com/advisories/GHSA-rf4j-j272-fj86 */
        advisory_url: string;
      }[];
      /**
       * @description Where the dependency is utilized. `development` means that the dependency is only utilized in the development environment. `runtime` means that the dependency is utilized at runtime and in the development environment.
       * @enum {string}
       */
      scope: "unknown" | "runtime" | "development";
    }[];
    /**
     * Dependency Graph SPDX SBOM
     * @description A schema for the SPDX JSON format returned by the Dependency Graph.
     */
    "dependency-graph-spdx-sbom": {
      sbom: {
        /**
         * @description The SPDX identifier for the SPDX document.
         * @example SPDXRef-DOCUMENT
         */
        SPDXID: string;
        /**
         * @description The version of the SPDX specification that this document conforms to.
         * @example SPDX-2.3
         */
        spdxVersion: string;
        creationInfo: {
          /**
           * @description The date and time the SPDX document was created.
           * @example 2021-11-03T00:00:00Z
           */
          created: string;
          /** @description The tools that were used to generate the SPDX document. */
          creators: string[];
        };
        /**
         * @description The name of the SPDX document.
         * @example github/github
         */
        name: string;
        /**
         * @description The license under which the SPDX document is licensed.
         * @example CC0-1.0
         */
        dataLicense: string;
        /** @description The name of the repository that the SPDX document describes. */
        documentDescribes: string[];
        /**
         * @description The namespace for the SPDX document.
         * @example https://github.com/example/dependency_graph/sbom-123
         */
        documentNamespace: string;
        packages: {
          /**
           * @description A unique SPDX identifier for the package.
           * @example SPDXRef-Package
           */
          SPDXID?: string;
          /**
           * @description The name of the package.
           * @example rubygems:github/github
           */
          name?: string;
          /**
           * @description The version of the package. If the package does not have an exact version specified,
           * a version range is given.
           * @example 1.0.0
           */
          versionInfo?: string;
          /**
           * @description The location where the package can be downloaded,
           * or NOASSERTION if this has not been determined.
           * @example NOASSERTION
           */
          downloadLocation?: string;
          /**
           * @description Whether the package's file content has been subjected to
           * analysis during the creation of the SPDX document.
           * @example false
           */
          filesAnalyzed?: boolean;
          /**
           * @description The license of the package as determined while creating the SPDX document.
           * @example MIT
           */
          licenseConcluded?: string;
          /**
           * @description The license of the package as declared by its author, or NOASSERTION if this information
           * was not available when the SPDX document was created.
           * @example NOASSERTION
           */
          licenseDeclared?: string;
          /**
           * @description The distribution source of this package, or NOASSERTION if this was not determined.
           * @example NOASSERTION
           */
          supplier?: string;
          externalRefs?: {
            /**
             * @description The category of reference to an external resource this reference refers to.
             * @example PACKAGE-MANAGER
             */
            referenceCategory: string;
            /**
             * @description A locator for the particular external resource this reference refers to.
             * @example pkg:gem/rails@6.0.1
             */
            referenceLocator: string;
            /**
             * @description The category of reference to an external resource this reference refers to.
             * @example purl
             */
            referenceType: string;
          }[];
        }[];
      };
    };
    /**
     * metadata
     * @description User-defined metadata to store domain-specific information limited to 8 keys with scalar values.
     */
    metadata: {
      [key: string]: ((string | number | boolean) | null) | undefined;
    };
    dependency: {
      /**
       * @description Package-url (PURL) of dependency. See https://github.com/package-url/purl-spec for more details.
       * @example pkg:/npm/%40actions/http-client@1.0.11
       */
      package_url?: string;
      metadata?: components["schemas"]["metadata"];
      /**
       * @description A notation of whether a dependency is requested directly by this manifest or is a dependency of another dependency.
       * @example direct
       * @enum {string}
       */
      relationship?: "direct" | "indirect";
      /**
       * @description A notation of whether the dependency is required for the primary build artifact (runtime) or is only used for development. Future versions of this specification may allow for more granular scopes.
       * @example runtime
       * @enum {string}
       */
      scope?: "runtime" | "development";
      /**
       * @description Array of package-url (PURLs) of direct child dependencies.
       * @example @actions/http-client
       */
      dependencies?: string[];
    };
    manifest: {
      /**
       * @description The name of the manifest.
       * @example package-lock.json
       */
      name: string;
      file?: {
        /**
         * @description The path of the manifest file relative to the root of the Git repository.
         * @example /src/build/package-lock.json
         */
        source_location?: string;
      };
      metadata?: components["schemas"]["metadata"];
      /** @description A collection of resolved package dependencies. */
      resolved?: {
        [key: string]: components["schemas"]["dependency"] | undefined;
      };
    };
    /**
     * snapshot
     * @description Create a new snapshot of a repository's dependencies.
     */
    snapshot: {
      /** @description The version of the repository snapshot submission. */
      version: number;
      job: {
        /**
         * @description The external ID of the job.
         * @example 5622a2b0-63f6-4732-8c34-a1ab27e102a11
         */
        id: string;
        /**
         * @description Correlator provides a key that is used to group snapshots submitted over time. Only the "latest" submitted snapshot for a given combination of `job.correlator` and `detector.name` will be considered when calculating a repository's current dependencies. Correlator should be as unique as it takes to distinguish all detection runs for a given "wave" of CI workflow you run. If you're using GitHub Actions, a good default value for this could be the environment variables GITHUB_WORKFLOW and GITHUB_JOB concatenated together. If you're using a build matrix, then you'll also need to add additional key(s) to distinguish between each submission inside a matrix variation.
         * @example yourworkflowname_yourjobname
         */
        correlator: string;
        /**
         * @description The url for the job.
         * @example http://example.com/build
         */
        html_url?: string;
      };
      /**
       * @description The commit SHA associated with this dependency snapshot. Maximum length: 40 characters.
       * @example ddc951f4b1293222421f2c8df679786153acf689
       */
      sha: string;
      /**
       * @description The repository branch that triggered this snapshot.
       * @example refs/heads/main
       */
      ref: string;
      /** @description A description of the detector used. */
      detector: {
        /**
         * @description The name of the detector used.
         * @example docker buildtime detector
         */
        name: string;
        /**
         * @description The version of the detector used.
         * @example 1.0.0
         */
        version: string;
        /**
         * @description The url of the detector used.
         * @example http://example.com/docker-buildtimer-detector
         */
        url: string;
      };
      metadata?: components["schemas"]["metadata"];
      /** @description A collection of package manifests, which are a collection of related dependencies declared in a file or representing a logical group of dependencies. */
      manifests?: {
        [key: string]: components["schemas"]["manifest"] | undefined;
      };
      /**
       * Format: date-time
       * @description The time at which the snapshot was scanned.
       * @example 2020-06-13T14:52:50-05:00
       */
      scanned: string;
    };
    /**
     * Deployment Status
     * @description The status of a deployment.
     */
    "deployment-status": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/42/statuses/1
       */
      url: string;
      /** @example 1 */
      id: number;
      /** @example MDE2OkRlcGxveW1lbnRTdGF0dXMx */
      node_id: string;
      /**
       * @description The state of the status.
       * @example success
       * @enum {string}
       */
      state:
        | "error"
        | "failure"
        | "inactive"
        | "pending"
        | "success"
        | "queued"
        | "in_progress";
      creator: components["schemas"]["nullable-simple-user"];
      /**
       * @description A short description of the status.
       * @default
       * @example Deployment finished successfully.
       */
      description: string;
      /**
       * @description The environment of the deployment that the status is for.
       * @default
       * @example production
       */
      environment?: string;
      /**
       * Format: uri
       * @description Deprecated: the URL to associate with this status.
       * @default
       * @example https://example.com/deployment/42/output
       */
      target_url: string;
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2012-07-20T01:19:13Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/deployments/42
       */
      deployment_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example
       */
      repository_url: string;
      /**
       * Format: uri
       * @description The URL for accessing your environment.
       * @default
       * @example https://staging.example.com/
       */
      environment_url?: string;
      /**
       * Format: uri
       * @description The URL to associate with this status.
       * @default
       * @example https://example.com/deployment/42/output
       */
      log_url?: string;
      performed_via_github_app?: components["schemas"]["nullable-integration"];
    };
    /**
     * @description The amount of time to delay a job after the job is initially triggered. The time (in minutes) must be an integer between 0 and 43,200 (30 days).
     * @example 30
     */
    "wait-timer": number;
    /** @description The type of deployment branch policy for this environment. To allow all branches to deploy, set to `null`. */
    "deployment-branch-policy-settings": {
      /** @description Whether only branches with branch protection rules can deploy to this environment. If `protected_branches` is `true`, `custom_branch_policies` must be `false`; if `protected_branches` is `false`, `custom_branch_policies` must be `true`. */
      protected_branches: boolean;
      /** @description Whether only branches that match the specified name patterns can deploy to this environment.  If `custom_branch_policies` is `true`, `protected_branches` must be `false`; if `custom_branch_policies` is `false`, `protected_branches` must be `true`. */
      custom_branch_policies: boolean;
    } | null;
    /**
     * Environment
     * @description Details of a deployment environment
     */
    environment: {
      /**
       * @description The id of the environment.
       * @example 56780428
       */
      id: number;
      /** @example MDExOkVudmlyb25tZW50NTY3ODA0Mjg= */
      node_id: string;
      /**
       * @description The name of the environment.
       * @example staging
       */
      name: string;
      /** @example https://api.github.com/repos/github/hello-world/environments/staging */
      url: string;
      /** @example https://github.com/github/hello-world/deployments/activity_log?environments_filter=staging */
      html_url: string;
      /**
       * Format: date-time
       * @description The time that the environment was created, in ISO 8601 format.
       * @example 2020-11-23T22:00:40Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The time that the environment was last updated, in ISO 8601 format.
       * @example 2020-11-23T22:00:40Z
       */
      updated_at: string;
      /** @description Built-in deployment protection rules for the environment. */
      protection_rules?: (
        | {
            /** @example 3515 */
            id: number;
            /** @example MDQ6R2F0ZTM1MTU= */
            node_id: string;
            /** @example wait_timer */
            type: string;
            wait_timer?: components["schemas"]["wait-timer"];
          }
        | {
            /** @example 3755 */
            id: number;
            /** @example MDQ6R2F0ZTM3NTU= */
            node_id: string;
            /** @example required_reviewers */
            type: string;
            /** @description The people or teams that may approve jobs that reference the environment. You can list up to six users or teams as reviewers. The reviewers must have at least read access to the repository. Only one of the required reviewers needs to approve the job for it to proceed. */
            reviewers?: {
              type?: components["schemas"]["deployment-reviewer-type"];
              reviewer?:
                | components["schemas"]["simple-user"]
                | components["schemas"]["team"];
            }[];
          }
        | {
            /** @example 3515 */
            id: number;
            /** @example MDQ6R2F0ZTM1MTU= */
            node_id: string;
            /** @example branch_policy */
            type: string;
          }
      )[];
      deployment_branch_policy?: components["schemas"]["deployment-branch-policy-settings"];
    };
    /**
     * Deployment branch policy
     * @description Details of a deployment branch policy.
     */
    "deployment-branch-policy": {
      /**
       * @description The unique identifier of the branch policy.
       * @example 361471
       */
      id?: number;
      /** @example MDE2OkdhdGVCcmFuY2hQb2xpY3kzNjE0NzE= */
      node_id?: string;
      /**
       * @description The name pattern that branches must match in order to deploy to the environment.
       * @example release/*
       */
      name?: string;
    };
    /** Deployment branch policy name pattern */
    "deployment-branch-policy-name-pattern": {
      /**
       * @description The name pattern that branches must match in order to deploy to the environment.
       *
       * Wildcard characters will not match `/`. For example, to match branches that begin with `release/` and contain an additional single slash, use `release/*\/*`.
       * For more information about pattern matching syntax, see the [Ruby File.fnmatch documentation](https://ruby-doc.org/core-2.5.1/File.html#method-c-fnmatch).
       * @example release/*
       */
      name: string;
    };
    /**
     * Custom deployment protection rule app
     * @description A GitHub App that is providing a custom deployment protection rule.
     */
    "custom-deployment-rule-app": {
      /**
       * @description The unique identifier of the deployment protection rule integration.
       * @example 3515
       */
      id: number;
      /**
       * @description The slugified name of the deployment protection rule integration.
       * @example my-custom-app
       */
      slug: string;
      /**
       * @description The URL for the endpoint to get details about the app.
       * @example https://api.github.com/apps/custom-app-slug
       */
      integration_url: string;
      /**
       * @description The node ID for the deployment protection rule integration.
       * @example MDQ6R2F0ZTM1MTU=
       */
      node_id: string;
    };
    /**
     * Deployment protection rule
     * @description Deployment protection rule
     */
    "deployment-protection-rule": {
      /**
       * @description The unique identifier for the deployment protection rule.
       * @example 3515
       */
      id: number;
      /**
       * @description The node ID for the deployment protection rule.
       * @example MDQ6R2F0ZTM1MTU=
       */
      node_id: string;
      /**
       * @description Whether the deployment protection rule is enabled for the environment.
       * @example true
       */
      enabled: boolean;
      app: components["schemas"]["custom-deployment-rule-app"];
    };
    /**
     * Short Blob
     * @description Short Blob
     */
    "short-blob": {
      url: string;
      sha: string;
    };
    /**
     * Blob
     * @description Blob
     */
    blob: {
      content: string;
      encoding: string;
      /** Format: uri */
      url: string;
      sha: string;
      size: number | null;
      node_id: string;
      highlighted_content?: string;
    };
    /**
     * Git Commit
     * @description Low-level Git commit operations within a repository
     */
    "git-commit": {
      /**
       * @description SHA for the commit
       * @example 7638417db6d59f3c431d3e1f261cc637155684cd
       */
      sha: string;
      node_id: string;
      /** Format: uri */
      url: string;
      /** @description Identifying information for the git-user */
      author: {
        /**
         * Format: date-time
         * @description Timestamp of the commit
         * @example 2014-08-09T08:02:04+12:00
         */
        date: string;
        /**
         * @description Git email address of the user
         * @example monalisa.octocat@example.com
         */
        email: string;
        /**
         * @description Name of the git user
         * @example Monalisa Octocat
         */
        name: string;
      };
      /** @description Identifying information for the git-user */
      committer: {
        /**
         * Format: date-time
         * @description Timestamp of the commit
         * @example 2014-08-09T08:02:04+12:00
         */
        date: string;
        /**
         * @description Git email address of the user
         * @example monalisa.octocat@example.com
         */
        email: string;
        /**
         * @description Name of the git user
         * @example Monalisa Octocat
         */
        name: string;
      };
      /**
       * @description Message describing the purpose of the commit
       * @example Fix #42
       */
      message: string;
      tree: {
        /**
         * @description SHA for the commit
         * @example 7638417db6d59f3c431d3e1f261cc637155684cd
         */
        sha: string;
        /** Format: uri */
        url: string;
      };
      parents: {
        /**
         * @description SHA for the commit
         * @example 7638417db6d59f3c431d3e1f261cc637155684cd
         */
        sha: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        html_url: string;
      }[];
      verification: {
        verified: boolean;
        reason: string;
        signature: string | null;
        payload: string | null;
      };
      /** Format: uri */
      html_url: string;
    };
    /**
     * Git Reference
     * @description Git references within a repository
     */
    "git-ref": {
      ref: string;
      node_id: string;
      /** Format: uri */
      url: string;
      object: {
        type: string;
        /**
         * @description SHA for the reference
         * @example 7638417db6d59f3c431d3e1f261cc637155684cd
         */
        sha: string;
        /** Format: uri */
        url: string;
      };
    };
    /**
     * Git Tag
     * @description Metadata for a Git tag
     */
    "git-tag": {
      /** @example MDM6VGFnOTQwYmQzMzYyNDhlZmFlMGY5ZWU1YmM3YjJkNWM5ODU4ODdiMTZhYw== */
      node_id: string;
      /**
       * @description Name of the tag
       * @example v0.0.1
       */
      tag: string;
      /** @example 940bd336248efae0f9ee5bc7b2d5c985887b16ac */
      sha: string;
      /**
       * Format: uri
       * @description URL for the tag
       * @example https://api.github.com/repositories/42/git/tags/940bd336248efae0f9ee5bc7b2d5c985887b16ac
       */
      url: string;
      /**
       * @description Message describing the purpose of the tag
       * @example Initial public release
       */
      message: string;
      tagger: {
        date: string;
        email: string;
        name: string;
      };
      object: {
        sha: string;
        type: string;
        /** Format: uri */
        url: string;
      };
      verification?: components["schemas"]["verification"];
    };
    /**
     * Git Tree
     * @description The hierarchy between files in a Git repository.
     */
    "git-tree": {
      sha: string;
      /** Format: uri */
      url: string;
      truncated: boolean;
      /**
       * @description Objects specifying a tree structure
       * @example [
       *   {
       *     "path": "file.rb",
       *     "mode": "100644",
       *     "type": "blob",
       *     "size": 30,
       *     "sha": "44b4fc6d56897b048c772eb4087f854f46256132",
       *     "url": "https://api.github.com/repos/octocat/Hello-World/git/blobs/44b4fc6d56897b048c772eb4087f854f46256132",
       *     "properties": {
       *       "path": {
       *         "type": "string"
       *       },
       *       "mode": {
       *         "type": "string"
       *       },
       *       "type": {
       *         "type": "string"
       *       },
       *       "size": {
       *         "type": "integer"
       *       },
       *       "sha": {
       *         "type": "string"
       *       },
       *       "url": {
       *         "type": "string"
       *       }
       *     },
       *     "required": [
       *       "path",
       *       "mode",
       *       "type",
       *       "sha",
       *       "url",
       *       "size"
       *     ]
       *   }
       * ]
       */
      tree: {
        /** @example test/file.rb */
        path?: string;
        /** @example 040000 */
        mode?: string;
        /** @example tree */
        type?: string;
        /** @example 23f6827669e43831def8a7ad935069c8bd418261 */
        sha?: string;
        /** @example 12 */
        size?: number;
        /** @example https://api.github.com/repos/owner-482f3203ecf01f67e9deb18e/BBB_Private_Repo/git/blobs/23f6827669e43831def8a7ad935069c8bd418261 */
        url?: string;
      }[];
    };
    /** Hook Response */
    "hook-response": {
      code: number | null;
      status: string | null;
      message: string | null;
    };
    /**
     * Webhook
     * @description Webhooks for repositories.
     */
    hook: {
      type: string;
      /**
       * @description Unique identifier of the webhook.
       * @example 42
       */
      id: number;
      /**
       * @description The name of a valid service, use 'web' for a webhook.
       * @example web
       */
      name: string;
      /**
       * @description Determines whether the hook is actually triggered on pushes.
       * @example true
       */
      active: boolean;
      /**
       * @description Determines what events the hook is triggered for. Default: ['push'].
       * @example [
       *   "push",
       *   "pull_request"
       * ]
       */
      events: string[];
      config: {
        /** @example "foo@bar.com" */
        email?: string;
        /** @example "foo" */
        password?: string;
        /** @example "roomer" */
        room?: string;
        /** @example "foo" */
        subdomain?: string;
        url?: components["schemas"]["webhook-config-url"];
        insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
        content_type?: components["schemas"]["webhook-config-content-type"];
        /** @example "sha256" */
        digest?: string;
        secret?: components["schemas"]["webhook-config-secret"];
        /** @example "abc" */
        token?: string;
      };
      /**
       * Format: date-time
       * @example 2011-09-06T20:39:23Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2011-09-06T17:26:27Z
       */
      created_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/hooks/1
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/hooks/1/test
       */
      test_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/hooks/1/pings
       */
      ping_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/hooks/1/deliveries
       */
      deliveries_url?: string;
      last_response: components["schemas"]["hook-response"];
    };
    /**
     * Import
     * @description A repository import from an external source.
     */
    import: {
      vcs: string | null;
      use_lfs?: boolean;
      /** @description The URL of the originating repository. */
      vcs_url: string;
      svc_root?: string;
      tfvc_project?: string;
      /** @enum {string} */
      status:
        | "auth"
        | "error"
        | "none"
        | "detecting"
        | "choose"
        | "auth_failed"
        | "importing"
        | "mapping"
        | "waiting_to_push"
        | "pushing"
        | "complete"
        | "setup"
        | "unknown"
        | "detection_found_multiple"
        | "detection_found_nothing"
        | "detection_needs_auth";
      status_text?: string | null;
      failed_step?: string | null;
      error_message?: string | null;
      import_percent?: number | null;
      commit_count?: number | null;
      push_percent?: number | null;
      has_large_files?: boolean;
      large_files_size?: number;
      large_files_count?: number;
      project_choices?: {
        vcs?: string;
        tfvc_project?: string;
        human_name?: string;
      }[];
      message?: string;
      authors_count?: number | null;
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      authors_url: string;
      /** Format: uri */
      repository_url: string;
      svn_root?: string;
    };
    /**
     * Porter Author
     * @description Porter Author
     */
    "porter-author": {
      id: number;
      remote_id: string;
      remote_name: string;
      email: string;
      name: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      import_url: string;
    };
    /**
     * Porter Large File
     * @description Porter Large File
     */
    "porter-large-file": {
      ref_name: string;
      path: string;
      oid: string;
      size: number;
    };
    /**
     * Issue
     * @description Issues are a great way to keep track of tasks, enhancements, and bugs for your projects.
     */
    "nullable-issue": {
      /** Format: int64 */
      id: number;
      node_id: string;
      /**
       * Format: uri
       * @description URL for the issue
       * @example https://api.github.com/repositories/42/issues/1
       */
      url: string;
      /** Format: uri */
      repository_url: string;
      labels_url: string;
      /** Format: uri */
      comments_url: string;
      /** Format: uri */
      events_url: string;
      /** Format: uri */
      html_url: string;
      /**
       * @description Number uniquely identifying the issue within its repository
       * @example 42
       */
      number: number;
      /**
       * @description State of the issue; either 'open' or 'closed'
       * @example open
       */
      state: string;
      /**
       * @description The reason for the current state
       * @example not_planned
       * @enum {string|null}
       */
      state_reason?: "completed" | "reopened" | "not_planned" | null;
      /**
       * @description Title of the issue
       * @example Widget creation fails in Safari on OS X 10.8
       */
      title: string;
      /**
       * @description Contents of the issue
       * @example It looks like the new widget form is broken on Safari. When I try and create the widget, Safari crashes. This is reproducible on 10.8, but not 10.9. Maybe a browser bug?
       */
      body?: string | null;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * @description Labels to associate with this issue; pass one or more label names to replace the set of labels on this issue; send an empty array to clear all labels from the issue; note that the labels are silently dropped for users without push access to the repository
       * @example [
       *   "bug",
       *   "registration"
       * ]
       */
      labels: OneOf<
        [
          string,
          {
            /** Format: int64 */
            id?: number;
            node_id?: string;
            /** Format: uri */
            url?: string;
            name?: string;
            description?: string | null;
            color?: string | null;
            default?: boolean;
          }
        ]
      >[];
      assignee: components["schemas"]["nullable-simple-user"];
      assignees?: components["schemas"]["simple-user"][] | null;
      milestone: components["schemas"]["nullable-milestone"];
      locked: boolean;
      active_lock_reason?: string | null;
      comments: number;
      pull_request?: {
        /** Format: date-time */
        merged_at?: string | null;
        /** Format: uri */
        diff_url: string | null;
        /** Format: uri */
        html_url: string | null;
        /** Format: uri */
        patch_url: string | null;
        /** Format: uri */
        url: string | null;
      };
      /** Format: date-time */
      closed_at: string | null;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      draft?: boolean;
      closed_by?: components["schemas"]["nullable-simple-user"];
      body_html?: string;
      body_text?: string;
      /** Format: uri */
      timeline_url?: string;
      repository?: components["schemas"]["repository"];
      performed_via_github_app?: components["schemas"]["nullable-integration"];
      author_association: components["schemas"]["author-association"];
      reactions?: components["schemas"]["reaction-rollup"];
    } | null;
    /**
     * Issue Event Label
     * @description Issue Event Label
     */
    "issue-event-label": {
      name: string | null;
      color: string | null;
    };
    /** Issue Event Dismissed Review */
    "issue-event-dismissed-review": {
      state: string;
      review_id: number;
      dismissal_message: string | null;
      dismissal_commit_id?: string | null;
    };
    /**
     * Issue Event Milestone
     * @description Issue Event Milestone
     */
    "issue-event-milestone": {
      title: string;
    };
    /**
     * Issue Event Project Card
     * @description Issue Event Project Card
     */
    "issue-event-project-card": {
      /** Format: uri */
      url: string;
      id: number;
      /** Format: uri */
      project_url: string;
      project_id: number;
      column_name: string;
      previous_column_name?: string;
    };
    /**
     * Issue Event Rename
     * @description Issue Event Rename
     */
    "issue-event-rename": {
      from: string;
      to: string;
    };
    /**
     * Issue Event
     * @description Issue Event
     */
    "issue-event": {
      /**
       * Format: int64
       * @example 1
       */
      id: number;
      /** @example MDEwOklzc3VlRXZlbnQx */
      node_id: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/issues/events/1
       */
      url: string;
      actor: components["schemas"]["nullable-simple-user"];
      /** @example closed */
      event: string;
      /** @example 6dcb09b5b57875f334f61aebed695e2e4193db5e */
      commit_id: string | null;
      /** @example https://api.github.com/repos/octocat/Hello-World/commits/6dcb09b5b57875f334f61aebed695e2e4193db5e */
      commit_url: string | null;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      created_at: string;
      issue?: components["schemas"]["nullable-issue"];
      label?: components["schemas"]["issue-event-label"];
      assignee?: components["schemas"]["nullable-simple-user"];
      assigner?: components["schemas"]["nullable-simple-user"];
      review_requester?: components["schemas"]["nullable-simple-user"];
      requested_reviewer?: components["schemas"]["nullable-simple-user"];
      requested_team?: components["schemas"]["team"];
      dismissed_review?: components["schemas"]["issue-event-dismissed-review"];
      milestone?: components["schemas"]["issue-event-milestone"];
      project_card?: components["schemas"]["issue-event-project-card"];
      rename?: components["schemas"]["issue-event-rename"];
      author_association?: components["schemas"]["author-association"];
      lock_reason?: string | null;
      performed_via_github_app?: components["schemas"]["nullable-integration"];
    };
    /**
     * Labeled Issue Event
     * @description Labeled Issue Event
     */
    "labeled-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      label: {
        name: string;
        color: string;
      };
    };
    /**
     * Unlabeled Issue Event
     * @description Unlabeled Issue Event
     */
    "unlabeled-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      label: {
        name: string;
        color: string;
      };
    };
    /**
     * Assigned Issue Event
     * @description Assigned Issue Event
     */
    "assigned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["integration"];
      assignee: components["schemas"]["simple-user"];
      assigner: components["schemas"]["simple-user"];
    };
    /**
     * Unassigned Issue Event
     * @description Unassigned Issue Event
     */
    "unassigned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      assignee: components["schemas"]["simple-user"];
      assigner: components["schemas"]["simple-user"];
    };
    /**
     * Milestoned Issue Event
     * @description Milestoned Issue Event
     */
    "milestoned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      milestone: {
        title: string;
      };
    };
    /**
     * Demilestoned Issue Event
     * @description Demilestoned Issue Event
     */
    "demilestoned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      milestone: {
        title: string;
      };
    };
    /**
     * Renamed Issue Event
     * @description Renamed Issue Event
     */
    "renamed-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      rename: {
        from: string;
        to: string;
      };
    };
    /**
     * Review Requested Issue Event
     * @description Review Requested Issue Event
     */
    "review-requested-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      review_requester: components["schemas"]["simple-user"];
      requested_team?: components["schemas"]["team"];
      requested_reviewer?: components["schemas"]["simple-user"];
    };
    /**
     * Review Request Removed Issue Event
     * @description Review Request Removed Issue Event
     */
    "review-request-removed-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      review_requester: components["schemas"]["simple-user"];
      requested_team?: components["schemas"]["team"];
      requested_reviewer?: components["schemas"]["simple-user"];
    };
    /**
     * Review Dismissed Issue Event
     * @description Review Dismissed Issue Event
     */
    "review-dismissed-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      dismissed_review: {
        state: string;
        review_id: number;
        dismissal_message: string | null;
        dismissal_commit_id?: string;
      };
    };
    /**
     * Locked Issue Event
     * @description Locked Issue Event
     */
    "locked-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      /** @example "off-topic" */
      lock_reason: string | null;
    };
    /**
     * Added to Project Issue Event
     * @description Added to Project Issue Event
     */
    "added-to-project-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      project_card?: {
        id: number;
        /** Format: uri */
        url: string;
        project_id: number;
        /** Format: uri */
        project_url: string;
        column_name: string;
        previous_column_name?: string;
      };
    };
    /**
     * Moved Column in Project Issue Event
     * @description Moved Column in Project Issue Event
     */
    "moved-column-in-project-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      project_card?: {
        id: number;
        /** Format: uri */
        url: string;
        project_id: number;
        /** Format: uri */
        project_url: string;
        column_name: string;
        previous_column_name?: string;
      };
    };
    /**
     * Removed from Project Issue Event
     * @description Removed from Project Issue Event
     */
    "removed-from-project-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      project_card?: {
        id: number;
        /** Format: uri */
        url: string;
        project_id: number;
        /** Format: uri */
        project_url: string;
        column_name: string;
        previous_column_name?: string;
      };
    };
    /**
     * Converted Note to Issue Issue Event
     * @description Converted Note to Issue Issue Event
     */
    "converted-note-to-issue-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["integration"];
      project_card?: {
        id: number;
        /** Format: uri */
        url: string;
        project_id: number;
        /** Format: uri */
        project_url: string;
        column_name: string;
        previous_column_name?: string;
      };
    };
    /**
     * Issue Event for Issue
     * @description Issue Event for Issue
     */
    "issue-event-for-issue":
      | components["schemas"]["labeled-issue-event"]
      | components["schemas"]["unlabeled-issue-event"]
      | components["schemas"]["assigned-issue-event"]
      | components["schemas"]["unassigned-issue-event"]
      | components["schemas"]["milestoned-issue-event"]
      | components["schemas"]["demilestoned-issue-event"]
      | components["schemas"]["renamed-issue-event"]
      | components["schemas"]["review-requested-issue-event"]
      | components["schemas"]["review-request-removed-issue-event"]
      | components["schemas"]["review-dismissed-issue-event"]
      | components["schemas"]["locked-issue-event"]
      | components["schemas"]["added-to-project-issue-event"]
      | components["schemas"]["moved-column-in-project-issue-event"]
      | components["schemas"]["removed-from-project-issue-event"]
      | components["schemas"]["converted-note-to-issue-issue-event"];
    /**
     * Label
     * @description Color-coded labels help you categorize and filter your issues (just like labels in Gmail).
     */
    label: {
      /**
       * Format: int64
       * @example 208045946
       */
      id: number;
      /** @example MDU6TGFiZWwyMDgwNDU5NDY= */
      node_id: string;
      /**
       * Format: uri
       * @description URL for the label
       * @example https://api.github.com/repositories/42/labels/bug
       */
      url: string;
      /**
       * @description The name of the label.
       * @example bug
       */
      name: string;
      /** @example Something isn't working */
      description: string | null;
      /**
       * @description 6-character hex code, without the leading #, identifying the color
       * @example FFFFFF
       */
      color: string;
      /** @example true */
      default: boolean;
    };
    /**
     * Timeline Comment Event
     * @description Timeline Comment Event
     */
    "timeline-comment-event": {
      event: string;
      actor: components["schemas"]["simple-user"];
      /**
       * @description Unique identifier of the issue comment
       * @example 42
       */
      id: number;
      node_id: string;
      /**
       * Format: uri
       * @description URL for the issue comment
       * @example https://api.github.com/repositories/42/issues/comments/1
       */
      url: string;
      /**
       * @description Contents of the issue comment
       * @example What version of Safari were you using when you observed this bug?
       */
      body?: string;
      body_text?: string;
      body_html?: string;
      /** Format: uri */
      html_url: string;
      user: components["schemas"]["simple-user"];
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      updated_at: string;
      /** Format: uri */
      issue_url: string;
      author_association: components["schemas"]["author-association"];
      performed_via_github_app?: components["schemas"]["nullable-integration"];
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Timeline Cross Referenced Event
     * @description Timeline Cross Referenced Event
     */
    "timeline-cross-referenced-event": {
      event: string;
      actor?: components["schemas"]["simple-user"];
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      source: {
        type?: string;
        issue?: components["schemas"]["issue"];
      };
    };
    /**
     * Timeline Committed Event
     * @description Timeline Committed Event
     */
    "timeline-committed-event": {
      event?: string;
      /**
       * @description SHA for the commit
       * @example 7638417db6d59f3c431d3e1f261cc637155684cd
       */
      sha: string;
      node_id: string;
      /** Format: uri */
      url: string;
      /** @description Identifying information for the git-user */
      author: {
        /**
         * Format: date-time
         * @description Timestamp of the commit
         * @example 2014-08-09T08:02:04+12:00
         */
        date: string;
        /**
         * @description Git email address of the user
         * @example monalisa.octocat@example.com
         */
        email: string;
        /**
         * @description Name of the git user
         * @example Monalisa Octocat
         */
        name: string;
      };
      /** @description Identifying information for the git-user */
      committer: {
        /**
         * Format: date-time
         * @description Timestamp of the commit
         * @example 2014-08-09T08:02:04+12:00
         */
        date: string;
        /**
         * @description Git email address of the user
         * @example monalisa.octocat@example.com
         */
        email: string;
        /**
         * @description Name of the git user
         * @example Monalisa Octocat
         */
        name: string;
      };
      /**
       * @description Message describing the purpose of the commit
       * @example Fix #42
       */
      message: string;
      tree: {
        /**
         * @description SHA for the commit
         * @example 7638417db6d59f3c431d3e1f261cc637155684cd
         */
        sha: string;
        /** Format: uri */
        url: string;
      };
      parents: {
        /**
         * @description SHA for the commit
         * @example 7638417db6d59f3c431d3e1f261cc637155684cd
         */
        sha: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        html_url: string;
      }[];
      verification: {
        verified: boolean;
        reason: string;
        signature: string | null;
        payload: string | null;
      };
      /** Format: uri */
      html_url: string;
    };
    /**
     * Timeline Reviewed Event
     * @description Timeline Reviewed Event
     */
    "timeline-reviewed-event": {
      event: string;
      /**
       * @description Unique identifier of the review
       * @example 42
       */
      id: number;
      /** @example MDE3OlB1bGxSZXF1ZXN0UmV2aWV3ODA= */
      node_id: string;
      user: components["schemas"]["simple-user"];
      /**
       * @description The text of the review.
       * @example This looks great.
       */
      body: string | null;
      /** @example CHANGES_REQUESTED */
      state: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/12#pullrequestreview-80
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/12
       */
      pull_request_url: string;
      _links: {
        html: {
          href: string;
        };
        pull_request: {
          href: string;
        };
      };
      /** Format: date-time */
      submitted_at?: string;
      /**
       * @description A commit SHA for the review.
       * @example 54bb654c9e6025347f57900a4a5c2313a96b8035
       */
      commit_id: string;
      body_html?: string;
      body_text?: string;
      author_association: components["schemas"]["author-association"];
    };
    /**
     * Pull Request Review Comment
     * @description Pull Request Review Comments are comments on a portion of the Pull Request's diff.
     */
    "pull-request-review-comment": {
      /**
       * @description URL for the pull request review comment
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/comments/1
       */
      url: string;
      /**
       * @description The ID of the pull request review to which the comment belongs.
       * @example 42
       */
      pull_request_review_id: number | null;
      /**
       * @description The ID of the pull request review comment.
       * @example 1
       */
      id: number;
      /**
       * @description The node ID of the pull request review comment.
       * @example MDI0OlB1bGxSZXF1ZXN0UmV2aWV3Q29tbWVudDEw
       */
      node_id: string;
      /**
       * @description The diff of the line that the comment refers to.
       * @example @@ -16,33 +16,40 @@ public class Connection : IConnection...
       */
      diff_hunk: string;
      /**
       * @description The relative path of the file to which the comment applies.
       * @example config/database.yaml
       */
      path: string;
      /**
       * @description The line index in the diff to which the comment applies. This field is deprecated; use `line` instead.
       * @example 1
       */
      position?: number;
      /**
       * @description The index of the original line in the diff to which the comment applies. This field is deprecated; use `original_line` instead.
       * @example 4
       */
      original_position?: number;
      /**
       * @description The SHA of the commit to which the comment applies.
       * @example 6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      commit_id: string;
      /**
       * @description The SHA of the original commit to which the comment applies.
       * @example 9c48853fa3dc5c1c3d6f1f1cd1f2743e72652840
       */
      original_commit_id: string;
      /**
       * @description The comment ID to reply to.
       * @example 8
       */
      in_reply_to_id?: number;
      user: components["schemas"]["simple-user"];
      /**
       * @description The text of the comment.
       * @example We should probably include a check for null values here.
       */
      body: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @description HTML URL for the pull request review comment.
       * @example https://github.com/octocat/Hello-World/pull/1#discussion-diff-1
       */
      html_url: string;
      /**
       * Format: uri
       * @description URL for the pull request that the review comment belongs to.
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1
       */
      pull_request_url: string;
      author_association: components["schemas"]["author-association"];
      _links: {
        self: {
          /**
           * Format: uri
           * @example https://api.github.com/repos/octocat/Hello-World/pulls/comments/1
           */
          href: string;
        };
        html: {
          /**
           * Format: uri
           * @example https://github.com/octocat/Hello-World/pull/1#discussion-diff-1
           */
          href: string;
        };
        pull_request: {
          /**
           * Format: uri
           * @example https://api.github.com/repos/octocat/Hello-World/pulls/1
           */
          href: string;
        };
      };
      /**
       * @description The first line of the range for a multi-line comment.
       * @example 2
       */
      start_line?: number | null;
      /**
       * @description The first line of the range for a multi-line comment.
       * @example 2
       */
      original_start_line?: number | null;
      /**
       * @description The side of the first line of the range for a multi-line comment.
       * @default RIGHT
       * @enum {string|null}
       */
      start_side?: "LEFT" | "RIGHT" | null;
      /**
       * @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment
       * @example 2
       */
      line?: number;
      /**
       * @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment
       * @example 2
       */
      original_line?: number;
      /**
       * @description The side of the diff to which the comment applies. The side of the last line of the range for a multi-line comment
       * @default RIGHT
       * @enum {string}
       */
      side?: "LEFT" | "RIGHT";
      /**
       * @description The level at which the comment is targeted, can be a diff line or a file.
       * @enum {string}
       */
      subject_type?: "line" | "file";
      reactions?: components["schemas"]["reaction-rollup"];
      /** @example "<p>comment body</p>" */
      body_html?: string;
      /** @example "comment body" */
      body_text?: string;
    };
    /**
     * Timeline Line Commented Event
     * @description Timeline Line Commented Event
     */
    "timeline-line-commented-event": {
      event?: string;
      node_id?: string;
      comments?: components["schemas"]["pull-request-review-comment"][];
    };
    /**
     * Timeline Commit Commented Event
     * @description Timeline Commit Commented Event
     */
    "timeline-commit-commented-event": {
      event?: string;
      node_id?: string;
      commit_id?: string;
      comments?: components["schemas"]["commit-comment"][];
    };
    /**
     * Timeline Assigned Issue Event
     * @description Timeline Assigned Issue Event
     */
    "timeline-assigned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      assignee: components["schemas"]["simple-user"];
    };
    /**
     * Timeline Unassigned Issue Event
     * @description Timeline Unassigned Issue Event
     */
    "timeline-unassigned-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      assignee: components["schemas"]["simple-user"];
    };
    /**
     * State Change Issue Event
     * @description State Change Issue Event
     */
    "state-change-issue-event": {
      id: number;
      node_id: string;
      url: string;
      actor: components["schemas"]["simple-user"];
      event: string;
      commit_id: string | null;
      commit_url: string | null;
      created_at: string;
      performed_via_github_app: components["schemas"]["nullable-integration"];
      state_reason?: string | null;
    };
    /**
     * Timeline Event
     * @description Timeline Event
     */
    "timeline-issue-events":
      | components["schemas"]["labeled-issue-event"]
      | components["schemas"]["unlabeled-issue-event"]
      | components["schemas"]["milestoned-issue-event"]
      | components["schemas"]["demilestoned-issue-event"]
      | components["schemas"]["renamed-issue-event"]
      | components["schemas"]["review-requested-issue-event"]
      | components["schemas"]["review-request-removed-issue-event"]
      | components["schemas"]["review-dismissed-issue-event"]
      | components["schemas"]["locked-issue-event"]
      | components["schemas"]["added-to-project-issue-event"]
      | components["schemas"]["moved-column-in-project-issue-event"]
      | components["schemas"]["removed-from-project-issue-event"]
      | components["schemas"]["converted-note-to-issue-issue-event"]
      | components["schemas"]["timeline-comment-event"]
      | components["schemas"]["timeline-cross-referenced-event"]
      | components["schemas"]["timeline-committed-event"]
      | components["schemas"]["timeline-reviewed-event"]
      | components["schemas"]["timeline-line-commented-event"]
      | components["schemas"]["timeline-commit-commented-event"]
      | components["schemas"]["timeline-assigned-issue-event"]
      | components["schemas"]["timeline-unassigned-issue-event"]
      | components["schemas"]["state-change-issue-event"];
    /**
     * Deploy Key
     * @description An SSH key granting access to a single repository.
     */
    "deploy-key": {
      id: number;
      key: string;
      url: string;
      title: string;
      verified: boolean;
      created_at: string;
      read_only: boolean;
      added_by?: string | null;
      last_used?: string | null;
    };
    /**
     * Language
     * @description Language
     */
    language: {
      [key: string]: number | undefined;
    };
    /**
     * License Content
     * @description License Content
     */
    "license-content": {
      name: string;
      path: string;
      sha: string;
      size: number;
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string | null;
      /** Format: uri */
      git_url: string | null;
      /** Format: uri */
      download_url: string | null;
      type: string;
      content: string;
      encoding: string;
      _links: {
        /** Format: uri */
        git: string | null;
        /** Format: uri */
        html: string | null;
        /** Format: uri */
        self: string;
      };
      license: components["schemas"]["nullable-license-simple"];
    };
    /**
     * Merged upstream
     * @description Results of a successful merge upstream request
     */
    "merged-upstream": {
      message?: string;
      /** @enum {string} */
      merge_type?: "merge" | "fast-forward" | "none";
      base_branch?: string;
    };
    /**
     * Milestone
     * @description A collection of related issues and pull requests.
     */
    milestone: {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/milestones/1
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/milestones/v1.0
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/milestones/1/labels
       */
      labels_url: string;
      /** @example 1002604 */
      id: number;
      /** @example MDk6TWlsZXN0b25lMTAwMjYwNA== */
      node_id: string;
      /**
       * @description The number of the milestone.
       * @example 42
       */
      number: number;
      /**
       * @description The state of the milestone.
       * @default open
       * @example open
       * @enum {string}
       */
      state: "open" | "closed";
      /**
       * @description The title of the milestone.
       * @example v1.0
       */
      title: string;
      /** @example Tracking milestone for version 1.0 */
      description: string | null;
      creator: components["schemas"]["nullable-simple-user"];
      /** @example 4 */
      open_issues: number;
      /** @example 8 */
      closed_issues: number;
      /**
       * Format: date-time
       * @example 2011-04-10T20:09:31Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2014-03-03T18:58:10Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2013-02-12T13:22:01Z
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @example 2012-10-09T23:39:01Z
       */
      due_on: string | null;
    };
    /** Pages Source Hash */
    "pages-source-hash": {
      branch: string;
      path: string;
    };
    /** Pages Https Certificate */
    "pages-https-certificate": {
      /**
       * @example approved
       * @enum {string}
       */
      state:
        | "new"
        | "authorization_created"
        | "authorization_pending"
        | "authorized"
        | "authorization_revoked"
        | "issued"
        | "uploaded"
        | "approved"
        | "errored"
        | "bad_authz"
        | "destroy_pending"
        | "dns_changed";
      /** @example Certificate is approved */
      description: string;
      /**
       * @description Array of the domain set and its alternate name (if it is configured)
       * @example [
       *   "example.com",
       *   "www.example.com"
       * ]
       */
      domains: string[];
      /** Format: date */
      expires_at?: string;
    };
    /**
     * GitHub Pages
     * @description The configuration for GitHub Pages for a repository.
     */
    page: {
      /**
       * Format: uri
       * @description The API address for accessing this Page resource.
       * @example https://api.github.com/repos/github/hello-world/pages
       */
      url: string;
      /**
       * @description The status of the most recent build of the Page.
       * @example built
       * @enum {string|null}
       */
      status: "built" | "building" | "errored" | null;
      /**
       * @description The Pages site's custom domain
       * @example example.com
       */
      cname: string | null;
      /**
       * @description The state if the domain is verified
       * @example pending
       * @enum {string|null}
       */
      protected_domain_state?: "pending" | "verified" | "unverified" | null;
      /**
       * Format: date-time
       * @description The timestamp when a pending domain becomes unverified.
       */
      pending_domain_unverified_at?: string | null;
      /**
       * @description Whether the Page has a custom 404 page.
       * @default false
       * @example false
       */
      custom_404: boolean;
      /**
       * Format: uri
       * @description The web address the Page can be accessed from.
       * @example https://example.com
       */
      html_url?: string;
      /**
       * @description The process in which the Page will be built.
       * @example legacy
       * @enum {string|null}
       */
      build_type?: "legacy" | "workflow" | null;
      source?: components["schemas"]["pages-source-hash"];
      /**
       * @description Whether the GitHub Pages site is publicly visible. If set to `true`, the site is accessible to anyone on the internet. If set to `false`, the site will only be accessible to users who have at least `read` access to the repository that published the site.
       * @example true
       */
      public: boolean;
      https_certificate?: components["schemas"]["pages-https-certificate"];
      /**
       * @description Whether https is enabled on the domain
       * @example true
       */
      https_enforced?: boolean;
    };
    /**
     * Page Build
     * @description Page Build
     */
    "page-build": {
      /** Format: uri */
      url: string;
      status: string;
      error: {
        message: string | null;
      };
      pusher: components["schemas"]["nullable-simple-user"];
      commit: string;
      duration: number;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
    };
    /**
     * Page Build Status
     * @description Page Build Status
     */
    "page-build-status": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/github/hello-world/pages/builds/latest
       */
      url: string;
      /** @example queued */
      status: string;
    };
    /**
     * GitHub Pages
     * @description The GitHub Pages deployment status.
     */
    "page-deployment": {
      /**
       * Format: uri
       * @description The URI to monitor GitHub Pages deployment status.
       * @example https://api.github.com/repos/github/hello-world/pages/deployments/4fd754f7e594640989b406850d0bc8f06a121251/status
       */
      status_url: string;
      /**
       * Format: uri
       * @description The URI to the deployed GitHub Pages.
       * @example hello-world.github.io
       */
      page_url: string;
      /**
       * Format: uri
       * @description The URI to the deployed GitHub Pages preview.
       * @example monalisa-1231a2312sa32-23sda74.drafts.github.io
       */
      preview_url?: string;
    };
    /**
     * Pages Health Check Status
     * @description Pages Health Check Status
     */
    "pages-health-check": {
      domain?: {
        host?: string;
        uri?: string;
        nameservers?: string;
        dns_resolves?: boolean;
        is_proxied?: boolean | null;
        is_cloudflare_ip?: boolean | null;
        is_fastly_ip?: boolean | null;
        is_old_ip_address?: boolean | null;
        is_a_record?: boolean | null;
        has_cname_record?: boolean | null;
        has_mx_records_present?: boolean | null;
        is_valid_domain?: boolean;
        is_apex_domain?: boolean;
        should_be_a_record?: boolean | null;
        is_cname_to_github_user_domain?: boolean | null;
        is_cname_to_pages_dot_github_dot_com?: boolean | null;
        is_cname_to_fastly?: boolean | null;
        is_pointed_to_github_pages_ip?: boolean | null;
        is_non_github_pages_ip_present?: boolean | null;
        is_pages_domain?: boolean;
        is_served_by_pages?: boolean | null;
        is_valid?: boolean;
        reason?: string | null;
        responds_to_https?: boolean;
        enforces_https?: boolean;
        https_error?: string | null;
        is_https_eligible?: boolean | null;
        caa_error?: string | null;
      };
      alt_domain?: {
        host?: string;
        uri?: string;
        nameservers?: string;
        dns_resolves?: boolean;
        is_proxied?: boolean | null;
        is_cloudflare_ip?: boolean | null;
        is_fastly_ip?: boolean | null;
        is_old_ip_address?: boolean | null;
        is_a_record?: boolean | null;
        has_cname_record?: boolean | null;
        has_mx_records_present?: boolean | null;
        is_valid_domain?: boolean;
        is_apex_domain?: boolean;
        should_be_a_record?: boolean | null;
        is_cname_to_github_user_domain?: boolean | null;
        is_cname_to_pages_dot_github_dot_com?: boolean | null;
        is_cname_to_fastly?: boolean | null;
        is_pointed_to_github_pages_ip?: boolean | null;
        is_non_github_pages_ip_present?: boolean | null;
        is_pages_domain?: boolean;
        is_served_by_pages?: boolean | null;
        is_valid?: boolean;
        reason?: string | null;
        responds_to_https?: boolean;
        enforces_https?: boolean;
        https_error?: string | null;
        is_https_eligible?: boolean | null;
        caa_error?: string | null;
      } | null;
    };
    /**
     * Pull Request
     * @description Pull requests let you tell others about changes you've pushed to a repository on GitHub. Once a pull request is sent, interested parties can review the set of changes, discuss potential modifications, and even push follow-up commits if necessary.
     */
    "pull-request": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347
       */
      url: string;
      /** @example 1 */
      id: number;
      /** @example MDExOlB1bGxSZXF1ZXN0MQ== */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347.diff
       */
      diff_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1347.patch
       */
      patch_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347
       */
      issue_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347/commits
       */
      commits_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1347/comments
       */
      review_comments_url: string;
      /** @example https://api.github.com/repos/octocat/Hello-World/pulls/comments{/number} */
      review_comment_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347/comments
       */
      comments_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/statuses/6dcb09b5b57875f334f61aebed695e2e4193db5e
       */
      statuses_url: string;
      /**
       * @description Number uniquely identifying the pull request within its repository.
       * @example 42
       */
      number: number;
      /**
       * @description State of this Pull Request. Either `open` or `closed`.
       * @example open
       * @enum {string}
       */
      state: "open" | "closed";
      /** @example true */
      locked: boolean;
      /**
       * @description The title of the pull request.
       * @example Amazing new feature
       */
      title: string;
      user: components["schemas"]["simple-user"];
      /** @example Please pull these awesome changes */
      body: string | null;
      labels: {
        /** Format: int64 */
        id: number;
        node_id: string;
        url: string;
        name: string;
        description: string | null;
        color: string;
        default: boolean;
      }[];
      milestone: components["schemas"]["nullable-milestone"];
      /** @example too heated */
      active_lock_reason?: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      merged_at: string | null;
      /** @example e5bd3914e2e596debea16f433f57875b5b90bcd6 */
      merge_commit_sha: string | null;
      assignee: components["schemas"]["nullable-simple-user"];
      assignees?: components["schemas"]["simple-user"][] | null;
      requested_reviewers?: components["schemas"]["simple-user"][] | null;
      requested_teams?: components["schemas"]["team-simple"][] | null;
      head: {
        label: string;
        ref: string;
        repo: {
          archive_url: string;
          assignees_url: string;
          blobs_url: string;
          branches_url: string;
          collaborators_url: string;
          comments_url: string;
          commits_url: string;
          compare_url: string;
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          git_commits_url: string;
          git_refs_url: string;
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          id: number;
          node_id: string;
          issue_comment_url: string;
          issue_events_url: string;
          issues_url: string;
          keys_url: string;
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          milestones_url: string;
          name: string;
          notifications_url: string;
          owner: {
            /** Format: uri */
            avatar_url: string;
            events_url: string;
            /** Format: uri */
            followers_url: string;
            following_url: string;
            gists_url: string;
            gravatar_id: string | null;
            /** Format: uri */
            html_url: string;
            id: number;
            node_id: string;
            login: string;
            /** Format: uri */
            organizations_url: string;
            /** Format: uri */
            received_events_url: string;
            /** Format: uri */
            repos_url: string;
            site_admin: boolean;
            starred_url: string;
            /** Format: uri */
            subscriptions_url: string;
            type: string;
            /** Format: uri */
            url: string;
          };
          private: boolean;
          pulls_url: string;
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          trees_url: string;
          /** Format: uri */
          url: string;
          clone_url: string;
          default_branch: string;
          forks: number;
          forks_count: number;
          git_url: string;
          has_downloads: boolean;
          has_issues: boolean;
          has_projects: boolean;
          has_wiki: boolean;
          has_pages: boolean;
          has_discussions: boolean;
          /** Format: uri */
          homepage: string | null;
          language: string | null;
          master_branch?: string;
          archived: boolean;
          disabled: boolean;
          /** @description The repository visibility: public, private, or internal. */
          visibility?: string;
          /** Format: uri */
          mirror_url: string | null;
          open_issues: number;
          open_issues_count: number;
          permissions?: {
            admin: boolean;
            maintain?: boolean;
            push: boolean;
            triage?: boolean;
            pull: boolean;
          };
          temp_clone_token?: string;
          allow_merge_commit?: boolean;
          allow_squash_merge?: boolean;
          allow_rebase_merge?: boolean;
          license: {
            key: string;
            name: string;
            /** Format: uri */
            url: string | null;
            spdx_id: string | null;
            node_id: string;
          } | null;
          /** Format: date-time */
          pushed_at: string;
          size: number;
          ssh_url: string;
          stargazers_count: number;
          /** Format: uri */
          svn_url: string;
          topics?: string[];
          watchers: number;
          watchers_count: number;
          /** Format: date-time */
          created_at: string;
          /** Format: date-time */
          updated_at: string;
          allow_forking?: boolean;
          is_template?: boolean;
          web_commit_signoff_required?: boolean;
        } | null;
        sha: string;
        user: {
          /** Format: uri */
          avatar_url: string;
          events_url: string;
          /** Format: uri */
          followers_url: string;
          following_url: string;
          gists_url: string;
          gravatar_id: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          node_id: string;
          login: string;
          /** Format: uri */
          organizations_url: string;
          /** Format: uri */
          received_events_url: string;
          /** Format: uri */
          repos_url: string;
          site_admin: boolean;
          starred_url: string;
          /** Format: uri */
          subscriptions_url: string;
          type: string;
          /** Format: uri */
          url: string;
        };
      };
      base: {
        label: string;
        ref: string;
        repo: {
          archive_url: string;
          assignees_url: string;
          blobs_url: string;
          branches_url: string;
          collaborators_url: string;
          comments_url: string;
          commits_url: string;
          compare_url: string;
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          git_commits_url: string;
          git_refs_url: string;
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          id: number;
          is_template?: boolean;
          node_id: string;
          issue_comment_url: string;
          issue_events_url: string;
          issues_url: string;
          keys_url: string;
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          milestones_url: string;
          name: string;
          notifications_url: string;
          owner: {
            /** Format: uri */
            avatar_url: string;
            events_url: string;
            /** Format: uri */
            followers_url: string;
            following_url: string;
            gists_url: string;
            gravatar_id: string | null;
            /** Format: uri */
            html_url: string;
            id: number;
            node_id: string;
            login: string;
            /** Format: uri */
            organizations_url: string;
            /** Format: uri */
            received_events_url: string;
            /** Format: uri */
            repos_url: string;
            site_admin: boolean;
            starred_url: string;
            /** Format: uri */
            subscriptions_url: string;
            type: string;
            /** Format: uri */
            url: string;
          };
          private: boolean;
          pulls_url: string;
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          trees_url: string;
          /** Format: uri */
          url: string;
          clone_url: string;
          default_branch: string;
          forks: number;
          forks_count: number;
          git_url: string;
          has_downloads: boolean;
          has_issues: boolean;
          has_projects: boolean;
          has_wiki: boolean;
          has_pages: boolean;
          has_discussions: boolean;
          /** Format: uri */
          homepage: string | null;
          language: string | null;
          master_branch?: string;
          archived: boolean;
          disabled: boolean;
          /** @description The repository visibility: public, private, or internal. */
          visibility?: string;
          /** Format: uri */
          mirror_url: string | null;
          open_issues: number;
          open_issues_count: number;
          permissions?: {
            admin: boolean;
            maintain?: boolean;
            push: boolean;
            triage?: boolean;
            pull: boolean;
          };
          temp_clone_token?: string;
          allow_merge_commit?: boolean;
          allow_squash_merge?: boolean;
          allow_rebase_merge?: boolean;
          license: components["schemas"]["nullable-license-simple"];
          /** Format: date-time */
          pushed_at: string;
          size: number;
          ssh_url: string;
          stargazers_count: number;
          /** Format: uri */
          svn_url: string;
          topics?: string[];
          watchers: number;
          watchers_count: number;
          /** Format: date-time */
          created_at: string;
          /** Format: date-time */
          updated_at: string;
          allow_forking?: boolean;
          web_commit_signoff_required?: boolean;
        };
        sha: string;
        user: {
          /** Format: uri */
          avatar_url: string;
          events_url: string;
          /** Format: uri */
          followers_url: string;
          following_url: string;
          gists_url: string;
          gravatar_id: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          node_id: string;
          login: string;
          /** Format: uri */
          organizations_url: string;
          /** Format: uri */
          received_events_url: string;
          /** Format: uri */
          repos_url: string;
          site_admin: boolean;
          starred_url: string;
          /** Format: uri */
          subscriptions_url: string;
          type: string;
          /** Format: uri */
          url: string;
        };
      };
      _links: {
        comments: components["schemas"]["link"];
        commits: components["schemas"]["link"];
        statuses: components["schemas"]["link"];
        html: components["schemas"]["link"];
        issue: components["schemas"]["link"];
        review_comments: components["schemas"]["link"];
        review_comment: components["schemas"]["link"];
        self: components["schemas"]["link"];
      };
      author_association: components["schemas"]["author-association"];
      auto_merge: components["schemas"]["auto-merge"];
      /**
       * @description Indicates whether or not the pull request is a draft.
       * @example false
       */
      draft?: boolean;
      merged: boolean;
      /** @example true */
      mergeable: boolean | null;
      /** @example true */
      rebaseable?: boolean | null;
      /** @example clean */
      mergeable_state: string;
      merged_by: components["schemas"]["nullable-simple-user"];
      /** @example 10 */
      comments: number;
      /** @example 0 */
      review_comments: number;
      /**
       * @description Indicates whether maintainers can modify the pull request.
       * @example true
       */
      maintainer_can_modify: boolean;
      /** @example 3 */
      commits: number;
      /** @example 100 */
      additions: number;
      /** @example 3 */
      deletions: number;
      /** @example 5 */
      changed_files: number;
    };
    /**
     * Pull Request Merge Result
     * @description Pull Request Merge Result
     */
    "pull-request-merge-result": {
      sha: string;
      merged: boolean;
      message: string;
    };
    /**
     * Pull Request Review Request
     * @description Pull Request Review Request
     */
    "pull-request-review-request": {
      users: components["schemas"]["simple-user"][];
      teams: components["schemas"]["team"][];
    };
    /**
     * Pull Request Review
     * @description Pull Request Reviews are reviews on pull requests.
     */
    "pull-request-review": {
      /**
       * @description Unique identifier of the review
       * @example 42
       */
      id: number;
      /** @example MDE3OlB1bGxSZXF1ZXN0UmV2aWV3ODA= */
      node_id: string;
      user: components["schemas"]["nullable-simple-user"];
      /**
       * @description The text of the review.
       * @example This looks great.
       */
      body: string;
      /** @example CHANGES_REQUESTED */
      state: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/12#pullrequestreview-80
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/12
       */
      pull_request_url: string;
      _links: {
        html: {
          href: string;
        };
        pull_request: {
          href: string;
        };
      };
      /** Format: date-time */
      submitted_at?: string;
      /**
       * @description A commit SHA for the review. If the commit object was garbage collected or forcibly deleted, then it no longer exists in Git and this value will be `null`.
       * @example 54bb654c9e6025347f57900a4a5c2313a96b8035
       */
      commit_id: string | null;
      body_html?: string;
      body_text?: string;
      author_association: components["schemas"]["author-association"];
    };
    /**
     * Legacy Review Comment
     * @description Legacy Review Comment
     */
    "review-comment": {
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/comments/1
       */
      url: string;
      /** @example 42 */
      pull_request_review_id: number | null;
      /** @example 10 */
      id: number;
      /** @example MDI0OlB1bGxSZXF1ZXN0UmV2aWV3Q29tbWVudDEw */
      node_id: string;
      /** @example @@ -16,33 +16,40 @@ public class Connection : IConnection... */
      diff_hunk: string;
      /** @example file1.txt */
      path: string;
      /** @example 1 */
      position: number | null;
      /** @example 4 */
      original_position: number;
      /** @example 6dcb09b5b57875f334f61aebed695e2e4193db5e */
      commit_id: string;
      /** @example 9c48853fa3dc5c1c3d6f1f1cd1f2743e72652840 */
      original_commit_id: string;
      /** @example 8 */
      in_reply_to_id?: number;
      user: components["schemas"]["nullable-simple-user"];
      /** @example Great stuff */
      body: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-04-14T16:00:49Z
       */
      updated_at: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/pull/1#discussion-diff-1
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/Hello-World/pulls/1
       */
      pull_request_url: string;
      author_association: components["schemas"]["author-association"];
      _links: {
        self: components["schemas"]["link"];
        html: components["schemas"]["link"];
        pull_request: components["schemas"]["link"];
      };
      body_text?: string;
      body_html?: string;
      reactions?: components["schemas"]["reaction-rollup"];
      /**
       * @description The side of the first line of the range for a multi-line comment.
       * @default RIGHT
       * @enum {string}
       */
      side?: "LEFT" | "RIGHT";
      /**
       * @description The side of the first line of the range for a multi-line comment.
       * @default RIGHT
       * @enum {string|null}
       */
      start_side?: "LEFT" | "RIGHT" | null;
      /**
       * @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment
       * @example 2
       */
      line?: number;
      /**
       * @description The original line of the blob to which the comment applies. The last line of the range for a multi-line comment
       * @example 2
       */
      original_line?: number;
      /**
       * @description The first line of the range for a multi-line comment.
       * @example 2
       */
      start_line?: number | null;
      /**
       * @description The original first line of the range for a multi-line comment.
       * @example 2
       */
      original_start_line?: number | null;
    };
    /**
     * Release Asset
     * @description Data related to a release.
     */
    "release-asset": {
      /** Format: uri */
      url: string;
      /** Format: uri */
      browser_download_url: string;
      id: number;
      node_id: string;
      /**
       * @description The file name of the asset.
       * @example Team Environment
       */
      name: string;
      label: string | null;
      /**
       * @description State of the release asset.
       * @enum {string}
       */
      state: "uploaded" | "open";
      content_type: string;
      size: number;
      download_count: number;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      uploader: components["schemas"]["nullable-simple-user"];
    };
    /**
     * Release
     * @description A release.
     */
    release: {
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      assets_url: string;
      upload_url: string;
      /** Format: uri */
      tarball_url: string | null;
      /** Format: uri */
      zipball_url: string | null;
      id: number;
      node_id: string;
      /**
       * @description The name of the tag.
       * @example v1.0.0
       */
      tag_name: string;
      /**
       * @description Specifies the commitish value that determines where the Git tag is created from.
       * @example master
       */
      target_commitish: string;
      name: string | null;
      body?: string | null;
      /**
       * @description true to create a draft (unpublished) release, false to create a published one.
       * @example false
       */
      draft: boolean;
      /**
       * @description Whether to identify the release as a prerelease or a full release.
       * @example false
       */
      prerelease: boolean;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      published_at: string | null;
      author: components["schemas"]["simple-user"];
      assets: components["schemas"]["release-asset"][];
      body_html?: string;
      body_text?: string;
      mentions_count?: number;
      /**
       * Format: uri
       * @description The URL of the release discussion.
       */
      discussion_url?: string;
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Generated Release Notes Content
     * @description Generated name and body describing a release
     */
    "release-notes-content": {
      /**
       * @description The generated name of the release
       * @example Release v1.0.0 is now available!
       */
      name: string;
      /** @description The generated body describing the contents of the release supporting markdown formatting */
      body: string;
    };
    "secret-scanning-alert": {
      number?: components["schemas"]["alert-number"];
      created_at?: components["schemas"]["alert-created-at"];
      updated_at?: components["schemas"]["nullable-alert-updated-at"];
      url?: components["schemas"]["alert-url"];
      html_url?: components["schemas"]["alert-html-url"];
      /**
       * Format: uri
       * @description The REST API URL of the code locations for this alert.
       */
      locations_url?: string;
      state?: components["schemas"]["secret-scanning-alert-state"];
      resolution?: components["schemas"]["secret-scanning-alert-resolution"];
      /**
       * Format: date-time
       * @description The time that the alert was resolved in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      resolved_at?: string | null;
      resolved_by?: components["schemas"]["nullable-simple-user"];
      /** @description An optional comment to resolve an alert. */
      resolution_comment?: string | null;
      /** @description The type of secret that secret scanning detected. */
      secret_type?: string;
      /**
       * @description User-friendly name for the detected secret, matching the `secret_type`.
       * For a list of built-in patterns, see "[Secret scanning patterns](https://docs.github.com/code-security/secret-scanning/secret-scanning-patterns#supported-secrets-for-advanced-security)."
       */
      secret_type_display_name?: string;
      /** @description The secret that was detected. */
      secret?: string;
      /** @description Whether push protection was bypassed for the detected secret. */
      push_protection_bypassed?: boolean | null;
      push_protection_bypassed_by?: components["schemas"]["nullable-simple-user"];
      /**
       * Format: date-time
       * @description The time that push protection was bypassed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
       */
      push_protection_bypassed_at?: string | null;
    };
    /** @description An optional comment when closing an alert. Cannot be updated or deleted. Must be `null` when changing `state` to `open`. */
    "secret-scanning-alert-resolution-comment": string | null;
    /** @description Represents a 'commit' secret scanning location type. This location type shows that a secret was detected inside a commit to a repository. */
    "secret-scanning-location-commit": {
      /**
       * @description The file path in the repository
       * @example /example/secrets.txt
       */
      path: string;
      /** @description Line number at which the secret starts in the file */
      start_line: number;
      /** @description Line number at which the secret ends in the file */
      end_line: number;
      /** @description The column at which the secret starts within the start line when the file is interpreted as 8BIT ASCII */
      start_column: number;
      /** @description The column at which the secret ends within the end line when the file is interpreted as 8BIT ASCII */
      end_column: number;
      /**
       * @description SHA-1 hash ID of the associated blob
       * @example af5626b4a114abcb82d63db7c8082c3c4756e51b
       */
      blob_sha: string;
      /** @description The API URL to get the associated blob resource */
      blob_url: string;
      /**
       * @description SHA-1 hash ID of the associated commit
       * @example af5626b4a114abcb82d63db7c8082c3c4756e51b
       */
      commit_sha: string;
      /** @description The API URL to get the associated commit resource */
      commit_url: string;
    };
    /** @description Represents an 'issue_title' secret scanning location type. This location type shows that a secret was detected in the title of an issue. */
    "secret-scanning-location-issue-title": {
      /**
       * Format: uri
       * @description The API URL to get the issue where the secret was detected.
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347
       */
      issue_title_url: string;
    };
    /** @description Represents an 'issue_body' secret scanning location type. This location type shows that a secret was detected in the body of an issue. */
    "secret-scanning-location-issue-body": {
      /**
       * Format: uri
       * @description The API URL to get the issue where the secret was detected.
       * @example https://api.github.com/repos/octocat/Hello-World/issues/1347
       */
      issue_body_url: string;
    };
    /** @description Represents an 'issue_comment' secret scanning location type. This location type shows that a secret was detected in a comment on an issue. */
    "secret-scanning-location-issue-comment": {
      /**
       * Format: uri
       * @description The API URL to get the issue comment where the secret was detected.
       * @example https://api.github.com/repos/octocat/Hello-World/issues/comments/1081119451
       */
      issue_comment_url: string;
    };
    "secret-scanning-location": {
      /**
       * @description The location type. Because secrets may be found in different types of resources (ie. code, comments, issues), this field identifies the type of resource where the secret was found.
       * @example commit
       * @enum {string}
       */
      type: "commit" | "issue_title" | "issue_body" | "issue_comment";
      details:
        | components["schemas"]["secret-scanning-location-commit"]
        | components["schemas"]["secret-scanning-location-issue-title"]
        | components["schemas"]["secret-scanning-location-issue-body"]
        | components["schemas"]["secret-scanning-location-issue-comment"];
    };
    /**
     * @description The package's language or package management ecosystem.
     * @enum {string}
     */
    "repository-advisory-ecosystems":
      | "rubygems"
      | "npm"
      | "pip"
      | "maven"
      | "nuget"
      | "composer"
      | "go"
      | "rust"
      | "erlang"
      | "actions"
      | "pub"
      | "other";
    /** @description A product affected by the vulnerability detailed in a repository security advisory. */
    "repository-advisory-vulnerability": {
      /** @description The name of the package affected by the vulnerability. */
      package: {
        ecosystem: components["schemas"]["repository-advisory-ecosystems"];
        /** @description The unique package name within its ecosystem. */
        name: string | null;
      } | null;
      /** @description The range of the package versions affected by the vulnerability. */
      vulnerable_version_range: string | null;
      /** @description The package version(s) that resolve the vulnerability. */
      patched_versions: string | null;
      /** @description The functions in the package that are affected. */
      vulnerable_functions: string[] | null;
    };
    /**
     * @description The type of credit the user is receiving.
     * @enum {string}
     */
    "repository-advisory-credit-types":
      | "analyst"
      | "finder"
      | "reporter"
      | "coordinator"
      | "remediation_developer"
      | "remediation_reviewer"
      | "remediation_verifier"
      | "tool"
      | "sponsor"
      | "other";
    /** @description A credit given to a user for a repository security advisory. */
    "repository-advisory-credit": {
      user: components["schemas"]["simple-user"];
      type: components["schemas"]["repository-advisory-credit-types"];
      /**
       * @description The state of the user's acceptance of the credit.
       * @enum {string}
       */
      state: "accepted" | "declined" | "pending";
    };
    /** @description A repository security advisory. */
    "repository-advisory": {
      /** @description The GitHub Security Advisory ID. */
      ghsa_id: string;
      /** @description The Common Vulnerabilities and Exposures (CVE) ID. */
      cve_id: string | null;
      /** @description The API URL for the advisory. */
      url: string;
      /**
       * Format: uri
       * @description The URL for the advisory.
       */
      html_url: string;
      /** @description A short summary of the advisory. */
      summary: string;
      /** @description A detailed description of what the advisory entails. */
      description: string | null;
      /**
       * @description The severity of the advisory.
       * @enum {string|null}
       */
      severity: "critical" | "high" | "medium" | "low" | null;
      /** @description The author of the advisory. */
      author: components["schemas"]["simple-user"] | null;
      /** @description The publisher of the advisory. */
      publisher: components["schemas"]["simple-user"] | null;
      identifiers: readonly {
        /**
         * @description The type of identifier.
         * @enum {string}
         */
        type: "CVE" | "GHSA";
        /** @description The identifier value. */
        value: string;
      }[];
      /**
       * @description The state of the advisory.
       * @enum {string}
       */
      state: "published" | "closed" | "withdrawn" | "draft" | "triage";
      /**
       * Format: date-time
       * @description The date and time of when the advisory was created, in ISO 8601 format.
       */
      created_at: string | null;
      /**
       * Format: date-time
       * @description The date and time of when the advisory was last updated, in ISO 8601 format.
       */
      updated_at: string | null;
      /**
       * Format: date-time
       * @description The date and time of when the advisory was published, in ISO 8601 format.
       */
      published_at: string | null;
      /**
       * Format: date-time
       * @description The date and time of when the advisory was closed, in ISO 8601 format.
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @description The date and time of when the advisory was withdrawn, in ISO 8601 format.
       */
      withdrawn_at: string | null;
      submission: {
        /** @description Whether a private vulnerability report was accepted by the repository's administrators. */
        readonly accepted: boolean;
      } | null;
      vulnerabilities:
        | components["schemas"]["repository-advisory-vulnerability"][]
        | null;
      cvss: {
        /** @description The CVSS vector. */
        vector_string: string | null;
        /** @description The CVSS score. */
        score: number | null;
      } | null;
      cwes:
        | readonly {
            /** @description The Common Weakness Enumeration (CWE) identifier. */
            cwe_id: string;
            /** @description The name of the CWE. */
            name: string;
          }[]
        | null;
      /** @description A list of only the CWE IDs. */
      cwe_ids: string[] | null;
      credits:
        | {
            /** @description The username of the user credited. */
            login?: string;
            type?: components["schemas"]["repository-advisory-credit-types"];
          }[]
        | null;
      credits_detailed:
        | readonly components["schemas"]["repository-advisory-credit"][]
        | null;
    };
    "repository-advisory-create": {
      /** @description A short summary of the advisory. */
      summary: string;
      /** @description A detailed description of what the advisory impacts. */
      description: string;
      /** @description The Common Vulnerabilities and Exposures (CVE) ID. */
      cve_id?: string | null;
      /** @description A product affected by the vulnerability detailed in a repository security advisory. */
      vulnerabilities: {
        /** @description The name of the package affected by the vulnerability. */
        package: {
          ecosystem: components["schemas"]["repository-advisory-ecosystems"];
          /** @description The unique package name within its ecosystem. */
          name?: string | null;
        };
        /** @description The range of the package versions affected by the vulnerability. */
        vulnerable_version_range?: string | null;
        /** @description The package version(s) that resolve the vulnerability. */
        patched_versions?: string | null;
        /** @description The functions in the package that are affected. */
        vulnerable_functions?: string[] | null;
      }[];
      /** @description A list of Common Weakness Enumeration (CWE) IDs. */
      cwe_ids?: string[] | null;
      /** @description A list of users receiving credit for their participation in the security advisory. */
      credits?:
        | {
            /** @description The username of the user credited. */
            login: string;
            type: components["schemas"]["repository-advisory-credit-types"];
          }[]
        | null;
      /**
       * @description The severity of the advisory. You must choose between setting this field or `cvss_vector_string`.
       * @enum {string|null}
       */
      severity?: "critical" | "high" | "medium" | "low" | null;
      /** @description The CVSS vector that calculates the severity of the advisory. You must choose between setting this field or `severity`. */
      cvss_vector_string?: string | null;
    };
    "private-vulnerability-report-create": {
      /** @description A short summary of the advisory. */
      summary: string;
      /** @description A detailed description of what the advisory impacts. */
      description: string;
      /** @description An array of products affected by the vulnerability detailed in a repository security advisory. */
      vulnerabilities?:
        | {
            /** @description The name of the package affected by the vulnerability. */
            package: {
              ecosystem: components["schemas"]["repository-advisory-ecosystems"];
              /** @description The unique package name within its ecosystem. */
              name?: string | null;
            };
            /** @description The range of the package versions affected by the vulnerability. */
            vulnerable_version_range?: string | null;
            /** @description The package version(s) that resolve the vulnerability. */
            patched_versions?: string | null;
            /** @description The functions in the package that are affected. */
            vulnerable_functions?: string[] | null;
          }[]
        | null;
      /** @description A list of Common Weakness Enumeration (CWE) IDs. */
      cwe_ids?: string[] | null;
      /**
       * @description The severity of the advisory. You must choose between setting this field or `cvss_vector_string`.
       * @enum {string|null}
       */
      severity?: "critical" | "high" | "medium" | "low" | null;
      /** @description The CVSS vector that calculates the severity of the advisory. You must choose between setting this field or `severity`. */
      cvss_vector_string?: string | null;
    };
    "repository-advisory-update": {
      /** @description A short summary of the advisory. */
      summary?: string;
      /** @description A detailed description of what the advisory impacts. */
      description?: string;
      /** @description The Common Vulnerabilities and Exposures (CVE) ID. */
      cve_id?: string | null;
      /** @description A product affected by the vulnerability detailed in a repository security advisory. */
      vulnerabilities?: {
        /** @description The name of the package affected by the vulnerability. */
        package: {
          ecosystem: components["schemas"]["repository-advisory-ecosystems"];
          /** @description The unique package name within its ecosystem. */
          name?: string | null;
        };
        /** @description The range of the package versions affected by the vulnerability. */
        vulnerable_version_range?: string | null;
        /** @description The package version(s) that resolve the vulnerability. */
        patched_versions?: string | null;
        /** @description The functions in the package that are affected. */
        vulnerable_functions?: string[] | null;
      }[];
      /** @description A list of Common Weakness Enumeration (CWE) IDs. */
      cwe_ids?: string[] | null;
      /** @description A list of users receiving credit for their participation in the security advisory. */
      credits?:
        | {
            /** @description The username of the user credited. */
            login: string;
            type: components["schemas"]["repository-advisory-credit-types"];
          }[]
        | null;
      /**
       * @description The severity of the advisory. You must choose between setting this field or `cvss_vector_string`.
       * @enum {string|null}
       */
      severity?: "critical" | "high" | "medium" | "low" | null;
      /** @description The CVSS vector that calculates the severity of the advisory. You must choose between setting this field or `severity`. */
      cvss_vector_string?: string | null;
      /**
       * @description The state of the advisory.
       * @enum {string}
       */
      state?: "published" | "closed" | "draft";
    };
    /**
     * Stargazer
     * @description Stargazer
     */
    stargazer: {
      /** Format: date-time */
      starred_at: string;
      user: components["schemas"]["nullable-simple-user"];
    };
    /**
     * Code Frequency Stat
     * @description Code Frequency Stat
     */
    "code-frequency-stat": number[];
    /**
     * Commit Activity
     * @description Commit Activity
     */
    "commit-activity": {
      /**
       * @example [
       *   0,
       *   3,
       *   26,
       *   20,
       *   39,
       *   1,
       *   0
       * ]
       */
      days: number[];
      /** @example 89 */
      total: number;
      /** @example 1336280400 */
      week: number;
    };
    /**
     * Contributor Activity
     * @description Contributor Activity
     */
    "contributor-activity": {
      author: components["schemas"]["nullable-simple-user"];
      /** @example 135 */
      total: number;
      /**
       * @example [
       *   {
       *     "w": "1367712000",
       *     "a": 6898,
       *     "d": 77,
       *     "c": 10
       *   }
       * ]
       */
      weeks: {
        w?: number;
        a?: number;
        d?: number;
        c?: number;
      }[];
    };
    /** Participation Stats */
    "participation-stats": {
      all: number[];
      owner: number[];
    };
    /**
     * Repository Invitation
     * @description Repository invitations let you manage who you collaborate with.
     */
    "repository-subscription": {
      /**
       * @description Determines if notifications should be received from this repository.
       * @example true
       */
      subscribed: boolean;
      /** @description Determines if all notifications should be blocked from this repository. */
      ignored: boolean;
      reason: string | null;
      /**
       * Format: date-time
       * @example 2012-10-06T21:34:12Z
       */
      created_at: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example/subscription
       */
      url: string;
      /**
       * Format: uri
       * @example https://api.github.com/repos/octocat/example
       */
      repository_url: string;
    };
    /**
     * Tag
     * @description Tag
     */
    tag: {
      /** @example v0.1 */
      name: string;
      commit: {
        sha: string;
        /** Format: uri */
        url: string;
      };
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/zipball/v0.1
       */
      zipball_url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat/Hello-World/tarball/v0.1
       */
      tarball_url: string;
      node_id: string;
    };
    /**
     * Tag protection
     * @description Tag protection
     */
    "tag-protection": {
      /** @example 2 */
      id?: number;
      /** @example 2011-01-26T19:01:12Z */
      created_at?: string;
      /** @example 2011-01-26T19:01:12Z */
      updated_at?: string;
      /** @example true */
      enabled?: boolean;
      /** @example v1.* */
      pattern: string;
    };
    /**
     * Topic
     * @description A topic aggregates entities that are related to a subject.
     */
    topic: {
      names: string[];
    };
    /** Traffic */
    traffic: {
      /** Format: date-time */
      timestamp: string;
      uniques: number;
      count: number;
    };
    /**
     * Clone Traffic
     * @description Clone Traffic
     */
    "clone-traffic": {
      /** @example 173 */
      count: number;
      /** @example 128 */
      uniques: number;
      clones: components["schemas"]["traffic"][];
    };
    /**
     * Content Traffic
     * @description Content Traffic
     */
    "content-traffic": {
      /** @example /github/hubot */
      path: string;
      /** @example github/hubot: A customizable life embetterment robot. */
      title: string;
      /** @example 3542 */
      count: number;
      /** @example 2225 */
      uniques: number;
    };
    /**
     * Referrer Traffic
     * @description Referrer Traffic
     */
    "referrer-traffic": {
      /** @example Google */
      referrer: string;
      /** @example 4 */
      count: number;
      /** @example 3 */
      uniques: number;
    };
    /**
     * View Traffic
     * @description View Traffic
     */
    "view-traffic": {
      /** @example 14850 */
      count: number;
      /** @example 3782 */
      uniques: number;
      views: components["schemas"]["traffic"][];
    };
    /** Search Result Text Matches */
    "search-result-text-matches": {
      object_url?: string;
      object_type?: string | null;
      property?: string;
      fragment?: string;
      matches?: {
        text?: string;
        indices?: number[];
      }[];
    }[];
    /**
     * Code Search Result Item
     * @description Code Search Result Item
     */
    "code-search-result-item": {
      name: string;
      path: string;
      sha: string;
      /** Format: uri */
      url: string;
      /** Format: uri */
      git_url: string;
      /** Format: uri */
      html_url: string;
      repository: components["schemas"]["minimal-repository"];
      score: number;
      file_size?: number;
      language?: string | null;
      /** Format: date-time */
      last_modified_at?: string;
      /**
       * @example [
       *   "73..77",
       *   "77..78"
       * ]
       */
      line_numbers?: string[];
      text_matches?: components["schemas"]["search-result-text-matches"];
    };
    /**
     * Commit Search Result Item
     * @description Commit Search Result Item
     */
    "commit-search-result-item": {
      /** Format: uri */
      url: string;
      sha: string;
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      comments_url: string;
      commit: {
        author: {
          name: string;
          email: string;
          /** Format: date-time */
          date: string;
        };
        committer: components["schemas"]["nullable-git-user"];
        comment_count: number;
        message: string;
        tree: {
          sha: string;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        url: string;
        verification?: components["schemas"]["verification"];
      };
      author: components["schemas"]["nullable-simple-user"];
      committer: components["schemas"]["nullable-git-user"];
      parents: {
        url?: string;
        html_url?: string;
        sha?: string;
      }[];
      repository: components["schemas"]["minimal-repository"];
      score: number;
      node_id: string;
      text_matches?: components["schemas"]["search-result-text-matches"];
    };
    /**
     * Issue Search Result Item
     * @description Issue Search Result Item
     */
    "issue-search-result-item": {
      /** Format: uri */
      url: string;
      /** Format: uri */
      repository_url: string;
      labels_url: string;
      /** Format: uri */
      comments_url: string;
      /** Format: uri */
      events_url: string;
      /** Format: uri */
      html_url: string;
      /** Format: int64 */
      id: number;
      node_id: string;
      number: number;
      title: string;
      locked: boolean;
      active_lock_reason?: string | null;
      assignees?: components["schemas"]["simple-user"][] | null;
      user: components["schemas"]["nullable-simple-user"];
      labels: {
        /** Format: int64 */
        id?: number;
        node_id?: string;
        url?: string;
        name?: string;
        color?: string;
        default?: boolean;
        description?: string | null;
      }[];
      state: string;
      state_reason?: string | null;
      assignee: components["schemas"]["nullable-simple-user"];
      milestone: components["schemas"]["nullable-milestone"];
      comments: number;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      /** Format: date-time */
      closed_at: string | null;
      text_matches?: components["schemas"]["search-result-text-matches"];
      pull_request?: {
        /** Format: date-time */
        merged_at?: string | null;
        /** Format: uri */
        diff_url: string | null;
        /** Format: uri */
        html_url: string | null;
        /** Format: uri */
        patch_url: string | null;
        /** Format: uri */
        url: string | null;
      };
      body?: string;
      score: number;
      author_association: components["schemas"]["author-association"];
      draft?: boolean;
      repository?: components["schemas"]["repository"];
      body_html?: string;
      body_text?: string;
      /** Format: uri */
      timeline_url?: string;
      performed_via_github_app?: components["schemas"]["nullable-integration"];
      reactions?: components["schemas"]["reaction-rollup"];
    };
    /**
     * Label Search Result Item
     * @description Label Search Result Item
     */
    "label-search-result-item": {
      id: number;
      node_id: string;
      /** Format: uri */
      url: string;
      name: string;
      color: string;
      default: boolean;
      description: string | null;
      score: number;
      text_matches?: components["schemas"]["search-result-text-matches"];
    };
    /**
     * Repo Search Result Item
     * @description Repo Search Result Item
     */
    "repo-search-result-item": {
      id: number;
      node_id: string;
      name: string;
      full_name: string;
      owner: components["schemas"]["nullable-simple-user"];
      private: boolean;
      /** Format: uri */
      html_url: string;
      description: string | null;
      fork: boolean;
      /** Format: uri */
      url: string;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      /** Format: date-time */
      pushed_at: string;
      /** Format: uri */
      homepage: string | null;
      size: number;
      stargazers_count: number;
      watchers_count: number;
      language: string | null;
      forks_count: number;
      open_issues_count: number;
      master_branch?: string;
      default_branch: string;
      score: number;
      /** Format: uri */
      forks_url: string;
      keys_url: string;
      collaborators_url: string;
      /** Format: uri */
      teams_url: string;
      /** Format: uri */
      hooks_url: string;
      issue_events_url: string;
      /** Format: uri */
      events_url: string;
      assignees_url: string;
      branches_url: string;
      /** Format: uri */
      tags_url: string;
      blobs_url: string;
      git_tags_url: string;
      git_refs_url: string;
      trees_url: string;
      statuses_url: string;
      /** Format: uri */
      languages_url: string;
      /** Format: uri */
      stargazers_url: string;
      /** Format: uri */
      contributors_url: string;
      /** Format: uri */
      subscribers_url: string;
      /** Format: uri */
      subscription_url: string;
      commits_url: string;
      git_commits_url: string;
      comments_url: string;
      issue_comment_url: string;
      contents_url: string;
      compare_url: string;
      /** Format: uri */
      merges_url: string;
      archive_url: string;
      /** Format: uri */
      downloads_url: string;
      issues_url: string;
      pulls_url: string;
      milestones_url: string;
      notifications_url: string;
      labels_url: string;
      releases_url: string;
      /** Format: uri */
      deployments_url: string;
      git_url: string;
      ssh_url: string;
      clone_url: string;
      /** Format: uri */
      svn_url: string;
      forks: number;
      open_issues: number;
      watchers: number;
      topics?: string[];
      /** Format: uri */
      mirror_url: string | null;
      has_issues: boolean;
      has_projects: boolean;
      has_pages: boolean;
      has_wiki: boolean;
      has_downloads: boolean;
      has_discussions?: boolean;
      archived: boolean;
      /** @description Returns whether or not this repository disabled. */
      disabled: boolean;
      /** @description The repository visibility: public, private, or internal. */
      visibility?: string;
      license: components["schemas"]["nullable-license-simple"];
      permissions?: {
        admin: boolean;
        maintain?: boolean;
        push: boolean;
        triage?: boolean;
        pull: boolean;
      };
      text_matches?: components["schemas"]["search-result-text-matches"];
      temp_clone_token?: string;
      allow_merge_commit?: boolean;
      allow_squash_merge?: boolean;
      allow_rebase_merge?: boolean;
      allow_auto_merge?: boolean;
      delete_branch_on_merge?: boolean;
      allow_forking?: boolean;
      is_template?: boolean;
      /** @example false */
      web_commit_signoff_required?: boolean;
    };
    /**
     * Topic Search Result Item
     * @description Topic Search Result Item
     */
    "topic-search-result-item": {
      name: string;
      display_name: string | null;
      short_description: string | null;
      description: string | null;
      created_by: string | null;
      released: string | null;
      /** Format: date-time */
      created_at: string;
      /** Format: date-time */
      updated_at: string;
      featured: boolean;
      curated: boolean;
      score: number;
      repository_count?: number | null;
      /** Format: uri */
      logo_url?: string | null;
      text_matches?: components["schemas"]["search-result-text-matches"];
      related?:
        | {
            topic_relation?: {
              id?: number;
              name?: string;
              topic_id?: number;
              relation_type?: string;
            };
          }[]
        | null;
      aliases?:
        | {
            topic_relation?: {
              id?: number;
              name?: string;
              topic_id?: number;
              relation_type?: string;
            };
          }[]
        | null;
    };
    /**
     * User Search Result Item
     * @description User Search Result Item
     */
    "user-search-result-item": {
      login: string;
      id: number;
      node_id: string;
      /** Format: uri */
      avatar_url: string;
      gravatar_id: string | null;
      /** Format: uri */
      url: string;
      /** Format: uri */
      html_url: string;
      /** Format: uri */
      followers_url: string;
      /** Format: uri */
      subscriptions_url: string;
      /** Format: uri */
      organizations_url: string;
      /** Format: uri */
      repos_url: string;
      /** Format: uri */
      received_events_url: string;
      type: string;
      score: number;
      following_url: string;
      gists_url: string;
      starred_url: string;
      events_url: string;
      public_repos?: number;
      public_gists?: number;
      followers?: number;
      following?: number;
      /** Format: date-time */
      created_at?: string;
      /** Format: date-time */
      updated_at?: string;
      name?: string | null;
      bio?: string | null;
      /** Format: email */
      email?: string | null;
      location?: string | null;
      site_admin: boolean;
      hireable?: boolean | null;
      text_matches?: components["schemas"]["search-result-text-matches"];
      blog?: string | null;
      company?: string | null;
      /** Format: date-time */
      suspended_at?: string | null;
    };
    /**
     * Private User
     * @description Private User
     */
    "private-user": {
      /** @example octocat */
      login: string;
      /** @example 1 */
      id: number;
      /** @example MDQ6VXNlcjE= */
      node_id: string;
      /**
       * Format: uri
       * @example https://github.com/images/error/octocat_happy.gif
       */
      avatar_url: string;
      /** @example 41d064eb2195891e12d0413f63227ea7 */
      gravatar_id: string | null;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat
       */
      url: string;
      /**
       * Format: uri
       * @example https://github.com/octocat
       */
      html_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/followers
       */
      followers_url: string;
      /** @example https://api.github.com/users/octocat/following{/other_user} */
      following_url: string;
      /** @example https://api.github.com/users/octocat/gists{/gist_id} */
      gists_url: string;
      /** @example https://api.github.com/users/octocat/starred{/owner}{/repo} */
      starred_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/subscriptions
       */
      subscriptions_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/orgs
       */
      organizations_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/repos
       */
      repos_url: string;
      /** @example https://api.github.com/users/octocat/events{/privacy} */
      events_url: string;
      /**
       * Format: uri
       * @example https://api.github.com/users/octocat/received_events
       */
      received_events_url: string;
      /** @example User */
      type: string;
      site_admin: boolean;
      /** @example monalisa octocat */
      name: string | null;
      /** @example GitHub */
      company: string | null;
      /** @example https://github.com/blog */
      blog: string | null;
      /** @example San Francisco */
      location: string | null;
      /**
       * Format: email
       * @example octocat@github.com
       */
      email: string | null;
      hireable: boolean | null;
      /** @example There once was... */
      bio: string | null;
      /** @example monalisa */
      twitter_username?: string | null;
      /** @example 2 */
      public_repos: number;
      /** @example 1 */
      public_gists: number;
      /** @example 20 */
      followers: number;
      /** @example 0 */
      following: number;
      /**
       * Format: date-time
       * @example 2008-01-14T04:33:35Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2008-01-14T04:33:35Z
       */
      updated_at: string;
      /** @example 81 */
      private_gists: number;
      /** @example 100 */
      total_private_repos: number;
      /** @example 100 */
      owned_private_repos: number;
      /** @example 10000 */
      disk_usage: number;
      /** @example 8 */
      collaborators: number;
      /** @example true */
      two_factor_authentication: boolean;
      plan?: {
        collaborators: number;
        name: string;
        space: number;
        private_repos: number;
      };
      /** Format: date-time */
      suspended_at?: string | null;
      business_plus?: boolean;
      ldap_dn?: string;
    };
    /**
     * Codespaces Secret
     * @description Secrets for a GitHub Codespace.
     */
    "codespaces-secret": {
      /**
       * @description The name of the secret
       * @example SECRET_NAME
       */
      name: string;
      /**
       * Format: date-time
       * @description The date and time at which the secret was created, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      created_at: string;
      /**
       * Format: date-time
       * @description The date and time at which the secret was last updated, in ISO 8601 format':' YYYY-MM-DDTHH:MM:SSZ.
       */
      updated_at: string;
      /**
       * @description The type of repositories in the organization that the secret is visible to
       * @enum {string}
       */
      visibility: "all" | "private" | "selected";
      /**
       * Format: uri
       * @description The API URL at which the list of repositories this secret is visible to can be retrieved
       * @example https://api.github.com/user/secrets/SECRET_NAME/repositories
       */
      selected_repositories_url: string;
    };
    /**
     * CodespacesUserPublicKey
     * @description The public key used for setting user Codespaces' Secrets.
     */
    "codespaces-user-public-key": {
      /**
       * @description The identifier for the key.
       * @example 1234567
       */
      key_id: string;
      /**
       * @description The Base64 encoded public key.
       * @example hBT5WZEj8ZoOv6TYJsfWq7MxTEQopZO5/IT3ZCVQPzs=
       */
      key: string;
    };
    /**
     * Fetches information about an export of a codespace.
     * @description An export of a codespace. Also, latest export details for a codespace can be fetched with id = latest
     */
    "codespace-export-details": {
      /**
       * @description State of the latest export
       * @example succeeded | failed | in_progress
       */
      state?: string | null;
      /**
       * Format: date-time
       * @description Completion time of the last export operation
       * @example 2021-01-01T19:01:12Z
       */
      completed_at?: string | null;
      /**
       * @description Name of the exported branch
       * @example codespace-monalisa-octocat-hello-world-g4wpq6h95q
       */
      branch?: string | null;
      /**
       * @description Git commit SHA of the exported branch
       * @example fd95a81ca01e48ede9f39c799ecbcef817b8a3b2
       */
      sha?: string | null;
      /**
       * @description Id for the export details
       * @example latest
       */
      id?: string;
      /**
       * @description Url for fetching export details
       * @example https://api.github.com/user/codespaces/:name/exports/latest
       */
      export_url?: string;
      /**
       * @description Web url for the exported branch
       * @example https://github.com/octocat/hello-world/tree/:branch
       */
      html_url?: string | null;
    };
    /**
     * Codespace
     * @description A codespace.
     */
    "codespace-with-full-repository": {
      /** @example 1 */
      id: number;
      /**
       * @description Automatically generated name of this codespace.
       * @example monalisa-octocat-hello-world-g4wpq6h95q
       */
      name: string;
      /**
       * @description Display name for this codespace.
       * @example sliderish space pancake
       */
      display_name?: string | null;
      /**
       * @description UUID identifying this codespace's environment.
       * @example 26a7c758-7299-4a73-b978-5a92a7ae98a0
       */
      environment_id: string | null;
      owner: components["schemas"]["simple-user"];
      billable_owner: components["schemas"]["simple-user"];
      repository: components["schemas"]["full-repository"];
      machine: components["schemas"]["nullable-codespace-machine"];
      /**
       * @description Path to devcontainer.json from repo root used to create Codespace.
       * @example .devcontainer/example/devcontainer.json
       */
      devcontainer_path?: string | null;
      /**
       * @description Whether the codespace was created from a prebuild.
       * @example false
       */
      prebuild: boolean | null;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2011-01-26T19:01:12Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @description Last known time this codespace was started.
       * @example 2011-01-26T19:01:12Z
       */
      last_used_at: string;
      /**
       * @description State of this codespace.
       * @example Available
       * @enum {string}
       */
      state:
        | "Unknown"
        | "Created"
        | "Queued"
        | "Provisioning"
        | "Available"
        | "Awaiting"
        | "Unavailable"
        | "Deleted"
        | "Moved"
        | "Shutdown"
        | "Archived"
        | "Starting"
        | "ShuttingDown"
        | "Failed"
        | "Exporting"
        | "Updating"
        | "Rebuilding";
      /**
       * Format: uri
       * @description API URL for this codespace.
       */
      url: string;
      /** @description Details about the codespace's git repository. */
      git_status: {
        /**
         * @description The number of commits the local repository is ahead of the remote.
         * @example 0
         */
        ahead?: number;
        /**
         * @description The number of commits the local repository is behind the remote.
         * @example 0
         */
        behind?: number;
        /** @description Whether the local repository has unpushed changes. */
        has_unpushed_changes?: boolean;
        /** @description Whether the local repository has uncommitted changes. */
        has_uncommitted_changes?: boolean;
        /**
         * @description The current branch (or SHA if in detached HEAD state) of the local repository.
         * @example main
         */
        ref?: string;
      };
      /**
       * @description The initally assigned location of a new codespace.
       * @example WestUs2
       * @enum {string}
       */
      location: "EastUs" | "SouthEastAsia" | "WestEurope" | "WestUs2";
      /**
       * @description The number of minutes of inactivity after which this codespace will be automatically stopped.
       * @example 60
       */
      idle_timeout_minutes: number | null;
      /**
       * Format: uri
       * @description URL to access this codespace on the web.
       */
      web_url: string;
      /**
       * Format: uri
       * @description API URL to access available alternate machine types for this codespace.
       */
      machines_url: string;
      /**
       * Format: uri
       * @description API URL to start this codespace.
       */
      start_url: string;
      /**
       * Format: uri
       * @description API URL to stop this codespace.
       */
      stop_url: string;
      /**
       * Format: uri
       * @description API URL to publish this codespace to a new repository.
       */
      publish_url?: string | null;
      /**
       * Format: uri
       * @description API URL for the Pull Request associated with this codespace, if any.
       */
      pulls_url: string | null;
      recent_folders: string[];
      runtime_constraints?: {
        /** @description The privacy settings a user can select from when forwarding a port. */
        allowed_port_privacy_settings?: string[] | null;
      };
      /** @description Whether or not a codespace has a pending async operation. This would mean that the codespace is temporarily unavailable. The only thing that you can do with a codespace in this state is delete it. */
      pending_operation?: boolean | null;
      /** @description Text to show user when codespace is disabled by a pending operation */
      pending_operation_disabled_reason?: string | null;
      /** @description Text to show user when codespace idle timeout minutes has been overriden by an organization policy */
      idle_timeout_notice?: string | null;
      /**
       * @description Duration in minutes after codespace has gone idle in which it will be deleted. Must be integer minutes between 0 and 43200 (30 days).
       * @example 60
       */
      retention_period_minutes?: number | null;
      /**
       * Format: date-time
       * @description When a codespace will be auto-deleted based on the "retention_period_minutes" and "last_used_at"
       * @example 2011-01-26T20:01:12Z
       */
      retention_expires_at?: string | null;
    };
    /**
     * Email
     * @description Email
     */
    email: {
      /**
       * Format: email
       * @example octocat@github.com
       */
      email: string;
      /** @example true */
      primary: boolean;
      /** @example true */
      verified: boolean;
      /** @example public */
      visibility: string | null;
    };
    /**
     * GPG Key
     * @description A unique encryption key
     */
    "gpg-key": {
      /** @example 3 */
      id: number;
      /** @example Octocat's GPG Key */
      name?: string | null;
      primary_key_id: number | null;
      /** @example 3262EFF25BA0D270 */
      key_id: string;
      /** @example xsBNBFayYZ... */
      public_key: string;
      /**
       * @example [
       *   {
       *     "email": "octocat@users.noreply.github.com",
       *     "verified": true
       *   }
       * ]
       */
      emails: {
        email?: string;
        verified?: boolean;
      }[];
      /**
       * @example [
       *   {
       *     "id": 4,
       *     "primary_key_id": 3,
       *     "key_id": "4A595D4C72EE49C7",
       *     "public_key": "zsBNBFayYZ...",
       *     "emails": [],
       *     "subkeys": [],
       *     "can_sign": false,
       *     "can_encrypt_comms": true,
       *     "can_encrypt_storage": true,
       *     "can_certify": false,
       *     "created_at": "2016-03-24T11:31:04-06:00",
       *     "expires_at": null,
       *     "revoked": false
       *   }
       * ]
       */
      subkeys: {
        id?: number;
        primary_key_id?: number;
        key_id?: string;
        public_key?: string;
        emails?: {
          email?: string;
          verified?: boolean;
        }[];
        subkeys?: unknown[];
        can_sign?: boolean;
        can_encrypt_comms?: boolean;
        can_encrypt_storage?: boolean;
        can_certify?: boolean;
        created_at?: string;
        expires_at?: string | null;
        raw_key?: string | null;
        revoked?: boolean;
      }[];
      /** @example true */
      can_sign: boolean;
      can_encrypt_comms: boolean;
      can_encrypt_storage: boolean;
      /** @example true */
      can_certify: boolean;
      /**
       * Format: date-time
       * @example 2016-03-24T11:31:04-06:00
       */
      created_at: string;
      /** Format: date-time */
      expires_at: string | null;
      /** @example true */
      revoked: boolean;
      raw_key: string | null;
    };
    /**
     * Key
     * @description Key
     */
    key: {
      key: string;
      id: number;
      url: string;
      title: string;
      /** Format: date-time */
      created_at: string;
      verified: boolean;
      read_only: boolean;
    };
    /** Marketplace Account */
    "marketplace-account": {
      /** Format: uri */
      url: string;
      id: number;
      type: string;
      node_id?: string;
      login: string;
      /** Format: email */
      email?: string | null;
      /** Format: email */
      organization_billing_email?: string | null;
    };
    /**
     * User Marketplace Purchase
     * @description User Marketplace Purchase
     */
    "user-marketplace-purchase": {
      /** @example monthly */
      billing_cycle: string;
      /**
       * Format: date-time
       * @example 2017-11-11T00:00:00Z
       */
      next_billing_date: string | null;
      unit_count: number | null;
      /** @example true */
      on_free_trial: boolean;
      /**
       * Format: date-time
       * @example 2017-11-11T00:00:00Z
       */
      free_trial_ends_on: string | null;
      /**
       * Format: date-time
       * @example 2017-11-02T01:12:12Z
       */
      updated_at: string | null;
      account: components["schemas"]["marketplace-account"];
      plan: components["schemas"]["marketplace-listing-plan"];
    };
    /**
     * Social account
     * @description Social media account
     */
    "social-account": {
      /** @example linkedin */
      provider: string;
      /** @example https://www.linkedin.com/company/github/ */
      url: string;
    };
    /**
     * SSH Signing Key
     * @description A public SSH key used to sign Git commits
     */
    "ssh-signing-key": {
      key: string;
      id: number;
      title: string;
      /** Format: date-time */
      created_at: string;
    };
    /**
     * Starred Repository
     * @description Starred Repository
     */
    "starred-repository": {
      /** Format: date-time */
      starred_at: string;
      repo: components["schemas"]["repository"];
    };
    /**
     * Hovercard
     * @description Hovercard
     */
    hovercard: {
      contexts: {
        message: string;
        octicon: string;
      }[];
    };
    /**
     * Key Simple
     * @description Key Simple
     */
    "key-simple": {
      id: number;
      key: string;
    };
    /**
     * Simple Installation
     * @description The GitHub App installation. This property is included when the event is configured for and sent to a GitHub App.
     */
    "simple-installation": {
      /**
       * @description The ID of the installation.
       * @example 1
       */
      id: number;
      /**
       * @description The global node ID of the installation.
       * @example MDQ6VXNlcjU4MzIzMQ==
       */
      node_id: string;
    };
    /** @description A suite of checks performed on the code of a given code change */
    "simple-check-suite": {
      /** @example d6fde92930d4715a2b49857d24b940956b26d2d3 */
      after?: string | null;
      app?: components["schemas"]["integration"];
      /** @example 146e867f55c26428e5f9fade55a9bbf5e95a7912 */
      before?: string | null;
      /**
       * @example neutral
       * @enum {string|null}
       */
      conclusion?:
        | "success"
        | "failure"
        | "neutral"
        | "cancelled"
        | "skipped"
        | "timed_out"
        | "action_required"
        | "stale"
        | "startup_failure"
        | null;
      /** Format: date-time */
      created_at?: string;
      /** @example master */
      head_branch?: string | null;
      /**
       * @description The SHA of the head commit that is being checked.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha?: string;
      /** @example 5 */
      id?: number;
      /** @example MDEwOkNoZWNrU3VpdGU1 */
      node_id?: string;
      pull_requests?: components["schemas"]["pull-request-minimal"][];
      repository?: components["schemas"]["minimal-repository"];
      /**
       * @example completed
       * @enum {string}
       */
      status?: "queued" | "in_progress" | "completed" | "pending" | "waiting";
      /** Format: date-time */
      updated_at?: string;
      /** @example https://api.github.com/repos/github/hello-world/check-suites/5 */
      url?: string;
    };
    /**
     * CheckRun
     * @description A check performed on the code of a given code change
     */
    "check-run-with-simple-check-suite": {
      app: components["schemas"]["nullable-integration"];
      check_suite: components["schemas"]["simple-check-suite"];
      /**
       * Format: date-time
       * @example 2018-05-04T01:14:52Z
       */
      completed_at: string | null;
      /**
       * @example neutral
       * @enum {string|null}
       */
      conclusion:
        | "waiting"
        | "pending"
        | "startup_failure"
        | "stale"
        | "success"
        | "failure"
        | "neutral"
        | "cancelled"
        | "skipped"
        | "timed_out"
        | "action_required"
        | null;
      deployment?: components["schemas"]["deployment-simple"];
      /** @example https://example.com */
      details_url: string;
      /** @example 42 */
      external_id: string;
      /**
       * @description The SHA of the commit that is being checked.
       * @example 009b8a3a9ccbb128af87f9b1c0f4c62e8a304f6d
       */
      head_sha: string;
      /** @example https://github.com/github/hello-world/runs/4 */
      html_url: string;
      /**
       * @description The id of the check.
       * @example 21
       */
      id: number;
      /**
       * @description The name of the check.
       * @example test-coverage
       */
      name: string;
      /** @example MDg6Q2hlY2tSdW40 */
      node_id: string;
      output: {
        annotations_count: number;
        /** Format: uri */
        annotations_url: string;
        summary: string | null;
        text: string | null;
        title: string | null;
      };
      pull_requests: components["schemas"]["pull-request-minimal"][];
      /**
       * Format: date-time
       * @example 2018-05-04T01:14:52Z
       */
      started_at: string;
      /**
       * @description The phase of the lifecycle that the check is currently in.
       * @example queued
       * @enum {string}
       */
      status: "queued" | "in_progress" | "completed" | "pending";
      /** @example https://api.github.com/repos/github/hello-world/check-runs/4 */
      url: string;
    };
    /**
     * Discussion
     * @description A Discussion in a repository.
     */
    discussion: {
      active_lock_reason: string | null;
      answer_chosen_at: string | null;
      /** User */
      answer_chosen_by: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      answer_html_url: string | null;
      /**
       * AuthorAssociation
       * @description How the author is associated with the repository.
       * @enum {string}
       */
      author_association:
        | "COLLABORATOR"
        | "CONTRIBUTOR"
        | "FIRST_TIMER"
        | "FIRST_TIME_CONTRIBUTOR"
        | "MANNEQUIN"
        | "MEMBER"
        | "NONE"
        | "OWNER";
      body: string;
      category: {
        /** Format: date-time */
        created_at: string;
        description: string;
        emoji: string;
        id: number;
        is_answerable: boolean;
        name: string;
        node_id?: string;
        repository_id: number;
        slug: string;
        updated_at: string;
      };
      comments: number;
      /** Format: date-time */
      created_at: string;
      html_url: string;
      id: number;
      locked: boolean;
      node_id: string;
      number: number;
      /** Reactions */
      reactions?: {
        "+1": number;
        "-1": number;
        confused: number;
        eyes: number;
        heart: number;
        hooray: number;
        laugh: number;
        rocket: number;
        total_count: number;
        /** Format: uri */
        url: string;
      };
      repository_url: string;
      /**
       * @description The current state of the discussion.
       * `converting` means that the discussion is being converted from an issue.
       * `transferring` means that the discussion is being transferred from another repository.
       * @enum {string}
       */
      state: "open" | "closed" | "locked" | "converting" | "transferring";
      /**
       * @description The reason for the current state
       * @example resolved
       * @enum {string|null}
       */
      state_reason: "resolved" | "outdated" | "duplicate" | "reopened" | null;
      timeline_url?: string;
      title: string;
      /** Format: date-time */
      updated_at: string;
      /** User */
      user: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
    };
    /**
     * Personal Access Token Request
     * @description Details of a Personal Access Token Request.
     */
    "personal-access-token-request": {
      /** @description Unique identifier of the request for access via fine-grained personal access token. Used as the `pat_request_id` parameter in the list and review API calls. */
      id: number;
      owner: components["schemas"]["simple-user"];
      /** @description New requested permissions, categorized by type of permission. */
      permissions_added: {
        organization?: {
          [key: string]: string | undefined;
        };
        repository?: {
          [key: string]: string | undefined;
        };
        other?: {
          [key: string]: string | undefined;
        };
      };
      /** @description Requested permissions that elevate access for a previously approved request for access, categorized by type of permission. */
      permissions_upgraded: {
        organization?: {
          [key: string]: string | undefined;
        };
        repository?: {
          [key: string]: string | undefined;
        };
        other?: {
          [key: string]: string | undefined;
        };
      };
      /** @description Permissions requested, categorized by type of permission. This field incorporates `permissions_added` and `permissions_upgraded`. */
      permissions_result: {
        organization?: {
          [key: string]: string | undefined;
        };
        repository?: {
          [key: string]: string | undefined;
        };
        other?: {
          [key: string]: string | undefined;
        };
      };
      /**
       * @description Type of repository selection requested.
       * @enum {string}
       */
      repository_selection: "none" | "all" | "subset";
      /** @description The number of repositories the token is requesting access to. This field is only populated when `repository_selection` is `subset`. */
      repository_count: number | null;
      /** @description An array of repository objects the token is requesting access to. This field is only populated when `repository_selection` is `subset`. */
      repositories:
        | {
            full_name: string;
            /** @description Unique identifier of the repository */
            id: number;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** @description Whether the repository is private or public. */
            private: boolean;
          }[]
        | null;
      /** @description Date and time when the request for access was created. */
      created_at: string;
      /** @description Whether the associated fine-grained personal access token has expired. */
      token_expired: boolean;
      /** @description Date and time when the associated fine-grained personal access token expires. */
      token_expires_at: string | null;
      /** @description Date and time when the associated fine-grained personal access token was last used for authentication. */
      token_last_used_at: string | null;
    };
    /**
     * Projects v2 Project
     * @description A projects v2 project
     */
    "projects-v2": {
      id: number;
      node_id: string;
      owner: components["schemas"]["simple-user"];
      creator: components["schemas"]["simple-user"];
      title: string;
      description: string | null;
      public: boolean;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      closed_at: string | null;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      updated_at: string;
      number: number;
      short_description: string | null;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      deleted_at: string | null;
      deleted_by: components["schemas"]["nullable-simple-user"];
    };
    /**
     * Projects v2 Item Content Type
     * @description The type of content tracked in a project item
     * @enum {string}
     */
    "projects-v2-item-content-type": "Issue" | "PullRequest" | "DraftIssue";
    /**
     * Projects v2 Item
     * @description An item belonging to a project
     */
    "projects-v2-item": {
      id: number;
      node_id?: string;
      project_node_id?: string;
      content_node_id: string;
      content_type: components["schemas"]["projects-v2-item-content-type"];
      creator?: components["schemas"]["simple-user"];
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      created_at: string;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      updated_at: string;
      /**
       * Format: date-time
       * @example 2022-04-28T12:00:00Z
       */
      archived_at: string | null;
    };
    /** branch protection rule created event */
    "webhook-branch-protection-rule-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      /**
       * branch protection rule
       * @description The branch protection rule. Includes a `name` and all the [branch protection settings](https://docs.github.com/github/administering-a-repository/defining-the-mergeability-of-pull-requests/about-protected-branches#about-branch-protection-settings) applied to branches that match the name. Binary settings are boolean. Multi-level configurations are one of `off`, `non_admins`, or `everyone`. Actor and build lists are arrays of strings.
       */
      rule: {
        admin_enforced: boolean;
        /** @enum {string} */
        allow_deletions_enforcement_level: "off" | "non_admins" | "everyone";
        /** @enum {string} */
        allow_force_pushes_enforcement_level: "off" | "non_admins" | "everyone";
        authorized_actor_names: string[];
        authorized_actors_only: boolean;
        authorized_dismissal_actors_only: boolean;
        create_protected?: boolean;
        /** Format: date-time */
        created_at: string;
        dismiss_stale_reviews_on_push: boolean;
        id: number;
        ignore_approvals_from_contributors: boolean;
        /** @enum {string} */
        linear_history_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        merge_queue_enforcement_level: "off" | "non_admins" | "everyone";
        name: string;
        /** @enum {string} */
        pull_request_reviews_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        repository_id: number;
        require_code_owner_review: boolean;
        required_approving_review_count: number;
        /** @enum {string} */
        required_conversation_resolution_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        required_deployments_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        required_status_checks: string[];
        /** @enum {string} */
        required_status_checks_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        signature_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        strict_required_status_checks_policy: boolean;
        /** Format: date-time */
        updated_at: string;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** branch protection rule deleted event */
    "webhook-branch-protection-rule-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      /**
       * branch protection rule
       * @description The branch protection rule. Includes a `name` and all the [branch protection settings](https://docs.github.com/github/administering-a-repository/defining-the-mergeability-of-pull-requests/about-protected-branches#about-branch-protection-settings) applied to branches that match the name. Binary settings are boolean. Multi-level configurations are one of `off`, `non_admins`, or `everyone`. Actor and build lists are arrays of strings.
       */
      rule: {
        admin_enforced: boolean;
        /** @enum {string} */
        allow_deletions_enforcement_level: "off" | "non_admins" | "everyone";
        /** @enum {string} */
        allow_force_pushes_enforcement_level: "off" | "non_admins" | "everyone";
        authorized_actor_names: string[];
        authorized_actors_only: boolean;
        authorized_dismissal_actors_only: boolean;
        create_protected?: boolean;
        /** Format: date-time */
        created_at: string;
        dismiss_stale_reviews_on_push: boolean;
        id: number;
        ignore_approvals_from_contributors: boolean;
        /** @enum {string} */
        linear_history_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        merge_queue_enforcement_level: "off" | "non_admins" | "everyone";
        name: string;
        /** @enum {string} */
        pull_request_reviews_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        repository_id: number;
        require_code_owner_review: boolean;
        required_approving_review_count: number;
        /** @enum {string} */
        required_conversation_resolution_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        required_deployments_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        required_status_checks: string[];
        /** @enum {string} */
        required_status_checks_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        signature_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        strict_required_status_checks_policy: boolean;
        /** Format: date-time */
        updated_at: string;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** branch protection rule edited event */
    "webhook-branch-protection-rule-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description If the action was `edited`, the changes to the rule. */
      changes?: {
        admin_enforced?: {
          from: boolean | null;
        };
        authorized_actor_names?: {
          from: string[];
        };
        authorized_actors_only?: {
          from: boolean | null;
        };
        authorized_dismissal_actors_only?: {
          from: boolean | null;
        };
        linear_history_requirement_enforcement_level?: {
          /** @enum {string} */
          from: "off" | "non_admins" | "everyone";
        };
        required_status_checks?: {
          from: string[];
        };
        required_status_checks_enforcement_level?: {
          /** @enum {string} */
          from: "off" | "non_admins" | "everyone";
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      /**
       * branch protection rule
       * @description The branch protection rule. Includes a `name` and all the [branch protection settings](https://docs.github.com/github/administering-a-repository/defining-the-mergeability-of-pull-requests/about-protected-branches#about-branch-protection-settings) applied to branches that match the name. Binary settings are boolean. Multi-level configurations are one of `off`, `non_admins`, or `everyone`. Actor and build lists are arrays of strings.
       */
      rule: {
        admin_enforced: boolean;
        /** @enum {string} */
        allow_deletions_enforcement_level: "off" | "non_admins" | "everyone";
        /** @enum {string} */
        allow_force_pushes_enforcement_level: "off" | "non_admins" | "everyone";
        authorized_actor_names: string[];
        authorized_actors_only: boolean;
        authorized_dismissal_actors_only: boolean;
        create_protected?: boolean;
        /** Format: date-time */
        created_at: string;
        dismiss_stale_reviews_on_push: boolean;
        id: number;
        ignore_approvals_from_contributors: boolean;
        /** @enum {string} */
        linear_history_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        merge_queue_enforcement_level: "off" | "non_admins" | "everyone";
        name: string;
        /** @enum {string} */
        pull_request_reviews_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        repository_id: number;
        require_code_owner_review: boolean;
        required_approving_review_count: number;
        /** @enum {string} */
        required_conversation_resolution_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        required_deployments_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        required_status_checks: string[];
        /** @enum {string} */
        required_status_checks_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        /** @enum {string} */
        signature_requirement_enforcement_level:
          | "off"
          | "non_admins"
          | "everyone";
        strict_required_status_checks_policy: boolean;
        /** Format: date-time */
        updated_at: string;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** Check Run Completed Event */
    "webhook-check-run-completed": {
      /** @enum {string} */
      action?: "completed";
      check_run: components["schemas"]["check-run-with-simple-check-suite"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /**
     * Check Run Completed Event
     * @description The check_run.completed webhook encoded with URL encoding
     */
    "webhook-check-run-completed-form-encoded": {
      /** @description A URL-encoded string of the check_run.completed JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** Check Run Created Event */
    "webhook-check-run-created": {
      /** @enum {string} */
      action?: "created";
      check_run: components["schemas"]["check-run-with-simple-check-suite"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /**
     * Check Run Created Event
     * @description The check_run.created webhook encoded with URL encoding
     */
    "webhook-check-run-created-form-encoded": {
      /** @description A URL-encoded string of the check_run.created JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** Check Run Requested Action Event */
    "webhook-check-run-requested-action": {
      /** @enum {string} */
      action: "requested_action";
      check_run: components["schemas"]["check-run-with-simple-check-suite"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      /** @description The action requested by the user. */
      requested_action?: {
        /** @description The integrator reference of the action requested by the user. */
        identifier?: string;
      };
      sender: components["schemas"]["simple-user"];
    };
    /**
     * Check Run Requested Action Event
     * @description The check_run.requested_action webhook encoded with URL encoding
     */
    "webhook-check-run-requested-action-form-encoded": {
      /** @description A URL-encoded string of the check_run.requested_action JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** Check Run Re-Requested Event */
    "webhook-check-run-rerequested": {
      /** @enum {string} */
      action?: "rerequested";
      check_run: components["schemas"]["check-run-with-simple-check-suite"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /**
     * Check Run Re-Requested Event
     * @description The check_run.rerequested webhook encoded with URL encoding
     */
    "webhook-check-run-rerequested-form-encoded": {
      /** @description A URL-encoded string of the check_run.rerequested JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** check_suite completed event */
    "webhook-check-suite-completed": {
      /** @enum {string} */
      action: "completed";
      actions_meta?: Record<string, unknown> | null;
      /** @description The [check_suite](https://docs.github.com/rest/reference/checks#suites). */
      check_suite: {
        after: string | null;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        app: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "merge_group"
            | "pull_request_review_thread"
            | "workflow_job"
            | "merge_queue_entry"
            | "security_and_analysis"
            | "projects_v2_item"
            | "secret_scanning_alert_location"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        };
        before: string | null;
        /** Format: uri */
        check_runs_url: string;
        /**
         * @description The summary conclusion for all check runs that are part of the check suite. Can be one of `success`, `failure`, `neutral`, `cancelled`, `timed_out`, `action_required` or `stale`. This value will be `null` until the check run has `completed`.
         * @enum {string|null}
         */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | "skipped"
          | "startup_failure"
          | null;
        /** Format: date-time */
        created_at: string;
        /** @description The head branch name the changes are on. */
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** @description The SHA of the head commit that is being checked. */
        head_sha: string;
        id: number;
        latest_check_runs_count: number;
        node_id: string;
        /** @description An array of pull requests that match this check suite. A pull request matches a check suite if they have the same `head_sha` and `head_branch`. When the check suite's `head_branch` is in a forked repository it will be `null` and the `pull_requests` array will be empty. */
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        rerequestable?: boolean;
        runs_rerequestable?: boolean;
        /**
         * @description The summary status for all check runs that are part of the check suite. Can be `requested`, `in_progress`, or `completed`.
         * @enum {string|null}
         */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | ""
          | "pending"
          | null;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL that points to the check suite API resource.
         */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** check_suite requested event */
    "webhook-check-suite-requested": {
      /** @enum {string} */
      action: "requested";
      actions_meta?: Record<string, unknown> | null;
      /** @description The [check_suite](https://docs.github.com/rest/reference/checks#suites). */
      check_suite: {
        after: string | null;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        app: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "pull_request_review_thread"
            | "workflow_job"
            | "merge_queue_entry"
            | "security_and_analysis"
            | "secret_scanning_alert_location"
            | "projects_v2_item"
            | "merge_group"
            | "repository_import"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        };
        before: string | null;
        /** Format: uri */
        check_runs_url: string;
        /**
         * @description The summary conclusion for all check runs that are part of the check suite. Can be one of `success`, `failure`,` neutral`, `cancelled`, `timed_out`, `action_required` or `stale`. This value will be `null` until the check run has completed.
         * @enum {string|null}
         */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | "skipped"
          | null;
        /** Format: date-time */
        created_at: string;
        /** @description The head branch name the changes are on. */
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** @description The SHA of the head commit that is being checked. */
        head_sha: string;
        id: number;
        latest_check_runs_count: number;
        node_id: string;
        /** @description An array of pull requests that match this check suite. A pull request matches a check suite if they have the same `head_sha` and `head_branch`. When the check suite's `head_branch` is in a forked repository it will be `null` and the `pull_requests` array will be empty. */
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        rerequestable?: boolean;
        runs_rerequestable?: boolean;
        /**
         * @description The summary status for all check runs that are part of the check suite. Can be `requested`, `in_progress`, or `completed`.
         * @enum {string|null}
         */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | ""
          | null;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL that points to the check suite API resource.
         */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** check_suite rerequested event */
    "webhook-check-suite-rerequested": {
      /** @enum {string} */
      action: "rerequested";
      actions_meta?: {
        rerun_info?: {
          plan_id?: string;
          job_ids?: string[];
        };
      } | null;
      /** @description The [check_suite](https://docs.github.com/rest/reference/checks#suites). */
      check_suite: {
        after: string | null;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        app: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "pull_request_review_thread"
            | "merge_queue_entry"
            | "workflow_job"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        };
        before: string | null;
        /** Format: uri */
        check_runs_url: string;
        /**
         * @description The summary conclusion for all check runs that are part of the check suite. Can be one of `success`, `failure`,` neutral`, `cancelled`, `timed_out`, `action_required` or `stale`. This value will be `null` until the check run has completed.
         * @enum {string|null}
         */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | null;
        /** Format: date-time */
        created_at: string;
        /** @description The head branch name the changes are on. */
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** @description The SHA of the head commit that is being checked. */
        head_sha: string;
        id: number;
        latest_check_runs_count: number;
        node_id: string;
        /** @description An array of pull requests that match this check suite. A pull request matches a check suite if they have the same `head_sha` and `head_branch`. When the check suite's `head_branch` is in a forked repository it will be `null` and the `pull_requests` array will be empty. */
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        rerequestable?: boolean;
        runs_rerequestable?: boolean;
        /**
         * @description The summary status for all check runs that are part of the check suite. Can be `requested`, `in_progress`, or `completed`.
         * @enum {string|null}
         */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | ""
          | null;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL that points to the check suite API resource.
         */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert appeared_in_branch event */
    "webhook-code-scanning-alert-appeared-in-branch": {
      /** @enum {string} */
      action: "appeared_in_branch";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string;
        /**
         * Format: date-time
         * @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
         */
        dismissed_at: string | null;
        /** User */
        dismissed_by: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`.
         * @enum {string|null}
         */
        dismissed_reason:
          | "false positive"
          | "won't fix"
          | "used in tests"
          | ""
          | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "open" | "dismissed" | "fixed";
        tool: {
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        };
        /** Format: uri */
        url: string;
      };
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert closed_by_user event */
    "webhook-code-scanning-alert-closed-by-user": {
      /** @enum {string} */
      action: "closed_by_user";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string;
        /**
         * Format: date-time
         * @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
         */
        dismissed_at: string;
        /** User */
        dismissed_by: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`.
         * @enum {string|null}
         */
        dismissed_reason:
          | "false positive"
          | "won't fix"
          | "used in tests"
          | ""
          | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          full_description?: string;
          help?: string | null;
          /** @description A link to the documentation for the rule used to detect the alert. */
          help_uri?: string | null;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          name?: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
          tags?: string[] | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "dismissed" | "fixed";
        tool: {
          guid?: string | null;
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        };
        /** Format: uri */
        url: string;
      };
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert created event */
    "webhook-code-scanning-alert-created": {
      /** @enum {string} */
      action: "created";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string | null;
        /** @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`. */
        dismissed_at: Record<string, unknown> | null;
        dismissed_by: Record<string, unknown> | null;
        dismissed_comment?: components["schemas"]["code-scanning-alert-dismissed-comment"];
        /** @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`. */
        dismissed_reason: Record<string, unknown> | null;
        fixed_at?: Record<string, unknown> | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        instances_url?: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          full_description?: string;
          help?: string | null;
          /** @description A link to the documentation for the rule used to detect the alert. */
          help_uri?: string | null;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          name?: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
          tags?: string[] | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "open" | "dismissed";
        tool: {
          guid?: string | null;
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        } | null;
        updated_at?: string | null;
        /** Format: uri */
        url: string;
      };
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert fixed event */
    "webhook-code-scanning-alert-fixed": {
      /** @enum {string} */
      action: "fixed";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string;
        /**
         * Format: date-time
         * @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
         */
        dismissed_at: string | null;
        /** User */
        dismissed_by: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`.
         * @enum {string|null}
         */
        dismissed_reason:
          | "false positive"
          | "won't fix"
          | "used in tests"
          | ""
          | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        /** Format: uri */
        instances_url?: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          full_description?: string;
          help?: string | null;
          /** @description A link to the documentation for the rule used to detect the alert. */
          help_uri?: string | null;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          name?: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
          tags?: string[] | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "fixed";
        tool: {
          guid?: string | null;
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        };
        /** Format: uri */
        url: string;
      };
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert reopened event */
    "webhook-code-scanning-alert-reopened": {
      /** @enum {string} */
      action: "reopened";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string;
        /** @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`. */
        dismissed_at: string | null;
        dismissed_by: Record<string, unknown> | null;
        /** @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`. */
        dismissed_reason: string | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          full_description?: string;
          help?: string | null;
          /** @description A link to the documentation for the rule used to detect the alert. */
          help_uri?: string | null;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          name?: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
          tags?: string[] | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "open" | "dismissed" | "fixed";
        tool: {
          guid?: string | null;
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        };
        /** Format: uri */
        url: string;
      } | null;
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string | null;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** code_scanning_alert reopened_by_user event */
    "webhook-code-scanning-alert-reopened-by-user": {
      /** @enum {string} */
      action: "reopened_by_user";
      /** @description The code scanning alert involved in the event. */
      alert: {
        /**
         * Format: date-time
         * @description The time that the alert was created in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ.`
         */
        created_at: string;
        /** @description The time that the alert was dismissed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`. */
        dismissed_at: Record<string, unknown> | null;
        dismissed_by: Record<string, unknown> | null;
        /** @description The reason for dismissing or closing the alert. Can be one of: `false positive`, `won't fix`, and `used in tests`. */
        dismissed_reason: Record<string, unknown> | null;
        /**
         * Format: uri
         * @description The GitHub URL of the alert resource.
         */
        html_url: string;
        /** Alert Instance */
        most_recent_instance?: {
          /** @description Identifies the configuration under which the analysis was executed. For example, in GitHub Actions this includes the workflow filename and job name. */
          analysis_key: string;
          /** @description Identifies the configuration under which the analysis was executed. */
          category?: string;
          classifications?: string[];
          commit_sha?: string;
          /** @description Identifies the variable values associated with the environment in which the analysis that generated this alert instance was performed, such as the language that was analyzed. */
          environment: string;
          location?: {
            end_column?: number;
            end_line?: number;
            path?: string;
            start_column?: number;
            start_line?: number;
          };
          message?: {
            text?: string;
          };
          /** @description The full Git reference, formatted as `refs/heads/<branch name>`. */
          ref: string;
          /**
           * @description State of a code scanning alert.
           * @enum {string}
           */
          state: "open" | "dismissed" | "fixed";
        } | null;
        /** @description The code scanning alert number. */
        number: number;
        rule: {
          /** @description A short description of the rule used to detect the alert. */
          description: string;
          /** @description A unique identifier for the rule used to detect the alert. */
          id: string;
          /**
           * @description The severity of the alert.
           * @enum {string|null}
           */
          severity: "none" | "note" | "warning" | "error" | "" | null;
        };
        /**
         * @description State of a code scanning alert.
         * @enum {string}
         */
        state: "open" | "fixed";
        tool: {
          /** @description The name of the tool used to generate the code scanning analysis alert. */
          name: string;
          /** @description The version of the tool used to detect the alert. */
          version: string | null;
        };
        /** Format: uri */
        url: string;
      };
      /** @description The commit SHA of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      commit_oid: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The Git reference of the code scanning alert. When the action is `reopened_by_user` or `closed_by_user`, the event was triggered by the `sender` and this value will be empty. */
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** commit_comment created event */
    "webhook-commit-comment-created": {
      /**
       * @description The action performed. Can be `created`.
       * @enum {string}
       */
      action: "created";
      /** @description The [commit comment](https://docs.github.com/rest/reference/repos#get-a-commit-comment) resource. */
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the comment. */
        body: string;
        /** @description The SHA of the commit to which the comment applies. */
        commit_id: string;
        created_at: string;
        /** Format: uri */
        html_url: string;
        /** @description The ID of the commit comment. */
        id: number;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        line: number | null;
        /** @description The node ID of the commit comment. */
        node_id: string;
        /** @description The relative path of the file to which the comment applies. */
        path: string | null;
        /** @description The line index in the diff to which the comment applies. */
        position: number | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** create event */
    "webhook-create": {
      /** @description The repository's current description. */
      description: string | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The name of the repository's default branch (usually `main`). */
      master_branch: string;
      organization?: components["schemas"]["organization-simple"];
      /** @description The pusher type for the event. Can be either `user` or a deploy key. */
      pusher_type: string;
      /** @description The [`git ref`](https://docs.github.com/rest/reference/git#get-a-reference) resource. */
      ref: string;
      /**
       * @description The type of Git ref object created in the repository.
       * @enum {string}
       */
      ref_type: "tag" | "branch";
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** delete event */
    "webhook-delete": {
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The pusher type for the event. Can be either `user` or a deploy key. */
      pusher_type: string;
      /** @description The [`git ref`](https://docs.github.com/rest/reference/git#get-a-reference) resource. */
      ref: string;
      /**
       * @description The type of Git ref object deleted in the repository.
       * @enum {string}
       */
      ref_type: "tag" | "branch";
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert auto-dismissed event */
    "webhook-dependabot-alert-auto-dismissed": {
      /** @enum {string} */
      action: "auto_dismissed";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert auto-reopened event */
    "webhook-dependabot-alert-auto-reopened": {
      /** @enum {string} */
      action: "auto_reopened";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert created event */
    "webhook-dependabot-alert-created": {
      /** @enum {string} */
      action: "created";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert dismissed event */
    "webhook-dependabot-alert-dismissed": {
      /** @enum {string} */
      action: "dismissed";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert fixed event */
    "webhook-dependabot-alert-fixed": {
      /** @enum {string} */
      action: "fixed";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert reintroduced event */
    "webhook-dependabot-alert-reintroduced": {
      /** @enum {string} */
      action: "reintroduced";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Dependabot alert reopened event */
    "webhook-dependabot-alert-reopened": {
      /** @enum {string} */
      action: "reopened";
      alert: components["schemas"]["dependabot-alert"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      enterprise?: components["schemas"]["enterprise"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** deploy_key created event */
    "webhook-deploy-key-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [`deploy key`](https://docs.github.com/rest/reference/deployments#get-a-deploy-key) resource. */
      key: {
        added_by?: string | null;
        created_at: string;
        id: number;
        key: string;
        last_used?: string | null;
        read_only: boolean;
        title: string;
        /** Format: uri */
        url: string;
        verified: boolean;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** deploy_key deleted event */
    "webhook-deploy-key-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [`deploy key`](https://docs.github.com/rest/reference/deployments#get-a-deploy-key) resource. */
      key: {
        added_by?: string | null;
        created_at: string;
        id: number;
        key: string;
        last_used?: string | null;
        read_only: boolean;
        title: string;
        /** Format: uri */
        url: string;
        verified: boolean;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** deployment created event */
    "webhook-deployment-created": {
      /** @enum {string} */
      action: "created";
      /**
       * Deployment
       * @description The [deployment](https://docs.github.com/rest/reference/deployments#list-deployments).
       */
      deployment: {
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        environment: string;
        id: number;
        node_id: string;
        original_environment: string;
        payload: Record<string, never> | string;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "workflow_job"
            | "pull_request_review_thread"
            | "merge_queue_entry"
            | "secret_scanning_alert_location"
            | "merge_group"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        production_environment?: boolean;
        ref: string;
        /** Format: uri */
        repository_url: string;
        sha: string;
        /** Format: uri */
        statuses_url: string;
        task: string;
        transient_environment?: boolean;
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** Workflow */
      workflow: {
        /** Format: uri */
        badge_url: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        node_id: string;
        path: string;
        state: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } | null;
      /** Deployment Workflow Run */
      workflow_run: {
        /** User */
        actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        artifacts_url?: string;
        cancel_url?: string;
        check_suite_id: number;
        check_suite_node_id: string;
        check_suite_url?: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | null;
        /** Format: date-time */
        created_at: string;
        display_title: string;
        event: string;
        head_branch: string;
        head_commit?: Record<string, unknown> | null;
        head_repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: Record<string, unknown> | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        jobs_url?: string;
        logs_url?: string;
        name: string;
        node_id: string;
        path: string;
        previous_attempt_url?: Record<string, unknown> | null;
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: Record<string, unknown> | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        rerun_url?: string;
        run_attempt: number;
        run_number: number;
        /** Format: date-time */
        run_started_at: string;
        /** @enum {string} */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | "waiting"
          | "pending";
        /** User */
        triggering_actor?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        workflow_id: number;
        workflow_url?: string;
      } | null;
    };
    /** deployment protection rule requested event */
    "webhook-deployment-protection-rule-requested": {
      /** @enum {string} */
      action?: "requested";
      /** @description The name of the environment that has the deployment protection rule. */
      environment?: string;
      /** @description The event that triggered the deployment protection rule. */
      event?: string;
      /**
       * Format: uri
       * @description The URL to review the deployment protection rule.
       */
      deployment_callback_url?: string;
      deployment?: components["schemas"]["deployment"];
      pull_requests?: components["schemas"]["pull-request"][];
      repository?: components["schemas"]["repository"];
      organization?: components["schemas"]["organization-simple"];
      installation?: components["schemas"]["simple-installation"];
      sender?: components["schemas"]["simple-user"];
    };
    /** deployment_status created event */
    "webhook-deployment-status-created": {
      /** @enum {string} */
      action: "created";
      check_run?: {
        /** Format: date-time */
        completed_at: string | null;
        /**
         * @description The result of the completed check run. Can be one of `success`, `failure`, `neutral`, `cancelled`, `timed_out`, `action_required` or `stale`. This value will be `null` until the check run has completed.
         * @enum {string|null}
         */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | "skipped"
          | ""
          | null;
        /** Format: uri */
        details_url: string;
        external_id: string;
        /** @description The SHA of the commit that is being checked. */
        head_sha: string;
        /** Format: uri */
        html_url: string;
        /** @description The id of the check. */
        id: number;
        /** @description The name of the check run. */
        name: string;
        node_id: string;
        /** Format: date-time */
        started_at: string;
        /**
         * @description The current status of the check run. Can be `queued`, `in_progress`, or `completed`.
         * @enum {string}
         */
        status: "queued" | "in_progress" | "completed" | "waiting" | "pending";
        /** Format: uri */
        url: string;
      } | null;
      /**
       * Deployment
       * @description The [deployment](https://docs.github.com/rest/reference/deployments#list-deployments).
       */
      deployment: {
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        environment: string;
        id: number;
        node_id: string;
        original_environment: string;
        payload: string | Record<string, never>;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "merge_queue_entry"
            | "workflow_job"
            | "pull_request_review_thread"
            | "secret_scanning_alert_location"
            | "merge_group"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        production_environment?: boolean;
        ref: string;
        /** Format: uri */
        repository_url: string;
        sha: string;
        /** Format: uri */
        statuses_url: string;
        task: string;
        transient_environment?: boolean;
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      /** @description The [deployment status](https://docs.github.com/rest/reference/deployments#list-deployment-statuses). */
      deployment_status: {
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        deployment_url: string;
        /** @description The optional human-readable description added to the status. */
        description: string;
        environment: string;
        /** Format: uri */
        environment_url?: string;
        id: number;
        /** Format: uri */
        log_url?: string;
        node_id: string;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "pull_request_review_thread"
            | "merge_queue_entry"
            | "workflow_job"
            | "merge_group"
            | "secret_scanning_alert_location"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        /** Format: uri */
        repository_url: string;
        /** @description The new state. Can be `pending`, `success`, `failure`, or `error`. */
        state: string;
        /** @description The optional link added to the status. */
        target_url: string;
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** Workflow */
      workflow?: {
        /** Format: uri */
        badge_url: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        node_id: string;
        path: string;
        state: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } | null;
      /** Deployment Workflow Run */
      workflow_run?: {
        /** User */
        actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        artifacts_url?: string;
        cancel_url?: string;
        check_suite_id: number;
        check_suite_node_id: string;
        check_suite_url?: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | "startup_failure"
          | null;
        /** Format: date-time */
        created_at: string;
        display_title: string;
        event: string;
        head_branch: string;
        head_commit?: Record<string, unknown> | null;
        head_repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: Record<string, unknown> | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        jobs_url?: string;
        logs_url?: string;
        name: string;
        node_id: string;
        path: string;
        previous_attempt_url?: Record<string, unknown> | null;
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: Record<string, unknown> | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        rerun_url?: string;
        run_attempt: number;
        run_number: number;
        /** Format: date-time */
        run_started_at: string;
        /** @enum {string} */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | "waiting"
          | "pending";
        /** User */
        triggering_actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        workflow_id: number;
        workflow_url?: string;
      } | null;
    };
    /** discussion answered event */
    "webhook-discussion-answered": {
      /** @enum {string} */
      action: "answered";
      answer: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string;
        child_comment_count: number;
        /** Format: date-time */
        created_at: string;
        discussion_id: number;
        html_url: string;
        id: number;
        node_id: string;
        parent_id: Record<string, unknown> | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        /** Format: date-time */
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion category changed event */
    "webhook-discussion-category-changed": {
      /** @enum {string} */
      action: "category_changed";
      changes: {
        category: {
          from: {
            /** Format: date-time */
            created_at: string;
            description: string;
            emoji: string;
            id: number;
            is_answerable: boolean;
            name: string;
            node_id?: string;
            repository_id: number;
            slug: string;
            updated_at: string;
          };
        };
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion closed event */
    "webhook-discussion-closed": {
      /** @enum {string} */
      action: "closed";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion_comment created event */
    "webhook-discussion-comment-created": {
      /** @enum {string} */
      action: "created";
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string;
        child_comment_count: number;
        created_at: string;
        discussion_id: number;
        html_url: string;
        id: number;
        node_id: string;
        parent_id: number | null;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion_comment deleted event */
    "webhook-discussion-comment-deleted": {
      /** @enum {string} */
      action: "deleted";
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string;
        child_comment_count: number;
        created_at: string;
        discussion_id: number;
        html_url: string;
        id: number;
        node_id: string;
        parent_id: number | null;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion_comment edited event */
    "webhook-discussion-comment-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        body: {
          from: string;
        };
      };
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string;
        child_comment_count: number;
        created_at: string;
        discussion_id: number;
        html_url: string;
        id: number;
        node_id: string;
        parent_id: number | null;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion created event */
    "webhook-discussion-created": {
      /** @enum {string} */
      action: "created";
      discussion: {
        active_lock_reason: string | null;
        answer_chosen_at: string | null;
        /** User */
        answer_chosen_by: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        answer_html_url: string | null;
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string | null;
        category: {
          /** Format: date-time */
          created_at: string;
          description: string;
          emoji: string;
          id: number;
          is_answerable: boolean;
          name: string;
          node_id?: string;
          repository_id: number;
          slug: string;
          updated_at: string;
        };
        comments: number;
        /** Format: date-time */
        created_at: string;
        html_url: string;
        id: number;
        locked: boolean;
        node_id: string;
        number: number;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        /** @enum {string} */
        state: "open" | "locked" | "converting" | "transferring";
        timeline_url?: string;
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: Record<string, unknown> | null;
        answer_chosen_at: Record<string, unknown> | null;
        answer_chosen_by: Record<string, unknown> | null;
        answer_html_url: string | null;
        author_association?: string;
        body?: string | null;
        category?: {
          created_at?: string;
          description?: string;
          emoji?: string;
          id?: number;
          is_answerable?: boolean;
          name?: string;
          node_id?: string;
          repository_id?: number;
          slug?: string;
          updated_at?: string;
        };
        comments?: number;
        created_at?: string;
        html_url?: string;
        id?: number;
        /** @enum {boolean} */
        locked: false;
        node_id?: string;
        number?: number;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /** @enum {string} */
        state: "open" | "converting" | "transferring";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion deleted event */
    "webhook-discussion-deleted": {
      /** @enum {string} */
      action: "deleted";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion edited event */
    "webhook-discussion-edited": {
      /** @enum {string} */
      action: "edited";
      changes?: {
        body?: {
          from: string;
        };
        title?: {
          from: string;
        };
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion labeled event */
    "webhook-discussion-labeled": {
      /** @enum {string} */
      action: "labeled";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion locked event */
    "webhook-discussion-locked": {
      /** @enum {string} */
      action: "locked";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion pinned event */
    "webhook-discussion-pinned": {
      /** @enum {string} */
      action: "pinned";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion reopened event */
    "webhook-discussion-reopened": {
      /** @enum {string} */
      action: "reopened";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion transferred event */
    "webhook-discussion-transferred": {
      /** @enum {string} */
      action: "transferred";
      changes: {
        new_discussion: components["schemas"]["discussion"];
        new_repository: components["schemas"]["repository"];
      };
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion unanswered event */
    "webhook-discussion-unanswered": {
      /** @enum {string} */
      action: "unanswered";
      discussion: components["schemas"]["discussion"];
      old_answer: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        body: string;
        child_comment_count: number;
        /** Format: date-time */
        created_at: string;
        discussion_id: number;
        html_url: string;
        id: number;
        node_id: string;
        parent_id: Record<string, unknown> | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        repository_url: string;
        /** Format: date-time */
        updated_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** discussion unlabeled event */
    "webhook-discussion-unlabeled": {
      /** @enum {string} */
      action: "unlabeled";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion unlocked event */
    "webhook-discussion-unlocked": {
      /** @enum {string} */
      action: "unlocked";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** discussion unpinned event */
    "webhook-discussion-unpinned": {
      /** @enum {string} */
      action: "unpinned";
      discussion: components["schemas"]["discussion"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /**
     * fork event
     * @description A user forks a repository.
     */
    "webhook-fork": {
      enterprise?: components["schemas"]["enterprise"];
      /** @description The created [`repository`](https://docs.github.com/rest/reference/repos#get-a-repository) resource. */
      forkee: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
        /** @description Whether to require contributors to sign off on web-based commits */
        web_commit_signoff_required?: boolean;
      } & {
        allow_forking?: boolean;
        archive_url?: string;
        archived?: boolean;
        assignees_url?: string;
        blobs_url?: string;
        branches_url?: string;
        clone_url?: string;
        collaborators_url?: string;
        comments_url?: string;
        commits_url?: string;
        compare_url?: string;
        contents_url?: string;
        contributors_url?: string;
        created_at?: string;
        default_branch?: string;
        deployments_url?: string;
        description?: string | null;
        disabled?: boolean;
        downloads_url?: string;
        events_url?: string;
        /** @enum {boolean} */
        fork?: true;
        forks?: number;
        forks_count?: number;
        forks_url?: string;
        full_name?: string;
        git_commits_url?: string;
        git_refs_url?: string;
        git_tags_url?: string;
        git_url?: string;
        has_downloads?: boolean;
        has_issues?: boolean;
        has_pages?: boolean;
        has_projects?: boolean;
        has_wiki?: boolean;
        homepage?: string | null;
        hooks_url?: string;
        html_url?: string;
        id?: number;
        is_template?: boolean;
        issue_comment_url?: string;
        issue_events_url?: string;
        issues_url?: string;
        keys_url?: string;
        labels_url?: string;
        language?: Record<string, unknown> | null;
        languages_url?: string;
        license?: Record<string, unknown> | null;
        merges_url?: string;
        milestones_url?: string;
        mirror_url?: Record<string, unknown> | null;
        name?: string;
        node_id?: string;
        notifications_url?: string;
        open_issues?: number;
        open_issues_count?: number;
        owner?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        private?: boolean;
        public?: boolean;
        pulls_url?: string;
        pushed_at?: string;
        releases_url?: string;
        size?: number;
        ssh_url?: string;
        stargazers_count?: number;
        stargazers_url?: string;
        statuses_url?: string;
        subscribers_url?: string;
        subscription_url?: string;
        svn_url?: string;
        tags_url?: string;
        teams_url?: string;
        topics?: (Record<string, unknown> | null)[];
        trees_url?: string;
        updated_at?: string;
        url?: string;
        visibility?: string;
        watchers?: number;
        watchers_count?: number;
      };
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** github_app_authorization revoked event */
    "webhook-github-app-authorization-revoked": {
      /** @enum {string} */
      action: "revoked";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** gollum event */
    "webhook-gollum": {
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description The pages that were updated. */
      pages: {
        /**
         * @description The action that was performed on the page. Can be `created` or `edited`.
         * @enum {string}
         */
        action: "created" | "edited";
        /**
         * Format: uri
         * @description Points to the HTML wiki page.
         */
        html_url: string;
        /** @description The name of the page. */
        page_name: string;
        /** @description The latest commit SHA of the page. */
        sha: string;
        summary: string | null;
        /** @description The current page title. */
        title: string;
      }[];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** installation created event */
    "webhook-installation-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects that the installation can access. */
      repositories?: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      /** User */
      requester?: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      sender: components["schemas"]["simple-user"];
    };
    /** installation deleted event */
    "webhook-installation-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects that the installation can access. */
      repositories?: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      requester?: Record<string, unknown> | null;
      sender: components["schemas"]["simple-user"];
    };
    /** installation new_permissions_accepted event */
    "webhook-installation-new-permissions-accepted": {
      /** @enum {string} */
      action: "new_permissions_accepted";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects that the installation can access. */
      repositories?: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      requester?: Record<string, unknown> | null;
      sender: components["schemas"]["simple-user"];
    };
    /** installation_repositories added event */
    "webhook-installation-repositories-added": {
      /** @enum {string} */
      action: "added";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects, which were added to the installation. */
      repositories_added: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      /** @description An array of repository objects, which were removed from the installation. */
      repositories_removed: {
        full_name?: string;
        /** @description Unique identifier of the repository */
        id?: number;
        /** @description The name of the repository. */
        name?: string;
        node_id?: string;
        /** @description Whether the repository is private or public. */
        private?: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      /**
       * @description Describe whether all repositories have been selected or there's a selection involved
       * @enum {string}
       */
      repository_selection: "all" | "selected";
      /** User */
      requester: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      sender: components["schemas"]["simple-user"];
    };
    /** installation_repositories removed event */
    "webhook-installation-repositories-removed": {
      /** @enum {string} */
      action: "removed";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects, which were added to the installation. */
      repositories_added: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      /** @description An array of repository objects, which were removed from the installation. */
      repositories_removed: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      /**
       * @description Describe whether all repositories have been selected or there's a selection involved
       * @enum {string}
       */
      repository_selection: "all" | "selected";
      /** User */
      requester: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      sender: components["schemas"]["simple-user"];
    };
    /** installation suspend event */
    "webhook-installation-suspend": {
      /** @enum {string} */
      action: "suspend";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects that the installation can access. */
      repositories?: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      requester?: Record<string, unknown> | null;
      sender: components["schemas"]["simple-user"];
    };
    "webhook-installation-target-renamed": {
      account: {
        avatar_url: string;
        created_at?: string;
        description?: Record<string, unknown> | null;
        events_url?: string;
        followers?: number;
        followers_url?: string;
        following?: number;
        following_url?: string;
        gists_url?: string;
        gravatar_id?: string;
        has_organization_projects?: boolean;
        has_repository_projects?: boolean;
        hooks_url?: string;
        html_url: string;
        id: number;
        is_verified?: boolean;
        issues_url?: string;
        login?: string;
        members_url?: string;
        name?: string;
        node_id: string;
        organizations_url?: string;
        public_gists?: number;
        public_members_url?: string;
        public_repos?: number;
        received_events_url?: string;
        repos_url?: string;
        site_admin?: boolean;
        slug?: string;
        starred_url?: string;
        subscriptions_url?: string;
        type?: string;
        updated_at?: string;
        url?: string;
        website_url?: Record<string, unknown> | null;
      };
      action: string;
      changes: {
        login?: {
          from: string;
        };
        slug?: {
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
      target_type: string;
    };
    /** installation unsuspend event */
    "webhook-installation-unsuspend": {
      /** @enum {string} */
      action: "unsuspend";
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description An array of repository objects that the installation can access. */
      repositories?: {
        full_name: string;
        /** @description Unique identifier of the repository */
        id: number;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** @description Whether the repository is private or public. */
        private: boolean;
      }[];
      repository?: components["schemas"]["repository"];
      requester?: Record<string, unknown> | null;
      sender: components["schemas"]["simple-user"];
    };
    /** issue_comment created event */
    "webhook-issue-comment-created": {
      /** @enum {string} */
      action: "created";
      /**
       * issue comment
       * @description The [comment](https://docs.github.com/rest/reference/issues#comments) itself.
       */
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue comment */
        body: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        /**
         * Format: int64
         * @description Unique identifier of the issue comment
         */
        id: number;
        /** Format: uri */
        issue_url: string;
        node_id: string;
        performed_via_github_app: components["schemas"]["nullable-integration"];
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [issue](https://docs.github.com/rest/reference/issues) the comment belongs to. */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        labels_url?: string;
        locked: boolean;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issue_comment deleted event */
    "webhook-issue-comment-deleted": {
      /** @enum {string} */
      action: "deleted";
      /**
       * issue comment
       * @description The [comment](https://docs.github.com/rest/reference/issues#comments) itself.
       */
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue comment */
        body: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        /**
         * Format: int64
         * @description Unique identifier of the issue comment
         */
        id: number;
        /** Format: uri */
        issue_url: string;
        node_id: string;
        performed_via_github_app: components["schemas"]["nullable-integration"];
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [issue](https://docs.github.com/rest/reference/issues) the comment belongs to. */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        labels_url?: string;
        locked: boolean;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issue_comment edited event */
    "webhook-issue-comment-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the comment. */
      changes: {
        body?: {
          /** @description The previous version of the body. */
          from: string;
        };
      };
      /**
       * issue comment
       * @description The [comment](https://docs.github.com/rest/reference/issues#comments) itself.
       */
      comment: {
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue comment */
        body: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        /**
         * Format: int64
         * @description Unique identifier of the issue comment
         */
        id: number;
        /** Format: uri */
        issue_url: string;
        node_id: string;
        performed_via_github_app: components["schemas"]["nullable-integration"];
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [issue](https://docs.github.com/rest/reference/issues) the comment belongs to. */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        labels_url?: string;
        locked: boolean;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues assigned event */
    "webhook-issues-assigned": {
      /**
       * @description The action that was performed.
       * @enum {string}
       */
      action: "assigned";
      /** User */
      assignee?: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues closed event */
    "webhook-issues-closed": {
      /**
       * @description The action that was performed.
       * @enum {string}
       */
      action: "closed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The [issue](https://docs.github.com/rest/reference/issues) itself. */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "security_and_analysis"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        locked?: boolean;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /** @enum {string} */
        state: "closed" | "open";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues deleted event */
    "webhook-issues-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues demilestoned event */
    "webhook-issues-demilestoned": {
      /** @enum {string} */
      action: "demilestoned";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        state?: string;
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone?: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues edited event */
    "webhook-issues-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the issue. */
      changes: {
        body?: {
          /** @description The previous version of the body. */
          from: string;
        };
        title?: {
          /** @description The previous version of the title. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "security_and_analysis"
            | "pull_request_review_thread"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      /** Label */
      label?: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues labeled event */
    "webhook-issues-labeled": {
      /** @enum {string} */
      action: "labeled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "pull_request_review_thread"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      /** Label */
      label?: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues locked event */
    "webhook-issues-locked": {
      /** @enum {string} */
      action: "locked";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "security_and_analysis"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        /** @enum {boolean} */
        locked: true;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        state?: string;
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues milestoned event */
    "webhook-issues-milestoned": {
      /** @enum {string} */
      action: "milestoned";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        };
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        state?: string;
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues opened event */
    "webhook-issues-opened": {
      /** @enum {string} */
      action: "opened";
      changes?: {
        /**
         * Issue
         * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
         */
        old_issue: {
          /** @enum {string|null} */
          active_lock_reason:
            | "resolved"
            | "off-topic"
            | "too heated"
            | "spam"
            | ""
            | null;
          /** User */
          assignee?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          assignees: ({
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null)[];
          /**
           * AuthorAssociation
           * @description How the author is associated with the repository.
           * @enum {string}
           */
          author_association:
            | "COLLABORATOR"
            | "CONTRIBUTOR"
            | "FIRST_TIMER"
            | "FIRST_TIME_CONTRIBUTOR"
            | "MANNEQUIN"
            | "MEMBER"
            | "NONE"
            | "OWNER";
          /** @description Contents of the issue */
          body: string | null;
          /** Format: date-time */
          closed_at: string | null;
          comments: number;
          /** Format: uri */
          comments_url: string;
          /** Format: date-time */
          created_at: string;
          draft?: boolean;
          /** Format: uri */
          events_url: string;
          /** Format: uri */
          html_url: string;
          /** Format: int64 */
          id: number;
          labels?: {
            /** @description 6-character hex code, without the leading #, identifying the color */
            color: string;
            default: boolean;
            description: string | null;
            id: number;
            /** @description The name of the label. */
            name: string;
            node_id: string;
            /**
             * Format: uri
             * @description URL for the label
             */
            url: string;
          }[];
          /** Format: uri-template */
          labels_url: string;
          locked?: boolean;
          /**
           * Milestone
           * @description A collection of related issues and pull requests.
           */
          milestone: {
            /** Format: date-time */
            closed_at: string | null;
            closed_issues: number;
            /** Format: date-time */
            created_at: string;
            /** User */
            creator: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            description: string | null;
            /** Format: date-time */
            due_on: string | null;
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            labels_url: string;
            node_id: string;
            /** @description The number of the milestone. */
            number: number;
            open_issues: number;
            /**
             * @description The state of the milestone.
             * @enum {string}
             */
            state: "open" | "closed";
            /** @description The title of the milestone. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
          } | null;
          node_id: string;
          number: number;
          /**
           * App
           * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
           */
          performed_via_github_app?: {
            /** Format: date-time */
            created_at: string | null;
            description: string | null;
            /** @description The list of events for the GitHub app */
            events?: (
              | "branch_protection_rule"
              | "check_run"
              | "check_suite"
              | "code_scanning_alert"
              | "commit_comment"
              | "content_reference"
              | "create"
              | "delete"
              | "deployment"
              | "deployment_review"
              | "deployment_status"
              | "deploy_key"
              | "discussion"
              | "discussion_comment"
              | "fork"
              | "gollum"
              | "issues"
              | "issue_comment"
              | "label"
              | "member"
              | "membership"
              | "milestone"
              | "organization"
              | "org_block"
              | "page_build"
              | "project"
              | "project_card"
              | "project_column"
              | "public"
              | "pull_request"
              | "pull_request_review"
              | "pull_request_review_comment"
              | "push"
              | "registry_package"
              | "release"
              | "repository"
              | "repository_dispatch"
              | "secret_scanning_alert"
              | "star"
              | "status"
              | "team"
              | "team_add"
              | "watch"
              | "workflow_dispatch"
              | "workflow_run"
            )[];
            /** Format: uri */
            external_url: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the GitHub app */
            id: number | null;
            /** @description The name of the GitHub app */
            name: string;
            node_id: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /** @description The set of permissions for the GitHub app */
            permissions?: {
              /** @enum {string} */
              actions?: "read" | "write";
              /** @enum {string} */
              administration?: "read" | "write";
              /** @enum {string} */
              checks?: "read" | "write";
              /** @enum {string} */
              content_references?: "read" | "write";
              /** @enum {string} */
              contents?: "read" | "write";
              /** @enum {string} */
              deployments?: "read" | "write";
              /** @enum {string} */
              discussions?: "read" | "write";
              /** @enum {string} */
              emails?: "read" | "write";
              /** @enum {string} */
              environments?: "read" | "write";
              /** @enum {string} */
              issues?: "read" | "write";
              /** @enum {string} */
              keys?: "read" | "write";
              /** @enum {string} */
              members?: "read" | "write";
              /** @enum {string} */
              metadata?: "read" | "write";
              /** @enum {string} */
              organization_administration?: "read" | "write";
              /** @enum {string} */
              organization_hooks?: "read" | "write";
              /** @enum {string} */
              organization_packages?: "read" | "write";
              /** @enum {string} */
              organization_plan?: "read" | "write";
              /** @enum {string} */
              organization_projects?: "read" | "write";
              /** @enum {string} */
              organization_secrets?: "read" | "write";
              /** @enum {string} */
              organization_self_hosted_runners?: "read" | "write";
              /** @enum {string} */
              organization_user_blocking?: "read" | "write";
              /** @enum {string} */
              packages?: "read" | "write";
              /** @enum {string} */
              pages?: "read" | "write";
              /** @enum {string} */
              pull_requests?: "read" | "write";
              /** @enum {string} */
              repository_hooks?: "read" | "write";
              /** @enum {string} */
              repository_projects?: "read" | "write";
              /** @enum {string} */
              secret_scanning_alerts?: "read" | "write";
              /** @enum {string} */
              secrets?: "read" | "write";
              /** @enum {string} */
              security_events?: "read" | "write";
              /** @enum {string} */
              security_scanning_alert?: "read" | "write";
              /** @enum {string} */
              single_file?: "read" | "write";
              /** @enum {string} */
              statuses?: "read" | "write";
              /** @enum {string} */
              team_discussions?: "read" | "write";
              /** @enum {string} */
              vulnerability_alerts?: "read" | "write";
              /** @enum {string} */
              workflows?: "read" | "write";
            };
            /** @description The slug name of the GitHub app */
            slug?: string;
            /** Format: date-time */
            updated_at: string | null;
          } | null;
          pull_request?: {
            /** Format: uri */
            diff_url?: string;
            /** Format: uri */
            html_url?: string;
            /** Format: date-time */
            merged_at?: string | null;
            /** Format: uri */
            patch_url?: string;
            /** Format: uri */
            url?: string;
          };
          /** Reactions */
          reactions: {
            "+1": number;
            "-1": number;
            confused: number;
            eyes: number;
            heart: number;
            hooray: number;
            laugh: number;
            rocket: number;
            total_count: number;
            /** Format: uri */
            url: string;
          };
          /** Format: uri */
          repository_url: string;
          /**
           * @description State of the issue; either 'open' or 'closed'
           * @enum {string}
           */
          state?: "open" | "closed";
          state_reason?: string | null;
          /** Format: uri */
          timeline_url?: string;
          /** @description Title of the issue */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /**
           * Format: uri
           * @description URL for the issue
           */
          url: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        } | null;
        /**
         * Repository
         * @description A git repository
         */
        old_repository: {
          /**
           * @description Whether to allow auto-merge for pull requests.
           * @default false
           */
          allow_auto_merge?: boolean;
          /** @description Whether to allow private forks */
          allow_forking?: boolean;
          /**
           * @description Whether to allow merge commits for pull requests.
           * @default true
           */
          allow_merge_commit?: boolean;
          /**
           * @description Whether to allow rebase merges for pull requests.
           * @default true
           */
          allow_rebase_merge?: boolean;
          /**
           * @description Whether to allow squash merges for pull requests.
           * @default true
           */
          allow_squash_merge?: boolean;
          allow_update_branch?: boolean;
          /** Format: uri-template */
          archive_url: string;
          /**
           * @description Whether the repository is archived.
           * @default false
           */
          archived: boolean;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri */
          clone_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          created_at: number | string;
          /** @description The default branch of the repository. */
          default_branch: string;
          /**
           * @description Whether to delete head branches when pull requests are merged
           * @default false
           */
          delete_branch_on_merge?: boolean;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** @description Returns whether or not this repository is disabled. */
          disabled?: boolean;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          forks: number;
          forks_count: number;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          git_url: string;
          /**
           * @description Whether downloads are enabled.
           * @default true
           */
          has_downloads: boolean;
          /**
           * @description Whether issues are enabled.
           * @default true
           */
          has_issues: boolean;
          has_pages: boolean;
          /**
           * @description Whether projects are enabled.
           * @default true
           */
          has_projects: boolean;
          /**
           * @description Whether the wiki is enabled.
           * @default true
           */
          has_wiki: boolean;
          homepage: string | null;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          is_template?: boolean;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          language: string | null;
          /** Format: uri */
          languages_url: string;
          /** License */
          license: {
            key: string;
            name: string;
            node_id: string;
            spdx_id: string;
            /** Format: uri */
            url: string | null;
          } | null;
          master_branch?: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** Format: uri */
          mirror_url: string | null;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          open_issues: number;
          open_issues_count: number;
          organization?: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          permissions?: {
            admin: boolean;
            maintain?: boolean;
            pull: boolean;
            push: boolean;
            triage?: boolean;
          };
          /** @description Whether the repository is private or public. */
          private: boolean;
          public?: boolean;
          /** Format: uri-template */
          pulls_url: string;
          pushed_at: number | string;
          /** Format: uri-template */
          releases_url: string;
          role_name?: string | null;
          size: number;
          ssh_url: string;
          stargazers?: number;
          stargazers_count: number;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          svn_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          topics: string[];
          /** Format: uri-template */
          trees_url: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
          /** @enum {string} */
          visibility: "public" | "private" | "internal";
          watchers: number;
          watchers_count: number;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "security_and_analysis"
            | "pull_request_review_thread"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues pinned event */
    "webhook-issues-pinned": {
      /** @enum {string} */
      action: "pinned";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues reopened event */
    "webhook-issues-reopened": {
      /** @enum {string} */
      action: "reopened";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "pull_request_review_thread"
            | "reminder"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason?: string | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        locked?: boolean;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        /** @enum {string} */
        state: "open" | "closed";
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues transferred event */
    "webhook-issues-transferred": {
      /** @enum {string} */
      action: "transferred";
      changes: {
        /**
         * Issue
         * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
         */
        new_issue: {
          /** @enum {string|null} */
          active_lock_reason:
            | "resolved"
            | "off-topic"
            | "too heated"
            | "spam"
            | ""
            | null;
          /** User */
          assignee?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          assignees: ({
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null)[];
          /**
           * AuthorAssociation
           * @description How the author is associated with the repository.
           * @enum {string}
           */
          author_association:
            | "COLLABORATOR"
            | "CONTRIBUTOR"
            | "FIRST_TIMER"
            | "FIRST_TIME_CONTRIBUTOR"
            | "MANNEQUIN"
            | "MEMBER"
            | "NONE"
            | "OWNER";
          /** @description Contents of the issue */
          body: string | null;
          /** Format: date-time */
          closed_at: string | null;
          comments: number;
          /** Format: uri */
          comments_url: string;
          /** Format: date-time */
          created_at: string;
          draft?: boolean;
          /** Format: uri */
          events_url: string;
          /** Format: uri */
          html_url: string;
          /** Format: int64 */
          id: number;
          labels?: {
            /** @description 6-character hex code, without the leading #, identifying the color */
            color: string;
            default: boolean;
            description: string | null;
            id: number;
            /** @description The name of the label. */
            name: string;
            node_id: string;
            /**
             * Format: uri
             * @description URL for the label
             */
            url: string;
          }[];
          /** Format: uri-template */
          labels_url: string;
          locked?: boolean;
          /**
           * Milestone
           * @description A collection of related issues and pull requests.
           */
          milestone: {
            /** Format: date-time */
            closed_at: string | null;
            closed_issues: number;
            /** Format: date-time */
            created_at: string;
            /** User */
            creator: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            description: string | null;
            /** Format: date-time */
            due_on: string | null;
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            labels_url: string;
            node_id: string;
            /** @description The number of the milestone. */
            number: number;
            open_issues: number;
            /**
             * @description The state of the milestone.
             * @enum {string}
             */
            state: "open" | "closed";
            /** @description The title of the milestone. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
          } | null;
          node_id: string;
          number: number;
          /**
           * App
           * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
           */
          performed_via_github_app?: {
            /** Format: date-time */
            created_at: string | null;
            description: string | null;
            /** @description The list of events for the GitHub app */
            events?: (
              | "branch_protection_rule"
              | "check_run"
              | "check_suite"
              | "code_scanning_alert"
              | "commit_comment"
              | "content_reference"
              | "create"
              | "delete"
              | "deployment"
              | "deployment_review"
              | "deployment_status"
              | "deploy_key"
              | "discussion"
              | "discussion_comment"
              | "fork"
              | "gollum"
              | "issues"
              | "issue_comment"
              | "label"
              | "member"
              | "membership"
              | "milestone"
              | "organization"
              | "org_block"
              | "page_build"
              | "project"
              | "project_card"
              | "project_column"
              | "public"
              | "pull_request"
              | "pull_request_review"
              | "pull_request_review_comment"
              | "push"
              | "registry_package"
              | "release"
              | "repository"
              | "repository_dispatch"
              | "secret_scanning_alert"
              | "star"
              | "status"
              | "team"
              | "team_add"
              | "watch"
              | "workflow_dispatch"
              | "workflow_run"
            )[];
            /** Format: uri */
            external_url: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the GitHub app */
            id: number | null;
            /** @description The name of the GitHub app */
            name: string;
            node_id: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /** @description The set of permissions for the GitHub app */
            permissions?: {
              /** @enum {string} */
              actions?: "read" | "write";
              /** @enum {string} */
              administration?: "read" | "write";
              /** @enum {string} */
              checks?: "read" | "write";
              /** @enum {string} */
              content_references?: "read" | "write";
              /** @enum {string} */
              contents?: "read" | "write";
              /** @enum {string} */
              deployments?: "read" | "write";
              /** @enum {string} */
              discussions?: "read" | "write";
              /** @enum {string} */
              emails?: "read" | "write";
              /** @enum {string} */
              environments?: "read" | "write";
              /** @enum {string} */
              issues?: "read" | "write";
              /** @enum {string} */
              keys?: "read" | "write";
              /** @enum {string} */
              members?: "read" | "write";
              /** @enum {string} */
              metadata?: "read" | "write";
              /** @enum {string} */
              organization_administration?: "read" | "write";
              /** @enum {string} */
              organization_hooks?: "read" | "write";
              /** @enum {string} */
              organization_packages?: "read" | "write";
              /** @enum {string} */
              organization_plan?: "read" | "write";
              /** @enum {string} */
              organization_projects?: "read" | "write";
              /** @enum {string} */
              organization_secrets?: "read" | "write";
              /** @enum {string} */
              organization_self_hosted_runners?: "read" | "write";
              /** @enum {string} */
              organization_user_blocking?: "read" | "write";
              /** @enum {string} */
              packages?: "read" | "write";
              /** @enum {string} */
              pages?: "read" | "write";
              /** @enum {string} */
              pull_requests?: "read" | "write";
              /** @enum {string} */
              repository_hooks?: "read" | "write";
              /** @enum {string} */
              repository_projects?: "read" | "write";
              /** @enum {string} */
              secret_scanning_alerts?: "read" | "write";
              /** @enum {string} */
              secrets?: "read" | "write";
              /** @enum {string} */
              security_events?: "read" | "write";
              /** @enum {string} */
              security_scanning_alert?: "read" | "write";
              /** @enum {string} */
              single_file?: "read" | "write";
              /** @enum {string} */
              statuses?: "read" | "write";
              /** @enum {string} */
              team_discussions?: "read" | "write";
              /** @enum {string} */
              vulnerability_alerts?: "read" | "write";
              /** @enum {string} */
              workflows?: "read" | "write";
            };
            /** @description The slug name of the GitHub app */
            slug?: string;
            /** Format: date-time */
            updated_at: string | null;
          } | null;
          pull_request?: {
            /** Format: uri */
            diff_url?: string;
            /** Format: uri */
            html_url?: string;
            /** Format: date-time */
            merged_at?: string | null;
            /** Format: uri */
            patch_url?: string;
            /** Format: uri */
            url?: string;
          };
          /** Reactions */
          reactions: {
            "+1": number;
            "-1": number;
            confused: number;
            eyes: number;
            heart: number;
            hooray: number;
            laugh: number;
            rocket: number;
            total_count: number;
            /** Format: uri */
            url: string;
          };
          /** Format: uri */
          repository_url: string;
          /**
           * @description State of the issue; either 'open' or 'closed'
           * @enum {string}
           */
          state?: "open" | "closed";
          state_reason?: string | null;
          /** Format: uri */
          timeline_url?: string;
          /** @description Title of the issue */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /**
           * Format: uri
           * @description URL for the issue
           */
          url: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /**
         * Repository
         * @description A git repository
         */
        new_repository: {
          /**
           * @description Whether to allow auto-merge for pull requests.
           * @default false
           */
          allow_auto_merge?: boolean;
          /** @description Whether to allow private forks */
          allow_forking?: boolean;
          /**
           * @description Whether to allow merge commits for pull requests.
           * @default true
           */
          allow_merge_commit?: boolean;
          /**
           * @description Whether to allow rebase merges for pull requests.
           * @default true
           */
          allow_rebase_merge?: boolean;
          /**
           * @description Whether to allow squash merges for pull requests.
           * @default true
           */
          allow_squash_merge?: boolean;
          allow_update_branch?: boolean;
          /** Format: uri-template */
          archive_url: string;
          /**
           * @description Whether the repository is archived.
           * @default false
           */
          archived: boolean;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri */
          clone_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          created_at: number | string;
          /** @description The default branch of the repository. */
          default_branch: string;
          /**
           * @description Whether to delete head branches when pull requests are merged
           * @default false
           */
          delete_branch_on_merge?: boolean;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** @description Returns whether or not this repository is disabled. */
          disabled?: boolean;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          forks: number;
          forks_count: number;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          git_url: string;
          /**
           * @description Whether downloads are enabled.
           * @default true
           */
          has_downloads: boolean;
          /**
           * @description Whether issues are enabled.
           * @default true
           */
          has_issues: boolean;
          has_pages: boolean;
          /**
           * @description Whether projects are enabled.
           * @default true
           */
          has_projects: boolean;
          /**
           * @description Whether the wiki is enabled.
           * @default true
           */
          has_wiki: boolean;
          /**
           * @description Whether discussions are enabled.
           * @default false
           */
          has_discussions: boolean;
          homepage: string | null;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          is_template?: boolean;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          language: string | null;
          /** Format: uri */
          languages_url: string;
          /** License */
          license: {
            key: string;
            name: string;
            node_id: string;
            spdx_id: string;
            /** Format: uri */
            url: string | null;
          } | null;
          master_branch?: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** Format: uri */
          mirror_url: string | null;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          open_issues: number;
          open_issues_count: number;
          organization?: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          permissions?: {
            admin: boolean;
            maintain?: boolean;
            pull: boolean;
            push: boolean;
            triage?: boolean;
          };
          /** @description Whether the repository is private or public. */
          private: boolean;
          public?: boolean;
          /** Format: uri-template */
          pulls_url: string;
          pushed_at: number | string;
          /** Format: uri-template */
          releases_url: string;
          role_name?: string | null;
          size: number;
          ssh_url: string;
          stargazers?: number;
          stargazers_count: number;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          svn_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          topics: string[];
          /** Format: uri-template */
          trees_url: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
          /** @enum {string} */
          visibility: "public" | "private" | "internal";
          watchers: number;
          watchers_count: number;
          /** @description Whether to require contributors to sign off on web-based commits */
          web_commit_signoff_required?: boolean;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues unassigned event */
    "webhook-issues-unassigned": {
      /**
       * @description The action that was performed.
       * @enum {string}
       */
      action: "unassigned";
      /** User */
      assignee?: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization" | "Mannequin";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues unlabeled event */
    "webhook-issues-unlabeled": {
      /** @enum {string} */
      action: "unlabeled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
            | "reminder"
            | "pull_request_review_thread"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write" | "admin";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      /** Label */
      label?: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues unlocked event */
    "webhook-issues-unlocked": {
      /** @enum {string} */
      action: "unlocked";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      } & {
        active_lock_reason: Record<string, unknown> | null;
        assignee?: Record<string, unknown> | null;
        assignees?: (Record<string, unknown> | null)[];
        author_association?: string;
        body?: string | null;
        closed_at?: string | null;
        comments?: number;
        comments_url?: string;
        created_at?: string;
        events_url?: string;
        html_url?: string;
        id?: number;
        labels?: (Record<string, unknown> | null)[];
        labels_url?: string;
        /** @enum {boolean} */
        locked: false;
        milestone?: Record<string, unknown> | null;
        node_id?: string;
        number?: number;
        performed_via_github_app?: Record<string, unknown> | null;
        reactions?: {
          "+1"?: number;
          "-1"?: number;
          confused?: number;
          eyes?: number;
          heart?: number;
          hooray?: number;
          laugh?: number;
          rocket?: number;
          total_count?: number;
          url?: string;
        };
        repository_url?: string;
        state?: string;
        timeline_url?: string;
        title?: string;
        updated_at?: string;
        url?: string;
        user?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** issues unpinned event */
    "webhook-issues-unpinned": {
      /** @enum {string} */
      action: "unpinned";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Issue
       * @description The [issue](https://docs.github.com/rest/reference/issues) itself.
       */
      issue: {
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description Contents of the issue */
        body: string | null;
        /** Format: date-time */
        closed_at: string | null;
        comments: number;
        /** Format: uri */
        comments_url: string;
        /** Format: date-time */
        created_at: string;
        draft?: boolean;
        /** Format: uri */
        events_url: string;
        /** Format: uri */
        html_url: string;
        /** Format: int64 */
        id: number;
        labels?: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        /** Format: uri-template */
        labels_url: string;
        locked?: boolean;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /**
         * App
         * @description GitHub apps are a new way to extend GitHub. They can be installed directly on organizations and user accounts and granted access to specific repositories. They come with granular permissions and built-in webhooks. GitHub apps are first class actors within GitHub.
         */
        performed_via_github_app?: {
          /** Format: date-time */
          created_at: string | null;
          description: string | null;
          /** @description The list of events for the GitHub app */
          events?: (
            | "branch_protection_rule"
            | "check_run"
            | "check_suite"
            | "code_scanning_alert"
            | "commit_comment"
            | "content_reference"
            | "create"
            | "delete"
            | "deployment"
            | "deployment_review"
            | "deployment_status"
            | "deploy_key"
            | "discussion"
            | "discussion_comment"
            | "fork"
            | "gollum"
            | "issues"
            | "issue_comment"
            | "label"
            | "member"
            | "membership"
            | "milestone"
            | "organization"
            | "org_block"
            | "page_build"
            | "project"
            | "project_card"
            | "project_column"
            | "public"
            | "pull_request"
            | "pull_request_review"
            | "pull_request_review_comment"
            | "push"
            | "registry_package"
            | "release"
            | "repository"
            | "repository_dispatch"
            | "secret_scanning_alert"
            | "star"
            | "status"
            | "team"
            | "team_add"
            | "watch"
            | "workflow_dispatch"
            | "workflow_run"
          )[];
          /** Format: uri */
          external_url: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the GitHub app */
          id: number | null;
          /** @description The name of the GitHub app */
          name: string;
          node_id: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description The set of permissions for the GitHub app */
          permissions?: {
            /** @enum {string} */
            actions?: "read" | "write";
            /** @enum {string} */
            administration?: "read" | "write";
            /** @enum {string} */
            checks?: "read" | "write";
            /** @enum {string} */
            content_references?: "read" | "write";
            /** @enum {string} */
            contents?: "read" | "write";
            /** @enum {string} */
            deployments?: "read" | "write";
            /** @enum {string} */
            discussions?: "read" | "write";
            /** @enum {string} */
            emails?: "read" | "write";
            /** @enum {string} */
            environments?: "read" | "write";
            /** @enum {string} */
            issues?: "read" | "write";
            /** @enum {string} */
            keys?: "read" | "write";
            /** @enum {string} */
            members?: "read" | "write";
            /** @enum {string} */
            metadata?: "read" | "write";
            /** @enum {string} */
            organization_administration?: "read" | "write";
            /** @enum {string} */
            organization_hooks?: "read" | "write";
            /** @enum {string} */
            organization_packages?: "read" | "write";
            /** @enum {string} */
            organization_plan?: "read" | "write";
            /** @enum {string} */
            organization_projects?: "read" | "write";
            /** @enum {string} */
            organization_secrets?: "read" | "write";
            /** @enum {string} */
            organization_self_hosted_runners?: "read" | "write";
            /** @enum {string} */
            organization_user_blocking?: "read" | "write";
            /** @enum {string} */
            packages?: "read" | "write";
            /** @enum {string} */
            pages?: "read" | "write";
            /** @enum {string} */
            pull_requests?: "read" | "write";
            /** @enum {string} */
            repository_hooks?: "read" | "write";
            /** @enum {string} */
            repository_projects?: "read" | "write";
            /** @enum {string} */
            secret_scanning_alerts?: "read" | "write";
            /** @enum {string} */
            secrets?: "read" | "write";
            /** @enum {string} */
            security_events?: "read" | "write";
            /** @enum {string} */
            security_scanning_alert?: "read" | "write";
            /** @enum {string} */
            single_file?: "read" | "write";
            /** @enum {string} */
            statuses?: "read" | "write";
            /** @enum {string} */
            team_discussions?: "read" | "write";
            /** @enum {string} */
            vulnerability_alerts?: "read" | "write";
            /** @enum {string} */
            workflows?: "read" | "write";
          };
          /** @description The slug name of the GitHub app */
          slug?: string;
          /** Format: date-time */
          updated_at: string | null;
        } | null;
        pull_request?: {
          /** Format: uri */
          diff_url?: string;
          /** Format: uri */
          html_url?: string;
          /** Format: date-time */
          merged_at?: string | null;
          /** Format: uri */
          patch_url?: string;
          /** Format: uri */
          url?: string;
        };
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        repository_url: string;
        /**
         * @description State of the issue; either 'open' or 'closed'
         * @enum {string}
         */
        state?: "open" | "closed";
        state_reason?: string | null;
        /** Format: uri */
        timeline_url?: string;
        /** @description Title of the issue */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the issue
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** label created event */
    "webhook-label-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** label deleted event */
    "webhook-label-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** label edited event */
    "webhook-label-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the label if the action was `edited`. */
      changes?: {
        color?: {
          /** @description The previous version of the color if the action was `edited`. */
          from: string;
        };
        description?: {
          /** @description The previous version of the description if the action was `edited`. */
          from: string;
        };
        name?: {
          /** @description The previous version of the name if the action was `edited`. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** marketplace_purchase cancelled event */
    "webhook-marketplace-purchase-cancelled": {
      /** @enum {string} */
      action: "cancelled";
      effective_date: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      marketplace_purchase: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      } & {
        account?: {
          id?: number;
          login?: string;
          node_id?: string;
          organization_billing_email?: string | null;
          type?: string;
        };
        billing_cycle?: string;
        free_trial_ends_on?: string | null;
        next_billing_date: string | null;
        on_free_trial?: boolean;
        plan?: {
          bullets?: (string | null)[];
          description?: string;
          has_free_trial?: boolean;
          id?: number;
          monthly_price_in_cents?: number;
          name?: string;
          /** @enum {string} */
          price_model?: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name?: string | null;
          yearly_price_in_cents?: number;
        };
        unit_count?: number;
      };
      organization?: components["schemas"]["organization-simple"];
      /** Marketplace Purchase */
      previous_marketplace_purchase?: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: Record<string, unknown> | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** marketplace_purchase changed event */
    "webhook-marketplace-purchase-changed": {
      /** @enum {string} */
      action: "changed";
      effective_date: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      marketplace_purchase: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      } & {
        account?: {
          id?: number;
          login?: string;
          node_id?: string;
          organization_billing_email?: string | null;
          type?: string;
        };
        billing_cycle?: string;
        free_trial_ends_on?: string | null;
        next_billing_date: string | null;
        on_free_trial?: boolean;
        plan?: {
          bullets?: (string | null)[];
          description?: string;
          has_free_trial?: boolean;
          id?: number;
          monthly_price_in_cents?: number;
          name?: string;
          /** @enum {string} */
          price_model?: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name?: string | null;
          yearly_price_in_cents?: number;
        };
        unit_count?: number;
      };
      organization?: components["schemas"]["organization-simple"];
      /** Marketplace Purchase */
      previous_marketplace_purchase?: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean | null;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** marketplace_purchase pending_change event */
    "webhook-marketplace-purchase-pending-change": {
      /** @enum {string} */
      action: "pending_change";
      effective_date: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      marketplace_purchase: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      } & {
        account?: {
          id?: number;
          login?: string;
          node_id?: string;
          organization_billing_email?: string | null;
          type?: string;
        };
        billing_cycle?: string;
        free_trial_ends_on?: string | null;
        next_billing_date: string | null;
        on_free_trial?: boolean;
        plan?: {
          bullets?: (string | null)[];
          description?: string;
          has_free_trial?: boolean;
          id?: number;
          monthly_price_in_cents?: number;
          name?: string;
          /** @enum {string} */
          price_model?: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name?: string | null;
          yearly_price_in_cents?: number;
        };
        unit_count?: number;
      };
      organization?: components["schemas"]["organization-simple"];
      /** Marketplace Purchase */
      previous_marketplace_purchase?: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** marketplace_purchase pending_change_cancelled event */
    "webhook-marketplace-purchase-pending-change-cancelled": {
      /** @enum {string} */
      action: "pending_change_cancelled";
      effective_date: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      marketplace_purchase: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: Record<string, unknown> | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      } & {
        next_billing_date: string;
      };
      organization?: components["schemas"]["organization-simple"];
      /** Marketplace Purchase */
      previous_marketplace_purchase?: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: Record<string, unknown> | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** marketplace_purchase purchased event */
    "webhook-marketplace-purchase-purchased": {
      /** @enum {string} */
      action: "purchased";
      effective_date: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      marketplace_purchase: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: string | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      } & {
        account?: {
          id?: number;
          login?: string;
          node_id?: string;
          organization_billing_email?: string | null;
          type?: string;
        };
        billing_cycle?: string;
        free_trial_ends_on?: string | null;
        next_billing_date: string | null;
        on_free_trial?: boolean;
        plan?: {
          bullets?: (string | null)[];
          description?: string;
          has_free_trial?: boolean;
          id?: number;
          monthly_price_in_cents?: number;
          name?: string;
          /** @enum {string} */
          price_model?: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name?: string | null;
          yearly_price_in_cents?: number;
        };
        unit_count?: number;
      };
      organization?: components["schemas"]["organization-simple"];
      /** Marketplace Purchase */
      previous_marketplace_purchase?: {
        account: {
          id: number;
          login: string;
          node_id: string;
          organization_billing_email: string | null;
          type: string;
        };
        billing_cycle: string;
        free_trial_ends_on: Record<string, unknown> | null;
        next_billing_date?: string | null;
        on_free_trial: boolean;
        plan: {
          bullets: string[];
          description: string;
          has_free_trial: boolean;
          id: number;
          monthly_price_in_cents: number;
          name: string;
          /** @enum {string} */
          price_model: "FREE" | "FLAT_RATE" | "PER_UNIT";
          unit_name: string | null;
          yearly_price_in_cents: number;
        };
        unit_count: number;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** member added event */
    "webhook-member-added": {
      /** @enum {string} */
      action: "added";
      changes?: {
        permission?: {
          /** @enum {string} */
          to: "write" | "admin" | "read";
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** User */
      member: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** member edited event */
    "webhook-member-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the collaborator permissions */
      changes: {
        old_permission?: {
          /** @description The previous permissions of the collaborator if the action was edited. */
          from: string;
        };
        permission?: {
          from?: string | null;
          to?: string | null;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** User */
      member: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** member removed event */
    "webhook-member-removed": {
      /** @enum {string} */
      action: "removed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** User */
      member: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** membership added event */
    "webhook-membership-added": {
      /** @enum {string} */
      action: "added";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** User */
      member: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      /**
       * @description The scope of the membership. Currently, can only be `team`.
       * @enum {string}
       */
      scope: "team";
      /** User */
      sender: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /** @enum {string} */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** membership removed event */
    "webhook-membership-removed": {
      /** @enum {string} */
      action: "removed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** User */
      member: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      /**
       * @description The scope of the membership. Currently, can only be `team`.
       * @enum {string}
       */
      scope: "team" | "organization";
      /** User */
      sender: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /** @enum {string} */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    "webhook-merge-group-checks-requested": {
      /** @enum {string} */
      action: "checks_requested";
      installation?: components["schemas"]["simple-installation"];
      /** MergeGroup */
      merge_group: {
        /** @description The SHA of the merge group. */
        head_sha: string;
        /** @description The full ref of the merge group. */
        head_ref: string;
        /** @description The SHA of the merge group's parent commit. */
        base_sha: string;
        /** @description The full ref of the branch the merge group will be merged into. */
        base_ref: string;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
      };
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** meta deleted event */
    "webhook-meta-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      /** @description The modified webhook. This will contain different keys based on the type of webhook it is: repository, organization, business, app, or GitHub Marketplace. */
      hook: {
        active: boolean;
        config: {
          /** @enum {string} */
          content_type: "json" | "form";
          insecure_ssl: string;
          secret?: string;
          /** Format: uri */
          url: string;
        };
        created_at: string;
        events: (
          | "*"
          | "branch_protection_rule"
          | "check_run"
          | "check_suite"
          | "code_scanning_alert"
          | "commit_comment"
          | "create"
          | "delete"
          | "deployment"
          | "deployment_status"
          | "deploy_key"
          | "discussion"
          | "discussion_comment"
          | "fork"
          | "gollum"
          | "issues"
          | "issue_comment"
          | "label"
          | "member"
          | "membership"
          | "meta"
          | "milestone"
          | "organization"
          | "org_block"
          | "package"
          | "page_build"
          | "project"
          | "project_card"
          | "project_column"
          | "public"
          | "pull_request"
          | "pull_request_review"
          | "pull_request_review_comment"
          | "pull_request_review_thread"
          | "push"
          | "registry_package"
          | "release"
          | "repository"
          | "repository_import"
          | "repository_vulnerability_alert"
          | "secret_scanning_alert"
          | "secret_scanning_alert_location"
          | "security_and_analysis"
          | "star"
          | "status"
          | "team"
          | "team_add"
          | "watch"
          | "workflow_job"
          | "workflow_run"
          | "repository_dispatch"
          | "projects_v2_item"
        )[];
        id: number;
        name: string;
        type: string;
        updated_at: string;
      };
      /** @description The id of the modified webhook. */
      hook_id: number;
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["nullable-repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** milestone closed event */
    "webhook-milestone-closed": {
      /** @enum {string} */
      action: "closed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** milestone created event */
    "webhook-milestone-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** milestone deleted event */
    "webhook-milestone-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** milestone edited event */
    "webhook-milestone-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the milestone if the action was `edited`. */
      changes: {
        description?: {
          /** @description The previous version of the description if the action was `edited`. */
          from: string;
        };
        due_on?: {
          /** @description The previous version of the due date if the action was `edited`. */
          from: string;
        };
        title?: {
          /** @description The previous version of the title if the action was `edited`. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** milestone opened event */
    "webhook-milestone-opened": {
      /** @enum {string} */
      action: "opened";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Milestone
       * @description A collection of related issues and pull requests.
       */
      milestone: {
        /** Format: date-time */
        closed_at: string | null;
        closed_issues: number;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        description: string | null;
        /** Format: date-time */
        due_on: string | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        labels_url: string;
        node_id: string;
        /** @description The number of the milestone. */
        number: number;
        open_issues: number;
        /**
         * @description The state of the milestone.
         * @enum {string}
         */
        state: "open" | "closed";
        /** @description The title of the milestone. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** org_block blocked event */
    "webhook-org-block-blocked": {
      /** @enum {string} */
      action: "blocked";
      /** User */
      blocked_user: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** org_block unblocked event */
    "webhook-org-block-unblocked": {
      /** @enum {string} */
      action: "unblocked";
      /** User */
      blocked_user: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** organization deleted event */
    "webhook-organization-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Membership
       * @description The membership between the user and the organization. Not present when the action is `member_invited`.
       */
      membership?: {
        /** Format: uri */
        organization_url: string;
        role: string;
        state: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** organization member_added event */
    "webhook-organization-member-added": {
      /** @enum {string} */
      action: "member_added";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Membership
       * @description The membership between the user and the organization. Not present when the action is `member_invited`.
       */
      membership: {
        /** Format: uri */
        organization_url: string;
        role: string;
        state: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** organization member_invited event */
    "webhook-organization-member-invited": {
      /** @enum {string} */
      action: "member_invited";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The invitation for the user or email if the action is `member_invited`. */
      invitation: {
        /** Format: date-time */
        created_at: string;
        email: string | null;
        /** Format: date-time */
        failed_at: string | null;
        failed_reason: string | null;
        id: number;
        /** Format: uri */
        invitation_teams_url: string;
        /** User */
        inviter: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        login: string | null;
        node_id: string;
        role: string;
        team_count: number;
        invitation_source?: string;
      };
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** User */
      user?: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
    };
    /** organization member_removed event */
    "webhook-organization-member-removed": {
      /** @enum {string} */
      action: "member_removed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Membership
       * @description The membership between the user and the organization. Not present when the action is `member_invited`.
       */
      membership: {
        /** Format: uri */
        organization_url: string;
        role: string;
        state: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** organization renamed event */
    "webhook-organization-renamed": {
      /** @enum {string} */
      action: "renamed";
      changes?: {
        login?: {
          from?: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /**
       * Membership
       * @description The membership between the user and the organization. Not present when the action is `member_invited`.
       */
      membership?: {
        /** Format: uri */
        organization_url: string;
        role: string;
        state: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      organization: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Ruby Gems metadata */
    "webhook-rubygems-metadata": {
      name?: string;
      description?: string;
      readme?: string;
      homepage?: string;
      version_info?: {
        version?: string;
      };
      platform?: string;
      metadata?: {
        [key: string]: string | undefined;
      };
      repo?: string;
      dependencies?: {
        [key: string]: string | undefined;
      }[];
      commit_oid?: string;
    };
    /** package published event */
    "webhook-package-published": {
      /** @enum {string} */
      action: "published";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description Information about the package. */
      package: {
        created_at: string | null;
        description: string | null;
        ecosystem: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        namespace: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        package_type: string;
        package_version: {
          /** User */
          author?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          body?: string | Record<string, never>;
          body_html?: string;
          container_metadata?: {
            labels?: Record<string, unknown> | null;
            manifest?: Record<string, unknown> | null;
            tag?: {
              digest?: string;
              name?: string;
            };
          } | null;
          created_at?: string;
          description: string;
          docker_metadata?: {
            tags?: string[];
          }[];
          draft?: boolean;
          /** Format: uri */
          html_url: string;
          id: number;
          installation_command: string;
          manifest?: string;
          metadata: {
            [key: string]: unknown;
          }[];
          name: string;
          npm_metadata?: {
            name?: string;
            version?: string;
            npm_user?: string;
            author?: Record<string, unknown> | null;
            bugs?: Record<string, unknown> | null;
            dependencies?: Record<string, never>;
            dev_dependencies?: Record<string, never>;
            peer_dependencies?: Record<string, never>;
            optional_dependencies?: Record<string, never>;
            description?: string;
            dist?: Record<string, unknown> | null;
            git_head?: string;
            homepage?: string;
            license?: string;
            main?: string;
            repository?: Record<string, unknown> | null;
            scripts?: Record<string, never>;
            id?: string;
            node_version?: string;
            npm_version?: string;
            has_shrinkwrap?: boolean;
            maintainers?: Record<string, never>[];
            contributors?: Record<string, never>[];
            engines?: Record<string, never>;
            keywords?: string[];
            files?: string[];
            bin?: Record<string, never>;
            man?: Record<string, never>;
            directories?: Record<string, unknown> | null;
            os?: string[];
            cpu?: string[];
            readme?: string;
            installation_command?: string;
            release_id?: number;
            commit_oid?: string;
            published_via_actions?: boolean;
            deleted_by_id?: number;
          } | null;
          nuget_metadata?:
            | {
                id?: number | string;
                name?: string;
                value?: OneOf<
                  [
                    boolean,
                    string,
                    number,
                    {
                      url?: string;
                      branch?: string;
                      commit?: string;
                      type?: string;
                    }
                  ]
                >;
              }[]
            | null;
          package_files: {
            content_type: string;
            created_at: string;
            /** Format: uri */
            download_url: string;
            id: number;
            md5: string | null;
            name: string;
            sha1: string | null;
            sha256: string | null;
            size: number;
            state: string | null;
            updated_at: string;
          }[];
          package_url?: string;
          prerelease?: boolean;
          release?: {
            /** User */
            author: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            created_at: string;
            draft: boolean;
            /** Format: uri */
            html_url: string;
            id: number;
            name: string | null;
            prerelease: boolean;
            published_at: string;
            tag_name: string;
            target_commitish: string;
            /** Format: uri */
            url: string;
          };
          rubygems_metadata?: components["schemas"]["webhook-rubygems-metadata"][];
          source_url?: string;
          summary: string;
          tag_name?: string;
          target_commitish?: string;
          target_oid?: string;
          updated_at?: string;
          version: string;
        } | null;
        registry: {
          /** Format: uri */
          about_url: string;
          name: string;
          type: string;
          /** Format: uri */
          url: string;
          vendor: string;
        } | null;
        updated_at: string | null;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** package updated event */
    "webhook-package-updated": {
      /** @enum {string} */
      action: "updated";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** @description Information about the package. */
      package: {
        created_at: string;
        description: string | null;
        ecosystem: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        namespace: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        package_type: string;
        package_version: {
          /** User */
          author: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          body: string;
          body_html: string;
          created_at: string;
          description: string;
          docker_metadata?: {
            tags?: string[];
          }[];
          draft?: boolean;
          /** Format: uri */
          html_url: string;
          id: number;
          installation_command: string;
          manifest?: string;
          metadata: {
            [key: string]: unknown;
          }[];
          name: string;
          package_files: {
            content_type: string;
            created_at: string;
            /** Format: uri */
            download_url: string;
            id: number;
            md5: string | null;
            name: string;
            sha1: string | null;
            sha256: string;
            size: number;
            state: string;
            updated_at: string;
          }[];
          package_url?: string;
          prerelease?: boolean;
          release?: {
            /** User */
            author: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            created_at: string;
            draft: boolean;
            /** Format: uri */
            html_url: string;
            id: number;
            name: string;
            prerelease: boolean;
            published_at: string;
            tag_name: string;
            target_commitish: string;
            /** Format: uri */
            url: string;
          };
          rubygems_metadata?: components["schemas"]["webhook-rubygems-metadata"][];
          /** Format: uri */
          source_url?: string;
          summary: string;
          tag_name?: string;
          target_commitish: string;
          target_oid: string;
          updated_at: string;
          version: string;
        };
        registry: {
          /** Format: uri */
          about_url: string;
          name: string;
          type: string;
          /** Format: uri */
          url: string;
          vendor: string;
        } | null;
        updated_at: string;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** page_build event */
    "webhook-page-build": {
      /** @description The [List GitHub Pages builds](https://docs.github.com/rest/reference/repos#list-github-pages-builds) itself. */
      build: {
        commit: string | null;
        created_at: string;
        duration: number;
        error: {
          message: string | null;
        };
        /** User */
        pusher: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        status: string;
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      enterprise?: components["schemas"]["enterprise"];
      id: number;
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** personal_access_token_request approved event */
    "webhook-personal-access-token-request-approved": {
      /** @enum {string} */
      action: "approved";
      personal_access_token_request: components["schemas"]["personal-access-token-request"];
      organization: components["schemas"]["organization-simple"];
      sender: components["schemas"]["simple-user"];
      installation: components["schemas"]["simple-installation"];
    };
    /** personal_access_token_request cancelled event */
    "webhook-personal-access-token-request-cancelled": {
      /** @enum {string} */
      action: "cancelled";
      personal_access_token_request: components["schemas"]["personal-access-token-request"];
      organization: components["schemas"]["organization-simple"];
      sender: components["schemas"]["simple-user"];
      installation: components["schemas"]["simple-installation"];
    };
    /** personal_access_token_request created event */
    "webhook-personal-access-token-request-created": {
      /** @enum {string} */
      action: "created";
      personal_access_token_request: components["schemas"]["personal-access-token-request"];
      organization: components["schemas"]["organization-simple"];
      sender: components["schemas"]["simple-user"];
      installation: components["schemas"]["simple-installation"];
    };
    /** personal_access_token_request denied event */
    "webhook-personal-access-token-request-denied": {
      /** @enum {string} */
      action: "denied";
      personal_access_token_request: components["schemas"]["personal-access-token-request"];
      organization: components["schemas"]["organization-simple"];
      sender: components["schemas"]["simple-user"];
      installation: components["schemas"]["simple-installation"];
    };
    "webhook-ping": {
      /**
       * Webhook
       * @description The webhook that is being pinged
       */
      hook?: {
        /** @description Determines whether the hook is actually triggered for the events it subscribes to. */
        active: boolean;
        /** @description Only included for GitHub Apps. When you register a new GitHub App, GitHub sends a ping event to the webhook URL you specified during registration. The GitHub App ID sent in this field is required for authenticating an app. */
        app_id?: number;
        config: {
          content_type?: components["schemas"]["webhook-config-content-type"];
          insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
          secret?: components["schemas"]["webhook-config-secret"];
          url?: components["schemas"]["webhook-config-url"];
        };
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        deliveries_url?: string;
        /** @description Determines what events the hook is triggered for. Default: ['push']. */
        events: string[];
        /** @description Unique identifier of the webhook. */
        id: number;
        last_response?: components["schemas"]["hook-response"];
        /**
         * @description The type of webhook. The only valid value is 'web'.
         * @enum {string}
         */
        name: "web";
        /** Format: uri */
        ping_url?: string;
        /** Format: uri */
        test_url?: string;
        type: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url?: string;
      };
      /** @description The ID of the webhook that triggered the ping. */
      hook_id?: number;
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
      /** @description Random string of GitHub zen. */
      zen?: string;
    };
    /** @description The webhooks ping payload encoded with URL encoding. */
    "webhook-ping-form-encoded": {
      /** @description A URL-encoded string of the ping JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** project_card converted event */
    "webhook-project-card-converted": {
      /** @enum {string} */
      action: "converted";
      changes: {
        note: {
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Card */
      project_card: {
        after_id?: number | null;
        /** @description Whether or not the card is archived */
        archived: boolean;
        column_id: number;
        /** Format: uri */
        column_url: string;
        /** Format: uri */
        content_url?: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** @description The project card's ID */
        id: number;
        node_id: string;
        note: string | null;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project_card created event */
    "webhook-project-card-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Card */
      project_card: {
        after_id?: number | null;
        /** @description Whether or not the card is archived */
        archived: boolean;
        column_id: number;
        /** Format: uri */
        column_url: string;
        /** Format: uri */
        content_url?: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** @description The project card's ID */
        id: number;
        node_id: string;
        note: string | null;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project_card deleted event */
    "webhook-project-card-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Card */
      project_card: {
        after_id?: number | null;
        /** @description Whether or not the card is archived */
        archived: boolean;
        column_id: number | null;
        /** Format: uri */
        column_url: string;
        /** Format: uri */
        content_url?: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /** @description The project card's ID */
        id: number;
        node_id: string;
        note: string | null;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["nullable-repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project_card edited event */
    "webhook-project-card-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        note: {
          from: string | null;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Card */
      project_card: {
        after_id?: number | null;
        /** @description Whether or not the card is archived */
        archived: boolean;
        column_id: number;
        /** Format: uri */
        column_url: string;
        /** Format: uri */
        content_url?: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** @description The project card's ID */
        id: number;
        node_id: string;
        note: string | null;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project_card moved event */
    "webhook-project-card-moved": {
      /** @enum {string} */
      action: "moved";
      changes?: {
        column_id: {
          from: number;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      project_card: {
        after_id?: number | null;
        /** @description Whether or not the card is archived */
        archived: boolean;
        column_id: number;
        /** Format: uri */
        column_url: string;
        /** Format: uri */
        content_url?: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /** @description The project card's ID */
        id: number;
        node_id: string;
        note: string | null;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } & {
        after_id: number | null;
        archived?: boolean;
        column_id?: number;
        column_url?: string;
        created_at?: string;
        creator?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        } | null;
        id?: number;
        node_id?: string;
        note?: string | null;
        project_url?: string;
        updated_at?: string;
        url?: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project closed event */
    "webhook-project-closed": {
      /** @enum {string} */
      action: "closed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project */
      project: {
        /** @description Body of the project */
        body: string | null;
        /** Format: uri */
        columns_url: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Name of the project */
        name: string;
        node_id: string;
        number: number;
        /** Format: uri */
        owner_url: string;
        /**
         * @description State of the project; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project_column created event */
    "webhook-project-column-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Column */
      project_column: {
        after_id?: number | null;
        /** Format: uri */
        cards_url: string;
        /** Format: date-time */
        created_at: string;
        /** @description The unique identifier of the project column */
        id: number;
        /** @description Name of the project column */
        name: string;
        node_id: string;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** project_column deleted event */
    "webhook-project-column-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Column */
      project_column: {
        after_id?: number | null;
        /** Format: uri */
        cards_url: string;
        /** Format: date-time */
        created_at: string;
        /** @description The unique identifier of the project column */
        id: number;
        /** @description Name of the project column */
        name: string;
        node_id: string;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["nullable-repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** project_column edited event */
    "webhook-project-column-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        name?: {
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Column */
      project_column: {
        after_id?: number | null;
        /** Format: uri */
        cards_url: string;
        /** Format: date-time */
        created_at: string;
        /** @description The unique identifier of the project column */
        id: number;
        /** @description Name of the project column */
        name: string;
        node_id: string;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** project_column moved event */
    "webhook-project-column-moved": {
      /** @enum {string} */
      action: "moved";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project Column */
      project_column: {
        after_id?: number | null;
        /** Format: uri */
        cards_url: string;
        /** Format: date-time */
        created_at: string;
        /** @description The unique identifier of the project column */
        id: number;
        /** @description Name of the project column */
        name: string;
        node_id: string;
        /** Format: uri */
        project_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project created event */
    "webhook-project-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project */
      project: {
        /** @description Body of the project */
        body: string | null;
        /** Format: uri */
        columns_url: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Name of the project */
        name: string;
        node_id: string;
        number: number;
        /** Format: uri */
        owner_url: string;
        /**
         * @description State of the project; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** project deleted event */
    "webhook-project-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project */
      project: {
        /** @description Body of the project */
        body: string | null;
        /** Format: uri */
        columns_url: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Name of the project */
        name: string;
        node_id: string;
        number: number;
        /** Format: uri */
        owner_url: string;
        /**
         * @description State of the project; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["nullable-repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** project edited event */
    "webhook-project-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the project if the action was `edited`. */
      changes?: {
        body?: {
          /** @description The previous version of the body if the action was `edited`. */
          from: string;
        };
        name?: {
          /** @description The changes to the project if the action was `edited`. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project */
      project: {
        /** @description Body of the project */
        body: string | null;
        /** Format: uri */
        columns_url: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Name of the project */
        name: string;
        node_id: string;
        number: number;
        /** Format: uri */
        owner_url: string;
        /**
         * @description State of the project; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** project reopened event */
    "webhook-project-reopened": {
      /** @enum {string} */
      action: "reopened";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Project */
      project: {
        /** @description Body of the project */
        body: string | null;
        /** Format: uri */
        columns_url: string;
        /** Format: date-time */
        created_at: string;
        /** User */
        creator: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Name of the project */
        name: string;
        node_id: string;
        number: number;
        /** Format: uri */
        owner_url: string;
        /**
         * @description State of the project; either 'open' or 'closed'
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Project Closed Event */
    "webhook-projects-v2-project-closed": {
      /** @enum {string} */
      action: "closed";
      organization: components["schemas"]["organization-simple"];
      projects_v2: components["schemas"]["projects-v2"];
      sender: components["schemas"]["simple-user"];
    };
    /** @description A project was created */
    "webhook-projects-v2-project-created": {
      /** @enum {string} */
      action: "created";
      organization: components["schemas"]["organization-simple"];
      projects_v2: components["schemas"]["projects-v2"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Project Deleted Event */
    "webhook-projects-v2-project-deleted": {
      /** @enum {string} */
      action: "deleted";
      organization: components["schemas"]["organization-simple"];
      projects_v2: components["schemas"]["projects-v2"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Project Edited Event */
    "webhook-projects-v2-project-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        description?: {
          from?: string | null;
          to?: string | null;
        };
        public?: {
          from?: boolean;
          to?: boolean;
        };
        short_description?: {
          from?: string | null;
          to?: string | null;
        };
        title?: {
          from?: string;
          to?: string;
        };
      };
      organization: components["schemas"]["organization-simple"];
      projects_v2: components["schemas"]["projects-v2"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Archived Event */
    "webhook-projects-v2-item-archived": {
      /** @enum {string} */
      action: "archived";
      changes: {
        archived_at?: {
          /** Format: date-time */
          from?: string | null;
          /** Format: date-time */
          to?: string | null;
        };
      };
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Converted Event */
    "webhook-projects-v2-item-converted": {
      /** @enum {string} */
      action: "converted";
      changes: {
        content_type?: {
          from?: string | null;
          to?: string;
        };
      };
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Created Event */
    "webhook-projects-v2-item-created": {
      /** @enum {string} */
      action: "created";
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Deleted Event */
    "webhook-projects-v2-item-deleted": {
      /** @enum {string} */
      action: "deleted";
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Edited Event */
    "webhook-projects-v2-item-edited": {
      /** @enum {string} */
      action: "edited";
      changes?: OneOf<
        [
          {
            field_value: {
              field_node_id?: string;
              field_type?: string;
            };
          },
          {
            body: {
              from?: string | null;
              to?: string | null;
            };
          }
        ]
      >;
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Reordered Event */
    "webhook-projects-v2-item-reordered": {
      /** @enum {string} */
      action: "reordered";
      changes: {
        previous_projects_v2_item_node_id?: {
          from?: string | null;
          to?: string | null;
        };
      };
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Item Restored Event */
    "webhook-projects-v2-item-restored": {
      /** @enum {string} */
      action: "restored";
      changes: {
        archived_at?: {
          /** Format: date-time */
          from?: string | null;
          /** Format: date-time */
          to?: string | null;
        };
      };
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      projects_v2_item: components["schemas"]["projects-v2-item"];
      sender: components["schemas"]["simple-user"];
    };
    /** Projects v2 Project Reopened Event */
    "webhook-projects-v2-project-reopened": {
      /** @enum {string} */
      action: "reopened";
      organization: components["schemas"]["organization-simple"];
      projects_v2: components["schemas"]["projects-v2"];
      sender: components["schemas"]["simple-user"];
    };
    /** public event */
    "webhook-public": {
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request assigned event */
    "webhook-pull-request-assigned": {
      /** @enum {string} */
      action: "assigned";
      /** User */
      assignee: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request auto_merge_disabled event */
    "webhook-pull-request-auto-merge-disabled": {
      /** @enum {string} */
      action: "auto_merge_disabled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      reason: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request auto_merge_enabled event */
    "webhook-pull-request-auto-merge-enabled": {
      /** @enum {string} */
      action: "auto_merge_enabled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      reason?: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request closed event */
    "webhook-pull-request-closed": {
      /** @enum {string} */
      action: "closed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., "Merge pull request #123 from branch-name").
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.**
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request converted_to_draft event */
    "webhook-pull-request-converted-to-draft": {
      /** @enum {string} */
      action: "converted_to_draft";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., "Merge pull request #123 from branch-name").
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.**
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request demilestoned event */
    "webhook-pull-request-demilestoned": {
      /** @enum {string} */
      action: "demilestoned";
      enterprise?: components["schemas"]["enterprise"];
      milestone?: components["schemas"]["milestone"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** pull_request dequeued event */
    "webhook-pull-request-dequeued": {
      /** @enum {string} */
      action: "dequeued";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      reason: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request edited event */
    "webhook-pull-request-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the comment if the action was `edited`. */
      changes: {
        base?: {
          ref: {
            from: string;
          };
          sha: {
            from: string;
          };
        };
        body?: {
          /** @description The previous version of the body if the action was `edited`. */
          from: string;
        };
        title?: {
          /** @description The previous version of the title if the action was `edited`. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., "Merge pull request #123 from branch-name").
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** pull_request enqueued event */
    "webhook-pull-request-enqueued": {
      /** @enum {string} */
      action: "enqueued";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request labeled event */
    "webhook-pull-request-labeled": {
      /** @enum {string} */
      action: "labeled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label?: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request locked event */
    "webhook-pull-request-locked": {
      /** @enum {string} */
      action: "locked";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request milestoned event */
    "webhook-pull-request-milestoned": {
      /** @enum {string} */
      action: "milestoned";
      enterprise?: components["schemas"]["enterprise"];
      milestone?: components["schemas"]["milestone"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** pull_request opened event */
    "webhook-pull-request-opened": {
      /** @enum {string} */
      action: "opened";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.**
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request ready_for_review event */
    "webhook-pull-request-ready-for-review": {
      /** @enum {string} */
      action: "ready_for_review";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., "Merge pull request #123 from branch-name").
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.**
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request reopened event */
    "webhook-pull-request-reopened": {
      /** @enum {string} */
      action: "reopened";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      pull_request: components["schemas"]["pull-request"] & {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow updating the pull request's branch. */
        allow_update_branch?: boolean;
        /**
         * @description Whether to delete head branches when pull requests are merged.
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /**
         * @description The default value for a merge commit message.
         * - `PR_TITLE` - default to the pull request's title.
         * - `PR_BODY` - default to the pull request's body.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        /**
         * @description The default value for a merge commit title.
         * - `PR_TITLE` - default to the pull request's title.
         * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., "Merge pull request #123 from branch-name").
         * @enum {string}
         */
        merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
        /**
         * @description The default value for a squash merge commit message:
         * - `PR_BODY` - default to the pull request's body.
         * - `COMMIT_MESSAGES` - default to the branch's commit messages.
         * - `BLANK` - default to a blank commit message.
         * @enum {string}
         */
        squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
        /**
         * @description The default value for a squash merge commit title:
         * - `PR_TITLE` - default to the pull request's title.
         * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
         * @enum {string}
         */
        squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
        /**
         * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.**
         * @default false
         */
        use_squash_pr_title_as_default?: boolean;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review_comment created event */
    "webhook-pull-request-review-comment-created": {
      /** @enum {string} */
      action: "created";
      /**
       * Pull Request Review Comment
       * @description The [comment](https://docs.github.com/rest/reference/pulls#comments) itself.
       */
      comment: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the comment. */
        body: string;
        /** @description The SHA of the commit to which the comment applies. */
        commit_id: string;
        /** Format: date-time */
        created_at: string;
        /** @description The diff of the line that the comment refers to. */
        diff_hunk: string;
        /**
         * Format: uri
         * @description HTML URL for the pull request review comment.
         */
        html_url: string;
        /** @description The ID of the pull request review comment. */
        id: number;
        /** @description The comment ID to reply to. */
        in_reply_to_id?: number;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        line: number | null;
        /** @description The node ID of the pull request review comment. */
        node_id: string;
        /** @description The SHA of the original commit to which the comment applies. */
        original_commit_id: string;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        original_line: number | null;
        /** @description The index of the original line in the diff to which the comment applies. */
        original_position: number;
        /** @description The first line of the range for a multi-line comment. */
        original_start_line: number | null;
        /** @description The relative path of the file to which the comment applies. */
        path: string;
        /** @description The line index in the diff to which the comment applies. */
        position: number | null;
        /** @description The ID of the pull request review to which the comment belongs. */
        pull_request_review_id: number | null;
        /**
         * Format: uri
         * @description URL for the pull request that the review comment belongs to.
         */
        pull_request_url: string;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @enum {string}
         */
        side: "LEFT" | "RIGHT";
        /** @description The first line of the range for a multi-line comment. */
        start_line: number | null;
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @default RIGHT
         * @enum {string|null}
         */
        start_side: "LEFT" | "RIGHT" | "" | null;
        /**
         * @description The level at which the comment is targeted, can be a diff line or a file.
         * @enum {string}
         */
        subject_type?: "line" | "file";
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the pull request review comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge?: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft?: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions?: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review_comment deleted event */
    "webhook-pull-request-review-comment-deleted": {
      /** @enum {string} */
      action: "deleted";
      /**
       * Pull Request Review Comment
       * @description The [comment](https://docs.github.com/rest/reference/pulls#comments) itself.
       */
      comment: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the comment. */
        body: string;
        /** @description The SHA of the commit to which the comment applies. */
        commit_id: string;
        /** Format: date-time */
        created_at: string;
        /** @description The diff of the line that the comment refers to. */
        diff_hunk: string;
        /**
         * Format: uri
         * @description HTML URL for the pull request review comment.
         */
        html_url: string;
        /** @description The ID of the pull request review comment. */
        id: number;
        /** @description The comment ID to reply to. */
        in_reply_to_id?: number;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        line: number | null;
        /** @description The node ID of the pull request review comment. */
        node_id: string;
        /** @description The SHA of the original commit to which the comment applies. */
        original_commit_id: string;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        original_line: number;
        /** @description The index of the original line in the diff to which the comment applies. */
        original_position: number;
        /** @description The first line of the range for a multi-line comment. */
        original_start_line: number | null;
        /** @description The relative path of the file to which the comment applies. */
        path: string;
        /** @description The line index in the diff to which the comment applies. */
        position: number | null;
        /** @description The ID of the pull request review to which the comment belongs. */
        pull_request_review_id: number | null;
        /**
         * Format: uri
         * @description URL for the pull request that the review comment belongs to.
         */
        pull_request_url: string;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @enum {string}
         */
        side: "LEFT" | "RIGHT";
        /** @description The first line of the range for a multi-line comment. */
        start_line: number | null;
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @default RIGHT
         * @enum {string|null}
         */
        start_side: "LEFT" | "RIGHT" | "" | null;
        /**
         * @description The level at which the comment is targeted, can be a diff line or a file.
         * @enum {string}
         */
        subject_type?: "line" | "file";
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the pull request review comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge?: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft?: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review_comment edited event */
    "webhook-pull-request-review-comment-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the comment. */
      changes: {
        body?: {
          /** @description The previous version of the body. */
          from: string;
        };
      };
      /**
       * Pull Request Review Comment
       * @description The [comment](https://docs.github.com/rest/reference/pulls#comments) itself.
       */
      comment: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the comment. */
        body: string;
        /** @description The SHA of the commit to which the comment applies. */
        commit_id: string;
        /** Format: date-time */
        created_at: string;
        /** @description The diff of the line that the comment refers to. */
        diff_hunk: string;
        /**
         * Format: uri
         * @description HTML URL for the pull request review comment.
         */
        html_url: string;
        /** @description The ID of the pull request review comment. */
        id: number;
        /** @description The comment ID to reply to. */
        in_reply_to_id?: number;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        line: number | null;
        /** @description The node ID of the pull request review comment. */
        node_id: string;
        /** @description The SHA of the original commit to which the comment applies. */
        original_commit_id: string;
        /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
        original_line: number;
        /** @description The index of the original line in the diff to which the comment applies. */
        original_position: number;
        /** @description The first line of the range for a multi-line comment. */
        original_start_line: number | null;
        /** @description The relative path of the file to which the comment applies. */
        path: string;
        /** @description The line index in the diff to which the comment applies. */
        position: number | null;
        /** @description The ID of the pull request review to which the comment belongs. */
        pull_request_review_id: number | null;
        /**
         * Format: uri
         * @description URL for the pull request that the review comment belongs to.
         */
        pull_request_url: string;
        /** Reactions */
        reactions: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @enum {string}
         */
        side: "LEFT" | "RIGHT";
        /** @description The first line of the range for a multi-line comment. */
        start_line: number | null;
        /**
         * @description The side of the first line of the range for a multi-line comment.
         * @default RIGHT
         * @enum {string|null}
         */
        start_side: "LEFT" | "RIGHT" | "" | null;
        /**
         * @description The level at which the comment is targeted, can be a diff line or a file.
         * @enum {string}
         */
        subject_type?: "line" | "file";
        /** Format: date-time */
        updated_at: string;
        /**
         * Format: uri
         * @description URL for the pull request review comment
         */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge?: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft?: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review dismissed event */
    "webhook-pull-request-review-dismissed": {
      /** @enum {string} */
      action: "dismissed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Simple Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      /** @description The review that was affected. */
      review: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the review. */
        body: string | null;
        /** @description A commit SHA for the review. */
        commit_id: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the review */
        id: number;
        node_id: string;
        /** Format: uri */
        pull_request_url: string;
        /** @enum {string} */
        state: "dismissed" | "approved" | "changes_requested";
        /** Format: date-time */
        submitted_at: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review edited event */
    "webhook-pull-request-review-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        body?: {
          /** @description The previous version of the body if the action was `edited`. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Simple Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      /** @description The review that was affected. */
      review: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the review. */
        body: string | null;
        /** @description A commit SHA for the review. */
        commit_id: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the review */
        id: number;
        node_id: string;
        /** Format: uri */
        pull_request_url: string;
        state: string;
        /** Format: date-time */
        submitted_at: string | null;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request review_request_removed event */
    "webhook-pull-request-review-request-removed": OneOf<
      [
        {
          /** @enum {string} */
          action: "review_request_removed";
          enterprise?: components["schemas"]["enterprise"];
          installation?: components["schemas"]["simple-installation"];
          /** @description The pull request number. */
          number: number;
          organization?: components["schemas"]["organization-simple"];
          /** Pull Request */
          pull_request: {
            _links: {
              /** Link */
              comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              commits: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              html: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              issue: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comment: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              self: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              statuses: {
                /** Format: uri-template */
                href: string;
              };
            };
            /** @enum {string|null} */
            active_lock_reason:
              | "resolved"
              | "off-topic"
              | "too heated"
              | "spam"
              | ""
              | null;
            additions?: number;
            /** User */
            assignee: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            assignees: ({
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null)[];
            /**
             * AuthorAssociation
             * @description How the author is associated with the repository.
             * @enum {string}
             */
            author_association:
              | "COLLABORATOR"
              | "CONTRIBUTOR"
              | "FIRST_TIMER"
              | "FIRST_TIME_CONTRIBUTOR"
              | "MANNEQUIN"
              | "MEMBER"
              | "NONE"
              | "OWNER";
            /**
             * PullRequestAutoMerge
             * @description The status of auto merging a pull request.
             */
            auto_merge: {
              /** @description Commit message for the merge commit. */
              commit_message: string | null;
              /** @description Title for the merge commit message. */
              commit_title: string | null;
              /** User */
              enabled_by: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              /**
               * @description The merge method to use.
               * @enum {string}
               */
              merge_method: "merge" | "squash" | "rebase";
            } | null;
            base: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title.
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            body: string | null;
            changed_files?: number;
            /** Format: date-time */
            closed_at: string | null;
            comments?: number;
            /** Format: uri */
            comments_url: string;
            commits?: number;
            /** Format: uri */
            commits_url: string;
            /** Format: date-time */
            created_at: string;
            deletions?: number;
            /** Format: uri */
            diff_url: string;
            /** @description Indicates whether or not the pull request is a draft. */
            draft: boolean;
            head: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            issue_url: string;
            labels: {
              /** @description 6-character hex code, without the leading #, identifying the color */
              color: string;
              default: boolean;
              description: string | null;
              id: number;
              /** @description The name of the label. */
              name: string;
              node_id: string;
              /**
               * Format: uri
               * @description URL for the label
               */
              url: string;
            }[];
            locked: boolean;
            /** @description Indicates whether maintainers can modify the pull request. */
            maintainer_can_modify?: boolean;
            merge_commit_sha: string | null;
            mergeable?: boolean | null;
            mergeable_state?: string;
            merged?: boolean | null;
            /** Format: date-time */
            merged_at: string | null;
            /** User */
            merged_by?: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /**
             * Milestone
             * @description A collection of related issues and pull requests.
             */
            milestone: {
              /** Format: date-time */
              closed_at: string | null;
              closed_issues: number;
              /** Format: date-time */
              created_at: string;
              /** User */
              creator: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              description: string | null;
              /** Format: date-time */
              due_on: string | null;
              /** Format: uri */
              html_url: string;
              id: number;
              /** Format: uri */
              labels_url: string;
              node_id: string;
              /** @description The number of the milestone. */
              number: number;
              open_issues: number;
              /**
               * @description The state of the milestone.
               * @enum {string}
               */
              state: "open" | "closed";
              /** @description The title of the milestone. */
              title: string;
              /** Format: date-time */
              updated_at: string;
              /** Format: uri */
              url: string;
            } | null;
            node_id: string;
            /** @description Number uniquely identifying the pull request within its repository. */
            number: number;
            /** Format: uri */
            patch_url: string;
            rebaseable?: boolean | null;
            requested_reviewers: OneOf<
              [
                {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null,
                {
                  deleted?: boolean;
                  /** @description Description of the team */
                  description: string | null;
                  /** Format: uri */
                  html_url: string;
                  /** @description Unique identifier of the team */
                  id: number;
                  /** Format: uri-template */
                  members_url: string;
                  /** @description Name of the team */
                  name: string;
                  node_id: string;
                  parent?: {
                    /** @description Description of the team */
                    description: string | null;
                    /** Format: uri */
                    html_url: string;
                    /** @description Unique identifier of the team */
                    id: number;
                    /** Format: uri-template */
                    members_url: string;
                    /** @description Name of the team */
                    name: string;
                    node_id: string;
                    /** @description Permission that the team will have for its repositories */
                    permission: string;
                    /** @enum {string} */
                    privacy: "open" | "closed" | "secret";
                    /** Format: uri */
                    repositories_url: string;
                    slug: string;
                    /**
                     * Format: uri
                     * @description URL for the team
                     */
                    url: string;
                  } | null;
                  /** @description Permission that the team will have for its repositories */
                  permission: string;
                  /** @enum {string} */
                  privacy: "open" | "closed" | "secret";
                  /** Format: uri */
                  repositories_url: string;
                  slug: string;
                  /**
                   * Format: uri
                   * @description URL for the team
                   */
                  url: string;
                }
              ]
            >[];
            requested_teams: {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }[];
            /** Format: uri-template */
            review_comment_url: string;
            review_comments?: number;
            /** Format: uri */
            review_comments_url: string;
            /**
             * @description State of this Pull Request. Either `open` or `closed`.
             * @enum {string}
             */
            state: "open" | "closed";
            /** Format: uri */
            statuses_url: string;
            /** @description The title of the pull request. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** User */
            user: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
          };
          repository: components["schemas"]["repository"];
          /** User */
          requested_reviewer: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          sender: components["schemas"]["simple-user"];
        },
        {
          /** @enum {string} */
          action: "review_request_removed";
          enterprise?: components["schemas"]["enterprise"];
          installation?: components["schemas"]["simple-installation"];
          /** @description The pull request number. */
          number: number;
          organization?: components["schemas"]["organization-simple"];
          /** Pull Request */
          pull_request: {
            _links: {
              /** Link */
              comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              commits: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              html: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              issue: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comment: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              self: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              statuses: {
                /** Format: uri-template */
                href: string;
              };
            };
            /** @enum {string|null} */
            active_lock_reason:
              | "resolved"
              | "off-topic"
              | "too heated"
              | "spam"
              | ""
              | null;
            additions?: number;
            /** User */
            assignee: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            assignees: ({
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null)[];
            /**
             * AuthorAssociation
             * @description How the author is associated with the repository.
             * @enum {string}
             */
            author_association:
              | "COLLABORATOR"
              | "CONTRIBUTOR"
              | "FIRST_TIMER"
              | "FIRST_TIME_CONTRIBUTOR"
              | "MANNEQUIN"
              | "MEMBER"
              | "NONE"
              | "OWNER";
            /**
             * PullRequestAutoMerge
             * @description The status of auto merging a pull request.
             */
            auto_merge: {
              /** @description Commit message for the merge commit. */
              commit_message: string | null;
              /** @description Title for the merge commit message. */
              commit_title: string | null;
              /** User */
              enabled_by: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              /**
               * @description The merge method to use.
               * @enum {string}
               */
              merge_method: "merge" | "squash" | "rebase";
            } | null;
            base: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            body: string | null;
            changed_files?: number;
            /** Format: date-time */
            closed_at: string | null;
            comments?: number;
            /** Format: uri */
            comments_url: string;
            commits?: number;
            /** Format: uri */
            commits_url: string;
            /** Format: date-time */
            created_at: string;
            deletions?: number;
            /** Format: uri */
            diff_url: string;
            /** @description Indicates whether or not the pull request is a draft. */
            draft: boolean;
            head: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            issue_url: string;
            labels: {
              /** @description 6-character hex code, without the leading #, identifying the color */
              color: string;
              default: boolean;
              description: string | null;
              id: number;
              /** @description The name of the label. */
              name: string;
              node_id: string;
              /**
               * Format: uri
               * @description URL for the label
               */
              url: string;
            }[];
            locked: boolean;
            /** @description Indicates whether maintainers can modify the pull request. */
            maintainer_can_modify?: boolean;
            merge_commit_sha: string | null;
            mergeable?: boolean | null;
            mergeable_state?: string;
            merged?: boolean | null;
            /** Format: date-time */
            merged_at: string | null;
            /** User */
            merged_by?: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /**
             * Milestone
             * @description A collection of related issues and pull requests.
             */
            milestone: {
              /** Format: date-time */
              closed_at: string | null;
              closed_issues: number;
              /** Format: date-time */
              created_at: string;
              /** User */
              creator: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              description: string | null;
              /** Format: date-time */
              due_on: string | null;
              /** Format: uri */
              html_url: string;
              id: number;
              /** Format: uri */
              labels_url: string;
              node_id: string;
              /** @description The number of the milestone. */
              number: number;
              open_issues: number;
              /**
               * @description The state of the milestone.
               * @enum {string}
               */
              state: "open" | "closed";
              /** @description The title of the milestone. */
              title: string;
              /** Format: date-time */
              updated_at: string;
              /** Format: uri */
              url: string;
            } | null;
            node_id: string;
            /** @description Number uniquely identifying the pull request within its repository. */
            number: number;
            /** Format: uri */
            patch_url: string;
            rebaseable?: boolean | null;
            requested_reviewers: OneOf<
              [
                {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null,
                {
                  deleted?: boolean;
                  /** @description Description of the team */
                  description: string | null;
                  /** Format: uri */
                  html_url: string;
                  /** @description Unique identifier of the team */
                  id: number;
                  /** Format: uri-template */
                  members_url: string;
                  /** @description Name of the team */
                  name: string;
                  node_id: string;
                  parent?: {
                    /** @description Description of the team */
                    description: string | null;
                    /** Format: uri */
                    html_url: string;
                    /** @description Unique identifier of the team */
                    id: number;
                    /** Format: uri-template */
                    members_url: string;
                    /** @description Name of the team */
                    name: string;
                    node_id: string;
                    /** @description Permission that the team will have for its repositories */
                    permission: string;
                    /** @enum {string} */
                    privacy: "open" | "closed" | "secret";
                    /** Format: uri */
                    repositories_url: string;
                    slug: string;
                    /**
                     * Format: uri
                     * @description URL for the team
                     */
                    url: string;
                  } | null;
                  /** @description Permission that the team will have for its repositories */
                  permission: string;
                  /** @enum {string} */
                  privacy: "open" | "closed" | "secret";
                  /** Format: uri */
                  repositories_url: string;
                  slug: string;
                  /**
                   * Format: uri
                   * @description URL for the team
                   */
                  url: string;
                }
              ]
            >[];
            requested_teams: {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }[];
            /** Format: uri-template */
            review_comment_url: string;
            review_comments?: number;
            /** Format: uri */
            review_comments_url: string;
            /**
             * @description State of this Pull Request. Either `open` or `closed`.
             * @enum {string}
             */
            state: "open" | "closed";
            /** Format: uri */
            statuses_url: string;
            /** @description The title of the pull request. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** User */
            user: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
          };
          repository: components["schemas"]["repository"];
          /**
           * Team
           * @description Groups of organization members that gives permissions on specified repositories.
           */
          requested_team: {
            deleted?: boolean;
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            parent?: {
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            } | null;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          };
          sender: components["schemas"]["simple-user"];
        }
      ]
    >;
    /** pull_request review_requested event */
    "webhook-pull-request-review-requested": OneOf<
      [
        {
          /** @enum {string} */
          action: "review_requested";
          enterprise?: components["schemas"]["enterprise"];
          installation?: components["schemas"]["simple-installation"];
          /** @description The pull request number. */
          number: number;
          organization?: components["schemas"]["organization-simple"];
          /** Pull Request */
          pull_request: {
            _links: {
              /** Link */
              comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              commits: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              html: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              issue: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comment: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              self: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              statuses: {
                /** Format: uri-template */
                href: string;
              };
            };
            /** @enum {string|null} */
            active_lock_reason:
              | "resolved"
              | "off-topic"
              | "too heated"
              | "spam"
              | ""
              | null;
            additions?: number;
            /** User */
            assignee: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null;
            assignees: ({
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null)[];
            /**
             * AuthorAssociation
             * @description How the author is associated with the repository.
             * @enum {string}
             */
            author_association:
              | "COLLABORATOR"
              | "CONTRIBUTOR"
              | "FIRST_TIMER"
              | "FIRST_TIME_CONTRIBUTOR"
              | "MANNEQUIN"
              | "MEMBER"
              | "NONE"
              | "OWNER";
            /**
             * PullRequestAutoMerge
             * @description The status of auto merging a pull request.
             */
            auto_merge: {
              /** @description Commit message for the merge commit. */
              commit_message: string | null;
              /** @description Title for the merge commit message. */
              commit_title: string | null;
              /** User */
              enabled_by: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              /**
               * @description The merge method to use.
               * @enum {string}
               */
              merge_method: "merge" | "squash" | "rebase";
            } | null;
            base: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            body: string | null;
            changed_files?: number;
            /** Format: date-time */
            closed_at: string | null;
            comments?: number;
            /** Format: uri */
            comments_url: string;
            commits?: number;
            /** Format: uri */
            commits_url: string;
            /** Format: date-time */
            created_at: string;
            deletions?: number;
            /** Format: uri */
            diff_url: string;
            /** @description Indicates whether or not the pull request is a draft. */
            draft: boolean;
            head: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            issue_url: string;
            labels: {
              /** @description 6-character hex code, without the leading #, identifying the color */
              color: string;
              default: boolean;
              description: string | null;
              id: number;
              /** @description The name of the label. */
              name: string;
              node_id: string;
              /**
               * Format: uri
               * @description URL for the label
               */
              url: string;
            }[];
            locked: boolean;
            /** @description Indicates whether maintainers can modify the pull request. */
            maintainer_can_modify?: boolean;
            merge_commit_sha: string | null;
            mergeable?: boolean | null;
            mergeable_state?: string;
            merged?: boolean | null;
            /** Format: date-time */
            merged_at: string | null;
            /** User */
            merged_by?: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /**
             * Milestone
             * @description A collection of related issues and pull requests.
             */
            milestone: {
              /** Format: date-time */
              closed_at: string | null;
              closed_issues: number;
              /** Format: date-time */
              created_at: string;
              /** User */
              creator: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization" | "Mannequin";
                /** Format: uri */
                url?: string;
              } | null;
              description: string | null;
              /** Format: date-time */
              due_on: string | null;
              /** Format: uri */
              html_url: string;
              id: number;
              /** Format: uri */
              labels_url: string;
              node_id: string;
              /** @description The number of the milestone. */
              number: number;
              open_issues: number;
              /**
               * @description The state of the milestone.
               * @enum {string}
               */
              state: "open" | "closed";
              /** @description The title of the milestone. */
              title: string;
              /** Format: date-time */
              updated_at: string;
              /** Format: uri */
              url: string;
            } | null;
            node_id: string;
            /** @description Number uniquely identifying the pull request within its repository. */
            number: number;
            /** Format: uri */
            patch_url: string;
            rebaseable?: boolean | null;
            requested_reviewers: OneOf<
              [
                {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null,
                {
                  deleted?: boolean;
                  /** @description Description of the team */
                  description: string | null;
                  /** Format: uri */
                  html_url: string;
                  /** @description Unique identifier of the team */
                  id: number;
                  /** Format: uri-template */
                  members_url: string;
                  /** @description Name of the team */
                  name: string;
                  node_id: string;
                  parent?: {
                    /** @description Description of the team */
                    description: string | null;
                    /** Format: uri */
                    html_url: string;
                    /** @description Unique identifier of the team */
                    id: number;
                    /** Format: uri-template */
                    members_url: string;
                    /** @description Name of the team */
                    name: string;
                    node_id: string;
                    /** @description Permission that the team will have for its repositories */
                    permission: string;
                    /** @enum {string} */
                    privacy: "open" | "closed" | "secret";
                    /** Format: uri */
                    repositories_url: string;
                    slug: string;
                    /**
                     * Format: uri
                     * @description URL for the team
                     */
                    url: string;
                  } | null;
                  /** @description Permission that the team will have for its repositories */
                  permission: string;
                  /** @enum {string} */
                  privacy: "open" | "closed" | "secret";
                  /** Format: uri */
                  repositories_url: string;
                  slug: string;
                  /**
                   * Format: uri
                   * @description URL for the team
                   */
                  url: string;
                }
              ]
            >[];
            requested_teams: {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }[];
            /** Format: uri-template */
            review_comment_url: string;
            review_comments?: number;
            /** Format: uri */
            review_comments_url: string;
            /**
             * @description State of this Pull Request. Either `open` or `closed`.
             * @enum {string}
             */
            state: "open" | "closed";
            /** Format: uri */
            statuses_url: string;
            /** @description The title of the pull request. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** User */
            user: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null;
          };
          repository: components["schemas"]["repository"];
          /** User */
          requested_reviewer: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          sender: components["schemas"]["simple-user"];
        },
        {
          /** @enum {string} */
          action: "review_requested";
          enterprise?: components["schemas"]["enterprise"];
          installation?: components["schemas"]["simple-installation"];
          /** @description The pull request number. */
          number: number;
          organization?: components["schemas"]["organization-simple"];
          /** Pull Request */
          pull_request: {
            _links: {
              /** Link */
              comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              commits: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              html: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              issue: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comment: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              review_comments: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              self: {
                /** Format: uri-template */
                href: string;
              };
              /** Link */
              statuses: {
                /** Format: uri-template */
                href: string;
              };
            };
            /** @enum {string|null} */
            active_lock_reason:
              | "resolved"
              | "off-topic"
              | "too heated"
              | "spam"
              | ""
              | null;
            additions?: number;
            /** User */
            assignee: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null;
            assignees: ({
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null)[];
            /**
             * AuthorAssociation
             * @description How the author is associated with the repository.
             * @enum {string}
             */
            author_association:
              | "COLLABORATOR"
              | "CONTRIBUTOR"
              | "FIRST_TIMER"
              | "FIRST_TIME_CONTRIBUTOR"
              | "MANNEQUIN"
              | "MEMBER"
              | "NONE"
              | "OWNER";
            /**
             * PullRequestAutoMerge
             * @description The status of auto merging a pull request.
             */
            auto_merge: {
              /** @description Commit message for the merge commit. */
              commit_message: string | null;
              /** @description Title for the merge commit message. */
              commit_title: string | null;
              /** User */
              enabled_by: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
              /**
               * @description The merge method to use.
               * @enum {string}
               */
              merge_method: "merge" | "squash" | "rebase";
            } | null;
            base: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            body: string | null;
            changed_files?: number;
            /** Format: date-time */
            closed_at: string | null;
            comments?: number;
            /** Format: uri */
            comments_url: string;
            commits?: number;
            /** Format: uri */
            commits_url: string;
            /** Format: date-time */
            created_at: string;
            deletions?: number;
            /** Format: uri */
            diff_url: string;
            /** @description Indicates whether or not the pull request is a draft. */
            draft: boolean;
            head: {
              label: string;
              ref: string;
              /**
               * Repository
               * @description A git repository
               */
              repo: {
                /**
                 * @description Whether to allow auto-merge for pull requests.
                 * @default false
                 */
                allow_auto_merge?: boolean;
                /** @description Whether to allow private forks */
                allow_forking?: boolean;
                /**
                 * @description Whether to allow merge commits for pull requests.
                 * @default true
                 */
                allow_merge_commit?: boolean;
                /**
                 * @description Whether to allow rebase merges for pull requests.
                 * @default true
                 */
                allow_rebase_merge?: boolean;
                /**
                 * @description Whether to allow squash merges for pull requests.
                 * @default true
                 */
                allow_squash_merge?: boolean;
                allow_update_branch?: boolean;
                /** Format: uri-template */
                archive_url: string;
                /**
                 * @description Whether the repository is archived.
                 * @default false
                 */
                archived: boolean;
                /** Format: uri-template */
                assignees_url: string;
                /** Format: uri-template */
                blobs_url: string;
                /** Format: uri-template */
                branches_url: string;
                /** Format: uri */
                clone_url: string;
                /** Format: uri-template */
                collaborators_url: string;
                /** Format: uri-template */
                comments_url: string;
                /** Format: uri-template */
                commits_url: string;
                /** Format: uri-template */
                compare_url: string;
                /** Format: uri-template */
                contents_url: string;
                /** Format: uri */
                contributors_url: string;
                created_at: number | string;
                /** @description The default branch of the repository. */
                default_branch: string;
                /**
                 * @description Whether to delete head branches when pull requests are merged
                 * @default false
                 */
                delete_branch_on_merge?: boolean;
                /** Format: uri */
                deployments_url: string;
                description: string | null;
                /** @description Returns whether or not this repository is disabled. */
                disabled?: boolean;
                /** Format: uri */
                downloads_url: string;
                /** Format: uri */
                events_url: string;
                fork: boolean;
                forks: number;
                forks_count: number;
                /** Format: uri */
                forks_url: string;
                full_name: string;
                /** Format: uri-template */
                git_commits_url: string;
                /** Format: uri-template */
                git_refs_url: string;
                /** Format: uri-template */
                git_tags_url: string;
                /** Format: uri */
                git_url: string;
                /**
                 * @description Whether downloads are enabled.
                 * @default true
                 */
                has_downloads: boolean;
                /**
                 * @description Whether issues are enabled.
                 * @default true
                 */
                has_issues: boolean;
                has_pages: boolean;
                /**
                 * @description Whether projects are enabled.
                 * @default true
                 */
                has_projects: boolean;
                /**
                 * @description Whether the wiki is enabled.
                 * @default true
                 */
                has_wiki: boolean;
                /**
                 * @description Whether discussions are enabled.
                 * @default false
                 */
                has_discussions: boolean;
                homepage: string | null;
                /** Format: uri */
                hooks_url: string;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the repository */
                id: number;
                is_template?: boolean;
                /** Format: uri-template */
                issue_comment_url: string;
                /** Format: uri-template */
                issue_events_url: string;
                /** Format: uri-template */
                issues_url: string;
                /** Format: uri-template */
                keys_url: string;
                /** Format: uri-template */
                labels_url: string;
                language: string | null;
                /** Format: uri */
                languages_url: string;
                /** License */
                license: {
                  key: string;
                  name: string;
                  node_id: string;
                  spdx_id: string;
                  /** Format: uri */
                  url: string | null;
                } | null;
                master_branch?: string;
                /**
                 * @description The default value for a merge commit message.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `PR_BODY` - default to the pull request's body.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
                /**
                 * @description The default value for a merge commit title.
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
                 * @enum {string}
                 */
                merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
                /** Format: uri */
                merges_url: string;
                /** Format: uri-template */
                milestones_url: string;
                /** Format: uri */
                mirror_url: string | null;
                /** @description The name of the repository. */
                name: string;
                node_id: string;
                /** Format: uri-template */
                notifications_url: string;
                open_issues: number;
                open_issues_count: number;
                organization?: string;
                /** User */
                owner: {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null;
                permissions?: {
                  admin: boolean;
                  maintain?: boolean;
                  pull: boolean;
                  push: boolean;
                  triage?: boolean;
                };
                /** @description Whether the repository is private or public. */
                private: boolean;
                public?: boolean;
                /** Format: uri-template */
                pulls_url: string;
                pushed_at: number | string;
                /** Format: uri-template */
                releases_url: string;
                role_name?: string | null;
                size: number;
                /**
                 * @description The default value for a squash merge commit message:
                 *
                 * - `PR_BODY` - default to the pull request's body.
                 * - `COMMIT_MESSAGES` - default to the branch's commit messages.
                 * - `BLANK` - default to a blank commit message.
                 * @enum {string}
                 */
                squash_merge_commit_message?:
                  | "PR_BODY"
                  | "COMMIT_MESSAGES"
                  | "BLANK";
                /**
                 * @description The default value for a squash merge commit title:
                 *
                 * - `PR_TITLE` - default to the pull request's title.
                 * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
                 * @enum {string}
                 */
                squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
                ssh_url: string;
                stargazers?: number;
                stargazers_count: number;
                /** Format: uri */
                stargazers_url: string;
                /** Format: uri-template */
                statuses_url: string;
                /** Format: uri */
                subscribers_url: string;
                /** Format: uri */
                subscription_url: string;
                /** Format: uri */
                svn_url: string;
                /** Format: uri */
                tags_url: string;
                /** Format: uri */
                teams_url: string;
                topics: string[];
                /** Format: uri-template */
                trees_url: string;
                /** Format: date-time */
                updated_at: string;
                /** Format: uri */
                url: string;
                /**
                 * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
                 * @default false
                 */
                use_squash_pr_title_as_default?: boolean;
                /** @enum {string} */
                visibility: "public" | "private" | "internal";
                watchers: number;
                watchers_count: number;
                /** @description Whether to require contributors to sign off on web-based commits */
                web_commit_signoff_required?: boolean;
              };
              sha: string;
              /** User */
              user: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization";
                /** Format: uri */
                url?: string;
              } | null;
            };
            /** Format: uri */
            html_url: string;
            id: number;
            /** Format: uri */
            issue_url: string;
            labels: {
              /** @description 6-character hex code, without the leading #, identifying the color */
              color: string;
              default: boolean;
              description: string | null;
              id: number;
              /** @description The name of the label. */
              name: string;
              node_id: string;
              /**
               * Format: uri
               * @description URL for the label
               */
              url: string;
            }[];
            locked: boolean;
            /** @description Indicates whether maintainers can modify the pull request. */
            maintainer_can_modify?: boolean;
            merge_commit_sha: string | null;
            mergeable?: boolean | null;
            mergeable_state?: string;
            merged?: boolean | null;
            /** Format: date-time */
            merged_at: string | null;
            /** User */
            merged_by?: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            /**
             * Milestone
             * @description A collection of related issues and pull requests.
             */
            milestone: {
              /** Format: date-time */
              closed_at: string | null;
              closed_issues: number;
              /** Format: date-time */
              created_at: string;
              /** User */
              creator: {
                /** Format: uri */
                avatar_url?: string;
                deleted?: boolean;
                email?: string | null;
                /** Format: uri-template */
                events_url?: string;
                /** Format: uri */
                followers_url?: string;
                /** Format: uri-template */
                following_url?: string;
                /** Format: uri-template */
                gists_url?: string;
                gravatar_id?: string;
                /** Format: uri */
                html_url?: string;
                id: number;
                login: string;
                name?: string;
                node_id?: string;
                /** Format: uri */
                organizations_url?: string;
                /** Format: uri */
                received_events_url?: string;
                /** Format: uri */
                repos_url?: string;
                site_admin?: boolean;
                /** Format: uri-template */
                starred_url?: string;
                /** Format: uri */
                subscriptions_url?: string;
                /** @enum {string} */
                type?: "Bot" | "User" | "Organization" | "Mannequin";
                /** Format: uri */
                url?: string;
              } | null;
              description: string | null;
              /** Format: date-time */
              due_on: string | null;
              /** Format: uri */
              html_url: string;
              id: number;
              /** Format: uri */
              labels_url: string;
              node_id: string;
              /** @description The number of the milestone. */
              number: number;
              open_issues: number;
              /**
               * @description The state of the milestone.
               * @enum {string}
               */
              state: "open" | "closed";
              /** @description The title of the milestone. */
              title: string;
              /** Format: date-time */
              updated_at: string;
              /** Format: uri */
              url: string;
            } | null;
            node_id: string;
            /** @description Number uniquely identifying the pull request within its repository. */
            number: number;
            /** Format: uri */
            patch_url: string;
            rebaseable?: boolean | null;
            requested_reviewers: OneOf<
              [
                {
                  /** Format: uri */
                  avatar_url?: string;
                  deleted?: boolean;
                  email?: string | null;
                  /** Format: uri-template */
                  events_url?: string;
                  /** Format: uri */
                  followers_url?: string;
                  /** Format: uri-template */
                  following_url?: string;
                  /** Format: uri-template */
                  gists_url?: string;
                  gravatar_id?: string;
                  /** Format: uri */
                  html_url?: string;
                  id: number;
                  login: string;
                  name?: string;
                  node_id?: string;
                  /** Format: uri */
                  organizations_url?: string;
                  /** Format: uri */
                  received_events_url?: string;
                  /** Format: uri */
                  repos_url?: string;
                  site_admin?: boolean;
                  /** Format: uri-template */
                  starred_url?: string;
                  /** Format: uri */
                  subscriptions_url?: string;
                  /** @enum {string} */
                  type?: "Bot" | "User" | "Organization";
                  /** Format: uri */
                  url?: string;
                } | null,
                {
                  deleted?: boolean;
                  /** @description Description of the team */
                  description?: string | null;
                  /** Format: uri */
                  html_url?: string;
                  /** @description Unique identifier of the team */
                  id: number;
                  /** Format: uri-template */
                  members_url?: string;
                  /** @description Name of the team */
                  name: string;
                  node_id?: string;
                  parent?: {
                    /** @description Description of the team */
                    description: string | null;
                    /** Format: uri */
                    html_url: string;
                    /** @description Unique identifier of the team */
                    id: number;
                    /** Format: uri-template */
                    members_url: string;
                    /** @description Name of the team */
                    name: string;
                    node_id: string;
                    /** @description Permission that the team will have for its repositories */
                    permission: string;
                    /** @enum {string} */
                    privacy: "open" | "closed" | "secret";
                    /** Format: uri */
                    repositories_url: string;
                    slug: string;
                    /**
                     * Format: uri
                     * @description URL for the team
                     */
                    url: string;
                  } | null;
                  /** @description Permission that the team will have for its repositories */
                  permission?: string;
                  /** @enum {string} */
                  privacy?: "open" | "closed" | "secret";
                  /** Format: uri */
                  repositories_url?: string;
                  slug?: string;
                  /**
                   * Format: uri
                   * @description URL for the team
                   */
                  url?: string;
                }
              ]
            >[];
            requested_teams: {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }[];
            /** Format: uri-template */
            review_comment_url: string;
            review_comments?: number;
            /** Format: uri */
            review_comments_url: string;
            /**
             * @description State of this Pull Request. Either `open` or `closed`.
             * @enum {string}
             */
            state: "open" | "closed";
            /** Format: uri */
            statuses_url: string;
            /** @description The title of the pull request. */
            title: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** User */
            user: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null;
          };
          repository: components["schemas"]["repository"];
          /**
           * Team
           * @description Groups of organization members that gives permissions on specified repositories.
           */
          requested_team: {
            deleted?: boolean;
            /** @description Description of the team */
            description?: string | null;
            /** Format: uri */
            html_url?: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url?: string;
            /** @description Name of the team */
            name: string;
            node_id?: string;
            parent?: {
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            } | null;
            /** @description Permission that the team will have for its repositories */
            permission?: string;
            /** @enum {string} */
            privacy?: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url?: string;
            slug?: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url?: string;
          };
          sender: components["schemas"]["simple-user"];
        }
      ]
    >;
    /** pull_request_review submitted event */
    "webhook-pull-request-review-submitted": {
      /** @enum {string} */
      action: "submitted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Simple Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      /** @description The review that was affected. */
      review: {
        _links: {
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          pull_request: {
            /** Format: uri-template */
            href: string;
          };
        };
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /** @description The text of the review. */
        body: string | null;
        /** @description A commit SHA for the review. */
        commit_id: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the review */
        id: number;
        node_id: string;
        /** Format: uri */
        pull_request_url: string;
        state: string;
        /** Format: date-time */
        submitted_at: string | null;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request_review_thread resolved event */
    "webhook-pull-request-review-thread-resolved": {
      /** @enum {string} */
      action: "resolved";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Simple Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
      thread: {
        comments: {
          _links: {
            /** Link */
            html: {
              /** Format: uri-template */
              href: string;
            };
            /** Link */
            pull_request: {
              /** Format: uri-template */
              href: string;
            };
            /** Link */
            self: {
              /** Format: uri-template */
              href: string;
            };
          };
          /**
           * AuthorAssociation
           * @description How the author is associated with the repository.
           * @enum {string}
           */
          author_association:
            | "COLLABORATOR"
            | "CONTRIBUTOR"
            | "FIRST_TIMER"
            | "FIRST_TIME_CONTRIBUTOR"
            | "MANNEQUIN"
            | "MEMBER"
            | "NONE"
            | "OWNER";
          /** @description The text of the comment. */
          body: string;
          /** @description The SHA of the commit to which the comment applies. */
          commit_id: string;
          /** Format: date-time */
          created_at: string;
          /** @description The diff of the line that the comment refers to. */
          diff_hunk: string;
          /**
           * Format: uri
           * @description HTML URL for the pull request review comment.
           */
          html_url: string;
          /** @description The ID of the pull request review comment. */
          id: number;
          /** @description The comment ID to reply to. */
          in_reply_to_id?: number;
          /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
          line: number | null;
          /** @description The node ID of the pull request review comment. */
          node_id: string;
          /** @description The SHA of the original commit to which the comment applies. */
          original_commit_id: string;
          /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
          original_line: number | null;
          /** @description The index of the original line in the diff to which the comment applies. */
          original_position: number;
          /** @description The first line of the range for a multi-line comment. */
          original_start_line: number | null;
          /** @description The relative path of the file to which the comment applies. */
          path: string;
          /** @description The line index in the diff to which the comment applies. */
          position: number | null;
          /** @description The ID of the pull request review to which the comment belongs. */
          pull_request_review_id: number | null;
          /**
           * Format: uri
           * @description URL for the pull request that the review comment belongs to.
           */
          pull_request_url: string;
          /** Reactions */
          reactions: {
            "+1": number;
            "-1": number;
            confused: number;
            eyes: number;
            heart: number;
            hooray: number;
            laugh: number;
            rocket: number;
            total_count: number;
            /** Format: uri */
            url: string;
          };
          /**
           * @description The side of the first line of the range for a multi-line comment.
           * @enum {string}
           */
          side: "LEFT" | "RIGHT";
          /** @description The first line of the range for a multi-line comment. */
          start_line: number | null;
          /**
           * @description The side of the first line of the range for a multi-line comment.
           * @default RIGHT
           * @enum {string|null}
           */
          start_side: "LEFT" | "RIGHT" | "" | null;
          /**
           * @description The level at which the comment is targeted, can be a diff line or a file.
           * @enum {string}
           */
          subject_type?: "line" | "file";
          /** Format: date-time */
          updated_at: string;
          /**
           * Format: uri
           * @description URL for the pull request review comment
           */
          url: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
        }[];
        node_id: string;
      };
    };
    /** pull_request_review_thread unresolved event */
    "webhook-pull-request-review-thread-unresolved": {
      /** @enum {string} */
      action: "unresolved";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /** Simple Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        closed_at: string | null;
        /** Format: uri */
        comments_url: string;
        /** Format: uri */
        commits_url: string;
        created_at: string;
        /** Format: uri */
        diff_url: string;
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        merge_commit_sha: string | null;
        merged_at: string | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        number: number;
        /** Format: uri */
        patch_url: string;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        /** Format: uri */
        review_comments_url: string;
        /** @enum {string} */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        title: string;
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
      thread: {
        comments: {
          _links: {
            /** Link */
            html: {
              /** Format: uri-template */
              href: string;
            };
            /** Link */
            pull_request: {
              /** Format: uri-template */
              href: string;
            };
            /** Link */
            self: {
              /** Format: uri-template */
              href: string;
            };
          };
          /**
           * AuthorAssociation
           * @description How the author is associated with the repository.
           * @enum {string}
           */
          author_association:
            | "COLLABORATOR"
            | "CONTRIBUTOR"
            | "FIRST_TIMER"
            | "FIRST_TIME_CONTRIBUTOR"
            | "MANNEQUIN"
            | "MEMBER"
            | "NONE"
            | "OWNER";
          /** @description The text of the comment. */
          body: string;
          /** @description The SHA of the commit to which the comment applies. */
          commit_id: string;
          /** Format: date-time */
          created_at: string;
          /** @description The diff of the line that the comment refers to. */
          diff_hunk: string;
          /**
           * Format: uri
           * @description HTML URL for the pull request review comment.
           */
          html_url: string;
          /** @description The ID of the pull request review comment. */
          id: number;
          /** @description The comment ID to reply to. */
          in_reply_to_id?: number;
          /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
          line: number | null;
          /** @description The node ID of the pull request review comment. */
          node_id: string;
          /** @description The SHA of the original commit to which the comment applies. */
          original_commit_id: string;
          /** @description The line of the blob to which the comment applies. The last line of the range for a multi-line comment */
          original_line: number;
          /** @description The index of the original line in the diff to which the comment applies. */
          original_position: number;
          /** @description The first line of the range for a multi-line comment. */
          original_start_line: number | null;
          /** @description The relative path of the file to which the comment applies. */
          path: string;
          /** @description The line index in the diff to which the comment applies. */
          position: number | null;
          /** @description The ID of the pull request review to which the comment belongs. */
          pull_request_review_id: number | null;
          /**
           * Format: uri
           * @description URL for the pull request that the review comment belongs to.
           */
          pull_request_url: string;
          /** Reactions */
          reactions: {
            "+1": number;
            "-1": number;
            confused: number;
            eyes: number;
            heart: number;
            hooray: number;
            laugh: number;
            rocket: number;
            total_count: number;
            /** Format: uri */
            url: string;
          };
          /**
           * @description The side of the first line of the range for a multi-line comment.
           * @enum {string}
           */
          side: "LEFT" | "RIGHT";
          /** @description The first line of the range for a multi-line comment. */
          start_line: number | null;
          /**
           * @description The side of the first line of the range for a multi-line comment.
           * @default RIGHT
           * @enum {string|null}
           */
          start_side: "LEFT" | "RIGHT" | "" | null;
          /**
           * @description The level at which the comment is targeted, can be a diff line or a file.
           * @enum {string}
           */
          subject_type?: "line" | "file";
          /** Format: date-time */
          updated_at: string;
          /**
           * Format: uri
           * @description URL for the pull request review comment
           */
          url: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        }[];
        node_id: string;
      };
    };
    /** pull_request synchronize event */
    "webhook-pull-request-synchronize": {
      /** @enum {string} */
      action: "synchronize";
      after: string;
      before: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit message title.
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request unassigned event */
    "webhook-pull-request-unassigned": {
      /** @enum {string} */
      action: "unassigned";
      /** User */
      assignee?: {
        /** Format: uri */
        avatar_url?: string;
        deleted?: boolean;
        email?: string | null;
        /** Format: uri-template */
        events_url?: string;
        /** Format: uri */
        followers_url?: string;
        /** Format: uri-template */
        following_url?: string;
        /** Format: uri-template */
        gists_url?: string;
        gravatar_id?: string;
        /** Format: uri */
        html_url?: string;
        id: number;
        login: string;
        name?: string;
        node_id?: string;
        /** Format: uri */
        organizations_url?: string;
        /** Format: uri */
        received_events_url?: string;
        /** Format: uri */
        repos_url?: string;
        site_admin?: boolean;
        /** Format: uri-template */
        starred_url?: string;
        /** Format: uri */
        subscriptions_url?: string;
        /** @enum {string} */
        type?: "Bot" | "User" | "Organization" | "Mannequin";
        /** Format: uri */
        url?: string;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** pull_request unlabeled event */
    "webhook-pull-request-unlabeled": {
      /** @enum {string} */
      action: "unlabeled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** Label */
      label?: {
        /** @description 6-character hex code, without the leading #, identifying the color */
        color: string;
        default: boolean;
        description: string | null;
        id: number;
        /** @description The name of the label. */
        name: string;
        node_id: string;
        /**
         * Format: uri
         * @description URL for the label
         */
        url: string;
      };
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string | null;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string | null;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit message title.
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization" | "Mannequin";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization" | "Mannequin";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description: string | null;
              /** Format: uri */
              html_url: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url: string;
              /** @description Name of the team */
              name: string;
              node_id: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission: string;
              /** @enum {string} */
              privacy: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url: string;
              slug: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization" | "Mannequin";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** pull_request unlocked event */
    "webhook-pull-request-unlocked": {
      /** @enum {string} */
      action: "unlocked";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      /** @description The pull request number. */
      number: number;
      organization?: components["schemas"]["organization-simple"];
      /** Pull Request */
      pull_request: {
        _links: {
          /** Link */
          comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          commits: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          html: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          issue: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comment: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          review_comments: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          self: {
            /** Format: uri-template */
            href: string;
          };
          /** Link */
          statuses: {
            /** Format: uri-template */
            href: string;
          };
        };
        /** @enum {string|null} */
        active_lock_reason:
          | "resolved"
          | "off-topic"
          | "too heated"
          | "spam"
          | ""
          | null;
        additions?: number;
        /** User */
        assignee: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        assignees: ({
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null)[];
        /**
         * AuthorAssociation
         * @description How the author is associated with the repository.
         * @enum {string}
         */
        author_association:
          | "COLLABORATOR"
          | "CONTRIBUTOR"
          | "FIRST_TIMER"
          | "FIRST_TIME_CONTRIBUTOR"
          | "MANNEQUIN"
          | "MEMBER"
          | "NONE"
          | "OWNER";
        /**
         * PullRequestAutoMerge
         * @description The status of auto merging a pull request.
         */
        auto_merge: {
          /** @description Commit message for the merge commit. */
          commit_message: string | null;
          /** @description Title for the merge commit message. */
          commit_title: string;
          /** User */
          enabled_by: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method: "merge" | "squash" | "rebase";
        } | null;
        base: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          };
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        body: string | null;
        changed_files?: number;
        /** Format: date-time */
        closed_at: string | null;
        comments?: number;
        /** Format: uri */
        comments_url: string;
        commits?: number;
        /** Format: uri */
        commits_url: string;
        /** Format: date-time */
        created_at: string;
        deletions?: number;
        /** Format: uri */
        diff_url: string;
        /** @description Indicates whether or not the pull request is a draft. */
        draft: boolean;
        head: {
          label: string;
          ref: string;
          /**
           * Repository
           * @description A git repository
           */
          repo: {
            /**
             * @description Whether to allow auto-merge for pull requests.
             * @default false
             */
            allow_auto_merge?: boolean;
            /** @description Whether to allow private forks */
            allow_forking?: boolean;
            /**
             * @description Whether to allow merge commits for pull requests.
             * @default true
             */
            allow_merge_commit?: boolean;
            /**
             * @description Whether to allow rebase merges for pull requests.
             * @default true
             */
            allow_rebase_merge?: boolean;
            /**
             * @description Whether to allow squash merges for pull requests.
             * @default true
             */
            allow_squash_merge?: boolean;
            allow_update_branch?: boolean;
            /** Format: uri-template */
            archive_url: string;
            /**
             * @description Whether the repository is archived.
             * @default false
             */
            archived: boolean;
            /** Format: uri-template */
            assignees_url: string;
            /** Format: uri-template */
            blobs_url: string;
            /** Format: uri-template */
            branches_url: string;
            /** Format: uri */
            clone_url: string;
            /** Format: uri-template */
            collaborators_url: string;
            /** Format: uri-template */
            comments_url: string;
            /** Format: uri-template */
            commits_url: string;
            /** Format: uri-template */
            compare_url: string;
            /** Format: uri-template */
            contents_url: string;
            /** Format: uri */
            contributors_url: string;
            created_at: number | string;
            /** @description The default branch of the repository. */
            default_branch: string;
            /**
             * @description Whether to delete head branches when pull requests are merged
             * @default false
             */
            delete_branch_on_merge?: boolean;
            /** Format: uri */
            deployments_url: string;
            description: string | null;
            /** @description Returns whether or not this repository is disabled. */
            disabled?: boolean;
            /** Format: uri */
            downloads_url: string;
            /** Format: uri */
            events_url: string;
            fork: boolean;
            forks: number;
            forks_count: number;
            /** Format: uri */
            forks_url: string;
            full_name: string;
            /** Format: uri-template */
            git_commits_url: string;
            /** Format: uri-template */
            git_refs_url: string;
            /** Format: uri-template */
            git_tags_url: string;
            /** Format: uri */
            git_url: string;
            /**
             * @description Whether downloads are enabled.
             * @default true
             */
            has_downloads: boolean;
            /**
             * @description Whether issues are enabled.
             * @default true
             */
            has_issues: boolean;
            has_pages: boolean;
            /**
             * @description Whether projects are enabled.
             * @default true
             */
            has_projects: boolean;
            /**
             * @description Whether the wiki is enabled.
             * @default true
             */
            has_wiki: boolean;
            /**
             * @description Whether discussions are enabled.
             * @default false
             */
            has_discussions: boolean;
            homepage: string | null;
            /** Format: uri */
            hooks_url: string;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the repository */
            id: number;
            is_template?: boolean;
            /** Format: uri-template */
            issue_comment_url: string;
            /** Format: uri-template */
            issue_events_url: string;
            /** Format: uri-template */
            issues_url: string;
            /** Format: uri-template */
            keys_url: string;
            /** Format: uri-template */
            labels_url: string;
            language: string | null;
            /** Format: uri */
            languages_url: string;
            /** License */
            license: {
              key: string;
              name: string;
              node_id: string;
              spdx_id: string;
              /** Format: uri */
              url: string | null;
            } | null;
            master_branch?: string;
            /**
             * @description The default value for a merge commit message.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `PR_BODY` - default to the pull request's body.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
            /**
             * @description The default value for a merge commit title.
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
             * @enum {string}
             */
            merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
            /** Format: uri */
            merges_url: string;
            /** Format: uri-template */
            milestones_url: string;
            /** Format: uri */
            mirror_url: string | null;
            /** @description The name of the repository. */
            name: string;
            node_id: string;
            /** Format: uri-template */
            notifications_url: string;
            open_issues: number;
            open_issues_count: number;
            organization?: string;
            /** User */
            owner: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
            permissions?: {
              admin: boolean;
              maintain?: boolean;
              pull: boolean;
              push: boolean;
              triage?: boolean;
            };
            /** @description Whether the repository is private or public. */
            private: boolean;
            public?: boolean;
            /** Format: uri-template */
            pulls_url: string;
            pushed_at: number | string;
            /** Format: uri-template */
            releases_url: string;
            role_name?: string | null;
            size: number;
            /**
             * @description The default value for a squash merge commit message:
             *
             * - `PR_BODY` - default to the pull request's body.
             * - `COMMIT_MESSAGES` - default to the branch's commit messages.
             * - `BLANK` - default to a blank commit message.
             * @enum {string}
             */
            squash_merge_commit_message?:
              | "PR_BODY"
              | "COMMIT_MESSAGES"
              | "BLANK";
            /**
             * @description The default value for a squash merge commit title:
             *
             * - `PR_TITLE` - default to the pull request's title.
             * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
             * @enum {string}
             */
            squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
            ssh_url: string;
            stargazers?: number;
            stargazers_count: number;
            /** Format: uri */
            stargazers_url: string;
            /** Format: uri-template */
            statuses_url: string;
            /** Format: uri */
            subscribers_url: string;
            /** Format: uri */
            subscription_url: string;
            /** Format: uri */
            svn_url: string;
            /** Format: uri */
            tags_url: string;
            /** Format: uri */
            teams_url: string;
            topics: string[];
            /** Format: uri-template */
            trees_url: string;
            /** Format: date-time */
            updated_at: string;
            /** Format: uri */
            url: string;
            /**
             * @description Whether a squash merge commit can use the pull request title as default. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
             * @default false
             */
            use_squash_pr_title_as_default?: boolean;
            /** @enum {string} */
            visibility: "public" | "private" | "internal";
            watchers: number;
            watchers_count: number;
            /** @description Whether to require contributors to sign off on web-based commits */
            web_commit_signoff_required?: boolean;
          } | null;
          sha: string;
          /** User */
          user: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
        };
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        issue_url: string;
        labels: {
          /** @description 6-character hex code, without the leading #, identifying the color */
          color: string;
          default: boolean;
          description: string | null;
          id: number;
          /** @description The name of the label. */
          name: string;
          node_id: string;
          /**
           * Format: uri
           * @description URL for the label
           */
          url: string;
        }[];
        locked: boolean;
        /** @description Indicates whether maintainers can modify the pull request. */
        maintainer_can_modify?: boolean;
        merge_commit_sha: string | null;
        mergeable?: boolean | null;
        mergeable_state?: string;
        merged?: boolean | null;
        /** Format: date-time */
        merged_at: string | null;
        /** User */
        merged_by?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Milestone
         * @description A collection of related issues and pull requests.
         */
        milestone: {
          /** Format: date-time */
          closed_at: string | null;
          closed_issues: number;
          /** Format: date-time */
          created_at: string;
          /** User */
          creator: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          description: string | null;
          /** Format: date-time */
          due_on: string | null;
          /** Format: uri */
          html_url: string;
          id: number;
          /** Format: uri */
          labels_url: string;
          node_id: string;
          /** @description The number of the milestone. */
          number: number;
          open_issues: number;
          /**
           * @description The state of the milestone.
           * @enum {string}
           */
          state: "open" | "closed";
          /** @description The title of the milestone. */
          title: string;
          /** Format: date-time */
          updated_at: string;
          /** Format: uri */
          url: string;
        } | null;
        node_id: string;
        /** @description Number uniquely identifying the pull request within its repository. */
        number: number;
        /** Format: uri */
        patch_url: string;
        rebaseable?: boolean | null;
        requested_reviewers: OneOf<
          [
            {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null,
            {
              deleted?: boolean;
              /** @description Description of the team */
              description?: string | null;
              /** Format: uri */
              html_url?: string;
              /** @description Unique identifier of the team */
              id: number;
              /** Format: uri-template */
              members_url?: string;
              /** @description Name of the team */
              name: string;
              node_id?: string;
              parent?: {
                /** @description Description of the team */
                description: string | null;
                /** Format: uri */
                html_url: string;
                /** @description Unique identifier of the team */
                id: number;
                /** Format: uri-template */
                members_url: string;
                /** @description Name of the team */
                name: string;
                node_id: string;
                /** @description Permission that the team will have for its repositories */
                permission: string;
                /** @enum {string} */
                privacy: "open" | "closed" | "secret";
                /** Format: uri */
                repositories_url: string;
                slug: string;
                /**
                 * Format: uri
                 * @description URL for the team
                 */
                url: string;
              } | null;
              /** @description Permission that the team will have for its repositories */
              permission?: string;
              /** @enum {string} */
              privacy?: "open" | "closed" | "secret";
              /** Format: uri */
              repositories_url?: string;
              slug?: string;
              /**
               * Format: uri
               * @description URL for the team
               */
              url?: string;
            }
          ]
        >[];
        requested_teams: {
          deleted?: boolean;
          /** @description Description of the team */
          description?: string | null;
          /** Format: uri */
          html_url?: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url?: string;
          /** @description Name of the team */
          name: string;
          node_id?: string;
          parent?: {
            /** @description Description of the team */
            description: string | null;
            /** Format: uri */
            html_url: string;
            /** @description Unique identifier of the team */
            id: number;
            /** Format: uri-template */
            members_url: string;
            /** @description Name of the team */
            name: string;
            node_id: string;
            /** @description Permission that the team will have for its repositories */
            permission: string;
            /** @enum {string} */
            privacy: "open" | "closed" | "secret";
            /** Format: uri */
            repositories_url: string;
            slug: string;
            /**
             * Format: uri
             * @description URL for the team
             */
            url: string;
          } | null;
          /** @description Permission that the team will have for its repositories */
          permission?: string;
          /** @enum {string} */
          privacy?: "open" | "closed" | "secret";
          /** Format: uri */
          repositories_url?: string;
          slug?: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url?: string;
        }[];
        /** Format: uri-template */
        review_comment_url: string;
        review_comments?: number;
        /** Format: uri */
        review_comments_url: string;
        /**
         * @description State of this Pull Request. Either `open` or `closed`.
         * @enum {string}
         */
        state: "open" | "closed";
        /** Format: uri */
        statuses_url: string;
        /** @description The title of the pull request. */
        title: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** User */
        user: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** push event */
    "webhook-push": {
      /** @description The SHA of the most recent commit on `ref` after the push. */
      after: string;
      base_ref: string | null;
      /** @description The SHA of the most recent commit on `ref` before the push. */
      before: string;
      /** @description An array of commit objects describing the pushed commits. (Pushed commits are all commits that are included in the `compare` between the `before` commit and the `after` commit.) The array includes a maximum of 20 commits. If necessary, you can use the [Commits API](https://docs.github.com/rest/reference/repos#commits) to fetch additional commits. This limit is applied to timeline events only and isn't applied to webhook deliveries. */
      commits: {
        /** @description An array of files added in the commit. */
        added?: string[];
        /**
         * Committer
         * @description Metaproperties for Git author/committer information.
         */
        author: {
          /** Format: date-time */
          date?: string;
          /** Format: email */
          email: string | null;
          /** @description The git author's name. */
          name: string;
          username?: string;
        };
        /**
         * Committer
         * @description Metaproperties for Git author/committer information.
         */
        committer: {
          /** Format: date-time */
          date?: string;
          /** Format: email */
          email: string | null;
          /** @description The git author's name. */
          name: string;
          username?: string;
        };
        /** @description Whether this commit is distinct from any that have been pushed before. */
        distinct: boolean;
        id: string;
        /** @description The commit message. */
        message: string;
        /** @description An array of files modified by the commit. */
        modified?: string[];
        /** @description An array of files removed in the commit. */
        removed?: string[];
        /**
         * Format: date-time
         * @description The ISO 8601 timestamp of the commit.
         */
        timestamp: string;
        tree_id: string;
        /**
         * Format: uri
         * @description URL that points to the commit API resource.
         */
        url: string;
      }[];
      /** @description URL that shows the changes in this `ref` update, from the `before` commit to the `after` commit. For a newly created `ref` that is directly based on the default branch, this is the comparison between the head of the default branch and the `after` commit. Otherwise, this shows all commits until the `after` commit. */
      compare: string;
      /** @description Whether this push created the `ref`. */
      created: boolean;
      /** @description Whether this push deleted the `ref`. */
      deleted: boolean;
      enterprise?: components["schemas"]["enterprise"];
      /** @description Whether this push was a force push of the `ref`. */
      forced: boolean;
      /** Commit */
      head_commit: {
        /** @description An array of files added in the commit. */
        added?: string[];
        /**
         * Committer
         * @description Metaproperties for Git author/committer information.
         */
        author: {
          /** Format: date-time */
          date?: string;
          /** Format: email */
          email: string | null;
          /** @description The git author's name. */
          name: string;
          username?: string;
        };
        /**
         * Committer
         * @description Metaproperties for Git author/committer information.
         */
        committer: {
          /** Format: date-time */
          date?: string;
          /** Format: email */
          email: string | null;
          /** @description The git author's name. */
          name: string;
          username?: string;
        };
        /** @description Whether this commit is distinct from any that have been pushed before. */
        distinct: boolean;
        id: string;
        /** @description The commit message. */
        message: string;
        /** @description An array of files modified by the commit. */
        modified?: string[];
        /** @description An array of files removed in the commit. */
        removed?: string[];
        /**
         * Format: date-time
         * @description The ISO 8601 timestamp of the commit.
         */
        timestamp: string;
        tree_id: string;
        /**
         * Format: uri
         * @description URL that points to the commit API resource.
         */
        url: string;
      } | null;
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /**
       * Committer
       * @description Metaproperties for Git author/committer information.
       */
      pusher: {
        /** Format: date-time */
        date?: string;
        /** Format: email */
        email?: string | null;
        /** @description The git author's name. */
        name: string;
        username?: string;
      };
      /** @description The full git ref that was pushed. Example: `refs/heads/main` or `refs/tags/v3.14.1`. */
      ref: string;
      /**
       * Repository
       * @description A git repository
       */
      repository: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        /**
         * @description Whether discussions are enabled.
         * @default false
         */
        has_discussions: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
        /** @description Whether to require contributors to sign off on web-based commits */
        web_commit_signoff_required?: boolean;
      };
      sender?: components["schemas"]["simple-user"];
    };
    "webhook-registry-package-published": {
      /** @enum {string} */
      action: "published";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      registry_package: {
        created_at: string | null;
        description: string | null;
        ecosystem: string;
        html_url: string;
        id: number;
        name: string;
        namespace: string;
        owner: {
          avatar_url: string;
          events_url: string;
          followers_url: string;
          following_url: string;
          gists_url: string;
          gravatar_id: string;
          html_url: string;
          id: number;
          login: string;
          node_id: string;
          organizations_url: string;
          received_events_url: string;
          repos_url: string;
          site_admin: boolean;
          starred_url: string;
          subscriptions_url: string;
          type: string;
          url: string;
        };
        package_type: string;
        package_version: {
          author?: {
            avatar_url: string;
            events_url: string;
            followers_url: string;
            following_url: string;
            gists_url: string;
            gravatar_id: string;
            html_url: string;
            id: number;
            login: string;
            node_id: string;
            organizations_url: string;
            received_events_url: string;
            repos_url: string;
            site_admin: boolean;
            starred_url: string;
            subscriptions_url: string;
            type: string;
            url: string;
          };
          body?: string | Record<string, never>;
          body_html?: string;
          container_metadata?: {
            labels?: Record<string, unknown> | null;
            manifest?: Record<string, unknown> | null;
            tag?: {
              digest?: string;
              name?: string;
            };
          };
          created_at?: string;
          description: string;
          docker_metadata?: {
            tags?: string[];
          }[];
          draft?: boolean;
          html_url: string;
          id: number;
          installation_command: string;
          manifest?: string;
          metadata: {
            [key: string]: unknown;
          }[];
          name: string;
          npm_metadata?: {
            name?: string;
            version?: string;
            npm_user?: string;
            author?: string | Record<string, never>;
            bugs?: string | Record<string, never>;
            dependencies?: Record<string, never>;
            dev_dependencies?: Record<string, never>;
            peer_dependencies?: Record<string, never>;
            optional_dependencies?: Record<string, never>;
            description?: string;
            dist?: string | Record<string, never>;
            git_head?: string;
            homepage?: string;
            license?: string;
            main?: string;
            repository?: string | Record<string, never>;
            scripts?: Record<string, never>;
            id?: string;
            node_version?: string;
            npm_version?: string;
            has_shrinkwrap?: boolean;
            maintainers?: string[];
            contributors?: string[];
            engines?: Record<string, never>;
            keywords?: string[];
            files?: string[];
            bin?: Record<string, never>;
            man?: Record<string, never>;
            directories?: string | Record<string, never>;
            os?: string[];
            cpu?: string[];
            readme?: string;
            installation_command?: string;
            release_id?: number;
            commit_oid?: string;
            published_via_actions?: boolean;
            deleted_by_id?: number;
          } | null;
          nuget_metadata?:
            | {
                id?: string | Record<string, never> | number;
                name?: string;
                value?: OneOf<
                  [
                    boolean,
                    string,
                    number,
                    {
                      url?: string;
                      branch?: string;
                      commit?: string;
                      type?: string;
                    }
                  ]
                >;
              }[]
            | null;
          package_files: {
            content_type: string;
            created_at: string;
            download_url: string;
            id: number;
            md5: string | null;
            name: string;
            sha1: string | null;
            sha256: string | null;
            size: number;
            state: string | null;
            updated_at: string;
          }[];
          package_url: string;
          prerelease?: boolean;
          release?: {
            author?: {
              avatar_url?: string;
              events_url?: string;
              followers_url?: string;
              following_url?: string;
              gists_url?: string;
              gravatar_id?: string;
              html_url?: string;
              id?: number;
              login?: string;
              node_id?: string;
              organizations_url?: string;
              received_events_url?: string;
              repos_url?: string;
              site_admin?: boolean;
              starred_url?: string;
              subscriptions_url?: string;
              type?: string;
              url?: string;
            };
            created_at?: string;
            draft?: boolean;
            html_url?: string;
            id?: number;
            name?: string | null;
            prerelease?: boolean;
            published_at?: string;
            tag_name?: string;
            target_commitish?: string;
            url?: string;
          };
          rubygems_metadata?: components["schemas"]["webhook-rubygems-metadata"][];
          summary: string;
          tag_name?: string;
          target_commitish?: string;
          target_oid?: string;
          updated_at?: string;
          version: string;
        } | null;
        registry: {
          about_url?: string;
          name?: string;
          type?: string;
          url?: string;
          vendor?: string;
        } | null;
        updated_at: string | null;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    "webhook-registry-package-updated": {
      action: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      registry_package: {
        created_at: string;
        description: Record<string, unknown> | null;
        ecosystem: string;
        html_url: string;
        id: number;
        name: string;
        namespace: string;
        owner: {
          avatar_url: string;
          events_url: string;
          followers_url: string;
          following_url: string;
          gists_url: string;
          gravatar_id: string;
          html_url: string;
          id: number;
          login: string;
          node_id: string;
          organizations_url: string;
          received_events_url: string;
          repos_url: string;
          site_admin: boolean;
          starred_url: string;
          subscriptions_url: string;
          type: string;
          url: string;
        };
        package_type: string;
        package_version: {
          author: {
            avatar_url: string;
            events_url: string;
            followers_url: string;
            following_url: string;
            gists_url: string;
            gravatar_id: string;
            html_url: string;
            id: number;
            login: string;
            node_id: string;
            organizations_url: string;
            received_events_url: string;
            repos_url: string;
            site_admin: boolean;
            starred_url: string;
            subscriptions_url: string;
            type: string;
            url: string;
          };
          body: string;
          body_html: string;
          created_at: string;
          description: string;
          docker_metadata?: ({
            tags?: string[];
          } | null)[];
          draft?: boolean;
          html_url: string;
          id: number;
          installation_command: string;
          manifest?: string;
          metadata: {
            [key: string]: unknown;
          }[];
          name: string;
          package_files: {
            content_type?: string;
            created_at?: string;
            download_url?: string;
            id?: number;
            md5?: string | null;
            name?: string;
            sha1?: string | null;
            sha256?: string;
            size?: number;
            state?: string;
            updated_at?: string;
          }[];
          package_url: string;
          prerelease?: boolean;
          release?: {
            author: {
              avatar_url: string;
              events_url: string;
              followers_url: string;
              following_url: string;
              gists_url: string;
              gravatar_id: string;
              html_url: string;
              id: number;
              login: string;
              node_id: string;
              organizations_url: string;
              received_events_url: string;
              repos_url: string;
              site_admin: boolean;
              starred_url: string;
              subscriptions_url: string;
              type: string;
              url: string;
            };
            created_at: string;
            draft: boolean;
            html_url: string;
            id: number;
            name: string;
            prerelease: boolean;
            published_at: string;
            tag_name: string;
            target_commitish: string;
            url: string;
          };
          rubygems_metadata?: components["schemas"]["webhook-rubygems-metadata"][];
          summary: string;
          tag_name?: string;
          target_commitish: string;
          target_oid: string;
          updated_at: string;
          version: string;
        };
        registry: Record<string, unknown> | null;
        updated_at: string;
      };
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** release created event */
    "webhook-release-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /**
       * Release
       * @description The [release](https://docs.github.com/rest/reference/repos/#get-a-release) object.
       */
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** release deleted event */
    "webhook-release-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /**
       * Release
       * @description The [release](https://docs.github.com/rest/reference/repos/#get-a-release) object.
       */
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      };
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** release edited event */
    "webhook-release-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        body?: {
          /** @description The previous version of the body if the action was `edited`. */
          from: string;
        };
        name?: {
          /** @description The previous version of the name if the action was `edited`. */
          from: string;
        };
        make_latest?: {
          /** @description Whether this release was explicitly `edited` to be the latest. */
          to: boolean;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /**
       * Release
       * @description The [release](https://docs.github.com/rest/reference/repos/#get-a-release) object.
       */
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** release prereleased event */
    "webhook-release-prereleased": {
      /** @enum {string} */
      action: "prereleased";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      } & {
        assets?: (Record<string, unknown> | null)[];
        assets_url?: string;
        author?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        body?: string | null;
        created_at?: string;
        draft?: boolean;
        html_url?: string;
        id?: number;
        name?: string | null;
        node_id?: string;
        /**
         * @description Whether the release is identified as a prerelease or a full release.
         * @enum {boolean}
         */
        prerelease: true;
        published_at?: string | null;
        tag_name?: string;
        tarball_url?: string | null;
        target_commitish?: string;
        upload_url?: string;
        url?: string;
        zipball_url?: string | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** release published event */
    "webhook-release-published": {
      /** @enum {string} */
      action: "published";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      } & {
        assets?: (Record<string, unknown> | null)[];
        assets_url?: string;
        author?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        body?: string | null;
        created_at?: string;
        draft?: boolean;
        html_url?: string;
        id?: number;
        name?: string | null;
        node_id?: string;
        prerelease?: boolean;
        /** Format: date-time */
        published_at: string | null;
        tag_name?: string;
        tarball_url?: string | null;
        target_commitish?: string;
        upload_url?: string;
        url?: string;
        zipball_url?: string | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** release released event */
    "webhook-release-released": {
      /** @enum {string} */
      action: "released";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      /**
       * Release
       * @description The [release](https://docs.github.com/rest/reference/repos/#get-a-release) object.
       */
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** release unpublished event */
    "webhook-release-unpublished": {
      /** @enum {string} */
      action: "unpublished";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      release: {
        assets: {
          /** Format: uri */
          browser_download_url: string;
          content_type: string;
          /** Format: date-time */
          created_at: string;
          download_count: number;
          id: number;
          label: string | null;
          /** @description The file name of the asset. */
          name: string;
          node_id: string;
          size: number;
          /**
           * @description State of the release asset.
           * @enum {string}
           */
          state: "uploaded";
          /** Format: date-time */
          updated_at: string;
          /** User */
          uploader?: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** Format: uri */
          url: string;
        }[];
        /** Format: uri */
        assets_url: string;
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        body: string | null;
        /** Format: date-time */
        created_at: string | null;
        /** Format: uri */
        discussion_url?: string;
        /** @description Whether the release is a draft or published */
        draft: boolean;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string | null;
        node_id: string;
        /** @description Whether the release is identified as a prerelease or a full release. */
        prerelease: boolean;
        /** Format: date-time */
        published_at: string | null;
        /** Reactions */
        reactions?: {
          "+1": number;
          "-1": number;
          confused: number;
          eyes: number;
          heart: number;
          hooray: number;
          laugh: number;
          rocket: number;
          total_count: number;
          /** Format: uri */
          url: string;
        };
        /** @description The name of the tag. */
        tag_name: string;
        /** Format: uri */
        tarball_url: string | null;
        /** @description Specifies the commitish value that determines where the Git tag is created from. */
        target_commitish: string;
        /** Format: uri-template */
        upload_url: string;
        /** Format: uri */
        url: string;
        /** Format: uri */
        zipball_url: string | null;
      } & {
        assets?: (Record<string, unknown> | null)[];
        assets_url?: string;
        author?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        body?: string | null;
        created_at?: string;
        draft?: boolean;
        html_url?: string;
        id?: number;
        name?: string | null;
        node_id?: string;
        prerelease?: boolean;
        published_at: string | null;
        tag_name?: string;
        tarball_url?: string | null;
        target_commitish?: string;
        upload_url?: string;
        url?: string;
        zipball_url?: string | null;
      };
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** Repository advisory published event */
    "webhook-repository-advisory-published": {
      /** @enum {string} */
      action: "published";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      repository_advisory: components["schemas"]["repository-advisory"];
      sender?: components["schemas"]["simple-user"];
    };
    /** Repository advisory reported event */
    "webhook-repository-advisory-reported": {
      /** @enum {string} */
      action: "reported";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      repository_advisory: components["schemas"]["repository-advisory"];
      sender?: components["schemas"]["simple-user"];
    };
    /** repository archived event */
    "webhook-repository-archived": {
      /** @enum {string} */
      action: "archived";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository created event */
    "webhook-repository-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository deleted event */
    "webhook-repository-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_dispatch event */
    "webhook-repository-dispatch-sample": {
      action: string;
      branch: string;
      client_payload: {
        [key: string]: unknown;
      } | null;
      enterprise?: components["schemas"]["enterprise"];
      installation: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository edited event */
    "webhook-repository-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        default_branch?: {
          from: string;
        };
        description?: {
          from: string | null;
        };
        homepage?: {
          from: string | null;
        };
        topics?: {
          from?: string[] | null;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_import event */
    "webhook-repository-import": {
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** @enum {string} */
      status: "success" | "cancelled" | "failure";
    };
    /** repository privatized event */
    "webhook-repository-privatized": {
      /** @enum {string} */
      action: "privatized";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository publicized event */
    "webhook-repository-publicized": {
      /** @enum {string} */
      action: "publicized";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository renamed event */
    "webhook-repository-renamed": {
      /** @enum {string} */
      action: "renamed";
      changes: {
        repository: {
          name: {
            from: string;
          };
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository transferred event */
    "webhook-repository-transferred": {
      /** @enum {string} */
      action: "transferred";
      changes: {
        owner: {
          from: {
            /** Organization */
            organization?: {
              /** Format: uri */
              avatar_url: string;
              description: string | null;
              /** Format: uri */
              events_url: string;
              /** Format: uri */
              hooks_url: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              /** Format: uri */
              issues_url: string;
              login: string;
              /** Format: uri-template */
              members_url: string;
              node_id: string;
              /** Format: uri-template */
              public_members_url: string;
              /** Format: uri */
              repos_url: string;
              /** Format: uri */
              url: string;
            };
            /** User */
            user?: {
              /** Format: uri */
              avatar_url?: string;
              deleted?: boolean;
              email?: string | null;
              /** Format: uri-template */
              events_url?: string;
              /** Format: uri */
              followers_url?: string;
              /** Format: uri-template */
              following_url?: string;
              /** Format: uri-template */
              gists_url?: string;
              gravatar_id?: string;
              /** Format: uri */
              html_url?: string;
              id: number;
              login: string;
              name?: string;
              node_id?: string;
              /** Format: uri */
              organizations_url?: string;
              /** Format: uri */
              received_events_url?: string;
              /** Format: uri */
              repos_url?: string;
              site_admin?: boolean;
              /** Format: uri-template */
              starred_url?: string;
              /** Format: uri */
              subscriptions_url?: string;
              /** @enum {string} */
              type?: "Bot" | "User" | "Organization";
              /** Format: uri */
              url?: string;
            } | null;
          };
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository unarchived event */
    "webhook-repository-unarchived": {
      /** @enum {string} */
      action: "unarchived";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_vulnerability_alert create event */
    "webhook-repository-vulnerability-alert-create": {
      /** @enum {string} */
      action: "create";
      alert: {
        affected_package_name: string;
        affected_range: string;
        created_at: string;
        dismiss_reason?: string;
        dismissed_at?: string;
        /** User */
        dismisser?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        external_identifier: string;
        /** Format: uri */
        external_reference: string | null;
        fix_reason?: string;
        /** Format: date-time */
        fixed_at?: string;
        fixed_in?: string;
        ghsa_id: string;
        id: number;
        node_id: string;
        number: number;
        severity: string;
        /** @enum {string} */
        state: "open" | "dismissed" | "fixed";
      } & {
        affected_package_name?: string;
        affected_range?: string;
        created_at?: string;
        external_identifier?: string;
        external_reference?: string | null;
        fixed_in?: string;
        ghsa_id?: string;
        id?: number;
        node_id?: string;
        number?: number;
        severity?: string;
        /** @enum {string} */
        state: "open";
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_vulnerability_alert dismiss event */
    "webhook-repository-vulnerability-alert-dismiss": {
      /** @enum {string} */
      action: "dismiss";
      alert: {
        affected_package_name: string;
        affected_range: string;
        created_at: string;
        dismiss_comment?: string | null;
        dismiss_reason?: string;
        dismissed_at?: string;
        /** User */
        dismisser?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        external_identifier: string;
        /** Format: uri */
        external_reference: string | null;
        fix_reason?: string;
        /** Format: date-time */
        fixed_at?: string;
        fixed_in?: string;
        ghsa_id: string;
        id: number;
        node_id: string;
        number: number;
        severity: string;
        /** @enum {string} */
        state: "open" | "dismissed" | "fixed";
      } & {
        affected_package_name?: string;
        affected_range?: string;
        created_at?: string;
        dismiss_comment?: string | null;
        dismiss_reason: string;
        dismissed_at: string;
        /** User */
        dismisser: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        external_identifier?: string;
        external_reference?: string | null;
        fixed_in?: string;
        ghsa_id?: string;
        id?: number;
        node_id?: string;
        number?: number;
        severity?: string;
        /** @enum {string} */
        state: "dismissed";
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_vulnerability_alert reopen event */
    "webhook-repository-vulnerability-alert-reopen": {
      /** @enum {string} */
      action: "reopen";
      alert: {
        affected_package_name: string;
        affected_range: string;
        created_at: string;
        dismiss_reason?: string;
        dismissed_at?: string;
        /** User */
        dismisser?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        external_identifier: string;
        /** Format: uri */
        external_reference: string | null;
        fix_reason?: string;
        /** Format: date-time */
        fixed_at?: string;
        fixed_in?: string;
        ghsa_id: string;
        id: number;
        node_id: string;
        number: number;
        severity: string;
        /** @enum {string} */
        state: "open" | "dismissed" | "fixed";
      } & {
        affected_package_name?: string;
        affected_range?: string;
        created_at?: string;
        external_identifier?: string;
        external_reference?: string | null;
        fixed_in?: string;
        ghsa_id?: string;
        id?: number;
        node_id?: string;
        number?: number;
        severity?: string;
        /** @enum {string} */
        state: "open";
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** repository_vulnerability_alert resolve event */
    "webhook-repository-vulnerability-alert-resolve": {
      /** @enum {string} */
      action: "resolve";
      alert: {
        affected_package_name: string;
        affected_range: string;
        created_at: string;
        dismiss_reason?: string;
        dismissed_at?: string;
        /** User */
        dismisser?: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        external_identifier: string;
        /** Format: uri */
        external_reference: string | null;
        fix_reason?: string;
        /** Format: date-time */
        fixed_at?: string;
        fixed_in?: string;
        ghsa_id: string;
        id: number;
        node_id: string;
        number: number;
        severity: string;
        /** @enum {string} */
        state: "open" | "dismissed" | "fixed";
      } & {
        affected_package_name?: string;
        affected_range?: string;
        created_at?: string;
        external_identifier?: string;
        external_reference?: string | null;
        fix_reason?: string;
        /** Format: date-time */
        fixed_at?: string;
        fixed_in?: string;
        ghsa_id?: string;
        id?: number;
        node_id?: string;
        number?: number;
        severity?: string;
        /** @enum {string} */
        state: "fixed" | "open";
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** secret_scanning_alert created event */
    "webhook-secret-scanning-alert-created": {
      /** @enum {string} */
      action: "created";
      alert: components["schemas"]["secret-scanning-alert"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** Secret Scanning Alert Location Created Event */
    "webhook-secret-scanning-alert-location-created": {
      /** @enum {string} */
      action?: "created";
      alert: components["schemas"]["secret-scanning-alert"];
      installation?: components["schemas"]["simple-installation"];
      location: components["schemas"]["secret-scanning-location"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** Secret Scanning Alert Location Created Event */
    "webhook-secret-scanning-alert-location-created-form-encoded": {
      /** @description A URL-encoded string of the secret_scanning_alert_location.created JSON payload. The decoded payload is a JSON object. */
      payload: string;
    };
    /** secret_scanning_alert reopened event */
    "webhook-secret-scanning-alert-reopened": {
      /** @enum {string} */
      action: "reopened";
      alert: components["schemas"]["secret-scanning-alert"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** secret_scanning_alert resolved event */
    "webhook-secret-scanning-alert-resolved": {
      /** @enum {string} */
      action: "resolved";
      alert: {
        created_at?: components["schemas"]["alert-created-at"];
        html_url?: components["schemas"]["alert-html-url"];
        /**
         * Format: uri
         * @description The REST API URL of the code locations for this alert.
         */
        locations_url?: string;
        number?: components["schemas"]["alert-number"];
        /** @description Whether push protection was bypassed for the detected secret. */
        push_protection_bypassed?: boolean | null;
        /**
         * Format: date-time
         * @description The time that push protection was bypassed in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
         */
        push_protection_bypassed_at?: string | null;
        push_protection_bypassed_by?: components["schemas"]["nullable-simple-user"];
        /**
         * @description **Required when the `state` is `resolved`.** The reason for resolving the alert.
         * @enum {string|null}
         */
        resolution?:
          | ""
          | "false_positive"
          | "wont_fix"
          | "revoked"
          | "used_in_tests"
          | "pattern_deleted"
          | "pattern_edited"
          | null;
        /**
         * Format: date-time
         * @description The time that the alert was resolved in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`.
         */
        resolved_at?: string | null;
        resolved_by?: components["schemas"]["nullable-simple-user"];
        /** @description An optional comment to resolve an alert. */
        resolution_comment?: string | null;
        /** @description The secret that was detected. */
        secret?: string;
        /** @description The type of secret that secret scanning detected. */
        secret_type?: string;
        /**
         * @description User-friendly name for the detected secret, matching the `secret_type`.
         * For a list of built-in patterns, see "[Secret scanning patterns](https://docs.github.com/code-security/secret-scanning/secret-scanning-patterns#supported-secrets-for-advanced-security)."
         */
        secret_type_display_name?: string;
        state?: components["schemas"]["secret-scanning-alert-state"];
        updated_at?: components["schemas"]["alert-updated-at"];
        url?: components["schemas"]["alert-url"];
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** secret_scanning_alert revoked event */
    "webhook-secret-scanning-alert-revoked": {
      /** @enum {string} */
      action: "revoked";
      alert: components["schemas"]["secret-scanning-alert"];
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** security_advisory published event */
    "webhook-security-advisory-published": {
      /** @enum {string} */
      action: "published";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      /** @description The details of the security advisory, including summary, description, and severity. */
      security_advisory: {
        cvss: {
          score: number;
          vector_string: string | null;
        };
        cwes: {
          cwe_id: string;
          name: string;
        }[];
        description: string;
        ghsa_id: string;
        identifiers: {
          type: string;
          value: string;
        }[];
        published_at: string;
        references: {
          /** Format: uri */
          url: string;
        }[];
        severity: string;
        summary: string;
        updated_at: string;
        vulnerabilities: {
          first_patched_version: {
            identifier: string;
          } | null;
          package: {
            ecosystem: string;
            name: string;
          };
          severity: string;
          vulnerable_version_range: string;
        }[];
        withdrawn_at: string | null;
      };
      sender?: components["schemas"]["simple-user"];
    };
    /** security_advisory updated event */
    "webhook-security-advisory-updated": {
      /** @enum {string} */
      action: "updated";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      /** @description The details of the security advisory, including summary, description, and severity. */
      security_advisory: {
        cvss: {
          score: number;
          vector_string: string | null;
        };
        cwes: {
          cwe_id: string;
          name: string;
        }[];
        description: string;
        ghsa_id: string;
        identifiers: {
          type: string;
          value: string;
        }[];
        published_at: string;
        references: {
          /** Format: uri */
          url: string;
        }[];
        severity: string;
        summary: string;
        updated_at: string;
        vulnerabilities: {
          first_patched_version: {
            identifier: string;
          } | null;
          package: {
            ecosystem: string;
            name: string;
          };
          severity: string;
          vulnerable_version_range: string;
        }[];
        withdrawn_at: string | null;
      };
      sender?: components["schemas"]["simple-user"];
    };
    /** security_advisory withdrawn event */
    "webhook-security-advisory-withdrawn": {
      /** @enum {string} */
      action: "withdrawn";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      /** @description The details of the security advisory, including summary, description, and severity. */
      security_advisory: {
        cvss: {
          score: number;
          vector_string: string | null;
        };
        cwes: {
          cwe_id: string;
          name: string;
        }[];
        description: string;
        ghsa_id: string;
        identifiers: {
          type: string;
          value: string;
        }[];
        published_at: string;
        references: {
          /** Format: uri */
          url: string;
        }[];
        severity: string;
        summary: string;
        updated_at: string;
        vulnerabilities: {
          first_patched_version: {
            identifier: string;
          } | null;
          package: {
            ecosystem: string;
            name: string;
          };
          severity: string;
          vulnerable_version_range: string;
        }[];
        withdrawn_at: string;
      };
      sender?: components["schemas"]["simple-user"];
    };
    /** security_and_analysis event */
    "webhook-security-and-analysis": {
      changes: {
        from?: {
          security_and_analysis?: components["schemas"]["security-and-analysis"];
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["full-repository"];
      sender?: components["schemas"]["simple-user"];
    };
    /** sponsorship cancelled event */
    "webhook-sponsorship-cancelled": {
      /** @enum {string} */
      action: "cancelled";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** sponsorship created event */
    "webhook-sponsorship-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** sponsorship edited event */
    "webhook-sponsorship-edited": {
      /** @enum {string} */
      action: "edited";
      changes: {
        privacy_level?: {
          /** @description The `edited` event types include the details about the change when someone edits a sponsorship to change the privacy. */
          from: string;
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** sponsorship pending_cancellation event */
    "webhook-sponsorship-pending-cancellation": {
      /** @enum {string} */
      action: "pending_cancellation";
      /** @description The `pending_cancellation` and `pending_tier_change` event types will include the date the cancellation or tier change will take effect. */
      effective_date?: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** sponsorship pending_tier_change event */
    "webhook-sponsorship-pending-tier-change": {
      /** @enum {string} */
      action: "pending_tier_change";
      changes: {
        tier: {
          /**
           * Sponsorship Tier
           * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
           */
          from: {
            created_at: string;
            description: string;
            is_custom_ammount?: boolean;
            is_custom_amount?: boolean;
            is_one_time: boolean;
            monthly_price_in_cents: number;
            monthly_price_in_dollars: number;
            name: string;
            node_id: string;
          };
        };
      };
      /** @description The `pending_cancellation` and `pending_tier_change` event types will include the date the cancellation or tier change will take effect. */
      effective_date?: string;
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** sponsorship tier_changed event */
    "webhook-sponsorship-tier-changed": {
      /** @enum {string} */
      action: "tier_changed";
      changes: {
        tier: {
          /**
           * Sponsorship Tier
           * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
           */
          from: {
            created_at: string;
            description: string;
            is_custom_ammount?: boolean;
            is_custom_amount?: boolean;
            is_one_time: boolean;
            monthly_price_in_cents: number;
            monthly_price_in_dollars: number;
            name: string;
            node_id: string;
          };
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository?: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      sponsorship: {
        created_at: string;
        maintainer?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        node_id: string;
        privacy_level: string;
        /** User */
        sponsor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** User */
        sponsorable: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /**
         * Sponsorship Tier
         * @description The `tier_changed` and `pending_tier_change` will include the original tier before the change or pending change. For more information, see the pending tier change payload.
         */
        tier: {
          created_at: string;
          description: string;
          is_custom_ammount?: boolean;
          is_custom_amount?: boolean;
          is_one_time: boolean;
          monthly_price_in_cents: number;
          monthly_price_in_dollars: number;
          name: string;
          node_id: string;
        };
      };
    };
    /** star created event */
    "webhook-star-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** @description The time the star was created. This is a timestamp in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`. Will be `null` for the `deleted` action. */
      starred_at: string | null;
    };
    /** star deleted event */
    "webhook-star-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** @description The time the star was created. This is a timestamp in ISO 8601 format: `YYYY-MM-DDTHH:MM:SSZ`. Will be `null` for the `deleted` action. */
      starred_at: Record<string, unknown> | null;
    };
    /** status event */
    "webhook-status": {
      /** Format: uri */
      avatar_url?: string | null;
      /** @description An array of branch objects containing the status' SHA. Each branch contains the given SHA, but the SHA may or may not be the head of the branch. The array includes a maximum of 10 branches. */
      branches: {
        commit: {
          sha: string | null;
          /** Format: uri */
          url: string | null;
        };
        name: string;
        protected: boolean;
      }[];
      commit: {
        /** User */
        author: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id?: number;
          login?: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        comments_url: string;
        commit: {
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          } & {
            date: string;
            email?: string;
            name?: string;
          };
          comment_count: number;
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          } & {
            date: string;
            email?: string;
            name?: string;
          };
          message: string;
          tree: {
            sha: string;
            /** Format: uri */
            url: string;
          };
          /** Format: uri */
          url: string;
          verification: {
            payload: string | null;
            /** @enum {string} */
            reason:
              | "expired_key"
              | "not_signing_key"
              | "gpgverify_error"
              | "gpgverify_unavailable"
              | "unsigned"
              | "unknown_signature_type"
              | "no_user"
              | "unverified_email"
              | "bad_email"
              | "unknown_key"
              | "malformed_signature"
              | "invalid"
              | "valid"
              | "bad_cert"
              | "ocsp_pending";
            signature: string | null;
            verified: boolean;
          };
        };
        /** User */
        committer: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id?: number;
          login?: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        html_url: string;
        node_id: string;
        parents: {
          /** Format: uri */
          html_url: string;
          sha: string;
          /** Format: uri */
          url: string;
        }[];
        sha: string;
        /** Format: uri */
        url: string;
      };
      context: string;
      created_at: string;
      /** @description The optional human-readable description added to the status. */
      description: string | null;
      enterprise?: components["schemas"]["enterprise"];
      /** @description The unique identifier of the status. */
      id: number;
      installation?: components["schemas"]["simple-installation"];
      name: string;
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** @description The Commit SHA. */
      sha: string;
      /**
       * @description The new state. Can be `pending`, `success`, `failure`, or `error`.
       * @enum {string}
       */
      state: "pending" | "success" | "failure" | "error";
      /** @description The optional link added to the status. */
      target_url: string | null;
      updated_at: string;
    };
    /** team_add event */
    "webhook-team-add": {
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** team added_to_repository event */
    "webhook-team-added-to-repository": {
      /** @enum {string} */
      action: "added_to_repository";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      /**
       * Repository
       * @description A git repository
       */
      repository?: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
      };
      sender?: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** team created event */
    "webhook-team-created": {
      /** @enum {string} */
      action: "created";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      /**
       * Repository
       * @description A git repository
       */
      repository?: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
      };
      sender: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** team deleted event */
    "webhook-team-deleted": {
      /** @enum {string} */
      action: "deleted";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      /**
       * Repository
       * @description A git repository
       */
      repository?: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
      };
      sender?: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** team edited event */
    "webhook-team-edited": {
      /** @enum {string} */
      action: "edited";
      /** @description The changes to the team if the action was `edited`. */
      changes: {
        description?: {
          /** @description The previous version of the description if the action was `edited`. */
          from: string;
        };
        name?: {
          /** @description The previous version of the name if the action was `edited`. */
          from: string;
        };
        privacy?: {
          /** @description The previous version of the team's privacy if the action was `edited`. */
          from: string;
        };
        notification_setting?: {
          /** @description The previous version of the team's notification setting if the action was `edited`. */
          from: string;
        };
        repository?: {
          permissions: {
            from: {
              /** @description The previous version of the team member's `admin` permission on a repository, if the action was `edited`. */
              admin?: boolean;
              /** @description The previous version of the team member's `pull` permission on a repository, if the action was `edited`. */
              pull?: boolean;
              /** @description The previous version of the team member's `push` permission on a repository, if the action was `edited`. */
              push?: boolean;
            };
          };
        };
      };
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      /**
       * Repository
       * @description A git repository
       */
      repository?: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
      };
      sender: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** team removed_from_repository event */
    "webhook-team-removed-from-repository": {
      /** @enum {string} */
      action: "removed_from_repository";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization: components["schemas"]["organization-simple"];
      /**
       * Repository
       * @description A git repository
       */
      repository?: {
        /**
         * @description Whether to allow auto-merge for pull requests.
         * @default false
         */
        allow_auto_merge?: boolean;
        /** @description Whether to allow private forks */
        allow_forking?: boolean;
        /**
         * @description Whether to allow merge commits for pull requests.
         * @default true
         */
        allow_merge_commit?: boolean;
        /**
         * @description Whether to allow rebase merges for pull requests.
         * @default true
         */
        allow_rebase_merge?: boolean;
        /**
         * @description Whether to allow squash merges for pull requests.
         * @default true
         */
        allow_squash_merge?: boolean;
        allow_update_branch?: boolean;
        /** Format: uri-template */
        archive_url: string;
        /**
         * @description Whether the repository is archived.
         * @default false
         */
        archived: boolean;
        /** Format: uri-template */
        assignees_url: string;
        /** Format: uri-template */
        blobs_url: string;
        /** Format: uri-template */
        branches_url: string;
        /** Format: uri */
        clone_url: string;
        /** Format: uri-template */
        collaborators_url: string;
        /** Format: uri-template */
        comments_url: string;
        /** Format: uri-template */
        commits_url: string;
        /** Format: uri-template */
        compare_url: string;
        /** Format: uri-template */
        contents_url: string;
        /** Format: uri */
        contributors_url: string;
        created_at: number | string;
        /** @description The default branch of the repository. */
        default_branch: string;
        /**
         * @description Whether to delete head branches when pull requests are merged
         * @default false
         */
        delete_branch_on_merge?: boolean;
        /** Format: uri */
        deployments_url: string;
        description: string | null;
        /** @description Returns whether or not this repository is disabled. */
        disabled?: boolean;
        /** Format: uri */
        downloads_url: string;
        /** Format: uri */
        events_url: string;
        fork: boolean;
        forks: number;
        forks_count: number;
        /** Format: uri */
        forks_url: string;
        full_name: string;
        /** Format: uri-template */
        git_commits_url: string;
        /** Format: uri-template */
        git_refs_url: string;
        /** Format: uri-template */
        git_tags_url: string;
        /** Format: uri */
        git_url: string;
        /**
         * @description Whether downloads are enabled.
         * @default true
         */
        has_downloads: boolean;
        /**
         * @description Whether issues are enabled.
         * @default true
         */
        has_issues: boolean;
        has_pages: boolean;
        /**
         * @description Whether projects are enabled.
         * @default true
         */
        has_projects: boolean;
        /**
         * @description Whether the wiki is enabled.
         * @default true
         */
        has_wiki: boolean;
        homepage: string | null;
        /** Format: uri */
        hooks_url: string;
        /** Format: uri */
        html_url: string;
        /** @description Unique identifier of the repository */
        id: number;
        is_template?: boolean;
        /** Format: uri-template */
        issue_comment_url: string;
        /** Format: uri-template */
        issue_events_url: string;
        /** Format: uri-template */
        issues_url: string;
        /** Format: uri-template */
        keys_url: string;
        /** Format: uri-template */
        labels_url: string;
        language: string | null;
        /** Format: uri */
        languages_url: string;
        /** License */
        license: {
          key: string;
          name: string;
          node_id: string;
          spdx_id: string;
          /** Format: uri */
          url: string | null;
        } | null;
        master_branch?: string;
        /** Format: uri */
        merges_url: string;
        /** Format: uri-template */
        milestones_url: string;
        /** Format: uri */
        mirror_url: string | null;
        /** @description The name of the repository. */
        name: string;
        node_id: string;
        /** Format: uri-template */
        notifications_url: string;
        open_issues: number;
        open_issues_count: number;
        organization?: string;
        /** User */
        owner: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        permissions?: {
          admin: boolean;
          maintain?: boolean;
          pull: boolean;
          push: boolean;
          triage?: boolean;
        };
        /** @description Whether the repository is private or public. */
        private: boolean;
        public?: boolean;
        /** Format: uri-template */
        pulls_url: string;
        pushed_at: number | string;
        /** Format: uri-template */
        releases_url: string;
        role_name?: string | null;
        size: number;
        ssh_url: string;
        stargazers?: number;
        stargazers_count: number;
        /** Format: uri */
        stargazers_url: string;
        /** Format: uri-template */
        statuses_url: string;
        /** Format: uri */
        subscribers_url: string;
        /** Format: uri */
        subscription_url: string;
        /** Format: uri */
        svn_url: string;
        /** Format: uri */
        tags_url: string;
        /** Format: uri */
        teams_url: string;
        topics: string[];
        /** Format: uri-template */
        trees_url: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        /** @enum {string} */
        visibility: "public" | "private" | "internal";
        watchers: number;
        watchers_count: number;
      };
      sender: components["schemas"]["simple-user"];
      /**
       * Team
       * @description Groups of organization members that gives permissions on specified repositories.
       */
      team: {
        deleted?: boolean;
        /** @description Description of the team */
        description?: string | null;
        /** Format: uri */
        html_url?: string;
        /** @description Unique identifier of the team */
        id: number;
        /** Format: uri-template */
        members_url?: string;
        /** @description Name of the team */
        name: string;
        node_id?: string;
        parent?: {
          /** @description Description of the team */
          description: string | null;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the team */
          id: number;
          /** Format: uri-template */
          members_url: string;
          /** @description Name of the team */
          name: string;
          node_id: string;
          /** @description Permission that the team will have for its repositories */
          permission: string;
          /** @enum {string} */
          privacy: "open" | "closed" | "secret";
          /**
           * @description Whether team members will receive notifications when their team is @mentioned
           * @enum {string}
           */
          notification_setting:
            | "notifications_enabled"
            | "notifications_disabled";
          /** Format: uri */
          repositories_url: string;
          slug: string;
          /**
           * Format: uri
           * @description URL for the team
           */
          url: string;
        } | null;
        /** @description Permission that the team will have for its repositories */
        permission?: string;
        /** @enum {string} */
        privacy?: "open" | "closed" | "secret";
        /**
         * @description Whether team members will receive notifications when their team is @mentioned
         * @enum {string}
         */
        notification_setting?:
          | "notifications_enabled"
          | "notifications_disabled";
        /** Format: uri */
        repositories_url?: string;
        slug?: string;
        /**
         * Format: uri
         * @description URL for the team
         */
        url?: string;
      };
    };
    /** watch started event */
    "webhook-watch-started": {
      /** @enum {string} */
      action: "started";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
    };
    /** workflow_dispatch event */
    "webhook-workflow-dispatch": {
      enterprise?: components["schemas"]["enterprise"];
      inputs: {
        [key: string]: unknown;
      } | null;
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      ref: string;
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      workflow: string;
    };
    /** workflow_job completed event */
    "webhook-workflow-job-completed": {
      /** @enum {string} */
      action: "completed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      workflow_job: {
        /** Format: uri */
        check_run_url: string;
        completed_at: string | null;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | ""
          | "skipped"
          | "cancelled"
          | "action_required"
          | "neutral"
          | "timed_out"
          | null;
        /** @description The time that the job created. */
        created_at: string;
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Custom labels for the job. Specified by the [`"runs-on"` attribute](https://docs.github.com/actions/reference/workflow-syntax-for-github-actions#jobsjob_idruns-on) in the workflow YAML. */
        labels: string[];
        name: string;
        node_id: string;
        run_attempt: number;
        run_id: number;
        /** Format: uri */
        run_url: string;
        /** @description The ID of the runner group that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_group_id: number | null;
        /** @description The name of the runner group that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_group_name: string | null;
        /** @description The ID of the runner that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_id: number | null;
        /** @description The name of the runner that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_name: string | null;
        started_at: string;
        /**
         * @description The current status of the job. Can be `queued`, `in_progress`, `waiting`, or `completed`.
         * @enum {string}
         */
        status: "queued" | "in_progress" | "completed" | "waiting";
        /** @description The name of the current branch. */
        head_branch: string | null;
        /** @description The name of the workflow. */
        workflow_name: string | null;
        steps: {
          completed_at: string | null;
          /** @enum {string|null} */
          conclusion:
            | "failure"
            | "skipped"
            | "success"
            | "cancelled"
            | ""
            | null;
          name: string;
          number: number;
          started_at: string | null;
          /** @enum {string} */
          status: "in_progress" | "completed" | "queued";
        }[];
        /** Format: uri */
        url: string;
      } & {
        check_run_url?: string;
        completed_at?: string;
        /** @enum {string} */
        conclusion:
          | "success"
          | "failure"
          | "skipped"
          | "cancelled"
          | "action_required"
          | "neutral"
          | "timed_out";
        /** @description The time that the job created. */
        created_at?: string;
        head_sha?: string;
        html_url?: string;
        id?: number;
        labels?: (string | null)[];
        name?: string;
        node_id?: string;
        run_attempt?: number;
        run_id?: number;
        run_url?: string;
        runner_group_id?: number | null;
        runner_group_name?: string | null;
        runner_id?: number | null;
        runner_name?: string | null;
        started_at?: string;
        status?: string;
        /** @description The name of the current branch. */
        head_branch?: string | null;
        /** @description The name of the workflow. */
        workflow_name?: string | null;
        steps?: (Record<string, unknown> | null)[];
        url?: string;
      };
      deployment?: components["schemas"]["deployment"];
    };
    /** workflow_job in_progress event */
    "webhook-workflow-job-in-progress": {
      /** @enum {string} */
      action: "in_progress";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      workflow_job: {
        /** Format: uri */
        check_run_url: string;
        completed_at: string | null;
        /** @enum {string|null} */
        conclusion: "success" | "failure" | "" | "cancelled" | "neutral" | null;
        /** @description The time that the job created. */
        created_at: string;
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        /** @description Custom labels for the job. Specified by the [`"runs-on"` attribute](https://docs.github.com/actions/reference/workflow-syntax-for-github-actions#jobsjob_idruns-on) in the workflow YAML. */
        labels: string[];
        name: string;
        node_id: string;
        run_attempt: number;
        run_id: number;
        /** Format: uri */
        run_url: string;
        /** @description The ID of the runner group that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_group_id: number | null;
        /** @description The name of the runner group that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_group_name: string | null;
        /** @description The ID of the runner that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_id: number | null;
        /** @description The name of the runner that is running this job. This will be `null` as long as `workflow_job[status]` is `queued`. */
        runner_name: string | null;
        started_at: string;
        /**
         * @description The current status of the job. Can be `queued`, `in_progress`, or `completed`.
         * @enum {string}
         */
        status: "queued" | "in_progress" | "completed";
        /** @description The name of the current branch. */
        head_branch: string | null;
        /** @description The name of the workflow. */
        workflow_name: string | null;
        steps: {
          completed_at: string | null;
          /** @enum {string|null} */
          conclusion:
            | "failure"
            | "skipped"
            | "success"
            | ""
            | "cancelled"
            | null;
          name: string;
          number: number;
          started_at: string | null;
          /** @enum {string} */
          status: "in_progress" | "completed" | "queued" | "pending";
        }[];
        /** Format: uri */
        url: string;
      } & {
        check_run_url?: string;
        completed_at?: string | null;
        conclusion?: string | null;
        /** @description The time that the job created. */
        created_at?: string;
        head_sha?: string;
        html_url?: string;
        id?: number;
        labels?: string[];
        name?: string;
        node_id?: string;
        run_attempt?: number;
        run_id?: number;
        run_url?: string;
        runner_group_id?: number | null;
        runner_group_name?: string | null;
        runner_id?: number | null;
        runner_name?: string | null;
        started_at?: string;
        /** @enum {string} */
        status: "in_progress" | "completed" | "queued";
        /** @description The name of the current branch. */
        head_branch?: string | null;
        /** @description The name of the workflow. */
        workflow_name?: string | null;
        steps: {
          completed_at: string | null;
          conclusion: string | null;
          name: string;
          number: number;
          started_at: string | null;
          /** @enum {string} */
          status: "in_progress" | "completed" | "pending" | "queued";
        }[];
        url?: string;
      };
      deployment?: components["schemas"]["deployment"];
    };
    /** workflow_job queued event */
    "webhook-workflow-job-queued": {
      /** @enum {string} */
      action: "queued";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      workflow_job: {
        /** Format: uri */
        check_run_url: string;
        completed_at: string | null;
        conclusion: string | null;
        /** @description The time that the job created. */
        created_at: string;
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        labels: string[];
        name: string;
        node_id: string;
        run_attempt: number;
        run_id: number;
        /** Format: uri */
        run_url: string;
        runner_group_id: number | null;
        runner_group_name: string | null;
        runner_id: number | null;
        runner_name: string | null;
        /** Format: date-time */
        started_at: string;
        /** @enum {string} */
        status: "queued" | "in_progress" | "completed" | "waiting";
        /** @description The name of the current branch. */
        head_branch: string | null;
        /** @description The name of the workflow. */
        workflow_name: string | null;
        steps: {
          completed_at: string | null;
          /** @enum {string|null} */
          conclusion:
            | "failure"
            | "skipped"
            | "success"
            | "cancelled"
            | ""
            | null;
          name: string;
          number: number;
          started_at: string | null;
          /** @enum {string} */
          status: "completed" | "in_progress" | "queued" | "pending";
        }[];
        /** Format: uri */
        url: string;
      };
      deployment?: components["schemas"]["deployment"];
    };
    /** workflow_job waiting event */
    "webhook-workflow-job-waiting": {
      /** @enum {string} */
      action: "waiting";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      workflow_job: {
        /** Format: uri */
        check_run_url: string;
        completed_at: string | null;
        conclusion: string | null;
        /** @description The time that the job created. */
        created_at: string;
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        labels: string[];
        name: string;
        node_id: string;
        run_attempt: number;
        run_id: number;
        /** Format: uri */
        run_url: string;
        runner_group_id: number | null;
        runner_group_name: string | null;
        runner_id: number | null;
        runner_name: string | null;
        /** Format: date-time */
        started_at: string;
        /** @description The name of the current branch. */
        head_branch: string | null;
        /** @description The name of the workflow. */
        workflow_name: string | null;
        /** @enum {string} */
        status: "queued" | "in_progress" | "completed" | "waiting";
        steps: {
          completed_at: string | null;
          /** @enum {string|null} */
          conclusion:
            | "failure"
            | "skipped"
            | "success"
            | "cancelled"
            | ""
            | null;
          name: string;
          number: number;
          started_at: string | null;
          /** @enum {string} */
          status:
            | "completed"
            | "in_progress"
            | "queued"
            | "pending"
            | "waiting";
        }[];
        /** Format: uri */
        url: string;
      };
      deployment?: components["schemas"]["deployment"];
    };
    /** workflow_run completed event */
    "webhook-workflow-run-completed": {
      /** @enum {string} */
      action: "completed";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** Workflow */
      workflow: {
        /** Format: uri */
        badge_url: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        node_id: string;
        path: string;
        state: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } | null;
      workflow_run: {
        /** User */
        actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        artifacts_url: string;
        /** Format: uri */
        cancel_url: string;
        check_suite_id: number;
        check_suite_node_id: string;
        /** Format: uri */
        check_suite_url: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | "skipped"
          | null;
        /** Format: date-time */
        created_at: string;
        event: string;
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** Repository Lite */
        head_repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        jobs_url: string;
        /** Format: uri */
        logs_url: string;
        name: string | null;
        node_id: string;
        path: string;
        /** Format: uri */
        previous_attempt_url: string | null;
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        /** Repository Lite */
        repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        rerun_url: string;
        run_attempt: number;
        run_number: number;
        /** Format: date-time */
        run_started_at: string;
        /** @enum {string} */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | "pending"
          | "waiting";
        /** User */
        triggering_actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        workflow_id: number;
        /** Format: uri */
        workflow_url: string;
      } & {
        actor?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        artifacts_url?: string;
        cancel_url?: string;
        check_suite_id?: number;
        check_suite_node_id?: string;
        check_suite_url?: string;
        /** @enum {string} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | "skipped";
        created_at?: string;
        event?: string;
        head_branch?: string | null;
        head_commit?: {
          author?: {
            email?: string;
            name?: string;
          };
          committer?: {
            email?: string;
            name?: string;
          };
          id?: string;
          message?: string;
          timestamp?: string;
          tree_id?: string;
        };
        head_repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: string | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        head_sha?: string;
        html_url?: string;
        id?: number;
        jobs_url?: string;
        logs_url?: string;
        name?: string | null;
        node_id?: string;
        path?: string;
        previous_attempt_url?: string | null;
        pull_requests?: (Record<string, unknown> | null)[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: string | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        rerun_url?: string;
        run_attempt?: number;
        run_number?: number;
        run_started_at?: string;
        status?: string;
        triggering_actor?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        } | null;
        updated_at?: string;
        url?: string;
        workflow_id?: number;
        workflow_url?: string;
      };
    };
    /** workflow_run in_progress event */
    "webhook-workflow-run-in-progress": {
      /** @enum {string} */
      action: "in_progress";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** Workflow */
      workflow: {
        /** Format: uri */
        badge_url: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        node_id: string;
        path: string;
        state: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } | null;
      workflow_run: {
        /** User */
        actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        artifacts_url: string;
        /** Format: uri */
        cancel_url: string;
        check_suite_id: number;
        check_suite_node_id: string;
        /** Format: uri */
        check_suite_url: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | "skipped"
          | ""
          | null;
        /** Format: date-time */
        created_at: string;
        event: string;
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** Repository Lite */
        head_repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        jobs_url: string;
        /** Format: uri */
        logs_url: string;
        name: string | null;
        node_id: string;
        path: string;
        /** Format: uri */
        previous_attempt_url: string | null;
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        /** Repository Lite */
        repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        rerun_url: string;
        run_attempt: number;
        run_number: number;
        /** Format: date-time */
        run_started_at: string;
        /** @enum {string} */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | "pending";
        /** User */
        triggering_actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        workflow_id: number;
        /** Format: uri */
        workflow_url: string;
      } & {
        actor?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        artifacts_url?: string;
        cancel_url?: string;
        check_suite_id?: number;
        check_suite_node_id?: string;
        check_suite_url?: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "skipped"
          | "stale"
          | null;
        created_at?: string;
        event?: string;
        head_branch?: string | null;
        head_commit?: {
          author?: {
            email?: string;
            name?: string;
          };
          committer?: {
            email?: string;
            name?: string;
          };
          id?: string;
          message?: string;
          timestamp?: string;
          tree_id?: string;
        };
        head_repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: string | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string | null;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        head_sha?: string;
        html_url?: string;
        id?: number;
        jobs_url?: string;
        logs_url?: string;
        name?: string | null;
        node_id?: string;
        path?: string;
        previous_attempt_url?: string | null;
        pull_requests?: (Record<string, unknown> | null)[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        repository?: {
          archive_url?: string;
          assignees_url?: string;
          blobs_url?: string;
          branches_url?: string;
          collaborators_url?: string;
          comments_url?: string;
          commits_url?: string;
          compare_url?: string;
          contents_url?: string;
          contributors_url?: string;
          deployments_url?: string;
          description?: string | null;
          downloads_url?: string;
          events_url?: string;
          fork?: boolean;
          forks_url?: string;
          full_name?: string;
          git_commits_url?: string;
          git_refs_url?: string;
          git_tags_url?: string;
          hooks_url?: string;
          html_url?: string;
          id?: number;
          issue_comment_url?: string;
          issue_events_url?: string;
          issues_url?: string;
          keys_url?: string;
          labels_url?: string;
          languages_url?: string;
          merges_url?: string;
          milestones_url?: string;
          name?: string;
          node_id?: string;
          notifications_url?: string;
          owner?: {
            avatar_url?: string;
            events_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            gravatar_id?: string;
            html_url?: string;
            id?: number;
            login?: string;
            node_id?: string;
            organizations_url?: string;
            received_events_url?: string;
            repos_url?: string;
            site_admin?: boolean;
            starred_url?: string;
            subscriptions_url?: string;
            type?: string;
            url?: string;
          };
          private?: boolean;
          pulls_url?: string;
          releases_url?: string;
          stargazers_url?: string;
          statuses_url?: string;
          subscribers_url?: string;
          subscription_url?: string;
          tags_url?: string;
          teams_url?: string;
          trees_url?: string;
          url?: string;
        };
        rerun_url?: string;
        run_attempt?: number;
        run_number?: number;
        run_started_at?: string;
        status?: string;
        triggering_actor?: {
          avatar_url?: string;
          events_url?: string;
          followers_url?: string;
          following_url?: string;
          gists_url?: string;
          gravatar_id?: string;
          html_url?: string;
          id?: number;
          login?: string;
          node_id?: string;
          organizations_url?: string;
          received_events_url?: string;
          repos_url?: string;
          site_admin?: boolean;
          starred_url?: string;
          subscriptions_url?: string;
          type?: string;
          url?: string;
        };
        updated_at?: string;
        url?: string;
        workflow_id?: number;
        workflow_url?: string;
      };
    };
    /** workflow_run requested event */
    "webhook-workflow-run-requested": {
      /** @enum {string} */
      action: "requested";
      enterprise?: components["schemas"]["enterprise"];
      installation?: components["schemas"]["simple-installation"];
      organization?: components["schemas"]["organization-simple"];
      repository: components["schemas"]["repository"];
      sender: components["schemas"]["simple-user"];
      /** Workflow */
      workflow: {
        /** Format: uri */
        badge_url: string;
        /** Format: date-time */
        created_at: string;
        /** Format: uri */
        html_url: string;
        id: number;
        name: string;
        node_id: string;
        path: string;
        state: string;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
      } | null;
      /** Workflow Run */
      workflow_run: {
        /** User */
        actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: uri */
        artifacts_url: string;
        /** Format: uri */
        cancel_url: string;
        check_suite_id: number;
        check_suite_node_id: string;
        /** Format: uri */
        check_suite_url: string;
        /** @enum {string|null} */
        conclusion:
          | "success"
          | "failure"
          | "neutral"
          | "cancelled"
          | "timed_out"
          | "action_required"
          | "stale"
          | ""
          | "skipped"
          | "startup_failure"
          | null;
        /** Format: date-time */
        created_at: string;
        event: string;
        head_branch: string | null;
        /** SimpleCommit */
        head_commit: {
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          author: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          /**
           * Committer
           * @description Metaproperties for Git author/committer information.
           */
          committer: {
            /** Format: date-time */
            date?: string;
            /** Format: email */
            email: string | null;
            /** @description The git author's name. */
            name: string;
            username?: string;
          };
          id: string;
          message: string;
          timestamp: string;
          tree_id: string;
        };
        /** Repository Lite */
        head_repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        head_sha: string;
        /** Format: uri */
        html_url: string;
        id: number;
        /** Format: uri */
        jobs_url: string;
        /** Format: uri */
        logs_url: string;
        name: string | null;
        node_id: string;
        path: string;
        /** Format: uri */
        previous_attempt_url: string | null;
        pull_requests: {
          base: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          head: {
            ref: string;
            /** Repo Ref */
            repo: {
              id: number;
              name: string;
              /** Format: uri */
              url: string;
            };
            sha: string;
          };
          id: number;
          number: number;
          /** Format: uri */
          url: string;
        }[];
        referenced_workflows?:
          | {
              path: string;
              ref?: string;
              sha: string;
            }[]
          | null;
        /** Repository Lite */
        repository: {
          /** Format: uri-template */
          archive_url: string;
          /** Format: uri-template */
          assignees_url: string;
          /** Format: uri-template */
          blobs_url: string;
          /** Format: uri-template */
          branches_url: string;
          /** Format: uri-template */
          collaborators_url: string;
          /** Format: uri-template */
          comments_url: string;
          /** Format: uri-template */
          commits_url: string;
          /** Format: uri-template */
          compare_url: string;
          /** Format: uri-template */
          contents_url: string;
          /** Format: uri */
          contributors_url: string;
          /** Format: uri */
          deployments_url: string;
          description: string | null;
          /** Format: uri */
          downloads_url: string;
          /** Format: uri */
          events_url: string;
          fork: boolean;
          /** Format: uri */
          forks_url: string;
          full_name: string;
          /** Format: uri-template */
          git_commits_url: string;
          /** Format: uri-template */
          git_refs_url: string;
          /** Format: uri-template */
          git_tags_url: string;
          /** Format: uri */
          hooks_url: string;
          /** Format: uri */
          html_url: string;
          /** @description Unique identifier of the repository */
          id: number;
          /** Format: uri-template */
          issue_comment_url: string;
          /** Format: uri-template */
          issue_events_url: string;
          /** Format: uri-template */
          issues_url: string;
          /** Format: uri-template */
          keys_url: string;
          /** Format: uri-template */
          labels_url: string;
          /** Format: uri */
          languages_url: string;
          /** Format: uri */
          merges_url: string;
          /** Format: uri-template */
          milestones_url: string;
          /** @description The name of the repository. */
          name: string;
          node_id: string;
          /** Format: uri-template */
          notifications_url: string;
          /** User */
          owner: {
            /** Format: uri */
            avatar_url?: string;
            deleted?: boolean;
            email?: string | null;
            /** Format: uri-template */
            events_url?: string;
            /** Format: uri */
            followers_url?: string;
            /** Format: uri-template */
            following_url?: string;
            /** Format: uri-template */
            gists_url?: string;
            gravatar_id?: string;
            /** Format: uri */
            html_url?: string;
            id: number;
            login: string;
            name?: string;
            node_id?: string;
            /** Format: uri */
            organizations_url?: string;
            /** Format: uri */
            received_events_url?: string;
            /** Format: uri */
            repos_url?: string;
            site_admin?: boolean;
            /** Format: uri-template */
            starred_url?: string;
            /** Format: uri */
            subscriptions_url?: string;
            /** @enum {string} */
            type?: "Bot" | "User" | "Organization";
            /** Format: uri */
            url?: string;
          } | null;
          /** @description Whether the repository is private or public. */
          private: boolean;
          /** Format: uri-template */
          pulls_url: string;
          /** Format: uri-template */
          releases_url: string;
          /** Format: uri */
          stargazers_url: string;
          /** Format: uri-template */
          statuses_url: string;
          /** Format: uri */
          subscribers_url: string;
          /** Format: uri */
          subscription_url: string;
          /** Format: uri */
          tags_url: string;
          /** Format: uri */
          teams_url: string;
          /** Format: uri-template */
          trees_url: string;
          /** Format: uri */
          url: string;
        };
        /** Format: uri */
        rerun_url: string;
        run_attempt: number;
        run_number: number;
        /** Format: date-time */
        run_started_at: string;
        /** @enum {string} */
        status:
          | "requested"
          | "in_progress"
          | "completed"
          | "queued"
          | "pending"
          | "waiting";
        /** User */
        triggering_actor: {
          /** Format: uri */
          avatar_url?: string;
          deleted?: boolean;
          email?: string | null;
          /** Format: uri-template */
          events_url?: string;
          /** Format: uri */
          followers_url?: string;
          /** Format: uri-template */
          following_url?: string;
          /** Format: uri-template */
          gists_url?: string;
          gravatar_id?: string;
          /** Format: uri */
          html_url?: string;
          id: number;
          login: string;
          name?: string;
          node_id?: string;
          /** Format: uri */
          organizations_url?: string;
          /** Format: uri */
          received_events_url?: string;
          /** Format: uri */
          repos_url?: string;
          site_admin?: boolean;
          /** Format: uri-template */
          starred_url?: string;
          /** Format: uri */
          subscriptions_url?: string;
          /** @enum {string} */
          type?: "Bot" | "User" | "Organization";
          /** Format: uri */
          url?: string;
        } | null;
        /** Format: date-time */
        updated_at: string;
        /** Format: uri */
        url: string;
        workflow_id: number;
        /** Format: uri */
        workflow_url: string;
        display_title: string;
      };
    };
  };
  responses: {
    /** @description Resource not found */
    not_found: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Validation failed, or the endpoint has been spammed. */
    validation_failed_simple: {
      content: {
        "application/json": components["schemas"]["validation-error-simple"];
      };
    };
    /** @description Bad Request */
    bad_request: {
      content: {
        "application/json": components["schemas"]["basic-error"];
        "application/scim+json": components["schemas"]["scim-error"];
      };
    };
    /** @description Validation failed, or the endpoint has been spammed. */
    validation_failed: {
      content: {
        "application/json": components["schemas"]["validation-error"];
      };
    };
    /** @description Accepted */
    accepted: {
      content: {
        "application/json": Record<string, never>;
      };
    };
    /** @description Not modified */
    not_modified: never;
    /** @description Requires authentication */
    requires_authentication: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Forbidden */
    forbidden: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Service unavailable */
    service_unavailable: {
      content: {
        "application/json": {
          code?: string;
          message?: string;
          documentation_url?: string;
        };
      };
    };
    /** @description Forbidden Gist */
    forbidden_gist: {
      content: {
        "application/json": {
          block?: {
            reason?: string;
            created_at?: string;
            html_url?: string | null;
          };
          message?: string;
          documentation_url?: string;
        };
      };
    };
    /** @description Moved permanently */
    moved_permanently: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Internal Error */
    internal_error: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description A header with no content is returned. */
    no_content: never;
    /** @description Conflict */
    conflict: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Response */
    actions_runner_labels: {
      content: {
        "application/json": {
          total_count: number;
          labels: components["schemas"]["runner-label"][];
        };
      };
    };
    /** @description Response */
    actions_runner_labels_readonly: {
      content: {
        "application/json": {
          total_count: number;
          labels: components["schemas"]["runner-label"][];
        };
      };
    };
    /** @description The value of `per_page` multiplied by `page` cannot be greater than 10000. */
    package_es_list_error: never;
    /** @description Gone */
    gone: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Temporary Redirect */
    temporary_redirect: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Response if GitHub Advanced Security is not enabled for this repository */
    code_scanning_forbidden_read: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Response if the repository is archived or if GitHub Advanced Security is not enabled for this repository */
    code_scanning_forbidden_write: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Found */
    found: never;
    /** @description Response if there is already a validation run in progress with a different default setup configuration */
    code_scanning_conflict: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
    /** @description Unavailable due to service under maintenance. */
    porter_maintenance: {
      content: {
        "application/json": components["schemas"]["basic-error"];
      };
    };
  };
  parameters: {
    /** @description The number of results per page (max 100). */
    "per-page"?: number;
    /** @description Used for pagination: the starting delivery from which the page of deliveries is fetched. Refer to the `link` header for the next and previous page cursors. */
    cursor?: string;
    "delivery-id": number;
    /** @description Page number of the results to fetch. */
    page?: number;
    /** @description Only show notifications updated after the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    since?: string;
    /** @description The unique identifier of the installation. */
    "installation-id": number;
    /** @description The client ID of the GitHub app. */
    "client-id": string;
    "app-slug": string;
    /** @description The slug version of the enterprise name. You can also substitute this value with the enterprise id. */
    enterprise: string;
    /**
     * @description A comma-separated list of states. If specified, only alerts with these states will be returned.
     *
     * Can be: `auto_dismissed`, `dismissed`, `fixed`, `open`
     */
    "dependabot-alert-comma-separated-states"?: string;
    /**
     * @description A comma-separated list of severities. If specified, only alerts with these severities will be returned.
     *
     * Can be: `low`, `medium`, `high`, `critical`
     */
    "dependabot-alert-comma-separated-severities"?: string;
    /**
     * @description A comma-separated list of ecosystems. If specified, only alerts for these ecosystems will be returned.
     *
     * Can be: `composer`, `go`, `maven`, `npm`, `nuget`, `pip`, `pub`, `rubygems`, `rust`
     */
    "dependabot-alert-comma-separated-ecosystems"?: string;
    /** @description A comma-separated list of package names. If specified, only alerts for these packages will be returned. */
    "dependabot-alert-comma-separated-packages"?: string;
    /** @description The scope of the vulnerable dependency. If specified, only alerts with this scope will be returned. */
    "dependabot-alert-scope"?: "development" | "runtime";
    /**
     * @description The property by which to sort the results.
     * `created` means when the alert was created.
     * `updated` means when the alert's state last changed.
     */
    "dependabot-alert-sort"?: "created" | "updated";
    /** @description The direction to sort the results by. */
    direction?: "asc" | "desc";
    /** @description A cursor, as given in the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers). If specified, the query only searches for results before this cursor. */
    "pagination-before"?: string;
    /** @description A cursor, as given in the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers). If specified, the query only searches for results after this cursor. */
    "pagination-after"?: string;
    /**
     * @description **Deprecated**. The number of results per page (max 100), starting from the first matching result.
     * This parameter must not be used in combination with `last`.
     * Instead, use `per_page` in combination with `after` to fetch the first page of results.
     */
    "pagination-first"?: number;
    /**
     * @description **Deprecated**. The number of results per page (max 100), starting from the last matching result.
     * This parameter must not be used in combination with `first`.
     * Instead, use `per_page` in combination with `before` to fetch the last page of results.
     */
    "pagination-last"?: number;
    /** @description Set to `open` or `resolved` to only list secret scanning alerts in a specific state. */
    "secret-scanning-alert-state"?: "open" | "resolved";
    /**
     * @description A comma-separated list of secret types to return. By default all secret types are returned.
     * See "[Secret scanning patterns](https://docs.github.com/code-security/secret-scanning/secret-scanning-patterns#supported-secrets-for-advanced-security)"
     * for a complete list of secret types.
     */
    "secret-scanning-alert-secret-type"?: string;
    /** @description A comma-separated list of resolutions. Only secret scanning alerts with one of these resolutions are listed. Valid resolutions are `false_positive`, `wont_fix`, `revoked`, `pattern_edited`, `pattern_deleted` or `used_in_tests`. */
    "secret-scanning-alert-resolution"?: string;
    /** @description The property to sort the results by. `created` means when the alert was created. `updated` means when the alert was updated or resolved. */
    "secret-scanning-alert-sort"?: "created" | "updated";
    /** @description The unique identifier of the gist. */
    "gist-id": string;
    /** @description The unique identifier of the comment. */
    "comment-id": number;
    /** @description A list of comma separated label names. Example: `bug,ui,@high` */
    labels?: string;
    /** @description account_id parameter */
    "account-id": number;
    /** @description The unique identifier of the plan. */
    "plan-id": number;
    /** @description The property to sort the results by. */
    sort?: "created" | "updated";
    /** @description The account owner of the repository. The name is not case sensitive. */
    owner: string;
    /** @description The name of the repository. The name is not case sensitive. */
    repo: string;
    /** @description If `true`, show notifications marked as read. */
    all?: boolean;
    /** @description If `true`, only shows notifications in which the user is directly participating or mentioned. */
    participating?: boolean;
    /** @description Only show notifications updated before the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    before?: string;
    /** @description The unique identifier of the notification thread. This corresponds to the value returned in the `id` field when you retrieve notifications (for example with the [`GET /notifications` operation](https://docs.github.com/rest/reference/activity#list-notifications-for-the-authenticated-user)). */
    "thread-id": number;
    /** @description An organization ID. Only return organizations with an ID greater than this ID. */
    "since-org"?: number;
    /** @description The organization name. The name is not case sensitive. */
    org: string;
    /** @description The property by which to sort the results. */
    "personal-access-token-sort"?: "created_at";
    /** @description A list of owner usernames to use to filter the results. */
    "personal-access-token-owner"?: string[];
    /** @description The name of the repository to use to filter the results. */
    "personal-access-token-repository"?: string;
    /** @description The permission to use to filter the results. */
    "personal-access-token-permission"?: string;
    /** @description Only show fine-grained personal access tokens used before the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    "personal-access-token-before"?: string;
    /** @description Only show fine-grained personal access tokens used after the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    "personal-access-token-after"?: string;
    /** @description The unique identifier of the fine-grained personal access token. */
    "fine-grained-personal-access-token-id": number;
    /** @description The unique identifier of the repository. */
    "repository-id": number;
    /** @description The unique identifier of the required workflow. */
    "required-workflow-id": number;
    /** @description Unique identifier of the self-hosted runner. */
    "runner-id": number;
    /** @description The name of a self-hosted runner's custom label. */
    "runner-label-name": string;
    /** @description The name of the secret. */
    "secret-name": string;
    /** @description The number of results per page (max 30). */
    "variables-per-page"?: number;
    /** @description The name of the variable. */
    "variable-name": string;
    /** @description The handle for the GitHub user account. */
    username: string;
    /** @description The name of a code scanning tool. Only results by this tool will be listed. You can specify the tool by using either `tool_name` or `tool_guid`, but not both. */
    "tool-name"?: components["schemas"]["code-scanning-analysis-tool-name"];
    /** @description The GUID of a code scanning tool. Only results by this tool will be listed. Note that some code scanning tools may not include a GUID in their analysis data. You can specify the tool by using either `tool_guid` or `tool_name`, but not both. */
    "tool-guid"?: components["schemas"]["code-scanning-analysis-tool-guid"];
    /** @description The unique identifier of the hook. */
    "hook-id": number;
    /** @description The unique identifier of the invitation. */
    "invitation-id": number;
    /** @description The name of the codespace. */
    "codespace-name": string;
    /** @description The unique identifier of the migration. */
    "migration-id": number;
    /** @description repo_name parameter */
    "repo-name": string;
    /**
     * @description The selected visibility of the packages.  This parameter is optional and only filters an existing result set.
     *
     * The `internal` visibility is only supported for GitHub Packages registries that allow for granular permissions. For other ecosystems `internal` is synonymous with `private`.
     * For the list of GitHub Packages registries that support granular permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
     */
    "package-visibility"?: "public" | "private" | "internal";
    /** @description The type of supported package. Packages in GitHub's Gradle registry have the type `maven`. Docker images pushed to GitHub's Container registry (`ghcr.io`) have the type `container`. You can use the type `docker` to find images that were pushed to GitHub's Docker registry (`docker.pkg.github.com`), even if these have now been migrated to the Container registry. */
    "package-type":
      | "npm"
      | "maven"
      | "rubygems"
      | "docker"
      | "nuget"
      | "container";
    /** @description The name of the package. */
    "package-name": string;
    /** @description Unique identifier of the package version. */
    "package-version-id": number;
    /** @description A cursor, as given in the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers). If specified, the query only searches for events before this cursor. To receive an initial cursor on your first request, include an empty "before" query string. */
    "secret-scanning-pagination-before-org-repo"?: string;
    /** @description A cursor, as given in the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers). If specified, the query only searches for events after this cursor.  To receive an initial cursor on your first request, include an empty "after" query string. */
    "secret-scanning-pagination-after-org-repo"?: string;
    /** @description The slug of the team name. */
    "team-slug": string;
    /** @description The number that identifies the discussion. */
    "discussion-number": number;
    /** @description The number that identifies the comment. */
    "comment-number": number;
    /** @description The unique identifier of the reaction. */
    "reaction-id": number;
    /** @description The unique identifier of the project. */
    "project-id": number;
    /** @description The security feature to enable or disable. */
    "security-product":
      | "dependency_graph"
      | "dependabot_alerts"
      | "dependabot_security_updates"
      | "advanced_security"
      | "code_scanning_default_setup"
      | "secret_scanning"
      | "secret_scanning_push_protection";
    /**
     * @description The action to take.
     *
     * `enable_all` means to enable the specified security feature for all repositories in the organization.
     * `disable_all` means to disable the specified security feature for all repositories in the organization.
     */
    "org-security-product-enablement": "enable_all" | "disable_all";
    /** @description The unique identifier of the card. */
    "card-id": number;
    /** @description The unique identifier of the column. */
    "column-id": number;
    /** @description The ID of the required workflow that has run at least once in a repository. */
    "repo-required-workflow-id": number;
    /** @description The unique identifier of the artifact. */
    "artifact-id": number;
    /** @description The full Git reference for narrowing down the cache. The `ref` for a branch should be formatted as `refs/heads/<branch name>`. To reference a pull request use `refs/pull/<number>/merge`. */
    "actions-cache-git-ref-full"?: string;
    /** @description An explicit key or prefix for identifying the cache */
    "actions-cache-key"?: string;
    /** @description The property to sort the results by. `created_at` means when the cache was created. `last_accessed_at` means when the cache was last accessed. `size_in_bytes` is the size of the cache in bytes. */
    "actions-cache-list-sort"?:
      | "created_at"
      | "last_accessed_at"
      | "size_in_bytes";
    /** @description A key for identifying the cache. */
    "actions-cache-key-required": string;
    /** @description The unique identifier of the GitHub Actions cache. */
    "cache-id": number;
    /** @description The unique identifier of the job. */
    "job-id": number;
    /** @description Returns someone's workflow runs. Use the login for the user who created the `push` associated with the check suite or workflow run. */
    actor?: string;
    /** @description Returns workflow runs associated with a branch. Use the name of the branch of the `push`. */
    "workflow-run-branch"?: string;
    /** @description Returns workflow run triggered by the event you specify. For example, `push`, `pull_request` or `issue`. For more information, see "[Events that trigger workflows](https://docs.github.com/actions/automating-your-workflow-with-github-actions/events-that-trigger-workflows)." */
    event?: string;
    /** @description Returns workflow runs with the check run `status` or `conclusion` that you specify. For example, a conclusion can be `success` or a status can be `in_progress`. Only GitHub can set a status of `waiting` or `requested`. */
    "workflow-run-status"?:
      | "completed"
      | "action_required"
      | "cancelled"
      | "failure"
      | "neutral"
      | "skipped"
      | "stale"
      | "success"
      | "timed_out"
      | "in_progress"
      | "queued"
      | "requested"
      | "waiting"
      | "pending";
    /** @description Returns workflow runs created within the given date-time range. For more information on the syntax, see "[Understanding the search syntax](https://docs.github.com/search-github/getting-started-with-searching-on-github/understanding-the-search-syntax#query-for-dates)." */
    created?: string;
    /** @description If `true` pull requests are omitted from the response (empty array). */
    "exclude-pull-requests"?: boolean;
    /** @description Returns workflow runs with the `check_suite_id` that you specify. */
    "workflow-run-check-suite-id"?: number;
    /** @description Only returns workflow runs that are associated with the specified `head_sha`. */
    "workflow-run-head-sha"?: string;
    /** @description The unique identifier of the workflow run. */
    "run-id": number;
    /** @description The attempt number of the workflow run. */
    "attempt-number": number;
    /** @description The ID of the workflow. You can also pass the workflow file name as a string. */
    "workflow-id": number | string;
    /** @description The unique identifier of the autolink. */
    "autolink-id": number;
    /** @description The name of the branch. Cannot contain wildcard characters. To use wildcard characters in branch names, use [the GraphQL API](https://docs.github.com/graphql). */
    branch: string;
    /** @description The unique identifier of the check run. */
    "check-run-id": number;
    /** @description The unique identifier of the check suite. */
    "check-suite-id": number;
    /** @description Returns check runs with the specified `name`. */
    "check-name"?: string;
    /** @description Returns check runs with the specified `status`. */
    status?: "queued" | "in_progress" | "completed";
    /** @description The Git reference for the results you want to list. The `ref` for a branch can be formatted either as `refs/heads/<branch name>` or simply `<branch name>`. To reference a pull request use `refs/pull/<number>/merge`. */
    "git-ref"?: components["schemas"]["code-scanning-ref"];
    /** @description The number that identifies an alert. You can find this at the end of the URL for a code scanning alert within GitHub, and in the `number` field in the response from the `GET /repos/{owner}/{repo}/code-scanning/alerts` operation. */
    "alert-number": components["schemas"]["alert-number"];
    /** @description The SHA of the commit. */
    "commit-sha": string;
    /** @description A comma-separated list of full manifest paths. If specified, only alerts for these manifests will be returned. */
    "dependabot-alert-comma-separated-manifests"?: string;
    /**
     * @description The number that identifies a Dependabot alert in its repository.
     * You can find this at the end of the URL for a Dependabot alert within GitHub,
     * or in `number` fields in the response from the
     * `GET /repos/{owner}/{repo}/dependabot/alerts` operation.
     */
    "dependabot-alert-number": components["schemas"]["alert-number"];
    /** @description The full path, relative to the repository root, of the dependency manifest file. */
    "manifest-path"?: string;
    /** @description deployment_id parameter */
    "deployment-id": number;
    /** @description The name of the environment. */
    "environment-name": string;
    /** @description The unique identifier of the branch policy. */
    "branch-policy-id": number;
    /** @description The unique identifier of the protection rule. */
    "protection-rule-id": number;
    /** @description A user ID. Only return users with an ID greater than this ID. */
    "since-user"?: number;
    /** @description The number that identifies the issue. */
    "issue-number": number;
    /** @description The unique identifier of the key. */
    "key-id": number;
    /** @description The number that identifies the milestone. */
    "milestone-number": number;
    /** @description The number that identifies the pull request. */
    "pull-number": number;
    /** @description The unique identifier of the review. */
    "review-id": number;
    /** @description The unique identifier of the asset. */
    "asset-id": number;
    /** @description The unique identifier of the release. */
    "release-id": number;
    /** @description The GHSA (GitHub Security Advisory) identifier of the advisory. */
    ghsa_id: string;
    /** @description The unique identifier of the tag protection. */
    "tag-protection-id": number;
    /** @description The time frame to display results for. */
    per?: "day" | "week";
    /** @description A repository ID. Only return repositories with an ID greater than this ID. */
    "since-repo"?: number;
    /** @description Determines whether the first search result returned is the highest number of matches (`desc`) or lowest number of matches (`asc`). This parameter is ignored unless you provide `sort`. */
    order?: "desc" | "asc";
    /** @description The unique identifier of the team. */
    "team-id": number;
    /** @description ID of the Repository to filter on */
    "repository-id-in-query"?: number;
    /** @description The ID of the export operation, or `latest`. Currently only `latest` is currently supported. */
    "export-id": string;
    /** @description The unique identifier of the GPG key. */
    "gpg-key-id": number;
    /** @description Only show repositories updated after the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    "since-repo-date"?: string;
    /** @description Only show repositories updated before the given time. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
    "before-repo-date"?: string;
    /** @description The unique identifier of the SSH signing key. */
    "ssh-signing-key-id": number;
    /** @description The property to sort the results by. `created` means when the repository was starred. `updated` means when the repository was last pushed to. */
    "sort-starred"?: "created" | "updated";
  };
  requestBodies: never;
  headers: {
    /** @example <https://api.github.com/resource?page=2>; rel="next", <https://api.github.com/resource?page=5>; rel="last" */
    link: string;
    /** @example text/html */
    "content-type": string;
    /** @example 0.17.4 */
    "x-common-marker-version": string;
    /** @example 5000 */
    "x-rate-limit-limit": number;
    /** @example 4999 */
    "x-rate-limit-remaining": number;
    /** @example 1590701888 */
    "x-rate-limit-reset": number;
    /** @example https://pipelines.actions.githubusercontent.com/OhgS4QRKqmgx7bKC27GKU83jnQjyeqG8oIMTge8eqtheppcmw8/_apis/pipelines/1/runs/176/signedlogcontent?urlExpires=2020-01-24T18%3A10%3A31.5729946Z&urlSigningMethod=HMACV1&urlSignature=agG73JakPYkHrh06seAkvmH7rBR4Ji4c2%2B6a2ejYh3E%3D */
    location: string;
  };
  pathItems: never;
}

export type external = Record<string, never>;

export interface operations {
  /**
   * GitHub API Root
   * @description Get Hypermedia links to resources accessible in GitHub's REST API
   */
  "meta/root": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["root"];
        };
      };
    };
  };
  /**
   * Get the authenticated app
   * @description Returns the GitHub App associated with the authentication credentials used. To see how many app installations are associated with this GitHub App, see the `installations_count` in the response. For more details about your app's installations, see the "[List installations for the authenticated app](https://docs.github.com/rest/reference/apps#list-installations-for-the-authenticated-app)" endpoint.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-authenticated": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"];
        };
      };
    };
  };
  /**
   * Create a GitHub App from a manifest
   * @description Use this endpoint to complete the handshake necessary when implementing the [GitHub App Manifest flow](https://docs.github.com/apps/building-github-apps/creating-github-apps-from-a-manifest/). When you create a GitHub App with the manifest flow, you receive a temporary `code` used to retrieve the GitHub App's `id`, `pem` (private key), and `webhook_secret`.
   */
  "apps/create-from-manifest": {
    parameters: {
      path: {
        code: string;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["integration"] & {
            client_id: string;
            client_secret: string;
            webhook_secret: string | null;
            pem: string;
            [key: string]: unknown;
          };
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get a webhook configuration for an app
   * @description Returns the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-webhook-config-for-app": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * Update a webhook configuration for an app
   * @description Updates the webhook configuration for a GitHub App. For more information about configuring a webhook for your app, see "[Creating a GitHub App](/developers/apps/creating-a-github-app)."
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/update-webhook-config-for-app": {
    requestBody: {
      content: {
        "application/json": {
          url?: components["schemas"]["webhook-config-url"];
          content_type?: components["schemas"]["webhook-config-content-type"];
          secret?: components["schemas"]["webhook-config-secret"];
          insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * List deliveries for an app webhook
   * @description Returns a list of webhook deliveries for the webhook configured for a GitHub App.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/list-webhook-deliveries": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        cursor?: components["parameters"]["cursor"];
        redelivery?: boolean;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery-item"][];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a delivery for an app webhook
   * @description Returns a delivery for the webhook configured for a GitHub App.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-webhook-delivery": {
    parameters: {
      path: {
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery"];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Redeliver a delivery for an app webhook
   * @description Redeliver a delivery for the webhook configured for a GitHub App.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/redeliver-webhook-delivery": {
    parameters: {
      path: {
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List installation requests for the authenticated app
   * @description Lists all the pending installation requests for the authenticated GitHub App.
   */
  "apps/list-installation-requests-for-authenticated-app": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description List of integration installation requests */
      200: {
        content: {
          "application/json": components["schemas"]["integration-installation-request"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
    };
  };
  /**
   * List installations for the authenticated app
   * @description You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   *
   * The permissions the installation has are included under the `permissions` key.
   */
  "apps/list-installations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        since?: components["parameters"]["since"];
        outdated?: string;
      };
    };
    responses: {
      /** @description The permissions the installation has are included under the `permissions` key. */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["installation"][];
        };
      };
    };
  };
  /**
   * Get an installation for the authenticated app
   * @description Enables an authenticated GitHub App to find an installation's information using the installation id.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-installation": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["installation"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an installation for the authenticated app
   * @description Uninstalls a GitHub App on a user, organization, or business account. If you prefer to temporarily suspend an app's access to your account's resources, then we recommend the "[Suspend an app installation](https://docs.github.com/rest/reference/apps/#suspend-an-app-installation)" endpoint.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/delete-installation": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create an installation access token for an app
   * @description Creates an installation access token that enables a GitHub App to make authenticated API requests for the app's installation on an organization or individual account. Installation tokens expire one hour from the time you create them. Using an expired token produces a status code of `401 - Unauthorized`, and requires creating a new installation token. By default the installation token has access to all repositories that the installation can access. To restrict the access to specific repositories, you can provide the `repository_ids` when creating the token. When you omit `repository_ids`, the response does not contain the `repositories` key.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/create-installation-access-token": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description List of repository names that the token should have access to */
          repositories?: string[];
          /**
           * @description List of repository IDs that the token should have access to
           * @example [
           *   1
           * ]
           */
          repository_ids?: number[];
          permissions?: components["schemas"]["app-permissions"];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["installation-token"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Suspend an app installation
   * @description Suspends a GitHub App on a user, organization, or business account, which blocks the app from accessing the account's resources. When a GitHub App is suspended, the app's access to the GitHub API or webhook events is blocked for that account.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/suspend-installation": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Unsuspend an app installation
   * @description Removes a GitHub App installation suspension.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/unsuspend-installation": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an app authorization
   * @description OAuth and GitHub application owners can revoke a grant for their application and a specific user. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the OAuth application's `client_id` and `client_secret` as the username and password. You must also provide a valid OAuth `access_token` as an input parameter and the grant for the token's owner will be deleted.
   * Deleting an application's grant will also delete all OAuth tokens associated with the application for the user. Once deleted, the application will have no access to the user's account and will no longer be listed on [the application authorizations settings screen within GitHub](https://github.com/settings/applications#authorized).
   */
  "apps/delete-authorization": {
    parameters: {
      path: {
        client_id: components["parameters"]["client-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The OAuth access token used to authenticate to the GitHub API. */
          access_token: string;
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Check a token
   * @description OAuth applications and GitHub applications with OAuth authorizations can use this API method for checking OAuth token validity without exceeding the normal rate limits for failed login attempts. Authentication works differently with this particular endpoint. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) to use this endpoint, where the username is the application `client_id` and the password is its `client_secret`. Invalid tokens will return `404 NOT FOUND`.
   */
  "apps/check-token": {
    parameters: {
      path: {
        client_id: components["parameters"]["client-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The access_token of the OAuth or GitHub application. */
          access_token: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["authorization"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete an app token
   * @description OAuth  or GitHub application owners can revoke a single token for an OAuth application or a GitHub application with an OAuth authorization. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the application's `client_id` and `client_secret` as the username and password.
   */
  "apps/delete-token": {
    parameters: {
      path: {
        client_id: components["parameters"]["client-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The OAuth access token used to authenticate to the GitHub API. */
          access_token: string;
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Reset a token
   * @description OAuth applications and GitHub applications with OAuth authorizations can use this API method to reset a valid OAuth token without end-user involvement. Applications must save the "token" property in the response because changes take effect immediately. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the application's `client_id` and `client_secret` as the username and password. Invalid tokens will return `404 NOT FOUND`.
   */
  "apps/reset-token": {
    parameters: {
      path: {
        client_id: components["parameters"]["client-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The access_token of the OAuth or GitHub application. */
          access_token: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["authorization"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a scoped access token
   * @description Use a non-scoped user-to-server access token to create a repository scoped and/or permission scoped user-to-server access token. You can specify which repositories the token can access and which permissions are granted to the token. You must use [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) when accessing this endpoint, using the `client_id` and `client_secret` of the GitHub App as the username and password. Invalid tokens will return `404 NOT FOUND`.
   */
  "apps/scope-token": {
    parameters: {
      path: {
        client_id: components["parameters"]["client-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The access token used to authenticate to the GitHub API.
           * @example e72e16c7e42f292c6912e7710c838347ae178b4a
           */
          access_token: string;
          /**
           * @description The name of the user or organization to scope the user-to-server access token to. **Required** unless `target_id` is specified.
           * @example octocat
           */
          target?: string;
          /**
           * @description The ID of the user or organization to scope the user-to-server access token to. **Required** unless `target` is specified.
           * @example 1
           */
          target_id?: number;
          /** @description The list of repository names to scope the user-to-server access token to. `repositories` may not be specified if `repository_ids` is specified. */
          repositories?: string[];
          /**
           * @description The list of repository IDs to scope the user-to-server access token to. `repository_ids` may not be specified if `repositories` is specified.
           * @example [
           *   1
           * ]
           */
          repository_ids?: number[];
          permissions?: components["schemas"]["app-permissions"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["authorization"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an app
   * @description **Note**: The `:app_slug` is just the URL-friendly name of your GitHub App. You can find this on the settings page for your GitHub App (e.g., `https://github.com/settings/apps/:app_slug`).
   *
   * If the GitHub App you specify is public, you can access this endpoint without authenticating. If the GitHub App you specify is private, you must authenticate with a [personal access token](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line/) or an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
   */
  "apps/get-by-slug": {
    parameters: {
      path: {
        app_slug: components["parameters"]["app-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Get all codes of conduct */
  "codes-of-conduct/get-all-codes-of-conduct": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-of-conduct"][];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /** Get a code of conduct */
  "codes-of-conduct/get-conduct-code": {
    parameters: {
      path: {
        key: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-of-conduct"];
        };
      };
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get emojis
   * @description Lists all the emojis available to use on GitHub.
   */
  "emojis/get": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            [key: string]: string | undefined;
          };
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * List Dependabot alerts for an enterprise
   * @description Lists Dependabot alerts for repositories that are owned by the specified enterprise.
   * To use this endpoint, you must be a member of the enterprise, and you must use an
   * access token with the `repo` scope or `security_events` scope.
   * Alerts are only returned for organizations in the enterprise for which you are an organization owner or a security manager. For more information about security managers, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   */
  "dependabot/list-alerts-for-enterprise": {
    parameters: {
      query: {
        state?: components["parameters"]["dependabot-alert-comma-separated-states"];
        severity?: components["parameters"]["dependabot-alert-comma-separated-severities"];
        ecosystem?: components["parameters"]["dependabot-alert-comma-separated-ecosystems"];
        package?: components["parameters"]["dependabot-alert-comma-separated-packages"];
        scope?: components["parameters"]["dependabot-alert-scope"];
        sort?: components["parameters"]["dependabot-alert-sort"];
        direction?: components["parameters"]["direction"];
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
        first?: components["parameters"]["pagination-first"];
        last?: components["parameters"]["pagination-last"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        enterprise: components["parameters"]["enterprise"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-alert-with-repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List secret scanning alerts for an enterprise
   * @description Lists secret scanning alerts for eligible repositories in an enterprise, from newest to oldest.
   * To use this endpoint, you must be a member of the enterprise, and you must use an access token with the `repo` scope or `security_events` scope. Alerts are only returned for organizations in the enterprise for which you are an organization owner or a [security manager](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization).
   */
  "secret-scanning/list-alerts-for-enterprise": {
    parameters: {
      query: {
        state?: components["parameters"]["secret-scanning-alert-state"];
        secret_type?: components["parameters"]["secret-scanning-alert-secret-type"];
        resolution?: components["parameters"]["secret-scanning-alert-resolution"];
        sort?: components["parameters"]["secret-scanning-alert-sort"];
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
      };
      path: {
        enterprise: components["parameters"]["enterprise"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-secret-scanning-alert"][];
        };
      };
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List public events
   * @description We delay the public events feed by five minutes, which means the most recent event returned by the public events API actually occurred at least five minutes ago.
   */
  "activity/list-public-events": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get feeds
   * @description GitHub provides several timeline resources in [Atom](http://en.wikipedia.org/wiki/Atom_(standard)) format. The Feeds API lists all the feeds available to the authenticated user:
   *
   * *   **Timeline**: The GitHub global public timeline
   * *   **User**: The public timeline for any user, using [URI template](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia)
   * *   **Current user public**: The public timeline for the authenticated user
   * *   **Current user**: The private timeline for the authenticated user
   * *   **Current user actor**: The private timeline for activity created by the authenticated user
   * *   **Current user organizations**: The private timeline for the organizations the authenticated user is a member of.
   * *   **Security advisories**: A collection of public announcements that provide information about security-related vulnerabilities in software on GitHub.
   *
   * **Note**: Private feeds are only returned when [authenticating via Basic Auth](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) since current feed URIs use the older, non revocable auth tokens.
   */
  "activity/get-feeds": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["feed"];
        };
      };
    };
  };
  /**
   * List gists for the authenticated user
   * @description Lists the authenticated user's gists or if called anonymously, this endpoint returns all public gists:
   */
  "gists/list": {
    parameters: {
      query: {
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["base-gist"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Create a gist
   * @description Allows you to add a new gist with one or more files.
   *
   * **Note:** Don't name your files "gistfile" with a numerical suffix. This is the format of the automatic naming scheme that Gist uses internally.
   */
  "gists/create": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Description of the gist
           * @example Example Ruby script
           */
          description?: string;
          /**
           * @description Names and content for the files that make up the gist
           * @example {
           *   "hello.rb": {
           *     "content": "puts \"Hello, World!\""
           *   }
           * }
           */
          files: {
            [key: string]:
              | {
                  /** @description Content of the file */
                  content: string;
                }
              | undefined;
          };
          public?: boolean | ("true" | "false");
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/gists/aa5a315d61ae9438b18d */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["gist-simple"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List public gists
   * @description List public gists sorted by most recently updated to least recently updated.
   *
   * Note: With [pagination](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
   */
  "gists/list-public": {
    parameters: {
      query: {
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["base-gist"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List starred gists
   * @description List the authenticated user's starred gists:
   */
  "gists/list-starred": {
    parameters: {
      query: {
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["base-gist"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Get a gist */
  "gists/get": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gist-simple"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden_gist"];
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a gist */
  "gists/delete": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a gist
   * @description Allows you to update a gist's description and to update, delete, or rename gist files. Files from the previous version of the gist that aren't explicitly changed during an edit are unchanged.
   */
  "gists/update": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The description of the gist.
           * @example Example Ruby script
           */
          description?: string;
          /**
           * @description The gist files to be updated, renamed, or deleted. Each `key` must match the current filename
           * (including extension) of the targeted gist file. For example: `hello.py`.
           *
           * To delete a file, set the whole file to null. For example: `hello.py : null`.
           * @example {
           *   "hello.rb": {
           *     "content": "blah",
           *     "filename": "goodbye.rb"
           *   }
           * }
           */
          files?: {
            [key: string]:
              | {
                  /** @description The new content of the file. */
                  content?: string;
                  /** @description The new filename for the file. */
                  filename?: string | null;
                }
              | undefined;
          };
        } | null;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gist-simple"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** List gist comments */
  "gists/list-comments": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["gist-comment"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Create a gist comment */
  "gists/create-comment": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The comment text.
           * @example Body of the attachment
           */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/gists/a6db0bec360bb87e9418/comments/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["gist-comment"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Get a gist comment */
  "gists/get-comment": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gist-comment"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden_gist"];
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a gist comment */
  "gists/delete-comment": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Update a gist comment */
  "gists/update-comment": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The comment text.
           * @example Body of the attachment
           */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gist-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** List gist commits */
  "gists/list-commits": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          /** @example <https://api.github.com/resource?page=2>; rel="next" */
          Link?: string;
        };
        content: {
          "application/json": components["schemas"]["gist-commit"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** List gist forks */
  "gists/list-forks": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["gist-simple"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Fork a gist */
  "gists/fork": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/gists/aa5a315d61ae9438b18d */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["base-gist"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Check if a gist is starred */
  "gists/check-is-starred": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response if gist is starred */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      /** @description Not Found if gist is not starred */
      404: {
        content: {
          "application/json": Record<string, never>;
        };
      };
    };
  };
  /**
   * Star a gist
   * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "gists/star": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Unstar a gist */
  "gists/unstar": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Get a gist revision */
  "gists/get-revision": {
    parameters: {
      path: {
        gist_id: components["parameters"]["gist-id"];
        sha: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gist-simple"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get all gitignore templates
   * @description List all templates available to pass as an option when [creating a repository](https://docs.github.com/rest/reference/repos#create-a-repository-for-the-authenticated-user).
   */
  "gitignore/get-all-templates": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Get a gitignore template
   * @description The API also allows fetching the source of a single template.
   * Use the raw [media type](https://docs.github.com/rest/overview/media-types/) to get the raw contents.
   */
  "gitignore/get-template": {
    parameters: {
      path: {
        name: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gitignore-template"];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * List repositories accessible to the app installation
   * @description List repositories that an app installation can access.
   *
   * You must use an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
   */
  "apps/list-repos-accessible-to-installation": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["repository"][];
            /** @example selected */
            repository_selection?: string;
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Revoke an installation access token
   * @description Revokes the installation token you're using to authenticate as an installation and access this endpoint.
   *
   * Once an installation token is revoked, the token is invalidated and cannot be used. Other endpoints that require the revoked installation token must have a new installation token to work. You can create a new token using the "[Create an installation access token for an app](https://docs.github.com/rest/reference/apps#create-an-installation-access-token-for-an-app)" endpoint.
   *
   * You must use an [installation access token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-an-installation) to access this endpoint.
   */
  "apps/revoke-installation-access-token": {
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List issues assigned to the authenticated user
   * @description List issues assigned to the authenticated user across all visible repositories including owned repositories, member
   * repositories, and organization repositories. You can use the `filter` query parameter to fetch issues that are not
   * necessarily assigned to you.
   *
   *
   * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
   * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
   * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
   * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
   */
  "issues/list": {
    parameters: {
      query: {
        /** @description Indicates which sorts of issues to return. `assigned` means issues assigned to you. `created` means issues created by you. `mentioned` means issues mentioning you. `subscribed` means issues you're subscribed to updates for. `all` or `repos` means all issues you can see, regardless of participation or creation. */
        filter?:
          | "assigned"
          | "created"
          | "mentioned"
          | "subscribed"
          | "repos"
          | "all";
        /** @description Indicates the state of the issues to return. */
        state?: "open" | "closed" | "all";
        labels?: components["parameters"]["labels"];
        /** @description What to sort results by. */
        sort?: "created" | "updated" | "comments";
        direction?: components["parameters"]["direction"];
        since?: components["parameters"]["since"];
        collab?: boolean;
        orgs?: boolean;
        owned?: boolean;
        pulls?: boolean;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue"][];
        };
      };
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get all commonly used licenses */
  "licenses/get-all-commonly-used": {
    parameters: {
      query: {
        featured?: boolean;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["license-simple"][];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /** Get a license */
  "licenses/get": {
    parameters: {
      path: {
        license: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["license"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Render a Markdown document */
  "markdown/render": {
    requestBody: {
      content: {
        "application/json": {
          /** @description The Markdown text to render in HTML. */
          text: string;
          /**
           * @description The rendering mode.
           * @default markdown
           * @example markdown
           * @enum {string}
           */
          mode?: "markdown" | "gfm";
          /** @description The repository context to use when creating references in `gfm` mode.  For example, setting `context` to `octo-org/octo-repo` will change the text `#42` into an HTML link to issue 42 in the `octo-org/octo-repo` repository. */
          context?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          "Content-Type": components["headers"]["content-type"];
          /** @example 279 */
          "Content-Length"?: string;
          "X-CommonMarker-Version": components["headers"]["x-common-marker-version"];
        };
        content: {
          "text/html": string;
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Render a Markdown document in raw mode
   * @description You must send Markdown as plain text (using a `Content-Type` header of `text/plain` or `text/x-markdown`) to this endpoint, rather than using JSON format. In raw mode, [GitHub Flavored Markdown](https://github.github.com/gfm/) is not supported and Markdown will be rendered in plain format like a README.md file. Markdown content must be 400 KB or less.
   */
  "markdown/render-raw": {
    requestBody?: {
      content: {
        "text/plain": string;
        "text/x-markdown": string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          "X-CommonMarker-Version": components["headers"]["x-common-marker-version"];
        };
        content: {
          "text/html": string;
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Get a subscription plan for an account
   * @description Shows whether the user or organization account actively subscribes to a plan listed by the authenticated GitHub App. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/get-subscription-plan-for-account": {
    parameters: {
      path: {
        account_id: components["parameters"]["account-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["marketplace-purchase"];
        };
      };
      401: components["responses"]["requires_authentication"];
      /** @description Not Found when the account has not purchased the listing */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * List plans
   * @description Lists all plans that are part of your GitHub Marketplace listing.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/list-plans": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["marketplace-listing-plan"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List accounts for a plan
   * @description Returns user and organization accounts associated with the specified plan, including free plans. For per-seat pricing, you see the list of accounts that have purchased the plan, including the number of seats purchased. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/list-accounts-for-plan": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort"];
        /** @description To return the oldest accounts first, set to `asc`. Ignored without the `sort` parameter. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        plan_id: components["parameters"]["plan-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["marketplace-purchase"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a subscription plan for an account (stubbed)
   * @description Shows whether the user or organization account actively subscribes to a plan listed by the authenticated GitHub App. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/get-subscription-plan-for-account-stubbed": {
    parameters: {
      path: {
        account_id: components["parameters"]["account-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["marketplace-purchase"];
        };
      };
      401: components["responses"]["requires_authentication"];
      /** @description Not Found when the account has not purchased the listing */
      404: never;
    };
  };
  /**
   * List plans (stubbed)
   * @description Lists all plans that are part of your GitHub Marketplace listing.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/list-plans-stubbed": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["marketplace-listing-plan"][];
        };
      };
      401: components["responses"]["requires_authentication"];
    };
  };
  /**
   * List accounts for a plan (stubbed)
   * @description Returns repository and organization accounts associated with the specified plan, including free plans. For per-seat pricing, you see the list of accounts that have purchased the plan, including the number of seats purchased. When someone submits a plan change that won't be processed until the end of their billing cycle, you will also see the upcoming pending change.
   *
   * GitHub Apps must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint. OAuth Apps must use [basic authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication) with their client ID and client secret to access this endpoint.
   */
  "apps/list-accounts-for-plan-stubbed": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort"];
        /** @description To return the oldest accounts first, set to `asc`. Ignored without the `sort` parameter. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        plan_id: components["parameters"]["plan-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["marketplace-purchase"][];
        };
      };
      401: components["responses"]["requires_authentication"];
    };
  };
  /**
   * Get GitHub meta information
   * @description Returns meta information about GitHub, including a list of GitHub's IP addresses. For more information, see "[About GitHub's IP addresses](https://docs.github.com/articles/about-github-s-ip-addresses/)."
   *
   * The values shown in the documentation's response are example values. You must always query the API directly to get the latest values.
   *
   * **Note:** This endpoint returns both IPv4 and IPv6 addresses. However, not all features support IPv6. You should refer to the specific documentation for each feature to determine if IPv6 is supported.
   */
  "meta/get": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["api-overview"];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /** List public events for a network of repositories */
  "activity/list-public-events-for-repo-network": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List notifications for the authenticated user
   * @description List all notifications for the current user, sorted by most recently updated.
   */
  "activity/list-notifications-for-authenticated-user": {
    parameters: {
      query: {
        all?: components["parameters"]["all"];
        participating?: components["parameters"]["participating"];
        since?: components["parameters"]["since"];
        before?: components["parameters"]["before"];
        page?: components["parameters"]["page"];
        /** @description The number of results per page (max 50). */
        per_page?: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["thread"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Mark notifications as read
   * @description Marks all notifications as "read" for the current user. If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List notifications for the authenticated user](https://docs.github.com/rest/reference/activity#list-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
   */
  "activity/mark-notifications-as-read": {
    requestBody?: {
      content: {
        "application/json": {
          /**
           * Format: date-time
           * @description Describes the last point that notifications were checked. Anything updated since this time will not be marked as read. If you omit this parameter, all notifications are marked as read. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. Default: The current timestamp.
           */
          last_read_at?: string;
          /** @description Whether the notification has been read. */
          read?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": {
            message?: string;
          };
        };
      };
      /** @description Reset Content */
      205: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get a thread
   * @description Gets information about a notification thread.
   */
  "activity/get-thread": {
    parameters: {
      path: {
        thread_id: components["parameters"]["thread-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["thread"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Mark a thread as read
   * @description Marks a thread as "read." Marking a thread as "read" is equivalent to clicking a notification in your notification inbox on GitHub: https://github.com/notifications.
   */
  "activity/mark-thread-as-read": {
    parameters: {
      path: {
        thread_id: components["parameters"]["thread-id"];
      };
    };
    responses: {
      /** @description Reset Content */
      205: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get a thread subscription for the authenticated user
   * @description This checks to see if the current user is subscribed to a thread. You can also [get a repository subscription](https://docs.github.com/rest/reference/activity#get-a-repository-subscription).
   *
   * Note that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
   */
  "activity/get-thread-subscription-for-authenticated-user": {
    parameters: {
      path: {
        thread_id: components["parameters"]["thread-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["thread-subscription"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Set a thread subscription
   * @description If you are watching a repository, you receive notifications for all threads by default. Use this endpoint to ignore future notifications for threads until you comment on the thread or get an **@mention**.
   *
   * You can also use this endpoint to subscribe to threads that you are currently not receiving notifications for or to subscribed to threads that you have previously ignored.
   *
   * Unsubscribing from a conversation in a repository that you are not watching is functionally equivalent to the [Delete a thread subscription](https://docs.github.com/rest/reference/activity#delete-a-thread-subscription) endpoint.
   */
  "activity/set-thread-subscription": {
    parameters: {
      path: {
        thread_id: components["parameters"]["thread-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Whether to block all notifications from a thread.
           * @default false
           */
          ignored?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["thread-subscription"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Delete a thread subscription
   * @description Mutes all future notifications for a conversation until you comment on the thread or get an **@mention**. If you are watching the repository of the thread, you will still receive notifications. To ignore future notifications for a repository you are watching, use the [Set a thread subscription](https://docs.github.com/rest/reference/activity#set-a-thread-subscription) endpoint and set `ignore` to `true`.
   */
  "activity/delete-thread-subscription": {
    parameters: {
      path: {
        thread_id: components["parameters"]["thread-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get Octocat
   * @description Get the octocat as ASCII art
   */
  "meta/get-octocat": {
    parameters: {
      query: {
        /** @description The words to show in Octocat's speech bubble */
        s?: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/octocat-stream": string;
        };
      };
    };
  };
  /**
   * List organizations
   * @description Lists all organizations, in the order that they were created on GitHub.
   *
   * **Note:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of organizations.
   */
  "orgs/list": {
    parameters: {
      query: {
        since?: components["parameters"]["since-org"];
        per_page?: components["parameters"]["per-page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          /** @example <https://api.github.com/organizations?since=135>; rel="next" */
          Link?: string;
        };
        content: {
          "application/json": components["schemas"]["organization-simple"][];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * List requests to access organization resources with fine-grained personal access tokens
   * @description Lists requests from organization members to access organization resources with a fine-grained personal access token. Only GitHub Apps can call this API,
   * using the `organization_personal_access_token_requests: read` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/list-pat-grant-requests": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        sort?: components["parameters"]["personal-access-token-sort"];
        direction?: components["parameters"]["direction"];
        owner?: components["parameters"]["personal-access-token-owner"];
        repository?: components["parameters"]["personal-access-token-repository"];
        permission?: components["parameters"]["personal-access-token-permission"];
        last_used_before?: components["parameters"]["personal-access-token-before"];
        last_used_after?: components["parameters"]["personal-access-token-after"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-programmatic-access-grant-request"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Review requests to access organization resources with fine-grained personal access tokens
   * @description Approves or denies multiple pending requests to access organization resources via a fine-grained personal access token. Only GitHub Apps can call this API,
   * using the `organization_personal_access_token_requests: write` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/review-pat-grant-requests-in-bulk": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Unique identifiers of the requests for access via fine-grained personal access token. Must be formed of between 1 and 100 `pat_request_id` values. */
          pat_request_ids?: number[];
          /**
           * @description Action to apply to the requests.
           * @enum {string}
           */
          action: "approve" | "deny";
          /** @description Reason for approving or denying the requests. Max 1024 characters. */
          reason?: string | null;
        };
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Review a request to access organization resources with a fine-grained personal access token
   * @description Approves or denies a pending request to access organization resources via a fine-grained personal access token. Only GitHub Apps can call this API,
   * using the `organization_personal_access_token_requests: write` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/review-pat-grant-request": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        /** @description Unique identifier of the request for access via fine-grained personal access token. */
        pat_request_id: number;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Action to apply to the request.
           * @enum {string}
           */
          action: "approve" | "deny";
          /** @description Reason for approving or denying the request. Max 1024 characters. */
          reason?: string | null;
        };
      };
    };
    responses: {
      204: components["responses"]["no_content"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List repositories requested to be accessed by a fine-grained personal access token
   * @description Lists the repositories a fine-grained personal access token request is requesting access to. Only GitHub Apps can call this API,
   * using the `organization_personal_access_token_requests: read` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/list-pat-grant-request-repositories": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        /** @description Unique identifier of the request for access via fine-grained personal access token. */
        pat_request_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List fine-grained personal access tokens with access to organization resources
   * @description Lists approved fine-grained personal access tokens owned by organization members that can access organization resources. Only GitHub Apps can call this API,
   * using the `organization_personal_access_tokens: read` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/list-pat-grants": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        sort?: components["parameters"]["personal-access-token-sort"];
        direction?: components["parameters"]["direction"];
        owner?: components["parameters"]["personal-access-token-owner"];
        repository?: components["parameters"]["personal-access-token-repository"];
        permission?: components["parameters"]["personal-access-token-permission"];
        last_used_before?: components["parameters"]["personal-access-token-before"];
        last_used_after?: components["parameters"]["personal-access-token-after"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-programmatic-access-grant"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Update the access to organization resources via fine-grained personal access tokens
   * @description Updates the access organization members have to organization resources via fine-grained personal access tokens. Limited to revoking a token's existing access. Only GitHub Apps can call this API,
   * using the `organization_personal_access_tokens: write` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/update-pat-accesses": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Action to apply to the fine-grained personal access token.
           * @enum {string}
           */
          action: "revoke";
          /** @description The IDs of the fine-grained personal access tokens. */
          pat_ids: number[];
        };
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Update the access a fine-grained personal access token has to organization resources
   * @description Updates the access an organization member has to organization resources via a fine-grained personal access token. Limited to revoking the token's existing access. Limited to revoking a token's existing access. Only GitHub Apps can call this API,
   * using the `organization_personal_access_tokens: write` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/update-pat-access": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        pat_id: components["parameters"]["fine-grained-personal-access-token-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Action to apply to the fine-grained personal access token.
           * @enum {string}
           */
          action: "revoke";
        };
      };
    };
    responses: {
      204: components["responses"]["no_content"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List repositories a fine-grained personal access token has access to
   * @description Lists the repositories a fine-grained personal access token has access to. Only GitHub Apps can call this API,
   * using the `organization_personal_access_tokens: read` permission.
   *
   * **Note**: Fine-grained PATs are in public beta. Related APIs, events, and functionality are subject to change.
   */
  "orgs/list-pat-grant-repositories": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        /** @description Unique identifier of the fine-grained personal access token. */
        pat_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get an organization
   * @description To see many of the organization response values, you need to be an authenticated organization owner with the `admin:org` scope. When the value of `two_factor_requirement_enabled` is `true`, the organization requires all members, billing managers, and outside collaborators to enable [two-factor authentication](https://docs.github.com/articles/securing-your-account-with-two-factor-authentication-2fa/).
   *
   * GitHub Apps with the `Organization plan` permission can use this endpoint to retrieve information about an organization's GitHub plan. See "[Authenticating with GitHub Apps](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/)" for details. For an example response, see 'Response with GitHub plan information' below."
   */
  "orgs/get": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["organization-full"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an organization
   * @description Deletes an organization and all its repositories.
   *
   * The organization login will be unavailable for 90 days after deletion.
   *
   * Please review the Terms of Service regarding account deletion before using this endpoint:
   *
   * https://docs.github.com/site-policy/github-terms/github-terms-of-service
   */
  "orgs/delete": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update an organization
   * @description **Parameter Deprecation Notice:** GitHub will replace and discontinue `members_allowed_repository_creation_type` in favor of more granular permissions. The new input parameters are `members_can_create_public_repositories`, `members_can_create_private_repositories` for all organizations and `members_can_create_internal_repositories` for organizations associated with an enterprise account using GitHub Enterprise Cloud or GitHub Enterprise Server 2.20+. For more information, see the [blog post](https://developer.github.com/changes/2019-12-03-internal-visibility-changes).
   *
   * Enables an authenticated organization owner with the `admin:org` scope to update the organization's profile and member privileges.
   */
  "orgs/update": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Billing email address. This address is not publicized. */
          billing_email?: string;
          /** @description The company name. */
          company?: string;
          /** @description The publicly visible email address. */
          email?: string;
          /** @description The Twitter username of the company. */
          twitter_username?: string;
          /** @description The location. */
          location?: string;
          /** @description The shorthand name of the company. */
          name?: string;
          /** @description The description of the company. */
          description?: string;
          /** @description Whether an organization can use organization projects. */
          has_organization_projects?: boolean;
          /** @description Whether repositories that belong to the organization can use repository projects. */
          has_repository_projects?: boolean;
          /**
           * @description Default permission level members have for organization repositories.
           * @default read
           * @enum {string}
           */
          default_repository_permission?: "read" | "write" | "admin" | "none";
          /**
           * @description Whether of non-admin organization members can create repositories. **Note:** A parameter can override this parameter. See `members_allowed_repository_creation_type` in this table for details.
           * @default true
           */
          members_can_create_repositories?: boolean;
          /** @description Whether organization members can create internal repositories, which are visible to all enterprise members. You can only allow members to create internal repositories if your organization is associated with an enterprise account using GitHub Enterprise Cloud or GitHub Enterprise Server 2.20+. For more information, see "[Restricting repository creation in your organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/restricting-repository-creation-in-your-organization)" in the GitHub Help documentation. */
          members_can_create_internal_repositories?: boolean;
          /** @description Whether organization members can create private repositories, which are visible to organization members with permission. For more information, see "[Restricting repository creation in your organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/restricting-repository-creation-in-your-organization)" in the GitHub Help documentation. */
          members_can_create_private_repositories?: boolean;
          /** @description Whether organization members can create public repositories, which are visible to anyone. For more information, see "[Restricting repository creation in your organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/restricting-repository-creation-in-your-organization)" in the GitHub Help documentation. */
          members_can_create_public_repositories?: boolean;
          /**
           * @description Specifies which types of repositories non-admin organization members can create. `private` is only available to repositories that are part of an organization on GitHub Enterprise Cloud.
           * **Note:** This parameter is deprecated and will be removed in the future. Its return value ignores internal repositories. Using this parameter overrides values set in `members_can_create_repositories`. See the parameter deprecation notice in the operation description for details.
           * @enum {string}
           */
          members_allowed_repository_creation_type?: "all" | "private" | "none";
          /**
           * @description Whether organization members can create GitHub Pages sites. Existing published sites will not be impacted.
           * @default true
           */
          members_can_create_pages?: boolean;
          /**
           * @description Whether organization members can create public GitHub Pages sites. Existing published sites will not be impacted.
           * @default true
           */
          members_can_create_public_pages?: boolean;
          /**
           * @description Whether organization members can create private GitHub Pages sites. Existing published sites will not be impacted.
           * @default true
           */
          members_can_create_private_pages?: boolean;
          /**
           * @description Whether organization members can fork private organization repositories.
           * @default false
           */
          members_can_fork_private_repositories?: boolean;
          /**
           * @description Whether contributors to organization repositories are required to sign off on commits they make through GitHub's web interface.
           * @default false
           */
          web_commit_signoff_required?: boolean;
          /** @example "http://github.blog" */
          blog?: string;
          /**
           * @description Whether GitHub Advanced Security is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          advanced_security_enabled_for_new_repositories?: boolean;
          /**
           * @description Whether Dependabot alerts is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          dependabot_alerts_enabled_for_new_repositories?: boolean;
          /**
           * @description Whether Dependabot security updates is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          dependabot_security_updates_enabled_for_new_repositories?: boolean;
          /**
           * @description Whether dependency graph is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          dependency_graph_enabled_for_new_repositories?: boolean;
          /**
           * @description Whether secret scanning is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          secret_scanning_enabled_for_new_repositories?: boolean;
          /**
           * @description Whether secret scanning push protection is automatically enabled for new repositories.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * You can check which security and analysis features are currently enabled by using a `GET /orgs/{org}` request.
           */
          secret_scanning_push_protection_enabled_for_new_repositories?: boolean;
          /** @description Whether a custom link is shown to contributors who are blocked from pushing a secret by push protection. */
          secret_scanning_push_protection_custom_link_enabled?: boolean;
          /** @description If `secret_scanning_push_protection_custom_link_enabled` is true, the URL that will be displayed to contributors who are blocked from pushing a secret. */
          secret_scanning_push_protection_custom_link?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["organization-full"];
        };
      };
      409: components["responses"]["conflict"];
      /** @description Validation failed */
      422: {
        content: {
          "application/json":
            | components["schemas"]["validation-error"]
            | components["schemas"]["validation-error-simple"];
        };
      };
    };
  };
  /**
   * Get GitHub Actions cache usage for an organization
   * @description Gets the total GitHub Actions cache usage for an organization.
   * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
   * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `organization_admistration:read` permission to use this endpoint.
   */
  "actions/get-actions-cache-usage-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["actions-cache-usage-org-enterprise"];
        };
      };
    };
  };
  /**
   * List repositories with GitHub Actions cache usage for an organization
   * @description Lists repositories and their GitHub Actions cache usage for an organization.
   * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
   * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `organization_admistration:read` permission to use this endpoint.
   */
  "actions/get-actions-cache-usage-by-repo-for-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            repository_cache_usages: components["schemas"]["actions-cache-usage-by-repository"][];
          };
        };
      };
    };
  };
  /**
   * Get the customization template for an OIDC subject claim for an organization
   * @description Gets the customization template for an OpenID Connect (OIDC) subject claim.
   * You must authenticate using an access token with the `read:org` scope to use this endpoint.
   * GitHub Apps must have the `organization_administration:write` permission to use this endpoint.
   */
  "oidc/get-oidc-custom-sub-template-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description A JSON serialized template for OIDC subject claim customization */
      200: {
        content: {
          "application/json": components["schemas"]["oidc-custom-sub"];
        };
      };
    };
  };
  /**
   * Set the customization template for an OIDC subject claim for an organization
   * @description Creates or updates the customization template for an OpenID Connect (OIDC) subject claim.
   * You must authenticate using an access token with the `write:org` scope to use this endpoint.
   * GitHub Apps must have the `admin:org` permission to use this endpoint.
   */
  "oidc/update-oidc-custom-sub-template-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["oidc-custom-sub"];
      };
    };
    responses: {
      /** @description Empty response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get GitHub Actions permissions for an organization
   * @description Gets the GitHub Actions permissions policy for repositories and allowed actions and reusable workflows in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/get-github-actions-permissions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-organization-permissions"];
        };
      };
    };
  };
  /**
   * Set GitHub Actions permissions for an organization
   * @description Sets the GitHub Actions permissions policy for repositories and allowed actions and reusable workflows in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/set-github-actions-permissions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          enabled_repositories: components["schemas"]["enabled-repositories"];
          allowed_actions?: components["schemas"]["allowed-actions"];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List selected repositories enabled for GitHub Actions in an organization
   * @description Lists the selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/list-selected-repositories-enabled-github-actions-organization": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["repository"][];
          };
        };
      };
    };
  };
  /**
   * Set selected repositories enabled for GitHub Actions in an organization
   * @description Replaces the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/set-selected-repositories-enabled-github-actions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description List of repository IDs to enable for GitHub Actions. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Enable a selected repository for GitHub Actions in an organization
   * @description Adds a repository to the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/enable-selected-repository-github-actions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Disable a selected repository for GitHub Actions in an organization
   * @description Removes a repository from the list of selected repositories that are enabled for GitHub Actions in an organization. To use this endpoint, the organization permission policy for `enabled_repositories` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/disable-selected-repository-github-actions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get allowed actions and reusable workflows for an organization
   * @description Gets the selected actions and reusable workflows that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization).""
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/get-allowed-actions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["selected-actions"];
        };
      };
    };
  };
  /**
   * Set allowed actions and reusable workflows for an organization
   * @description Sets the actions and reusable workflows that are allowed in an organization. To use this endpoint, the organization permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for an organization](#set-github-actions-permissions-for-an-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/set-allowed-actions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody?: {
      content: {
        "application/json": components["schemas"]["selected-actions"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get default workflow permissions for an organization
   * @description Gets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in an organization,
   * as well as whether GitHub Actions can submit approving pull request reviews. For more information, see
   * "[Setting the permissions of the GITHUB_TOKEN for your organization](https://docs.github.com/organizations/managing-organization-settings/disabling-or-limiting-github-actions-for-your-organization#setting-the-permissions-of-the-github_token-for-your-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/get-github-actions-default-workflow-permissions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-get-default-workflow-permissions"];
        };
      };
    };
  };
  /**
   * Set default workflow permissions for an organization
   * @description Sets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in an organization, and sets if GitHub Actions
   * can submit approving pull request reviews. For more information, see
   * "[Setting the permissions of the GITHUB_TOKEN for your organization](https://docs.github.com/organizations/managing-organization-settings/disabling-or-limiting-github-actions-for-your-organization#setting-the-permissions-of-the-github_token-for-your-organization)."
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this API.
   */
  "actions/set-github-actions-default-workflow-permissions-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody?: {
      content: {
        "application/json": components["schemas"]["actions-set-default-workflow-permissions"];
      };
    };
    responses: {
      /** @description Success response */
      204: never;
    };
  };
  /**
   * List required workflows
   * @description List all required workflows in an organization.
   *
   * You must authenticate using an access token with the `read:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/list-required-workflows": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            required_workflows: components["schemas"]["required-workflow"][];
          };
        };
      };
    };
  };
  /**
   * Create a required workflow
   * @description Create a required workflow in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/create-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Path of the workflow file to be configured as a required workflow. */
          workflow_file_path: string;
          /** @description The ID of the repository that contains the workflow file. */
          repository_id: string;
          /**
           * @description Enable the required workflow for all repositories or selected repositories in the organization.
           * @default all
           * @enum {string}
           */
          scope?: "selected" | "all";
          /** @description A list of repository IDs where you want to enable the required workflow. You can only provide a list of repository ids when the `scope` is set to `selected`. */
          selected_repository_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["required-workflow"];
        };
      };
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get a required workflow
   * @description Get a required workflow configured in an organization.
   *
   * You must authenticate using an access token with the `read:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/get-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["required-workflow"];
        };
      };
    };
  };
  /**
   * Delete a required workflow
   * @description Deletes a required workflow configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/delete-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a required workflow
   * @description Update a required workflow in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/update-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Path of the workflow file to be configured as a required workflow. */
          workflow_file_path?: string;
          /** @description The ID of the repository that contains the workflow file. */
          repository_id?: string;
          /**
           * @description Enable the required workflow for all repositories or selected repositories in the organization.
           * @default all
           * @enum {string}
           */
          scope?: "selected" | "all";
          /** @description A list of repository IDs where you want to enable the required workflow. A list of repository IDs where you want to enable the required workflow. You can only provide a list of repository ids when the `scope` is set to `selected`. */
          selected_repository_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["required-workflow"];
        };
      };
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List selected repositories for a required workflow
   * @description Lists the selected repositories that are configured for a required workflow in an organization. To use this endpoint, the required workflow must be configured to run on selected repositories.
   *
   * You must authenticate using an access token with the `read:org` scope to use this endpoint. GitHub Apps must have the `administration` organization permission to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/list-selected-repositories-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
      };
    };
    responses: {
      /** @description Success */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["repository"][];
          };
        };
      };
      /** @description Resource Not Found */
      404: never;
    };
  };
  /**
   * Sets repositories for a required workflow
   * @description Sets the repositories for a required workflow that is required for selected repositories.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/set-selected-repos-to-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The IDs of the repositories for which the workflow should be required. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Add a repository to a required workflow
   * @description Adds a repository to a required workflow. To use this endpoint, the required workflow must be configured to run on selected repositories.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/add-selected-repo-to-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Success */
      204: never;
      /** @description Resource Not Found */
      404: never;
      /** @description Validation Error */
      422: never;
    };
  };
  /**
   * Remove a selected repository from required workflow
   * @description Removes a repository from a required workflow. To use this endpoint, the required workflow must be configured to run on selected repositories.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/remove-selected-repo-from-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        required_workflow_id: components["parameters"]["required-workflow-id"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Success */
      204: never;
      /** @description Resource Not Found */
      404: never;
      /** @description Validation Error */
      422: never;
    };
  };
  /**
   * List self-hosted runners for an organization
   * @description Lists all self-hosted runners configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/list-self-hosted-runners-for-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            runners: components["schemas"]["runner"][];
          };
        };
      };
    };
  };
  /**
   * List runner applications for an organization
   * @description Lists binaries for the runner application that you can download and run.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/list-runner-applications-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["runner-application"][];
        };
      };
    };
  };
  /**
   * Create a registration token for an organization
   * @description Returns a token that you can pass to the `config` script. The token expires after one hour.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * #### Example using registration token
   *
   * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
   *
   * ```
   * ./config.sh --url https://github.com/octo-org --token TOKEN
   * ```
   */
  "actions/create-registration-token-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["authentication-token"];
        };
      };
    };
  };
  /**
   * Create a remove token for an organization
   * @description Returns a token that you can pass to the `config` script to remove a self-hosted runner from an organization. The token expires after one hour.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   *
   * #### Example using remove token
   *
   * To remove your self-hosted runner from an organization, replace `TOKEN` with the remove token provided by this
   * endpoint.
   *
   * ```
   * ./config.sh remove --token TOKEN
   * ```
   */
  "actions/create-remove-token-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["authentication-token"];
        };
      };
    };
  };
  /**
   * Get a self-hosted runner for an organization
   * @description Gets a specific self-hosted runner configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/get-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["runner"];
        };
      };
    };
  };
  /**
   * Delete a self-hosted runner from an organization
   * @description Forces the removal of a self-hosted runner from an organization. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/delete-self-hosted-runner-from-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List labels for a self-hosted runner for an organization
   * @description Lists all labels for a self-hosted runner configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/list-labels-for-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set custom labels for a self-hosted runner for an organization
   * @description Remove all previous custom labels and set the new custom labels for a specific
   * self-hosted runner configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/set-custom-labels-for-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The names of the custom labels to set for the runner. You can pass an empty array to remove all custom labels. */
          labels: string[];
        };
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Add custom labels to a self-hosted runner for an organization
   * @description Add custom labels to a self-hosted runner configured in an organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/add-custom-labels-to-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The names of the custom labels to add to the runner. */
          labels: string[];
        };
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Remove all custom labels from a self-hosted runner for an organization
   * @description Remove all custom labels from a self-hosted runner configured in an
   * organization. Returns the remaining read-only labels from the runner.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/remove-all-custom-labels-from-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels_readonly"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Remove a custom label from a self-hosted runner for an organization
   * @description Remove a custom label from a self-hosted runner configured
   * in an organization. Returns the remaining labels from the runner.
   *
   * This endpoint returns a `404 Not Found` status if the custom label is not
   * present on the runner.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "actions/remove-custom-label-from-self-hosted-runner-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        runner_id: components["parameters"]["runner-id"];
        name: components["parameters"]["runner-label-name"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List organization secrets
   * @description Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/list-org-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["organization-actions-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get an organization public key
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/get-org-public-key": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-public-key"];
        };
      };
    };
  };
  /**
   * Get an organization secret
   * @description Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/get-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["organization-actions-secret"];
        };
      };
    };
  };
  /**
   * Create or update an organization secret
   * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to
   * use this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
   *
   * ```
   * const sodium = require('tweetsodium');
   *
   * const key = "base64-encoded-public-key";
   * const value = "plain-text-secret";
   *
   * // Convert the message and key to Uint8Array's (Buffer implements that interface)
   * const messageBytes = Buffer.from(value);
   * const keyBytes = Buffer.from(key, 'base64');
   *
   * // Encrypt using LibSodium.
   * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
   *
   * // Base64 the encrypted secret
   * const encrypted = Buffer.from(encryptedBytes).toString('base64');
   *
   * console.log(encrypted);
   * ```
   *
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "actions/create-or-update-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get an organization public key](https://docs.github.com/rest/reference/actions#get-an-organization-public-key) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id?: string;
          /**
           * @description Which type of organization repositories have access to the organization secret. `selected` means only the repositories specified by `selected_repository_ids` can access the secret.
           * @enum {string}
           */
          visibility: "all" | "private" | "selected";
          /** @description An array of repository ids that can access the organization secret. You can only provide a list of repository ids when the `visibility` is set to `selected`. You can manage the list of selected repositories using the [List selected repositories for an organization secret](https://docs.github.com/rest/reference/actions#list-selected-repositories-for-an-organization-secret), [Set selected repositories for an organization secret](https://docs.github.com/rest/reference/actions#set-selected-repositories-for-an-organization-secret), and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/actions#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids?: (number | string)[];
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete an organization secret
   * @description Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/delete-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List selected repositories for an organization secret
   * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/list-selected-repos-for-org-secret": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["minimal-repository"][];
          };
        };
      };
    };
  };
  /**
   * Set selected repositories for an organization secret
   * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/set-selected-repos-for-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of repository ids that can access the organization secret. You can only provide a list of repository ids when the `visibility` is set to `selected`. You can add and remove individual repositories using the [Add selected repository to an organization secret](https://docs.github.com/rest/actions/secrets#add-selected-repository-to-an-organization-secret) and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/actions#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Add selected repository to an organization secret
   * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/add-selected-repo-to-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description No Content when repository was added to the selected list */
      204: never;
      /** @description Conflict when visibility type is not set to selected */
      409: never;
    };
  };
  /**
   * Remove selected repository from an organization secret
   * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/actions#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `secrets` organization permission to use this endpoint.
   */
  "actions/remove-selected-repo-from-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description Response when repository was removed from the selected list */
      204: never;
      /** @description Conflict when visibility type not set to selected */
      409: never;
    };
  };
  /**
   * List organization variables
   * @description Lists all organization variables. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
   */
  "actions/list-org-variables": {
    parameters: {
      query: {
        per_page?: components["parameters"]["variables-per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            variables: components["schemas"]["organization-actions-variable"][];
          };
        };
      };
    };
  };
  /**
   * Create an organization variable
   * @description Creates an organization variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/create-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name: string;
          /** @description The value of the variable. */
          value: string;
          /**
           * @description The type of repositories in the organization that can access the variable. `selected` means only the repositories specified by `selected_repository_ids` can access the variable.
           * @enum {string}
           */
          visibility: "all" | "private" | "selected";
          /** @description An array of repository ids that can access the organization variable. You can only provide a list of repository ids when the `visibility` is set to `selected`. */
          selected_repository_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response when creating a variable */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * Get an organization variable
   * @description Gets a specific variable in an organization. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
   */
  "actions/get-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["organization-actions-variable"];
        };
      };
    };
  };
  /**
   * Delete an organization variable
   * @description Deletes an organization variable using the variable name.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/delete-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update an organization variable
   * @description Updates an organization variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   * GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/update-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name?: string;
          /** @description The value of the variable. */
          value?: string;
          /**
           * @description The type of repositories in the organization that can access the variable. `selected` means only the repositories specified by `selected_repository_ids` can access the variable.
           * @enum {string}
           */
          visibility?: "all" | "private" | "selected";
          /** @description An array of repository ids that can access the organization variable. You can only provide a list of repository ids when the `visibility` is set to `selected`. */
          selected_repository_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List selected repositories for an organization variable
   * @description Lists all repositories that can access an organization variable that is available to selected repositories. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:read` organization permission to use this endpoint.
   */
  "actions/list-selected-repos-for-org-variable": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["minimal-repository"][];
          };
        };
      };
      /** @description Response when the visibility of the variable is not set to `selected` */
      409: never;
    };
  };
  /**
   * Set selected repositories for an organization variable
   * @description Replaces all repositories for an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/set-selected-repos-for-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The IDs of the repositories that can access the organization variable. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Response when the visibility of the variable is not set to `selected` */
      409: never;
    };
  };
  /**
   * Add selected repository to an organization variable
   * @description Adds a repository to an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/add-selected-repo-to-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Response when the visibility of the variable is not set to `selected` */
      409: never;
    };
  };
  /**
   * Remove selected repository from an organization variable
   * @description Removes a repository from an organization variable that is available to selected repositories. Organization variables that are available to selected repositories have their `visibility` field set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `organization_actions_variables:write` organization permission to use this endpoint.
   */
  "actions/remove-selected-repo-from-org-variable": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        name: components["parameters"]["variable-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Response when the visibility of the variable is not set to `selected` */
      409: never;
    };
  };
  /**
   * List users blocked by an organization
   * @description List the users blocked by an organization.
   */
  "orgs/list-blocked-users": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /** Check if a user is blocked by an organization */
  "orgs/check-blocked-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description If the user is blocked */
      204: never;
      /** @description If the user is not blocked */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /** Block a user from an organization */
  "orgs/block-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /** Unblock a user from an organization */
  "orgs/unblock-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List code scanning alerts for an organization
   * @description Lists code scanning alerts for the default branch for all eligible repositories in an organization. Eligible repositories are repositories that are owned by organizations that you own or for which you are a security manager. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   *
   * To use this endpoint, you must be an owner or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
   *
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `security_events` read permission to use this endpoint.
   */
  "code-scanning/list-alerts-for-org": {
    parameters: {
      query: {
        tool_name?: components["parameters"]["tool-name"];
        tool_guid?: components["parameters"]["tool-guid"];
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        direction?: components["parameters"]["direction"];
        /** @description If specified, only code scanning alerts with this state will be returned. */
        state?: components["schemas"]["code-scanning-alert-state"];
        /** @description The property by which to sort the results. */
        sort?: "created" | "updated";
        /** @description If specified, only code scanning alerts with this severity will be returned. */
        severity?: components["schemas"]["code-scanning-alert-severity"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["code-scanning-organization-alert-items"][];
        };
      };
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List codespaces for the organization
   * @description Lists the codespaces associated to a specified organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/list-in-organization": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            codespaces: components["schemas"]["codespace"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Manage access control for organization codespaces
   * @description Sets which users can access codespaces in an organization. This is synonymous with granting or revoking codespaces billing permissions for users according to the visibility.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/set-codespaces-billing": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Which users can access codespaces in the organization. `disabled` means that no users can access codespaces in the organization.
           * @enum {string}
           */
          visibility:
            | "disabled"
            | "selected_members"
            | "all_members"
            | "all_members_and_outside_collaborators";
          /** @description The usernames of the organization members who should have access to codespaces in the organization. Required when `visibility` is `selected_members`. The provided list of usernames will replace any existing value. */
          selected_usernames?: string[];
        };
      };
    };
    responses: {
      /** @description Response when successfully modifying permissions. */
      204: never;
      304: components["responses"]["not_modified"];
      /** @description Users are neither members nor collaborators of this organization. */
      400: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Add users to Codespaces billing for an organization
   * @description Codespaces for the specified users will be billed to the organization.
   * To use this endpoint, the billing settings for the organization must be set to `selected_members`. For information on how to change this setting please see [these docs].(https://docs.github.com/rest/codespaces/organizations#manage-access-control-for-organization-codespaces) You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/set-codespaces-billing-users": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The usernames of the organization members whose codespaces be billed to the organization. */
          selected_usernames: string[];
        };
      };
    };
    responses: {
      /** @description Response when successfully modifying permissions. */
      204: never;
      304: components["responses"]["not_modified"];
      /** @description Users are neither members nor collaborators of this organization. */
      400: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Removes users from Codespaces billing for an organization
   * @description Codespaces for the specified users will no longer be billed to the organization.
   * To use this endpoint, the billing settings for the organization must be set to `selected_members`. For information on how to change this setting please see [these docs].(https://docs.github.com/rest/codespaces/organizations#manage-access-control-for-organization-codespaces) You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/delete-codespaces-billing-users": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The usernames of the organization members whose codespaces should not be billed to the organization. */
          selected_usernames: string[];
        };
      };
    };
    responses: {
      /** @description Response when successfully modifying permissions. */
      204: never;
      304: components["responses"]["not_modified"];
      /** @description Users are neither members nor collaborators of this organization. */
      400: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List organization secrets
   * @description Lists all Codespaces secrets available at the organization-level without revealing their encrypted values.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/list-org-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["codespaces-org-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get an organization public key
   * @description Gets a public key for an organization, which is required in order to encrypt secrets. You need to encrypt the value of a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/get-org-public-key": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespaces-public-key"];
        };
      };
    };
  };
  /**
   * Get an organization secret
   * @description Gets an organization secret without revealing its encrypted value.
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/get-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["codespaces-org-secret"];
        };
      };
    };
  };
  /**
   * Create or update an organization secret
   * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `admin:org` scope to use this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "codespaces/create-or-update-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get an organization public key](https://docs.github.com/rest/reference/codespaces#get-an-organization-public-key) endpoint. */
          encrypted_value?: string;
          /** @description The ID of the key you used to encrypt the secret. */
          key_id?: string;
          /**
           * @description Which type of organization repositories have access to the organization secret. `selected` means only the repositories specified by `selected_repository_ids` can access the secret.
           * @enum {string}
           */
          visibility: "all" | "private" | "selected";
          /** @description An array of repository IDs that can access the organization secret. You can only provide a list of repository IDs when the `visibility` is set to `selected`. You can manage the list of selected repositories using the [List selected repositories for an organization secret](https://docs.github.com/rest/reference/codespaces#list-selected-repositories-for-an-organization-secret), [Set selected repositories for an organization secret](https://docs.github.com/rest/reference/codespaces#set-selected-repositories-for-an-organization-secret), and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/codespaces#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete an organization secret
   * @description Deletes an organization secret using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/delete-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List selected repositories for an organization secret
   * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/list-selected-repos-for-org-secret": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["minimal-repository"][];
          };
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set selected repositories for an organization secret
   * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/set-selected-repos-for-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of repository ids that can access the organization secret. You can only provide a list of repository ids when the `visibility` is set to `selected`. You can add and remove individual repositories using the [Set selected repositories for an organization secret](https://docs.github.com/rest/reference/codespaces#set-selected-repositories-for-an-organization-secret) and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/codespaces#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      /** @description Conflict when visibility type not set to selected */
      409: never;
    };
  };
  /**
   * Add selected repository to an organization secret
   * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/add-selected-repo-to-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description No Content when repository was added to the selected list */
      204: never;
      404: components["responses"]["not_found"];
      /** @description Conflict when visibility type is not set to selected */
      409: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove selected repository from an organization secret
   * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/codespaces#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/remove-selected-repo-from-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description Response when repository was removed from the selected list */
      204: never;
      404: components["responses"]["not_found"];
      /** @description Conflict when visibility type not set to selected */
      409: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List Dependabot alerts for an organization
   * @description Lists Dependabot alerts for an organization.
   *
   * To use this endpoint, you must be an owner or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
   *
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
   */
  "dependabot/list-alerts-for-org": {
    parameters: {
      query: {
        state?: components["parameters"]["dependabot-alert-comma-separated-states"];
        severity?: components["parameters"]["dependabot-alert-comma-separated-severities"];
        ecosystem?: components["parameters"]["dependabot-alert-comma-separated-ecosystems"];
        package?: components["parameters"]["dependabot-alert-comma-separated-packages"];
        scope?: components["parameters"]["dependabot-alert-scope"];
        sort?: components["parameters"]["dependabot-alert-sort"];
        direction?: components["parameters"]["direction"];
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
        first?: components["parameters"]["pagination-first"];
        last?: components["parameters"]["pagination-last"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-alert-with-repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      400: components["responses"]["bad_request"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List organization secrets
   * @description Lists all secrets available in an organization without revealing their encrypted values. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/list-org-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["organization-dependabot-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get an organization public key
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/get-org-public-key": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-public-key"];
        };
      };
    };
  };
  /**
   * Get an organization secret
   * @description Gets a single organization secret without revealing its encrypted value. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/get-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["organization-dependabot-secret"];
        };
      };
    };
  };
  /**
   * Create or update an organization secret
   * @description Creates or updates an organization secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization
   * permission to use this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [tweetsodium](https://github.com/github/tweetsodium) library.
   *
   * ```
   * const sodium = require('tweetsodium');
   *
   * const key = "base64-encoded-public-key";
   * const value = "plain-text-secret";
   *
   * // Convert the message and key to Uint8Array's (Buffer implements that interface)
   * const messageBytes = Buffer.from(value);
   * const keyBytes = Buffer.from(key, 'base64');
   *
   * // Encrypt using LibSodium.
   * const encryptedBytes = sodium.seal(messageBytes, keyBytes);
   *
   * // Base64 the encrypted secret
   * const encrypted = Buffer.from(encryptedBytes).toString('base64');
   *
   * console.log(encrypted);
   * ```
   *
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "dependabot/create-or-update-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get an organization public key](https://docs.github.com/rest/reference/dependabot#get-an-organization-public-key) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id?: string;
          /**
           * @description Which type of organization repositories have access to the organization secret. `selected` means only the repositories specified by `selected_repository_ids` can access the secret.
           * @enum {string}
           */
          visibility: "all" | "private" | "selected";
          /** @description An array of repository ids that can access the organization secret. You can only provide a list of repository ids when the `visibility` is set to `selected`. You can manage the list of selected repositories using the [List selected repositories for an organization secret](https://docs.github.com/rest/reference/dependabot#list-selected-repositories-for-an-organization-secret), [Set selected repositories for an organization secret](https://docs.github.com/rest/reference/dependabot#set-selected-repositories-for-an-organization-secret), and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/dependabot#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids?: (string | number)[];
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete an organization secret
   * @description Deletes a secret in an organization using the secret name. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/delete-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List selected repositories for an organization secret
   * @description Lists all repositories that have been selected when the `visibility` for repository access to a secret is set to `selected`. You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/list-selected-repos-for-org-secret": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["minimal-repository"][];
          };
        };
      };
    };
  };
  /**
   * Set selected repositories for an organization secret
   * @description Replaces all repositories for an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/set-selected-repos-for-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of repository ids that can access the organization secret. You can only provide a list of repository ids when the `visibility` is set to `selected`. You can add and remove individual repositories using the [Set selected repositories for an organization secret](https://docs.github.com/rest/reference/dependabot#set-selected-repositories-for-an-organization-secret) and [Remove selected repository from an organization secret](https://docs.github.com/rest/reference/dependabot#remove-selected-repository-from-an-organization-secret) endpoints. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Add selected repository to an organization secret
   * @description Adds a repository to an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/add-selected-repo-to-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description No Content when repository was added to the selected list */
      204: never;
      /** @description Conflict when visibility type is not set to selected */
      409: never;
    };
  };
  /**
   * Remove selected repository from an organization secret
   * @description Removes a repository from an organization secret when the `visibility` for repository access is set to `selected`. The visibility is set when you [Create or update an organization secret](https://docs.github.com/rest/reference/dependabot#create-or-update-an-organization-secret). You must authenticate using an access token with the `admin:org` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` organization permission to use this endpoint.
   */
  "dependabot/remove-selected-repo-from-org-secret": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description Response when repository was removed from the selected list */
      204: never;
      /** @description Conflict when visibility type not set to selected */
      409: never;
    };
  };
  /**
   * Get list of conflicting packages during Docker migration for organization
   * @description Lists all packages that are in a specific organization, are readable by the requesting user, and that encountered a conflict during a Docker migration.
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
   */
  "packages/list-docker-migration-conflicting-packages-for-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** List public organization events */
  "activity/list-public-org-events": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /**
   * List failed organization invitations
   * @description The return hash contains `failed_at` and `failed_reason` fields which represent the time at which the invitation failed and the reason for the failure.
   */
  "orgs/list-failed-invitations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-invitation"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** List organization webhooks */
  "orgs/list-webhooks": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["org-hook"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create an organization webhook
   * @description Here's how you can create a hook that posts payloads in JSON format:
   */
  "orgs/create-webhook": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Must be passed as "web". */
          name: string;
          /** @description Key/value pairs to provide settings for this webhook. [These are defined below](https://docs.github.com/rest/reference/orgs#create-hook-config-params). */
          config: {
            url: components["schemas"]["webhook-config-url"];
            content_type?: components["schemas"]["webhook-config-content-type"];
            secret?: components["schemas"]["webhook-config-secret"];
            insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
            /** @example "kdaigle" */
            username?: string;
            /** @example "password" */
            password?: string;
          };
          /**
           * @description Determines what [events](https://docs.github.com/webhooks/event-payloads) the hook is triggered for. Set to `["*"]` to receive all possible events.
           * @default [
           *   "push"
           * ]
           */
          events?: string[];
          /**
           * @description Determines if notifications are sent when the webhook is triggered. Set to `true` to send notifications.
           * @default true
           */
          active?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/orgs/octocat/hooks/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["org-hook"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an organization webhook
   * @description Returns a webhook configured in an organization. To get only the webhook `config` properties, see "[Get a webhook configuration for an organization](/rest/reference/orgs#get-a-webhook-configuration-for-an-organization)."
   */
  "orgs/get-webhook": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-hook"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Delete an organization webhook */
  "orgs/delete-webhook": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update an organization webhook
   * @description Updates a webhook configured in an organization. When you update a webhook, the `secret` will be overwritten. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for an organization](/rest/reference/orgs#update-a-webhook-configuration-for-an-organization)."
   */
  "orgs/update-webhook": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Key/value pairs to provide settings for this webhook. [These are defined below](https://docs.github.com/rest/reference/orgs#update-hook-config-params). */
          config?: {
            url: components["schemas"]["webhook-config-url"];
            content_type?: components["schemas"]["webhook-config-content-type"];
            secret?: components["schemas"]["webhook-config-secret"];
            insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
          };
          /**
           * @description Determines what [events](https://docs.github.com/webhooks/event-payloads) the hook is triggered for.
           * @default [
           *   "push"
           * ]
           */
          events?: string[];
          /**
           * @description Determines if notifications are sent when the webhook is triggered. Set to `true` to send notifications.
           * @default true
           */
          active?: boolean;
          /** @example "web" */
          name?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-hook"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a webhook configuration for an organization
   * @description Returns the webhook configuration for an organization. To get more information about the webhook, including the `active` state and `events`, use "[Get an organization webhook ](/rest/reference/orgs#get-an-organization-webhook)."
   *
   * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:read` permission.
   */
  "orgs/get-webhook-config-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * Update a webhook configuration for an organization
   * @description Updates the webhook configuration for an organization. To update more information about the webhook, including the `active` state and `events`, use "[Update an organization webhook ](/rest/reference/orgs#update-an-organization-webhook)."
   *
   * Access tokens must have the `admin:org_hook` scope, and GitHub Apps must have the `organization_hooks:write` permission.
   */
  "orgs/update-webhook-config-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          url?: components["schemas"]["webhook-config-url"];
          content_type?: components["schemas"]["webhook-config-content-type"];
          secret?: components["schemas"]["webhook-config-secret"];
          insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * List deliveries for an organization webhook
   * @description Returns a list of webhook deliveries for a webhook configured in an organization.
   */
  "orgs/list-webhook-deliveries": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        cursor?: components["parameters"]["cursor"];
        redelivery?: boolean;
      };
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery-item"][];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a webhook delivery for an organization webhook
   * @description Returns a delivery for a webhook configured in an organization.
   */
  "orgs/get-webhook-delivery": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery"];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Redeliver a delivery for an organization webhook
   * @description Redeliver a delivery for a webhook configured in an organization.
   */
  "orgs/redeliver-webhook-delivery": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Ping an organization webhook
   * @description This will trigger a [ping event](https://docs.github.com/webhooks/#ping-event) to be sent to the hook.
   */
  "orgs/ping-webhook": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get an organization installation for the authenticated app
   * @description Enables an authenticated GitHub App to find the organization's installation information.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-org-installation": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["installation"];
        };
      };
    };
  };
  /**
   * List app installations for an organization
   * @description Lists all GitHub Apps in an organization. The installation count includes all GitHub Apps installed on repositories in the organization. You must be an organization owner with `admin:read` scope to use this endpoint.
   */
  "orgs/list-app-installations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            installations: components["schemas"]["installation"][];
          };
        };
      };
    };
  };
  /**
   * Get interaction restrictions for an organization
   * @description Shows which type of GitHub user can interact with this organization and when the restriction expires. If there is no restrictions, you will see an empty response.
   */
  "interactions/get-restrictions-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json":
            | components["schemas"]["interaction-limit-response"]
            | Record<string, never>;
        };
      };
    };
  };
  /**
   * Set interaction restrictions for an organization
   * @description Temporarily restricts interactions to a certain type of GitHub user in any public repository in the given organization. You must be an organization owner to set these restrictions. Setting the interaction limit at the organization level will overwrite any interaction limits that are set for individual repositories owned by the organization.
   */
  "interactions/set-restrictions-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["interaction-limit"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["interaction-limit-response"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove interaction restrictions for an organization
   * @description Removes all interaction restrictions from public repositories in the given organization. You must be an organization owner to remove restrictions.
   */
  "interactions/remove-restrictions-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List pending organization invitations
   * @description The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, or `hiring_manager`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
   */
  "orgs/list-pending-invitations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        /** @description Filter invitations by their member role. */
        role?:
          | "all"
          | "admin"
          | "direct_member"
          | "billing_manager"
          | "hiring_manager";
        /** @description Filter invitations by their invitation source. */
        invitation_source?: "all" | "member" | "scim";
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-invitation"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create an organization invitation
   * @description Invite people to an organization by using their GitHub user ID or their email address. In order to create invitations in an organization, the authenticated user must be an organization owner.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "orgs/create-invitation": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description **Required unless you provide `email`**. GitHub user ID for the person you are inviting. */
          invitee_id?: number;
          /** @description **Required unless you provide `invitee_id`**. Email address of the person you are inviting, which can be an existing GitHub user. */
          email?: string;
          /**
           * @description The role for the new member.
           *  * `admin` - Organization owners with full administrative rights to the organization and complete access to all repositories and teams.
           *  * `direct_member` - Non-owner organization members with ability to see other members and join teams by invitation.
           *  * `billing_manager` - Non-owner organization members with ability to manage the billing settings of your organization.
           * @default direct_member
           * @enum {string}
           */
          role?: "admin" | "direct_member" | "billing_manager";
          /** @description Specify IDs for the teams you want to invite new members to. */
          team_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["organization-invitation"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Cancel an organization invitation
   * @description Cancel an organization invitation. In order to cancel an organization invitation, the authenticated user must be an organization owner.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications).
   */
  "orgs/cancel-invitation": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List organization invitation teams
   * @description List all teams associated with an invitation. In order to see invitations in an organization, the authenticated user must be an organization owner.
   */
  "orgs/list-invitation-teams": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List organization issues assigned to the authenticated user
   * @description List issues in an organization assigned to the authenticated user.
   *
   * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
   * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
   * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
   * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
   */
  "issues/list-for-org": {
    parameters: {
      query: {
        /** @description Indicates which sorts of issues to return. `assigned` means issues assigned to you. `created` means issues created by you. `mentioned` means issues mentioning you. `subscribed` means issues you're subscribed to updates for. `all` or `repos` means all issues you can see, regardless of participation or creation. */
        filter?:
          | "assigned"
          | "created"
          | "mentioned"
          | "subscribed"
          | "repos"
          | "all";
        /** @description Indicates the state of the issues to return. */
        state?: "open" | "closed" | "all";
        labels?: components["parameters"]["labels"];
        /** @description What to sort results by. */
        sort?: "created" | "updated" | "comments";
        direction?: components["parameters"]["direction"];
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List organization members
   * @description List all users who are members of an organization. If the authenticated user is also a member of this organization then both concealed and public members will be returned.
   */
  "orgs/list-members": {
    parameters: {
      query: {
        /** @description Filter members returned in the list. `2fa_disabled` means that only members without [two-factor authentication](https://github.com/blog/1614-two-factor-authentication) enabled will be returned. This options is only available for organization owners. */
        filter?: "2fa_disabled" | "all";
        /** @description Filter members returned by their role. */
        role?: "all" | "admin" | "member";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Check organization membership for a user
   * @description Check if a user is, publicly or privately, a member of the organization.
   */
  "orgs/check-membership-for-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response if requester is an organization member and user is a member */
      204: never;
      /** @description Response if requester is not an organization member */
      302: never;
      /** @description Not Found if requester is an organization member and user is not a member */
      404: never;
    };
  };
  /**
   * Remove an organization member
   * @description Removing a user from this list will remove them from all teams and they will no longer have any access to the organization's repositories.
   */
  "orgs/remove-member": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List codespaces for a user in organization
   * @description Lists the codespaces that a member of an organization has for repositories in that organization.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/get-codespaces-for-user-in-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            codespaces: components["schemas"]["codespace"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Delete a codespace from the organization
   * @description Deletes a user's codespace.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/delete-from-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Stop a codespace for an organization user
   * @description Stops a user's codespace.
   *
   * You must authenticate using an access token with the `admin:org` scope to use this endpoint.
   */
  "codespaces/stop-in-organization": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get organization membership for a user
   * @description In order to get a user's membership with an organization, the authenticated user must be an organization member. The `state` parameter in the response can be used to identify the user's membership status.
   */
  "orgs/get-membership-for-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-membership"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set organization membership for a user
   * @description Only authenticated organization owners can add a member to the organization or update the member's role.
   *
   * *   If the authenticated user is _adding_ a member to the organization, the invited user will receive an email inviting them to the organization. The user's [membership status](https://docs.github.com/rest/reference/orgs#get-organization-membership-for-a-user) will be `pending` until they accept the invitation.
   *
   * *   Authenticated users can _update_ a user's membership by passing the `role` parameter. If the authenticated user changes a member's role to `admin`, the affected user will receive an email notifying them that they've been made an organization owner. If the authenticated user changes an owner's role to `member`, no email will be sent.
   *
   * **Rate limits**
   *
   * To prevent abuse, the authenticated user is limited to 50 organization invitations per 24 hour period. If the organization is more than one month old or on a paid plan, the limit is 500 invitations per 24 hour period.
   */
  "orgs/set-membership-for-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The role to give the user in the organization. Can be one of:
           *  * `admin` - The user will become an owner of the organization.
           *  * `member` - The user will become a non-owner member of the organization.
           * @default member
           * @enum {string}
           */
          role?: "admin" | "member";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-membership"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove organization membership for a user
   * @description In order to remove a user's membership with an organization, the authenticated user must be an organization owner.
   *
   * If the specified user is an active member of the organization, this will remove them from the organization. If the specified user has been invited to the organization, this will cancel their invitation. The specified user will receive an email notification in both cases.
   */
  "orgs/remove-membership-for-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List organization migrations
   * @description Lists the most recent migrations, including both exports (which can be started through the REST API) and imports (which cannot be started using the REST API).
   *
   * A list of `repositories` is only returned for export migrations.
   */
  "migrations/list-for-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        /** @description Exclude attributes from the API response to improve performance */
        exclude?: "repositories"[];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["migration"][];
        };
      };
    };
  };
  /**
   * Start an organization migration
   * @description Initiates the generation of a migration archive.
   */
  "migrations/start-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description A list of arrays indicating which repositories should be migrated. */
          repositories: string[];
          /**
           * @description Indicates whether repositories should be locked (to prevent manipulation) while migrating data.
           * @default false
           * @example true
           */
          lock_repositories?: boolean;
          /**
           * @description Indicates whether metadata should be excluded and only git source should be included for the migration.
           * @default false
           */
          exclude_metadata?: boolean;
          /**
           * @description Indicates whether the repository git data should be excluded from the migration.
           * @default false
           */
          exclude_git_data?: boolean;
          /**
           * @description Indicates whether attachments should be excluded from the migration (to reduce migration archive file size).
           * @default false
           * @example true
           */
          exclude_attachments?: boolean;
          /**
           * @description Indicates whether releases should be excluded from the migration (to reduce migration archive file size).
           * @default false
           * @example true
           */
          exclude_releases?: boolean;
          /**
           * @description Indicates whether projects owned by the organization or users should be excluded. from the migration.
           * @default false
           * @example true
           */
          exclude_owner_projects?: boolean;
          /**
           * @description Indicates whether this should only include organization metadata (repositories array should be empty and will ignore other flags).
           * @default false
           * @example true
           */
          org_metadata_only?: boolean;
          /** @description Exclude related items from being returned in the response in order to improve performance of the request. The array can include any of: `"repositories"`. */
          exclude?: "repositories"[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["migration"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an organization migration status
   * @description Fetches the status of a migration.
   *
   * The `state` of a migration can be one of the following values:
   *
   * *   `pending`, which means the migration hasn't started yet.
   * *   `exporting`, which means the migration is in progress.
   * *   `exported`, which means the migration finished successfully.
   * *   `failed`, which means the migration failed.
   */
  "migrations/get-status-for-org": {
    parameters: {
      query: {
        /** @description Exclude attributes from the API response to improve performance */
        exclude?: "repositories"[];
      };
      path: {
        org: components["parameters"]["org"];
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /**
       * @description *   `pending`, which means the migration hasn't started yet.
       * *   `exporting`, which means the migration is in progress.
       * *   `exported`, which means the migration finished successfully.
       * *   `failed`, which means the migration failed.
       */
      200: {
        content: {
          "application/json": components["schemas"]["migration"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Download an organization migration archive
   * @description Fetches the URL to a migration archive.
   */
  "migrations/download-archive-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      302: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an organization migration archive
   * @description Deletes a previous migration archive. Migration archives are automatically deleted after seven days.
   */
  "migrations/delete-archive-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Unlock an organization repository
   * @description Unlocks a repository that was locked for migration. You should unlock each migrated repository and [delete them](https://docs.github.com/rest/repos/repos#delete-a-repository) when the migration is complete and you no longer need the source data.
   */
  "migrations/unlock-repo-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        migration_id: components["parameters"]["migration-id"];
        repo_name: components["parameters"]["repo-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repositories in an organization migration
   * @description List all the repositories for this organization migration.
   */
  "migrations/list-repos-for-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List outside collaborators for an organization
   * @description List all users who are outside collaborators of an organization.
   */
  "orgs/list-outside-collaborators": {
    parameters: {
      query: {
        /** @description Filter the list of outside collaborators. `2fa_disabled` means that only outside collaborators without [two-factor authentication](https://github.com/blog/1614-two-factor-authentication) enabled will be returned. */
        filter?: "2fa_disabled" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /**
   * Convert an organization member to outside collaborator
   * @description When an organization member is converted to an outside collaborator, they'll only have access to the repositories that their current team membership allows. The user will no longer be a member of the organization. For more information, see "[Converting an organization member to an outside collaborator](https://docs.github.com/articles/converting-an-organization-member-to-an-outside-collaborator/)". Converting an organization member to an outside collaborator may be restricted by enterprise administrators. For more information, see "[Enforcing repository management policies in your enterprise](https://docs.github.com/admin/policies/enforcing-policies-for-your-enterprise/enforcing-repository-management-policies-in-your-enterprise#enforcing-a-policy-for-inviting-outside-collaborators-to-repositories)."
   */
  "orgs/convert-member-to-outside-collaborator": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description When set to `true`, the request will be performed asynchronously. Returns a 202 status code when the job is successfully queued.
           * @default false
           */
          async?: boolean;
        };
      };
    };
    responses: {
      /** @description User is getting converted asynchronously */
      202: {
        content: {
          "application/json": Record<string, never>;
        };
      };
      /** @description User was converted */
      204: never;
      /** @description Forbidden if user is the last owner of the organization, not a member of the organization, or if the enterprise enforces a policy for inviting outside collaborators. For more information, see "[Enforcing repository management policies in your enterprise](https://docs.github.com/admin/policies/enforcing-policies-for-your-enterprise/enforcing-repository-management-policies-in-your-enterprise#enforcing-a-policy-for-inviting-outside-collaborators-to-repositories)." */
      403: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Remove outside collaborator from an organization
   * @description Removing a user from this list will remove them from all the organization's repositories.
   */
  "orgs/remove-outside-collaborator": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Unprocessable Entity if user is a member of the organization */
      422: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
    };
  };
  /**
   * List packages for an organization
   * @description Lists packages in an organization readable by the user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/list-packages-for-organization": {
    parameters: {
      query: {
        /** @description The type of supported package. Packages in GitHub's Gradle registry have the type `maven`. Docker images pushed to GitHub's Container registry (`ghcr.io`) have the type `container`. You can use the type `docker` to find images that were pushed to GitHub's Docker registry (`docker.pkg.github.com`), even if these have now been migrated to the Container registry. */
        package_type:
          | "npm"
          | "maven"
          | "rubygems"
          | "docker"
          | "nuget"
          | "container";
        visibility?: components["parameters"]["package-visibility"];
        /** @description Page number of the results to fetch. */
        page?: number;
        /** @description The number of results per page (max 100). */
        per_page?: number;
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
      400: components["responses"]["package_es_list_error"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get a package for an organization
   * @description Gets a specific package in an organization.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-for-organization": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"];
        };
      };
    };
  };
  /**
   * Delete a package for an organization
   * @description Deletes an entire package in an organization. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/delete-package-for-org": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore a package for an organization
   * @description Restores an entire package in an organization.
   *
   * You can restore a deleted package under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/restore-package-for-org": {
    parameters: {
      query: {
        /** @description package token */
        token?: string;
      };
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List package versions for a package owned by an organization
   * @description Lists package versions for a package owned by an organization.
   *
   * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-all-package-versions-for-package-owned-by-org": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        /** @description The state of the package, either active or deleted. */
        state?: "active" | "deleted";
      };
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a package version for an organization
   * @description Gets a specific package version in an organization.
   *
   * You must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-version-for-organization": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"];
        };
      };
    };
  };
  /**
   * Delete package version for an organization
   * @description Deletes a specific package version in an organization. If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/delete-package-version-for-org": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore package version for an organization
   * @description Restores a specific package version in an organization.
   *
   * You can restore a deleted package under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/restore-package-version-for-org": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        org: components["parameters"]["org"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List organization projects
   * @description Lists the projects in an organization. Returns a `404 Not Found` status if projects are disabled in the organization. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/list-for-org": {
    parameters: {
      query: {
        /** @description Indicates the state of the projects to return. */
        state?: "open" | "closed" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["project"][];
        };
      };
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Create an organization project
   * @description Creates an organization project board. Returns a `410 Gone` status if projects are disabled in the organization or if the organization does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/create-for-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the project. */
          name: string;
          /** @description The description of the project. */
          body?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["project"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List public organization members
   * @description Members of an organization can choose to have their membership publicized or not.
   */
  "orgs/list-public-members": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /** Check public organization membership for a user */
  "orgs/check-public-membership-for-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response if user is a public member */
      204: never;
      /** @description Not Found if user is not a public member */
      404: never;
    };
  };
  /**
   * Set public organization membership for the authenticated user
   * @description The user can publicize their own membership. (A user cannot publicize the membership for another user.)
   *
   * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "orgs/set-public-membership-for-authenticated-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
    };
  };
  /** Remove public organization membership for the authenticated user */
  "orgs/remove-public-membership-for-authenticated-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List organization repositories
   * @description Lists repositories for the specified organization.
   *
   * **Note:** In order to see the `security_and_analysis` block for a repository you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   */
  "repos/list-for-org": {
    parameters: {
      query: {
        /** @description Specifies the types of repositories you want returned. */
        type?: "all" | "public" | "private" | "forks" | "sources" | "member";
        /** @description The property to sort the results by. */
        sort?: "created" | "updated" | "pushed" | "full_name";
        /** @description The order to sort by. Default: `asc` when using `full_name`, otherwise `desc`. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
    };
  };
  /**
   * Create an organization repository
   * @description Creates a new repository in the specified organization. The authenticated user must be a member of the organization.
   *
   * **OAuth scope requirements**
   *
   * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
   *
   * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
   * *   `repo` scope to create a private repository
   */
  "repos/create-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the repository. */
          name: string;
          /** @description A short description of the repository. */
          description?: string;
          /** @description A URL with more information about the repository. */
          homepage?: string;
          /**
           * @description Whether the repository is private.
           * @default false
           */
          private?: boolean;
          /**
           * @description The visibility of the repository.
           * @enum {string}
           */
          visibility?: "public" | "private";
          /**
           * @description Either `true` to enable issues for this repository or `false` to disable them.
           * @default true
           */
          has_issues?: boolean;
          /**
           * @description Either `true` to enable projects for this repository or `false` to disable them. **Note:** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
           * @default true
           */
          has_projects?: boolean;
          /**
           * @description Either `true` to enable the wiki for this repository or `false` to disable it.
           * @default true
           */
          has_wiki?: boolean;
          /**
           * @description Whether downloads are enabled.
           * @default true
           * @example true
           */
          has_downloads?: boolean;
          /**
           * @description Either `true` to make this repo available as a template repository or `false` to prevent it.
           * @default false
           */
          is_template?: boolean;
          /** @description The id of the team that will be granted access to this repository. This is only valid when creating a repository in an organization. */
          team_id?: number;
          /**
           * @description Pass `true` to create an initial commit with empty README.
           * @default false
           */
          auto_init?: boolean;
          /** @description Desired language or platform [.gitignore template](https://github.com/github/gitignore) to apply. Use the name of the template without the extension. For example, "Haskell". */
          gitignore_template?: string;
          /** @description Choose an [open source license template](https://choosealicense.com/) that best suits your needs, and then use the [license keyword](https://docs.github.com/articles/licensing-a-repository/#searching-github-by-license-type) as the `license_template` string. For example, "mit" or "mpl-2.0". */
          license_template?: string;
          /**
           * @description Either `true` to allow squash-merging pull requests, or `false` to prevent squash-merging.
           * @default true
           */
          allow_squash_merge?: boolean;
          /**
           * @description Either `true` to allow merging pull requests with a merge commit, or `false` to prevent merging pull requests with merge commits.
           * @default true
           */
          allow_merge_commit?: boolean;
          /**
           * @description Either `true` to allow rebase-merging pull requests, or `false` to prevent rebase-merging.
           * @default true
           */
          allow_rebase_merge?: boolean;
          /**
           * @description Either `true` to allow auto-merge on pull requests, or `false` to disallow auto-merge.
           * @default false
           */
          allow_auto_merge?: boolean;
          /**
           * @description Either `true` to allow automatically deleting head branches when pull requests are merged, or `false` to prevent automatic deletion. **The authenticated user must be an organization owner to set this property to `true`.**
           * @default false
           */
          delete_branch_on_merge?: boolean;
          /**
           * @deprecated
           * @description Either `true` to allow squash-merge commits to use pull request title, or `false` to use commit message. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
           * @default false
           */
          use_squash_pr_title_as_default?: boolean;
          /**
           * @description The default value for a squash merge commit title:
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
           * @enum {string}
           */
          squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
          /**
           * @description The default value for a squash merge commit message:
           *
           * - `PR_BODY` - default to the pull request's body.
           * - `COMMIT_MESSAGES` - default to the branch's commit messages.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
          /**
           * @description The default value for a merge commit title.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
           * @enum {string}
           */
          merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
          /**
           * @description The default value for a merge commit message.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `PR_BODY` - default to the pull request's body.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["repository"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get all organization repository rulesets
   * @description Get all the repository rulesets for an organization.
   */
  "repos/get-org-rulesets": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"][];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Create an organization repository ruleset
   * @description Create a repository ruleset for an organization.
   */
  "repos/create-org-ruleset": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    /** @description Request body */
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the ruleset. */
          name: string;
          /**
           * @description The target of the ruleset.
           * @enum {string}
           */
          target?: "branch" | "tag";
          enforcement: components["schemas"]["repository-rule-enforcement"];
          /** @description The actors that can bypass the rules in this ruleset */
          bypass_actors?: components["schemas"]["repository-ruleset-bypass-actor"][];
          conditions?: components["schemas"]["org-ruleset-conditions"];
          /** @description An array of rules within the ruleset. */
          rules?: components["schemas"]["repository-rule"][];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get an organization repository ruleset
   * @description Get a repository ruleset for an organization.
   */
  "repos/get-org-ruleset": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Update an organization repository ruleset
   * @description Update a ruleset for an organization.
   */
  "repos/update-org-ruleset": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    /** @description Request body */
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the ruleset. */
          name?: string;
          /**
           * @description The target of the ruleset.
           * @enum {string}
           */
          target?: "branch" | "tag";
          enforcement?: components["schemas"]["repository-rule-enforcement"];
          /** @description The actors that can bypass the rules in this ruleset */
          bypass_actors?: components["schemas"]["repository-ruleset-bypass-actor"][];
          conditions?: components["schemas"]["org-ruleset-conditions"];
          /** @description An array of rules within the ruleset. */
          rules?: components["schemas"]["repository-rule"][];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Delete an organization repository ruleset
   * @description Delete a ruleset for an organization.
   */
  "repos/delete-org-ruleset": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List secret scanning alerts for an organization
   * @description Lists secret scanning alerts for eligible repositories in an organization, from newest to oldest.
   * To use this endpoint, you must be an administrator or security manager for the organization, and you must use an access token with the `repo` scope or `security_events` scope.
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
   */
  "secret-scanning/list-alerts-for-org": {
    parameters: {
      query: {
        state?: components["parameters"]["secret-scanning-alert-state"];
        secret_type?: components["parameters"]["secret-scanning-alert-secret-type"];
        resolution?: components["parameters"]["secret-scanning-alert-resolution"];
        sort?: components["parameters"]["secret-scanning-alert-sort"];
        direction?: components["parameters"]["direction"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        before?: components["parameters"]["secret-scanning-pagination-before-org-repo"];
        after?: components["parameters"]["secret-scanning-pagination-after-org-repo"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-secret-scanning-alert"][];
        };
      };
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List security manager teams
   * @description Lists teams that are security managers for an organization. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   *
   * To use this endpoint, you must be an administrator or security manager for the organization, and you must use an access token with the `read:org` scope.
   *
   * GitHub Apps must have the `administration` organization read permission to use this endpoint.
   */
  "orgs/list-security-manager-teams": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-simple"][];
        };
      };
    };
  };
  /**
   * Add a security manager team
   * @description Adds a team as a security manager for an organization. For more information, see "[Managing security for an organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization) for an organization."
   *
   * To use this endpoint, you must be an administrator for the organization, and you must use an access token with the `write:org` scope.
   *
   * GitHub Apps must have the `administration` organization read-write permission to use this endpoint.
   */
  "orgs/add-security-manager-team": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description The organization has reached the maximum number of security manager teams. */
      409: never;
    };
  };
  /**
   * Remove a security manager team
   * @description Removes the security manager role from a team for an organization. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization) team from an organization."
   *
   * To use this endpoint, you must be an administrator for the organization, and you must use an access token with the `admin:org` scope.
   *
   * GitHub Apps must have the `administration` organization read-write permission to use this endpoint.
   */
  "orgs/remove-security-manager-team": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get GitHub Actions billing for an organization
   * @description Gets the summary of the free and paid GitHub Actions minutes used.
   *
   * Paid minutes only apply to workflows in private repositories that use GitHub-hosted runners. Minutes used is listed for each GitHub-hosted runner operating system. Any job re-runs are also included in the usage. The usage returned includes any minute multipliers for macOS and Windows runners, and is rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
   *
   * Access tokens must have the `repo` or `admin:org` scope.
   */
  "billing/get-github-actions-billing-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-billing-usage"];
        };
      };
    };
  };
  /**
   * Get GitHub Packages billing for an organization
   * @description Gets the free and paid storage used for GitHub Packages in gigabytes.
   *
   * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
   *
   * Access tokens must have the `repo` or `admin:org` scope.
   */
  "billing/get-github-packages-billing-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["packages-billing-usage"];
        };
      };
    };
  };
  /**
   * Get shared storage billing for an organization
   * @description Gets the estimated paid and estimated total storage used for GitHub Actions and GitHub Packages.
   *
   * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
   *
   * Access tokens must have the `repo` or `admin:org` scope.
   */
  "billing/get-shared-storage-billing-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["combined-billing-usage"];
        };
      };
    };
  };
  /**
   * List teams
   * @description Lists all teams in an organization that are visible to the authenticated user.
   */
  "teams/list": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Create a team
   * @description To create a team, the authenticated user must be a member or owner of `{org}`. By default, organization members can create teams. Organization owners can limit team creation to organization owners. For more information, see "[Setting team creation permissions](https://docs.github.com/articles/setting-team-creation-permissions-in-your-organization)."
   *
   * When you create a new team, you automatically become a team maintainer without explicitly adding yourself to the optional array of `maintainers`. For more information, see "[About teams](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/about-teams)".
   */
  "teams/create": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the team. */
          name: string;
          /** @description The description of the team. */
          description?: string;
          /** @description List GitHub IDs for organization members who will become team maintainers. */
          maintainers?: string[];
          /** @description The full name (e.g., "organization-name/repository-name") of repositories to add the team to. */
          repo_names?: string[];
          /**
           * @description The level of privacy this team should have. The options are:
           * **For a non-nested team:**
           *  * `secret` - only visible to organization owners and members of this team.
           *  * `closed` - visible to all members of this organization.
           * Default: `secret`
           * **For a parent or child team:**
           *  * `closed` - visible to all members of this organization.
           * Default for child team: `closed`
           * @enum {string}
           */
          privacy?: "secret" | "closed";
          /**
           * @description The notification setting the team has chosen. The options are:
           *  * `notifications_enabled` - team members receive notifications when the team is @mentioned.
           *  * `notifications_disabled` - no one receives notifications.
           * Default: `notifications_enabled`
           * @enum {string}
           */
          notification_setting?:
            | "notifications_enabled"
            | "notifications_disabled";
          /**
           * @description **Deprecated**. The permission that new repositories will be added to the team with when none is specified.
           * @default pull
           * @enum {string}
           */
          permission?: "pull" | "push";
          /** @description The ID of a team to set as the parent team. */
          parent_team_id?: number;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a team by name
   * @description Gets a team using the team's `slug`. To create the `slug`, GitHub replaces special characters in the `name` string, changes all words to lowercase, and replaces spaces with a `-` separator. For example, `"My TEam Näme"` would become `my-team-name`.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}`.
   */
  "teams/get-by-name": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a team
   * @description To delete a team, the authenticated user must be an organization owner or team maintainer.
   *
   * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}`.
   */
  "teams/delete-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a team
   * @description To edit a team, the authenticated user must either be an organization owner or a team maintainer.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}`.
   */
  "teams/update-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the team. */
          name?: string;
          /** @description The description of the team. */
          description?: string;
          /**
           * @description The level of privacy this team should have. Editing teams without specifying this parameter leaves `privacy` intact. When a team is nested, the `privacy` for parent teams cannot be `secret`. The options are:
           * **For a non-nested team:**
           *  * `secret` - only visible to organization owners and members of this team.
           *  * `closed` - visible to all members of this organization.
           * **For a parent or child team:**
           *  * `closed` - visible to all members of this organization.
           * @enum {string}
           */
          privacy?: "secret" | "closed";
          /**
           * @description The notification setting the team has chosen. Editing teams without specifying this parameter leaves `notification_setting` intact. The options are:
           *  * `notifications_enabled` - team members receive notifications when the team is @mentioned.
           *  * `notifications_disabled` - no one receives notifications.
           * @enum {string}
           */
          notification_setting?:
            | "notifications_enabled"
            | "notifications_disabled";
          /**
           * @description **Deprecated**. The permission that new repositories will be added to the team with when none is specified.
           * @default pull
           * @enum {string}
           */
          permission?: "pull" | "push" | "admin";
          /** @description The ID of a team to set as the parent team. */
          parent_team_id?: number | null;
        };
      };
    };
    responses: {
      /** @description Response when the updated information already exists */
      200: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List discussions
   * @description List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions`.
   */
  "teams/list-discussions-in-org": {
    parameters: {
      query: {
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        /** @description Pinned discussions only filter */
        pinned?: string;
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-discussion"][];
        };
      };
    };
  };
  /**
   * Create a discussion
   * @description Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions`.
   */
  "teams/create-discussion-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion post's title. */
          title: string;
          /** @description The discussion post's body text. */
          body: string;
          /**
           * @description Private posts are only visible to team members, organization owners, and team maintainers. Public posts are visible to all members of the organization. Set to `true` to create a private post.
           * @default false
           */
          private?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * Get a discussion
   * @description Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
   */
  "teams/get-discussion-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * Delete a discussion
   * @description Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
   */
  "teams/delete-discussion-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a discussion
   * @description Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}`.
   */
  "teams/update-discussion-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The discussion post's title. */
          title?: string;
          /** @description The discussion post's body text. */
          body?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * List discussion comments
   * @description List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
   */
  "teams/list-discussion-comments-in-org": {
    parameters: {
      query: {
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-discussion-comment"][];
        };
      };
    };
  };
  /**
   * Create a discussion comment
   * @description Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments`.
   */
  "teams/create-discussion-comment-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion comment's body text. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * Get a discussion comment
   * @description Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
   */
  "teams/get-discussion-comment-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * Delete a discussion comment
   * @description Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
   */
  "teams/delete-discussion-comment-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a discussion comment
   * @description Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PATCH /organizations/{org_id}/team/{team_id}/discussions/{discussion_number}/comments/{comment_number}`.
   */
  "teams/update-discussion-comment-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion comment's body text. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * List reactions for a team discussion comment
   * @description List the reactions to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments/). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
   */
  "reactions/list-for-team-discussion-comment-in-org": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a team discussion comment. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
    };
  };
  /**
   * Create reaction for a team discussion comment
   * @description Create a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions`.
   */
  "reactions/create-for-team-discussion-comment-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the team discussion comment.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Response when the reaction type has already been added to this team discussion comment */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
    };
  };
  /**
   * Delete team discussion comment reaction
   * @description **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/comments/:comment_number/reactions/:reaction_id`.
   *
   * Delete a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "reactions/delete-for-team-discussion-comment": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List reactions for a team discussion
   * @description List the reactions to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
   */
  "reactions/list-for-team-discussion-in-org": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a team discussion. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
    };
  };
  /**
   * Create reaction for a team discussion
   * @description Create a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `POST /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions`.
   */
  "reactions/create-for-team-discussion-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the team discussion.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
    };
  };
  /**
   * Delete team discussion reaction
   * @description **Note:** You can also specify a team or organization with `team_id` and `org_id` using the route `DELETE /organizations/:org_id/team/:team_id/discussions/:discussion_number/reactions/:reaction_id`.
   *
   * Delete a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "reactions/delete-for-team-discussion": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        discussion_number: components["parameters"]["discussion-number"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List pending team invitations
   * @description The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, `hiring_manager`, or `reinstate`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/invitations`.
   */
  "teams/list-pending-invitations-in-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-invitation"][];
        };
      };
    };
  };
  /**
   * List team members
   * @description Team members will include the members of child teams.
   *
   * To list members in a team, the team must be visible to the authenticated user.
   */
  "teams/list-members-in-org": {
    parameters: {
      query: {
        /** @description Filters members returned by their role in the team. */
        role?: "member" | "maintainer" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /**
   * Get team membership for a user
   * @description Team members will include the members of child teams.
   *
   * To get a user's membership with a team, the team must be visible to the authenticated user.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/memberships/{username}`.
   *
   * **Note:**
   * The response contains the `state` of the membership and the member's `role`.
   *
   * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see see [Create a team](https://docs.github.com/rest/reference/teams#create-a-team).
   */
  "teams/get-membership-for-user-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-membership"];
        };
      };
      /** @description if user has no team membership */
      404: never;
    };
  };
  /**
   * Add or update team membership for a user
   * @description Adds an organization member to a team. An authenticated organization owner or team maintainer can add organization members to a team.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   *
   * An organization owner can add someone who is not part of the team's organization to a team. When an organization owner adds someone to a team who is not an organization member, this endpoint will send an invitation to the person via email. This newly-created membership will be in the "pending" state until the person accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team.
   *
   * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/memberships/{username}`.
   */
  "teams/add-or-update-membership-for-user-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The role that this user should have in the team.
           * @default member
           * @enum {string}
           */
          role?: "member" | "maintainer";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-membership"];
        };
      };
      /** @description Forbidden if team synchronization is set up */
      403: never;
      /** @description Unprocessable Entity if you attempt to add an organization to a team */
      422: never;
    };
  };
  /**
   * Remove team membership for a user
   * @description To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/memberships/{username}`.
   */
  "teams/remove-membership-for-user-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Forbidden if team synchronization is set up */
      403: never;
    };
  };
  /**
   * List team projects
   * @description Lists the organization projects for a team.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects`.
   */
  "teams/list-projects-in-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-project"][];
        };
      };
    };
  };
  /**
   * Check team permissions for a project
   * @description Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
   */
  "teams/check-permissions-for-project-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-project"];
        };
      };
      /** @description Not Found if project is not managed by this team */
      404: never;
    };
  };
  /**
   * Add or update team project permissions
   * @description Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
   */
  "teams/add-or-update-project-permissions-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        project_id: components["parameters"]["project-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant to the team for this project. Default: the team's `permission` attribute will be used to determine what permission to grant the team on this project. Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
           * @enum {string}
           */
          permission?: "read" | "write" | "admin";
        } | null;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Forbidden if the project is not owned by the organization */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
    };
  };
  /**
   * Remove a project from a team
   * @description Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. This endpoint removes the project from the team, but does not delete the project.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/projects/{project_id}`.
   */
  "teams/remove-project-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List team repositories
   * @description Lists a team's repositories visible to the authenticated user.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos`.
   */
  "teams/list-repos-in-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
    };
  };
  /**
   * Check team permissions for a repository
   * @description Checks whether a team has `admin`, `push`, `maintain`, `triage`, or `pull` permission for a repository. Repositories inherited through a parent team will also be checked.
   *
   * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `application/vnd.github.v3.repository+json` accept header.
   *
   * If a team doesn't have permission for the repository, you will receive a `404 Not Found` response status.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
   */
  "teams/check-permissions-for-repo-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Alternative response with repository permissions */
      200: {
        content: {
          "application/json": components["schemas"]["team-repository"];
        };
      };
      /** @description Response if team has permission for the repository. This is the response when the repository media type hasn't been provded in the Accept header. */
      204: never;
      /** @description Not Found if team does not have permission for the repository */
      404: never;
    };
  };
  /**
   * Add or update team repository permissions
   * @description To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization. Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `PUT /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
   *
   * For more information about the permission levels, see "[Repository permission levels for an organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)".
   */
  "teams/add-or-update-repo-permissions-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant the team on this repository. We accept the following permissions to be set: `pull`, `triage`, `push`, `maintain`, `admin` and you can also specify a custom repository role name, if the owning organization has defined any. If no permission is specified, the team's `permission` attribute will be used to determine what permission to grant the team on this repository.
           * @default push
           */
          permission?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Remove a repository from a team
   * @description If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. This does not delete the repository, it just removes it from the team.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `DELETE /organizations/{org_id}/team/{team_id}/repos/{owner}/{repo}`.
   */
  "teams/remove-repo-in-org": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List child teams
   * @description Lists the child teams of the team specified by `{team_slug}`.
   *
   * **Note:** You can also specify a team by `org_id` and `team_id` using the route `GET /organizations/{org_id}/team/{team_id}/teams`.
   */
  "teams/list-child-in-org": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        team_slug: components["parameters"]["team-slug"];
      };
    };
    responses: {
      /** @description if child teams exist */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
    };
  };
  /**
   * Enable or disable a security feature for an organization
   * @description Enables or disables the specified security feature for all eligible repositories in an organization.
   *
   * To use this endpoint, you must be an organization owner or be member of a team with the security manager role.
   * A token with the 'write:org' scope is also required.
   *
   * GitHub Apps must have the `organization_administration:write` permission to use this endpoint.
   *
   * For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   */
  "orgs/enable-or-disable-security-product-on-all-org-repos": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        security_product: components["parameters"]["security-product"];
        enablement: components["parameters"]["org-security-product-enablement"];
      };
    };
    responses: {
      /** @description Action started */
      204: never;
      /** @description The action could not be taken due to an in progress enablement, or a policy is preventing enablement */
      422: never;
    };
  };
  /** Get a project card */
  "projects/get-card": {
    parameters: {
      path: {
        card_id: components["parameters"]["card-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project-card"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a project card */
  "projects/delete-card": {
    parameters: {
      path: {
        card_id: components["parameters"]["card-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      /** @description Forbidden */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
            errors?: string[];
          };
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Update an existing project card */
  "projects/update-card": {
    parameters: {
      path: {
        card_id: components["parameters"]["card-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The project card's note
           * @example Update all gems
           */
          note?: string | null;
          /**
           * @description Whether or not the card is archived
           * @example false
           */
          archived?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project-card"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /** Move a project card */
  "projects/move-card": {
    parameters: {
      path: {
        card_id: components["parameters"]["card-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The position of the card in a column. Can be one of: `top`, `bottom`, or `after:<card_id>` to place after the specified card.
           * @example bottom
           */
          position: string;
          /**
           * @description The unique identifier of the column the card should be moved to
           * @example 42
           */
          column_id?: number;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": Record<string, never>;
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      /** @description Forbidden */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
            errors?: {
              code?: string;
              message?: string;
              resource?: string;
              field?: string;
            }[];
          };
        };
      };
      422: components["responses"]["validation_failed"];
      /** @description Response */
      503: {
        content: {
          "application/json": {
            code?: string;
            message?: string;
            documentation_url?: string;
            errors?: {
              code?: string;
              message?: string;
            }[];
          };
        };
      };
    };
  };
  /** Get a project column */
  "projects/get-column": {
    parameters: {
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project-column"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a project column */
  "projects/delete-column": {
    parameters: {
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Update an existing project column */
  "projects/update-column": {
    parameters: {
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Name of the project column
           * @example Remaining tasks
           */
          name: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project-column"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** List project cards */
  "projects/list-cards": {
    parameters: {
      query: {
        /** @description Filters the project cards that are returned by the card's state. */
        archived_state?: "all" | "archived" | "not_archived";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["project-card"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Create a project card */
  "projects/create-card": {
    parameters: {
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": OneOf<
          [
            {
              /**
               * @description The project card's note
               * @example Update all gems
               */
              note: string | null;
            },
            {
              /**
               * @description The unique identifier of the content associated with the card
               * @example 42
               */
              content_id: number;
              /**
               * @description The piece of content associated with the card
               * @example PullRequest
               */
              content_type: string;
            }
          ]
        >;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["project-card"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      /** @description Validation failed */
      422: {
        content: {
          "application/json":
            | components["schemas"]["validation-error"]
            | components["schemas"]["validation-error-simple"];
        };
      };
      /** @description Response */
      503: {
        content: {
          "application/json": {
            code?: string;
            message?: string;
            documentation_url?: string;
            errors?: {
              code?: string;
              message?: string;
            }[];
          };
        };
      };
    };
  };
  /** Move a project column */
  "projects/move-column": {
    parameters: {
      path: {
        column_id: components["parameters"]["column-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The position of the column in a project. Can be one of: `first`, `last`, or `after:<column_id>` to place after the specified column.
           * @example last
           */
          position: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": Record<string, never>;
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get a project
   * @description Gets a project by its `id`. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/get": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Delete a project
   * @description Deletes a project board. Returns a `404 Not Found` status if projects are disabled.
   */
  "projects/delete": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Delete Success */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      /** @description Forbidden */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
            errors?: string[];
          };
        };
      };
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Update a project
   * @description Updates a project board's information. Returns a `404 Not Found` status if projects are disabled. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/update": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Name of the project
           * @example Week One Sprint
           */
          name?: string;
          /**
           * @description Body of the project
           * @example This project represents the sprint of the first week in January
           */
          body?: string | null;
          /**
           * @description State of the project; either 'open' or 'closed'
           * @example open
           */
          state?: string;
          /**
           * @description The baseline permission that all organization members have on this project
           * @enum {string}
           */
          organization_permission?: "read" | "write" | "admin" | "none";
          /** @description Whether or not this project can be seen by everyone. */
          private?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      /** @description Forbidden */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
            errors?: string[];
          };
        };
      };
      /** @description Not Found if the authenticated user does not have access to the project */
      404: never;
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List project collaborators
   * @description Lists the collaborators for an organization project. For a project, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners. You must be an organization owner or a project `admin` to list collaborators.
   */
  "projects/list-collaborators": {
    parameters: {
      query: {
        /** @description Filters the collaborators by their affiliation. `outside` means outside collaborators of a project that are not a member of the project's organization. `direct` means collaborators with permissions to a project, regardless of organization membership status. `all` means all collaborators the authenticated user can see. */
        affiliation?: "outside" | "direct" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Add project collaborator
   * @description Adds a collaborator to an organization project and sets their permission level. You must be an organization owner or a project `admin` to add a collaborator.
   */
  "projects/add-collaborator": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant the collaborator.
           * @default write
           * @example write
           * @enum {string}
           */
          permission?: "read" | "write" | "admin";
        } | null;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove user as a collaborator
   * @description Removes a collaborator from an organization project. You must be an organization owner or a project `admin` to remove a collaborator.
   */
  "projects/remove-collaborator": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get project permission for a user
   * @description Returns the collaborator's permission level for an organization project. Possible values for the `permission` key: `admin`, `write`, `read`, `none`. You must be an organization owner or a project `admin` to review a user's permission level.
   */
  "projects/get-permission-for-user": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["project-collaborator-permission"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** List project columns */
  "projects/list-columns": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["project-column"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Create a project column */
  "projects/create-column": {
    parameters: {
      path: {
        project_id: components["parameters"]["project-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Name of the project column
           * @example Remaining tasks
           */
          name: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["project-column"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get rate limit status for the authenticated user
   * @description **Note:** Accessing this endpoint does not count against your REST API rate limit.
   *
   * **Note:** The `rate` object is deprecated. If you're writing new API client code or updating existing code, you should use the `core` object instead of the `rate` object. The `core` object contains the same information that is present in the `rate` object.
   */
  "rate-limit/get": {
    responses: {
      /** @description Response */
      200: {
        headers: {
          "X-RateLimit-Limit": components["headers"]["x-rate-limit-limit"];
          "X-RateLimit-Remaining": components["headers"]["x-rate-limit-remaining"];
          "X-RateLimit-Reset": components["headers"]["x-rate-limit-reset"];
        };
        content: {
          "application/json": components["schemas"]["rate-limit-overview"];
        };
      };
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repository required workflows
   * @description Lists the required workflows in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/list-repo-required-workflows": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        org: components["parameters"]["org"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            required_workflows: components["schemas"]["repo-required-workflow"][];
          };
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a required workflow entity for a repository
   * @description Gets a specific required workflow present in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/get-repo-required-workflow": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        repo: components["parameters"]["repo"];
        required_workflow_id_for_repo: components["parameters"]["repo-required-workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repo-required-workflow"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get required workflow usage
   * @description Gets the number of billable minutes used by a specific required workflow during the current billing cycle.
   *
   * Billable minutes only apply to required workflows running in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)."
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-repo-required-workflow-usage": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
        repo: components["parameters"]["repo"];
        required_workflow_id_for_repo: components["parameters"]["repo-required-workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow-usage"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a repository
   * @description The `parent` and `source` objects are present when the repository is a fork. `parent` is the repository this repository was forked from, `source` is the ultimate source for the network.
   *
   * **Note:** In order to see the `security_and_analysis` block for a repository you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
   */
  "repos/get": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["full-repository"];
        };
      };
      301: components["responses"]["moved_permanently"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a repository
   * @description Deleting a repository requires admin access. If OAuth is used, the `delete_repo` scope is required.
   *
   * If an organization owner has configured the organization to prevent members from deleting organization-owned
   * repositories, you will get a `403 Forbidden` response.
   */
  "repos/delete": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      307: components["responses"]["temporary_redirect"];
      /** @description If an organization owner has configured the organization to prevent members from deleting organization-owned repositories, a member will get this response: */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a repository
   * @description **Note**: To edit a repository's topics, use the [Replace all repository topics](https://docs.github.com/rest/reference/repos#replace-all-repository-topics) endpoint.
   */
  "repos/update": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the repository. */
          name?: string;
          /** @description A short description of the repository. */
          description?: string;
          /** @description A URL with more information about the repository. */
          homepage?: string;
          /**
           * @description Either `true` to make the repository private or `false` to make it public. Default: `false`.
           * **Note**: You will get a `422` error if the organization restricts [changing repository visibility](https://docs.github.com/articles/repository-permission-levels-for-an-organization#changing-the-visibility-of-repositories) to organization owners and a non-owner tries to change the value of private.
           * @default false
           */
          private?: boolean;
          /**
           * @description The visibility of the repository.
           * @enum {string}
           */
          visibility?: "public" | "private";
          /**
           * @description Specify which security and analysis features to enable or disable for the repository.
           *
           * To use this parameter, you must have admin permissions for the repository or be an owner or security manager for the organization that owns the repository. For more information, see "[Managing security managers in your organization](https://docs.github.com/organizations/managing-peoples-access-to-your-organization-with-roles/managing-security-managers-in-your-organization)."
           *
           * For example, to enable GitHub Advanced Security, use this data in the body of the `PATCH` request:
           * `{ "security_and_analysis": {"advanced_security": { "status": "enabled" } } }`.
           *
           * You can check which security and analysis features are currently enabled by using a `GET /repos/{owner}/{repo}` request.
           */
          security_and_analysis?: {
            /** @description Use the `status` property to enable or disable GitHub Advanced Security for this repository. For more information, see "[About GitHub Advanced Security](/github/getting-started-with-github/learning-about-github/about-github-advanced-security)." */
            advanced_security?: {
              /** @description Can be `enabled` or `disabled`. */
              status?: string;
            };
            /** @description Use the `status` property to enable or disable secret scanning for this repository. For more information, see "[About secret scanning](/code-security/secret-security/about-secret-scanning)." */
            secret_scanning?: {
              /** @description Can be `enabled` or `disabled`. */
              status?: string;
            };
            /** @description Use the `status` property to enable or disable secret scanning push protection for this repository. For more information, see "[Protecting pushes with secret scanning](/code-security/secret-scanning/protecting-pushes-with-secret-scanning)." */
            secret_scanning_push_protection?: {
              /** @description Can be `enabled` or `disabled`. */
              status?: string;
            };
          } | null;
          /**
           * @description Either `true` to enable issues for this repository or `false` to disable them.
           * @default true
           */
          has_issues?: boolean;
          /**
           * @description Either `true` to enable projects for this repository or `false` to disable them. **Note:** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
           * @default true
           */
          has_projects?: boolean;
          /**
           * @description Either `true` to enable the wiki for this repository or `false` to disable it.
           * @default true
           */
          has_wiki?: boolean;
          /**
           * @description Either `true` to make this repo available as a template repository or `false` to prevent it.
           * @default false
           */
          is_template?: boolean;
          /** @description Updates the default branch for this repository. */
          default_branch?: string;
          /**
           * @description Either `true` to allow squash-merging pull requests, or `false` to prevent squash-merging.
           * @default true
           */
          allow_squash_merge?: boolean;
          /**
           * @description Either `true` to allow merging pull requests with a merge commit, or `false` to prevent merging pull requests with merge commits.
           * @default true
           */
          allow_merge_commit?: boolean;
          /**
           * @description Either `true` to allow rebase-merging pull requests, or `false` to prevent rebase-merging.
           * @default true
           */
          allow_rebase_merge?: boolean;
          /**
           * @description Either `true` to allow auto-merge on pull requests, or `false` to disallow auto-merge.
           * @default false
           */
          allow_auto_merge?: boolean;
          /**
           * @description Either `true` to allow automatically deleting head branches when pull requests are merged, or `false` to prevent automatic deletion.
           * @default false
           */
          delete_branch_on_merge?: boolean;
          /**
           * @description Either `true` to always allow a pull request head branch that is behind its base branch to be updated even if it is not required to be up to date before merging, or false otherwise.
           * @default false
           */
          allow_update_branch?: boolean;
          /**
           * @deprecated
           * @description Either `true` to allow squash-merge commits to use pull request title, or `false` to use commit message. **This property has been deprecated. Please use `squash_merge_commit_title` instead.
           * @default false
           */
          use_squash_pr_title_as_default?: boolean;
          /**
           * @description The default value for a squash merge commit title:
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
           * @enum {string}
           */
          squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
          /**
           * @description The default value for a squash merge commit message:
           *
           * - `PR_BODY` - default to the pull request's body.
           * - `COMMIT_MESSAGES` - default to the branch's commit messages.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
          /**
           * @description The default value for a merge commit title.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
           * @enum {string}
           */
          merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
          /**
           * @description The default value for a merge commit message.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `PR_BODY` - default to the pull request's body.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
          /**
           * @description Whether to archive this repository. `false` will unarchive a previously archived repository.
           * @default false
           */
          archived?: boolean;
          /**
           * @description Either `true` to allow private forks, or `false` to prevent private forks.
           * @default false
           */
          allow_forking?: boolean;
          /**
           * @description Either `true` to require contributors to sign off on web-based commits, or `false` to not require contributors to sign off on web-based commits.
           * @default false
           */
          web_commit_signoff_required?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["full-repository"];
        };
      };
      307: components["responses"]["temporary_redirect"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List artifacts for a repository
   * @description Lists all artifacts for a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/list-artifacts-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        /** @description Filters artifacts by exact match on their name field. */
        name?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            artifacts: components["schemas"]["artifact"][];
          };
        };
      };
    };
  };
  /**
   * Get an artifact
   * @description Gets a specific artifact for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-artifact": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        artifact_id: components["parameters"]["artifact-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["artifact"];
        };
      };
    };
  };
  /**
   * Delete an artifact
   * @description Deletes an artifact for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/delete-artifact": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        artifact_id: components["parameters"]["artifact-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Download an artifact
   * @description Gets a redirect URL to download an archive for a repository. This URL expires after 1 minute. Look for `Location:` in
   * the response header to find the URL for the download. The `:archive_format` must be `zip`. Anyone with read access to
   * the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
   * GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/download-artifact": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        artifact_id: components["parameters"]["artifact-id"];
        archive_format: string;
      };
    };
    responses: {
      /** @description Response */
      302: never;
      410: components["responses"]["gone"];
    };
  };
  /**
   * Get GitHub Actions cache usage for a repository
   * @description Gets GitHub Actions cache usage for a repository.
   * The data fetched using this API is refreshed approximately every 5 minutes, so values returned from this endpoint may take at least 5 minutes to get updated.
   * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-actions-cache-usage": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-cache-usage-by-repository"];
        };
      };
    };
  };
  /**
   * List GitHub Actions caches for a repository
   * @description Lists the GitHub Actions caches for a repository.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-actions-cache-list": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        ref?: components["parameters"]["actions-cache-git-ref-full"];
        key?: components["parameters"]["actions-cache-key"];
        sort?: components["parameters"]["actions-cache-list-sort"];
        direction?: components["parameters"]["direction"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["actions-cache-list"];
        };
      };
    };
  };
  /**
   * Delete GitHub Actions caches for a repository (using a cache key)
   * @description Deletes one or more GitHub Actions caches for a repository, using a complete cache key. By default, all caches that match the provided key are deleted, but you can optionally provide a Git ref to restrict deletions to caches that match both the provided key and the Git ref.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   *
   * GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/delete-actions-cache-by-key": {
    parameters: {
      query: {
        key: components["parameters"]["actions-cache-key-required"];
        ref?: components["parameters"]["actions-cache-git-ref-full"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-cache-list"];
        };
      };
    };
  };
  /**
   * Delete a GitHub Actions cache for a repository (using a cache ID)
   * @description Deletes a GitHub Actions cache for a repository, using a cache ID.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   *
   * GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/delete-actions-cache-by-id": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        cache_id: components["parameters"]["cache-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get a job for a workflow run
   * @description Gets a specific job in a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-job-for-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        job_id: components["parameters"]["job-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["job"];
        };
      };
    };
  };
  /**
   * Download job logs for a workflow run
   * @description Gets a redirect URL to download a plain text file of logs for a workflow job. This link expires after 1 minute. Look
   * for `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can
   * use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must
   * have the `actions:read` permission to use this endpoint.
   */
  "actions/download-job-logs-for-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        job_id: components["parameters"]["job-id"];
      };
    };
    responses: {
      /** @description Response */
      302: never;
    };
  };
  /**
   * Re-run a job from a workflow run
   * @description Re-run a job and its dependent jobs in a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/re-run-job-for-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        job_id: components["parameters"]["job-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Whether to enable debug logging for the re-run.
           * @default false
           */
          enable_debug_logging?: boolean;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get the customization template for an OIDC subject claim for a repository
   * @description Gets the customization template for an OpenID Connect (OIDC) subject claim.
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint. GitHub Apps must have the `organization_administration:read` permission to use this endpoint.
   */
  "actions/get-custom-oidc-sub-claim-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Status response */
      200: {
        content: {
          "application/json": components["schemas"]["oidc-custom-sub-repo"];
        };
      };
      400: components["responses"]["bad_request"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set the customization template for an OIDC subject claim for a repository
   * @description Sets the customization template and `opt-in` or `opt-out` flag for an OpenID Connect (OIDC) subject claim for a repository.
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/set-custom-oidc-sub-claim-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Whether to use the default template or not. If `true`, the `include_claim_keys` field is ignored. */
          use_default: boolean;
          /** @description Array of unique strings. Each claim key can only contain alphanumeric characters and underscores. */
          include_claim_keys?: string[];
        };
      };
    };
    responses: {
      /** @description Empty response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      400: components["responses"]["bad_request"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List repository organization secrets
   * @description Lists all organization secrets shared with a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/list-repo-organization-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["actions-secret"][];
          };
        };
      };
    };
  };
  /**
   * List repository organization variables
   * @description Lists all organiation variables shared with a repository. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
   */
  "actions/list-repo-organization-variables": {
    parameters: {
      query: {
        per_page?: components["parameters"]["variables-per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            variables: components["schemas"]["actions-variable"][];
          };
        };
      };
    };
  };
  /**
   * Get GitHub Actions permissions for a repository
   * @description Gets the GitHub Actions permissions policy for a repository, including whether GitHub Actions is enabled and the actions and reusable workflows allowed to run in the repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
   */
  "actions/get-github-actions-permissions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-repository-permissions"];
        };
      };
    };
  };
  /**
   * Set GitHub Actions permissions for a repository
   * @description Sets the GitHub Actions permissions policy for enabling GitHub Actions and allowed actions and reusable workflows in the repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
   */
  "actions/set-github-actions-permissions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          enabled: components["schemas"]["actions-enabled"];
          allowed_actions?: components["schemas"]["allowed-actions"];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get the level of access for workflows outside of the repository
   * @description Gets the level of access that workflows outside of the repository have to actions and reusable workflows in the repository.
   * This endpoint only applies to private repositories.
   * For more information, see "[Allowing access to components in a private repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#allowing-access-to-components-in-a-private-repository)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the
   * repository `administration` permission to use this endpoint.
   */
  "actions/get-workflow-access-to-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-workflow-access-to-repository"];
        };
      };
    };
  };
  /**
   * Set the level of access for workflows outside of the repository
   * @description Sets the level of access that workflows outside of the repository have to actions and reusable workflows in the repository.
   * This endpoint only applies to private repositories.
   * For more information, see "[Allowing access to components in a private repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#allowing-access-to-components-in-a-private-repository)".
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the
   * repository `administration` permission to use this endpoint.
   */
  "actions/set-workflow-access-to-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["actions-workflow-access-to-repository"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get allowed actions and reusable workflows for a repository
   * @description Gets the settings for selected actions and reusable workflows that are allowed in a repository. To use this endpoint, the repository policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
   */
  "actions/get-allowed-actions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["selected-actions"];
        };
      };
    };
  };
  /**
   * Set allowed actions and reusable workflows for a repository
   * @description Sets the actions and reusable workflows that are allowed in a repository. To use this endpoint, the repository permission policy for `allowed_actions` must be configured to `selected`. For more information, see "[Set GitHub Actions permissions for a repository](#set-github-actions-permissions-for-a-repository)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration` repository permission to use this API.
   */
  "actions/set-allowed-actions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": components["schemas"]["selected-actions"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get default workflow permissions for a repository
   * @description Gets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in a repository,
   * as well as if GitHub Actions can submit approving pull request reviews.
   * For more information, see "[Setting the permissions of the GITHUB_TOKEN for your repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#setting-the-permissions-of-the-github_token-for-your-repository)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the repository `administration` permission to use this API.
   */
  "actions/get-github-actions-default-workflow-permissions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-get-default-workflow-permissions"];
        };
      };
    };
  };
  /**
   * Set default workflow permissions for a repository
   * @description Sets the default workflow permissions granted to the `GITHUB_TOKEN` when running workflows in a repository, and sets if GitHub Actions
   * can submit approving pull request reviews.
   * For more information, see "[Setting the permissions of the GITHUB_TOKEN for your repository](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/enabling-features-for-your-repository/managing-github-actions-settings-for-a-repository#setting-the-permissions-of-the-github_token-for-your-repository)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the repository `administration` permission to use this API.
   */
  "actions/set-github-actions-default-workflow-permissions-repository": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["actions-set-default-workflow-permissions"];
      };
    };
    responses: {
      /** @description Success response */
      204: never;
      /** @description Conflict response when changing a setting is prevented by the owning organization */
      409: never;
    };
  };
  /**
   * List workflow runs for a required workflow
   * @description List all workflow runs for a required workflow. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. For more information, see "[Required Workflows](https://docs.github.com/actions/using-workflows/required-workflows)."
   */
  "actions/list-required-workflow-runs": {
    parameters: {
      query: {
        actor?: components["parameters"]["actor"];
        branch?: components["parameters"]["workflow-run-branch"];
        event?: components["parameters"]["event"];
        status?: components["parameters"]["workflow-run-status"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        created?: components["parameters"]["created"];
        exclude_pull_requests?: components["parameters"]["exclude-pull-requests"];
        check_suite_id?: components["parameters"]["workflow-run-check-suite-id"];
        head_sha?: components["parameters"]["workflow-run-head-sha"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        required_workflow_id_for_repo: components["parameters"]["repo-required-workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            workflow_runs: components["schemas"]["workflow-run"][];
          };
        };
      };
    };
  };
  /**
   * List self-hosted runners for a repository
   * @description Lists all self-hosted runners configured in a repository. You must authenticate using an access token with the `repo` scope to use this endpoint.
   */
  "actions/list-self-hosted-runners-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            runners: components["schemas"]["runner"][];
          };
        };
      };
    };
  };
  /**
   * List runner applications for a repository
   * @description Lists binaries for the runner application that you can download and run.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   */
  "actions/list-runner-applications-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["runner-application"][];
        };
      };
    };
  };
  /**
   * Create a registration token for a repository
   * @description Returns a token that you can pass to the `config` script. The token expires after one hour. You must authenticate
   * using an access token with the `repo` scope to use this endpoint.
   *
   * #### Example using registration token
   *
   * Configure your self-hosted runner, replacing `TOKEN` with the registration token provided by this endpoint.
   *
   * ```
   * ./config.sh --url https://github.com/octo-org/octo-repo-artifacts --token TOKEN
   * ```
   */
  "actions/create-registration-token-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["authentication-token"];
        };
      };
    };
  };
  /**
   * Create a remove token for a repository
   * @description Returns a token that you can pass to remove a self-hosted runner from a repository. The token expires after one hour.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   *
   * #### Example using remove token
   *
   * To remove your self-hosted runner from a repository, replace TOKEN with the remove token provided by this endpoint.
   *
   * ```
   * ./config.sh remove --token TOKEN
   * ```
   */
  "actions/create-remove-token-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["authentication-token"];
        };
      };
    };
  };
  /**
   * Get a self-hosted runner for a repository
   * @description Gets a specific self-hosted runner configured in a repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/get-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["runner"];
        };
      };
    };
  };
  /**
   * Delete a self-hosted runner from a repository
   * @description Forces the removal of a self-hosted runner from a repository. You can use this endpoint to completely remove the runner when the machine you were using no longer exists.
   *
   * You must authenticate using an access token with the `repo`
   * scope to use this endpoint.
   */
  "actions/delete-self-hosted-runner-from-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List labels for a self-hosted runner for a repository
   * @description Lists all labels for a self-hosted runner configured in a repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/list-labels-for-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set custom labels for a self-hosted runner for a repository
   * @description Remove all previous custom labels and set the new custom labels for a specific
   * self-hosted runner configured in a repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/set-custom-labels-for-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The names of the custom labels to set for the runner. You can pass an empty array to remove all custom labels. */
          labels: string[];
        };
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Add custom labels to a self-hosted runner for a repository
   * @description Add custom labels to a self-hosted runner configured in a repository.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/add-custom-labels-to-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The names of the custom labels to add to the runner. */
          labels: string[];
        };
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Remove all custom labels from a self-hosted runner for a repository
   * @description Remove all custom labels from a self-hosted runner configured in a
   * repository. Returns the remaining read-only labels from the runner.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/remove-all-custom-labels-from-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels_readonly"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Remove a custom label from a self-hosted runner for a repository
   * @description Remove a custom label from a self-hosted runner configured
   * in a repository. Returns the remaining labels from the runner.
   *
   * This endpoint returns a `404 Not Found` status if the custom label is not
   * present on the runner.
   *
   * You must authenticate using an access token with the `repo` scope to use this
   * endpoint.
   */
  "actions/remove-custom-label-from-self-hosted-runner-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        runner_id: components["parameters"]["runner-id"];
        name: components["parameters"]["runner-label-name"];
      };
    };
    responses: {
      200: components["responses"]["actions_runner_labels"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List workflow runs for a repository
   * @description Lists all workflow runs for a repository. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/list-workflow-runs-for-repo": {
    parameters: {
      query: {
        actor?: components["parameters"]["actor"];
        branch?: components["parameters"]["workflow-run-branch"];
        event?: components["parameters"]["event"];
        status?: components["parameters"]["workflow-run-status"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        created?: components["parameters"]["created"];
        exclude_pull_requests?: components["parameters"]["exclude-pull-requests"];
        check_suite_id?: components["parameters"]["workflow-run-check-suite-id"];
        head_sha?: components["parameters"]["workflow-run-head-sha"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            workflow_runs: components["schemas"]["workflow-run"][];
          };
        };
      };
    };
  };
  /**
   * Get a workflow run
   * @description Gets a specific workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-workflow-run": {
    parameters: {
      query: {
        exclude_pull_requests?: components["parameters"]["exclude-pull-requests"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow-run"];
        };
      };
    };
  };
  /**
   * Delete a workflow run
   * @description Delete a specific workflow run. Anyone with write access to the repository can use this endpoint. If the repository is
   * private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:write` permission to use
   * this endpoint.
   */
  "actions/delete-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get the review history for a workflow run
   * @description Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-reviews-for-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["environment-approvals"][];
        };
      };
    };
  };
  /**
   * Approve a workflow run for a fork pull request
   * @description Approves a workflow run for a pull request from a public fork of a first time contributor. For more information, see ["Approving workflow runs from public forks](https://docs.github.com/actions/managing-workflow-runs/approving-workflow-runs-from-public-forks)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/approve-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List workflow run artifacts
   * @description Lists artifacts for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/list-workflow-run-artifacts": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            artifacts: components["schemas"]["artifact"][];
          };
        };
      };
    };
  };
  /**
   * Get a workflow run attempt
   * @description Gets a specific workflow run attempt. Anyone with read access to the repository
   * can use this endpoint. If the repository is private you must use an access token
   * with the `repo` scope. GitHub Apps must have the `actions:read` permission to
   * use this endpoint.
   */
  "actions/get-workflow-run-attempt": {
    parameters: {
      query: {
        exclude_pull_requests?: components["parameters"]["exclude-pull-requests"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
        attempt_number: components["parameters"]["attempt-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow-run"];
        };
      };
    };
  };
  /**
   * List jobs for a workflow run attempt
   * @description Lists jobs for a specific workflow run attempt. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
   */
  "actions/list-jobs-for-workflow-run-attempt": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
        attempt_number: components["parameters"]["attempt-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            jobs: components["schemas"]["job"][];
          };
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Download workflow run attempt logs
   * @description Gets a redirect URL to download an archive of log files for a specific workflow run attempt. This link expires after
   * 1 minute. Look for `Location:` in the response header to find the URL for the download. Anyone with read access to
   * the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
   * GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/download-workflow-run-attempt-logs": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
        attempt_number: components["parameters"]["attempt-number"];
      };
    };
    responses: {
      /** @description Response */
      302: never;
    };
  };
  /**
   * Cancel a workflow run
   * @description Cancels a workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/cancel-workflow-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      409: components["responses"]["conflict"];
    };
  };
  /**
   * Review custom deployment protection rules for a workflow run
   * @description Approve or reject custom deployment protection rules provided by a GitHub App for a workflow run. For more information, see "[Using environments for deployment](https://docs.github.com/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
   *
   * **Note:** GitHub Apps can only review their own custom deployment protection rules.
   * To approve or reject pending deployments that are waiting for review from a specific person or team, see [`POST /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments`](/rest/actions/workflow-runs#review-pending-deployments-for-a-workflow-run).
   *
   * GitHub Apps must have read and write permission for **Deployments** to use this endpoint.
   */
  "actions/review-custom-gates-for-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    requestBody: {
      content: {
        "application/json":
          | components["schemas"]["review-custom-gates-comment-required"]
          | components["schemas"]["review-custom-gates-state-required"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List jobs for a workflow run
   * @description Lists jobs for a workflow run. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
   */
  "actions/list-jobs-for-workflow-run": {
    parameters: {
      query: {
        /** @description Filters jobs by their `completed_at` timestamp. `latest` returns jobs from the most recent execution of the workflow run. `all` returns all jobs for a workflow run, including from old executions of the workflow run. */
        filter?: "latest" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            jobs: components["schemas"]["job"][];
          };
        };
      };
    };
  };
  /**
   * Download workflow run logs
   * @description Gets a redirect URL to download an archive of log files for a workflow run. This link expires after 1 minute. Look for
   * `Location:` in the response header to find the URL for the download. Anyone with read access to the repository can use
   * this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have
   * the `actions:read` permission to use this endpoint.
   */
  "actions/download-workflow-run-logs": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      302: never;
    };
  };
  /**
   * Delete workflow run logs
   * @description Deletes all logs for a workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/delete-workflow-run-logs": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get pending deployments for a workflow run
   * @description Get all deployment environments for a workflow run that are waiting for protection rules to pass.
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-pending-deployments-for-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pending-deployment"][];
        };
      };
    };
  };
  /**
   * Review pending deployments for a workflow run
   * @description Approve or reject pending deployments that are waiting on approval by a required reviewer.
   *
   * Required reviewers with read access to the repository contents and deployments can use this endpoint. Required reviewers must authenticate using an access token with the `repo` scope to use this endpoint.
   */
  "actions/review-pending-deployments-for-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The list of environment ids to approve or reject
           * @example [
           *   161171787,
           *   161171795
           * ]
           */
          environment_ids: number[];
          /**
           * @description Whether to approve or reject deployment to the specified environments.
           * @example approved
           * @enum {string}
           */
          state: "approved" | "rejected";
          /**
           * @description A comment to accompany the deployment review
           * @example Ship it!
           */
          comment: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment"][];
        };
      };
    };
  };
  /**
   * Re-run a workflow
   * @description Re-runs your workflow run using its `id`. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/re-run-workflow": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Whether to enable debug logging for the re-run.
           * @default false
           */
          enable_debug_logging?: boolean;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * Re-run failed jobs from a workflow run
   * @description Re-run all of the failed jobs and their dependent jobs in a workflow run using the `id` of the workflow run. You must authenticate using an access token with the `repo` scope to use this endpoint.
   */
  "actions/re-run-workflow-failed-jobs": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Whether to enable debug logging for the re-run.
           * @default false
           */
          enable_debug_logging?: boolean;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * Get workflow run usage
   * @description Gets the number of billable minutes and total run time for a specific workflow run. Billable minutes only apply to workflows in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-workflow-run-usage": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        run_id: components["parameters"]["run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow-run-usage"];
        };
      };
    };
  };
  /**
   * List repository secrets
   * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/list-repo-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["actions-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get a repository public key
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/get-repo-public-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-public-key"];
        };
      };
    };
  };
  /**
   * Get a repository secret
   * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/get-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-secret"];
        };
      };
    };
  };
  /**
   * Create or update a repository secret
   * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
   * this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "actions/create-or-update-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get a repository public key](https://docs.github.com/rest/reference/actions#get-a-repository-public-key) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id?: string;
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete a repository secret
   * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/delete-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List repository variables
   * @description Lists all repository variables. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
   */
  "actions/list-repo-variables": {
    parameters: {
      query: {
        per_page?: components["parameters"]["variables-per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            variables: components["schemas"]["actions-variable"][];
          };
        };
      };
    };
  };
  /**
   * Create a repository variable
   * @description Creates a repository variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
   */
  "actions/create-repo-variable": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name: string;
          /** @description The value of the variable. */
          value: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * Get a repository variable
   * @description Gets a specific variable in a repository. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions_variables:read` repository permission to use this endpoint.
   */
  "actions/get-repo-variable": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-variable"];
        };
      };
    };
  };
  /**
   * Delete a repository variable
   * @description Deletes a repository variable using the variable name.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
   */
  "actions/delete-repo-variable": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a repository variable
   * @description Updates a repository variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `actions_variables:write` repository permission to use this endpoint.
   */
  "actions/update-repo-variable": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: components["parameters"]["variable-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name?: string;
          /** @description The value of the variable. */
          value?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List repository workflows
   * @description Lists the workflows in a repository. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/list-repo-workflows": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            workflows: components["schemas"]["workflow"][];
          };
        };
      };
    };
  };
  /**
   * Get a workflow
   * @description Gets a specific workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-workflow": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow"];
        };
      };
    };
  };
  /**
   * Disable a workflow
   * @description Disables a workflow and sets the `state` of the workflow to `disabled_manually`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/disable-workflow": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Create a workflow dispatch event
   * @description You can use this endpoint to manually trigger a GitHub Actions workflow run. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
   *
   * You must configure your GitHub Actions workflow to run when the [`workflow_dispatch` webhook](/developers/webhooks-and-events/webhook-events-and-payloads#workflow_dispatch) event occurs. The `inputs` are configured in the workflow file. For more information about how to configure the `workflow_dispatch` event in the workflow file, see "[Events that trigger workflows](/actions/reference/events-that-trigger-workflows#workflow_dispatch)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)."
   */
  "actions/create-workflow-dispatch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The git reference for the workflow. The reference can be a branch or tag name. */
          ref: string;
          /** @description Input keys and values configured in the workflow file. The maximum number of properties is 10. Any default properties configured in the workflow file will be used when `inputs` are omitted. */
          inputs?: {
            [key: string]: unknown;
          };
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Enable a workflow
   * @description Enables a workflow and sets the `state` of the workflow to `active`. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `actions:write` permission to use this endpoint.
   */
  "actions/enable-workflow": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List workflow runs for a workflow
   * @description List all workflow runs for a workflow. You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. You can use parameters to narrow the list of results. For more information about using parameters, see [Parameters](https://docs.github.com/rest/overview/resources-in-the-rest-api#parameters).
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope.
   */
  "actions/list-workflow-runs": {
    parameters: {
      query: {
        actor?: components["parameters"]["actor"];
        branch?: components["parameters"]["workflow-run-branch"];
        event?: components["parameters"]["event"];
        status?: components["parameters"]["workflow-run-status"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        created?: components["parameters"]["created"];
        exclude_pull_requests?: components["parameters"]["exclude-pull-requests"];
        check_suite_id?: components["parameters"]["workflow-run-check-suite-id"];
        head_sha?: components["parameters"]["workflow-run-head-sha"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            workflow_runs: components["schemas"]["workflow-run"][];
          };
        };
      };
    };
  };
  /**
   * Get workflow usage
   * @description Gets the number of billable minutes used by a specific workflow during the current billing cycle. Billable minutes only apply to workflows in private repositories that use GitHub-hosted runners. Usage is listed for each GitHub-hosted runner operating system in milliseconds. Any job re-runs are also included in the usage. The usage does not include the multiplier for macOS and Windows runners and is not rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
   *
   * You can replace `workflow_id` with the workflow file name. For example, you could use `main.yaml`. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "actions/get-workflow-usage": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        workflow_id: components["parameters"]["workflow-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["workflow-usage"];
        };
      };
    };
  };
  /**
   * List assignees
   * @description Lists the [available assignees](https://docs.github.com/articles/assigning-issues-and-pull-requests-to-other-github-users/) for issues in a repository.
   */
  "issues/list-assignees": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Check if a user can be assigned
   * @description Checks if a user has permission to be assigned to an issue in this repository.
   *
   * If the `assignee` can be assigned to issues in the repository, a `204` header with no content is returned.
   *
   * Otherwise a `404` status code is returned.
   */
  "issues/check-user-can-be-assigned": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        assignee: string;
      };
    };
    responses: {
      /** @description If the `assignee` can be assigned to issues in the repository, a `204` header with no content is returned. */
      204: never;
      /** @description Otherwise a `404` status code is returned. */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * List all autolinks of a repository
   * @description This returns a list of autolinks configured for the given repository.
   *
   * Information about autolinks are only available to repository administrators.
   */
  "repos/list-autolinks": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["autolink"][];
        };
      };
    };
  };
  /**
   * Create an autolink reference for a repository
   * @description Users with admin access to the repository can create an autolink.
   */
  "repos/create-autolink": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description This prefix appended by certain characters will generate a link any time it is found in an issue, pull request, or commit. */
          key_prefix: string;
          /** @description The URL must contain `<num>` for the reference number. `<num>` matches different characters depending on the value of `is_alphanumeric`. */
          url_template: string;
          /**
           * @description Whether this autolink reference matches alphanumeric characters. If true, the `<num>` parameter of the `url_template` matches alphanumeric characters `A-Z` (case insensitive), `0-9`, and `-`. If false, this autolink reference only matches numeric characters.
           * @default true
           */
          is_alphanumeric?: boolean;
        };
      };
    };
    responses: {
      /** @description response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/autolinks/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["autolink"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an autolink reference of a repository
   * @description This returns a single autolink reference by ID that was configured for the given repository.
   *
   * Information about autolinks are only available to repository administrators.
   */
  "repos/get-autolink": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        autolink_id: components["parameters"]["autolink-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["autolink"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an autolink reference from a repository
   * @description This deletes a single autolink reference by ID that was configured for the given repository.
   *
   * Information about autolinks are only available to repository administrators.
   */
  "repos/delete-autolink": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        autolink_id: components["parameters"]["autolink-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Enable automated security fixes
   * @description Enables automated security fixes for a repository. The authenticated user must have admin access to the repository. For more information, see "[Configuring automated security fixes](https://docs.github.com/articles/configuring-automated-security-fixes)".
   */
  "repos/enable-automated-security-fixes": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Disable automated security fixes
   * @description Disables automated security fixes for a repository. The authenticated user must have admin access to the repository. For more information, see "[Configuring automated security fixes](https://docs.github.com/articles/configuring-automated-security-fixes)".
   */
  "repos/disable-automated-security-fixes": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** List branches */
  "repos/list-branches": {
    parameters: {
      query: {
        /** @description Setting to `true` returns only protected branches. When set to `false`, only unprotected branches are returned. Omitting this parameter returns all branches. */
        protected?: boolean;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["short-branch"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Get a branch */
  "repos/get-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["branch-with-protection"];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/get-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["branch-protection"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Protecting a branch requires admin or owner permissions to the repository.
   *
   * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
   *
   * **Note**: The list of users, apps, and teams in total is limited to 100 items.
   */
  "repos/update-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Require status checks to pass before merging. Set to `null` to disable. */
          required_status_checks: {
            /** @description Require branches to be up to date before merging. */
            strict: boolean;
            /**
             * @deprecated
             * @description **Deprecated**: The list of status checks to require in order to merge into this branch. If any of these checks have recently been set by a particular GitHub App, they will be required to come from that app in future for the branch to merge. Use `checks` instead of `contexts` for more fine-grained control.
             */
            contexts: string[];
            /** @description The list of status checks to require in order to merge into this branch. */
            checks?: {
              /** @description The name of the required check */
              context: string;
              /** @description The ID of the GitHub App that must provide this check. Omit this field to automatically select the GitHub App that has recently provided this check, or any app if it was not set by a GitHub App. Pass -1 to explicitly allow any app to set the status. */
              app_id?: number;
            }[];
          } | null;
          /** @description Enforce all configured restrictions for administrators. Set to `true` to enforce required status checks for repository administrators. Set to `null` to disable. */
          enforce_admins: boolean | null;
          /** @description Require at least one approving review on a pull request, before merging. Set to `null` to disable. */
          required_pull_request_reviews: {
            /** @description Specify which users, teams, and apps can dismiss pull request reviews. Pass an empty `dismissal_restrictions` object to disable. User and team `dismissal_restrictions` are only available for organization-owned repositories. Omit this parameter for personal repositories. */
            dismissal_restrictions?: {
              /** @description The list of user `login`s with dismissal access */
              users?: string[];
              /** @description The list of team `slug`s with dismissal access */
              teams?: string[];
              /** @description The list of app `slug`s with dismissal access */
              apps?: string[];
            };
            /** @description Set to `true` if you want to automatically dismiss approving reviews when someone pushes a new commit. */
            dismiss_stale_reviews?: boolean;
            /** @description Blocks merging pull requests until [code owners](https://docs.github.com/articles/about-code-owners/) review them. */
            require_code_owner_reviews?: boolean;
            /** @description Specify the number of reviewers required to approve pull requests. Use a number between 1 and 6 or 0 to not require reviewers. */
            required_approving_review_count?: number;
            /**
             * @description Whether the most recent push must be approved by someone other than the person who pushed it. Default: `false`.
             * @default false
             */
            require_last_push_approval?: boolean;
            /** @description Allow specific users, teams, or apps to bypass pull request requirements. */
            bypass_pull_request_allowances?: {
              /** @description The list of user `login`s allowed to bypass pull request requirements. */
              users?: string[];
              /** @description The list of team `slug`s allowed to bypass pull request requirements. */
              teams?: string[];
              /** @description The list of app `slug`s allowed to bypass pull request requirements. */
              apps?: string[];
            };
          } | null;
          /** @description Restrict who can push to the protected branch. User, app, and team `restrictions` are only available for organization-owned repositories. Set to `null` to disable. */
          restrictions: {
            /** @description The list of user `login`s with push access */
            users: string[];
            /** @description The list of team `slug`s with push access */
            teams: string[];
            /** @description The list of app `slug`s with push access */
            apps?: string[];
          } | null;
          /** @description Enforces a linear commit Git history, which prevents anyone from pushing merge commits to a branch. Set to `true` to enforce a linear commit history. Set to `false` to disable a linear commit Git history. Your repository must allow squash merging or rebase merging before you can enable a linear commit history. Default: `false`. For more information, see "[Requiring a linear commit history](https://docs.github.com/github/administering-a-repository/requiring-a-linear-commit-history)" in the GitHub Help documentation. */
          required_linear_history?: boolean;
          /** @description Permits force pushes to the protected branch by anyone with write access to the repository. Set to `true` to allow force pushes. Set to `false` or `null` to block force pushes. Default: `false`. For more information, see "[Enabling force pushes to a protected branch](https://docs.github.com/github/administering-a-repository/enabling-force-pushes-to-a-protected-branch)" in the GitHub Help documentation." */
          allow_force_pushes?: boolean | null;
          /** @description Allows deletion of the protected branch by anyone with write access to the repository. Set to `false` to prevent deletion of the protected branch. Default: `false`. For more information, see "[Enabling force pushes to a protected branch](https://docs.github.com/github/administering-a-repository/enabling-force-pushes-to-a-protected-branch)" in the GitHub Help documentation. */
          allow_deletions?: boolean;
          /** @description If set to `true`, the `restrictions` branch protection settings which limits who can push will also block pushes which create new branches, unless the push is initiated by a user, team, or app which has the ability to push. Set to `true` to restrict new branch creation. Default: `false`. */
          block_creations?: boolean;
          /** @description Requires all conversations on code to be resolved before a pull request can be merged into a branch that matches this rule. Set to `false` to disable. Default: `false`. */
          required_conversation_resolution?: boolean;
          /**
           * @description Whether to set the branch as read-only. If this is true, users will not be able to push to the branch. Default: `false`.
           * @default false
           */
          lock_branch?: boolean;
          /**
           * @description Whether users can pull changes from upstream when the branch is locked. Set to `true` to allow fork syncing. Set to `false` to prevent fork syncing. Default: `false`.
           * @default false
           */
          allow_fork_syncing?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Delete branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/delete-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get admin branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/get-admin-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-admin-enforced"];
        };
      };
    };
  };
  /**
   * Set admin branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Adding admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
   */
  "repos/set-admin-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-admin-enforced"];
        };
      };
    };
  };
  /**
   * Delete admin branch protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Removing admin enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
   */
  "repos/delete-admin-branch-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get pull request review protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/get-pull-request-review-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-pull-request-review"];
        };
      };
    };
  };
  /**
   * Delete pull request review protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/delete-pull-request-review-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update pull request review protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Updating pull request review enforcement requires admin or owner permissions to the repository and branch protection to be enabled.
   *
   * **Note**: Passing new arrays of `users` and `teams` replaces their previous values.
   */
  "repos/update-pull-request-review-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Specify which users, teams, and apps can dismiss pull request reviews. Pass an empty `dismissal_restrictions` object to disable. User and team `dismissal_restrictions` are only available for organization-owned repositories. Omit this parameter for personal repositories. */
          dismissal_restrictions?: {
            /** @description The list of user `login`s with dismissal access */
            users?: string[];
            /** @description The list of team `slug`s with dismissal access */
            teams?: string[];
            /** @description The list of app `slug`s with dismissal access */
            apps?: string[];
          };
          /** @description Set to `true` if you want to automatically dismiss approving reviews when someone pushes a new commit. */
          dismiss_stale_reviews?: boolean;
          /** @description Blocks merging pull requests until [code owners](https://docs.github.com/articles/about-code-owners/) have reviewed. */
          require_code_owner_reviews?: boolean;
          /** @description Specifies the number of reviewers required to approve pull requests. Use a number between 1 and 6 or 0 to not require reviewers. */
          required_approving_review_count?: number;
          /**
           * @description Whether the most recent push must be approved by someone other than the person who pushed it. Default: `false`
           * @default false
           */
          require_last_push_approval?: boolean;
          /** @description Allow specific users, teams, or apps to bypass pull request requirements. */
          bypass_pull_request_allowances?: {
            /** @description The list of user `login`s allowed to bypass pull request requirements. */
            users?: string[];
            /** @description The list of team `slug`s allowed to bypass pull request requirements. */
            teams?: string[];
            /** @description The list of app `slug`s allowed to bypass pull request requirements. */
            apps?: string[];
          };
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-pull-request-review"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get commit signature protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * When authenticated with admin or owner permissions to the repository, you can use this endpoint to check whether a branch requires signed commits. An enabled status of `true` indicates you must sign commits on this branch. For more information, see [Signing commits with GPG](https://docs.github.com/articles/signing-commits-with-gpg) in GitHub Help.
   *
   * **Note**: You must enable branch protection to require signed commits.
   */
  "repos/get-commit-signature-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-admin-enforced"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create commit signature protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * When authenticated with admin or owner permissions to the repository, you can use this endpoint to require signed commits on a branch. You must enable branch protection to require signed commits.
   */
  "repos/create-commit-signature-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["protected-branch-admin-enforced"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete commit signature protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * When authenticated with admin or owner permissions to the repository, you can use this endpoint to disable required signed commits on a branch. You must enable branch protection to require signed commits.
   */
  "repos/delete-commit-signature-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get status checks protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/get-status-checks-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["status-check-policy"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Remove status check protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/remove-status-check-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update status check protection
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Updating required status checks requires admin or owner permissions to the repository and branch protection to be enabled.
   */
  "repos/update-status-check-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Require branches to be up to date before merging. */
          strict?: boolean;
          /**
           * @deprecated
           * @description **Deprecated**: The list of status checks to require in order to merge into this branch. If any of these checks have recently been set by a particular GitHub App, they will be required to come from that app in future for the branch to merge. Use `checks` instead of `contexts` for more fine-grained control.
           */
          contexts?: string[];
          /** @description The list of status checks to require in order to merge into this branch. */
          checks?: {
            /** @description The name of the required check */
            context: string;
            /** @description The ID of the GitHub App that must provide this check. Omit this field to automatically select the GitHub App that has recently provided this check, or any app if it was not set by a GitHub App. Pass -1 to explicitly allow any app to set the status. */
            app_id?: number;
          }[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["status-check-policy"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get all status check contexts
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/get-all-status-check-contexts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set status check contexts
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/set-status-check-contexts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the status checks */
          contexts: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Add status check contexts
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/add-status-check-contexts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the status checks */
          contexts: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove status check contexts
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "repos/remove-status-check-contexts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the status checks */
          contexts: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Lists who has access to this protected branch.
   *
   * **Note**: Users, apps, and teams `restrictions` are only available for organization-owned repositories.
   */
  "repos/get-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["branch-restriction-policy"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Disables the ability to restrict who can push to this branch.
   */
  "repos/delete-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get apps with access to the protected branch
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Lists the GitHub Apps that have push access to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
   */
  "repos/get-apps-with-access-to-protected-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set app access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Replaces the list of apps that have push access to this branch. This removes all apps that previously had push access and grants push access to the new list of apps. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
   */
  "repos/set-app-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The GitHub Apps that have push access to this branch. Use the slugified version of the app name. **Note**: The list of users, apps, and teams in total is limited to 100 items. */
          apps: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Add app access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Grants the specified apps push access for this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
   */
  "repos/add-app-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The GitHub Apps that have push access to this branch. Use the slugified version of the app name. **Note**: The list of users, apps, and teams in total is limited to 100 items. */
          apps: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove app access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Removes the ability of an app to push to this branch. Only installed GitHub Apps with `write` access to the `contents` permission can be added as authorized actors on a protected branch.
   */
  "repos/remove-app-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The GitHub Apps that have push access to this branch. Use the slugified version of the app name. **Note**: The list of users, apps, and teams in total is limited to 100 items. */
          apps: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["integration"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get teams with access to the protected branch
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Lists the teams who have push access to this branch. The list includes child teams.
   */
  "repos/get-teams-with-access-to-protected-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set team access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Replaces the list of teams that have push access to this branch. This removes all teams that previously had push access and grants push access to the new list of teams. Team restrictions include child teams.
   */
  "repos/set-team-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The slug values for teams */
          teams: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Add team access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Grants the specified teams push access for this branch. You can also give push access to child teams.
   */
  "repos/add-team-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The slug values for teams */
          teams: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove team access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Removes the ability of a team to push to this branch. You can also remove push access for child teams.
   */
  "repos/remove-team-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The slug values for teams */
          teams: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get users with access to the protected branch
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Lists the people who have push access to this branch.
   */
  "repos/get-users-with-access-to-protected-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Set user access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Replaces the list of people that have push access to this branch. This removes all people that previously had push access and grants push access to the new list of people.
   *
   * | Type    | Description                                                                                                                   |
   * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
   * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
   */
  "repos/set-user-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The username for users */
          users: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Add user access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Grants the specified people push access for this branch.
   *
   * | Type    | Description                                                                                                                   |
   * | ------- | ----------------------------------------------------------------------------------------------------------------------------- |
   * | `array` | Usernames for people who can have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
   */
  "repos/add-user-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The username for users */
          users: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove user access restrictions
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Removes the ability of a user to push to this branch.
   *
   * | Type    | Description                                                                                                                                   |
   * | ------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
   * | `array` | Usernames of the people who should no longer have push access. **Note**: The list of users, apps, and teams in total is limited to 100 items. |
   */
  "repos/remove-user-access-restrictions": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The username for users */
          users: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Rename a branch
   * @description Renames a branch in a repository.
   *
   * **Note:** Although the API responds immediately, the branch rename process might take some extra time to complete in the background. You won't be able to push to the old branch name while the rename process is in progress. For more information, see "[Renaming a branch](https://docs.github.com/github/administering-a-repository/renaming-a-branch)".
   *
   * The permissions required to use this endpoint depends on whether you are renaming the default branch.
   *
   * To rename a non-default branch:
   *
   * * Users must have push access.
   * * GitHub Apps must have the `contents:write` repository permission.
   *
   * To rename the default branch:
   *
   * * Users must have admin or owner permissions.
   * * GitHub Apps must have the `administration:write` repository permission.
   */
  "repos/rename-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The new name of the branch. */
          new_name: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["branch-with-protection"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a check run
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
   *
   * Creates a new check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to create check runs.
   *
   * In a check suite, GitHub limits the number of check runs with the same name to 1000. Once these check runs exceed 1000, GitHub will start to automatically delete older check runs.
   */
  "checks/create": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": OneOf<
          [
            {
              /** @enum {unknown} */
              status: "completed";
              [key: string]: unknown;
            },
            {
              /** @enum {unknown} */
              status?: "queued" | "in_progress";
              [key: string]: unknown;
            }
          ]
        >;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["check-run"];
        };
      };
    };
  };
  /**
   * Get a check run
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
   *
   * Gets a single check run using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
   */
  "checks/get": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_run_id: components["parameters"]["check-run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["check-run"];
        };
      };
    };
  };
  /**
   * Update a check run
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
   *
   * Updates a check run for a specific commit in a repository. Your GitHub App must have the `checks:write` permission to edit check runs.
   */
  "checks/update": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_run_id: components["parameters"]["check-run-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the check. For example, "code-coverage". */
          name?: string;
          /** @description The URL of the integrator's site that has the full details of the check. */
          details_url?: string;
          /** @description A reference for the run on the integrator's system. */
          external_id?: string;
          /**
           * Format: date-time
           * @description This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
           */
          started_at?: string;
          /**
           * @description The current status.
           * @enum {string}
           */
          status?: "queued" | "in_progress" | "completed";
          /**
           * @description **Required if you provide `completed_at` or a `status` of `completed`**. The final conclusion of the check.
           * **Note:** Providing `conclusion` will automatically set the `status` parameter to `completed`. You cannot change a check run conclusion to `stale`, only GitHub can set this.
           * @enum {string}
           */
          conclusion?:
            | "action_required"
            | "cancelled"
            | "failure"
            | "neutral"
            | "success"
            | "skipped"
            | "stale"
            | "timed_out";
          /**
           * Format: date-time
           * @description The time the check completed. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
           */
          completed_at?: string;
          /** @description Check runs can accept a variety of data in the `output` object, including a `title` and `summary` and can optionally provide descriptive details about the run. */
          output?: {
            /** @description **Required**. */
            title?: string;
            /** @description Can contain Markdown. */
            summary: string;
            /** @description Can contain Markdown. */
            text?: string;
            /** @description Adds information from your analysis to specific lines of code. Annotations are visible in GitHub's pull request UI. Annotations are visible in GitHub's pull request UI. The Checks API limits the number of annotations to a maximum of 50 per API request. To create more than 50 annotations, you have to make multiple requests to the [Update a check run](https://docs.github.com/rest/reference/checks#update-a-check-run) endpoint. Each time you update the check run, annotations are appended to the list of annotations that already exist for the check run. GitHub Actions are limited to 10 warning annotations and 10 error annotations per step. For details about annotations in the UI, see "[About status checks](https://docs.github.com/articles/about-status-checks#checks)". */
            annotations?: {
              /** @description The path of the file to add an annotation to. For example, `assets/css/main.css`. */
              path: string;
              /** @description The start line of the annotation. Line numbers start at 1. */
              start_line: number;
              /** @description The end line of the annotation. */
              end_line: number;
              /** @description The start column of the annotation. Annotations only support `start_column` and `end_column` on the same line. Omit this parameter if `start_line` and `end_line` have different values. Column numbers start at 1. */
              start_column?: number;
              /** @description The end column of the annotation. Annotations only support `start_column` and `end_column` on the same line. Omit this parameter if `start_line` and `end_line` have different values. */
              end_column?: number;
              /**
               * @description The level of the annotation.
               * @enum {string}
               */
              annotation_level: "notice" | "warning" | "failure";
              /** @description A short description of the feedback for these lines of code. The maximum size is 64 KB. */
              message: string;
              /** @description The title that represents the annotation. The maximum size is 255 characters. */
              title?: string;
              /** @description Details about this annotation. The maximum size is 64 KB. */
              raw_details?: string;
            }[];
            /** @description Adds images to the output displayed in the GitHub pull request UI. */
            images?: {
              /** @description The alternative text for the image. */
              alt: string;
              /** @description The full URL of the image. */
              image_url: string;
              /** @description A short image description. */
              caption?: string;
            }[];
          };
          /** @description Possible further actions the integrator can perform, which a user may trigger. Each action includes a `label`, `identifier` and `description`. A maximum of three actions are accepted. See the [`actions` object](https://docs.github.com/rest/reference/checks#actions-object) description. To learn more about check runs and requested actions, see "[Check runs and requested actions](https://docs.github.com/rest/reference/checks#check-runs-and-requested-actions)." */
          actions?: {
            /** @description The text to be displayed on a button in the web UI. The maximum size is 20 characters. */
            label: string;
            /** @description A short explanation of what this action would do. The maximum size is 40 characters. */
            description: string;
            /** @description A reference for the action on the integrator's system. The maximum size is 20 characters. */
            identifier: string;
          }[];
        } & (
          | {
              /** @enum {unknown} */
              status?: "completed";
              [key: string]: unknown;
            }
          | {
              /** @enum {unknown} */
              status?: "queued" | "in_progress";
              [key: string]: unknown;
            }
        );
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["check-run"];
        };
      };
    };
  };
  /**
   * List check run annotations
   * @description Lists annotations for a check run using the annotation `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get annotations for a check run. OAuth Apps and authenticated users must have the `repo` scope to get annotations for a check run in a private repository.
   */
  "checks/list-annotations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_run_id: components["parameters"]["check-run-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["check-annotation"][];
        };
      };
    };
  };
  /**
   * Rerequest a check run
   * @description Triggers GitHub to rerequest an existing check run, without pushing new code to a repository. This endpoint will trigger the [`check_run` webhook](https://docs.github.com/webhooks/event-payloads/#check_run) event with the action `rerequested`. When a check run is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
   *
   * To rerequest a check run, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
   */
  "checks/rerequest-run": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_run_id: components["parameters"]["check-run-id"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Forbidden if the check run is not rerequestable or doesn't belong to the authenticated GitHub App */
      403: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
      404: components["responses"]["not_found"];
      /** @description Validation error if the check run is not rerequestable */
      422: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * Create a check suite
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
   *
   * By default, check suites are automatically created when you create a [check run](https://docs.github.com/rest/reference/checks#check-runs). You only need to use this endpoint for manually creating check suites when you've disabled automatic creation using "[Update repository preferences for check suites](https://docs.github.com/rest/reference/checks#update-repository-preferences-for-check-suites)". Your GitHub App must have the `checks:write` permission to create check suites.
   */
  "checks/create-suite": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The sha of the head commit. */
          head_sha: string;
        };
      };
    };
    responses: {
      /** @description Response when the suite already exists */
      200: {
        content: {
          "application/json": components["schemas"]["check-suite"];
        };
      };
      /** @description Response when the suite was created */
      201: {
        content: {
          "application/json": components["schemas"]["check-suite"];
        };
      };
    };
  };
  /**
   * Update repository preferences for check suites
   * @description Changes the default automatic flow when creating check suites. By default, a check suite is automatically created each time code is pushed to a repository. When you disable the automatic creation of check suites, you can manually [Create a check suite](https://docs.github.com/rest/reference/checks#create-a-check-suite). You must have admin permissions in the repository to set preferences for check suites.
   */
  "checks/set-suites-preferences": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Enables or disables automatic creation of CheckSuite events upon pushes to the repository. Enabled by default. */
          auto_trigger_checks?: {
            /** @description The `id` of the GitHub App. */
            app_id: number;
            /**
             * @description Set to `true` to enable automatic creation of CheckSuite events upon pushes to the repository, or `false` to disable them.
             * @default true
             */
            setting: boolean;
          }[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["check-suite-preference"];
        };
      };
    };
  };
  /**
   * Get a check suite
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
   *
   * Gets a single check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
   */
  "checks/get-suite": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_suite_id: components["parameters"]["check-suite-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["check-suite"];
        };
      };
    };
  };
  /**
   * List check runs in a check suite
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
   *
   * Lists check runs for a check suite using its `id`. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
   */
  "checks/list-for-suite": {
    parameters: {
      query: {
        check_name?: components["parameters"]["check-name"];
        status?: components["parameters"]["status"];
        /** @description Filters check runs by their `completed_at` timestamp. `latest` returns the most recent check runs. */
        filter?: "latest" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_suite_id: components["parameters"]["check-suite-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            check_runs: components["schemas"]["check-run"][];
          };
        };
      };
    };
  };
  /**
   * Rerequest a check suite
   * @description Triggers GitHub to rerequest an existing check suite, without pushing new code to a repository. This endpoint will trigger the [`check_suite` webhook](https://docs.github.com/webhooks/event-payloads/#check_suite) event with the action `rerequested`. When a check suite is `rerequested`, its `status` is reset to `queued` and the `conclusion` is cleared.
   *
   * To rerequest a check suite, your GitHub App must have the `checks:read` permission on a private repository or pull access to a public repository.
   */
  "checks/rerequest-suite": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        check_suite_id: components["parameters"]["check-suite-id"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * List code scanning alerts for a repository
   * @description Lists all open code scanning alerts for the default branch (usually `main`
   * or `master`). You must use an access token with the `security_events` scope to use
   * this endpoint with private repos, the `public_repo` scope also grants permission to read
   * security events on public repos only. GitHub Apps must have the `security_events` read
   * permission to use this endpoint.
   *
   * The response includes a `most_recent_instance` object.
   * This provides details of the most recent instance of this alert
   * for the default branch or for the specified Git reference
   * (if you used `ref` in the request).
   */
  "code-scanning/list-alerts-for-repo": {
    parameters: {
      query: {
        tool_name?: components["parameters"]["tool-name"];
        tool_guid?: components["parameters"]["tool-guid"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        ref?: components["parameters"]["git-ref"];
        direction?: components["parameters"]["direction"];
        /** @description The property by which to sort the results. . `number` is deprecated - we recommend that you use `created` instead. */
        sort?: "created" | "number" | "updated";
        /** @description Set to `open`, `closed, `fixed`, or `dismissed` to list code scanning alerts in a specific state. */
        state?: components["schemas"]["code-scanning-alert-state"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-alert-items"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a code scanning alert
   * @description Gets a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
   */
  "code-scanning/get-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-alert"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Update a code scanning alert
   * @description Updates the status of a single code scanning alert. You must use an access token with the `security_events` scope to use this endpoint with private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
   */
  "code-scanning/update-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          state: components["schemas"]["code-scanning-alert-set-state"];
          dismissed_reason?: components["schemas"]["code-scanning-alert-dismissed-reason"];
          dismissed_comment?: components["schemas"]["code-scanning-alert-dismissed-comment"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-alert"];
        };
      };
      403: components["responses"]["code_scanning_forbidden_write"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List instances of a code scanning alert
   * @description Lists all instances of the specified code scanning alert.
   * You must use an access token with the `security_events` scope to use this endpoint with private repos,
   * the `public_repo` scope also grants permission to read security events on public repos only.
   * GitHub Apps must have the `security_events` read permission to use this endpoint.
   */
  "code-scanning/list-alert-instances": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        ref?: components["parameters"]["git-ref"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-alert-instance"][];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List code scanning analyses for a repository
   * @description Lists the details of all code scanning analyses for a repository,
   * starting with the most recent.
   * The response is paginated and you can use the `page` and `per_page` parameters
   * to list the analyses you're interested in.
   * By default 30 analyses are listed per page.
   *
   * The `rules_count` field in the response give the number of rules
   * that were run in the analysis.
   * For very old analyses this data is not available,
   * and `0` is returned in this field.
   *
   * You must use an access token with the `security_events` scope to use this endpoint with private repos,
   * the `public_repo` scope also grants permission to read security events on public repos only.
   * GitHub Apps must have the `security_events` read permission to use this endpoint.
   *
   * **Deprecation notice**:
   * The `tool_name` field is deprecated and will, in future, not be included in the response for this endpoint. The example response reflects this change. The tool name can now be found inside the `tool` field.
   */
  "code-scanning/list-recent-analyses": {
    parameters: {
      query: {
        tool_name?: components["parameters"]["tool-name"];
        tool_guid?: components["parameters"]["tool-guid"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        /** @description The Git reference for the analyses you want to list. The `ref` for a branch can be formatted either as `refs/heads/<branch name>` or simply `<branch name>`. To reference a pull request use `refs/pull/<number>/merge`. */
        ref?: components["schemas"]["code-scanning-ref"];
        /** @description Filter analyses belonging to the same SARIF upload. */
        sarif_id?: components["schemas"]["code-scanning-analysis-sarif-id"];
        direction?: components["parameters"]["direction"];
        /** @description The property by which to sort the results. */
        sort?: "created";
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-analysis"][];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a code scanning analysis for a repository
   * @description Gets a specified code scanning analysis for a repository.
   * You must use an access token with the `security_events` scope to use this endpoint with private repos,
   * the `public_repo` scope also grants permission to read security events on public repos only.
   * GitHub Apps must have the `security_events` read permission to use this endpoint.
   *
   * The default JSON response contains fields that describe the analysis.
   * This includes the Git reference and commit SHA to which the analysis relates,
   * the datetime of the analysis, the name of the code scanning tool,
   * and the number of alerts.
   *
   * The `rules_count` field in the default response give the number of rules
   * that were run in the analysis.
   * For very old analyses this data is not available,
   * and `0` is returned in this field.
   *
   * If you use the Accept header `application/sarif+json`,
   * the response contains the analysis data that was uploaded.
   * This is formatted as
   * [SARIF version 2.1.0](https://docs.oasis-open.org/sarif/sarif/v2.1.0/cs01/sarif-v2.1.0-cs01.html).
   */
  "code-scanning/get-analysis": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The ID of the analysis, as returned from the `GET /repos/{owner}/{repo}/code-scanning/analyses` operation. */
        analysis_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-analysis"];
          "application/json+sarif": {
            [key: string]: unknown;
          };
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Delete a code scanning analysis from a repository
   * @description Deletes a specified code scanning analysis from a repository. For
   * private repositories, you must use an access token with the `repo` scope. For public repositories,
   * you must use an access token with `public_repo` scope.
   * GitHub Apps must have the `security_events` write permission to use this endpoint.
   *
   * You can delete one analysis at a time.
   * To delete a series of analyses, start with the most recent analysis and work backwards.
   * Conceptually, the process is similar to the undo function in a text editor.
   *
   * When you list the analyses for a repository,
   * one or more will be identified as deletable in the response:
   *
   * ```
   * "deletable": true
   * ```
   *
   * An analysis is deletable when it's the most recent in a set of analyses.
   * Typically, a repository will have multiple sets of analyses
   * for each enabled code scanning tool,
   * where a set is determined by a unique combination of analysis values:
   *
   * * `ref`
   * * `tool`
   * * `category`
   *
   * If you attempt to delete an analysis that is not the most recent in a set,
   * you'll get a 400 response with the message:
   *
   * ```
   * Analysis specified is not deletable.
   * ```
   *
   * The response from a successful `DELETE` operation provides you with
   * two alternative URLs for deleting the next analysis in the set:
   * `next_analysis_url` and `confirm_delete_url`.
   * Use the `next_analysis_url` URL if you want to avoid accidentally deleting the final analysis
   * in a set. This is a useful option if you want to preserve at least one analysis
   * for the specified tool in your repository.
   * Use the `confirm_delete_url` URL if you are content to remove all analyses for a tool.
   * When you delete the last analysis in a set, the value of `next_analysis_url` and `confirm_delete_url`
   * in the 200 response is `null`.
   *
   * As an example of the deletion process,
   * let's imagine that you added a workflow that configured a particular code scanning tool
   * to analyze the code in a repository. This tool has added 15 analyses:
   * 10 on the default branch, and another 5 on a topic branch.
   * You therefore have two separate sets of analyses for this tool.
   * You've now decided that you want to remove all of the analyses for the tool.
   * To do this you must make 15 separate deletion requests.
   * To start, you must find an analysis that's identified as deletable.
   * Each set of analyses always has one that's identified as deletable.
   * Having found the deletable analysis for one of the two sets,
   * delete this analysis and then continue deleting the next analysis in the set until they're all deleted.
   * Then repeat the process for the second set.
   * The procedure therefore consists of a nested loop:
   *
   * **Outer loop**:
   * * List the analyses for the repository, filtered by tool.
   * * Parse this list to find a deletable analysis. If found:
   *
   *   **Inner loop**:
   *   * Delete the identified analysis.
   *   * Parse the response for the value of `confirm_delete_url` and, if found, use this in the next iteration.
   *
   * The above process assumes that you want to remove all trace of the tool's analyses from the GitHub user interface, for the specified repository, and it therefore uses the `confirm_delete_url` value. Alternatively, you could use the `next_analysis_url` value, which would leave the last analysis in each set undeleted to avoid removing a tool's analysis entirely.
   */
  "code-scanning/delete-analysis": {
    parameters: {
      query: {
        /** @description Allow deletion if the specified analysis is the last in a set. If you attempt to delete the final analysis in a set without setting this parameter to `true`, you'll get a 400 response with the message: `Analysis is last of its type and deletion may result in the loss of historical alert data. Please specify confirm_delete.` */
        confirm_delete?: string | null;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The ID of the analysis, as returned from the `GET /repos/{owner}/{repo}/code-scanning/analyses` operation. */
        analysis_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-analysis-deletion"];
        };
      };
      400: components["responses"]["bad_request"];
      403: components["responses"]["code_scanning_forbidden_write"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List CodeQL databases for a repository
   * @description Lists the CodeQL databases that are available in a repository.
   *
   * For private repositories, you must use an access token with the `security_events` scope.
   * For public repositories, you can use tokens with the `security_events` or `public_repo` scope.
   * GitHub Apps must have the `contents` read permission to use this endpoint.
   */
  "code-scanning/list-codeql-databases": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-codeql-database"][];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a CodeQL database for a repository
   * @description Gets a CodeQL database for a language in a repository.
   *
   * By default this endpoint returns JSON metadata about the CodeQL database. To
   * download the CodeQL database binary content, set the `Accept` header of the request
   * to [`application/zip`](https://docs.github.com/rest/overview/media-types), and make sure
   * your HTTP client is configured to follow redirects or use the `Location` header
   * to make a second request to get the redirect URL.
   *
   * For private repositories, you must use an access token with the `security_events` scope.
   * For public repositories, you can use tokens with the `security_events` or `public_repo` scope.
   * GitHub Apps must have the `contents` read permission to use this endpoint.
   */
  "code-scanning/get-codeql-database": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The language of the CodeQL database. */
        language: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-codeql-database"];
        };
      };
      302: components["responses"]["found"];
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a code scanning default setup configuration
   * @description Gets a code scanning default setup configuration.
   * You must use an access token with the `repo` scope to use this endpoint with private repos or the `public_repo`
   * scope for public repos. GitHub Apps must have the `repo` write permission to use this endpoint.
   */
  "code-scanning/get-default-setup": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-default-setup"];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Update a code scanning default setup configuration
   * @description Updates a code scanning default setup configuration.
   * You must use an access token with the `repo` scope to use this endpoint with private repos or the `public_repo`
   * scope for public repos. GitHub Apps must have the `repo` write permission to use this endpoint.
   */
  "code-scanning/update-default-setup": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["code-scanning-default-setup-update"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["code-scanning-default-setup-update-response"];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      404: components["responses"]["not_found"];
      409: components["responses"]["code_scanning_conflict"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Upload an analysis as SARIF data
   * @description Uploads SARIF data containing the results of a code scanning analysis to make the results available in a repository. You must use an access token with the `security_events` scope to use this endpoint for private repositories. You can also use tokens with the `public_repo` scope for public repositories only. GitHub Apps must have the `security_events` write permission to use this endpoint.
   *
   * There are two places where you can upload code scanning results.
   *  - If you upload to a pull request, for example `--ref refs/pull/42/merge` or `--ref refs/pull/42/head`, then the results appear as alerts in a pull request check. For more information, see "[Triaging code scanning alerts in pull requests](/code-security/secure-coding/triaging-code-scanning-alerts-in-pull-requests)."
   *  - If you upload to a branch, for example `--ref refs/heads/my-branch`, then the results appear in the **Security** tab for your repository. For more information, see "[Managing code scanning alerts for your repository](/code-security/secure-coding/managing-code-scanning-alerts-for-your-repository#viewing-the-alerts-for-a-repository)."
   *
   * You must compress the SARIF-formatted analysis data that you want to upload, using `gzip`, and then encode it as a Base64 format string. For example:
   *
   * ```
   * gzip -c analysis-data.sarif | base64 -w0
   * ```
   * <br>
   * SARIF upload supports a maximum number of entries per the following data objects, and an analysis will be rejected if any of these objects is above its maximum value. For some objects, there are additional values over which the entries will be ignored while keeping the most important entries whenever applicable.
   * To get the most out of your analysis when it includes data above the supported limits, try to optimize the analysis configuration. For example, for the CodeQL tool, identify and remove the most noisy queries.
   *
   *
   * | **SARIF data**                   | **Maximum values** | **Additional limits**                                                            |
   * |----------------------------------|:------------------:|----------------------------------------------------------------------------------|
   * | Runs per file                    |         20         |                                                                                  |
   * | Results per run                  |       25,000       | Only the top 5,000 results will be included, prioritized by severity.            |
   * | Rules per run                    |       25,000       |                                                                                  |
   * | Tool extensions per run          |        100         |                                                                                  |
   * | Thread Flow Locations per result |       10,000       | Only the top 1,000 Thread Flow Locations will be included, using prioritization. |
   * | Location per result	             |       1,000        | Only 100 locations will be included.                                             |
   * | Tags per rule	                   |         20         | Only 10 tags will be included.                                                   |
   *
   *
   * The `202 Accepted` response includes an `id` value.
   * You can use this ID to check the status of the upload by using it in the `/sarifs/{sarif_id}` endpoint.
   * For more information, see "[Get information about a SARIF upload](/rest/reference/code-scanning#get-information-about-a-sarif-upload)."
   */
  "code-scanning/upload-sarif": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          commit_sha: components["schemas"]["code-scanning-analysis-commit-sha"];
          ref: components["schemas"]["code-scanning-ref"];
          sarif: components["schemas"]["code-scanning-analysis-sarif-file"];
          /**
           * Format: uri
           * @description The base directory used in the analysis, as it appears in the SARIF file.
           * This property is used to convert file paths from absolute to relative, so that alerts can be mapped to their correct location in the repository.
           * @example file:///github/workspace/
           */
          checkout_uri?: string;
          /**
           * Format: date-time
           * @description The time that the analysis run began. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
           */
          started_at?: string;
          /** @description The name of the tool used to generate the code scanning analysis. If this parameter is not used, the tool name defaults to "API". If the uploaded SARIF contains a tool GUID, this will be available for filtering using the `tool_guid` parameter of operations such as `GET /repos/{owner}/{repo}/code-scanning/alerts`. */
          tool_name?: string;
          /**
           * @description Whether the SARIF file will be validated according to the code scanning specifications.
           * This parameter is intended to help integrators ensure that the uploaded SARIF files are correctly rendered by code scanning.
           */
          validate?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["code-scanning-sarifs-receipt"];
        };
      };
      /** @description Bad Request if the sarif field is invalid */
      400: never;
      403: components["responses"]["code_scanning_forbidden_write"];
      404: components["responses"]["not_found"];
      /** @description Payload Too Large if the sarif field is too large */
      413: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get information about a SARIF upload
   * @description Gets information about a SARIF upload, including the status and the URL of the analysis that was uploaded so that you can retrieve details of the analysis. For more information, see "[Get a code scanning analysis for a repository](/rest/reference/code-scanning#get-a-code-scanning-analysis-for-a-repository)." You must use an access token with the `security_events` scope to use this endpoint with private repos, the `public_repo` scope also grants permission to read security events on public repos only. GitHub Apps must have the `security_events` read permission to use this endpoint.
   */
  "code-scanning/get-sarif": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The SARIF ID obtained after uploading. */
        sarif_id: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["code-scanning-sarifs-status"];
        };
      };
      403: components["responses"]["code_scanning_forbidden_read"];
      /** @description Not Found if the sarif id does not match any upload */
      404: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List CODEOWNERS errors
   * @description List any syntax errors that are detected in the CODEOWNERS
   * file.
   *
   * For more information about the correct CODEOWNERS syntax,
   * see "[About code owners](https://docs.github.com/repositories/managing-your-repositorys-settings-and-features/customizing-your-repository/about-code-owners)."
   */
  "repos/codeowners-errors": {
    parameters: {
      query: {
        /** @description A branch, tag or commit name used to determine which version of the CODEOWNERS file to use. Default: the repository's default branch (e.g. `main`) */
        ref?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codeowners-errors"];
        };
      };
      /** @description Resource not found */
      404: never;
    };
  };
  /**
   * List codespaces in a repository for the authenticated user
   * @description Lists the codespaces associated to a specified repository and the authenticated user.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/list-in-repository-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            codespaces: components["schemas"]["codespace"][];
          };
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Create a codespace in a repository
   * @description Creates a codespace owned by the authenticated user in the specified repository.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/create-with-repo-for-authenticated-user": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Git ref (typically a branch name) for this codespace */
          ref?: string;
          /** @description The requested location for a new codespace. Best efforts are made to respect this upon creation. Assigned by IP if not provided. */
          location?: string;
          /** @description IP for location auto-detection when proxying a request */
          client_ip?: string;
          /** @description Machine type to use for this codespace */
          machine?: string;
          /** @description Path to devcontainer.json config to use for this codespace */
          devcontainer_path?: string;
          /** @description Whether to authorize requested permissions from devcontainer.json */
          multi_repo_permissions_opt_out?: boolean;
          /** @description Working directory for this codespace */
          working_directory?: string;
          /** @description Time in minutes before codespace stops from inactivity */
          idle_timeout_minutes?: number;
          /** @description Display name for this codespace */
          display_name?: string;
          /** @description Duration in minutes after codespace has gone idle in which it will be deleted. Must be integer minutes between 0 and 43200 (30 days). */
          retention_period_minutes?: number;
        } | null;
      };
    };
    responses: {
      /** @description Response when the codespace was successfully created */
      201: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      /** @description Response when the codespace creation partially failed but is being retried in the background */
      202: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      400: components["responses"]["bad_request"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List devcontainer configurations in a repository for the authenticated user
   * @description Lists the devcontainer.json files associated with a specified repository and the authenticated user. These files
   * specify launchpoint configurations for codespaces created within the repository.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_metadata` repository permission to use this endpoint.
   */
  "codespaces/list-devcontainers-in-repository-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            devcontainers: {
              path: string;
              name?: string;
              display_name?: string;
            }[];
          };
        };
      };
      400: components["responses"]["bad_request"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List available machine types for a repository
   * @description List the machine types available for a given repository based on its configuration.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_metadata` repository permission to use this endpoint.
   */
  "codespaces/repo-machines-for-authenticated-user": {
    parameters: {
      query: {
        /** @description The location to check for available machines. Assigned by IP if not provided. */
        location?: string;
        /** @description IP for location auto-detection when proxying a request */
        client_ip?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            machines: components["schemas"]["codespace-machine"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get default attributes for a codespace
   * @description Gets the default attributes for codespaces created by the user with the repository.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/pre-flight-with-repo-for-authenticated-user": {
    parameters: {
      query: {
        /** @description The branch or commit to check for a default devcontainer path. If not specified, the default branch will be checked. */
        ref?: string;
        /** @description An alternative IP for default location auto-detection, such as when proxying a request. */
        client_ip?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response when a user is able to create codespaces from the repository. */
      200: {
        content: {
          "application/json": {
            billable_owner?: components["schemas"]["simple-user"];
            defaults?: {
              location: string;
              devcontainer_path: string | null;
            };
          };
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repository secrets
   * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
   */
  "codespaces/list-repo-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["repo-codespaces-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get a repository public key
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
   */
  "codespaces/get-repo-public-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespaces-public-key"];
        };
      };
    };
  };
  /**
   * Get a repository secret
   * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
   */
  "codespaces/get-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repo-codespaces-secret"];
        };
      };
    };
  };
  /**
   * Create or update a repository secret
   * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets`
   * repository permission to use this endpoint.
   *
   * #### Example of encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example of encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example of encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example of encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "codespaces/create-or-update-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get a repository public key](https://docs.github.com/rest/reference/codespaces#get-a-repository-public-key) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id?: string;
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete a repository secret
   * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have write access to the `codespaces_secrets` repository permission to use this endpoint.
   */
  "codespaces/delete-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List repository collaborators
   * @description For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
   * Organization members with write, maintain, or admin privileges on the organization-owned repository can use this endpoint.
   *
   * Team members will include the members of child teams.
   *
   * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
   * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
   * endpoint.
   */
  "repos/list-collaborators": {
    parameters: {
      query: {
        /** @description Filter collaborators returned by their affiliation. `outside` means all outside collaborators of an organization-owned repository. `direct` means all collaborators with permissions to an organization-owned repository, regardless of organization membership status. `all` means all collaborators the authenticated user can see. */
        affiliation?: "outside" | "direct" | "all";
        /** @description Filter collaborators by the permissions they have on the repository. If not specified, all collaborators will be returned. */
        permission?: "pull" | "triage" | "push" | "maintain" | "admin";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["collaborator"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Check if a user is a repository collaborator
   * @description For organization-owned repositories, the list of collaborators includes outside collaborators, organization members that are direct collaborators, organization members with access through team memberships, organization members with access through default organization permissions, and organization owners.
   *
   * Team members will include the members of child teams.
   *
   * You must authenticate using an access token with the `read:org` and `repo` scopes with push access to use this
   * endpoint. GitHub Apps must have the `members` organization permission and `metadata` repository permission to use this
   * endpoint.
   */
  "repos/check-collaborator": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response if user is a collaborator */
      204: never;
      /** @description Not Found if user is not a collaborator */
      404: never;
    };
  };
  /**
   * Add a repository collaborator
   * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   *
   * Adding an outside collaborator may be restricted by enterprise administrators. For more information, see "[Enforcing repository management policies in your enterprise](https://docs.github.com/admin/policies/enforcing-policies-for-your-enterprise/enforcing-repository-management-policies-in-your-enterprise#enforcing-a-policy-for-inviting-outside-collaborators-to-repositories)."
   *
   * For more information on permission levels, see "[Repository permission levels for an organization](https://docs.github.com/github/setting-up-and-managing-organizations-and-teams/repository-permission-levels-for-an-organization#permission-levels-for-repositories-owned-by-an-organization)". There are restrictions on which permissions can be granted to organization members when an organization base role is in place. In this case, the permission being given must be equal to or higher than the org base permission. Otherwise, the request will fail with:
   *
   * ```
   * Cannot assign {member} permission of {role name}
   * ```
   *
   * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   *
   * The invitee will receive a notification that they have been invited to the repository, which they must accept or decline. They may do this via the notifications page, the email they receive, or by using the [repository invitations API endpoints](https://docs.github.com/rest/reference/repos#invitations).
   *
   * **Updating an existing collaborator's permission level**
   *
   * The endpoint can also be used to change the permissions of an existing collaborator without first removing and re-adding the collaborator. To change the permissions, use the same endpoint and pass a different `permission` parameter. The response will be a `204`, with no other indication that the permission level changed.
   *
   * **Rate limits**
   *
   * You are limited to sending 50 invitations to a repository per 24 hour period. Note there is no limit if you are inviting organization members to an organization repository.
   */
  "repos/add-collaborator": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant the collaborator. **Only valid on organization-owned repositories.** We accept the following permissions to be set: `pull`, `triage`, `push`, `maintain`, `admin` and you can also specify a custom repository role name, if the owning organization has defined any.
           * @default push
           */
          permission?: string;
        };
      };
    };
    responses: {
      /** @description Response when a new invitation is created */
      201: {
        content: {
          "application/json": components["schemas"]["repository-invitation"];
        };
      };
      /**
       * @description Response when:
       * - an existing collaborator is added as a collaborator
       * - an organization member is added as an individual collaborator
       * - an existing team member (whose team is also a repository collaborator) is added as an individual collaborator
       */
      204: never;
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Remove a repository collaborator */
  "repos/remove-collaborator": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get repository permissions for a user
   * @description Checks the repository permission of a collaborator. The possible repository permissions are `admin`, `write`, `read`, and `none`.
   */
  "repos/get-collaborator-permission-level": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description if user has admin permissions */
      200: {
        content: {
          "application/json": components["schemas"]["repository-collaborator-permission"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List commit comments for a repository
   * @description Commit Comments use [these custom media types](https://docs.github.com/rest/reference/repos#custom-media-types). You can read more about the use of media types in the API [here](https://docs.github.com/rest/overview/media-types/).
   *
   * Comments are ordered by ascending ID.
   */
  "repos/list-commit-comments-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["commit-comment"][];
        };
      };
    };
  };
  /** Get a commit comment */
  "repos/get-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a commit comment */
  "repos/delete-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /** Update a commit comment */
  "repos/update-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The contents of the comment */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List reactions for a commit comment
   * @description List the reactions to a [commit comment](https://docs.github.com/rest/reference/repos#comments).
   */
  "reactions/list-for-commit-comment": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a commit comment. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create reaction for a commit comment
   * @description Create a reaction to a [commit comment](https://docs.github.com/rest/reference/repos#comments). A response with an HTTP `200` status means that you already added the reaction type to this commit comment.
   */
  "reactions/create-for-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the commit comment.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Reaction exists */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Reaction created */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a commit comment reaction
   * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/comments/:comment_id/reactions/:reaction_id`.
   *
   * Delete a reaction to a [commit comment](https://docs.github.com/rest/reference/repos#comments).
   */
  "reactions/delete-for-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List commits
   * @description **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "repos/list-commits": {
    parameters: {
      query: {
        /** @description SHA or branch to start listing commits from. Default: the repository’s default branch (usually `main`). */
        sha?: string;
        /** @description Only commits containing this file path will be returned. */
        path?: string;
        /** @description GitHub username or email address to use to filter by commit author. */
        author?: string;
        /** @description GitHub username or email address to use to filter by commit committer. */
        committer?: string;
        since?: components["parameters"]["since"];
        /** @description Only commits before this date will be returned. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. */
        until?: string;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["commit"][];
        };
      };
      400: components["responses"]["bad_request"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List branches for HEAD commit
   * @description Protected branches are available in public repositories with GitHub Free and GitHub Free for organizations, and in public and private repositories with GitHub Pro, GitHub Team, GitHub Enterprise Cloud, and GitHub Enterprise Server. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Returns all branches where the given commit SHA is the HEAD, or latest commit for the branch.
   */
  "repos/list-branches-for-head-commit": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        commit_sha: components["parameters"]["commit-sha"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["branch-short"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List commit comments
   * @description Use the `:commit_sha` to specify the commit that will have its comments listed.
   */
  "repos/list-comments-for-commit": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        commit_sha: components["parameters"]["commit-sha"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["commit-comment"][];
        };
      };
    };
  };
  /**
   * Create a commit comment
   * @description Create a comment for a commit using its `:commit_sha`.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "repos/create-commit-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        commit_sha: components["parameters"]["commit-sha"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The contents of the comment. */
          body: string;
          /** @description Relative path of the file to comment on. */
          path?: string;
          /** @description Line index in the diff to comment on. */
          position?: number;
          /** @description **Deprecated**. Use **position** parameter instead. Line number in the file to comment on. */
          line?: number;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/comments/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["commit-comment"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List pull requests associated with a commit
   * @description Lists the merged pull request that introduced the commit to the repository. If the commit is not present in the default branch, will only return open pull requests associated with the commit.
   */
  "repos/list-pull-requests-associated-with-commit": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        commit_sha: components["parameters"]["commit-sha"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-simple"][];
        };
      };
    };
  };
  /**
   * Get a commit
   * @description Returns the contents of a single commit reference. You must have `read` access for the repository to use this endpoint.
   *
   * **Note:** If there are more than 300 files in the commit diff, the response will include pagination link headers for the remaining files, up to a limit of 3000 files. Each page contains the static commit information, and the only changes are to the file listing.
   *
   * You can pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to  fetch `diff` and `patch` formats. Diffs with binary data will have no `patch` property.
   *
   * To return only the SHA-1 hash of the commit reference, you can provide the `sha` custom [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) in the `Accept` header. You can use this endpoint to check if a remote reference's SHA-1 hash is the same as your local reference's SHA-1 hash by providing the local SHA-1 reference as the ETag.
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "repos/get-commit": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List check runs for a Git reference
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
   *
   * Lists check runs for a commit ref. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to get check runs. OAuth Apps and authenticated users must have the `repo` scope to get check runs in a private repository.
   */
  "checks/list-for-ref": {
    parameters: {
      query: {
        check_name?: components["parameters"]["check-name"];
        status?: components["parameters"]["status"];
        /** @description Filters check runs by their `completed_at` timestamp. `latest` returns the most recent check runs. */
        filter?: "latest" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        app_id?: number;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            check_runs: components["schemas"]["check-run"][];
          };
        };
      };
    };
  };
  /**
   * List check suites for a Git reference
   * @description **Note:** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array and a `null` value for `head_branch`.
   *
   * Lists check suites for a commit `ref`. The `ref` can be a SHA, branch name, or a tag name. GitHub Apps must have the `checks:read` permission on a private repository or pull access to a public repository to list check suites. OAuth Apps and authenticated users must have the `repo` scope to get check suites in a private repository.
   */
  "checks/list-suites-for-ref": {
    parameters: {
      query: {
        /**
         * @description Filters check suites by GitHub App `id`.
         * @example 1
         */
        app_id?: number;
        check_name?: components["parameters"]["check-name"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            check_suites: components["schemas"]["check-suite"][];
          };
        };
      };
    };
  };
  /**
   * Get the combined status for a specific reference
   * @description Users with pull access in a repository can access a combined view of commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name.
   *
   *
   * Additionally, a combined `state` is returned. The `state` is one of:
   *
   * *   **failure** if any of the contexts report as `error` or `failure`
   * *   **pending** if there are no statuses or a context is `pending`
   * *   **success** if the latest status for all contexts is `success`
   */
  "repos/get-combined-status-for-ref": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["combined-commit-status"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List commit statuses for a reference
   * @description Users with pull access in a repository can view commit statuses for a given ref. The ref can be a SHA, a branch name, or a tag name. Statuses are returned in reverse chronological order. The first status in the list will be the latest one.
   *
   * This resource is also available via a legacy route: `GET /repos/:owner/:repo/statuses/:ref`.
   */
  "repos/list-commit-statuses-for-ref": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["status"][];
        };
      };
      301: components["responses"]["moved_permanently"];
    };
  };
  /**
   * Get community profile metrics
   * @description Returns all community profile metrics for a repository. The repository cannot be a fork.
   *
   * The returned metrics include an overall health score, the repository description, the presence of documentation, the
   * detected code of conduct, the detected license, and the presence of ISSUE\_TEMPLATE, PULL\_REQUEST\_TEMPLATE,
   * README, and CONTRIBUTING files.
   *
   * The `health_percentage` score is defined as a percentage of how many of
   * these four documents are present: README, CONTRIBUTING, LICENSE, and
   * CODE_OF_CONDUCT. For example, if all four documents are present, then
   * the `health_percentage` is `100`. If only one is present, then the
   * `health_percentage` is `25`.
   *
   * `content_reports_enabled` is only returned for organization-owned repositories.
   */
  "repos/get-community-profile-metrics": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["community-profile"];
        };
      };
    };
  };
  /**
   * Compare two commits
   * @description Compares two commits against one another. You can compare branches in the same repository, or you can compare branches that exist in different repositories within the same repository network, including fork branches. For more information about how to view a repository's network, see "[Understanding connections between repositories](https://docs.github.com/repositories/viewing-activity-and-data-for-your-repository/understanding-connections-between-repositories)."
   *
   * This endpoint is equivalent to running the `git log BASE..HEAD` command, but it returns commits in a different order. The `git log BASE..HEAD` command returns commits in reverse chronological order, whereas the API returns commits in chronological order. You can pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
   *
   * The API response includes details about the files that were changed between the two commits. This includes the status of the change (if a file was added, removed, modified, or renamed), and details of the change itself. For example, files with a `renamed` status have a `previous_filename` field showing the previous filename of the file, and files with a `modified` status have a `patch` field showing the changes made to the file.
   *
   * When calling this endpoint without any paging parameter (`per_page` or `page`), the returned list is limited to 250 commits, and the last commit in the list is the most recent of the entire comparison.
   *
   * **Working with large comparisons**
   *
   * To process a response with a large number of commits, use a query parameter (`per_page` or `page`) to paginate the results. When using pagination:
   *
   * - The list of changed files is only shown on the first page of results, but it includes all changed files for the entire comparison.
   * - The results are returned in chronological order, but the last commit in the returned list may not be the most recent one in the entire set if there are more pages of results.
   *
   * For more information on working with pagination, see "[Using pagination in the REST API](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api)."
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The `verification` object includes the following fields:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "repos/compare-commits-with-basehead": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The base branch and head branch to compare. This parameter expects the format `BASE...HEAD`. Both must be branch names in `repo`. To compare with a branch that exists in a different repository in the same network as `repo`, the `basehead` parameter expects the format `USERNAME:BASE...USERNAME:HEAD`. */
        basehead: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit-comparison"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get repository content
   * @description Gets the contents of a file or directory in a repository. Specify the file path or directory in `:path`. If you omit
   * `:path`, you will receive the contents of the repository's root directory. See the description below regarding what the API response includes for directories.
   *
   * Files and symlinks support [a custom media type](https://docs.github.com/rest/reference/repos#custom-media-types) for
   * retrieving the raw content or rendered HTML (when supported). All content types support [a custom media
   * type](https://docs.github.com/rest/reference/repos#custom-media-types) to ensure the content is returned in a consistent
   * object format.
   *
   * **Notes**:
   * *   To get a repository's contents recursively, you can [recursively get the tree](https://docs.github.com/rest/reference/git#trees).
   * *   This API has an upper limit of 1,000 files for a directory. If you need to retrieve more files, use the [Git Trees
   * API](https://docs.github.com/rest/reference/git#get-a-tree).
   *  *  Download URLs expire and are meant to be used just once. To ensure the download URL does not expire, please use the contents API to obtain a fresh download URL for each download.
   * #### Size limits
   * If the requested file's size is:
   * * 1 MB or smaller: All features of this endpoint are supported.
   * * Between 1-100 MB: Only the `raw` or `object` [custom media types](https://docs.github.com/rest/repos/contents#custom-media-types-for-repository-contents) are supported. Both will work as normal, except that when using the `object` media type, the `content` field will be an empty string and the `encoding` field will be `"none"`. To get the contents of these larger files, use the `raw` media type.
   *  * Greater than 100 MB: This endpoint is not supported.
   *
   * #### If the content is a directory
   * The response will be an array of objects, one object for each item in the directory.
   * When listing the contents of a directory, submodules have their "type" specified as "file". Logically, the value
   * _should_ be "submodule". This behavior exists in API v3 [for backwards compatibility purposes](https://git.io/v1YCW).
   * In the next major version of the API, the type will be returned as "submodule".
   *
   * #### If the content is a symlink
   * If the requested `:path` points to a symlink, and the symlink's target is a normal file in the repository, then the
   * API responds with the content of the file (in the format shown in the example. Otherwise, the API responds with an object
   * describing the symlink itself.
   *
   * #### If the content is a submodule
   * The `submodule_git_url` identifies the location of the submodule repository, and the `sha` identifies a specific
   * commit within the submodule repository. Git uses the given URL when cloning the submodule repository, and checks out
   * the submodule at that specific commit.
   *
   * If the submodule repository is not hosted on github.com, the Git URLs (`git_url` and `_links["git"]`) and the
   * github.com URLs (`html_url` and `_links["html"]`) will have null values.
   */
  "repos/get-content": {
    parameters: {
      query: {
        /** @description The name of the commit/branch/tag. Default: the repository’s default branch. */
        ref?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description path parameter */
        path: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/vnd.github.object": components["schemas"]["content-tree"];
          "application/json":
            | components["schemas"]["content-directory"]
            | components["schemas"]["content-file"]
            | components["schemas"]["content-symlink"]
            | components["schemas"]["content-submodule"];
        };
      };
      302: components["responses"]["found"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create or update file contents
   * @description Creates a new file or replaces an existing file in a repository. You must authenticate using an access token with the `workflow` scope to use this endpoint.
   *
   * **Note:** If you use this endpoint and the "[Delete a file](https://docs.github.com/rest/reference/repos/#delete-file)" endpoint in parallel, the concurrent requests will conflict and you will receive errors. You must use these endpoints serially instead.
   */
  "repos/create-or-update-file-contents": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description path parameter */
        path: string;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The commit message. */
          message: string;
          /** @description The new file content, using Base64 encoding. */
          content: string;
          /** @description **Required if you are updating a file**. The blob SHA of the file being replaced. */
          sha?: string;
          /** @description The branch name. Default: the repository’s default branch. */
          branch?: string;
          /** @description The person that committed the file. Default: the authenticated user. */
          committer?: {
            /** @description The name of the author or committer of the commit. You'll receive a `422` status code if `name` is omitted. */
            name: string;
            /** @description The email of the author or committer of the commit. You'll receive a `422` status code if `email` is omitted. */
            email: string;
            /** @example "2013-01-05T13:13:22+05:00" */
            date?: string;
          };
          /** @description The author of the file. Default: The `committer` or the authenticated user if you omit `committer`. */
          author?: {
            /** @description The name of the author or committer of the commit. You'll receive a `422` status code if `name` is omitted. */
            name: string;
            /** @description The email of the author or committer of the commit. You'll receive a `422` status code if `email` is omitted. */
            email: string;
            /** @example "2013-01-15T17:13:22+05:00" */
            date?: string;
          };
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["file-commit"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["file-commit"];
        };
      };
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a file
   * @description Deletes a file in a repository.
   *
   * You can provide an additional `committer` parameter, which is an object containing information about the committer. Or, you can provide an `author` parameter, which is an object containing information about the author.
   *
   * The `author` section is optional and is filled in with the `committer` information if omitted. If the `committer` information is omitted, the authenticated user's information is used.
   *
   * You must provide values for both `name` and `email`, whether you choose to use `author` or `committer`. Otherwise, you'll receive a `422` status code.
   *
   * **Note:** If you use this endpoint and the "[Create or update file contents](https://docs.github.com/rest/reference/repos/#create-or-update-file-contents)" endpoint in parallel, the concurrent requests will conflict and you will receive errors. You must use these endpoints serially instead.
   */
  "repos/delete-file": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description path parameter */
        path: string;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The commit message. */
          message: string;
          /** @description The blob SHA of the file being deleted. */
          sha: string;
          /** @description The branch name. Default: the repository’s default branch */
          branch?: string;
          /** @description object containing information about the committer. */
          committer?: {
            /** @description The name of the author (or committer) of the commit */
            name?: string;
            /** @description The email of the author (or committer) of the commit */
            email?: string;
          };
          /** @description object containing information about the author. */
          author?: {
            /** @description The name of the author (or committer) of the commit */
            name?: string;
            /** @description The email of the author (or committer) of the commit */
            email?: string;
          };
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["file-commit"];
        };
      };
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List repository contributors
   * @description Lists contributors to the specified repository and sorts them by the number of commits per contributor in descending order. This endpoint may return information that is a few hours old because the GitHub REST API caches contributor data to improve performance.
   *
   * GitHub identifies contributors by author email address. This endpoint groups contribution counts by GitHub user, which includes all associated email addresses. To improve performance, only the first 500 author email addresses in the repository link to GitHub users. The rest will appear as anonymous contributors without associated GitHub user information.
   */
  "repos/list-contributors": {
    parameters: {
      query: {
        /** @description Set to `1` or `true` to include anonymous contributors in results. */
        anon?: string;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description if repository contains content */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["contributor"][];
        };
      };
      /** @description Response if repository is empty */
      204: never;
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List Dependabot alerts for a repository
   * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
   * You can also use tokens with the `public_repo` scope for public repositories only.
   * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
   */
  "dependabot/list-alerts-for-repo": {
    parameters: {
      query: {
        state?: components["parameters"]["dependabot-alert-comma-separated-states"];
        severity?: components["parameters"]["dependabot-alert-comma-separated-severities"];
        ecosystem?: components["parameters"]["dependabot-alert-comma-separated-ecosystems"];
        package?: components["parameters"]["dependabot-alert-comma-separated-packages"];
        manifest?: components["parameters"]["dependabot-alert-comma-separated-manifests"];
        scope?: components["parameters"]["dependabot-alert-scope"];
        sort?: components["parameters"]["dependabot-alert-sort"];
        direction?: components["parameters"]["direction"];
        /**
         * @deprecated
         * @description **Deprecated**. Page number of the results to fetch. Use cursor-based pagination with `before` or `after` instead.
         */
        page?: number;
        /**
         * @deprecated
         * @description The number of results per page (max 100).
         */
        per_page?: number;
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
        first?: components["parameters"]["pagination-first"];
        last?: components["parameters"]["pagination-last"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-alert"][];
        };
      };
      304: components["responses"]["not_modified"];
      400: components["responses"]["bad_request"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get a Dependabot alert
   * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
   * You can also use tokens with the `public_repo` scope for public repositories only.
   * GitHub Apps must have **Dependabot alerts** read permission to use this endpoint.
   */
  "dependabot/get-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["dependabot-alert-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-alert"];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a Dependabot alert
   * @description You must use an access token with the `security_events` scope to use this endpoint with private repositories.
   * You can also use tokens with the `public_repo` scope for public repositories only.
   * GitHub Apps must have **Dependabot alerts** write permission to use this endpoint.
   */
  "dependabot/update-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["dependabot-alert-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The state of the Dependabot alert.
           * A `dismissed_reason` must be provided when setting the state to `dismissed`.
           * @enum {string}
           */
          state: "dismissed" | "open";
          /**
           * @description **Required when `state` is `dismissed`.** A reason for dismissing the alert.
           * @enum {string}
           */
          dismissed_reason?:
            | "fix_started"
            | "inaccurate"
            | "no_bandwidth"
            | "not_used"
            | "tolerable_risk";
          /** @description An optional comment associated with dismissing the alert. */
          dismissed_comment?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-alert"];
        };
      };
      400: components["responses"]["bad_request"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List repository secrets
   * @description Lists all secrets available in a repository without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
   */
  "dependabot/list-repo-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["dependabot-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get a repository public key
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
   */
  "dependabot/get-repo-public-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-public-key"];
        };
      };
    };
  };
  /**
   * Get a repository secret
   * @description Gets a single repository secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
   */
  "dependabot/get-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["dependabot-secret"];
        };
      };
    };
  };
  /**
   * Create or update a repository secret
   * @description Creates or updates a repository secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository
   * permission to use this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "dependabot/create-or-update-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get a repository public key](https://docs.github.com/rest/reference/dependabot#get-a-repository-public-key) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id?: string;
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete a repository secret
   * @description Deletes a secret in a repository using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `dependabot_secrets` repository permission to use this endpoint.
   */
  "dependabot/delete-repo-secret": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get a diff of the dependencies between commits
   * @description Gets the diff of the dependency changes between two commits of a repository, based on the changes to the dependency manifests made in those commits.
   */
  "dependency-graph/diff-range": {
    parameters: {
      query: {
        name?: components["parameters"]["manifest-path"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The base and head Git revisions to compare. The Git revisions will be resolved to commit SHAs. Named revisions will be resolved to their corresponding HEAD commits, and an appropriate merge base will be determined. This parameter expects the format `{base}...{head}`. */
        basehead: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["dependency-graph-diff"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Export a software bill of materials (SBOM) for a repository.
   * @description Exports the software bill of materials (SBOM) for a repository in SPDX JSON format.
   */
  "dependency-graph/export-sbom": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["dependency-graph-spdx-sbom"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a snapshot of dependencies for a repository
   * @description Create a new snapshot of a repository's dependencies. You must authenticate using an access token with the `repo` scope to use this endpoint for a repository that the requesting user has access to.
   */
  "dependency-graph/create-repository-snapshot": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["snapshot"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": {
            /** @description ID of the created snapshot. */
            id: number;
            /** @description The time at which the snapshot was created. */
            created_at: string;
            /** @description Either "SUCCESS", "ACCEPTED", or "INVALID". "SUCCESS" indicates that the snapshot was successfully created and the repository's dependencies were updated. "ACCEPTED" indicates that the snapshot was successfully created, but the repository's dependencies were not updated. "INVALID" indicates that the snapshot was malformed. */
            result: string;
            /** @description A message providing further details about the result, such as why the dependencies were not updated. */
            message: string;
          };
        };
      };
    };
  };
  /**
   * List deployments
   * @description Simple filtering of deployments is available via query parameters:
   */
  "repos/list-deployments": {
    parameters: {
      query: {
        /** @description The SHA recorded at creation time. */
        sha?: string;
        /** @description The name of the ref. This can be a branch, tag, or SHA. */
        ref?: string;
        /** @description The name of the task for the deployment (e.g., `deploy` or `deploy:migrations`). */
        task?: string;
        /** @description The name of the environment that was deployed to (e.g., `staging` or `production`). */
        environment?: string | null;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["deployment"][];
        };
      };
    };
  };
  /**
   * Create a deployment
   * @description Deployments offer a few configurable parameters with certain defaults.
   *
   * The `ref` parameter can be any named branch, tag, or SHA. At GitHub we often deploy branches and verify them
   * before we merge a pull request.
   *
   * The `environment` parameter allows deployments to be issued to different runtime environments. Teams often have
   * multiple environments for verifying their applications, such as `production`, `staging`, and `qa`. This parameter
   * makes it easier to track which environments have requested deployments. The default environment is `production`.
   *
   * The `auto_merge` parameter is used to ensure that the requested ref is not behind the repository's default branch. If
   * the ref _is_ behind the default branch for the repository, we will attempt to merge it for you. If the merge succeeds,
   * the API will return a successful merge commit. If merge conflicts prevent the merge from succeeding, the API will
   * return a failure response.
   *
   * By default, [commit statuses](https://docs.github.com/rest/commits/statuses) for every submitted context must be in a `success`
   * state. The `required_contexts` parameter allows you to specify a subset of contexts that must be `success`, or to
   * specify contexts that have not yet been submitted. You are not required to use commit statuses to deploy. If you do
   * not require any contexts or create any commit statuses, the deployment will always succeed.
   *
   * The `payload` parameter is available for any extra information that a deployment system might need. It is a JSON text
   * field that will be passed on when a deployment event is dispatched.
   *
   * The `task` parameter is used by the deployment system to allow different execution paths. In the web world this might
   * be `deploy:migrations` to run schema changes on the system. In the compiled world this could be a flag to compile an
   * application with debugging enabled.
   *
   * Users with `repo` or `repo_deployment` scopes can create a deployment for a given ref.
   *
   * #### Merged branch response
   * You will see this response when GitHub automatically merges the base branch into the topic branch instead of creating
   * a deployment. This auto-merge happens when:
   * *   Auto-merge option is enabled in the repository
   * *   Topic branch does not include the latest changes on the base branch, which is `master` in the response example
   * *   There are no merge conflicts
   *
   * If there are no new commits in the base branch, a new request to create a deployment should give a successful
   * response.
   *
   * #### Merge conflict response
   * This error happens when the `auto_merge` option is enabled and when the default branch (in this case `master`), can't
   * be merged into the branch that's being deployed (in this case `topic-branch`), due to merge conflicts.
   *
   * #### Failed commit status checks
   * This error happens when the `required_contexts` parameter indicates that one or more contexts need to have a `success`
   * status for the commit to be deployed, but one or more of the required contexts do not have a state of `success`.
   */
  "repos/create-deployment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The ref to deploy. This can be a branch, tag, or SHA. */
          ref: string;
          /**
           * @description Specifies a task to execute (e.g., `deploy` or `deploy:migrations`).
           * @default deploy
           */
          task?: string;
          /**
           * @description Attempts to automatically merge the default branch into the requested ref, if it's behind the default branch.
           * @default true
           */
          auto_merge?: boolean;
          /** @description The [status](https://docs.github.com/rest/commits/statuses) contexts to verify against commit status checks. If you omit this parameter, GitHub verifies all unique contexts before creating a deployment. To bypass checking entirely, pass an empty array. Defaults to all unique contexts. */
          required_contexts?: string[];
          payload?: OneOf<
            [
              {
                [key: string]: unknown;
              },
              string
            ]
          >;
          /**
           * @description Name for the target deployment environment (e.g., `production`, `staging`, `qa`).
           * @default production
           */
          environment?: string;
          /**
           * @description Short description of the deployment.
           * @default
           */
          description?: string | null;
          /**
           * @description Specifies if the given environment is specific to the deployment and will no longer exist at some point in the future. Default: `false`
           * @default false
           */
          transient_environment?: boolean;
          /** @description Specifies if the given environment is one that end-users directly interact with. Default: `true` when `environment` is `production` and `false` otherwise. */
          production_environment?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["deployment"];
        };
      };
      /** @description Merged branch response */
      202: {
        content: {
          "application/json": {
            message?: string;
          };
        };
      };
      /** @description Conflict when there is a merge conflict or the commit's status checks failed */
      409: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get a deployment */
  "repos/get-deployment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        deployment_id: components["parameters"]["deployment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a deployment
   * @description If the repository only has one deployment, you can delete the deployment regardless of its status. If the repository has more than one deployment, you can only delete inactive deployments. This ensures that repositories with multiple deployments will always have an active deployment. Anyone with `repo` or `repo_deployment` scopes can delete a deployment.
   *
   * To set a deployment as inactive, you must:
   *
   * *   Create a new deployment that is active so that the system has a record of the current state, then delete the previously active deployment.
   * *   Mark the active deployment as inactive by adding any non-successful deployment status.
   *
   * For more information, see "[Create a deployment](https://docs.github.com/rest/deployments/deployments/#create-a-deployment)" and "[Create a deployment status](https://docs.github.com/rest/deployments/deployment-statuses#create-a-deployment-status)."
   */
  "repos/delete-deployment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        deployment_id: components["parameters"]["deployment-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List deployment statuses
   * @description Users with pull access can view deployment statuses for a deployment:
   */
  "repos/list-deployment-statuses": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        deployment_id: components["parameters"]["deployment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["deployment-status"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a deployment status
   * @description Users with `push` access can create deployment statuses for a given deployment.
   *
   * GitHub Apps require `read & write` access to "Deployments" and `read-only` access to "Repo contents" (for private repos). OAuth Apps require the `repo_deployment` scope.
   */
  "repos/create-deployment-status": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        deployment_id: components["parameters"]["deployment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The state of the status. When you set a transient deployment to `inactive`, the deployment will be shown as `destroyed` in GitHub.
           * @enum {string}
           */
          state:
            | "error"
            | "failure"
            | "inactive"
            | "in_progress"
            | "queued"
            | "pending"
            | "success";
          /**
           * @description The target URL to associate with this status. This URL should contain output to keep the user updated while the task is running or serve as historical information for what happened in the deployment. **Note:** It's recommended to use the `log_url` parameter, which replaces `target_url`.
           * @default
           */
          target_url?: string;
          /**
           * @description The full URL of the deployment's output. This parameter replaces `target_url`. We will continue to accept `target_url` to support legacy uses, but we recommend replacing `target_url` with `log_url`. Setting `log_url` will automatically set `target_url` to the same value. Default: `""`
           * @default
           */
          log_url?: string;
          /**
           * @description A short description of the status. The maximum description length is 140 characters.
           * @default
           */
          description?: string;
          /**
           * @description Name for the target deployment environment, which can be changed when setting a deploy status. For example, `production`, `staging`, or `qa`.
           * @enum {string}
           */
          environment?: "production" | "staging" | "qa";
          /**
           * @description Sets the URL for accessing your environment. Default: `""`
           * @default
           */
          environment_url?: string;
          /** @description Adds a new `inactive` status to all prior non-transient, non-production environment deployments with the same repository and `environment` name as the created status's deployment. An `inactive` status is only added to deployments that had a `success` state. Default: `true` */
          auto_inactive?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/example/deployments/42/statuses/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["deployment-status"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a deployment status
   * @description Users with pull access can view a deployment status for a deployment:
   */
  "repos/get-deployment-status": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        deployment_id: components["parameters"]["deployment-id"];
        status_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment-status"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a repository dispatch event
   * @description You can use this endpoint to trigger a webhook event called `repository_dispatch` when you want activity that happens outside of GitHub to trigger a GitHub Actions workflow or GitHub App webhook. You must configure your GitHub Actions workflow or GitHub App to run when the `repository_dispatch` event occurs. For an example `repository_dispatch` webhook payload, see "[RepositoryDispatchEvent](https://docs.github.com/webhooks/event-payloads/#repository_dispatch)."
   *
   * The `client_payload` parameter is available for any extra information that your workflow might need. This parameter is a JSON payload that will be passed on when the webhook event is dispatched. For example, the `client_payload` can include a message that a user would like to send using a GitHub Actions workflow. Or the `client_payload` can be used as a test to debug your workflow.
   *
   * This endpoint requires write access to the repository by providing either:
   *
   *   - Personal access tokens with `repo` scope. For more information, see "[Creating a personal access token for the command line](https://docs.github.com/articles/creating-a-personal-access-token-for-the-command-line)" in the GitHub Help documentation.
   *   - GitHub Apps with both `metadata:read` and `contents:read&write` permissions.
   *
   * This input example shows how you can use the `client_payload` as a test to debug your workflow.
   */
  "repos/create-dispatch-event": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description A custom webhook event name. Must be 100 characters or fewer. */
          event_type: string;
          /** @description JSON payload with extra information about the webhook event that your action or workflow may use. The maximum number of top-level properties is 10. */
          client_payload?: {
            [key: string]: unknown;
          };
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List environments
   * @description Lists the environments for a repository.
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "repos/get-all-environments": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            /**
             * @description The number of environments in this repository
             * @example 5
             */
            total_count?: number;
            environments?: components["schemas"]["environment"][];
          };
        };
      };
    };
  };
  /**
   * Get an environment
   * @description **Note:** To get information about name patterns that branches must match in order to deploy to this environment, see "[Get a deployment branch policy](/rest/deployments/branch-policies#get-a-deployment-branch-policy)."
   *
   * Anyone with read access to the repository can use this endpoint. If the
   * repository is private, you must use an access token with the `repo` scope. GitHub
   * Apps must have the `actions:read` permission to use this endpoint.
   */
  "repos/get-environment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["environment"];
        };
      };
    };
  };
  /**
   * Create or update an environment
   * @description Create or update an environment with protection rules, such as required reviewers. For more information about environment protection rules, see "[Environments](/actions/reference/environments#environment-protection-rules)."
   *
   * **Note:** To create or update name patterns that branches must match in order to deploy to this environment, see "[Deployment branch policies](/rest/deployments/branch-policies)."
   *
   * **Note:** To create or update secrets for an environment, see "[Secrets](/rest/reference/actions#secrets)."
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
   */
  "repos/create-or-update-environment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          wait_timer?: components["schemas"]["wait-timer"];
          /** @description The people or teams that may review jobs that reference the environment. You can list up to six users or teams as reviewers. The reviewers must have at least read access to the repository. Only one of the required reviewers needs to approve the job for it to proceed. */
          reviewers?:
            | {
                type?: components["schemas"]["deployment-reviewer-type"];
                /**
                 * @description The id of the user or team who can review the deployment
                 * @example 4532992
                 */
                id?: number;
              }[]
            | null;
          deployment_branch_policy?: components["schemas"]["deployment-branch-policy-settings"];
        } | null;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["environment"];
        };
      };
      /** @description Validation error when the environment name is invalid or when `protected_branches` and `custom_branch_policies` in `deployment_branch_policy` are set to the same value */
      422: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * Delete an environment
   * @description You must authenticate using an access token with the repo scope to use this endpoint.
   */
  "repos/delete-an-environment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Default response */
      204: never;
    };
  };
  /**
   * List deployment branch policies
   * @description Lists the deployment branch policies for an environment.
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "repos/list-deployment-branch-policies": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            /**
             * @description The number of deployment branch policies for the environment.
             * @example 2
             */
            total_count: number;
            branch_policies: components["schemas"]["deployment-branch-policy"][];
          };
        };
      };
    };
  };
  /**
   * Create a deployment branch policy
   * @description Creates a deployment branch policy for an environment.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
   */
  "repos/create-deployment-branch-policy": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["deployment-branch-policy-name-pattern"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment-branch-policy"];
        };
      };
      /** @description Response if the same branch name pattern already exists */
      303: never;
      /** @description Not Found or `deployment_branch_policy.custom_branch_policies` property for the environment is set to false */
      404: never;
    };
  };
  /**
   * Get a deployment branch policy
   * @description Gets a deployment branch policy for an environment.
   *
   * Anyone with read access to the repository can use this endpoint. If the repository is private, you must use an access token with the `repo` scope. GitHub Apps must have the `actions:read` permission to use this endpoint.
   */
  "repos/get-deployment-branch-policy": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
        branch_policy_id: components["parameters"]["branch-policy-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment-branch-policy"];
        };
      };
    };
  };
  /**
   * Update a deployment branch policy
   * @description Updates a deployment branch policy for an environment.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
   */
  "repos/update-deployment-branch-policy": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
        branch_policy_id: components["parameters"]["branch-policy-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["deployment-branch-policy-name-pattern"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment-branch-policy"];
        };
      };
    };
  };
  /**
   * Delete a deployment branch policy
   * @description Deletes a deployment branch policy for an environment.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `administration:write` permission for the repository to use this endpoint.
   */
  "repos/delete-deployment-branch-policy": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
        branch_policy_id: components["parameters"]["branch-policy-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get all deployment protection rules for an environment
   * @description Gets all custom deployment protection rules that are enabled for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint. For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
   *
   * For more information about the app that is providing this custom deployment rule, see the [documentation for the `GET /apps/{app_slug}` endpoint](https://docs.github.com/rest/apps/apps#get-an-app).
   */
  "repos/get-all-deployment-protection-rules": {
    parameters: {
      path: {
        environment_name: components["parameters"]["environment-name"];
        repo: components["parameters"]["repo"];
        owner: components["parameters"]["owner"];
      };
    };
    responses: {
      /** @description List of deployment protection rules */
      200: {
        content: {
          "application/json": {
            /**
             * @description The number of enabled custom deployment protection rules for this environment
             * @example 10
             */
            total_count?: number;
            custom_deployment_protection_rules?: components["schemas"]["deployment-protection-rule"][];
          };
        };
      };
    };
  };
  /**
   * Create a custom deployment protection rule on an environment
   * @description Enable a custom deployment protection rule for an environment.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. Enabling a custom protection rule requires admin or owner permissions to the repository. GitHub Apps must have the `actions:write` permission to use this endpoint.
   *
   * For more information about the app that is providing this custom deployment rule, see the [documentation for the `GET /apps/{app_slug}` endpoint](https://docs.github.com/rest/apps/apps#get-an-app).
   */
  "repos/create-deployment-protection-rule": {
    parameters: {
      path: {
        environment_name: components["parameters"]["environment-name"];
        repo: components["parameters"]["repo"];
        owner: components["parameters"]["owner"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The ID of the custom app that will be enabled on the environment. */
          integration_id?: number;
        };
      };
    };
    responses: {
      /** @description The enabled custom deployment protection rule */
      201: {
        content: {
          "application/json": components["schemas"]["deployment-protection-rule"];
        };
      };
    };
  };
  /**
   * List custom deployment rule integrations available for an environment
   * @description Gets all custom deployment protection rule integrations that are available for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint.
   *
   * For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
   *
   * For more information about the app that is providing this custom deployment rule, see "[GET an app](https://docs.github.com/rest/apps/apps#get-an-app)".
   */
  "repos/list-custom-deployment-rule-integrations": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        environment_name: components["parameters"]["environment-name"];
        repo: components["parameters"]["repo"];
        owner: components["parameters"]["owner"];
      };
    };
    responses: {
      /** @description A list of custom deployment rule integrations available for this environment. */
      200: {
        content: {
          "application/json": {
            /**
             * @description The total number of custom deployment protection rule integrations available for this environment.
             * @example 35
             */
            total_count?: number;
            available_custom_deployment_protection_rule_integrations?: components["schemas"]["custom-deployment-rule-app"][];
          };
        };
      };
    };
  };
  /**
   * Get a custom deployment protection rule
   * @description Gets an enabled custom deployment protection rule for an environment. Anyone with read access to the repository can use this endpoint. If the repository is private and you want to use a personal access token (classic), you must use an access token with the `repo` scope. GitHub Apps and fine-grained personal access tokens must have the `actions:read` permission to use this endpoint. For more information about environments, see "[Using environments for deployment](https://docs.github.com/en/actions/deployment/targeting-different-environments/using-environments-for-deployment)."
   *
   * For more information about the app that is providing this custom deployment rule, see [`GET /apps/{app_slug}`](https://docs.github.com/rest/apps/apps#get-an-app).
   */
  "repos/get-custom-deployment-protection-rule": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        environment_name: components["parameters"]["environment-name"];
        protection_rule_id: components["parameters"]["protection-rule-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deployment-protection-rule"];
        };
      };
    };
  };
  /**
   * Disable a custom protection rule for an environment
   * @description Disables a custom deployment protection rule for an environment.
   *
   * You must authenticate using an access token with the `repo` scope to use this endpoint. Removing a custom protection rule requires admin or owner permissions to the repository. GitHub Apps must have the `actions:write` permission to use this endpoint. For more information, see "[Get an app](https://docs.github.com/rest/apps/apps#get-an-app)".
   */
  "repos/disable-deployment-protection-rule": {
    parameters: {
      path: {
        environment_name: components["parameters"]["environment-name"];
        repo: components["parameters"]["repo"];
        owner: components["parameters"]["owner"];
        protection_rule_id: components["parameters"]["protection-rule-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List repository events
   * @description **Note**: This API is not built to serve real-time use cases. Depending on the time of day, event latency can be anywhere from 30s to 6h.
   */
  "activity/list-repo-events": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /** List forks */
  "repos/list-forks": {
    parameters: {
      query: {
        /** @description The sort order. `stargazers` will sort by star count. */
        sort?: "newest" | "oldest" | "stargazers" | "watchers";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      400: components["responses"]["bad_request"];
    };
  };
  /**
   * Create a fork
   * @description Create a fork for the authenticated user.
   *
   * **Note**: Forking a Repository happens asynchronously. You may have to wait a short period of time before you can access the git objects. If this takes longer than 5 minutes, be sure to contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api).
   *
   * **Note**: Although this endpoint works with GitHub Apps, the GitHub App must be installed on the destination account with access to all repositories and on the source account with access to the source repository.
   */
  "repos/create-fork": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Optional parameter to specify the organization name if forking into an organization. */
          organization?: string;
          /** @description When forking from an existing repository, a new name for the fork. */
          name?: string;
          /** @description When forking from an existing repository, fork with only the default branch. */
          default_branch_only?: boolean;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["full-repository"];
        };
      };
      400: components["responses"]["bad_request"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Create a blob */
  "git/create-blob": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The new blob's content. */
          content: string;
          /**
           * @description The encoding used for `content`. Currently, `"utf-8"` and `"base64"` are supported.
           * @default utf-8
           */
          encoding?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/example/git/blobs/3a0f86fb8db8eea7ccbb9a95f325ddbedfb25e15 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["short-blob"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a blob
   * @description The `content` in the response will always be Base64 encoded.
   *
   * _Note_: This API supports blobs up to 100 megabytes in size.
   */
  "git/get-blob": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        file_sha: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["blob"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a commit
   * @description Creates a new Git [commit object](https://git-scm.com/slider/en/v1/Git-Internals-Git-Objects#Commit-Objects).
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in the table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "git/create-commit": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The commit message */
          message: string;
          /** @description The SHA of the tree object this commit points to */
          tree: string;
          /** @description The SHAs of the commits that were the parents of this commit. If omitted or empty, the commit will be written as a root commit. For a single parent, an array of one SHA should be provided; for a merge commit, an array of more than one should be provided. */
          parents?: string[];
          /** @description Information about the author of the commit. By default, the `author` will be the authenticated user and the current date. See the `author` and `committer` object below for details. */
          author?: {
            /** @description The name of the author (or committer) of the commit */
            name: string;
            /** @description The email of the author (or committer) of the commit */
            email: string;
            /**
             * Format: date-time
             * @description Indicates when this commit was authored (or committed). This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
             */
            date?: string;
          };
          /** @description Information about the person who is making the commit. By default, `committer` will use the information set in `author`. See the `author` and `committer` object below for details. */
          committer?: {
            /** @description The name of the author (or committer) of the commit */
            name?: string;
            /** @description The email of the author (or committer) of the commit */
            email?: string;
            /**
             * Format: date-time
             * @description Indicates when this commit was authored (or committed). This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
             */
            date?: string;
          };
          /** @description The [PGP signature](https://en.wikipedia.org/wiki/Pretty_Good_Privacy) of the commit. GitHub adds the signature to the `gpgsig` header of the created commit. For a commit signature to be verifiable by Git or GitHub, it must be an ASCII-armored detached PGP signature over the string commit as it would be written to the object database. To pass a `signature` parameter, you need to first manually create a valid PGP signature, which can be complicated. You may find it easier to [use the command line](https://git-scm.com/slider/id/v2/Git-Tools-Signing-Your-Work) to create signed commits. */
          signature?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/git/commits/7638417db6d59f3c431d3e1f261cc637155684cd */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["git-commit"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a commit
   * @description Gets a Git [commit object](https://git-scm.com/slider/en/v1/Git-Internals-Git-Objects#Commit-Objects).
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in the table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "git/get-commit": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        commit_sha: components["parameters"]["commit-sha"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["git-commit"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List matching references
   * @description Returns an array of references from your Git database that match the supplied name. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't exist in the repository, but existing refs start with `:ref`, they will be returned as an array.
   *
   * When you use this endpoint without providing a `:ref`, it will return an array of all the references from your Git database, including notes and stashes if they exist on the server. Anything in the namespace is returned, not just `heads` and `tags`.
   *
   * **Note:** You need to explicitly [request a pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
   *
   * If you request matching references for a branch named `feature` but the branch `feature` doesn't exist, the response can still include other matching head refs that start with the word `feature`, such as `featureA` and `featureB`.
   */
  "git/list-matching-refs": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["git-ref"][];
        };
      };
    };
  };
  /**
   * Get a reference
   * @description Returns a single reference from your Git database. The `:ref` in the URL must be formatted as `heads/<branch name>` for branches and `tags/<tag name>` for tags. If the `:ref` doesn't match an existing ref, a `404` is returned.
   *
   * **Note:** You need to explicitly [request a pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) to trigger a test merge commit, which checks the mergeability of pull requests. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
   */
  "git/get-ref": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["git-ref"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a reference
   * @description Creates a reference for your repository. You are unable to create new references for empty repositories, even if the commit SHA-1 hash used exists. Empty repositories are repositories without branches.
   */
  "git/create-ref": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the fully qualified reference (ie: `refs/heads/master`). If it doesn't start with 'refs' and have at least two slashes, it will be rejected. */
          ref: string;
          /** @description The SHA1 value for this reference. */
          sha: string;
          /** @example "refs/heads/newbranch" */
          key?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/git/refs/heads/featureA */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["git-ref"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /** Delete a reference */
  "git/delete-ref": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description ref parameter */
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /** Update a reference */
  "git/update-ref": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /**
         * @description The name of the fully qualified reference to update. For example, `refs/heads/master`. If the value doesn't start with `refs` and have at least two slashes, it will be rejected.
         * @example refs/head/master
         */
        ref: string;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The SHA1 value to set this reference to */
          sha: string;
          /**
           * @description Indicates whether to force the update or to make sure the update is a fast-forward update. Leaving this out or setting it to `false` will make sure you're not overwriting work.
           * @default false
           */
          force?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["git-ref"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a tag object
   * @description Note that creating a tag object does not create the reference that makes a tag in Git. If you want to create an annotated tag in Git, you have to do this call to create the tag object, and then [create](https://docs.github.com/rest/reference/git#create-a-reference) the `refs/tags/[tag]` reference. If you want to create a lightweight tag, you only have to [create](https://docs.github.com/rest/reference/git#create-a-reference) the tag reference - this call would be unnecessary.
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "git/create-tag": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The tag's name. This is typically a version (e.g., "v0.0.1"). */
          tag: string;
          /** @description The tag message. */
          message: string;
          /** @description The SHA of the git object this is tagging. */
          object: string;
          /**
           * @description The type of the object we're tagging. Normally this is a `commit` but it can also be a `tree` or a `blob`.
           * @enum {string}
           */
          type: "commit" | "tree" | "blob";
          /** @description An object with information about the individual creating the tag. */
          tagger?: {
            /** @description The name of the author of the tag */
            name: string;
            /** @description The email of the author of the tag */
            email: string;
            /**
             * Format: date-time
             * @description When this object was tagged. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
             */
            date?: string;
          };
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/git/tags/940bd336248efae0f9ee5bc7b2d5c985887b16ac */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["git-tag"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a tag
   * @description **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on their account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "git/get-tag": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        tag_sha: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["git-tag"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a tree
   * @description The tree creation API accepts nested entries. If you specify both a tree and a nested path modifying that tree, this endpoint will overwrite the contents of the tree with the new path contents, and create a new tree structure.
   *
   * If you use this endpoint to add, delete, or modify the file contents in a tree, you will need to commit the tree and then update a branch to point to the commit. For more information see "[Create a commit](https://docs.github.com/rest/reference/git#create-a-commit)" and "[Update a reference](https://docs.github.com/rest/reference/git#update-a-reference)."
   *
   * Returns an error if you try to delete a file that does not exist.
   */
  "git/create-tree": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Objects (of `path`, `mode`, `type`, and `sha`) specifying a tree structure. */
          tree: {
            /** @description The file referenced in the tree. */
            path?: string;
            /**
             * @description The file mode; one of `100644` for file (blob), `100755` for executable (blob), `040000` for subdirectory (tree), `160000` for submodule (commit), or `120000` for a blob that specifies the path of a symlink.
             * @enum {string}
             */
            mode?: "100644" | "100755" | "040000" | "160000" | "120000";
            /**
             * @description Either `blob`, `tree`, or `commit`.
             * @enum {string}
             */
            type?: "blob" | "tree" | "commit";
            /**
             * @description The SHA1 checksum ID of the object in the tree. Also called `tree.sha`. If the value is `null` then the file will be deleted.
             *
             * **Note:** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
             */
            sha?: string | null;
            /**
             * @description The content you want this file to have. GitHub will write this blob out and use that SHA for this entry. Use either this, or `tree.sha`.
             *
             * **Note:** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
             */
            content?: string;
          }[];
          /**
           * @description The SHA1 of an existing Git tree object which will be used as the base for the new tree. If provided, a new Git tree object will be created from entries in the Git tree object pointed to by `base_tree` and entries defined in the `tree` parameter. Entries defined in the `tree` parameter will overwrite items from `base_tree` with the same `path`. If you're creating new changes on a branch, then normally you'd set `base_tree` to the SHA1 of the Git tree object of the current latest commit on the branch you're working on.
           * If not provided, GitHub will create a new Git tree object from only the entries defined in the `tree` parameter. If you create a new commit pointing to such a tree, then all files which were a part of the parent commit's tree and were not defined in the `tree` parameter will be listed as deleted by the new commit.
           */
          base_tree?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/trees/cd8274d15fa3ae2ab983129fb037999f264ba9a7 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["git-tree"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a tree
   * @description Returns a single tree using the SHA1 value for that tree.
   *
   * If `truncated` is `true` in the response then the number of items in the `tree` array exceeded our maximum limit. If you need to fetch more items, use the non-recursive method of fetching trees, and fetch one sub-tree at a time.
   *
   *
   * **Note**: The limit for the `tree` array is 100,000 entries with a maximum size of 7 MB when using the `recursive` parameter.
   */
  "git/get-tree": {
    parameters: {
      query: {
        /** @description Setting this parameter to any value returns the objects or subtrees referenced by the tree specified in `:tree_sha`. For example, setting `recursive` to any of the following will enable returning objects or subtrees: `0`, `1`, `"true"`, and `"false"`. Omit this parameter to prevent recursively returning objects or subtrees. */
        recursive?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        tree_sha: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["git-tree"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List repository webhooks
   * @description Lists webhooks for a repository. `last response` may return null if there have not been any deliveries within 30 days.
   */
  "repos/list-webhooks": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["hook"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a repository webhook
   * @description Repositories can have multiple webhooks installed. Each webhook should have a unique `config`. Multiple webhooks can
   * share the same `config` as long as those webhooks do not have any `events` that overlap.
   */
  "repos/create-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Use `web` to create a webhook. Default: `web`. This parameter only accepts the value `web`. */
          name?: string;
          /** @description Key/value pairs to provide settings for this webhook. [These are defined below](https://docs.github.com/rest/reference/repos#create-hook-config-params). */
          config?: {
            url?: components["schemas"]["webhook-config-url"];
            content_type?: components["schemas"]["webhook-config-content-type"];
            secret?: components["schemas"]["webhook-config-secret"];
            insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
            /** @example "abc" */
            token?: string;
            /** @example "sha256" */
            digest?: string;
          };
          /**
           * @description Determines what [events](https://docs.github.com/webhooks/event-payloads) the hook is triggered for.
           * @default [
           *   "push"
           * ]
           */
          events?: string[];
          /**
           * @description Determines if notifications are sent when the webhook is triggered. Set to `true` to send notifications.
           * @default true
           */
          active?: boolean;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/hooks/12345678 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["hook"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a repository webhook
   * @description Returns a webhook configured in a repository. To get only the webhook `config` properties, see "[Get a webhook configuration for a repository](/rest/reference/repos#get-a-webhook-configuration-for-a-repository)."
   */
  "repos/get-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a repository webhook */
  "repos/delete-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a repository webhook
   * @description Updates a webhook configured in a repository. If you previously had a `secret` set, you must provide the same `secret` or set a new `secret` or the secret will be removed. If you are only updating individual webhook `config` properties, use "[Update a webhook configuration for a repository](/rest/reference/repos#update-a-webhook-configuration-for-a-repository)."
   */
  "repos/update-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Key/value pairs to provide settings for this webhook. [These are defined below](https://docs.github.com/rest/reference/repos#create-hook-config-params). */
          config?: {
            url: components["schemas"]["webhook-config-url"];
            content_type?: components["schemas"]["webhook-config-content-type"];
            secret?: components["schemas"]["webhook-config-secret"];
            insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
            /** @example "bar@example.com" */
            address?: string;
            /** @example "The Serious Room" */
            room?: string;
          };
          /**
           * @description Determines what [events](https://docs.github.com/webhooks/event-payloads) the hook is triggered for. This replaces the entire array of events.
           * @default [
           *   "push"
           * ]
           */
          events?: string[];
          /** @description Determines a list of events to be added to the list of events that the Hook triggers for. */
          add_events?: string[];
          /** @description Determines a list of events to be removed from the list of events that the Hook triggers for. */
          remove_events?: string[];
          /**
           * @description Determines if notifications are sent when the webhook is triggered. Set to `true` to send notifications.
           * @default true
           */
          active?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a webhook configuration for a repository
   * @description Returns the webhook configuration for a repository. To get more information about the webhook, including the `active` state and `events`, use "[Get a repository webhook](/rest/reference/orgs#get-a-repository-webhook)."
   *
   * Access tokens must have the `read:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:read` permission.
   */
  "repos/get-webhook-config-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * Update a webhook configuration for a repository
   * @description Updates the webhook configuration for a repository. To update more information about the webhook, including the `active` state and `events`, use "[Update a repository webhook](/rest/reference/orgs#update-a-repository-webhook)."
   *
   * Access tokens must have the `write:repo_hook` or `repo` scope, and GitHub Apps must have the `repository_hooks:write` permission.
   */
  "repos/update-webhook-config-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          url?: components["schemas"]["webhook-config-url"];
          content_type?: components["schemas"]["webhook-config-content-type"];
          secret?: components["schemas"]["webhook-config-secret"];
          insecure_ssl?: components["schemas"]["webhook-config-insecure-ssl"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["webhook-config"];
        };
      };
    };
  };
  /**
   * List deliveries for a repository webhook
   * @description Returns a list of webhook deliveries for a webhook configured in a repository.
   */
  "repos/list-webhook-deliveries": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        cursor?: components["parameters"]["cursor"];
        redelivery?: boolean;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery-item"][];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a delivery for a repository webhook
   * @description Returns a delivery for a webhook configured in a repository.
   */
  "repos/get-webhook-delivery": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hook-delivery"];
        };
      };
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Redeliver a delivery for a repository webhook
   * @description Redeliver a webhook delivery for a webhook configured in a repository.
   */
  "repos/redeliver-webhook-delivery": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
        delivery_id: components["parameters"]["delivery-id"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      400: components["responses"]["bad_request"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Ping a repository webhook
   * @description This will trigger a [ping event](https://docs.github.com/webhooks/#ping-event) to be sent to the hook.
   */
  "repos/ping-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Test the push repository webhook
   * @description This will trigger the hook with the latest push to the current repository if the hook is subscribed to `push` events. If the hook is not subscribed to `push` events, the server will respond with 204 but no test POST will be generated.
   *
   * **Note**: Previously `/repos/:owner/:repo/hooks/:hook_id/test`
   */
  "repos/test-push-webhook": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        hook_id: components["parameters"]["hook-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get an import status
   * @description View the progress of an import.
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   *
   * **Import status**
   *
   * This section includes details about the possible values of the `status` field of the Import Progress response.
   *
   * An import that does not have errors will progress through these steps:
   *
   * *   `detecting` - the "detection" step of the import is in progress because the request did not include a `vcs` parameter. The import is identifying the type of source control present at the URL.
   * *   `importing` - the "raw" step of the import is in progress. This is where commit data is fetched from the original repository. The import progress response will include `commit_count` (the total number of raw commits that will be imported) and `percent` (0 - 100, the current progress through the import).
   * *   `mapping` - the "rewrite" step of the import is in progress. This is where SVN branches are converted to Git branches, and where author updates are applied. The import progress response does not include progress information.
   * *   `pushing` - the "push" step of the import is in progress. This is where the importer updates the repository on GitHub. The import progress response will include `push_percent`, which is the percent value reported by `git push` when it is "Writing objects".
   * *   `complete` - the import is complete, and the repository is ready on GitHub.
   *
   * If there are problems, you will see one of these in the `status` field:
   *
   * *   `auth_failed` - the import requires authentication in order to connect to the original repository. To update authentication for the import, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
   * *   `error` - the import encountered an error. The import progress response will include the `failed_step` and an error message. Contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api) for more information.
   * *   `detection_needs_auth` - the importer requires authentication for the originating repository to continue detection. To update authentication for the import, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
   * *   `detection_found_nothing` - the importer didn't recognize any source control at the URL. To resolve, [Cancel the import](https://docs.github.com/rest/migrations/source-imports#cancel-an-import) and [retry](https://docs.github.com/rest/migrations/source-imports#start-an-import) with the correct URL.
   * *   `detection_found_multiple` - the importer found several projects or repositories at the provided URL. When this is the case, the Import Progress response will also include a `project_choices` field with the possible project choices as values. To update project choice, please see the [Update an import](https://docs.github.com/rest/migrations/source-imports#update-an-import) section.
   *
   * **The project_choices field**
   *
   * When multiple projects are found at the provided URL, the response hash will include a `project_choices` field, the value of which is an array of hashes each representing a project choice. The exact key/value pairs of the project hashes will differ depending on the version control type.
   *
   * **Git LFS related fields**
   *
   * This section includes details about Git LFS related fields that may be present in the Import Progress response.
   *
   * *   `use_lfs` - describes whether the import has been opted in or out of using Git LFS. The value can be `opt_in`, `opt_out`, or `undecided` if no action has been taken.
   * *   `has_large_files` - the boolean value describing whether files larger than 100MB were found during the `importing` step.
   * *   `large_files_size` - the total size in gigabytes of files larger than 100MB found in the originating repository.
   * *   `large_files_count` - the total number of files larger than 100MB found in the originating repository. To see a list of these files, make a "Get Large Files" request.
   */
  "migrations/get-import-status": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["import"];
        };
      };
      404: components["responses"]["not_found"];
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Start an import
   * @description Start a source import to a GitHub repository using GitHub Importer. Importing into a GitHub repository with GitHub Actions enabled is not supported and will return a status `422 Unprocessable Entity` response.
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/start-import": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The URL of the originating repository. */
          vcs_url: string;
          /**
           * @description The originating VCS type. Without this parameter, the import job will take additional time to detect the VCS type before beginning the import. This detection step will be reflected in the response.
           * @enum {string}
           */
          vcs?: "subversion" | "git" | "mercurial" | "tfvc";
          /** @description If authentication is required, the username to provide to `vcs_url`. */
          vcs_username?: string;
          /** @description If authentication is required, the password to provide to `vcs_url`. */
          vcs_password?: string;
          /** @description For a tfvc import, the name of the project that is being imported. */
          tfvc_project?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/spraints/socm/import */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["import"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Cancel an import
   * @description Stop an import for a repository.
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/cancel-import": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Update an import
   * @description An import can be updated with credentials or a project choice by passing in the appropriate parameters in this API
   * request. If no parameters are provided, the import will be restarted.
   *
   * Some servers (e.g. TFS servers) can have several projects at a single URL. In those cases the import progress will
   * have the status `detection_found_multiple` and the Import Progress response will include a `project_choices` array.
   * You can select the project to import by providing one of the objects in the `project_choices` array in the update request.
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/update-import": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The username to provide to the originating repository. */
          vcs_username?: string;
          /** @description The password to provide to the originating repository. */
          vcs_password?: string;
          /**
           * @description The type of version control system you are migrating from.
           * @example "git"
           * @enum {string}
           */
          vcs?: "subversion" | "tfvc" | "git" | "mercurial";
          /**
           * @description For a tfvc import, the name of the project that is being imported.
           * @example "project1"
           */
          tfvc_project?: string;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["import"];
        };
      };
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Get commit authors
   * @description Each type of source control system represents authors in a different way. For example, a Git commit author has a display name and an email address, but a Subversion commit author just has a username. The GitHub Importer will make the author information valid, but the author might not be correct. For example, it will change the bare Subversion username `hubot` into something like `hubot <hubot@12341234-abab-fefe-8787-fedcba987654>`.
   *
   * This endpoint and the [Map a commit author](https://docs.github.com/rest/migrations/source-imports#map-a-commit-author) endpoint allow you to provide correct Git author information.
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/get-commit-authors": {
    parameters: {
      query: {
        since?: components["parameters"]["since-user"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["porter-author"][];
        };
      };
      404: components["responses"]["not_found"];
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Map a commit author
   * @description Update an author's identity for the import. Your application can continue updating authors any time before you push
   * new commits to the repository.
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/map-commit-author": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        author_id: number;
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The new Git author email. */
          email?: string;
          /** @description The new Git author name. */
          name?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["porter-author"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Get large files
   * @description List files larger than 100MB found during the import
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/get-large-files": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["porter-large-file"][];
        };
      };
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Update Git LFS preference
   * @description You can import repositories from Subversion, Mercurial, and TFS that include files larger than 100MB. This ability
   * is powered by [Git LFS](https://git-lfs.com).
   *
   * You can learn more about our LFS feature and working with large files [on our help
   * site](https://docs.github.com/repositories/working-with-files/managing-large-files).
   *
   * **Warning:** Support for importing Mercurial, Subversion and Team Foundation Version Control repositories will end
   * on October 17, 2023. For more details, see [changelog](https://gh.io/github-importer-non-git-eol). In the coming weeks, we will update
   * these docs to reflect relevant changes to the API and will contact all integrators using the "Source imports" API.
   */
  "migrations/set-lfs-preference": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Whether to store large files during the import. `opt_in` means large files will be stored using Git LFS. `opt_out` means large files will be removed during the import.
           * @enum {string}
           */
          use_lfs: "opt_in" | "opt_out";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["import"];
        };
      };
      422: components["responses"]["validation_failed"];
      503: components["responses"]["porter_maintenance"];
    };
  };
  /**
   * Get a repository installation for the authenticated app
   * @description Enables an authenticated GitHub App to find the repository's installation information. The installation's account type will be either an organization or a user account, depending which account the repository belongs to.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-repo-installation": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["installation"];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get interaction restrictions for a repository
   * @description Shows which type of GitHub user can interact with this repository and when the restriction expires. If there are no restrictions, you will see an empty response.
   */
  "interactions/get-restrictions-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json":
            | components["schemas"]["interaction-limit-response"]
            | Record<string, never>;
        };
      };
    };
  };
  /**
   * Set interaction restrictions for a repository
   * @description Temporarily restricts interactions to a certain type of GitHub user within the given repository. You must have owner or admin access to set these restrictions. If an interaction limit is set for the user or organization that owns this repository, you will receive a `409 Conflict` response and will not be able to use this endpoint to change the interaction limit for a single repository.
   */
  "interactions/set-restrictions-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["interaction-limit"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["interaction-limit-response"];
        };
      };
      /** @description Response */
      409: never;
    };
  };
  /**
   * Remove interaction restrictions for a repository
   * @description Removes all interaction restrictions from the given repository. You must have owner or admin access to remove restrictions. If the interaction limit is set for the user or organization that owns this repository, you will receive a `409 Conflict` response and will not be able to use this endpoint to change the interaction limit for a single repository.
   */
  "interactions/remove-restrictions-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Response */
      409: never;
    };
  };
  /**
   * List repository invitations
   * @description When authenticating as a user with admin rights to a repository, this endpoint will list all currently open repository invitations.
   */
  "repos/list-invitations": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["repository-invitation"][];
        };
      };
    };
  };
  /** Delete a repository invitation */
  "repos/delete-invitation": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** Update a repository invitation */
  "repos/update-invitation": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permissions that the associated user will have on the repository. Valid values are `read`, `write`, `maintain`, `triage`, and `admin`.
           * @enum {string}
           */
          permissions?: "read" | "write" | "maintain" | "triage" | "admin";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-invitation"];
        };
      };
    };
  };
  /**
   * List repository issues
   * @description List issues in a repository. Only open issues will be listed.
   *
   * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
   * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
   * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
   * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
   */
  "issues/list-for-repo": {
    parameters: {
      query: {
        /** @description If an `integer` is passed, it should refer to a milestone by its `number` field. If the string `*` is passed, issues with any milestone are accepted. If the string `none` is passed, issues without milestones are returned. */
        milestone?: string;
        /** @description Indicates the state of the issues to return. */
        state?: "open" | "closed" | "all";
        /** @description Can be the name of a user. Pass in `none` for issues with no assigned user, and `*` for issues assigned to any user. */
        assignee?: string;
        /** @description The user that created the issue. */
        creator?: string;
        /** @description A user that's mentioned in the issue. */
        mentioned?: string;
        labels?: components["parameters"]["labels"];
        /** @description What to sort results by. */
        sort?: "created" | "updated" | "comments";
        direction?: components["parameters"]["direction"];
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create an issue
   * @description Any user with pull access to a repository can create an issue. If [issues are disabled in the repository](https://docs.github.com/articles/disabling-issues/), the API returns a `410 Gone` status.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "issues/create": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The title of the issue. */
          title: string | number;
          /** @description The contents of the issue. */
          body?: string;
          /** @description Login for the user that this issue should be assigned to. _NOTE: Only users with push access can set the assignee for new issues. The assignee is silently dropped otherwise. **This field is deprecated.**_ */
          assignee?: string | null;
          milestone?: string | number;
          /** @description Labels to associate with this issue. _NOTE: Only users with push access can set labels for new issues. Labels are silently dropped otherwise._ */
          labels?: OneOf<
            [
              string,
              {
                id?: number;
                name?: string;
                description?: string | null;
                color?: string | null;
              }
            ]
          >[];
          /** @description Logins for Users to assign to this issue. _NOTE: Only users with push access can set assignees for new issues. Assignees are silently dropped otherwise._ */
          assignees?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/issues/1347 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["issue"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List issue comments for a repository
   * @description You can use the REST API to list comments on issues and pull requests for a repository. Every pull request is an issue, but not every issue is a pull request.
   *
   * By default, issue comments are ordered by ascending ID.
   */
  "issues/list-comments-for-repo": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort"];
        /** @description Either `asc` or `desc`. Ignored without the `sort` parameter. */
        direction?: "asc" | "desc";
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue-comment"][];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an issue comment
   * @description You can use the REST API to get comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
   */
  "issues/get-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an issue comment
   * @description You can use the REST API to delete comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
   */
  "issues/delete-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update an issue comment
   * @description You can use the REST API to update comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
   */
  "issues/update-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The contents of the comment. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue-comment"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List reactions for an issue comment
   * @description List the reactions to an [issue comment](https://docs.github.com/rest/reference/issues#comments).
   */
  "reactions/list-for-issue-comment": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to an issue comment. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create reaction for an issue comment
   * @description Create a reaction to an [issue comment](https://docs.github.com/rest/reference/issues#comments). A response with an HTTP `200` status means that you already added the reaction type to this issue comment.
   */
  "reactions/create-for-issue-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the issue comment.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Reaction exists */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Reaction created */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete an issue comment reaction
   * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE delete /repositories/:repository_id/issues/comments/:comment_id/reactions/:reaction_id`.
   *
   * Delete a reaction to an [issue comment](https://docs.github.com/rest/reference/issues#comments).
   */
  "reactions/delete-for-issue-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** List issue events for a repository */
  "issues/list-events-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue-event"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get an issue event */
  "issues/get-event": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        event_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue-event"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Get an issue
   * @description The API returns a [`301 Moved Permanently` status](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-redirects-redirects) if the issue was
   * [transferred](https://docs.github.com/articles/transferring-an-issue-to-another-repository/) to another repository. If
   * the issue was transferred to or deleted from a repository where the authenticated user lacks read access, the API
   * returns a `404 Not Found` status. If the issue was deleted from a repository where the authenticated user has read
   * access, the API returns a `410 Gone` status. To receive webhook events for transferred and deleted issues, subscribe
   * to the [`issues`](https://docs.github.com/webhooks/event-payloads/#issues) webhook.
   *
   * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
   * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
   * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
   * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
   */
  "issues/get": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue"];
        };
      };
      301: components["responses"]["moved_permanently"];
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Update an issue
   * @description Issue owners and users with push access can edit an issue.
   */
  "issues/update": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The title of the issue. */
          title?: string | number;
          /** @description The contents of the issue. */
          body?: string | null;
          /** @description Username to assign to this issue. **This field is deprecated.** */
          assignee?: string | null;
          /**
           * @description The open or closed state of the issue.
           * @enum {string}
           */
          state?: "open" | "closed";
          /**
           * @description The reason for the state change. Ignored unless `state` is changed.
           * @example not_planned
           * @enum {string|null}
           */
          state_reason?: "completed" | "not_planned" | "reopened" | null;
          milestone?: string | number;
          /** @description Labels to associate with this issue. Pass one or more labels to _replace_ the set of labels on this issue. Send an empty array (`[]`) to clear all labels from the issue. Only users with push access can set labels for issues. Without push access to the repository, label changes are silently dropped. */
          labels?: OneOf<
            [
              string,
              {
                id?: number;
                name?: string;
                description?: string | null;
                color?: string | null;
              }
            ]
          >[];
          /** @description Usernames to assign to this issue. Pass one or more user logins to _replace_ the set of assignees on this issue. Send an empty array (`[]`) to clear all assignees from the issue. Only users with push access can set assignees for new issues. Without push access to the repository, assignee changes are silently dropped. */
          assignees?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue"];
        };
      };
      301: components["responses"]["moved_permanently"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Add assignees to an issue
   * @description Adds up to 10 assignees to an issue. Users already assigned to an issue are not replaced.
   */
  "issues/add-assignees": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Usernames of people to assign this issue to. _NOTE: Only users with push access can add assignees to an issue. Assignees are silently ignored otherwise._ */
          assignees?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["issue"];
        };
      };
    };
  };
  /**
   * Remove assignees from an issue
   * @description Removes one or more assignees from an issue.
   */
  "issues/remove-assignees": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Usernames of assignees to remove from an issue. _NOTE: Only users with push access can remove assignees from an issue. Assignees are silently ignored otherwise._ */
          assignees: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["issue"];
        };
      };
    };
  };
  /**
   * Check if a user can be assigned to a issue
   * @description Checks if a user has permission to be assigned to a specific issue.
   *
   * If the `assignee` can be assigned to this issue, a `204` status code with no content is returned.
   *
   * Otherwise a `404` status code is returned.
   */
  "issues/check-user-can-be-assigned-to-issue": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
        assignee: string;
      };
    };
    responses: {
      /** @description Response if `assignee` can be assigned to `issue_number` */
      204: never;
      /** @description Response if `assignee` can not be assigned to `issue_number` */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * List issue comments
   * @description You can use the REST API to list comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
   *
   * Issue comments are ordered by ascending ID.
   */
  "issues/list-comments": {
    parameters: {
      query: {
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue-comment"][];
        };
      };
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Create an issue comment
   * @description
   * You can use the REST API to create comments on issues and pull requests. Every pull request is an issue, but not every issue is a pull request.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications).
   * Creating content too quickly using this endpoint may result in secondary rate limiting.
   * See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)"
   * and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)"
   * for details.
   */
  "issues/create-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The contents of the comment. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/issues/comments/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["issue-comment"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** List issue events */
  "issues/list-events": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue-event-for-issue"][];
        };
      };
      410: components["responses"]["gone"];
    };
  };
  /** List labels for an issue */
  "issues/list-labels-on-issue": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Set labels for an issue
   * @description Removes any previous labels and sets the new labels for an issue.
   */
  "issues/set-labels": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": OneOf<
          [
            {
              /** @description The names of the labels to set for the issue. The labels you set replace any existing labels. You can pass an empty array to remove all labels. Alternatively, you can pass a single label as a `string` or an `array` of labels directly, but GitHub recommends passing an object with the `labels` key. You can also add labels to the existing labels for an issue. For more information, see "[Add labels to an issue](https://docs.github.com/rest/reference/issues#add-labels-to-an-issue)." */
              labels?: string[];
            },
            {
              labels?: {
                name: string;
              }[];
            }
          ]
        >;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Add labels to an issue */
  "issues/add-labels": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": OneOf<
          [
            {
              /** @description The names of the labels to add to the issue's existing labels. You can pass an empty array to remove all labels. Alternatively, you can pass a single label as a `string` or an `array` of labels directly, but GitHub recommends passing an object with the `labels` key. You can also replace all of the labels for an issue. For more information, see "[Set labels for an issue](https://docs.github.com/rest/reference/issues#set-labels-for-an-issue)." */
              labels?: string[];
            },
            {
              labels?: {
                name: string;
              }[];
            }
          ]
        >;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Remove all labels from an issue */
  "issues/remove-all-labels": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Remove a label from an issue
   * @description Removes the specified label from the issue, and returns the remaining labels on the issue. This endpoint returns a `404 Not Found` status if the label does not exist.
   */
  "issues/remove-label": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
        name: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
      301: components["responses"]["moved_permanently"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Lock an issue
   * @description Users with push access can lock an issue or pull request's conversation.
   *
   * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "issues/lock": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The reason for locking the issue or pull request conversation. Lock will fail if you don't use one of these reasons:
           *  * `off-topic`
           *  * `too heated`
           *  * `resolved`
           *  * `spam`
           * @enum {string}
           */
          lock_reason?: "off-topic" | "too heated" | "resolved" | "spam";
        } | null;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Unlock an issue
   * @description Users with push access can unlock an issue's conversation.
   */
  "issues/unlock": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List reactions for an issue
   * @description List the reactions to an [issue](https://docs.github.com/rest/reference/issues).
   */
  "reactions/list-for-issue": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to an issue. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /**
   * Create reaction for an issue
   * @description Create a reaction to an [issue](https://docs.github.com/rest/reference/issues/). A response with an HTTP `200` status means that you already added the reaction type to this issue.
   */
  "reactions/create-for-issue": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the issue.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete an issue reaction
   * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/issues/:issue_number/reactions/:reaction_id`.
   *
   * Delete a reaction to an [issue](https://docs.github.com/rest/reference/issues/).
   */
  "reactions/delete-for-issue": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** List timeline events for an issue */
  "issues/list-events-for-timeline": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        issue_number: components["parameters"]["issue-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["timeline-issue-events"][];
        };
      };
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
    };
  };
  /** List deploy keys */
  "repos/list-deploy-keys": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["deploy-key"][];
        };
      };
    };
  };
  /**
   * Create a deploy key
   * @description You can create a read-only deploy key.
   */
  "repos/create-deploy-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description A name for the key. */
          title?: string;
          /** @description The contents of the key. */
          key: string;
          /**
           * @description If `true`, the key will only be able to read repository contents. Otherwise, the key will be able to read and write.
           *
           * Deploy keys with write access can perform the same actions as an organization member with admin access, or a collaborator on a personal repository. For more information, see "[Repository permission levels for an organization](https://docs.github.com/articles/repository-permission-levels-for-an-organization/)" and "[Permission levels for a user account repository](https://docs.github.com/articles/permission-levels-for-a-user-account-repository/)."
           */
          read_only?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/keys/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["deploy-key"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get a deploy key */
  "repos/get-deploy-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        key_id: components["parameters"]["key-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["deploy-key"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a deploy key
   * @description Deploy keys are immutable. If you need to update a key, remove the key and create a new one instead.
   */
  "repos/delete-deploy-key": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        key_id: components["parameters"]["key-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** List labels for a repository */
  "issues/list-labels-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Create a label */
  "issues/create-label": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the label. Emoji can be added to label names, using either native emoji or colon-style markup. For example, typing `:strawberry:` will render the emoji ![:strawberry:](https://github.githubassets.com/images/icons/emoji/unicode/1f353.png ":strawberry:"). For a full list of available emoji and codes, see "[Emoji cheat sheet](https://github.com/ikatyang/emoji-cheat-sheet)." */
          name: string;
          /** @description The [hexadecimal color code](http://www.color-hex.com/) for the label, without the leading `#`. */
          color?: string;
          /** @description A short description of the label. Must be 100 characters or fewer. */
          description?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/labels/bug */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["label"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get a label */
  "issues/get-label": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["label"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a label */
  "issues/delete-label": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: string;
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** Update a label */
  "issues/update-label": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        name: string;
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The new name of the label. Emoji can be added to label names, using either native emoji or colon-style markup. For example, typing `:strawberry:` will render the emoji ![:strawberry:](https://github.githubassets.com/images/icons/emoji/unicode/1f353.png ":strawberry:"). For a full list of available emoji and codes, see "[Emoji cheat sheet](https://github.com/ikatyang/emoji-cheat-sheet)." */
          new_name?: string;
          /** @description The [hexadecimal color code](http://www.color-hex.com/) for the label, without the leading `#`. */
          color?: string;
          /** @description A short description of the label. Must be 100 characters or fewer. */
          description?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["label"];
        };
      };
    };
  };
  /**
   * List repository languages
   * @description Lists languages for the specified repository. The value shown for each language is the number of bytes of code written in that language.
   */
  "repos/list-languages": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["language"];
        };
      };
    };
  };
  /**
   * Enable Git LFS for a repository
   * @description Enables Git LFS for a repository. Access tokens must have the `admin:enterprise` scope.
   */
  "repos/enable-lfs-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      /**
       * @description We will return a 403 with one of the following messages:
       *
       * - Git LFS support not enabled because Git LFS is globally disabled.
       * - Git LFS support not enabled because Git LFS is disabled for the root repository in the network.
       * - Git LFS support not enabled because Git LFS is disabled for <owner>.
       */
      403: never;
    };
  };
  /**
   * Disable Git LFS for a repository
   * @description Disables Git LFS for a repository. Access tokens must have the `admin:enterprise` scope.
   */
  "repos/disable-lfs-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get the license for a repository
   * @description This method returns the contents of the repository's license file, if one is detected.
   *
   * Similar to [Get repository content](https://docs.github.com/rest/reference/repos#get-repository-content), this method also supports [custom media types](https://docs.github.com/rest/overview/media-types) for retrieving the raw license content or rendered license HTML.
   */
  "licenses/get-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["license-content"];
        };
      };
    };
  };
  /**
   * Sync a fork branch with the upstream repository
   * @description Sync a branch of a forked repository to keep it up-to-date with the upstream repository.
   */
  "repos/merge-upstream": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the branch which should be updated to match upstream. */
          branch: string;
        };
      };
    };
    responses: {
      /** @description The branch has been successfully synced with the upstream repository */
      200: {
        content: {
          "application/json": components["schemas"]["merged-upstream"];
        };
      };
      /** @description The branch could not be synced because of a merge conflict */
      409: never;
      /** @description The branch could not be synced for some other reason */
      422: never;
    };
  };
  /** Merge a branch */
  "repos/merge": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the base branch that the head will be merged into. */
          base: string;
          /** @description The head to merge. This can be a branch name or a commit SHA1. */
          head: string;
          /** @description Commit message to use for the merge commit. If omitted, a default message will be used. */
          commit_message?: string;
        };
      };
    };
    responses: {
      /** @description Successful Response (The resulting merge commit) */
      201: {
        content: {
          "application/json": components["schemas"]["commit"];
        };
      };
      /** @description Response when already merged */
      204: never;
      403: components["responses"]["forbidden"];
      /** @description Not Found when the base or head does not exist */
      404: never;
      /** @description Conflict when there is a merge conflict */
      409: never;
      422: components["responses"]["validation_failed"];
    };
  };
  /** List milestones */
  "issues/list-milestones": {
    parameters: {
      query: {
        /** @description The state of the milestone. Either `open`, `closed`, or `all`. */
        state?: "open" | "closed" | "all";
        /** @description What to sort results by. Either `due_on` or `completeness`. */
        sort?: "due_on" | "completeness";
        /** @description The direction of the sort. Either `asc` or `desc`. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["milestone"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Create a milestone */
  "issues/create-milestone": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The title of the milestone. */
          title: string;
          /**
           * @description The state of the milestone. Either `open` or `closed`.
           * @default open
           * @enum {string}
           */
          state?: "open" | "closed";
          /** @description A description of the milestone. */
          description?: string;
          /**
           * Format: date-time
           * @description The milestone due date. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
           */
          due_on?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/milestones/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["milestone"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get a milestone */
  "issues/get-milestone": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        milestone_number: components["parameters"]["milestone-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["milestone"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a milestone */
  "issues/delete-milestone": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        milestone_number: components["parameters"]["milestone-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /** Update a milestone */
  "issues/update-milestone": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        milestone_number: components["parameters"]["milestone-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The title of the milestone. */
          title?: string;
          /**
           * @description The state of the milestone. Either `open` or `closed`.
           * @default open
           * @enum {string}
           */
          state?: "open" | "closed";
          /** @description A description of the milestone. */
          description?: string;
          /**
           * Format: date-time
           * @description The milestone due date. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`.
           */
          due_on?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["milestone"];
        };
      };
    };
  };
  /** List labels for issues in a milestone */
  "issues/list-labels-for-milestone": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        milestone_number: components["parameters"]["milestone-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["label"][];
        };
      };
    };
  };
  /**
   * List repository notifications for the authenticated user
   * @description Lists all notifications for the current user in the specified repository.
   */
  "activity/list-repo-notifications-for-authenticated-user": {
    parameters: {
      query: {
        all?: components["parameters"]["all"];
        participating?: components["parameters"]["participating"];
        since?: components["parameters"]["since"];
        before?: components["parameters"]["before"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["thread"][];
        };
      };
    };
  };
  /**
   * Mark repository notifications as read
   * @description Marks all notifications in a repository as "read" for the current user. If the number of notifications is too large to complete in one request, you will receive a `202 Accepted` status and GitHub will run an asynchronous process to mark notifications as "read." To check whether any "unread" notifications remain, you can use the [List repository notifications for the authenticated user](https://docs.github.com/rest/reference/activity#list-repository-notifications-for-the-authenticated-user) endpoint and pass the query parameter `all=false`.
   */
  "activity/mark-repo-notifications-as-read": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * Format: date-time
           * @description Describes the last point that notifications were checked. Anything updated since this time will not be marked as read. If you omit this parameter, all notifications are marked as read. This is a timestamp in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format: `YYYY-MM-DDTHH:MM:SSZ`. Default: The current timestamp.
           */
          last_read_at?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": {
            message?: string;
            url?: string;
          };
        };
      };
      /** @description Reset Content */
      205: never;
    };
  };
  /** Get a GitHub Pages site */
  "repos/get-pages": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["page"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update information about a GitHub Pages site
   * @description Updates information for a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages).
   *
   * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
   */
  "repos/update-information-about-pages-site": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Specify a custom domain for the repository. Sending a `null` value will remove the custom domain. For more about custom domains, see "[Using a custom domain with GitHub Pages](https://docs.github.com/articles/using-a-custom-domain-with-github-pages/)." */
          cname?: string | null;
          /** @description Specify whether HTTPS should be enforced for the repository. */
          https_enforced?: boolean;
          /**
           * @description The process by which the GitHub Pages site will be built. `workflow` means that the site is built by a custom GitHub Actions workflow. `legacy` means that the site is built by GitHub when changes are pushed to a specific branch.
           * @enum {string}
           */
          build_type?: "legacy" | "workflow";
          source?:
            | ("gh-pages" | "master" | "master /docs")
            | {
                /** @description The repository branch used to publish your site's source files. */
                branch: string;
                /**
                 * @description The repository directory that includes the source files for the Pages site. Allowed paths are `/` or `/docs`.
                 * @enum {string}
                 */
                path: "/" | "/docs";
              };
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      400: components["responses"]["bad_request"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a GitHub Pages site
   * @description Configures a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages)."
   *
   * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
   */
  "repos/create-pages-site": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The process in which the Page will be built. Possible values are `"legacy"` and `"workflow"`.
           * @enum {string}
           */
          build_type?: "legacy" | "workflow";
          /** @description The source branch and directory used to publish your Pages site. */
          source?: {
            /** @description The repository branch used to publish your site's source files. */
            branch: string;
            /**
             * @description The repository directory that includes the source files for the Pages site. Allowed paths are `/` or `/docs`. Default: `/`
             * @default /
             * @enum {string}
             */
            path?: "/" | "/docs";
          };
        } | null;
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["page"];
        };
      };
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a GitHub Pages site
   * @description Deletes a GitHub Pages site. For more information, see "[About GitHub Pages](/github/working-with-github-pages/about-github-pages).
   *
   * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administration:write` and `pages:write` permissions.
   */
  "repos/delete-pages-site": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** List GitHub Pages builds */
  "repos/list-pages-builds": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["page-build"][];
        };
      };
    };
  };
  /**
   * Request a GitHub Pages build
   * @description You can request that your site be built from the latest revision on the default branch. This has the same effect as pushing a commit to your default branch, but does not require an additional commit. Manually triggering page builds can be helpful when diagnosing build warnings and failures.
   *
   * Build requests are limited to one concurrent build per repository and one concurrent build per requester. If you request a build while another is still in progress, the second request will be queued until the first completes.
   */
  "repos/request-pages-build": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["page-build-status"];
        };
      };
    };
  };
  /** Get latest Pages build */
  "repos/get-latest-pages-build": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["page-build"];
        };
      };
    };
  };
  /** Get GitHub Pages build */
  "repos/get-pages-build": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        build_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["page-build"];
        };
      };
    };
  };
  /**
   * Create a GitHub Pages deployment
   * @description Create a GitHub Pages deployment for a repository.
   *
   * Users must have write permissions. GitHub Apps must have the `pages:write` permission to use this endpoint.
   */
  "repos/create-pages-deployment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The URL of an artifact that contains the .zip or .tar of static assets to deploy. The artifact belongs to the repository. */
          artifact_url: string;
          /**
           * @description The target environment for this GitHub Pages deployment.
           * @default github-pages
           */
          environment?: string;
          /**
           * @description A unique string that represents the version of the build for this deployment.
           * @default GITHUB_SHA
           */
          pages_build_version: string;
          /** @description The OIDC token issued by GitHub Actions certifying the origin of the deployment. */
          oidc_token: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["page-deployment"];
        };
      };
      400: components["responses"]["bad_request"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a DNS health check for GitHub Pages
   * @description Gets a health check of the DNS settings for the `CNAME` record configured for a repository's GitHub Pages.
   *
   * The first request to this endpoint returns a `202 Accepted` status and starts an asynchronous background task to get the results for the domain. After the background task completes, subsequent requests to this endpoint return a `200 OK` status with the health check results in the response.
   *
   * To use this endpoint, you must be a repository administrator, maintainer, or have the 'manage GitHub Pages settings' permission. A token with the `repo` scope or Pages write permission is required. GitHub Apps must have the `administrative:write` and `pages:write` permissions.
   */
  "repos/get-pages-health-check": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pages-health-check"];
        };
      };
      /** @description Empty response */
      202: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Custom domains are not available for GitHub Pages */
      400: never;
      404: components["responses"]["not_found"];
      /** @description There isn't a CNAME for this page */
      422: never;
    };
  };
  /**
   * List repository projects
   * @description Lists the projects in a repository. Returns a `404 Not Found` status if projects are disabled in the repository. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/list-for-repo": {
    parameters: {
      query: {
        /** @description Indicates the state of the projects to return. */
        state?: "open" | "closed" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["project"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Create a repository project
   * @description Creates a repository project board. Returns a `410 Gone` status if projects are disabled in the repository or if the repository does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/create-for-repo": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the project. */
          name: string;
          /** @description The description of the project. */
          body?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["project"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      410: components["responses"]["gone"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List pull requests
   * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   */
  "pulls/list": {
    parameters: {
      query: {
        /** @description Either `open`, `closed`, or `all` to filter by state. */
        state?: "open" | "closed" | "all";
        /** @description Filter pulls by head user or head organization and branch name in the format of `user:ref-name` or `organization:ref-name`. For example: `github:new-script-format` or `octocat:test-branch`. */
        head?: string;
        /** @description Filter pulls by base branch name. Example: `gh-pages`. */
        base?: string;
        /** @description What to sort results by. `popularity` will sort by the number of comments. `long-running` will sort by date created and will limit the results to pull requests that have been open for more than a month and have had activity within the past month. */
        sort?: "created" | "updated" | "popularity" | "long-running";
        /** @description The direction of the sort. Default: `desc` when sort is `created` or sort is not specified, otherwise `asc`. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-simple"][];
        };
      };
      304: components["responses"]["not_modified"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a pull request
   * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-rate-limits)" for details.
   */
  "pulls/create": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The title of the new pull request. Required unless `issue` is specified. */
          title?: string;
          /** @description The name of the branch where your changes are implemented. For cross-repository pull requests in the same network, namespace `head` with a user like this: `username:branch`. */
          head: string;
          /**
           * Format: repo.nwo
           * @description The name of the repository where the changes in the pull request were made. This field is required for cross-repository pull requests if both repositories are owned by the same organization.
           * @example octo-org/octo-repo
           */
          head_repo?: string;
          /** @description The name of the branch you want the changes pulled into. This should be an existing branch on the current repository. You cannot submit a pull request to one repository that requests a merge to a base of another repository. */
          base: string;
          /** @description The contents of the pull request. */
          body?: string;
          /** @description Indicates whether [maintainers can modify](https://docs.github.com/articles/allowing-changes-to-a-pull-request-branch-created-from-a-fork/) the pull request. */
          maintainer_can_modify?: boolean;
          /** @description Indicates whether the pull request is a draft. See "[Draft Pull Requests](https://docs.github.com/articles/about-pull-requests#draft-pull-requests)" in the GitHub Help documentation to learn more. */
          draft?: boolean;
          /**
           * Format: int64
           * @description An issue in the repository to convert to a pull request. The issue title, body, and comments will become the title, body, and comments on the new pull request. Required unless `title` is specified.
           * @example 1
           */
          issue?: number;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/pulls/1347 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["pull-request"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List review comments in a repository
   * @description Lists review comments for all pull requests in a repository. By default, review comments are in ascending order by ID.
   */
  "pulls/list-review-comments-for-repo": {
    parameters: {
      query: {
        sort?: "created" | "updated" | "created_at";
        /** @description The direction to sort results. Ignored without `sort` parameter. */
        direction?: "asc" | "desc";
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"][];
        };
      };
    };
  };
  /**
   * Get a review comment for a pull request
   * @description Provides details for a review comment.
   */
  "pulls/get-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a review comment for a pull request
   * @description Deletes a review comment.
   */
  "pulls/delete-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a review comment for a pull request
   * @description Enables you to edit a review comment.
   */
  "pulls/update-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The text of the reply to the review comment. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"];
        };
      };
    };
  };
  /**
   * List reactions for a pull request review comment
   * @description List the reactions to a [pull request review comment](https://docs.github.com/rest/reference/pulls#review-comments).
   */
  "reactions/list-for-pull-request-review-comment": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a pull request review comment. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create reaction for a pull request review comment
   * @description Create a reaction to a [pull request review comment](https://docs.github.com/rest/reference/pulls#comments). A response with an HTTP `200` status means that you already added the reaction type to this pull request review comment.
   */
  "reactions/create-for-pull-request-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the pull request review comment.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Reaction exists */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Reaction created */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a pull request comment reaction
   * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE /repositories/:repository_id/pulls/comments/:comment_id/reactions/:reaction_id.`
   *
   * Delete a reaction to a [pull request review comment](https://docs.github.com/rest/reference/pulls#review-comments).
   */
  "reactions/delete-for-pull-request-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        comment_id: components["parameters"]["comment-id"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get a pull request
   * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * Lists details of a pull request by providing its number.
   *
   * When you get, [create](https://docs.github.com/rest/reference/pulls/#create-a-pull-request), or [edit](https://docs.github.com/rest/reference/pulls#update-a-pull-request) a pull request, GitHub creates a merge commit to test whether the pull request can be automatically merged into the base branch. This test commit is not added to the base branch or the head branch. You can review the status of the test commit using the `mergeable` key. For more information, see "[Checking mergeability of pull requests](https://docs.github.com/rest/guides/getting-started-with-the-git-database-api#checking-mergeability-of-pull-requests)".
   *
   * The value of the `mergeable` attribute can be `true`, `false`, or `null`. If the value is `null`, then GitHub has started a background job to compute the mergeability. After giving the job time to complete, resubmit the request. When the job finishes, you will see a non-`null` value for the `mergeable` attribute in the response. If `mergeable` is `true`, then `merge_commit_sha` will be the SHA of the _test_ merge commit.
   *
   * The value of the `merge_commit_sha` attribute changes depending on the state of the pull request. Before merging a pull request, the `merge_commit_sha` attribute holds the SHA of the _test_ merge commit. After merging a pull request, the `merge_commit_sha` attribute changes depending on how you merged the pull request:
   *
   * *   If merged as a [merge commit](https://docs.github.com/articles/about-merge-methods-on-github/), `merge_commit_sha` represents the SHA of the merge commit.
   * *   If merged via a [squash](https://docs.github.com/articles/about-merge-methods-on-github/#squashing-your-merge-commits), `merge_commit_sha` represents the SHA of the squashed commit on the base branch.
   * *   If [rebased](https://docs.github.com/articles/about-merge-methods-on-github/#rebasing-and-merging-your-commits), `merge_commit_sha` represents the commit that the base branch was updated to.
   *
   * Pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
   */
  "pulls/get": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats. */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request"];
        };
      };
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Update a pull request
   * @description Draft pull requests are available in public repositories with GitHub Free and GitHub Free for organizations, GitHub Pro, and legacy per-repository billing plans, and in public and private repositories with GitHub Team and GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * To open or update a pull request in a public repository, you must have write access to the head or the source branch. For organization-owned repositories, you must be a member of the organization that owns the repository to open or update a pull request.
   */
  "pulls/update": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The title of the pull request. */
          title?: string;
          /** @description The contents of the pull request. */
          body?: string;
          /**
           * @description State of this Pull Request. Either `open` or `closed`.
           * @enum {string}
           */
          state?: "open" | "closed";
          /** @description The name of the branch you want your changes pulled into. This should be an existing branch on the current repository. You cannot update the base branch on a pull request to point to another repository. */
          base?: string;
          /** @description Indicates whether [maintainers can modify](https://docs.github.com/articles/allowing-changes-to-a-pull-request-branch-created-from-a-fork/) the pull request. */
          maintainer_can_modify?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a codespace from a pull request
   * @description Creates a codespace owned by the authenticated user for the specified pull request.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/create-with-pr-for-authenticated-user": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The requested location for a new codespace. Best efforts are made to respect this upon creation. Assigned by IP if not provided. */
          location?: string;
          /** @description IP for location auto-detection when proxying a request */
          client_ip?: string;
          /** @description Machine type to use for this codespace */
          machine?: string;
          /** @description Path to devcontainer.json config to use for this codespace */
          devcontainer_path?: string;
          /** @description Whether to authorize requested permissions from devcontainer.json */
          multi_repo_permissions_opt_out?: boolean;
          /** @description Working directory for this codespace */
          working_directory?: string;
          /** @description Time in minutes before codespace stops from inactivity */
          idle_timeout_minutes?: number;
          /** @description Display name for this codespace */
          display_name?: string;
          /** @description Duration in minutes after codespace has gone idle in which it will be deleted. Must be integer minutes between 0 and 43200 (30 days). */
          retention_period_minutes?: number;
        } | null;
      };
    };
    responses: {
      /** @description Response when the codespace was successfully created */
      201: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      /** @description Response when the codespace creation partially failed but is being retried in the background */
      202: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List review comments on a pull request
   * @description Lists all review comments for a pull request. By default, review comments are in ascending order by ID.
   */
  "pulls/list-review-comments": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort"];
        /** @description The direction to sort results. Ignored without `sort` parameter. */
        direction?: "asc" | "desc";
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"][];
        };
      };
    };
  };
  /**
   * Create a review comment for a pull request
   * @description
   * Creates a review comment in the pull request diff. To add a regular comment to a pull request timeline, see "[Create an issue comment](https://docs.github.com/rest/reference/issues#create-an-issue-comment)." We recommend creating a review comment using `line`, `side`, and optionally `start_line` and `start_side` if your comment applies to more than one line in the pull request diff.
   *
   * The `position` parameter is deprecated. If you use `position`, the `line`, `side`, `start_line`, and `start_side` parameters are not required.
   *
   * **Note:** The position value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "pulls/create-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The text of the review comment. */
          body: string;
          /** @description The SHA of the commit needing a comment. Not using the latest commit SHA may render your comment outdated if a subsequent commit modifies the line you specify as the `position`. */
          commit_id: string;
          /** @description The relative path to the file that necessitates a comment. */
          path: string;
          /**
           * @deprecated
           * @description **This parameter is deprecated. Use `line` instead**. The position in the diff where you want to add a review comment. Note this value is not the same as the line number in the file. For help finding the position value, read the note above.
           */
          position?: number;
          /**
           * @description In a split diff view, the side of the diff that the pull request's changes appear on. Can be `LEFT` or `RIGHT`. Use `LEFT` for deletions that appear in red. Use `RIGHT` for additions that appear in green or unchanged lines that appear in white and are shown for context. For a multi-line comment, side represents whether the last line of the comment range is a deletion or addition. For more information, see "[Diff view options](https://docs.github.com/articles/about-comparing-branches-in-pull-requests#diff-view-options)" in the GitHub Help documentation.
           * @enum {string}
           */
          side?: "LEFT" | "RIGHT";
          /** @description The line of the blob in the pull request diff that the comment applies to. For a multi-line comment, the last line of the range that your comment applies to. */
          line: number;
          /** @description **Required when using multi-line comments unless using `in_reply_to`**. The `start_line` is the first line in the pull request diff that your multi-line comment applies to. To learn more about multi-line comments, see "[Commenting on a pull request](https://docs.github.com/articles/commenting-on-a-pull-request#adding-line-comments-to-a-pull-request)" in the GitHub Help documentation. */
          start_line?: number;
          /**
           * @description **Required when using multi-line comments unless using `in_reply_to`**. The `start_side` is the starting side of the diff that the comment applies to. Can be `LEFT` or `RIGHT`. To learn more about multi-line comments, see "[Commenting on a pull request](https://docs.github.com/articles/commenting-on-a-pull-request#adding-line-comments-to-a-pull-request)" in the GitHub Help documentation. See `side` in this table for additional context.
           * @enum {string}
           */
          start_side?: "LEFT" | "RIGHT" | "side";
          /**
           * @description The ID of the review comment to reply to. To find the ID of a review comment with ["List review comments on a pull request"](#list-review-comments-on-a-pull-request). When specified, all parameters other than `body` in the request body are ignored.
           * @example 2
           */
          in_reply_to?: number;
          /**
           * @description The level at which the comment is targeted.
           * @enum {string}
           */
          subject_type?: "LINE" | "FILE";
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/pulls/comments/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a reply for a review comment
   * @description Creates a reply to a review comment for a pull request. For the `comment_id`, provide the ID of the review comment you are replying to. This must be the ID of a _top-level review comment_, not a reply to that comment. Replies to replies are not supported.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "pulls/create-reply-for-review-comment": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        comment_id: components["parameters"]["comment-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The text of the review comment. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/pulls/comments/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["pull-request-review-comment"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List commits on a pull request
   * @description Lists a maximum of 250 commits for a pull request. To receive a complete commit list for pull requests with more than 250 commits, use the [List commits](https://docs.github.com/rest/reference/repos#list-commits) endpoint.
   */
  "pulls/list-commits": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["commit"][];
        };
      };
    };
  };
  /**
   * List pull requests files
   * @description **Note:** Responses include a maximum of 3000 files. The paginated response returns 30 files per page by default.
   */
  "pulls/list-files": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["diff-entry"][];
        };
      };
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /** Check if a pull request has been merged */
  "pulls/check-if-merged": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Response if pull request has been merged */
      204: never;
      /** @description Not Found if pull request has not been merged */
      404: never;
    };
  };
  /**
   * Merge a pull request
   * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "pulls/merge": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Title for the automatic commit message. */
          commit_title?: string;
          /** @description Extra detail to append to automatic commit message. */
          commit_message?: string;
          /** @description SHA that pull request head must match to allow merge. */
          sha?: string;
          /**
           * @description The merge method to use.
           * @enum {string}
           */
          merge_method?: "merge" | "squash" | "rebase";
        } | null;
      };
    };
    responses: {
      /** @description if merge was successful */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-merge-result"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      /** @description Method Not Allowed if merge cannot be performed */
      405: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
      /** @description Conflict if sha was provided and pull request head did not match */
      409: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get all requested reviewers for a pull request
   * @description Gets the users or teams whose review is requested for a pull request. Once a requested reviewer submits a review, they are no longer considered a requested reviewer. Their review will instead be returned by the [List reviews for a pull request](https://docs.github.com/rest/pulls/reviews#list-reviews-for-a-pull-request) operation.
   */
  "pulls/list-requested-reviewers": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-review-request"];
        };
      };
    };
  };
  /**
   * Request reviewers for a pull request
   * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "pulls/request-reviewers": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description An array of user `login`s that will be requested. */
          reviewers?: string[];
          /** @description An array of team `slug`s that will be requested. */
          team_reviewers?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["pull-request-simple"];
        };
      };
      403: components["responses"]["forbidden"];
      /** @description Unprocessable Entity if user is not a collaborator */
      422: never;
    };
  };
  /** Remove requested reviewers from a pull request */
  "pulls/remove-requested-reviewers": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of user `login`s that will be removed. */
          reviewers: string[];
          /** @description An array of team `slug`s that will be removed. */
          team_reviewers?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-simple"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List reviews for a pull request
   * @description The list of reviews returns in chronological order.
   */
  "pulls/list-reviews": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    responses: {
      /** @description The list of reviews returns in chronological order. */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["pull-request-review"][];
        };
      };
    };
  };
  /**
   * Create a review for a pull request
   * @description This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   *
   * Pull request reviews created in the `PENDING` state are not submitted and therefore do not include the `submitted_at` property in the response. To create a pending review for a pull request, leave the `event` parameter blank. For more information about submitting a `PENDING` review, see "[Submit a review for a pull request](https://docs.github.com/rest/pulls#submit-a-review-for-a-pull-request)."
   *
   * **Note:** To comment on a specific line in a file, you need to first determine the _position_ of that line in the diff. The GitHub REST API offers the `application/vnd.github.v3.diff` [media type](https://docs.github.com/rest/overview/media-types#commits-commit-comparison-and-pull-requests). To see a pull request diff, add this media type to the `Accept` header of a call to the [single pull request](https://docs.github.com/rest/reference/pulls#get-a-pull-request) endpoint.
   *
   * The `position` value equals the number of lines down from the first "@@" hunk header in the file you want to add a comment. The line just below the "@@" line is position 1, the next line is position 2, and so on. The position in the diff continues to increase through lines of whitespace and additional hunks until the beginning of a new file.
   */
  "pulls/create-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The SHA of the commit that needs a review. Not using the latest commit SHA may render your review comment outdated if a subsequent commit modifies the line you specify as the `position`. Defaults to the most recent commit in the pull request when you do not specify a value. */
          commit_id?: string;
          /** @description **Required** when using `REQUEST_CHANGES` or `COMMENT` for the `event` parameter. The body text of the pull request review. */
          body?: string;
          /**
           * @description The review action you want to perform. The review actions include: `APPROVE`, `REQUEST_CHANGES`, or `COMMENT`. By leaving this blank, you set the review action state to `PENDING`, which means you will need to [submit the pull request review](https://docs.github.com/rest/pulls#submit-a-review-for-a-pull-request) when you are ready.
           * @enum {string}
           */
          event?: "APPROVE" | "REQUEST_CHANGES" | "COMMENT";
          /** @description Use the following table to specify the location, destination, and contents of the draft review comment. */
          comments?: {
            /** @description The relative path to the file that necessitates a review comment. */
            path: string;
            /** @description The position in the diff where you want to add a review comment. Note this value is not the same as the line number in the file. For help finding the position value, read the note below. */
            position?: number;
            /** @description Text of the review comment. */
            body: string;
            /** @example 28 */
            line?: number;
            /** @example RIGHT */
            side?: string;
            /** @example 26 */
            start_line?: number;
            /** @example LEFT */
            start_side?: string;
          }[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /** Get a review for a pull request */
  "pulls/get-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a review for a pull request
   * @description Update the review summary comment with new text.
   */
  "pulls/update-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The body text of the pull request review. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /** Delete a pending review for a pull request */
  "pulls/delete-pending-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List comments for a pull request review
   * @description List comments for a specific pull request review.
   */
  "pulls/list-comments-for-review": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["review-comment"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Dismiss a review for a pull request
   * @description **Note:** To dismiss a pull request review on a [protected branch](https://docs.github.com/rest/reference/repos#branches), you must be a repository administrator or be included in the list of people or teams who can dismiss pull request reviews.
   */
  "pulls/dismiss-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The message for the pull request review dismissal */
          message: string;
          /**
           * @example "DISMISS"
           * @enum {string}
           */
          event?: "DISMISS";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Submit a review for a pull request
   * @description Submits a pending review for a pull request. For more information about creating a pending review for a pull request, see "[Create a review for a pull request](https://docs.github.com/rest/pulls#create-a-review-for-a-pull-request)."
   */
  "pulls/submit-review": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
        review_id: components["parameters"]["review-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The body text of the pull request review */
          body?: string;
          /**
           * @description The review action you want to perform. The review actions include: `APPROVE`, `REQUEST_CHANGES`, or `COMMENT`. When you leave this blank, the API returns _HTTP 422 (Unrecognizable entity)_ and sets the review action state to `PENDING`, which means you will need to re-submit the pull request review using a review action.
           * @enum {string}
           */
          event: "APPROVE" | "REQUEST_CHANGES" | "COMMENT";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["pull-request-review"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Update a pull request branch
   * @description Updates the pull request branch with the latest upstream changes by merging HEAD from the base branch into the pull request branch.
   */
  "pulls/update-branch": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        pull_number: components["parameters"]["pull-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The expected SHA of the pull request's HEAD ref. This is the most recent commit on the pull request's branch. If the expected SHA does not match the pull request's HEAD, you will receive a `422 Unprocessable Entity` status. You can use the "[List commits](https://docs.github.com/rest/reference/repos#list-commits)" endpoint to find the most recent commit SHA. Default: SHA of the pull request's current HEAD ref. */
          expected_head_sha?: string;
        } | null;
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": {
            message?: string;
            url?: string;
          };
        };
      };
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a repository README
   * @description Gets the preferred README for a repository.
   *
   * READMEs support [custom media types](https://docs.github.com/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
   */
  "repos/get-readme": {
    parameters: {
      query: {
        /** @description The name of the commit/branch/tag. Default: the repository’s default branch. */
        ref?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["content-file"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a repository README for a directory
   * @description Gets the README from a repository directory.
   *
   * READMEs support [custom media types](https://docs.github.com/rest/reference/repos#custom-media-types) for retrieving the raw content or rendered HTML.
   */
  "repos/get-readme-in-directory": {
    parameters: {
      query: {
        /** @description The name of the commit/branch/tag. Default: the repository’s default branch. */
        ref?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The alternate path to look for a README file */
        dir: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["content-file"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List releases
   * @description This returns a list of releases, which does not include regular Git tags that have not been associated with a release. To get a list of Git tags, use the [Repository Tags API](https://docs.github.com/rest/reference/repos#list-repository-tags).
   *
   * Information about published releases are available to everyone. Only users with push access will receive listings for draft releases.
   */
  "repos/list-releases": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["release"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a release
   * @description Users with push access to the repository can create a release.
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "repos/create-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the tag. */
          tag_name: string;
          /** @description Specifies the commitish value that determines where the Git tag is created from. Can be any branch or commit SHA. Unused if the Git tag already exists. Default: the repository's default branch. */
          target_commitish?: string;
          /** @description The name of the release. */
          name?: string;
          /** @description Text describing the contents of the tag. */
          body?: string;
          /**
           * @description `true` to create a draft (unpublished) release, `false` to create a published one.
           * @default false
           */
          draft?: boolean;
          /**
           * @description `true` to identify the release as a prerelease. `false` to identify the release as a full release.
           * @default false
           */
          prerelease?: boolean;
          /** @description If specified, a discussion of the specified category is created and linked to the release. The value must be a category that already exists in the repository. For more information, see "[Managing categories for discussions in your repository](https://docs.github.com/discussions/managing-discussions-for-your-community/managing-categories-for-discussions-in-your-repository)." */
          discussion_category_name?: string;
          /**
           * @description Whether to automatically generate the name and body for this release. If `name` is specified, the specified name will be used; otherwise, a name will be automatically generated. If `body` is specified, the body will be pre-pended to the automatically generated notes.
           * @default false
           */
          generate_release_notes?: boolean;
          /**
           * @description Specifies whether this release should be set as the latest release for the repository. Drafts and prereleases cannot be set as latest. Defaults to `true` for newly published releases. `legacy` specifies that the latest release should be determined based on the release creation date and higher semantic version.
           * @default true
           * @enum {string}
           */
          make_latest?: "true" | "false" | "legacy";
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/releases/1 */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["release"];
        };
      };
      /** @description Not Found if the discussion category name is invalid */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a release asset
   * @description To download the asset's binary content, set the `Accept` header of the request to [`application/octet-stream`](https://docs.github.com/rest/overview/media-types). The API will either redirect the client to the location, or stream it directly if possible. API clients should handle both a `200` or `302` response.
   */
  "repos/get-release-asset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        asset_id: components["parameters"]["asset-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["release-asset"];
        };
      };
      302: components["responses"]["found"];
      404: components["responses"]["not_found"];
    };
  };
  /** Delete a release asset */
  "repos/delete-release-asset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        asset_id: components["parameters"]["asset-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a release asset
   * @description Users with push access to the repository can edit a release asset.
   */
  "repos/update-release-asset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        asset_id: components["parameters"]["asset-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The file name of the asset. */
          name?: string;
          /** @description An alternate short description of the asset. Used in place of the filename. */
          label?: string;
          /** @example "uploaded" */
          state?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["release-asset"];
        };
      };
    };
  };
  /**
   * Generate release notes content for a release
   * @description Generate a name and body describing a [release](https://docs.github.com/rest/reference/repos#releases). The body content will be markdown formatted and contain information like the changes since last release and users who contributed. The generated release notes are not saved anywhere. They are intended to be generated and used when creating a new release.
   */
  "repos/generate-release-notes": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The tag name for the release. This can be an existing tag or a new one. */
          tag_name: string;
          /** @description Specifies the commitish value that will be the target for the release's tag. Required if the supplied tag_name does not reference an existing tag. Ignored if the tag_name already exists. */
          target_commitish?: string;
          /** @description The name of the previous tag to use as the starting point for the release notes. Use to manually specify the range for the set of changes considered as part this release. */
          previous_tag_name?: string;
          /** @description Specifies a path to a file in the repository containing configuration settings used for generating the release notes. If unspecified, the configuration file located in the repository at '.github/release.yml' or '.github/release.yaml' will be used. If that is not present, the default configuration will be used. */
          configuration_file_path?: string;
        };
      };
    };
    responses: {
      /** @description Name and body of generated release notes */
      200: {
        content: {
          "application/json": components["schemas"]["release-notes-content"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get the latest release
   * @description View the latest published full release for the repository.
   *
   * The latest release is the most recent non-prerelease, non-draft release, sorted by the `created_at` attribute. The `created_at` attribute is the date of the commit used for the release, and not the date when the release was drafted or published.
   */
  "repos/get-latest-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["release"];
        };
      };
    };
  };
  /**
   * Get a release by tag name
   * @description Get a published release with the specified tag.
   */
  "repos/get-release-by-tag": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description tag parameter */
        tag: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["release"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a release
   * @description **Note:** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a [hypermedia resource](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia).
   */
  "repos/get-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    responses: {
      /** @description **Note:** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a [hypermedia resource](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia). */
      200: {
        content: {
          "application/json": components["schemas"]["release"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a release
   * @description Users with push access to the repository can delete a release.
   */
  "repos/delete-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a release
   * @description Users with push access to the repository can edit a release.
   */
  "repos/update-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the tag. */
          tag_name?: string;
          /** @description Specifies the commitish value that determines where the Git tag is created from. Can be any branch or commit SHA. Unused if the Git tag already exists. Default: the repository's default branch. */
          target_commitish?: string;
          /** @description The name of the release. */
          name?: string;
          /** @description Text describing the contents of the tag. */
          body?: string;
          /** @description `true` makes the release a draft, and `false` publishes the release. */
          draft?: boolean;
          /** @description `true` to identify the release as a prerelease, `false` to identify the release as a full release. */
          prerelease?: boolean;
          /**
           * @description Specifies whether this release should be set as the latest release for the repository. Drafts and prereleases cannot be set as latest. Defaults to `true` for newly published releases. `legacy` specifies that the latest release should be determined based on the release creation date and higher semantic version.
           * @default true
           * @enum {string}
           */
          make_latest?: "true" | "false" | "legacy";
          /** @description If specified, a discussion of the specified category is created and linked to the release. The value must be a category that already exists in the repository. If there is already a discussion linked to the release, this parameter is ignored. For more information, see "[Managing categories for discussions in your repository](https://docs.github.com/discussions/managing-discussions-for-your-community/managing-categories-for-discussions-in-your-repository)." */
          discussion_category_name?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["release"];
        };
      };
      /** @description Not Found if the discussion category name is invalid */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /** List release assets */
  "repos/list-release-assets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["release-asset"][];
        };
      };
    };
  };
  /**
   * Upload a release asset
   * @description This endpoint makes use of [a Hypermedia relation](https://docs.github.com/rest/overview/resources-in-the-rest-api#hypermedia) to determine which URL to access. The endpoint you call to upload release assets is specific to your release. Use the `upload_url` returned in
   * the response of the [Create a release endpoint](https://docs.github.com/rest/releases/releases#create-a-release) to upload a release asset.
   *
   * You need to use an HTTP client which supports [SNI](http://en.wikipedia.org/wiki/Server_Name_Indication) to make calls to this endpoint.
   *
   * Most libraries will set the required `Content-Length` header automatically. Use the required `Content-Type` header to provide the media type of the asset. For a list of media types, see [Media Types](https://www.iana.org/assignments/media-types/media-types.xhtml). For example:
   *
   * `application/zip`
   *
   * GitHub expects the asset data in its raw binary form, rather than JSON. You will send the raw binary content of the asset as the request body. Everything else about the endpoint is the same as the rest of the API. For example,
   * you'll still need to pass your authentication to be able to upload an asset.
   *
   * When an upstream failure occurs, you will receive a `502 Bad Gateway` status. This may leave an empty asset with a state of `starter`. It can be safely deleted.
   *
   * **Notes:**
   * *   GitHub renames asset filenames that have special characters, non-alphanumeric characters, and leading or trailing periods. The "[List assets for a release](https://docs.github.com/rest/reference/repos#list-assets-for-a-release)"
   * endpoint lists the renamed filenames. For more information and help, contact [GitHub Support](https://support.github.com/contact?tags=dotcom-rest-api).
   * *   To find the `release_id` query the [`GET /repos/{owner}/{repo}/releases/latest` endpoint](https://docs.github.com/rest/releases/releases#get-the-latest-release).
   * *   If you upload an asset with the same filename as another uploaded asset, you'll receive an error and must delete the old file before you can re-upload the new asset.
   */
  "repos/upload-release-asset": {
    parameters: {
      query: {
        name: string;
        label?: string;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    requestBody?: {
      content: {
        "application/octet-stream": string;
      };
    };
    responses: {
      /** @description Response for successful upload */
      201: {
        content: {
          "application/json": components["schemas"]["release-asset"];
        };
      };
      /** @description Response if you upload an asset with the same filename as another uploaded asset */
      422: never;
    };
  };
  /**
   * List reactions for a release
   * @description List the reactions to a [release](https://docs.github.com/rest/reference/repos#releases).
   */
  "reactions/list-for-release": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a release. */
        content?: "+1" | "laugh" | "heart" | "hooray" | "rocket" | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create reaction for a release
   * @description Create a reaction to a [release](https://docs.github.com/rest/reference/repos#releases). A response with a `Status: 200 OK` means that you already added the reaction type to this release.
   */
  "reactions/create-for-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the release.
           * @enum {string}
           */
          content: "+1" | "laugh" | "heart" | "hooray" | "rocket" | "eyes";
        };
      };
    };
    responses: {
      /** @description Reaction exists */
      200: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      /** @description Reaction created */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a release reaction
   * @description **Note:** You can also specify a repository by `repository_id` using the route `DELETE delete /repositories/:repository_id/releases/:release_id/reactions/:reaction_id`.
   *
   * Delete a reaction to a [release](https://docs.github.com/rest/reference/repos#releases).
   */
  "reactions/delete-for-release": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        release_id: components["parameters"]["release-id"];
        reaction_id: components["parameters"]["reaction-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Get rules for a branch
   * @description Returns all rules that apply to the specified branch.
   */
  "repos/get-branch-rules": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        branch: components["parameters"]["branch"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-rule"][];
        };
      };
    };
  };
  /**
   * Get all repository rulesets
   * @description Get all the rulesets for a repository.
   */
  "repos/get-repo-rulesets": {
    parameters: {
      query: {
        /** @description Include rulesets configured at higher levels that apply to this repository */
        includes_parents?: boolean;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"][];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Create a repository ruleset
   * @description Create a ruleset for a repository.
   */
  "repos/create-repo-ruleset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    /** @description Request body */
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the ruleset. */
          name: string;
          /**
           * @description The target of the ruleset.
           * @enum {string}
           */
          target?: "branch" | "tag";
          enforcement: components["schemas"]["repository-rule-enforcement"];
          /**
           * @description The permission level required to bypass this ruleset. "repository" allows those with bypass permission at the repository level to bypass. "organization" allows those with bypass permission at the organization level to bypass. "none" prevents anyone from bypassing.
           * @enum {string}
           */
          bypass_mode?: "none" | "repository" | "organization";
          /** @description The actors that can bypass the rules in this ruleset */
          bypass_actors?: components["schemas"]["repository-ruleset-bypass-actor"][];
          conditions?: components["schemas"]["repository-ruleset-conditions"];
          /** @description An array of rules within the ruleset. */
          rules?: components["schemas"]["repository-rule"][];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get a repository ruleset
   * @description Get a ruleset for a repository.
   */
  "repos/get-repo-ruleset": {
    parameters: {
      query: {
        /** @description Include rulesets configured at higher levels that apply to this repository */
        includes_parents?: boolean;
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Update a repository ruleset
   * @description Update a ruleset for a repository.
   */
  "repos/update-repo-ruleset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    /** @description Request body */
    requestBody?: {
      content: {
        "application/json": {
          /** @description The name of the ruleset. */
          name?: string;
          /**
           * @description The target of the ruleset.
           * @enum {string}
           */
          target?: "branch" | "tag";
          enforcement?: components["schemas"]["repository-rule-enforcement"];
          /**
           * @description The permission level required to bypass this ruleset. "repository" allows those with bypass permission at the repository level to bypass. "organization" allows those with bypass permission at the organization level to bypass. "none" prevents anyone from bypassing.
           * @enum {string}
           */
          bypass_mode?: "none" | "repository" | "organization";
          /** @description The actors that can bypass the rules in this ruleset */
          bypass_actors?: components["schemas"]["repository-ruleset-bypass-actor"][];
          conditions?: components["schemas"]["repository-ruleset-conditions"];
          /** @description An array of rules within the ruleset. */
          rules?: components["schemas"]["repository-rule"][];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-ruleset"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Delete a repository ruleset
   * @description Delete a ruleset for a repository.
   */
  "repos/delete-repo-ruleset": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        /** @description The ID of the ruleset. */
        ruleset_id: number;
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * List secret scanning alerts for a repository
   * @description Lists secret scanning alerts for an eligible repository, from newest to oldest.
   * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
   */
  "secret-scanning/list-alerts-for-repo": {
    parameters: {
      query: {
        state?: components["parameters"]["secret-scanning-alert-state"];
        secret_type?: components["parameters"]["secret-scanning-alert-secret-type"];
        resolution?: components["parameters"]["secret-scanning-alert-resolution"];
        sort?: components["parameters"]["secret-scanning-alert-sort"];
        direction?: components["parameters"]["direction"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        before?: components["parameters"]["secret-scanning-pagination-before-org-repo"];
        after?: components["parameters"]["secret-scanning-pagination-after-org-repo"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["secret-scanning-alert"][];
        };
      };
      /** @description Repository is public or secret scanning is disabled for the repository */
      404: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a secret scanning alert
   * @description Gets a single secret scanning alert detected in an eligible repository.
   * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
   */
  "secret-scanning/get-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["secret-scanning-alert"];
        };
      };
      304: components["responses"]["not_modified"];
      /** @description Repository is public, or secret scanning is disabled for the repository, or the resource is not found */
      404: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Update a secret scanning alert
   * @description Updates the status of a secret scanning alert in an eligible repository.
   * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `secret_scanning_alerts` write permission to use this endpoint.
   */
  "secret-scanning/update-alert": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          state: components["schemas"]["secret-scanning-alert-state"];
          resolution?: components["schemas"]["secret-scanning-alert-resolution"];
          resolution_comment?: components["schemas"]["secret-scanning-alert-resolution-comment"];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["secret-scanning-alert"];
        };
      };
      /** @description Bad request, resolution comment is invalid or the resolution was not changed. */
      400: never;
      /** @description Repository is public, or secret scanning is disabled for the repository, or the resource is not found */
      404: never;
      /** @description State does not match the resolution or resolution comment */
      422: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List locations for a secret scanning alert
   * @description Lists all locations for a given secret scanning alert for an eligible repository.
   * To use this endpoint, you must be an administrator for the repository or for the organization that owns the repository, and you must use a personal access token with the `repo` scope or `security_events` scope.
   * For public repositories, you may instead use the `public_repo` scope.
   *
   * GitHub Apps must have the `secret_scanning_alerts` read permission to use this endpoint.
   */
  "secret-scanning/list-locations-for-alert": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        alert_number: components["parameters"]["alert-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["secret-scanning-location"][];
        };
      };
      /** @description Repository is public, or secret scanning is disabled for the repository, or the resource is not found */
      404: never;
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List repository security advisories
   * @description Lists security advisories in a repository.
   * You must authenticate using an access token with the `repo` scope or `repository_advisories:read` permission
   * in order to get published security advisories in a private repository, or any unpublished security advisories that you have access to.
   *
   * You can access unpublished security advisories from a repository if you are a security manager or administrator of that repository, or if you are a collaborator on any security advisory.
   */
  "security-advisories/list-repository-advisories": {
    parameters: {
      query: {
        direction?: components["parameters"]["direction"];
        /** @description The property to sort the results by. */
        sort?: "created" | "updated" | "published";
        before?: components["parameters"]["pagination-before"];
        after?: components["parameters"]["pagination-after"];
        /** @description Number of advisories to return per page. */
        per_page?: number;
        /** @description Filter by state of the repository advisories. Only advisories of this state will be returned. */
        state?: "triage" | "draft" | "published" | "closed";
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-advisory"][];
        };
      };
      400: components["responses"]["bad_request"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a repository security advisory
   * @description Creates a new repository security advisory.
   * You must authenticate using an access token with the `repo` scope or `repository_advisories:write` permission to use this endpoint.
   *
   * In order to create a draft repository security advisory, you must be a security manager or administrator of that repository.
   */
  "security-advisories/create-repository-advisory": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["repository-advisory-create"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["repository-advisory"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Privately report a security vulnerability
   * @description Report a security vulnerability to the maintainers of the repository.
   * See "[Privately reporting a security vulnerability](https://docs.github.com/code-security/security-advisories/guidance-on-reporting-and-writing/privately-reporting-a-security-vulnerability)" for more information about private vulnerability reporting.
   */
  "security-advisories/create-private-vulnerability-report": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["private-vulnerability-report-create"];
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["repository-advisory"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a repository security advisory
   * @description Get a repository security advisory using its GitHub Security Advisory (GHSA) identifier.
   * You can access any published security advisory on a public repository.
   * You must authenticate using an access token with the `repo` scope or `repository_advisories:read` permission
   * in order to get a published security advisory in a private repository, or any unpublished security advisory that you have access to.
   *
   * You can access an unpublished security advisory from a repository if you are a security manager or administrator of that repository, or if you are a
   * collaborator on the security advisory.
   */
  "security-advisories/get-repository-advisory": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        ghsa_id: components["parameters"]["ghsa_id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-advisory"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Update a repository security advisory
   * @description Update a repository security advisory using its GitHub Security Advisory (GHSA) identifier.
   * You must authenticate using an access token with the `repo` scope or `repository_advisories:write` permission to use this endpoint.
   *
   * In order to update any security advisory, you must be a security manager or administrator of that repository,
   * or a collaborator on the repository security advisory.
   */
  "security-advisories/update-repository-advisory": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        ghsa_id: components["parameters"]["ghsa_id"];
      };
    };
    requestBody: {
      content: {
        "application/json": components["schemas"]["repository-advisory-update"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-advisory"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      /** @description Validation failed, or the endpoint has been spammed. */
      422: {
        content: {
          "application/json": components["schemas"]["validation-error"];
        };
      };
    };
  };
  /**
   * List stargazers
   * @description Lists the people that have starred the repository.
   *
   * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
   */
  "activity/list-stargazers-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json":
            | components["schemas"]["simple-user"][]
            | components["schemas"]["stargazer"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get the weekly commit activity
   * @description Returns a weekly aggregate of the number of additions and deletions pushed to a repository.
   */
  "repos/get-code-frequency-stats": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Returns a weekly aggregate of the number of additions and deletions pushed to a repository. */
      200: {
        content: {
          "application/json": components["schemas"]["code-frequency-stat"][];
        };
      };
      202: components["responses"]["accepted"];
      204: components["responses"]["no_content"];
    };
  };
  /**
   * Get the last year of commit activity
   * @description Returns the last year of commit activity grouped by week. The `days` array is a group of commits per day, starting on `Sunday`.
   */
  "repos/get-commit-activity-stats": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit-activity"][];
        };
      };
      202: components["responses"]["accepted"];
      204: components["responses"]["no_content"];
    };
  };
  /**
   * Get all contributor commit activity
   * @description
   * Returns the `total` number of commits authored by the contributor. In addition, the response includes a Weekly Hash (`weeks` array) with the following information:
   *
   * *   `w` - Start of the week, given as a [Unix timestamp](http://en.wikipedia.org/wiki/Unix_time).
   * *   `a` - Number of additions
   * *   `d` - Number of deletions
   * *   `c` - Number of commits
   */
  "repos/get-contributors-stats": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["contributor-activity"][];
        };
      };
      202: components["responses"]["accepted"];
      204: components["responses"]["no_content"];
    };
  };
  /**
   * Get the weekly commit count
   * @description Returns the total commit counts for the `owner` and total commit counts in `all`. `all` is everyone combined, including the `owner` in the last 52 weeks. If you'd like to get the commit counts for non-owners, you can subtract `owner` from `all`.
   *
   * The array order is oldest week (index 0) to most recent week.
   */
  "repos/get-participation-stats": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description The array order is oldest week (index 0) to most recent week. */
      200: {
        content: {
          "application/json": components["schemas"]["participation-stats"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get the hourly commit count for each day
   * @description Each array contains the day number, hour number, and number of commits:
   *
   * *   `0-6`: Sunday - Saturday
   * *   `0-23`: Hour of day
   * *   Number of commits
   *
   * For example, `[2, 14, 25]` indicates that there were 25 total commits, during the 2:00pm hour on Tuesdays. All times are based on the time zone of individual commits.
   */
  "repos/get-punch-card-stats": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description For example, `[2, 14, 25]` indicates that there were 25 total commits, during the 2:00pm hour on Tuesdays. All times are based on the time zone of individual commits. */
      200: {
        content: {
          "application/json": components["schemas"]["code-frequency-stat"][];
        };
      };
      204: components["responses"]["no_content"];
    };
  };
  /**
   * Create a commit status
   * @description Users with push access in a repository can create commit statuses for a given SHA.
   *
   * Note: there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
   */
  "repos/create-commit-status": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        sha: string;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The state of the status.
           * @enum {string}
           */
          state: "error" | "failure" | "pending" | "success";
          /**
           * @description The target URL to associate with this status. This URL will be linked from the GitHub UI to allow users to easily see the source of the status.
           * For example, if your continuous integration system is posting build status, you would want to provide the deep link for the build output for this specific SHA:
           * `http://ci.example.com/user/repo/build/sha`
           */
          target_url?: string | null;
          /** @description A short description of the status. */
          description?: string | null;
          /**
           * @description A string label to differentiate this status from the status of other systems. This field is case-insensitive.
           * @default default
           */
          context?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World/statuses/6dcb09b5b57875f334f61aebed695e2e4193db5e */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["status"];
        };
      };
    };
  };
  /**
   * List watchers
   * @description Lists the people watching the specified repository.
   */
  "activity/list-watchers-for-repo": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /** Get a repository subscription */
  "activity/get-repo-subscription": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description if you subscribe to the repository */
      200: {
        content: {
          "application/json": components["schemas"]["repository-subscription"];
        };
      };
      403: components["responses"]["forbidden"];
      /** @description Not Found if you don't subscribe to the repository */
      404: never;
    };
  };
  /**
   * Set a repository subscription
   * @description If you would like to watch a repository, set `subscribed` to `true`. If you would like to ignore notifications made within a repository, set `ignored` to `true`. If you would like to stop watching a repository, [delete the repository's subscription](https://docs.github.com/rest/reference/activity#delete-a-repository-subscription) completely.
   */
  "activity/set-repo-subscription": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description Determines if notifications should be received from this repository. */
          subscribed?: boolean;
          /** @description Determines if all notifications should be blocked from this repository. */
          ignored?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository-subscription"];
        };
      };
    };
  };
  /**
   * Delete a repository subscription
   * @description This endpoint should only be used to stop watching a repository. To control whether or not you wish to receive notifications from a repository, [set the repository's subscription manually](https://docs.github.com/rest/reference/activity#set-a-repository-subscription).
   */
  "activity/delete-repo-subscription": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /** List repository tags */
  "repos/list-tags": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["tag"][];
        };
      };
    };
  };
  /**
   * List tag protection states for a repository
   * @description This returns the tag protection states of a repository.
   *
   * This information is only available to repository administrators.
   */
  "repos/list-tag-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["tag-protection"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a tag protection state for a repository
   * @description This creates a tag protection state for a repository.
   * This endpoint is only available to repository administrators.
   */
  "repos/create-tag-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An optional glob pattern to match against when enforcing tag protection. */
          pattern: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["tag-protection"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a tag protection state for a repository
   * @description This deletes a tag protection state for a repository.
   * This endpoint is only available to repository administrators.
   */
  "repos/delete-tag-protection": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        tag_protection_id: components["parameters"]["tag-protection-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Download a repository archive (tar)
   * @description Gets a redirect URL to download a tar archive for a repository. If you omit `:ref`, the repository’s default branch (usually
   * `main`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
   * the `Location` header to make a second `GET` request.
   * **Note**: For private repositories, these links are temporary and expire after five minutes.
   */
  "repos/download-tarball-archive": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      302: never;
    };
  };
  /** List repository teams */
  "repos/list-teams": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
    };
  };
  /** Get all repository topics */
  "repos/get-all-topics": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["topic"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /** Replace all repository topics */
  "repos/replace-all-topics": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of topics to add to the repository. Pass one or more topics to _replace_ the set of existing topics. Send an empty array (`[]`) to clear all topics from the repository. **Note:** Topic `names` cannot contain uppercase letters. */
          names: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["topic"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * Get repository clones
   * @description Get the total number of clones and breakdown per day or week for the last 14 days. Timestamps are aligned to UTC midnight of the beginning of the day or week. Week begins on Monday.
   */
  "repos/get-clones": {
    parameters: {
      query: {
        per?: components["parameters"]["per"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["clone-traffic"];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get top referral paths
   * @description Get the top 10 popular contents over the last 14 days.
   */
  "repos/get-top-paths": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["content-traffic"][];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get top referral sources
   * @description Get the top 10 referrers over the last 14 days.
   */
  "repos/get-top-referrers": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["referrer-traffic"][];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get page views
   * @description Get the total number of views and breakdown per day or week for the last 14 days. Timestamps are aligned to UTC midnight of the beginning of the day or week. Week begins on Monday.
   */
  "repos/get-views": {
    parameters: {
      query: {
        per?: components["parameters"]["per"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["view-traffic"];
        };
      };
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Transfer a repository
   * @description A transfer request will need to be accepted by the new owner when transferring a personal repository to another user. The response will contain the original `owner`, and the transfer will continue asynchronously. For more details on the requirements to transfer personal and organization-owned repositories, see [about repository transfers](https://docs.github.com/articles/about-repository-transfers/).
   */
  "repos/transfer": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The username or organization name the repository will be transferred to. */
          new_owner: string;
          /** @description The new name to be given to the repository. */
          new_name?: string;
          /** @description ID of the team or teams to add to the repository. Teams can only be added to organization-owned repositories. */
          team_ids?: number[];
        };
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["minimal-repository"];
        };
      };
    };
  };
  /**
   * Check if vulnerability alerts are enabled for a repository
   * @description Shows whether dependency alerts are enabled or disabled for a repository. The authenticated user must have admin read access to the repository. For more information, see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
   */
  "repos/check-vulnerability-alerts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response if repository is enabled with vulnerability alerts */
      204: never;
      /** @description Not Found if repository is not enabled with vulnerability alerts */
      404: never;
    };
  };
  /**
   * Enable vulnerability alerts
   * @description Enables dependency alerts and the dependency graph for a repository. The authenticated user must have admin access to the repository. For more information, see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
   */
  "repos/enable-vulnerability-alerts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Disable vulnerability alerts
   * @description Disables dependency alerts and the dependency graph for a repository.
   * The authenticated user must have admin access to the repository. For more information,
   * see "[About security alerts for vulnerable dependencies](https://docs.github.com/articles/about-security-alerts-for-vulnerable-dependencies)".
   */
  "repos/disable-vulnerability-alerts": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Download a repository archive (zip)
   * @description Gets a redirect URL to download a zip archive for a repository. If you omit `:ref`, the repository’s default branch (usually
   * `main`) will be used. Please make sure your HTTP framework is configured to follow redirects or you will need to use
   * the `Location` header to make a second `GET` request.
   *
   * **Note**: For private repositories, these links are temporary and expire after five minutes. If the repository is empty, you will receive a 404 when you follow the redirect.
   */
  "repos/download-zipball-archive": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        ref: string;
      };
    };
    responses: {
      /** @description Response */
      302: never;
    };
  };
  /**
   * Create a repository using a template
   * @description Creates a new repository using a repository template. Use the `template_owner` and `template_repo` route parameters to specify the repository to use as the template. If the repository is not public, the authenticated user must own or be a member of an organization that owns the repository. To check if a repository is available to use as a template, get the repository's information using the [Get a repository](https://docs.github.com/rest/reference/repos#get-a-repository) endpoint and check that the `is_template` key is `true`.
   *
   * **OAuth scope requirements**
   *
   * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
   *
   * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
   * *   `repo` scope to create a private repository
   */
  "repos/create-using-template": {
    parameters: {
      path: {
        template_owner: string;
        template_repo: string;
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The organization or person who will own the new repository. To create a new repository in an organization, the authenticated user must be a member of the specified organization. */
          owner?: string;
          /** @description The name of the new repository. */
          name: string;
          /** @description A short description of the new repository. */
          description?: string;
          /**
           * @description Set to `true` to include the directory structure and files from all branches in the template repository, and not just the default branch. Default: `false`.
           * @default false
           */
          include_all_branches?: boolean;
          /**
           * @description Either `true` to create a new private repository or `false` to create a new public one.
           * @default false
           */
          private?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["repository"];
        };
      };
    };
  };
  /**
   * List public repositories
   * @description Lists all public repositories in the order that they were created.
   *
   * Note:
   * - For GitHub Enterprise Server, this endpoint will only list repositories available to all users on the enterprise.
   * - Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of repositories.
   */
  "repos/list-public": {
    parameters: {
      query: {
        since?: components["parameters"]["since-repo"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          /** @example <https://api.github.com/repositories?since=364>; rel="next" */
          Link?: string;
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List environment secrets
   * @description Lists all secrets available in an environment without revealing their encrypted values. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/list-environment-secrets": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["actions-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get an environment public key
   * @description Get the public key for an environment, which you need to encrypt environment secrets. You need to encrypt a secret before you can create or update secrets. Anyone with read access to the repository can use this endpoint. If the repository is private you must use an access token with the `repo` scope. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/get-environment-public-key": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-public-key"];
        };
      };
    };
  };
  /**
   * Get an environment secret
   * @description Gets a single environment secret without revealing its encrypted value. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/get-environment-secret": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-secret"];
        };
      };
    };
  };
  /**
   * Create or update an environment secret
   * @description Creates or updates an environment secret with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages). You must authenticate using an access
   * token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use
   * this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "actions/create-or-update-environment-secret": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get an environment public key](https://docs.github.com/rest/reference/actions#get-an-environment-public-key) endpoint. */
          encrypted_value: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id: string;
        };
      };
    };
    responses: {
      /** @description Response when creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response when updating a secret */
      204: never;
    };
  };
  /**
   * Delete an environment secret
   * @description Deletes a secret in an environment using the secret name. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `secrets` repository permission to use this endpoint.
   */
  "actions/delete-environment-secret": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Default response */
      204: never;
    };
  };
  /**
   * List environment variables
   * @description Lists all environment variables. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `environments:read` repository permission to use this endpoint.
   */
  "actions/list-environment-variables": {
    parameters: {
      query: {
        per_page?: components["parameters"]["variables-per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            variables: components["schemas"]["actions-variable"][];
          };
        };
      };
    };
  };
  /**
   * Create an environment variable
   * @description Create an environment variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
   */
  "actions/create-environment-variable": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name: string;
          /** @description The value of the variable. */
          value: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
    };
  };
  /**
   * Get an environment variable
   * @description Gets a specific variable in an environment. You must authenticate using an access token with the `repo` scope to use this endpoint. GitHub Apps must have the `environments:read` repository permission to use this endpoint.
   */
  "actions/get-environment-variable": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        environment_name: components["parameters"]["environment-name"];
        name: components["parameters"]["variable-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-variable"];
        };
      };
    };
  };
  /**
   * Delete an environment variable
   * @description Deletes an environment variable using the variable name.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
   */
  "actions/delete-environment-variable": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        name: components["parameters"]["variable-name"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update an environment variable
   * @description Updates an environment variable that you can reference in a GitHub Actions workflow.
   * You must authenticate using an access token with the `repo` scope to use this endpoint.
   * GitHub Apps must have the `environment:write` repository permission to use this endpoint.
   */
  "actions/update-environment-variable": {
    parameters: {
      path: {
        repository_id: components["parameters"]["repository-id"];
        name: components["parameters"]["variable-name"];
        environment_name: components["parameters"]["environment-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the variable. */
          name?: string;
          /** @description The value of the variable. */
          value?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Search code
   * @description Searches for query terms inside of a file. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for code, you can get text match metadata for the file **content** and file **path** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to find the definition of the `addClass` function inside [jQuery](https://github.com/jquery/jquery) repository, your query would look something like this:
   *
   * `q=addClass+in:file+language:js+repo:jquery/jquery`
   *
   * This query searches for the keyword `addClass` within a file's contents. The query limits the search to files where the language is JavaScript in the `jquery/jquery` repository.
   *
   * #### Considerations for code search
   *
   * Due to the complexity of searching code, there are a few restrictions on how searches are performed:
   *
   * *   Only the _default branch_ is considered. In most cases, this will be the `master` branch.
   * *   Only files smaller than 384 KB are searchable.
   * *   You must always include at least one search term when searching source code. For example, searching for [`language:go`](https://github.com/search?utf8=%E2%9C%93&q=language%3Ago&type=Code) is not valid, while [`amazing
   * language:go`](https://github.com/search?utf8=%E2%9C%93&q=amazing+language%3Ago&type=Code) is.
   *
   * This endpoint requires you to authenticate and limits you to 10 requests per minute.
   */
  "search/code": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). See "[Searching code](https://docs.github.com/search-github/searching-on-github/searching-code)" for a detailed list of qualifiers. */
        q: string;
        /**
         * @deprecated
         * @description **This field is deprecated.** Sorts the results of your query. Can only be `indexed`, which indicates how recently a file has been indexed by the GitHub search infrastructure. Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results)
         */
        sort?: "indexed";
        /**
         * @deprecated
         * @description **This field is deprecated.** Determines whether the first search result returned is the highest number of matches (`desc`) or lowest number of matches (`asc`). This parameter is ignored unless you provide `sort`.
         */
        order?: "desc" | "asc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["code-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Search commits
   * @description Find commits via various criteria on the default branch (usually `main`). This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for commits, you can get text match metadata for the **message** field when you provide the `text-match` media type. For more details about how to receive highlighted search results, see [Text match
   * metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to find commits related to CSS in the [octocat/Spoon-Knife](https://github.com/octocat/Spoon-Knife) repository. Your query would look something like this:
   *
   * `q=repo:octocat/Spoon-Knife+css`
   */
  "search/commits": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). See "[Searching commits](https://docs.github.com/search-github/searching-on-github/searching-commits)" for a detailed list of qualifiers. */
        q: string;
        /** @description Sorts the results of your query by `author-date` or `committer-date`. Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results) */
        sort?: "author-date" | "committer-date";
        order?: components["parameters"]["order"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["commit-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Search issues and pull requests
   * @description Find issues by state and keyword. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for issues, you can get text match metadata for the issue **title**, issue **body**, and issue **comment body** fields when you pass the `text-match` media type. For more details about how to receive highlighted
   * search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to find the oldest unresolved Python bugs on Windows. Your query might look something like this.
   *
   * `q=windows+label:bug+language:python+state:open&sort=created&order=asc`
   *
   * This query searches for the keyword `windows`, within any open issue that is labeled as `bug`. The search runs across repositories whose primary language is Python. The results are sorted by creation date in ascending order, which means the oldest issues appear first in the search results.
   *
   * **Note:** For [user-to-server](https://docs.github.com/developers/apps/identifying-and-authorizing-users-for-github-apps#user-to-server-requests) GitHub App requests, you can't retrieve a combination of issues and pull requests in a single query. Requests that don't include the `is:issue` or `is:pull-request` qualifier will receive an HTTP `422 Unprocessable Entity` response. To get results for both issues and pull requests, you must send separate queries for issues and pull requests. For more information about the `is` qualifier, see "[Searching only issues or pull requests](https://docs.github.com/github/searching-for-information-on-github/searching-issues-and-pull-requests#search-only-issues-or-pull-requests)."
   */
  "search/issues-and-pull-requests": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). See "[Searching issues and pull requests](https://docs.github.com/search-github/searching-on-github/searching-issues-and-pull-requests)" for a detailed list of qualifiers. */
        q: string;
        /** @description Sorts the results of your query by the number of `comments`, `reactions`, `reactions-+1`, `reactions--1`, `reactions-smile`, `reactions-thinking_face`, `reactions-heart`, `reactions-tada`, or `interactions`. You can also sort results by how recently the items were `created` or `updated`, Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results) */
        sort?:
          | "comments"
          | "reactions"
          | "reactions-+1"
          | "reactions--1"
          | "reactions-smile"
          | "reactions-thinking_face"
          | "reactions-heart"
          | "reactions-tada"
          | "interactions"
          | "created"
          | "updated";
        order?: components["parameters"]["order"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["issue-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Search labels
   * @description Find labels in a repository with names or descriptions that match search keywords. Returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for labels, you can get text match metadata for the label **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to find labels in the `linguist` repository that match `bug`, `defect`, or `enhancement`. Your query might look like this:
   *
   * `q=bug+defect+enhancement&repository_id=64778136`
   *
   * The labels that best match the query appear first in the search results.
   */
  "search/labels": {
    parameters: {
      query: {
        /** @description The id of the repository. */
        repository_id: number;
        /** @description The search keywords. This endpoint does not accept qualifiers in the query. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). */
        q: string;
        /** @description Sorts the results of your query by when the label was `created` or `updated`. Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results) */
        sort?: "created" | "updated";
        order?: components["parameters"]["order"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["label-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Search repositories
   * @description Find repositories via various criteria. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for repositories, you can get text match metadata for the **name** and **description** fields when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to search for popular Tetris repositories written in assembly code, your query might look like this:
   *
   * `q=tetris+language:assembly&sort=stars&order=desc`
   *
   * This query searches for repositories with the word `tetris` in the name, the description, or the README. The results are limited to repositories where the primary language is assembly. The results are sorted by stars in descending order, so that the most popular repositories appear first in the search results.
   */
  "search/repos": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). See "[Searching for repositories](https://docs.github.com/articles/searching-for-repositories/)" for a detailed list of qualifiers. */
        q: string;
        /** @description Sorts the results of your query by number of `stars`, `forks`, or `help-wanted-issues` or how recently the items were `updated`. Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results) */
        sort?: "stars" | "forks" | "help-wanted-issues" | "updated";
        order?: components["parameters"]["order"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["repo-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Search topics
   * @description Find topics via various criteria. Results are sorted by best match. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination). See "[Searching topics](https://docs.github.com/articles/searching-topics/)" for a detailed list of qualifiers.
   *
   * When searching for topics, you can get text match metadata for the topic's **short\_description**, **description**, **name**, or **display\_name** field when you pass the `text-match` media type. For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you want to search for topics related to Ruby that are featured on https://github.com/topics. Your query might look like this:
   *
   * `q=ruby+is:featured`
   *
   * This query searches for topics with the keyword `ruby` and limits the results to find only topics that are featured. The topics that are the best match for the query appear first in the search results.
   */
  "search/topics": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). */
        q: string;
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["topic-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Search users
   * @description Find users via various criteria. This method returns up to 100 results [per page](https://docs.github.com/rest/overview/resources-in-the-rest-api#pagination).
   *
   * When searching for users, you can get text match metadata for the issue **login**, public **email**, and **name** fields when you pass the `text-match` media type. For more details about highlighting search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata). For more details about how to receive highlighted search results, see [Text match metadata](https://docs.github.com/rest/reference/search#text-match-metadata).
   *
   * For example, if you're looking for a list of popular users, you might try this query:
   *
   * `q=tom+repos:%3E42+followers:%3E1000`
   *
   * This query searches for users with the name `tom`. The results are restricted to users with more than 42 repositories and over 1,000 followers.
   */
  "search/users": {
    parameters: {
      query: {
        /** @description The query contains one or more search keywords and qualifiers. Qualifiers allow you to limit your search to specific areas of GitHub. The REST API supports the same qualifiers as the web interface for GitHub. To learn more about the format of the query, see [Constructing a search query](https://docs.github.com/rest/reference/search#constructing-a-search-query). See "[Searching users](https://docs.github.com/search-github/searching-on-github/searching-users)" for a detailed list of qualifiers. */
        q: string;
        /** @description Sorts the results of your query by number of `followers` or `repositories`, or when the person `joined` GitHub. Default: [best match](https://docs.github.com/rest/reference/search#ranking-search-results) */
        sort?: "followers" | "repositories" | "joined";
        order?: components["parameters"]["order"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            incomplete_results: boolean;
            items: components["schemas"]["user-search-result-item"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      422: components["responses"]["validation_failed"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * Get a team (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the [Get a team by name](https://docs.github.com/rest/reference/teams#get-a-team-by-name) endpoint.
   */
  "teams/get-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a team (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a team](https://docs.github.com/rest/reference/teams#delete-a-team) endpoint.
   *
   * To delete a team, the authenticated user must be an organization owner or team maintainer.
   *
   * If you are an organization owner, deleting a parent team will delete all of its child teams as well.
   */
  "teams/delete-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Update a team (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a team](https://docs.github.com/rest/reference/teams#update-a-team) endpoint.
   *
   * To edit a team, the authenticated user must either be an organization owner or a team maintainer.
   *
   * **Note:** With nested teams, the `privacy` for parent teams cannot be `secret`.
   */
  "teams/update-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The name of the team. */
          name: string;
          /** @description The description of the team. */
          description?: string;
          /**
           * @description The level of privacy this team should have. Editing teams without specifying this parameter leaves `privacy` intact. The options are:
           * **For a non-nested team:**
           *  * `secret` - only visible to organization owners and members of this team.
           *  * `closed` - visible to all members of this organization.
           * **For a parent or child team:**
           *  * `closed` - visible to all members of this organization.
           * @enum {string}
           */
          privacy?: "secret" | "closed";
          /**
           * @description The notification setting the team has chosen. Editing teams without specifying this parameter leaves `notification_setting` intact. The options are:
           *  * `notifications_enabled` - team members receive notifications when the team is @mentioned.
           *  * `notifications_disabled` - no one receives notifications.
           * @enum {string}
           */
          notification_setting?:
            | "notifications_enabled"
            | "notifications_disabled";
          /**
           * @description **Deprecated**. The permission that new repositories will be added to the team with when none is specified.
           * @default pull
           * @enum {string}
           */
          permission?: "pull" | "push" | "admin";
          /** @description The ID of a team to set as the parent team. */
          parent_team_id?: number | null;
        };
      };
    };
    responses: {
      /** @description Response when the updated information already exists */
      200: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-full"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List discussions (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List discussions`](https://docs.github.com/rest/reference/teams#list-discussions) endpoint.
   *
   * List all discussions on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/list-discussions-legacy": {
    parameters: {
      query: {
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-discussion"][];
        };
      };
    };
  };
  /**
   * Create a discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create a discussion`](https://docs.github.com/rest/reference/teams#create-a-discussion) endpoint.
   *
   * Creates a new discussion post on a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "teams/create-discussion-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion post's title. */
          title: string;
          /** @description The discussion post's body text. */
          body: string;
          /**
           * @description Private posts are only visible to team members, organization owners, and team maintainers. Public posts are visible to all members of the organization. Set to `true` to create a private post.
           * @default false
           */
          private?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * Get a discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion](https://docs.github.com/rest/reference/teams#get-a-discussion) endpoint.
   *
   * Get a specific discussion on a team's page. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/get-discussion-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * Delete a discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Delete a discussion`](https://docs.github.com/rest/reference/teams#delete-a-discussion) endpoint.
   *
   * Delete a discussion from a team's page. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/delete-discussion-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion](https://docs.github.com/rest/reference/teams#update-a-discussion) endpoint.
   *
   * Edits the title and body text of a discussion post. Only the parameters you provide are updated. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/update-discussion-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description The discussion post's title. */
          title?: string;
          /** @description The discussion post's body text. */
          body?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion"];
        };
      };
    };
  };
  /**
   * List discussion comments (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List discussion comments](https://docs.github.com/rest/reference/teams#list-discussion-comments) endpoint.
   *
   * List all comments on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/list-discussion-comments-legacy": {
    parameters: {
      query: {
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-discussion-comment"][];
        };
      };
    };
  };
  /**
   * Create a discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Create a discussion comment](https://docs.github.com/rest/reference/teams#create-a-discussion-comment) endpoint.
   *
   * Creates a new comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   *
   * This endpoint triggers [notifications](https://docs.github.com/github/managing-subscriptions-and-notifications-on-github/about-notifications). Creating content too quickly using this endpoint may result in secondary rate limiting. See "[Secondary rate limits](https://docs.github.com/rest/overview/resources-in-the-rest-api#secondary-rate-limits)" and "[Dealing with secondary rate limits](https://docs.github.com/rest/guides/best-practices-for-integrators#dealing-with-secondary-rate-limits)" for details.
   */
  "teams/create-discussion-comment-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion comment's body text. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * Get a discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get a discussion comment](https://docs.github.com/rest/reference/teams#get-a-discussion-comment) endpoint.
   *
   * Get a specific comment on a team discussion. OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/get-discussion-comment-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * Delete a discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Delete a discussion comment](https://docs.github.com/rest/reference/teams#delete-a-discussion-comment) endpoint.
   *
   * Deletes a comment on a team discussion. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/delete-discussion-comment-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * Update a discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Update a discussion comment](https://docs.github.com/rest/reference/teams#update-a-discussion-comment) endpoint.
   *
   * Edits the body text of a discussion comment. OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "teams/update-discussion-comment-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description The discussion comment's body text. */
          body: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-discussion-comment"];
        };
      };
    };
  };
  /**
   * List reactions for a team discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion comment`](https://docs.github.com/rest/reference/reactions#list-reactions-for-a-team-discussion-comment) endpoint.
   *
   * List the reactions to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "reactions/list-for-team-discussion-comment-legacy": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a team discussion comment. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
    };
  };
  /**
   * Create reaction for a team discussion comment (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Create reaction for a team discussion comment](https://docs.github.com/rest/reference/reactions#create-reaction-for-a-team-discussion-comment)" endpoint.
   *
   * Create a reaction to a [team discussion comment](https://docs.github.com/rest/reference/teams#discussion-comments). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion comment.
   */
  "reactions/create-for-team-discussion-comment-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
        comment_number: components["parameters"]["comment-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the team discussion comment.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
    };
  };
  /**
   * List reactions for a team discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List reactions for a team discussion`](https://docs.github.com/rest/reference/reactions#list-reactions-for-a-team-discussion) endpoint.
   *
   * List the reactions to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `read:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "reactions/list-for-team-discussion-legacy": {
    parameters: {
      query: {
        /** @description Returns a single [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types). Omit this parameter to list all reactions to a team discussion. */
        content?:
          | "+1"
          | "-1"
          | "laugh"
          | "confused"
          | "heart"
          | "hooray"
          | "rocket"
          | "eyes";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["reaction"][];
        };
      };
    };
  };
  /**
   * Create reaction for a team discussion (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`Create reaction for a team discussion`](https://docs.github.com/rest/reference/reactions#create-reaction-for-a-team-discussion) endpoint.
   *
   * Create a reaction to a [team discussion](https://docs.github.com/rest/reference/teams#discussions). OAuth access tokens require the `write:discussion` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/). A response with an HTTP `200` status means that you already added the reaction type to this team discussion.
   */
  "reactions/create-for-team-discussion-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        discussion_number: components["parameters"]["discussion-number"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The [reaction type](https://docs.github.com/rest/reference/reactions#reaction-types) to add to the team discussion.
           * @enum {string}
           */
          content:
            | "+1"
            | "-1"
            | "laugh"
            | "confused"
            | "heart"
            | "hooray"
            | "rocket"
            | "eyes";
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["reaction"];
        };
      };
    };
  };
  /**
   * List pending team invitations (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List pending team invitations`](https://docs.github.com/rest/reference/teams#list-pending-team-invitations) endpoint.
   *
   * The return hash contains a `role` field which refers to the Organization Invitation role and will be one of the following values: `direct_member`, `admin`, `billing_manager`, `hiring_manager`, or `reinstate`. If the invitee is not a GitHub member, the `login` field in the return hash will be `null`.
   */
  "teams/list-pending-invitations-legacy": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-invitation"][];
        };
      };
    };
  };
  /**
   * List team members (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team members`](https://docs.github.com/rest/reference/teams#list-team-members) endpoint.
   *
   * Team members will include the members of child teams.
   */
  "teams/list-members-legacy": {
    parameters: {
      query: {
        /** @description Filters members returned by their role in the team. */
        role?: "member" | "maintainer" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get team member (Legacy)
   * @deprecated
   * @description The "Get team member" endpoint (described below) is deprecated.
   *
   * We recommend using the [Get team membership for a user](https://docs.github.com/rest/reference/teams#get-team-membership-for-a-user) endpoint instead. It allows you to get both active and pending memberships.
   *
   * To list members in a team, the team must be visible to the authenticated user.
   */
  "teams/get-member-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description if user is a member */
      204: never;
      /** @description if user is not a member */
      404: never;
    };
  };
  /**
   * Add team member (Legacy)
   * @deprecated
   * @description The "Add team member" endpoint (described below) is deprecated.
   *
   * We recommend using the [Add or update team membership for a user](https://docs.github.com/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint instead. It allows you to invite new organization members to your teams.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * To add someone to a team, the authenticated user must be an organization owner or a team maintainer in the team they're changing. The person being added to the team must be a member of the team's organization.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   *
   * Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "teams/add-member-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      /** @description Not Found if team synchronization is set up */
      404: never;
      /** @description Unprocessable Entity if you attempt to add an organization to a team or you attempt to add a user to a team when they are not a member of at least one other team in the same organization */
      422: never;
    };
  };
  /**
   * Remove team member (Legacy)
   * @deprecated
   * @description The "Remove team member" endpoint (described below) is deprecated.
   *
   * We recommend using the [Remove team membership for a user](https://docs.github.com/rest/reference/teams#remove-team-membership-for-a-user) endpoint instead. It allows you to remove both active and pending memberships.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * To remove a team member, the authenticated user must have 'admin' permissions to the team or be an owner of the org that the team is associated with. Removing a team member does not delete the user, it just removes them from the team.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   */
  "teams/remove-member-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Not Found if team synchronization is setup */
      404: never;
    };
  };
  /**
   * Get team membership for a user (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Get team membership for a user](https://docs.github.com/rest/reference/teams#get-team-membership-for-a-user) endpoint.
   *
   * Team members will include the members of child teams.
   *
   * To get a user's membership with a team, the team must be visible to the authenticated user.
   *
   * **Note:**
   * The response contains the `state` of the membership and the member's `role`.
   *
   * The `role` for organization owners is set to `maintainer`. For more information about `maintainer` roles, see [Create a team](https://docs.github.com/rest/reference/teams#create-a-team).
   */
  "teams/get-membership-for-user-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-membership"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Add or update team membership for a user (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team membership for a user](https://docs.github.com/rest/reference/teams#add-or-update-team-membership-for-a-user) endpoint.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * If the user is already a member of the team's organization, this endpoint will add the user to the team. To add a membership between an organization member and a team, the authenticated user must be an organization owner or a team maintainer.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   *
   * If the user is unaffiliated with the team's organization, this endpoint will send an invitation to the user via email. This newly-created membership will be in the "pending" state until the user accepts the invitation, at which point the membership will transition to the "active" state and the user will be added as a member of the team. To add a membership between an unaffiliated user and a team, the authenticated user must be an organization owner.
   *
   * If the user is already a member of the team, this endpoint will update the role of the team member's role. To update the membership of a team member, the authenticated user must be an organization owner or a team maintainer.
   */
  "teams/add-or-update-membership-for-user-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The role that this user should have in the team.
           * @default member
           * @enum {string}
           */
          role?: "member" | "maintainer";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-membership"];
        };
      };
      /** @description Forbidden if team synchronization is set up */
      403: never;
      404: components["responses"]["not_found"];
      /** @description Unprocessable Entity if you attempt to add an organization to a team */
      422: never;
    };
  };
  /**
   * Remove team membership for a user (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove team membership for a user](https://docs.github.com/rest/reference/teams#remove-team-membership-for-a-user) endpoint.
   *
   * Team synchronization is available for organizations using GitHub Enterprise Cloud. For more information, see [GitHub's products](https://docs.github.com/github/getting-started-with-github/githubs-products) in the GitHub Help documentation.
   *
   * To remove a membership between a user and a team, the authenticated user must have 'admin' permissions to the team or be an owner of the organization that the team is associated with. Removing team membership does not delete the user, it just removes their membership from the team.
   *
   * **Note:** When you have team synchronization set up for a team with your organization's identity provider (IdP), you will see an error if you attempt to use the API for making changes to the team's membership. If you have access to manage group membership in your IdP, you can manage GitHub team membership through your identity provider, which automatically adds and removes team members in an organization. For more information, see "[Synchronizing teams between your identity provider and GitHub](https://docs.github.com/articles/synchronizing-teams-between-your-identity-provider-and-github/)."
   */
  "teams/remove-membership-for-user-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description if team synchronization is set up */
      403: never;
    };
  };
  /**
   * List team projects (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List team projects`](https://docs.github.com/rest/reference/teams#list-team-projects) endpoint.
   *
   * Lists the organization projects for a team.
   */
  "teams/list-projects-legacy": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-project"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Check team permissions for a project (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a project](https://docs.github.com/rest/reference/teams#check-team-permissions-for-a-project) endpoint.
   *
   * Checks whether a team has `read`, `write`, or `admin` permissions for an organization project. The response includes projects inherited from a parent team.
   */
  "teams/check-permissions-for-project-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["team-project"];
        };
      };
      /** @description Not Found if project is not managed by this team */
      404: never;
    };
  };
  /**
   * Add or update team project permissions (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Add or update team project permissions](https://docs.github.com/rest/reference/teams#add-or-update-team-project-permissions) endpoint.
   *
   * Adds an organization project to a team. To add a project to a team or update the team's permission on a project, the authenticated user must have `admin` permissions for the project. The project and team must be part of the same organization.
   */
  "teams/add-or-update-project-permissions-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        project_id: components["parameters"]["project-id"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant to the team for this project. Default: the team's `permission` attribute will be used to determine what permission to grant the team on this project. Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
           * @enum {string}
           */
          permission?: "read" | "write" | "admin";
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      /** @description Forbidden if the project is not owned by the organization */
      403: {
        content: {
          "application/json": {
            message?: string;
            documentation_url?: string;
          };
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove a project from a team (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a project from a team](https://docs.github.com/rest/reference/teams#remove-a-project-from-a-team) endpoint.
   *
   * Removes an organization project from a team. An organization owner or a team maintainer can remove any project from the team. To remove a project from a team as an organization member, the authenticated user must have `read` access to both the team and project, or `admin` access to the team or project. **Note:** This endpoint removes the project from the team, but does not delete it.
   */
  "teams/remove-project-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        project_id: components["parameters"]["project-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List team repositories (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [List team repositories](https://docs.github.com/rest/reference/teams#list-team-repositories) endpoint.
   */
  "teams/list-repos-legacy": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Check team permissions for a repository (Legacy)
   * @deprecated
   * @description **Note**: Repositories inherited through a parent team will also be checked.
   *
   * **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Check team permissions for a repository](https://docs.github.com/rest/reference/teams#check-team-permissions-for-a-repository) endpoint.
   *
   * You can also get information about the specified repository, including what permissions the team grants on it, by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header:
   */
  "teams/check-permissions-for-repo-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Alternative response with extra repository information */
      200: {
        content: {
          "application/json": components["schemas"]["team-repository"];
        };
      };
      /** @description Response if repository is managed by this team */
      204: never;
      /** @description Not Found if repository is not managed by this team */
      404: never;
    };
  };
  /**
   * Add or update team repository permissions (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new "[Add or update team repository permissions](https://docs.github.com/rest/reference/teams#add-or-update-team-repository-permissions)" endpoint.
   *
   * To add a repository to a team or update the team's permission on a repository, the authenticated user must have admin access to the repository, and must be able to see the team. The repository must be owned by the organization, or a direct fork of a repository owned by the organization. You will get a `422 Unprocessable Entity` status if you attempt to add a repository to a team that is not owned by the organization.
   *
   * Note that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "teams/add-or-update-repo-permissions-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The permission to grant the team on this repository. If no permission is specified, the team's `permission` attribute will be used to determine what permission to grant the team on this repository.
           * @enum {string}
           */
          permission?: "pull" | "push" | "admin";
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove a repository from a team (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [Remove a repository from a team](https://docs.github.com/rest/reference/teams#remove-a-repository-from-a-team) endpoint.
   *
   * If the authenticated user is an organization owner or a team maintainer, they can remove any repositories from the team. To remove a repository from a team as an organization member, the authenticated user must have admin access to the repository and must be able to see the team. NOTE: This does not delete the repository, it just removes it from the team.
   */
  "teams/remove-repo-legacy": {
    parameters: {
      path: {
        team_id: components["parameters"]["team-id"];
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List child teams (Legacy)
   * @deprecated
   * @description **Deprecation Notice:** This endpoint route is deprecated and will be removed from the Teams API. We recommend migrating your existing code to use the new [`List child teams`](https://docs.github.com/rest/reference/teams#list-child-teams) endpoint.
   */
  "teams/list-child-legacy": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        team_id: components["parameters"]["team-id"];
      };
    };
    responses: {
      /** @description if child teams exist */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team"][];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get the authenticated user
   * @description If the authenticated user is authenticated through basic authentication or OAuth with the `user` scope, then the response lists public and private profile information.
   *
   * If the authenticated user is authenticated through OAuth without the `user` scope, then the response lists only public profile information.
   */
  "users/get-authenticated": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json":
            | components["schemas"]["private-user"]
            | components["schemas"]["public-user"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Update the authenticated user
   * @description **Note:** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
   */
  "users/update-authenticated": {
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description The new name of the user.
           * @example Omar Jahandar
           */
          name?: string;
          /**
           * @description The publicly visible email address of the user.
           * @example omar@example.com
           */
          email?: string;
          /**
           * @description The new blog URL of the user.
           * @example blog.example.com
           */
          blog?: string;
          /**
           * @description The new Twitter username of the user.
           * @example therealomarj
           */
          twitter_username?: string | null;
          /**
           * @description The new company of the user.
           * @example Acme corporation
           */
          company?: string;
          /**
           * @description The new location of the user.
           * @example Berlin, Germany
           */
          location?: string;
          /** @description The new hiring availability of the user. */
          hireable?: boolean;
          /** @description The new short biography of the user. */
          bio?: string;
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["private-user"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List users blocked by the authenticated user
   * @description List the users you've blocked on your personal account.
   */
  "users/list-blocked-by-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Check if a user is blocked by the authenticated user */
  "users/check-blocked": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description If the user is blocked */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      /** @description If the user is not blocked */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /** Block a user */
  "users/block": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Unblock a user */
  "users/unblock": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List codespaces for the authenticated user
   * @description Lists the authenticated user's codespaces.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/list-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        repository_id?: components["parameters"]["repository-id-in-query"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            codespaces: components["schemas"]["codespace"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Create a codespace for the authenticated user
   * @description Creates a new codespace, owned by the authenticated user.
   *
   * This endpoint requires either a `repository_id` OR a `pull_request` but not both.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/create-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": OneOf<
          [
            {
              /** @description Repository id for this codespace */
              repository_id: number;
              /** @description Git ref (typically a branch name) for this codespace */
              ref?: string;
              /** @description The requested location for a new codespace. Best efforts are made to respect this upon creation. Assigned by IP if not provided. */
              location?: string;
              /** @description IP for location auto-detection when proxying a request */
              client_ip?: string;
              /** @description Machine type to use for this codespace */
              machine?: string;
              /** @description Path to devcontainer.json config to use for this codespace */
              devcontainer_path?: string;
              /** @description Whether to authorize requested permissions from devcontainer.json */
              multi_repo_permissions_opt_out?: boolean;
              /** @description Working directory for this codespace */
              working_directory?: string;
              /** @description Time in minutes before codespace stops from inactivity */
              idle_timeout_minutes?: number;
              /** @description Display name for this codespace */
              display_name?: string;
              /** @description Duration in minutes after codespace has gone idle in which it will be deleted. Must be integer minutes between 0 and 43200 (30 days). */
              retention_period_minutes?: number;
            },
            {
              /** @description Pull request number for this codespace */
              pull_request: {
                /** @description Pull request number */
                pull_request_number: number;
                /** @description Repository id for this codespace */
                repository_id: number;
              };
              /** @description The requested location for a new codespace. Best efforts are made to respect this upon creation. Assigned by IP if not provided. */
              location?: string;
              /** @description Machine type to use for this codespace */
              machine?: string;
              /** @description Path to devcontainer.json config to use for this codespace */
              devcontainer_path?: string;
              /** @description Working directory for this codespace */
              working_directory?: string;
              /** @description Time in minutes before codespace stops from inactivity */
              idle_timeout_minutes?: number;
            }
          ]
        >;
      };
    };
    responses: {
      /** @description Response when the codespace was successfully created */
      201: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      /** @description Response when the codespace creation partially failed but is being retried in the background */
      202: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      503: components["responses"]["service_unavailable"];
    };
  };
  /**
   * List secrets for the authenticated user
   * @description Lists all secrets available for a user's Codespaces without revealing their
   * encrypted values.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
   */
  "codespaces/list-secrets-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            secrets: components["schemas"]["codespaces-secret"][];
          };
        };
      };
    };
  };
  /**
   * Get public key for the authenticated user
   * @description Gets your public key, which you need to encrypt secrets. You need to encrypt a secret before you can create or update secrets.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
   */
  "codespaces/get-public-key-for-authenticated-user": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespaces-user-public-key"];
        };
      };
    };
  };
  /**
   * Get a secret for the authenticated user
   * @description Gets a secret available to a user's codespaces without revealing its encrypted value.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_user_secrets` user permission to use this endpoint.
   */
  "codespaces/get-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespaces-secret"];
        };
      };
    };
  };
  /**
   * Create or update a secret for the authenticated user
   * @description Creates or updates a secret for a user's codespace with an encrypted value. Encrypt your secret using
   * [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages).
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must also have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
   *
   * #### Example encrypting a secret using Node.js
   *
   * Encrypt your secret using the [libsodium-wrappers](https://www.npmjs.com/package/libsodium-wrappers) library.
   *
   * ```
   * const sodium = require('libsodium-wrappers')
   * const secret = 'plain-text-secret' // replace with the secret you want to encrypt
   * const key = 'base64-encoded-public-key' // replace with the Base64 encoded public key
   *
   * //Check if libsodium is ready and then proceed.
   * sodium.ready.then(() => {
   *   // Convert Secret & Base64 key to Uint8Array.
   *   let binkey = sodium.from_base64(key, sodium.base64_variants.ORIGINAL)
   *   let binsec = sodium.from_string(secret)
   *
   *   //Encrypt the secret using LibSodium
   *   let encBytes = sodium.crypto_box_seal(binsec, binkey)
   *
   *   // Convert encrypted Uint8Array to Base64
   *   let output = sodium.to_base64(encBytes, sodium.base64_variants.ORIGINAL)
   *
   *   console.log(output)
   * });
   * ```
   *
   * #### Example encrypting a secret using Python
   *
   * Encrypt your secret using [pynacl](https://pynacl.readthedocs.io/en/latest/public/#nacl-public-sealedbox) with Python 3.
   *
   * ```
   * from base64 import b64encode
   * from nacl import encoding, public
   *
   * def encrypt(public_key: str, secret_value: str) -> str:
   *   """Encrypt a Unicode string using the public key."""
   *   public_key = public.PublicKey(public_key.encode("utf-8"), encoding.Base64Encoder())
   *   sealed_box = public.SealedBox(public_key)
   *   encrypted = sealed_box.encrypt(secret_value.encode("utf-8"))
   *   return b64encode(encrypted).decode("utf-8")
   * ```
   *
   * #### Example encrypting a secret using C#
   *
   * Encrypt your secret using the [Sodium.Core](https://www.nuget.org/packages/Sodium.Core/) package.
   *
   * ```
   * var secretValue = System.Text.Encoding.UTF8.GetBytes("mySecret");
   * var publicKey = Convert.FromBase64String("2Sg8iYjAxxmI2LvUXpJjkYrMxURPc8r+dB7TJyvvcCU=");
   *
   * var sealedPublicKeyBox = Sodium.SealedPublicKeyBox.Create(secretValue, publicKey);
   *
   * Console.WriteLine(Convert.ToBase64String(sealedPublicKeyBox));
   * ```
   *
   * #### Example encrypting a secret using Ruby
   *
   * Encrypt your secret using the [rbnacl](https://github.com/RubyCrypto/rbnacl) gem.
   *
   * ```ruby
   * require "rbnacl"
   * require "base64"
   *
   * key = Base64.decode64("+ZYvJDZMHUfBkJdyq5Zm9SKqeuBQ4sj+6sfjlH4CgG0=")
   * public_key = RbNaCl::PublicKey.new(key)
   *
   * box = RbNaCl::Boxes::Sealed.from_public_key(public_key)
   * encrypted_secret = box.encrypt("my_secret")
   *
   * # Print the base64 encoded secret
   * puts Base64.strict_encode64(encrypted_secret)
   * ```
   */
  "codespaces/create-or-update-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description Value for your secret, encrypted with [LibSodium](https://libsodium.gitslider.io/doc/bindings_for_other_languages) using the public key retrieved from the [Get the public key for the authenticated user](https://docs.github.com/rest/reference/codespaces#get-the-public-key-for-the-authenticated-user) endpoint. */
          encrypted_value?: string;
          /** @description ID of the key you used to encrypt the secret. */
          key_id: string;
          /** @description An array of repository ids that can access the user secret. You can manage the list of selected repositories using the [List selected repositories for a user secret](https://docs.github.com/rest/reference/codespaces#list-selected-repositories-for-a-user-secret), [Set selected repositories for a user secret](https://docs.github.com/rest/reference/codespaces#set-selected-repositories-for-a-user-secret), and [Remove a selected repository from a user secret](https://docs.github.com/rest/reference/codespaces#remove-a-selected-repository-from-a-user-secret) endpoints. */
          selected_repository_ids?: (number | string)[];
        };
      };
    };
    responses: {
      /** @description Response after successfully creating a secret */
      201: {
        content: {
          "application/json": components["schemas"]["empty-object"];
        };
      };
      /** @description Response after successfully updating a secret */
      204: never;
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete a secret for the authenticated user
   * @description Deletes a secret from a user's codespaces using the secret name. Deleting the secret will remove access from all codespaces that were allowed to access the secret.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_user_secrets` user permission to use this endpoint.
   */
  "codespaces/delete-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List selected repositories for a user secret
   * @description List the repositories that have been granted the ability to use a user's codespace secret.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
   */
  "codespaces/list-repositories-for-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            repositories: components["schemas"]["minimal-repository"][];
          };
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Set selected repositories for a user secret
   * @description Select the repositories that will use a user's codespace secret.
   *
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on all referenced repositories to use this endpoint.
   */
  "codespaces/set-repositories-for-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description An array of repository ids for which a codespace can access the secret. You can manage the list of selected repositories using the [List selected repositories for a user secret](https://docs.github.com/rest/reference/codespaces#list-selected-repositories-for-a-user-secret), [Add a selected repository to a user secret](https://docs.github.com/rest/reference/codespaces#add-a-selected-repository-to-a-user-secret), and [Remove a selected repository from a user secret](https://docs.github.com/rest/reference/codespaces#remove-a-selected-repository-from-a-user-secret) endpoints. */
          selected_repository_ids: number[];
        };
      };
    };
    responses: {
      /** @description No Content when repositories were added to the selected list */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Add a selected repository to a user secret
   * @description Adds a repository to the selected repositories for a user's codespace secret.
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   * GitHub Apps must have write access to the `codespaces_user_secrets` user permission and write access to the `codespaces_secrets` repository permission on the referenced repository to use this endpoint.
   */
  "codespaces/add-repository-for-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description No Content when repository was added to the selected list */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Remove a selected repository from a user secret
   * @description Removes a repository from the selected repositories for a user's codespace secret.
   * You must authenticate using an access token with the `codespace` or `codespace:secrets` scope to use this endpoint. User must have Codespaces access to use this endpoint.
   * GitHub Apps must have write access to the `codespaces_user_secrets` user permission to use this endpoint.
   */
  "codespaces/remove-repository-for-secret-for-authenticated-user": {
    parameters: {
      path: {
        secret_name: components["parameters"]["secret-name"];
        repository_id: number;
      };
    };
    responses: {
      /** @description No Content when repository was removed from the selected list */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get a codespace for the authenticated user
   * @description Gets information about a user's codespace.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/get-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Delete a codespace for the authenticated user
   * @description Deletes a user's codespace.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/delete-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      202: components["responses"]["accepted"];
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Update a codespace for the authenticated user
   * @description Updates a codespace owned by the authenticated user. Currently only the codespace's machine type and recent folders can be modified using this endpoint.
   *
   * If you specify a new machine type it will be applied the next time your codespace is started.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/update-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    requestBody?: {
      content: {
        "application/json": {
          /** @description A valid machine to transition this codespace to. */
          machine?: string;
          /** @description Display name for this codespace */
          display_name?: string;
          /** @description Recently opened folders inside the codespace. It is currently used by the clients to determine the folder path to load the codespace in. */
          recent_folders?: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Export a codespace for the authenticated user
   * @description Triggers an export of the specified codespace and returns a URL and ID where the status of the export can be monitored.
   *
   * If changes cannot be pushed to the codespace's repository, they will be pushed to a new or previously-existing fork instead.
   *
   * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
   */
  "codespaces/export-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      202: {
        content: {
          "application/json": components["schemas"]["codespace-export-details"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get details about a codespace export
   * @description Gets information about an export of a codespace.
   *
   * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
   */
  "codespaces/get-export-details-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
        export_id: components["parameters"]["export-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace-export-details"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List machine types for a codespace
   * @description List the machine types a codespace can transition to use.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have read access to the `codespaces_metadata` repository permission to use this endpoint.
   */
  "codespaces/codespace-machines-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": {
            total_count: number;
            machines: components["schemas"]["codespace-machine"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Create a repository from an unpublished codespace
   * @description Publishes an unpublished codespace, creating a new repository and assigning it to the codespace.
   *
   * The codespace's token is granted write permissions to the repository, allowing the user to push their changes.
   *
   * This will fail for a codespace that is already published, meaning it has an associated repository.
   *
   * You must authenticate using a personal access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces` repository permission to use this endpoint.
   */
  "codespaces/publish-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /** @description A name for the new repository. */
          name?: string;
          /**
           * @description Whether the new repository should be private.
           * @default false
           */
          private?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["codespace-with-full-repository"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Start a codespace for the authenticated user
   * @description Starts a user's codespace.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
   */
  "codespaces/start-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      304: components["responses"]["not_modified"];
      400: components["responses"]["bad_request"];
      401: components["responses"]["requires_authentication"];
      /** @description Payment required */
      402: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Stop a codespace for the authenticated user
   * @description Stops a user's codespace.
   *
   * You must authenticate using an access token with the `codespace` scope to use this endpoint.
   *
   * GitHub Apps must have write access to the `codespaces_lifecycle_admin` repository permission to use this endpoint.
   */
  "codespaces/stop-for-authenticated-user": {
    parameters: {
      path: {
        codespace_name: components["parameters"]["codespace-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["codespace"];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
  /**
   * Get list of conflicting packages during Docker migration for authenticated-user
   * @description Lists all packages that are owned by the authenticated user within the user's namespace, and that encountered a conflict during a Docker migration.
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
   */
  "packages/list-docker-migration-conflicting-packages-for-authenticated-user": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
    };
  };
  /**
   * Set primary email visibility for the authenticated user
   * @description Sets the visibility for your primary email addresses.
   */
  "users/set-primary-email-visibility-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Denotes whether an email is publicly visible.
           * @enum {string}
           */
          visibility: "public" | "private";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["email"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List email addresses for the authenticated user
   * @description Lists all of your email addresses, and specifies which one is visible to the public. This endpoint is accessible with the `user:email` scope.
   */
  "users/list-emails-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["email"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Add an email address for the authenticated user
   * @description This endpoint is accessible with the `user` scope.
   */
  "users/add-email-for-authenticated-user": {
    requestBody?: {
      content: {
        "application/json": {
          /**
           * @description Adds one or more email addresses to your GitHub account. Must contain at least one email address. **Note:** Alternatively, you can pass a single email address or an `array` of emails addresses directly, but we recommend that you pass an object using the `emails` key.
           * @example []
           */
          emails: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["email"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete an email address for the authenticated user
   * @description This endpoint is accessible with the `user` scope.
   */
  "users/delete-email-for-authenticated-user": {
    requestBody?: {
      content: {
        "application/json": {
          /** @description Email addresses associated with the GitHub user account. */
          emails: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List followers of the authenticated user
   * @description Lists the people following the authenticated user.
   */
  "users/list-followers-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List the people the authenticated user follows
   * @description Lists the people who the authenticated user follows.
   */
  "users/list-followed-by-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Check if a person is followed by the authenticated user */
  "users/check-person-is-followed-by-authenticated": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description if the person is followed by the authenticated user */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      /** @description if the person is not followed by the authenticated user */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * Follow a user
   * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   *
   * Following a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
   */
  "users/follow": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Unfollow a user
   * @description Unfollowing a user requires the user to be logged in and authenticated with basic auth or OAuth with the `user:follow` scope.
   */
  "users/unfollow": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List GPG keys for the authenticated user
   * @description Lists the current user's GPG keys. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/list-gpg-keys-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["gpg-key"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a GPG key for the authenticated user
   * @description Adds a GPG key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/create-gpg-key-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /** @description A descriptive name for the new key. */
          name?: string;
          /** @description A GPG key in ASCII-armored format. */
          armored_public_key: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["gpg-key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a GPG key for the authenticated user
   * @description View extended details for a single GPG key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/get-gpg-key-for-authenticated-user": {
    parameters: {
      path: {
        gpg_key_id: components["parameters"]["gpg-key-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["gpg-key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a GPG key for the authenticated user
   * @description Removes a GPG key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:gpg_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/delete-gpg-key-for-authenticated-user": {
    parameters: {
      path: {
        gpg_key_id: components["parameters"]["gpg-key-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List app installations accessible to the user access token
   * @description Lists installations of your GitHub App that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
   *
   * You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
   *
   * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
   *
   * You can find the permissions for the installation under the `permissions` key.
   */
  "apps/list-installations-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description You can find the permissions for the installation under the `permissions` key. */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            installations: components["schemas"]["installation"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List repositories accessible to the user access token
   * @description List repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access for an installation.
   *
   * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
   *
   * You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint.
   *
   * The access the user has to each repository is included in the hash under the `permissions` key.
   */
  "apps/list-installation-repos-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        installation_id: components["parameters"]["installation-id"];
      };
    };
    responses: {
      /** @description The access the user has to each repository is included in the hash under the `permissions` key. */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": {
            total_count: number;
            repository_selection?: string;
            repositories: components["schemas"]["repository"][];
          };
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Add a repository to an app installation
   * @description Add a single repository to an installation. The authenticated user must have admin access to the repository.
   *
   * You must use a personal access token (which you can create via the [command line](https://docs.github.com/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
   */
  "apps/add-repo-to-installation-for-authenticated-user": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Remove a repository from an app installation
   * @description Remove a single repository from an installation. The authenticated user must have admin access to the repository.
   *
   * You must use a personal access token (which you can create via the [command line](https://docs.github.com/github/authenticating-to-github/creating-a-personal-access-token) or [Basic Authentication](https://docs.github.com/rest/overview/other-authentication-methods#basic-authentication)) to access this endpoint.
   */
  "apps/remove-repo-from-installation-for-authenticated-user": {
    parameters: {
      path: {
        installation_id: components["parameters"]["installation-id"];
        repository_id: components["parameters"]["repository-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get interaction restrictions for your public repositories
   * @description Shows which type of GitHub user can interact with your public repositories and when the restriction expires.
   */
  "interactions/get-restrictions-for-authenticated-user": {
    responses: {
      /** @description Default response */
      200: {
        content: {
          "application/json":
            | components["schemas"]["interaction-limit-response"]
            | Record<string, never>;
        };
      };
      /** @description Response when there are no restrictions */
      204: never;
    };
  };
  /**
   * Set interaction restrictions for your public repositories
   * @description Temporarily restricts which type of GitHub user can interact with your public repositories. Setting the interaction limit at the user level will overwrite any interaction limits that are set for individual repositories owned by the user.
   */
  "interactions/set-restrictions-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": components["schemas"]["interaction-limit"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["interaction-limit-response"];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Remove interaction restrictions from your public repositories
   * @description Removes any interaction restrictions from your public repositories.
   */
  "interactions/remove-restrictions-for-authenticated-user": {
    responses: {
      /** @description Response */
      204: never;
    };
  };
  /**
   * List user account issues assigned to the authenticated user
   * @description List issues across owned and member repositories assigned to the authenticated user.
   *
   * **Note**: GitHub's REST API considers every pull request an issue, but not every issue is a pull request. For this
   * reason, "Issues" endpoints may return both issues and pull requests in the response. You can identify pull requests by
   * the `pull_request` key. Be aware that the `id` of a pull request returned from "Issues" endpoints will be an _issue id_. To find out the pull
   * request id, use the "[List pull requests](https://docs.github.com/rest/reference/pulls#list-pull-requests)" endpoint.
   */
  "issues/list-for-authenticated-user": {
    parameters: {
      query: {
        /** @description Indicates which sorts of issues to return. `assigned` means issues assigned to you. `created` means issues created by you. `mentioned` means issues mentioning you. `subscribed` means issues you're subscribed to updates for. `all` or `repos` means all issues you can see, regardless of participation or creation. */
        filter?:
          | "assigned"
          | "created"
          | "mentioned"
          | "subscribed"
          | "repos"
          | "all";
        /** @description Indicates the state of the issues to return. */
        state?: "open" | "closed" | "all";
        labels?: components["parameters"]["labels"];
        /** @description What to sort results by. */
        sort?: "created" | "updated" | "comments";
        direction?: components["parameters"]["direction"];
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["issue"][];
        };
      };
      304: components["responses"]["not_modified"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List public SSH keys for the authenticated user
   * @description Lists the public SSH keys for the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/list-public-ssh-keys-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["key"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a public SSH key for the authenticated user
   * @description Adds a public SSH key to the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth, or OAuth with at least `write:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/create-public-ssh-key-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description A descriptive name for the new key.
           * @example Personal MacBook Air
           */
          title?: string;
          /** @description The public SSH key to add to your GitHub account. */
          key: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a public SSH key for the authenticated user
   * @description View extended details for a single public SSH key. Requires that you are authenticated via Basic Auth or via OAuth with at least `read:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/get-public-ssh-key-for-authenticated-user": {
    parameters: {
      path: {
        key_id: components["parameters"]["key-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete a public SSH key for the authenticated user
   * @description Removes a public SSH key from the authenticated user's GitHub account. Requires that you are authenticated via Basic Auth or via OAuth with at least `admin:public_key` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/).
   */
  "users/delete-public-ssh-key-for-authenticated-user": {
    parameters: {
      path: {
        key_id: components["parameters"]["key-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List subscriptions for the authenticated user
   * @description Lists the active subscriptions for the authenticated user. You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint. . OAuth Apps must authenticate using an [OAuth token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/).
   */
  "apps/list-subscriptions-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["user-marketplace-purchase"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List subscriptions for the authenticated user (stubbed)
   * @description Lists the active subscriptions for the authenticated user. You must use a [user-to-server OAuth access token](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/#identifying-users-on-your-site), created for a user who has authorized your GitHub App, to access this endpoint. . OAuth Apps must authenticate using an [OAuth token](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/).
   */
  "apps/list-subscriptions-for-authenticated-user-stubbed": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["user-marketplace-purchase"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
    };
  };
  /** List organization memberships for the authenticated user */
  "orgs/list-memberships-for-authenticated-user": {
    parameters: {
      query: {
        /** @description Indicates the state of the memberships to return. If not specified, the API returns both active and pending memberships. */
        state?: "active" | "pending";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["org-membership"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /** Get an organization membership for the authenticated user */
  "orgs/get-membership-for-authenticated-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-membership"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Update an organization membership for the authenticated user */
  "orgs/update-membership-for-authenticated-user": {
    parameters: {
      path: {
        org: components["parameters"]["org"];
      };
    };
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The state that the membership should be in. Only `"active"` will be accepted.
           * @enum {string}
           */
          state: "active";
        };
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["org-membership"];
        };
      };
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List user migrations
   * @description Lists all migrations a user has started.
   */
  "migrations/list-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["migration"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Start a user migration
   * @description Initiates the generation of a user migration archive.
   */
  "migrations/start-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Lock the repositories being migrated at the start of the migration
           * @example true
           */
          lock_repositories?: boolean;
          /**
           * @description Indicates whether metadata should be excluded and only git source should be included for the migration.
           * @example true
           */
          exclude_metadata?: boolean;
          /**
           * @description Indicates whether the repository git data should be excluded from the migration.
           * @example true
           */
          exclude_git_data?: boolean;
          /**
           * @description Do not include attachments in the migration
           * @example true
           */
          exclude_attachments?: boolean;
          /**
           * @description Do not include releases in the migration
           * @example true
           */
          exclude_releases?: boolean;
          /**
           * @description Indicates whether projects owned by the organization or users should be excluded.
           * @example true
           */
          exclude_owner_projects?: boolean;
          /**
           * @description Indicates whether this should only include organization metadata (repositories array should be empty and will ignore other flags).
           * @default false
           * @example true
           */
          org_metadata_only?: boolean;
          /**
           * @description Exclude attributes from the API response to improve performance
           * @example [
           *   "repositories"
           * ]
           */
          exclude?: "repositories"[];
          repositories: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["migration"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a user migration status
   * @description Fetches a single user migration. The response includes the `state` of the migration, which can be one of the following values:
   *
   * *   `pending` - the migration hasn't started yet.
   * *   `exporting` - the migration is in progress.
   * *   `exported` - the migration finished successfully.
   * *   `failed` - the migration failed.
   *
   * Once the migration has been `exported` you can [download the migration archive](https://docs.github.com/rest/migrations/users#download-a-user-migration-archive).
   */
  "migrations/get-status-for-authenticated-user": {
    parameters: {
      query: {
        exclude?: string[];
      };
      path: {
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["migration"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Download a user migration archive
   * @description Fetches the URL to download the migration archive as a `tar.gz` file. Depending on the resources your repository uses, the migration archive can contain JSON files with data for these objects:
   *
   * *   attachments
   * *   bases
   * *   commit\_comments
   * *   issue\_comments
   * *   issue\_events
   * *   issues
   * *   milestones
   * *   organizations
   * *   projects
   * *   protected\_branches
   * *   pull\_request\_reviews
   * *   pull\_requests
   * *   releases
   * *   repositories
   * *   review\_comments
   * *   schema
   * *   users
   *
   * The archive will also contain an `attachments` directory that includes all attachment files uploaded to GitHub.com and a `repositories` directory that contains the repository's Git data.
   */
  "migrations/get-archive-for-authenticated-user": {
    parameters: {
      path: {
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      302: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Delete a user migration archive
   * @description Deletes a previous migration archive. Downloadable migration archives are automatically deleted after seven days. Migration metadata, which is returned in the [List user migrations](https://docs.github.com/rest/migrations/users#list-user-migrations) and [Get a user migration status](https://docs.github.com/rest/migrations/users#get-a-user-migration-status) endpoints, will continue to be available even after an archive is deleted.
   */
  "migrations/delete-archive-for-authenticated-user": {
    parameters: {
      path: {
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Unlock a user repository
   * @description Unlocks a repository. You can lock repositories when you [start a user migration](https://docs.github.com/rest/migrations/users#start-a-user-migration). Once the migration is complete you can unlock each repository to begin using it again or [delete the repository](https://docs.github.com/rest/repos/repos#delete-a-repository) if you no longer need the source data. Returns a status of `404 Not Found` if the repository is not locked.
   */
  "migrations/unlock-repo-for-authenticated-user": {
    parameters: {
      path: {
        migration_id: components["parameters"]["migration-id"];
        repo_name: components["parameters"]["repo-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repositories for a user migration
   * @description Lists all the repositories for this user migration.
   */
  "migrations/list-repos-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        migration_id: components["parameters"]["migration-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List organizations for the authenticated user
   * @description List organizations for the authenticated user.
   *
   * **OAuth scope requirements**
   *
   * This only lists organizations that your authorization allows you to operate on in some way (e.g., you can list teams with `read:org` scope, you can publicize your organization membership with `user` scope, etc.). Therefore, this API requires at least `user` or `read:org` scope. OAuth requests with insufficient scope receive a `403 Forbidden` response.
   */
  "orgs/list-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-simple"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List packages for the authenticated user's namespace
   * @description Lists packages owned by the authenticated user within the user's namespace.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/list-packages-for-authenticated-user": {
    parameters: {
      query: {
        /** @description The type of supported package. Packages in GitHub's Gradle registry have the type `maven`. Docker images pushed to GitHub's Container registry (`ghcr.io`) have the type `container`. You can use the type `docker` to find images that were pushed to GitHub's Docker registry (`docker.pkg.github.com`), even if these have now been migrated to the Container registry. */
        package_type:
          | "npm"
          | "maven"
          | "rubygems"
          | "docker"
          | "nuget"
          | "container";
        visibility?: components["parameters"]["package-visibility"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
      400: components["responses"]["package_es_list_error"];
    };
  };
  /**
   * Get a package for the authenticated user
   * @description Gets a specific package for a package owned by the authenticated user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-for-authenticated-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"];
        };
      };
    };
  };
  /**
   * Delete a package for the authenticated user
   * @description Deletes a package owned by the authenticated user. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes.
   * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/delete-package-for-authenticated-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore a package for the authenticated user
   * @description Restores a package owned by the authenticated user.
   *
   * You can restore a deleted package under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/restore-package-for-authenticated-user": {
    parameters: {
      query: {
        /** @description package token */
        token?: string;
      };
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List package versions for a package owned by the authenticated user
   * @description Lists package versions for a package owned by the authenticated user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-all-package-versions-for-package-owned-by-authenticated-user": {
    parameters: {
      query: {
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
        /** @description The state of the package, either active or deleted. */
        state?: "active" | "deleted";
      };
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a package version for the authenticated user
   * @description Gets a specific package version for a package owned by the authenticated user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-version-for-authenticated-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"];
        };
      };
    };
  };
  /**
   * Delete a package version for the authenticated user
   * @description Deletes a specific package version for a package owned by the authenticated user.  If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must have admin permissions in the organization and authenticate using an access token with the `read:packages` and `delete:packages` scopes.
   * If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/delete-package-version-for-authenticated-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore a package version for the authenticated user
   * @description Restores a package version owned by the authenticated user.
   *
   * You can restore a deleted package version under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/restore-package-version-for-authenticated-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a user project
   * @description Creates a user project board. Returns a `410 Gone` status if the user does not have existing classic projects. If you do not have sufficient privileges to perform this action, a `401 Unauthorized` or `410 Gone` status is returned.
   */
  "projects/create-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Name of the project
           * @example Week One Sprint
           */
          name: string;
          /**
           * @description Body of the project
           * @example This project represents the sprint of the first week in January
           */
          body?: string | null;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["project"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed_simple"];
    };
  };
  /**
   * List public email addresses for the authenticated user
   * @description Lists your publicly visible email address, which you can set with the [Set primary email visibility for the authenticated user](https://docs.github.com/rest/reference/users#set-primary-email-visibility-for-the-authenticated-user) endpoint. This endpoint is accessible with the `user:email` scope.
   */
  "users/list-public-emails-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["email"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repositories for the authenticated user
   * @description Lists repositories that the authenticated user has explicit permission (`:read`, `:write`, or `:admin`) to access.
   *
   * The authenticated user has explicit permission to access repositories they own, repositories where they are a collaborator, and repositories that they can access through an organization membership.
   */
  "repos/list-for-authenticated-user": {
    parameters: {
      query: {
        /** @description Limit results to repositories with the specified visibility. */
        visibility?: "all" | "public" | "private";
        /**
         * @description Comma-separated list of values. Can include:
         *  * `owner`: Repositories that are owned by the authenticated user.
         *  * `collaborator`: Repositories that the user has been added to as a collaborator.
         *  * `organization_member`: Repositories that the user has access to through being a member of an organization. This includes every repository on every team that the user is on.
         */
        affiliation?: string;
        /** @description Limit results to repositories of the specified type. Will cause a `422` error if used in the same request as **visibility** or **affiliation**. */
        type?: "all" | "owner" | "public" | "private" | "member";
        /** @description The property to sort the results by. */
        sort?: "created" | "updated" | "pushed" | "full_name";
        /** @description The order to sort by. Default: `asc` when using `full_name`, otherwise `desc`. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
        since?: components["parameters"]["since-repo-date"];
        before?: components["parameters"]["before-repo-date"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Create a repository for the authenticated user
   * @description Creates a new repository for the authenticated user.
   *
   * **OAuth scope requirements**
   *
   * When using [OAuth](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/), authorizations must include:
   *
   * *   `public_repo` scope or `repo` scope to create a public repository. Note: For GitHub AE, use `repo` scope to create an internal repository.
   * *   `repo` scope to create a private repository.
   */
  "repos/create-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description The name of the repository.
           * @example Team Environment
           */
          name: string;
          /** @description A short description of the repository. */
          description?: string;
          /** @description A URL with more information about the repository. */
          homepage?: string;
          /**
           * @description Whether the repository is private.
           * @default false
           */
          private?: boolean;
          /**
           * @description Whether issues are enabled.
           * @default true
           * @example true
           */
          has_issues?: boolean;
          /**
           * @description Whether projects are enabled.
           * @default true
           * @example true
           */
          has_projects?: boolean;
          /**
           * @description Whether the wiki is enabled.
           * @default true
           * @example true
           */
          has_wiki?: boolean;
          /**
           * @description Whether discussions are enabled.
           * @default false
           * @example true
           */
          has_discussions?: boolean;
          /** @description The id of the team that will be granted access to this repository. This is only valid when creating a repository in an organization. */
          team_id?: number;
          /**
           * @description Whether the repository is initialized with a minimal README.
           * @default false
           */
          auto_init?: boolean;
          /**
           * @description The desired language or platform to apply to the .gitignore.
           * @example Haskell
           */
          gitignore_template?: string;
          /**
           * @description The license keyword of the open source license for this repository.
           * @example mit
           */
          license_template?: string;
          /**
           * @description Whether to allow squash merges for pull requests.
           * @default true
           * @example true
           */
          allow_squash_merge?: boolean;
          /**
           * @description Whether to allow merge commits for pull requests.
           * @default true
           * @example true
           */
          allow_merge_commit?: boolean;
          /**
           * @description Whether to allow rebase merges for pull requests.
           * @default true
           * @example true
           */
          allow_rebase_merge?: boolean;
          /**
           * @description Whether to allow Auto-merge to be used on pull requests.
           * @default false
           * @example false
           */
          allow_auto_merge?: boolean;
          /**
           * @description Whether to delete head branches when pull requests are merged
           * @default false
           * @example false
           */
          delete_branch_on_merge?: boolean;
          /**
           * @description The default value for a squash merge commit title:
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `COMMIT_OR_PR_TITLE` - default to the commit's title (if only one commit) or the pull request's title (when more than one commit).
           * @enum {string}
           */
          squash_merge_commit_title?: "PR_TITLE" | "COMMIT_OR_PR_TITLE";
          /**
           * @description The default value for a squash merge commit message:
           *
           * - `PR_BODY` - default to the pull request's body.
           * - `COMMIT_MESSAGES` - default to the branch's commit messages.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          squash_merge_commit_message?: "PR_BODY" | "COMMIT_MESSAGES" | "BLANK";
          /**
           * @description The default value for a merge commit title.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `MERGE_MESSAGE` - default to the classic title for a merge message (e.g., Merge pull request #123 from branch-name).
           * @enum {string}
           */
          merge_commit_title?: "PR_TITLE" | "MERGE_MESSAGE";
          /**
           * @description The default value for a merge commit message.
           *
           * - `PR_TITLE` - default to the pull request's title.
           * - `PR_BODY` - default to the pull request's body.
           * - `BLANK` - default to a blank commit message.
           * @enum {string}
           */
          merge_commit_message?: "PR_BODY" | "PR_TITLE" | "BLANK";
          /**
           * @description Whether downloads are enabled.
           * @default true
           * @example true
           */
          has_downloads?: boolean;
          /**
           * @description Whether this repository acts as a template that can be used to generate new repositories.
           * @default false
           * @example true
           */
          is_template?: boolean;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        headers: {
          /** @example https://api.github.com/repos/octocat/Hello-World */
          Location?: string;
        };
        content: {
          "application/json": components["schemas"]["repository"];
        };
      };
      304: components["responses"]["not_modified"];
      400: components["responses"]["bad_request"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List repository invitations for the authenticated user
   * @description When authenticating as a user, this endpoint will list all currently open repository invitations for that user.
   */
  "repos/list-invitations-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["repository-invitation"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Decline a repository invitation */
  "repos/decline-invitation-for-authenticated-user": {
    parameters: {
      path: {
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
    };
  };
  /** Accept a repository invitation */
  "repos/accept-invitation-for-authenticated-user": {
    parameters: {
      path: {
        invitation_id: components["parameters"]["invitation-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      409: components["responses"]["conflict"];
    };
  };
  /**
   * List social accounts for the authenticated user
   * @description Lists all of your social accounts.
   */
  "users/list-social-accounts-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["social-account"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Add social accounts for the authenticated user
   * @description Add one or more social accounts to the authenticated user's profile. This endpoint is accessible with the `user` scope.
   */
  "users/add-social-account-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Full URLs for the social media profiles to add.
           * @example []
           */
          account_urls: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["social-account"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Delete social accounts for the authenticated user
   * @description Deletes one or more social accounts from the authenticated user's profile. This endpoint is accessible with the `user` scope.
   */
  "users/delete-social-account-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description Full URLs for the social media profiles to delete.
           * @example []
           */
          account_urls: string[];
        };
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List SSH signing keys for the authenticated user
   * @description Lists the SSH signing keys for the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `read:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
   */
  "users/list-ssh-signing-keys-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["ssh-signing-key"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Create a SSH signing key for the authenticated user
   * @description Creates an SSH signing key for the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `write:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
   */
  "users/create-ssh-signing-key-for-authenticated-user": {
    requestBody: {
      content: {
        "application/json": {
          /**
           * @description A descriptive name for the new key.
           * @example Personal MacBook Air
           */
          title?: string;
          /** @description The public SSH key to add to your GitHub account. For more information, see "[Checking for existing SSH keys](https://docs.github.com/authentication/connecting-to-github-with-ssh/checking-for-existing-ssh-keys)." */
          key: string;
        };
      };
    };
    responses: {
      /** @description Response */
      201: {
        content: {
          "application/json": components["schemas"]["ssh-signing-key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get an SSH signing key for the authenticated user
   * @description Gets extended details for an SSH signing key. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `read:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
   */
  "users/get-ssh-signing-key-for-authenticated-user": {
    parameters: {
      path: {
        ssh_signing_key_id: components["parameters"]["ssh-signing-key-id"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["ssh-signing-key"];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Delete an SSH signing key for the authenticated user
   * @description Deletes an SSH signing key from the authenticated user's GitHub account. You must authenticate with Basic Authentication, or you must authenticate with OAuth with at least `admin:ssh_signing_key` scope. For more information, see "[Understanding scopes for OAuth apps](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/)."
   */
  "users/delete-ssh-signing-key-for-authenticated-user": {
    parameters: {
      path: {
        ssh_signing_key_id: components["parameters"]["ssh-signing-key-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repositories starred by the authenticated user
   * @description Lists repositories the authenticated user has starred.
   *
   * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
   */
  "activity/list-repos-starred-by-authenticated-user": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort-starred"];
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["repository"][];
          "application/vnd.github.v3.star+json": components["schemas"]["starred-repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /** Check if a repository is starred by the authenticated user */
  "activity/check-repo-is-starred-by-authenticated-user": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response if this repository is starred by you */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      /** @description Not Found if this repository is not starred by you */
      404: {
        content: {
          "application/json": components["schemas"]["basic-error"];
        };
      };
    };
  };
  /**
   * Star a repository for the authenticated user
   * @description Note that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP verbs](https://docs.github.com/rest/overview/resources-in-the-rest-api#http-verbs)."
   */
  "activity/star-repo-for-authenticated-user": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** Unstar a repository for the authenticated user */
  "activity/unstar-repo-for-authenticated-user": {
    parameters: {
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List repositories watched by the authenticated user
   * @description Lists repositories the authenticated user is watching.
   */
  "activity/list-watched-repos-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
      304: components["responses"]["not_modified"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List teams for the authenticated user
   * @description List all of the teams across all of the organizations to which the authenticated user belongs. This method requires `user`, `repo`, or `read:org` [scope](https://docs.github.com/apps/building-oauth-apps/understanding-scopes-for-oauth-apps/) when authenticating via [OAuth](https://docs.github.com/apps/building-oauth-apps/). When using a fine-grained personal access token, the resource owner of the token [must be a single organization](https://docs.github.com/authentication/keeping-your-account-and-data-secure/creating-a-personal-access-token#fine-grained-personal-access-tokens), and have at least read-only member organization permissions. The response payload only contains the teams from a single organization when using a fine-grained personal access token.
   */
  "teams/list-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["team-full"][];
        };
      };
      304: components["responses"]["not_modified"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List users
   * @description Lists all users, in the order that they signed up on GitHub. This list includes personal user accounts and organization accounts.
   *
   * Note: Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
   */
  "users/list": {
    parameters: {
      query: {
        since?: components["parameters"]["since-user"];
        per_page?: components["parameters"]["per-page"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          /** @example <https://api.github.com/users?since=135>; rel="next" */
          Link?: string;
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
      304: components["responses"]["not_modified"];
    };
  };
  /**
   * Get a user
   * @description Provides publicly available information about someone with a GitHub account.
   *
   * GitHub Apps with the `Plan` user permission can use this endpoint to retrieve information about a user's GitHub plan. The GitHub App must be authenticated as a user. See "[Identifying and authorizing users for GitHub Apps](https://docs.github.com/apps/building-github-apps/identifying-and-authorizing-users-for-github-apps/)" for details about authentication. For an example response, see 'Response with GitHub plan information' below"
   *
   * The `email` key in the following response is the publicly visible email address from your GitHub [profile page](https://github.com/settings/profile). When setting up your profile, you can select a primary email address to be “public” which provides an email entry for this endpoint. If you do not set a public email address for `email`, then it will have a value of `null`. You only see publicly visible email addresses when authenticated with GitHub. For more information, see [Authentication](https://docs.github.com/rest/overview/resources-in-the-rest-api#authentication).
   *
   * The Emails API enables you to list all of your email addresses, and toggle a primary email to be visible publicly. For more information, see "[Emails API](https://docs.github.com/rest/reference/users#emails)".
   */
  "users/get-by-username": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json":
            | components["schemas"]["private-user"]
            | components["schemas"]["public-user"];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get list of conflicting packages during Docker migration for user
   * @description Lists all packages that are in a specific user's namespace, that the requesting user has access to, and that encountered a conflict during Docker migration.
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope.
   */
  "packages/list-docker-migration-conflicting-packages-for-user": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * List events for the authenticated user
   * @description If you are authenticated as the given user, you will see your private events. Otherwise, you'll only see public events.
   */
  "activity/list-events-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /**
   * List organization events for the authenticated user
   * @description This is the user's organization dashboard. You must be authenticated as the user to view this.
   */
  "activity/list-org-events-for-authenticated-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
        org: components["parameters"]["org"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /** List public events for a user */
  "activity/list-public-events-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /**
   * List followers of a user
   * @description Lists the people following the specified user.
   */
  "users/list-followers-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /**
   * List the people a user follows
   * @description Lists the people who the specified user follows.
   */
  "users/list-following-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["simple-user"][];
        };
      };
    };
  };
  /** Check if a user follows another user */
  "users/check-following-for-user": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
        target_user: string;
      };
    };
    responses: {
      /** @description if the user follows the target user */
      204: never;
      /** @description if the user does not follow the target user */
      404: never;
    };
  };
  /**
   * List gists for a user
   * @description Lists public gists for the specified user:
   */
  "gists/list-for-user": {
    parameters: {
      query: {
        since?: components["parameters"]["since"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["base-gist"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List GPG keys for a user
   * @description Lists the GPG keys for a user. This information is accessible by anyone.
   */
  "users/list-gpg-keys-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["gpg-key"][];
        };
      };
    };
  };
  /**
   * Get contextual information for a user
   * @description Provides hovercard information when authenticated through basic auth or OAuth with the `repo` scope. You can find out more about someone in relation to their pull requests, issues, repositories, and organizations.
   *
   * The `subject_type` and `subject_id` parameters provide context for the person's hovercard, which returns more information than without the parameters. For example, if you wanted to find out more about `octocat` who owns the `Spoon-Knife` repository via cURL, it would look like this:
   *
   * ```shell
   *  curl -u username:token
   *   https://api.github.com/users/octocat/hovercard?subject_type=repository&subject_id=1300192
   * ```
   */
  "users/get-context-for-user": {
    parameters: {
      query: {
        /** @description Identifies which additional information you'd like to receive about the person's hovercard. Can be `organization`, `repository`, `issue`, `pull_request`. **Required** when using `subject_id`. */
        subject_type?: "organization" | "repository" | "issue" | "pull_request";
        /** @description Uses the ID for the `subject_type` you specified. **Required** when using `subject_type`. */
        subject_id?: string;
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["hovercard"];
        };
      };
      404: components["responses"]["not_found"];
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * Get a user installation for the authenticated app
   * @description Enables an authenticated GitHub App to find the user’s installation information.
   *
   * You must use a [JWT](https://docs.github.com/apps/building-github-apps/authenticating-with-github-apps/#authenticating-as-a-github-app) to access this endpoint.
   */
  "apps/get-user-installation": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["installation"];
        };
      };
    };
  };
  /**
   * List public keys for a user
   * @description Lists the _verified_ public SSH keys for a user. This is accessible by anyone.
   */
  "users/list-public-keys-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["key-simple"][];
        };
      };
    };
  };
  /**
   * List organizations for a user
   * @description List [public organization memberships](https://docs.github.com/articles/publicizing-or-concealing-organization-membership) for the specified user.
   *
   * This method only lists _public_ memberships, regardless of authentication. If you need to fetch all of the organization memberships (public and private) for the authenticated user, use the [List organizations for the authenticated user](https://docs.github.com/rest/reference/orgs#list-organizations-for-the-authenticated-user) API instead.
   */
  "orgs/list-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["organization-simple"][];
        };
      };
    };
  };
  /**
   * List packages for a user
   * @description Lists all packages in a user's namespace for which the requesting user has access.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/list-packages-for-user": {
    parameters: {
      query: {
        /** @description The type of supported package. Packages in GitHub's Gradle registry have the type `maven`. Docker images pushed to GitHub's Container registry (`ghcr.io`) have the type `container`. You can use the type `docker` to find images that were pushed to GitHub's Docker registry (`docker.pkg.github.com`), even if these have now been migrated to the Container registry. */
        package_type:
          | "npm"
          | "maven"
          | "rubygems"
          | "docker"
          | "nuget"
          | "container";
        visibility?: components["parameters"]["package-visibility"];
        page?: components["parameters"]["page"];
        per_page?: components["parameters"]["per-page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"][];
        };
      };
      400: components["responses"]["package_es_list_error"];
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
    };
  };
  /**
   * Get a package for a user
   * @description Gets a specific package metadata for a public package owned by a user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-for-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package"];
        };
      };
    };
  };
  /**
   * Delete a package for a user
   * @description Deletes an entire package for a user. You cannot delete a public package if any version of the package has more than 5,000 downloads. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/delete-package-for-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore a package for a user
   * @description Restores an entire package for a user.
   *
   * You can restore a deleted package under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/restore-package-for-user": {
    parameters: {
      query: {
        /** @description package token */
        token?: string;
      };
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * List package versions for a package owned by a user
   * @description Lists package versions for a public package owned by a specified user.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-all-package-versions-for-package-owned-by-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"][];
        };
      };
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get a package version for a user
   * @description Gets a specific package version for a public package owned by a specified user.
   *
   * At this time, to use this endpoint, you must authenticate using an access token with the `read:packages` scope. If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of GitHub Packages registries that only support repository-scoped permissions, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   */
  "packages/get-package-version-for-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        package_version_id: components["parameters"]["package-version-id"];
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["package-version"];
        };
      };
    };
  };
  /**
   * Delete package version for a user
   * @description Deletes a specific package version for a user. If the package is public and the package version has more than 5,000 downloads, you cannot delete the package version. In this scenario, contact GitHub support for further assistance.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `delete:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to delete. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/delete-package-version-for-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Restore package version for a user
   * @description Restores a specific package version for a user.
   *
   * You can restore a deleted package under the following conditions:
   *   - The package was deleted within the last 30 days.
   *   - The same package namespace and version is still available and not reused for a new package. If the same package namespace is not available, you will not be able to restore your package. In this scenario, to restore the deleted package, you must delete the new package that uses the deleted package's namespace first.
   *
   * To use this endpoint, you must authenticate using an access token with the `read:packages` and `write:packages` scopes. In addition:
   * - If the `package_type` belongs to a GitHub Packages registry that only supports repository-scoped permissions, your token must also include the `repo` scope. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#permissions-for-repository-scoped-packages)."
   * - If the `package_type` belongs to a GitHub Packages registry that supports granular permissions, you must have admin permissions to the package whose version you want to restore. For the list of these registries, see "[About permissions for GitHub Packages](https://docs.github.com/packages/learn-github-packages/about-permissions-for-github-packages#granular-permissions-for-userorganization-scoped-packages)."
   */
  "packages/restore-package-version-for-user": {
    parameters: {
      path: {
        package_type: components["parameters"]["package-type"];
        package_name: components["parameters"]["package-name"];
        username: components["parameters"]["username"];
        package_version_id: components["parameters"]["package-version-id"];
      };
    };
    responses: {
      /** @description Response */
      204: never;
      401: components["responses"]["requires_authentication"];
      403: components["responses"]["forbidden"];
      404: components["responses"]["not_found"];
    };
  };
  /** List user projects */
  "projects/list-for-user": {
    parameters: {
      query: {
        /** @description Indicates the state of the projects to return. */
        state?: "open" | "closed" | "all";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["project"][];
        };
      };
      422: components["responses"]["validation_failed"];
    };
  };
  /**
   * List events received by the authenticated user
   * @description These are events that you've received by watching repos and following users. If you are authenticated as the given user, you will see private events. Otherwise, you'll only see public events.
   */
  "activity/list-received-events-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /** List public events received by a user */
  "activity/list-received-public-events-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["event"][];
        };
      };
    };
  };
  /**
   * List repositories for a user
   * @description Lists public repositories for the specified user. Note: For GitHub AE, this endpoint will list internal repositories for the specified user.
   */
  "repos/list-for-user": {
    parameters: {
      query: {
        /** @description Limit results to repositories of the specified type. */
        type?: "all" | "owner" | "member";
        /** @description The property to sort the results by. */
        sort?: "created" | "updated" | "pushed" | "full_name";
        /** @description The order to sort by. Default: `asc` when using `full_name`, otherwise `desc`. */
        direction?: "asc" | "desc";
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
    };
  };
  /**
   * Get GitHub Actions billing for a user
   * @description Gets the summary of the free and paid GitHub Actions minutes used.
   *
   * Paid minutes only apply to workflows in private repositories that use GitHub-hosted runners. Minutes used is listed for each GitHub-hosted runner operating system. Any job re-runs are also included in the usage. The usage returned includes any minute multipliers for macOS and Windows runners, and is rounded up to the nearest whole minute. For more information, see "[Managing billing for GitHub Actions](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-actions)".
   *
   * Access tokens must have the `user` scope.
   */
  "billing/get-github-actions-billing-user": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["actions-billing-usage"];
        };
      };
    };
  };
  /**
   * Get GitHub Packages billing for a user
   * @description Gets the free and paid storage used for GitHub Packages in gigabytes.
   *
   * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
   *
   * Access tokens must have the `user` scope.
   */
  "billing/get-github-packages-billing-user": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["packages-billing-usage"];
        };
      };
    };
  };
  /**
   * Get shared storage billing for a user
   * @description Gets the estimated paid and estimated total storage used for GitHub Actions and GitHub Packages.
   *
   * Paid minutes only apply to packages stored for private repositories. For more information, see "[Managing billing for GitHub Packages](https://docs.github.com/github/setting-up-and-managing-billing-and-payments-on-github/managing-billing-for-github-packages)."
   *
   * Access tokens must have the `user` scope.
   */
  "billing/get-shared-storage-billing-user": {
    parameters: {
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["combined-billing-usage"];
        };
      };
    };
  };
  /**
   * List social accounts for a user
   * @description Lists social media accounts for a user. This endpoint is accessible by anyone.
   */
  "users/list-social-accounts-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["social-account"][];
        };
      };
    };
  };
  /**
   * List SSH signing keys for a user
   * @description Lists the SSH signing keys for a user. This operation is accessible by anyone.
   */
  "users/list-ssh-signing-keys-for-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["ssh-signing-key"][];
        };
      };
    };
  };
  /**
   * List repositories starred by a user
   * @description Lists repositories a user has starred.
   *
   * You can also find out _when_ stars were created by passing the following custom [media type](https://docs.github.com/rest/overview/media-types/) via the `Accept` header: `application/vnd.github.star+json`.
   */
  "activity/list-repos-starred-by-user": {
    parameters: {
      query: {
        sort?: components["parameters"]["sort-starred"];
        direction?: components["parameters"]["direction"];
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json":
            | components["schemas"]["starred-repository"][]
            | components["schemas"]["repository"][];
        };
      };
    };
  };
  /**
   * List repositories watched by a user
   * @description Lists repositories a user is watching.
   */
  "activity/list-repos-watched-by-user": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        username: components["parameters"]["username"];
      };
    };
    responses: {
      /** @description Response */
      200: {
        headers: {
          Link: components["headers"]["link"];
        };
        content: {
          "application/json": components["schemas"]["minimal-repository"][];
        };
      };
    };
  };
  /**
   * Get all API versions
   * @description Get all supported GitHub API versions.
   */
  "meta/get-all-versions": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": string[];
        };
      };
      404: components["responses"]["not_found"];
    };
  };
  /**
   * Get the Zen of GitHub
   * @description Get a random sentence from the Zen of GitHub
   */
  "meta/get-zen": {
    responses: {
      /** @description Response */
      200: {
        content: {
          "text/plain": string;
        };
      };
    };
  };
  /**
   * Compare two commits
   * @description **Deprecated**: Use `repos.compareCommitsWithBasehead()` (`GET /repos/{owner}/{repo}/compare/{basehead}`) instead. Both `:base` and `:head` must be branch names in `:repo`. To compare branches across other repositories in the same network as `:repo`, use the format `<USERNAME>:branch`.
   *
   * The response from the API is equivalent to running the `git log base..head` command; however, commits are returned in chronological order. Pass the appropriate [media type](https://docs.github.com/rest/overview/media-types/#commits-commit-comparison-and-pull-requests) to fetch diff and patch formats.
   *
   * The response also includes details on the files that were changed between the two commits. This includes the status of the change (for example, if a file was added, removed, modified, or renamed), and details of the change itself. For example, files with a `renamed` status have a `previous_filename` field showing the previous filename of the file, and files with a `modified` status have a `patch` field showing the changes made to the file.
   *
   * **Working with large comparisons**
   *
   * To process a response with a large number of commits, you can use (`per_page` or `page`) to paginate the results. When using paging, the list of changed files is only returned with page 1, but includes all changed files for the entire comparison. For more information on working with pagination, see "[Traversing with pagination](/rest/guides/traversing-with-pagination)."
   *
   * When calling this API without any paging parameters (`per_page` or `page`), the returned list is limited to 250 commits and the last commit in the list is the most recent of the entire comparison. When a paging parameter is specified, the first commit in the returned list of each page is the earliest.
   *
   * **Signature verification object**
   *
   * The response will include a `verification` object that describes the result of verifying the commit's signature. The following fields are included in the `verification` object:
   *
   * | Name | Type | Description |
   * | ---- | ---- | ----------- |
   * | `verified` | `boolean` | Indicates whether GitHub considers the signature in this commit to be verified. |
   * | `reason` | `string` | The reason for verified value. Possible values and their meanings are enumerated in table below. |
   * | `signature` | `string` | The signature that was extracted from the commit. |
   * | `payload` | `string` | The value that was signed. |
   *
   * These are the possible values for `reason` in the `verification` object:
   *
   * | Value | Description |
   * | ----- | ----------- |
   * | `expired_key` | The key that made the signature is expired. |
   * | `not_signing_key` | The "signing" flag is not among the usage flags in the GPG key that made the signature. |
   * | `gpgverify_error` | There was an error communicating with the signature verification service. |
   * | `gpgverify_unavailable` | The signature verification service is currently unavailable. |
   * | `unsigned` | The object does not include a signature. |
   * | `unknown_signature_type` | A non-PGP signature was found in the commit. |
   * | `no_user` | No user was associated with the `committer` email address in the commit. |
   * | `unverified_email` | The `committer` email address in the commit was associated with a user, but the email address is not verified on her/his account. |
   * | `bad_email` | The `committer` email address in the commit is not included in the identities of the PGP key that made the signature. |
   * | `unknown_key` | The key that made the signature has not been registered with any user's account. |
   * | `malformed_signature` | There was an error parsing the signature. |
   * | `invalid` | The signature could not be cryptographically verified using the key whose key-id was found in the signature. |
   * | `valid` | None of the above errors applied, so the signature is considered to be verified. |
   */
  "repos/compare-commits": {
    parameters: {
      query: {
        per_page?: components["parameters"]["per-page"];
        page?: components["parameters"]["page"];
      };
      path: {
        owner: components["parameters"]["owner"];
        repo: components["parameters"]["repo"];
        base: string;
        head: string;
      };
    };
    responses: {
      /** @description Response */
      200: {
        content: {
          "application/json": components["schemas"]["commit-comparison"];
        };
      };
      404: components["responses"]["not_found"];
      500: components["responses"]["internal_error"];
    };
  };
}
